<?php
/**
 * CLink Activations Functions
 *
 * CLink activation default options, requirements
 *
 * @package CLink
 * @subpackage System
 */
 // Direct Access Not Allowed
defined( 'ABSPATH' ) or die( 'No script kiddies please!' );
/**
 * CLink Default Option to Load on Activation
 */
function wpclink_default_options(){
	
	// Default Options
	$cl_option = 'preferences_general';
	$default_value['cl_mode'] = "both";
	$default_value['message_popup'] = 0;
	$default_value['licensor_url'] = 'reuse_guid';
	$default_value['canonical_time'] = 'daily';
	$default_value['embeded_metadata'] = 'overwrite';
	
	
	
	$defualt_offer = '<form id="cl_new_offer" action="">
<div id="cl_offer_response">
<h2>Do you want to get this content?</h2>
<input id="cl_weburl" required="required" value="" autofocus="autofocus" placeholder="Your Website Address" type="url">
<div id="wait"></div>
<input id="cl_modal_submit" value="Submit" type="submit">
</div>
</form>';
$defualt_offer_clinkid = '<form id="cl_new_offer_clinkid" action="">
<div id="cl_offer_response">
<h2>Do you want to get this content?</h2>
<input id="cl_weburl" required="required" value="" autofocus="autofocus" placeholder="Your Website Address" type="url">
<input type="hidden" name="content_method" value="single" />
<input type="hidden" name="cl_auto_code" value="" />
<div id="wait"></div>
<input id="cl_modal_submit" value="Submit" type="submit">
</div>
</form>';
	// Save
	if($saved = wpclink_get_option($cl_option)){ }else{	wpclink_add_option($cl_option,$default_value); }
	if($saved_offer_clinkid = wpclink_get_option('reuse_content_popup_html')){ }else{ wpclink_add_option('reuse_content_popup_html',$defualt_offer_clinkid); }
	if($primary_linked_site = wpclink_get_option('primary_linked_site')){ }else{ wpclink_add_option('primary_linked_site','0');	}
	
	
	if($saved_registered_posts = wpclink_get_option('referent_posts')){ }else{ wpclink_add_option('referent_posts',array()); }
	if($saved_registered_pages = wpclink_get_option('referent_pages')){ }else{ wpclink_add_option('referent_pages',array()); }
	if($saved_registered_attachments = wpclink_get_option('referent_attachments')){ }else{ wpclink_add_option('referent_attachments',array()); }
	
	
	
	// License Versions
	$clink_version = array('0.9'=>'0.9');
	if($clink_license_version = wpclink_get_option('license_versions')){ }else{ wpclink_add_option('license_versions',$clink_version); }
	
	$texo_permission = array(
		'right_type' => array(
			'AddToTaxonomy' => 'Add to Taxonomy',
			'ModifyTaxonomy' => 'Modify Taxonomy',
		)
	);
	
	// Taxonomy Permission
	if($texo_permission_data = wpclink_get_option('programmatic_right_categories')){ }else{ wpclink_add_option('programmatic_right_categories',$texo_permission); }
	
	// Reuse Button Position
	if($clink_reuse_button_left_offset = wpclink_get_option('reuse_button_left_offset')){ }else{ wpclink_add_option('reuse_button_left_offset','0'); }
	
	if($clink_reuse_button_top_offset = wpclink_get_option('reuse_button_top_offset')){ }else{ wpclink_add_option('reuse_button_top_offset','0'); }
	
	// License URLs
	$clink_license_uris = array('0.9'=>'https://licenses.clink.id/personal/0-9/');
	wpclink_update_option('license_uris',$clink_license_uris);
		
	// Creator by default as Right Holder
	wpclink_update_option('rights_holder','creator');
	
	//clink_popup_pre_auth
	$terms_and_condition = '<div><p><strong> The effective date of this Agreement is May 17, 2018.</strong></p></div><div><p> By accessing or using any features and/or services on the site located at&#8239; <a href="http://www.clink.id" target="_blank" rel="noreferrer"> www.clink.id </a> &#8239;(the "Site") and operated and managed CLink Media, Inc ("we" or "us"), you agree to be bound by these terms and conditions (collectively, "Terms"). All visitors to and users of any aspects of this&#8239;Site&#8239;(collectively, "Users") are bound by these&#8239;Terms. We reserve the right to modify the&#8239;Terms&#8239;at any time without prior notice to you. Therefore, we recommend that you read these terms and conditions carefully each time you use this Web site.</p></div><div><p> Please note that the guidelines, policies and other terms and conditions use of other Web sites affiliated with this&#8239;Site&#8239;may vary from these&#8239;Terms.</p></div><div><p> As a User of this&#8239;Site&#8239;you may, from time to time, register content and share it with other users, read content generated by other visitors to this&#8239;Site&#8239;and other affiliated sites. If you wish to register content to or participate in this&#8239;Site&#8239;other than simply by reading product information and content registered by others, you must use our WordPress plugins.</p></div><div><p> These&#8239;Terms&#8239;set out the legally binding terms with respect to your use of this&#8239;Site. Please read these&#8239;Terms&#8239;carefully. Your access to and use of this&#8239;Site&#8239;constitutes your acceptance of all the provisions of these&#8239;Terms. If you are unwilling to be bound by these&#8239;Terms, you should not access or use this&#8239;Site.</p></div><div></div><div><p><strong> Changes to the CLink.ID Site</strong></p></div><div><p> You agree and understand that this&#8239;Site, including any and all features available via this&#8239;Site and any&#8239;User Content&#8239;(as defined below), may be modified by us, in our sole discretion, at any time without prior notice. Unless expressly stated otherwise, any new features, new services, enhancements or modifications to this&#8239;Site&#8239;implemented after your initial access to this&#8239;Site shall be subject to these&#8239;Terms.</p></div><div></div><div><p> <strong>Use of the Site/Services</strong></p></div><div><p> You may use this&#8239;Site&#8239;for your personal or commercial use.</p></div><div></div><div><p> <strong>Restrictions on Rights to Use</strong></p></div><div><p> Without limiting the generality of any other provisions of these&#8239;Terms, you agree you shall not (and you agree not to allow any other individual or entity to):</p></div><div><ul><li><p> reformat or frame any portion of any Web pages that are part of this&#8239;Site;</p></li><li><p> submit to&#8239;Site&#8239;any content that is unlawful or facilitates, constitutes, promotes or encourages illegal activity; or otherwise use this&#8239;Site to transfer or store illegal material, including any material deemed threatening or obscene;</p></li><li><p> take any action that imposes, or may impose, in our sole discretion, an unreasonable or disproportionately large load on this&#8239;Site&#8239;or the IT infrastructure used to operate and make this&#8239;Site&#8239;available.</p></li></ul><div></div><div><p> <strong>Privacy</strong></p></div></div><div><p> Use of this&#8239;Site&#8239;is also governed by our&#8239; <a href="'.WPCLINK_ID_URL.'/privacy.html" target="_blank" rel="noreferrer"> Privacy Policy </a> &#8239;which we encourage you to review.</p></div><div></div><div><p> <strong>Changes to Terms and Conditions</strong></p></div><div><p> We reserve the right to make changes at any time to these&#8239;Terms. Any modifications to the&#8239;Terms&#8239;will be effective upon posting. You agree to review the&#8239;Terms&#8239;periodically so that you are aware of any modifications. Your continued use of this&#8239;Site&#8239;after any modifications indicates your acceptance of the modified&#8239;Terms.</p></div><div></div><div><p> <strong>Applicable law</strong></p></div><div><p> By visiting this&#8239;Site, you agree that the laws of the State of Texas of the United States, without regard to principles of conflict of laws, will govern these&#8239;Terms&#8239;and any dispute of any sort that might arise between you and this&#8239;Site.</p></div><div></div><div><p> <strong>Miscellaneous</strong></p></div><div><p> We may provide you with notices, including those regarding changes to these&#8239;Terms, by email, regular mail, or postings on this&#8239;Site. These&#8239;Terms, which shall be deemed accepted by you upon your use of this&#8239;Site, constitute the entire agreement among you and us regarding use of this&#8239;Site. The headings in these&#8239;Terms&#8239;are for convenience only and have no legal or contractual effect. These&#8239;Terms&#8239;incorporate the&#8239; <a href="'.WPCLINK_ID_URL.'/privacy.html" target="_blank" rel="noreferrer"> Privacy Policy </a> &#8239;&#8239;for this&#8239;Site&#8239;and any notices regarding this&#8239;Site.</p></div><div></div><div><p> <strong>Contact and Violations</strong></p></div><div><p> Please contact us with any questions regarding these&#8239;Terms. Please report any violations of the&#8239;Terms&#8239;to&#8239; <a href="mailto:contact@clink.media" target="_blank" rel="noreferrer"> contact@clink.media </a> .</p></div><div></div>';
	
	if($terms_and_condition_text = wpclink_get_option('terms_and_conditions')){ }else{ 
	wpclink_add_option('terms_and_conditions',$terms_and_condition,'','no');
	}
	
	
	if($clink_ip_verification = wpclink_get_option('verification_linked_ip')){ }else{ 
	wpclink_add_option('verification_linked_ip',1);
	}
	
	
	$clink_popup_pre_auth_text = '<h3>CONSENT TO PRE-AUTHORIZED LICENSING OF REFERENT CREATIONS</h3>
<p>You have selected one or more Creation(s) to be designated  as referent Creation(s). By choosing to designate your Creation(s) as  &ldquo;referent&rdquo; you agree to make the Creation(s) available for revocable,  non-exclusive use by persons (Licensees) requesting re-use of the Creation(s)  via the CLink plug-in for WordPress subject to the terms and conditions set  forth in a License. By default the License is a standard license provided by  CLink Media, Inc. for non-commercial use in accordance with the license type  you select for your Creation(s).  </p>';
	
	if($clink_popup_pre_auth = wpclink_get_option('pre_auth_license')){ }else{ 
	wpclink_add_option('pre_auth_license',$clink_popup_pre_auth_text,'','no');
	}
	
	$clink_esign_pre_auth_text = '<h3>CONSENT TO PRE-AUTHORIZED APPLICATION OF E-SIGNATURE TO LICENSE</h3>
<p>So long as you have not suspended licensing of the Creation(s) via the CLink plug-in, you authorize your electronic signature to automatically be applied to the selected standard License upon request from a Requester. In addition, you agree to such e-signed License to be delivered to the Requester along with a copy of the Creation(s) via the CLink™ Media, Inc. system. Upon receipt the Requester become a Licensee permitted to re-use the Creation subject to the terms and conditions set forth in the License</p>';
	
	if($clink_esign_pre_auth = wpclink_get_option('pre_auth_esign')){ }else{ 
	wpclink_add_option('pre_auth_esign',$clink_esign_pre_auth_text,'','no');
	}
	
	
	if($clink_empty_slot = wpclink_get_option('clink_empty_slot')){ }else{ 
	wpclink_add_option('clink_empty_slot','','','no');
	}
	
	if($clink_show_registration = wpclink_get_option('show_registration')){ }else{ 
	wpclink_add_option('show_registration',1);
	}
	
	if($show_linked_mode = wpclink_get_option('show_linked_mode')){ }else{ 
	wpclink_add_option('show_linked_mode',1);
	}
	
	if($clink_canonical_fail_attemps = wpclink_get_option('verification_canonical_fail_threshold')){ }else{ 
	wpclink_add_option('verification_canonical_fail_threshold',3,'','no');
	}
	
	if($clink_canonical_success_attemps = wpclink_get_option('verification_canonical_success_threshold')){ }else{ 
	wpclink_add_option('verification_canonical_success_threshold',3,'','no');
	}
	
	if($clink_debug_filename = wpclink_get_option('debug_filename')){ }else{ 
	
		// Filename
		$unique_name = wpclink_go_live_link(16);
		$filename = 'debug_'.$unique_name.'.log';
		wpclink_add_option('debug_filename',$filename,'','no');
	}
	
	
}
register_activation_hook( WPCLINK_MAIN_FILE, 'wpclink_default_options' );
/**
 * CLink Plugin Requirements
 * 
 * WordPress version 4.8 or greater than
 * PHP version 7.0 or greater than
 * file_get_contents is required
 * simplexml extention is required
 * cURL is required
 * SSL Certificate is required
 */

function wpclink_requirments_activate() {

  $die = false;
	
  if ( version_compare( get_bloginfo('version'), '5.0', '<') )  {
    $message .= "WordPress version is lower than 5.0 \n";
	$die = true;   
  }
 if ( version_compare( phpversion(), '7.0', '<') )  {
	$message .= "PHP version is lower than 7.0 \n";
	$die = true;  
 }
 if(!ini_get('allow_url_fopen') ) {
	 $message .= "The PHP directive allow_url_fopen is not activated in the php.ini file on your server. Please contact your site administrator or host provider. \n";
	 $die = true;  
 }
 if (!extension_loaded('simplexml')) {
	 $message .= "simplexml extention is required \n";
	 $die = true;
 }
 if(!function_exists('curl_version')){
	 $message .= "cURL is not installed \n";
	 $die = true;
 }
 if(!function_exists('proc_open')){
	 $message .= "proc_open function is required for writing image metadata, which is not available on your PHP installation \n";
	 $die = true;
 }

 if(!function_exists('proc_close')){
	 $message .= "proc_close function is required for writing image metadata, which is not available on your PHP installation \n";
	 $die = true;
 }
 if(!is_ssl()){
	 $message .= "HTTPS is a system requirement for the wpCLink plugin! It will not activate nor operate if the site address does not start with https. Please contact your administrator.\n";
	 $die = true;
}

  // DIE
  if($die == true){
	if( is_plugin_active('wpclink/wpclink.php') ){
  		wpclink_notif_print($message,'error');
		deactivate_plugins('wpclink/wpclink.php');	
	}
  }

}

add_action( 'admin_init', 'wpclink_requirments_activate' );


/**
 * wpCLink SSL required.
 * 
 * Plugin required SSL (https) secured connection.
 *
 */
function wpclink_deactive_without_ssl() {
	
	$site_url = get_bloginfo('url');
	$site_url_final = parse_url($site_url);
	
	if (is_admin() ) {
		if(($site_url_final['scheme'] != 'https') || !is_ssl()){
			if( is_plugin_active('wpclink/wpclink.php') ){
					  deactivate_plugins('wpclink/wpclink.php');
				
					// Message
  					wpclink_notif_print('HTTPS is a system requirement for the wpCLink plugin! It will not activate nor operate if the site address does not start with https. Please contact your administrator.','error');
	
				  }
		} 
	}
}
add_action( 'admin_init', 'wpclink_deactive_without_ssl' );
/**
 * CLink Exif Tool Extension
 * 
 * Exif Tool required executable permission.
 *
 */
function wpclink_check_exif_tool_executable() {
	
	$exiftool_file = dirname (WPCLINK_MAIN_FILE) . '/vendor/phpexiftool/exiftool/exiftool';
	
	if(file_exists($exiftool_file)){
		if(!is_executable($exiftool_file)){
			// Only executable permission as required by exiftool
			chmod($exiftool_file, 0744);
		}
	}
	
}
add_action( 'activate_' . WPCLINK_BASENAME, 'wpclink_check_exif_tool_executable' );
