<?php
/*
 * This file is part of the PHPExifTool package.
 *
 * (c) Alchemy <support@alchemy.fr>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */
namespace PHPExiftool\Driver;
class TagProvider extends \Pimple
{
    public function __construct()
    {
       
       
        $this['MAC'] = $this->share(function(){
            return array(
                'CompressionLevel' => new \PHPExiftool\Driver\Tag\MAC\CompressionLevel(),
                'BlocksPerFrame' => new \PHPExiftool\Driver\Tag\MAC\BlocksPerFrame(),
                'FinalFrameBlocks' => new \PHPExiftool\Driver\Tag\MAC\FinalFrameBlocks(),
                'TotalFrames' => new \PHPExiftool\Driver\Tag\MAC\TotalFrames(),
                'BitsPerSample' => new \PHPExiftool\Driver\Tag\MAC\BitsPerSample(),
                'Channels' => new \PHPExiftool\Driver\Tag\MAC\Channels(),
                'SampleRate' => new \PHPExiftool\Driver\Tag\MAC\SampleRate(),
                'APEVersion' => new \PHPExiftool\Driver\Tag\MAC\APEVersion(),
            );
        });
        $this['Ducky'] = $this->share(function(){
            return array(
                'Quality' => new \PHPExiftool\Driver\Tag\Ducky\Quality(),
                'Comment' => new \PHPExiftool\Driver\Tag\Ducky\Comment(),
                'Copyright' => new \PHPExiftool\Driver\Tag\Ducky\Copyright(),
            );
        });
        $this['PictureInfo'] = $this->share(function(){
            return array(
                'Aperture' => new \PHPExiftool\Driver\Tag\PictureInfo\Aperture(),
                'ColorMode' => new \PHPExiftool\Driver\Tag\PictureInfo\ColorMode(),
                'ConTake' => new \PHPExiftool\Driver\Tag\PictureInfo\ConTake(),
                'ExposureCompensation' => new \PHPExiftool\Driver\Tag\PictureInfo\ExposureCompensation(),
                'FNumber' => new \PHPExiftool\Driver\Tag\PictureInfo\FNumber(),
                'FirmwareVersion' => new \PHPExiftool\Driver\Tag\PictureInfo\FirmwareVersion(),
                'Flash' => new \PHPExiftool\Driver\Tag\PictureInfo\Flash(),
                'FocusMode' => new \PHPExiftool\Driver\Tag\PictureInfo\FocusMode(),
                'FocusPos' => new \PHPExiftool\Driver\Tag\PictureInfo\FocusPos(),
                'ID' => new \PHPExiftool\Driver\Tag\PictureInfo\ID(),
                'ImageSize' => new \PHPExiftool\Driver\Tag\PictureInfo\ImageSize(),
                'LightS' => new \PHPExiftool\Driver\Tag\PictureInfo\LightS(),
                'Macro' => new \PHPExiftool\Driver\Tag\PictureInfo\Macro(),
                'Protect' => new \PHPExiftool\Driver\Tag\PictureInfo\Protect(),
                'Quality' => new \PHPExiftool\Driver\Tag\PictureInfo\Quality(),
                'Resolution' => new \PHPExiftool\Driver\Tag\PictureInfo\Resolution(),
                'SerialNumber' => new \PHPExiftool\Driver\Tag\PictureInfo\SerialNumber(),
                'ExposureTime' => new \PHPExiftool\Driver\Tag\PictureInfo\ExposureTime(),
                'StrobeTime' => new \PHPExiftool\Driver\Tag\PictureInfo\StrobeTime(),
                'DateTimeOriginal' => new \PHPExiftool\Driver\Tag\PictureInfo\DateTimeOriginal(),
                'CameraType' => new \PHPExiftool\Driver\Tag\PictureInfo\CameraType(),
                'Version' => new \PHPExiftool\Driver\Tag\PictureInfo\Version(),
                'YTarget' => new \PHPExiftool\Driver\Tag\PictureInfo\YTarget(),
                'Zoom' => new \PHPExiftool\Driver\Tag\PictureInfo\Zoom(),
                'ZoomPos' => new \PHPExiftool\Driver\Tag\PictureInfo\ZoomPos(),
                'YLevel' => new \PHPExiftool\Driver\Tag\PictureInfo\YLevel(),
            );
        });
        $this['ASF'] = $this->share(function(){
            return array(
                'AudioCodecDescription' => new \PHPExiftool\Driver\Tag\ASF\AudioCodecDescription(),
                'AudioCodecName' => new \PHPExiftool\Driver\Tag\ASF\AudioCodecName(),
                'OtherCodecDescription' => new \PHPExiftool\Driver\Tag\ASF\OtherCodecDescription(),
                'OtherCodecName' => new \PHPExiftool\Driver\Tag\ASF\OtherCodecName(),
                'VideoCodecDescription' => new \PHPExiftool\Driver\Tag\ASF\VideoCodecDescription(),
                'VideoCodecName' => new \PHPExiftool\Driver\Tag\ASF\VideoCodecName(),
                'BannerImageType' => new \PHPExiftool\Driver\Tag\ASF\BannerImageType(),
                'BannerImage' => new \PHPExiftool\Driver\Tag\ASF\BannerImage(),
                'BannerImageURL' => new \PHPExiftool\Driver\Tag\ASF\BannerImageURL(),
                'CopyrightURL' => new \PHPExiftool\Driver\Tag\ASF\CopyrightURL(),
                'Title' => new \PHPExiftool\Driver\Tag\ASF\Title(),
                'Author' => new \PHPExiftool\Driver\Tag\ASF\Author(),
                'Copyright' => new \PHPExiftool\Driver\Tag\ASF\Copyright(),
                'Description' => new \PHPExiftool\Driver\Tag\ASF\Description(),
                'Rating' => new \PHPExiftool\Driver\Tag\ASF\Rating(),
                'ASFLeakyBucketPairs' => new \PHPExiftool\Driver\Tag\ASF\ASFLeakyBucketPairs(),
                'ASFPacketCount' => new \PHPExiftool\Driver\Tag\ASF\ASFPacketCount(),
                'ASFSecurityObjectsSize' => new \PHPExiftool\Driver\Tag\ASF\ASFSecurityObjectsSize(),
                'AlbumArtist' => new \PHPExiftool\Driver\Tag\ASF\AlbumArtist(),
                'AlbumCoverURL' => new \PHPExiftool\Driver\Tag\ASF\AlbumCoverURL(),
                'AlbumTitle' => new \PHPExiftool\Driver\Tag\ASF\AlbumTitle(),
                'AspectRatioX' => new \PHPExiftool\Driver\Tag\ASF\AspectRatioX(),
                'AspectRatioY' => new \PHPExiftool\Driver\Tag\ASF\AspectRatioY(),
                'AudioFileURL' => new \PHPExiftool\Driver\Tag\ASF\AudioFileURL(),
                'AudioSourceURL' => new \PHPExiftool\Driver\Tag\ASF\AudioSourceURL(),
                'AuthorURL' => new \PHPExiftool\Driver\Tag\ASF\AuthorURL(),
                'AverageLevel' => new \PHPExiftool\Driver\Tag\ASF\AverageLevel(),
                'BannerImageData' => new \PHPExiftool\Driver\Tag\ASF\BannerImageData(),
                'BeatsPerMinute' => new \PHPExiftool\Driver\Tag\ASF\BeatsPerMinute(),
                'Bitrate' => new \PHPExiftool\Driver\Tag\ASF\Bitrate(),
                'Broadcast' => new \PHPExiftool\Driver\Tag\ASF\Broadcast(),
                'BufferAverage' => new \PHPExiftool\Driver\Tag\ASF\BufferAverage(),
                'Can_Skip_Backward' => new \PHPExiftool\Driver\Tag\ASF\CanSkipBackward(),
                'Can_Skip_Forward' => new \PHPExiftool\Driver\Tag\ASF\CanSkipForward(),
                'Category' => new \PHPExiftool\Driver\Tag\ASF\Category(),
                'Codec' => new \PHPExiftool\Driver\Tag\ASF\Codec(),
                'Composer' => new \PHPExiftool\Driver\Tag\ASF\Composer(),
                'Conductor' => new \PHPExiftool\Driver\Tag\ASF\Conductor(),
                'ContainerFormat' => new \PHPExiftool\Driver\Tag\ASF\ContainerFormat(),
                'ContentDistributor' => new \PHPExiftool\Driver\Tag\ASF\ContentDistributor(),
                'ContentGroupDescription' => new \PHPExiftool\Driver\Tag\ASF\ContentGroupDescription(),
                'CurrentBitrate' => new \PHPExiftool\Driver\Tag\ASF\CurrentBitrate(),
                'DRM' => new \PHPExiftool\Driver\Tag\ASF\DRM(),
                'DRM_ContentID' => new \PHPExiftool\Driver\Tag\ASF\DRMContentID(),
                'DRM_DRMHeader' => new \PHPExiftool\Driver\Tag\ASF\DRMDRMHeader(),
                'DRM_DRMHeader_ContentDistributor' => new \PHPExiftool\Driver\Tag\ASF\DRMDRMHeaderContentDistributor(),
                'DRM_DRMHeader_ContentID' => new \PHPExiftool\Driver\Tag\ASF\DRMDRMHeaderContentID(),
                'DRM_DRMHeader_IndividualizedVersion' => new \PHPExiftool\Driver\Tag\ASF\DRMDRMHeaderIndividualizedVersion(),
                'DRM_DRMHeader_KeyID' => new \PHPExiftool\Driver\Tag\ASF\DRMDRMHeaderKeyID(),
                'DRM_DRMHeader_LicenseAcqURL' => new \PHPExiftool\Driver\Tag\ASF\DRMDRMHeaderLicenseAcqURL(),
                'DRM_DRMHeader_SubscriptionContentID' => new \PHPExiftool\Driver\Tag\ASF\DRMDRMHeaderSubscriptionContentID(),
                'DRM_IndividualizedVersion' => new \PHPExiftool\Driver\Tag\ASF\DRMIndividualizedVersion(),
                'DRM_KeyID' => new \PHPExiftool\Driver\Tag\ASF\DRMKeyID(),
                'DRM_LASignatureCert' => new \PHPExiftool\Driver\Tag\ASF\DRMLASignatureCert(),
                'DRM_LASignatureLicSrvCert' => new \PHPExiftool\Driver\Tag\ASF\DRMLASignatureLicSrvCert(),
                'DRM_LASignaturePrivKey' => new \PHPExiftool\Driver\Tag\ASF\DRMLASignaturePrivKey(),
                'DRM_LASignatureRootCert' => new \PHPExiftool\Driver\Tag\ASF\DRMLASignatureRootCert(),
                'DRM_LicenseAcqURL' => new \PHPExiftool\Driver\Tag\ASF\DRMLicenseAcqURL(),
                'DRM_V1LicenseAcqURL' => new \PHPExiftool\Driver\Tag\ASF\DRMV1LicenseAcqURL(),
                'DVDID' => new \PHPExiftool\Driver\Tag\ASF\DVDID(),
                'Director' => new \PHPExiftool\Driver\Tag\ASF\Director(),
                'Duration' => new \PHPExiftool\Driver\Tag\ASF\Duration(),
                'EncodedBy' => new \PHPExiftool\Driver\Tag\ASF\EncodedBy(),
                'EncodingSettings' => new \PHPExiftool\Driver\Tag\ASF\EncodingSettings(),
                'EncodingTime' => new \PHPExiftool\Driver\Tag\ASF\EncodingTime(),
                'FileSize' => new \PHPExiftool\Driver\Tag\ASF\FileSize(),
                'Genre' => new \PHPExiftool\Driver\Tag\ASF\Genre(),
                'GenreID' => new \PHPExiftool\Driver\Tag\ASF\GenreID(),
                'HasArbitraryDataStream' => new \PHPExiftool\Driver\Tag\ASF\HasArbitraryDataStream(),
                'HasAttachedImages' => new \PHPExiftool\Driver\Tag\ASF\HasAttachedImages(),
                'HasAudio' => new \PHPExiftool\Driver\Tag\ASF\HasAudio(),
                'HasFileTransferStream' => new \PHPExiftool\Driver\Tag\ASF\HasFileTransferStream(),
                'HasImage' => new \PHPExiftool\Driver\Tag\ASF\HasImage(),
                'HasScript' => new \PHPExiftool\Driver\Tag\ASF\HasScript(),
                'HasVideo' => new \PHPExiftool\Driver\Tag\ASF\HasVideo(),
                'ISRC' => new \PHPExiftool\Driver\Tag\ASF\ISRC(),
                'InitialKey' => new \PHPExiftool\Driver\Tag\ASF\InitialKey(),
                'IsVBR' => new \PHPExiftool\Driver\Tag\ASF\IsVBR(),
                'Is_Protected' => new \PHPExiftool\Driver\Tag\ASF\IsProtected(),
                'Is_Trusted' => new \PHPExiftool\Driver\Tag\ASF\IsTrusted(),
                'Language' => new \PHPExiftool\Driver\Tag\ASF\Language(),
                'Lyrics' => new \PHPExiftool\Driver\Tag\ASF\Lyrics(),
                'Lyrics_Synchronised' => new \PHPExiftool\Driver\Tag\ASF\LyricsSynchronised(),
                'MCDI' => new \PHPExiftool\Driver\Tag\ASF\MCDI(),
                'MediaClassPrimaryID' => new \PHPExiftool\Driver\Tag\ASF\MediaClassPrimaryID(),
                'MediaClassSecondaryID' => new \PHPExiftool\Driver\Tag\ASF\MediaClassSecondaryID(),
                'MediaCredits' => new \PHPExiftool\Driver\Tag\ASF\MediaCredits(),
                'MediaIsDelay' => new \PHPExiftool\Driver\Tag\ASF\MediaIsDelay(),
                'MediaIsFinale' => new \PHPExiftool\Driver\Tag\ASF\MediaIsFinale(),
                'MediaIsLive' => new \PHPExiftool\Driver\Tag\ASF\MediaIsLive(),
                'MediaIsPremiere' => new \PHPExiftool\Driver\Tag\ASF\MediaIsPremiere(),
                'MediaIsRepeat' => new \PHPExiftool\Driver\Tag\ASF\MediaIsRepeat(),
                'MediaIsSAP' => new \PHPExiftool\Driver\Tag\ASF\MediaIsSAP(),
                'MediaIsStereo' => new \PHPExiftool\Driver\Tag\ASF\MediaIsStereo(),
                'MediaIsSubtitled' => new \PHPExiftool\Driver\Tag\ASF\MediaIsSubtitled(),
                'MediaIsTape' => new \PHPExiftool\Driver\Tag\ASF\MediaIsTape(),
                'MediaNetworkAffiliation' => new \PHPExiftool\Driver\Tag\ASF\MediaNetworkAffiliation(),
                'MediaOriginalBroadcastDateTime' => new \PHPExiftool\Driver\Tag\ASF\MediaOriginalBroadcastDateTime(),
                'MediaOriginalChannel' => new \PHPExiftool\Driver\Tag\ASF\MediaOriginalChannel(),
                'MediaStationCallSign' => new \PHPExiftool\Driver\Tag\ASF\MediaStationCallSign(),
                'MediaStationName' => new \PHPExiftool\Driver\Tag\ASF\MediaStationName(),
                'ModifiedBy' => new \PHPExiftool\Driver\Tag\ASF\ModifiedBy(),
                'Mood' => new \PHPExiftool\Driver\Tag\ASF\Mood(),
                'NSC_Address' => new \PHPExiftool\Driver\Tag\ASF\NSCAddress(),
                'NSC_Description' => new \PHPExiftool\Driver\Tag\ASF\NSCDescription(),
                'NSC_Email' => new \PHPExiftool\Driver\Tag\ASF\NSCEmail(),
                'NSC_Name' => new \PHPExiftool\Driver\Tag\ASF\NSCName(),
                'NSC_Phone' => new \PHPExiftool\Driver\Tag\ASF\NSCPhone(),
                'NumberOfFrames' => new \PHPExiftool\Driver\Tag\ASF\NumberOfFrames(),
                'OptimalBitrate' => new \PHPExiftool\Driver\Tag\ASF\OptimalBitrate(),
                'OriginalAlbumTitle' => new \PHPExiftool\Driver\Tag\ASF\OriginalAlbumTitle(),
                'OriginalArtist' => new \PHPExiftool\Driver\Tag\ASF\OriginalArtist(),
                'OriginalFileName' => new \PHPExiftool\Driver\Tag\ASF\OriginalFileName(),
                'OriginalLyricist' => new \PHPExiftool\Driver\Tag\ASF\OriginalLyricist(),
                'OriginalReleaseTime' => new \PHPExiftool\Driver\Tag\ASF\OriginalReleaseTime(),
                'OriginalReleaseYear' => new \PHPExiftool\Driver\Tag\ASF\OriginalReleaseYear(),
                'ParentalRating' => new \PHPExiftool\Driver\Tag\ASF\ParentalRating(),
                'ParentalRatingReason' => new \PHPExiftool\Driver\Tag\ASF\ParentalRatingReason(),
                'PartOfSet' => new \PHPExiftool\Driver\Tag\ASF\PartOfSet(),
                'PeakBitrate' => new \PHPExiftool\Driver\Tag\ASF\PeakBitrate(),
                'PeakValue' => new \PHPExiftool\Driver\Tag\ASF\PeakValue(),
                'Period' => new \PHPExiftool\Driver\Tag\ASF\Period(),
                'PlaylistDelay' => new \PHPExiftool\Driver\Tag\ASF\PlaylistDelay(),
                'Producer' => new \PHPExiftool\Driver\Tag\ASF\Producer(),
                'PromotionURL' => new \PHPExiftool\Driver\Tag\ASF\PromotionURL(),
                'ProtectionType' => new \PHPExiftool\Driver\Tag\ASF\ProtectionType(),
                'Provider' => new \PHPExiftool\Driver\Tag\ASF\Provider(),
                'ProviderCopyright' => new \PHPExiftool\Driver\Tag\ASF\ProviderCopyright(),
                'ProviderRating' => new \PHPExiftool\Driver\Tag\ASF\ProviderRating(),
                'ProviderStyle' => new \PHPExiftool\Driver\Tag\ASF\ProviderStyle(),
                'Publisher' => new \PHPExiftool\Driver\Tag\ASF\Publisher(),
                'RadioStationName' => new \PHPExiftool\Driver\Tag\ASF\RadioStationName(),
                'RadioStationOwner' => new \PHPExiftool\Driver\Tag\ASF\RadioStationOwner(),
                'Seekable' => new \PHPExiftool\Driver\Tag\ASF\Seekable(),
                'SharedUserRating' => new \PHPExiftool\Driver\Tag\ASF\SharedUserRating(),
                'Signature_Name' => new \PHPExiftool\Driver\Tag\ASF\SignatureName(),
                'StreamTypeInfo' => new \PHPExiftool\Driver\Tag\ASF\StreamTypeInfo(),
                'Stridable' => new \PHPExiftool\Driver\Tag\ASF\Stridable(),
                'Subtitle' => new \PHPExiftool\Driver\Tag\ASF\Subtitle(),
                'SubtitleDescription' => new \PHPExiftool\Driver\Tag\ASF\SubtitleDescription(),
                'SubscriptionContentID' => new \PHPExiftool\Driver\Tag\ASF\SubscriptionContentID(),
                'Text' => new \PHPExiftool\Driver\Tag\ASF\Text(),
                'ToolName' => new \PHPExiftool\Driver\Tag\ASF\ToolName(),
                'ToolVersion' => new \PHPExiftool\Driver\Tag\ASF\ToolVersion(),
                'Track' => new \PHPExiftool\Driver\Tag\ASF\Track(),
                'TrackNumber' => new \PHPExiftool\Driver\Tag\ASF\TrackNumber(),
                'UniqueFileIdentifier' => new \PHPExiftool\Driver\Tag\ASF\UniqueFileIdentifier(),
                'UserWebURL' => new \PHPExiftool\Driver\Tag\ASF\UserWebURL(),
                'VBRPeak' => new \PHPExiftool\Driver\Tag\ASF\VBRPeak(),
                'VideoClosedCaptioning' => new \PHPExiftool\Driver\Tag\ASF\VideoClosedCaptioning(),
                'VideoFrameRate' => new \PHPExiftool\Driver\Tag\ASF\VideoFrameRate(),
                'VideoHeight' => new \PHPExiftool\Driver\Tag\ASF\VideoHeight(),
                'VideoWidth' => new \PHPExiftool\Driver\Tag\ASF\VideoWidth(),
                'WMADRCAverageReference' => new \PHPExiftool\Driver\Tag\ASF\WMADRCAverageReference(),
                'WMADRCAverageTarget' => new \PHPExiftool\Driver\Tag\ASF\WMADRCAverageTarget(),
                'WMADRCPeakReference' => new \PHPExiftool\Driver\Tag\ASF\WMADRCPeakReference(),
                'WMADRCPeakTarget' => new \PHPExiftool\Driver\Tag\ASF\WMADRCPeakTarget(),
                'WMCollectionGroupID' => new \PHPExiftool\Driver\Tag\ASF\WMCollectionGroupID(),
                'WMCollectionID' => new \PHPExiftool\Driver\Tag\ASF\WMCollectionID(),
                'WMContentID' => new \PHPExiftool\Driver\Tag\ASF\WMContentID(),
                'Writer' => new \PHPExiftool\Driver\Tag\ASF\Writer(),
                'Year' => new \PHPExiftool\Driver\Tag\ASF\Year(),
                'FileID' => new \PHPExiftool\Driver\Tag\ASF\FileID(),
                'FileLength' => new \PHPExiftool\Driver\Tag\ASF\FileLength(),
                'CreationDate' => new \PHPExiftool\Driver\Tag\ASF\CreationDate(),
                'DataPackets' => new \PHPExiftool\Driver\Tag\ASF\DataPackets(),
                'SendDuration' => new \PHPExiftool\Driver\Tag\ASF\SendDuration(),
                'Preroll' => new \PHPExiftool\Driver\Tag\ASF\Preroll(),
                'Flags' => new \PHPExiftool\Driver\Tag\ASF\Flags(),
                'MinPacketSize' => new \PHPExiftool\Driver\Tag\ASF\MinPacketSize(),
                'MaxPacketSize' => new \PHPExiftool\Driver\Tag\ASF\MaxPacketSize(),
                'MaxBitrate' => new \PHPExiftool\Driver\Tag\ASF\MaxBitrate(),
                'Padding' => new \PHPExiftool\Driver\Tag\ASF\Padding(),
                'ScriptCommand' => new \PHPExiftool\Driver\Tag\ASF\ScriptCommand(),
                'ContentEncryption' => new \PHPExiftool\Driver\Tag\ASF\ContentEncryption(),
                'DigitalSignature' => new \PHPExiftool\Driver\Tag\ASF\DigitalSignature(),
                'ExtendedContentEncryption' => new \PHPExiftool\Driver\Tag\ASF\ExtendedContentEncryption(),
                'ErrorCorrection' => new \PHPExiftool\Driver\Tag\ASF\ErrorCorrection(),
                'StreamBitrateProps' => new \PHPExiftool\Driver\Tag\ASF\StreamBitrateProps(),
                'BitrateMutualExclusion' => new \PHPExiftool\Driver\Tag\ASF\BitrateMutualExclusion(),
                'Marker' => new \PHPExiftool\Driver\Tag\ASF\Marker(),
                'ExtendedStreamProps' => new \PHPExiftool\Driver\Tag\ASF\ExtendedStreamProps(),
                'AdvancedContentEncryption' => new \PHPExiftool\Driver\Tag\ASF\AdvancedContentEncryption(),
                'TimecodeIndexParms' => new \PHPExiftool\Driver\Tag\ASF\TimecodeIndexParms(),
                'Compatibility' => new \PHPExiftool\Driver\Tag\ASF\Compatibility(),
                'LanguageList' => new \PHPExiftool\Driver\Tag\ASF\LanguageList(),
                'AdvancedMutualExcl' => new \PHPExiftool\Driver\Tag\ASF\AdvancedMutualExcl(),
                'BandwidthSharing' => new \PHPExiftool\Driver\Tag\ASF\BandwidthSharing(),
                'Reserved1' => new \PHPExiftool\Driver\Tag\ASF\Reserved1(),
                'GroupMutualExclusion' => new \PHPExiftool\Driver\Tag\ASF\GroupMutualExclusion(),
                'StreamPrioritization' => new \PHPExiftool\Driver\Tag\ASF\StreamPrioritization(),
                'IndexParameters' => new \PHPExiftool\Driver\Tag\ASF\IndexParameters(),
                'SimpleIndex' => new \PHPExiftool\Driver\Tag\ASF\SimpleIndex(),
                'TimecodeIndex' => new \PHPExiftool\Driver\Tag\ASF\TimecodeIndex(),
                'Data' => new \PHPExiftool\Driver\Tag\ASF\Data(),
                'Index' => new \PHPExiftool\Driver\Tag\ASF\Index(),
                'MediaIndex' => new \PHPExiftool\Driver\Tag\ASF\MediaIndex(),
                'PictureType' => new \PHPExiftool\Driver\Tag\ASF\PictureType(),
                'PictureMIMEType' => new \PHPExiftool\Driver\Tag\ASF\PictureMIMEType(),
                'PictureDescription' => new \PHPExiftool\Driver\Tag\ASF\PictureDescription(),
                'Picture' => new \PHPExiftool\Driver\Tag\ASF\Picture(),
                'StreamType' => new \PHPExiftool\Driver\Tag\ASF\StreamType(),
                'ErrorCorrectionType' => new \PHPExiftool\Driver\Tag\ASF\ErrorCorrectionType(),
                'TimeOffset' => new \PHPExiftool\Driver\Tag\ASF\TimeOffset(),
                'StreamNumber' => new \PHPExiftool\Driver\Tag\ASF\StreamNumber(),
                'AudioCodecID' => new \PHPExiftool\Driver\Tag\ASF\AudioCodecID(),
                'ImageWidth' => new \PHPExiftool\Driver\Tag\ASF\ImageWidth(),
                'AudioChannels' => new \PHPExiftool\Driver\Tag\ASF\AudioChannels(),
                'AudioSampleRate' => new \PHPExiftool\Driver\Tag\ASF\AudioSampleRate(),
                'ImageHeight' => new \PHPExiftool\Driver\Tag\ASF\ImageHeight(),
            );
        });
        $this['Apple'] = $this->share(function(){
            return array(
                'AccelerationVector' => new \PHPExiftool\Driver\Tag\Apple\AccelerationVector(),
                'HDRImageType' => new \PHPExiftool\Driver\Tag\Apple\HDRImageType(),
                'BurstUUID' => new \PHPExiftool\Driver\Tag\Apple\BurstUUID(),
                'ContentIdentifier' => new \PHPExiftool\Driver\Tag\Apple\ContentIdentifier(),
                'ImageUniqueID' => new \PHPExiftool\Driver\Tag\Apple\ImageUniqueID(),
                'RunTimeEpoch' => new \PHPExiftool\Driver\Tag\Apple\RunTimeEpoch(),
                'RunTimeFlags' => new \PHPExiftool\Driver\Tag\Apple\RunTimeFlags(),
                'RunTimeScale' => new \PHPExiftool\Driver\Tag\Apple\RunTimeScale(),
                'RunTimeValue' => new \PHPExiftool\Driver\Tag\Apple\RunTimeValue(),
            );
        });
        $this['Audible'] = $this->share(function(){
            return array(
                'ChapterCount' => new \PHPExiftool\Driver\Tag\Audible\ChapterCount(),
                'CoverArt' => new \PHPExiftool\Driver\Tag\Audible\CoverArt(),
                'Author' => new \PHPExiftool\Driver\Tag\Audible\Author(),
                'Copyright' => new \PHPExiftool\Driver\Tag\Audible\Copyright(),
                'PublishDateStart' => new \PHPExiftool\Driver\Tag\Audible\PublishDateStart(),
                'PublishDate' => new \PHPExiftool\Driver\Tag\Audible\PublishDate(),
                'CoverArtType' => new \PHPExiftool\Driver\Tag\Audible\CoverArtType(),
                'AlbumArtist' => new \PHPExiftool\Driver\Tag\Audible\AlbumArtist(),
                'Album' => new \PHPExiftool\Driver\Tag\Audible\Album(),
                'Artist' => new \PHPExiftool\Driver\Tag\Audible\Artist(),
                'Comment' => new \PHPExiftool\Driver\Tag\Audible\Comment(),
                'Genre' => new \PHPExiftool\Driver\Tag\Audible\Genre(),
                'Subtitle' => new \PHPExiftool\Driver\Tag\Audible\Subtitle(),
                'CreatorTool' => new \PHPExiftool\Driver\Tag\Audible\CreatorTool(),
                'Title' => new \PHPExiftool\Driver\Tag\Audible\Title(),
                'Year' => new \PHPExiftool\Driver\Tag\Audible\Year(),
                'iTunesMediaType' => new \PHPExiftool\Driver\Tag\Audible\ITunesMediaType(),
                'ChapterName' => new \PHPExiftool\Driver\Tag\Audible\ChapterName(),
                'ChapterNumber' => new \PHPExiftool\Driver\Tag\Audible\ChapterNumber(),
            );
        });
        $this['File'] = $this->share(function(){
            return array(
                'EmbeddedJPG' => new \PHPExiftool\Driver\Tag\File\EmbeddedJPG(),
                'EmbeddedPNG' => new \PHPExiftool\Driver\Tag\File\EmbeddedPNG(),
                'LinkedProfileName' => new \PHPExiftool\Driver\Tag\File\LinkedProfileName(),
                'BMPVersion' => new \PHPExiftool\Driver\Tag\File\BMPVersion(),
                'ImageWidth' => new \PHPExiftool\Driver\Tag\File\ImageWidth(),
                'ImageHeight' => new \PHPExiftool\Driver\Tag\File\ImageHeight(),
                'Planes' => new \PHPExiftool\Driver\Tag\File\Planes(),
                'BitDepth' => new \PHPExiftool\Driver\Tag\File\BitDepth(),
                'Compression' => new \PHPExiftool\Driver\Tag\File\Compression(),
                'ImageLength' => new \PHPExiftool\Driver\Tag\File\ImageLength(),
                'PixelsPerMeterX' => new \PHPExiftool\Driver\Tag\File\PixelsPerMeterX(),
                'PixelsPerMeterY' => new \PHPExiftool\Driver\Tag\File\PixelsPerMeterY(),
                'NumColors' => new \PHPExiftool\Driver\Tag\File\NumColors(),
                'NumImportantColors' => new \PHPExiftool\Driver\Tag\File\NumImportantColors(),
                'RedMask' => new \PHPExiftool\Driver\Tag\File\RedMask(),
                'GreenMask' => new \PHPExiftool\Driver\Tag\File\GreenMask(),
                'BlueMask' => new \PHPExiftool\Driver\Tag\File\BlueMask(),
                'AlphaMask' => new \PHPExiftool\Driver\Tag\File\AlphaMask(),
                'ColorSpace' => new \PHPExiftool\Driver\Tag\File\ColorSpace(),
                'RedEndpoint' => new \PHPExiftool\Driver\Tag\File\RedEndpoint(),
                'GreenEndpoint' => new \PHPExiftool\Driver\Tag\File\GreenEndpoint(),
                'BlueEndpoint' => new \PHPExiftool\Driver\Tag\File\BlueEndpoint(),
                'GammaRed' => new \PHPExiftool\Driver\Tag\File\GammaRed(),
                'GammaGreen' => new \PHPExiftool\Driver\Tag\File\GammaGreen(),
                'GammaBlue' => new \PHPExiftool\Driver\Tag\File\GammaBlue(),
                'RenderingIntent' => new \PHPExiftool\Driver\Tag\File\RenderingIntent(),
                'ProfileDataOffset' => new \PHPExiftool\Driver\Tag\File\ProfileDataOffset(),
                'ProfileSize' => new \PHPExiftool\Driver\Tag\File\ProfileSize(),
                'ThumbnailBPG' => new \PHPExiftool\Driver\Tag\File\ThumbnailBPG(),
                'AnimationControl' => new \PHPExiftool\Driver\Tag\File\AnimationControl(),
                'PixelFormat' => new \PHPExiftool\Driver\Tag\File\PixelFormat(),
                'Alpha' => new \PHPExiftool\Driver\Tag\File\Alpha(),
                'Flags' => new \PHPExiftool\Driver\Tag\File\Flags(),
                'ByteOrder' => new \PHPExiftool\Driver\Tag\File\ByteOrder(),
                'HeaderVersion' => new \PHPExiftool\Driver\Tag\File\HeaderVersion(),
                'DPXFileSize' => new \PHPExiftool\Driver\Tag\File\DPXFileSize(),
                'DittoKey' => new \PHPExiftool\Driver\Tag\File\DittoKey(),
                'ImageFileName' => new \PHPExiftool\Driver\Tag\File\ImageFileName(),
                'CreateDate' => new \PHPExiftool\Driver\Tag\File\CreateDate(),
                'Creator' => new \PHPExiftool\Driver\Tag\File\Creator(),
                'Project' => new \PHPExiftool\Driver\Tag\File\Project(),
                'Copyright' => new \PHPExiftool\Driver\Tag\File\Copyright(),
                'EncryptionKey' => new \PHPExiftool\Driver\Tag\File\EncryptionKey(),
                'Orientation' => new \PHPExiftool\Driver\Tag\File\Orientation(),
                'ImageElements' => new \PHPExiftool\Driver\Tag\File\ImageElements(),
                'DataSign' => new \PHPExiftool\Driver\Tag\File\DataSign(),
                'ComponentsConfiguration' => new \PHPExiftool\Driver\Tag\File\ComponentsConfiguration(),
                'ImageDescription' => new \PHPExiftool\Driver\Tag\File\ImageDescription(),
                'Image2Description' => new \PHPExiftool\Driver\Tag\File\Image2Description(),
                'Image3Description' => new \PHPExiftool\Driver\Tag\File\Image3Description(),
                'Image4Description' => new \PHPExiftool\Driver\Tag\File\Image4Description(),
                'Image5Description' => new \PHPExiftool\Driver\Tag\File\Image5Description(),
                'Image6Description' => new \PHPExiftool\Driver\Tag\File\Image6Description(),
                'Image7Description' => new \PHPExiftool\Driver\Tag\File\Image7Description(),
                'Image8Description' => new \PHPExiftool\Driver\Tag\File\Image8Description(),
                'SourceFileName' => new \PHPExiftool\Driver\Tag\File\SourceFileName(),
                'SourceCreateDate' => new \PHPExiftool\Driver\Tag\File\SourceCreateDate(),
                'InputDeviceName' => new \PHPExiftool\Driver\Tag\File\InputDeviceName(),
                'InputDeviceSerialNumber' => new \PHPExiftool\Driver\Tag\File\InputDeviceSerialNumber(),
                'FrameRate' => new \PHPExiftool\Driver\Tag\File\FrameRate(),
                'FrameID' => new \PHPExiftool\Driver\Tag\File\FrameID(),
                'SlateInformation' => new \PHPExiftool\Driver\Tag\File\SlateInformation(),
                'Reserved5' => new \PHPExiftool\Driver\Tag\File\Reserved5(),
                'UserID' => new \PHPExiftool\Driver\Tag\File\UserID(),
                'Comment' => new \PHPExiftool\Driver\Tag\File\Comment(),
                'CurrentIPTCDigest' => new \PHPExiftool\Driver\Tag\File\CurrentIPTCDigest(),
                'EmbeddedVideo' => new \PHPExiftool\Driver\Tag\File\EmbeddedVideo(),
                'ExifByteOrder' => new \PHPExiftool\Driver\Tag\File\ExifByteOrder(),
                'ExifUnicodeByteOrder' => new \PHPExiftool\Driver\Tag\File\ExifUnicodeByteOrder(),
                'FileType' => new \PHPExiftool\Driver\Tag\File\FileType(),
                'FileTypeExtension' => new \PHPExiftool\Driver\Tag\File\FileTypeExtension(),
                'Geosync' => new \PHPExiftool\Driver\Tag\File\Geosync(),
                'Geotag' => new \PHPExiftool\Driver\Tag\File\Geotag(),
                'Geotime' => new \PHPExiftool\Driver\Tag\File\Geotime(),
                'HardLink' => new \PHPExiftool\Driver\Tag\File\HardLink(),
                'ID3Size' => new \PHPExiftool\Driver\Tag\File\ID3Size(),
                'JPEGDigest' => new \PHPExiftool\Driver\Tag\File\JPEGDigest(),
                'JPEGImageLength' => new \PHPExiftool\Driver\Tag\File\JPEGImageLength(),
                'JPEGQualityEstimate' => new \PHPExiftool\Driver\Tag\File\JPEGQualityEstimate(),
                'MIMEType' => new \PHPExiftool\Driver\Tag\File\MIMEType(),
                'MaxVal' => new \PHPExiftool\Driver\Tag\File\MaxVal(),
                'OtherImage' => new \PHPExiftool\Driver\Tag\File\OtherImage(),
                'PreviewPDF' => new \PHPExiftool\Driver\Tag\File\PreviewPDF(),
                'PreviewPNG' => new \PHPExiftool\Driver\Tag\File\PreviewPNG(),
                'PreviewTIFF' => new \PHPExiftool\Driver\Tag\File\PreviewTIFF(),
                'PreviewWMF' => new \PHPExiftool\Driver\Tag\File\PreviewWMF(),
                'RAFVersion' => new \PHPExiftool\Driver\Tag\File\RAFVersion(),
                'SymLink' => new \PHPExiftool\Driver\Tag\File\SymLink(),
                'TestName' => new \PHPExiftool\Driver\Tag\File\TestName(),
                'ThumbnailImage' => new \PHPExiftool\Driver\Tag\File\ThumbnailImage(),
                'XResolution' => new \PHPExiftool\Driver\Tag\File\XResolution(),
                'YResolution' => new \PHPExiftool\Driver\Tag\File\YResolution(),
                'ImageType' => new \PHPExiftool\Driver\Tag\File\ImageType(),
                'AnimationFrames' => new \PHPExiftool\Driver\Tag\File\AnimationFrames(),
                'Encoding' => new \PHPExiftool\Driver\Tag\File\Encoding(),
                'BitsPerSample' => new \PHPExiftool\Driver\Tag\File\BitsPerSample(),
                'ColorComponents' => new \PHPExiftool\Driver\Tag\File\ColorComponents(),
                'EncodingProcess' => new \PHPExiftool\Driver\Tag\File\EncodingProcess(),
                'YCbCrSubSampling' => new \PHPExiftool\Driver\Tag\File\YCbCrSubSampling(),
                'Manufacturer' => new \PHPExiftool\Driver\Tag\File\Manufacturer(),
                'Software' => new \PHPExiftool\Driver\Tag\File\Software(),
                'BitsPerPixel' => new \PHPExiftool\Driver\Tag\File\BitsPerPixel(),
                'LeftMargin' => new \PHPExiftool\Driver\Tag\File\LeftMargin(),
                'TopMargin' => new \PHPExiftool\Driver\Tag\File\TopMargin(),
                'ColorPlanes' => new \PHPExiftool\Driver\Tag\File\ColorPlanes(),
                'BytesPerLine' => new \PHPExiftool\Driver\Tag\File\BytesPerLine(),
                'ColorMode' => new \PHPExiftool\Driver\Tag\File\ColorMode(),
                'ScreenWidth' => new \PHPExiftool\Driver\Tag\File\ScreenWidth(),
                'ScreenHeight' => new \PHPExiftool\Driver\Tag\File\ScreenHeight(),
                'PGFVersion' => new \PHPExiftool\Driver\Tag\File\PGFVersion(),
                'PyramidLevels' => new \PHPExiftool\Driver\Tag\File\PyramidLevels(),
                'Quality' => new \PHPExiftool\Driver\Tag\File\Quality(),
                'BackgroundColor' => new \PHPExiftool\Driver\Tag\File\BackgroundColor(),
                'ByteOrderMark' => new \PHPExiftool\Driver\Tag\File\ByteOrderMark(),
                'LineCount' => new \PHPExiftool\Driver\Tag\File\LineCount(),
                'MIMEEncoding' => new \PHPExiftool\Driver\Tag\File\MIMEEncoding(),
                'Newlines' => new \PHPExiftool\Driver\Tag\File\Newlines(),
                'WordCount' => new \PHPExiftool\Driver\Tag\File\WordCount(),
            );
        });
      
        $this['All'] = $this->share(function(){
            return array(
                'JpgFromRaw' => new \PHPExiftool\Driver\Tag\All\JpgFromRaw(),
                'OtherImage' => new \PHPExiftool\Driver\Tag\All\OtherImage(),
                'PreviewImage' => new \PHPExiftool\Driver\Tag\All\PreviewImage(),
                'ThumbnailImage' => new \PHPExiftool\Driver\Tag\All\ThumbnailImage(),
                'PreviewImageStart' => new \PHPExiftool\Driver\Tag\All\PreviewImageStart(),
                'PreviewImageLength' => new \PHPExiftool\Driver\Tag\All\PreviewImageLength(),
            );
        });
       
        $this['XMP-drone-dji'] = $this->share(function(){
            return array(
                'AbsoluteAltitude' => new \PHPExiftool\Driver\Tag\XMPDroneDji\AbsoluteAltitude(),
                'CalibratedFocalLength' => new \PHPExiftool\Driver\Tag\XMPDroneDji\CalibratedFocalLength(),
                'CalibratedOpticalCenterX' => new \PHPExiftool\Driver\Tag\XMPDroneDji\CalibratedOpticalCenterX(),
                'CalibratedOpticalCenterY' => new \PHPExiftool\Driver\Tag\XMPDroneDji\CalibratedOpticalCenterY(),
                'CamReverse' => new \PHPExiftool\Driver\Tag\XMPDroneDji\CamReverse(),
                'DewarpData' => new \PHPExiftool\Driver\Tag\XMPDroneDji\DewarpData(),
                'DewarpFlag' => new \PHPExiftool\Driver\Tag\XMPDroneDji\DewarpFlag(),
                'FlightPitchDegree' => new \PHPExiftool\Driver\Tag\XMPDroneDji\FlightPitchDegree(),
                'FlightRollDegree' => new \PHPExiftool\Driver\Tag\XMPDroneDji\FlightRollDegree(),
                'FlightXSpeed' => new \PHPExiftool\Driver\Tag\XMPDroneDji\FlightXSpeed(),
                'FlightYSpeed' => new \PHPExiftool\Driver\Tag\XMPDroneDji\FlightYSpeed(),
                'FlightYawDegree' => new \PHPExiftool\Driver\Tag\XMPDroneDji\FlightYawDegree(),
                'FlightZSpeed' => new \PHPExiftool\Driver\Tag\XMPDroneDji\FlightZSpeed(),
                'GimbalPitchDegree' => new \PHPExiftool\Driver\Tag\XMPDroneDji\GimbalPitchDegree(),
                'GimbalReverse' => new \PHPExiftool\Driver\Tag\XMPDroneDji\GimbalReverse(),
                'GimbalRollDegree' => new \PHPExiftool\Driver\Tag\XMPDroneDji\GimbalRollDegree(),
                'GimbalYawDegree' => new \PHPExiftool\Driver\Tag\XMPDroneDji\GimbalYawDegree(),
                'GPSLatitude' => new \PHPExiftool\Driver\Tag\XMPDroneDji\GPSLatitude(),
                'GPSLongitude' => new \PHPExiftool\Driver\Tag\XMPDroneDji\GPSLongitude(),
                'GPSLongtitude' => new \PHPExiftool\Driver\Tag\XMPDroneDji\GPSLongtitude(),
                'Latitude' => new \PHPExiftool\Driver\Tag\XMPDroneDji\Latitude(),
                'Longitude' => new \PHPExiftool\Driver\Tag\XMPDroneDji\Longitude(),
                'RelativeAltitude' => new \PHPExiftool\Driver\Tag\XMPDroneDji\RelativeAltitude(),
                'RtkFlag' => new \PHPExiftool\Driver\Tag\XMPDroneDji\RtkFlag(),
                'RtkStdHgt' => new \PHPExiftool\Driver\Tag\XMPDroneDji\RtkStdHgt(),
                'RtkStdLat' => new \PHPExiftool\Driver\Tag\XMPDroneDji\RtkStdLat(),
                'RtkStdLon' => new \PHPExiftool\Driver\Tag\XMPDroneDji\RtkStdLon(),
                'SelfData' => new \PHPExiftool\Driver\Tag\XMPDroneDji\SelfData(),
            );
        });
        $this['ExifIFD'] = $this->share(function(){
            return array(
                'ExifVersion' => new \PHPExiftool\Driver\Tag\ExifIFD\ExifVersion(),
                'DateTimeOriginal' => new \PHPExiftool\Driver\Tag\ExifIFD\DateTimeOriginal(),
                'CreateDate' => new \PHPExiftool\Driver\Tag\ExifIFD\CreateDate(),
                'OffsetTime' => new \PHPExiftool\Driver\Tag\ExifIFD\OffsetTime(),
                'OffsetTimeOriginal' => new \PHPExiftool\Driver\Tag\ExifIFD\OffsetTimeOriginal(),
                'OffsetTimeDigitized' => new \PHPExiftool\Driver\Tag\ExifIFD\OffsetTimeDigitized(),
				
				'ComponentsConfiguration' => new \PHPExiftool\Driver\Tag\ExifIFD\ComponentsConfiguration(),
				
				'FlashpixVersion' => new \PHPExiftool\Driver\Tag\ExifIFD\FlashpixVersion(),
                'ColorSpace' => new \PHPExiftool\Driver\Tag\ExifIFD\ColorSpace(),
              
            );
        });
		$this['IFD0'] = $this->share(function(){
            return array(
                'ModifyDate' => new \PHPExiftool\Driver\Tag\IFD0\ModifyDate(),              
            );
        });
        $this['DNG'] = $this->share(function(){
            return array(
                'OriginalRawImage' => new \PHPExiftool\Driver\Tag\DNG\OriginalRawImage(),
                'OriginalRawResource' => new \PHPExiftool\Driver\Tag\DNG\OriginalRawResource(),
                'OriginalRawFileType' => new \PHPExiftool\Driver\Tag\DNG\OriginalRawFileType(),
                'OriginalRawCreator' => new \PHPExiftool\Driver\Tag\DNG\OriginalRawCreator(),
                'OriginalTHMImage' => new \PHPExiftool\Driver\Tag\DNG\OriginalTHMImage(),
                'OriginalTHMResource' => new \PHPExiftool\Driver\Tag\DNG\OriginalTHMResource(),
                'OriginalTHMFileType' => new \PHPExiftool\Driver\Tag\DNG\OriginalTHMFileType(),
                'OriginalTHMCreator' => new \PHPExiftool\Driver\Tag\DNG\OriginalTHMCreator(),
            );
        });
        $this['DV'] = $this->share(function(){
            return array(
                'AspectRatio' => new \PHPExiftool\Driver\Tag\DV\AspectRatio(),
                'AudioBitsPerSample' => new \PHPExiftool\Driver\Tag\DV\AudioBitsPerSample(),
                'AudioChannels' => new \PHPExiftool\Driver\Tag\DV\AudioChannels(),
                'AudioSampleRate' => new \PHPExiftool\Driver\Tag\DV\AudioSampleRate(),
                'Colorimetry' => new \PHPExiftool\Driver\Tag\DV\Colorimetry(),
                'DateTimeOriginal' => new \PHPExiftool\Driver\Tag\DV\DateTimeOriginal(),
                'Duration' => new \PHPExiftool\Driver\Tag\DV\Duration(),
                'FrameRate' => new \PHPExiftool\Driver\Tag\DV\FrameRate(),
                'ImageHeight' => new \PHPExiftool\Driver\Tag\DV\ImageHeight(),
                'ImageWidth' => new \PHPExiftool\Driver\Tag\DV\ImageWidth(),
                'TotalBitrate' => new \PHPExiftool\Driver\Tag\DV\TotalBitrate(),
                'VideoFormat' => new \PHPExiftool\Driver\Tag\DV\VideoFormat(),
                'VideoScanType' => new \PHPExiftool\Driver\Tag\DV\VideoScanType(),
            );
        });
        $this['XMP-dwc'] = $this->share(function(){
            return array(
                'DCEvent' => new \PHPExiftool\Driver\Tag\XMPDwc\DCEvent(),
                'EventDay' => new \PHPExiftool\Driver\Tag\XMPDwc\EventDay(),
                'EventEarliestDate' => new \PHPExiftool\Driver\Tag\XMPDwc\EventEarliestDate(),
                'EventEndDayOfYear' => new \PHPExiftool\Driver\Tag\XMPDwc\EventEndDayOfYear(),
                'EventDate' => new \PHPExiftool\Driver\Tag\XMPDwc\EventDate(),
                'EventID' => new \PHPExiftool\Driver\Tag\XMPDwc\EventID(),
                'EventRemarks' => new \PHPExiftool\Driver\Tag\XMPDwc\EventRemarks(),
                'EventTime' => new \PHPExiftool\Driver\Tag\XMPDwc\EventTime(),
                'EventFieldNotes' => new \PHPExiftool\Driver\Tag\XMPDwc\EventFieldNotes(),
                'EventFieldNumber' => new \PHPExiftool\Driver\Tag\XMPDwc\EventFieldNumber(),
                'EventHabitat' => new \PHPExiftool\Driver\Tag\XMPDwc\EventHabitat(),
                'EventLatestDate' => new \PHPExiftool\Driver\Tag\XMPDwc\EventLatestDate(),
                'EventMonth' => new \PHPExiftool\Driver\Tag\XMPDwc\EventMonth(),
                'EventParentEventID' => new \PHPExiftool\Driver\Tag\XMPDwc\EventParentEventID(),
                'EventSampleSizeUnit' => new \PHPExiftool\Driver\Tag\XMPDwc\EventSampleSizeUnit(),
                'EventSampleSizeValue' => new \PHPExiftool\Driver\Tag\XMPDwc\EventSampleSizeValue(),
                'EventSamplingEffort' => new \PHPExiftool\Driver\Tag\XMPDwc\EventSamplingEffort(),
                'EventSamplingProtocol' => new \PHPExiftool\Driver\Tag\XMPDwc\EventSamplingProtocol(),
                'EventStartDayOfYear' => new \PHPExiftool\Driver\Tag\XMPDwc\EventStartDayOfYear(),
                'EventVerbatimEventDate' => new \PHPExiftool\Driver\Tag\XMPDwc\EventVerbatimEventDate(),
                'EventYear' => new \PHPExiftool\Driver\Tag\XMPDwc\EventYear(),
                'FossilSpecimen' => new \PHPExiftool\Driver\Tag\XMPDwc\FossilSpecimen(),
                'FossilSpecimenMaterialSampleID' => new \PHPExiftool\Driver\Tag\XMPDwc\FossilSpecimenMaterialSampleID(),
                'GeologicalContext' => new \PHPExiftool\Driver\Tag\XMPDwc\GeologicalContext(),
                'GeologicalContextBed' => new \PHPExiftool\Driver\Tag\XMPDwc\GeologicalContextBed(),
                'EarliestAgeOrLowestStage' => new \PHPExiftool\Driver\Tag\XMPDwc\EarliestAgeOrLowestStage(),
                'EarliestEonOrLowestEonothem' => new \PHPExiftool\Driver\Tag\XMPDwc\EarliestEonOrLowestEonothem(),
                'EarliestEpochOrLowestSeries' => new \PHPExiftool\Driver\Tag\XMPDwc\EarliestEpochOrLowestSeries(),
                'EarliestEraOrLowestErathem' => new \PHPExiftool\Driver\Tag\XMPDwc\EarliestEraOrLowestErathem(),
                'EarliestPeriodOrLowestSystem' => new \PHPExiftool\Driver\Tag\XMPDwc\EarliestPeriodOrLowestSystem(),
                'GeologicalContextFormation' => new \PHPExiftool\Driver\Tag\XMPDwc\GeologicalContextFormation(),
                'GeologicalContextID' => new \PHPExiftool\Driver\Tag\XMPDwc\GeologicalContextID(),
                'GeologicalContextGroup' => new \PHPExiftool\Driver\Tag\XMPDwc\GeologicalContextGroup(),
                'HighestBiostratigraphicZone' => new \PHPExiftool\Driver\Tag\XMPDwc\HighestBiostratigraphicZone(),
                'LatestAgeOrHighestStage' => new \PHPExiftool\Driver\Tag\XMPDwc\LatestAgeOrHighestStage(),
                'LatestEonOrHighestEonothem' => new \PHPExiftool\Driver\Tag\XMPDwc\LatestEonOrHighestEonothem(),
                'LatestEpochOrHighestSeries' => new \PHPExiftool\Driver\Tag\XMPDwc\LatestEpochOrHighestSeries(),
                'LatestEraOrHighestErathem' => new \PHPExiftool\Driver\Tag\XMPDwc\LatestEraOrHighestErathem(),
                'LatestPeriodOrHighestSystem' => new \PHPExiftool\Driver\Tag\XMPDwc\LatestPeriodOrHighestSystem(),
                'LithostratigraphicTerms' => new \PHPExiftool\Driver\Tag\XMPDwc\LithostratigraphicTerms(),
                'LowestBiostratigraphicZone' => new \PHPExiftool\Driver\Tag\XMPDwc\LowestBiostratigraphicZone(),
                'GeologicalContextMember' => new \PHPExiftool\Driver\Tag\XMPDwc\GeologicalContextMember(),
                'HumanObservation' => new \PHPExiftool\Driver\Tag\XMPDwc\HumanObservation(),
                'HumanObservationDay' => new \PHPExiftool\Driver\Tag\XMPDwc\HumanObservationDay(),
                'HumanObservationEarliestDate' => new \PHPExiftool\Driver\Tag\XMPDwc\HumanObservationEarliestDate(),
                'HumanObservationEndDayOfYear' => new \PHPExiftool\Driver\Tag\XMPDwc\HumanObservationEndDayOfYear(),
                'HumanObservationEventDate' => new \PHPExiftool\Driver\Tag\XMPDwc\HumanObservationEventDate(),
                'HumanObservationEventID' => new \PHPExiftool\Driver\Tag\XMPDwc\HumanObservationEventID(),
                'HumanObservationEventRemarks' => new \PHPExiftool\Driver\Tag\XMPDwc\HumanObservationEventRemarks(),
                'HumanObservationEventTime' => new \PHPExiftool\Driver\Tag\XMPDwc\HumanObservationEventTime(),
                'HumanObservationFieldNotes' => new \PHPExiftool\Driver\Tag\XMPDwc\HumanObservationFieldNotes(),
                'HumanObservationFieldNumber' => new \PHPExiftool\Driver\Tag\XMPDwc\HumanObservationFieldNumber(),
                'HumanObservationHabitat' => new \PHPExiftool\Driver\Tag\XMPDwc\HumanObservationHabitat(),
                'HumanObservationLatestDate' => new \PHPExiftool\Driver\Tag\XMPDwc\HumanObservationLatestDate(),
                'HumanObservationMonth' => new \PHPExiftool\Driver\Tag\XMPDwc\HumanObservationMonth(),
                'HumanObservationParentEventID' => new \PHPExiftool\Driver\Tag\XMPDwc\HumanObservationParentEventID(),
                'HumanObservationSampleSizeUnit' => new \PHPExiftool\Driver\Tag\XMPDwc\HumanObservationSampleSizeUnit(),
                'HumanObservationSampleSizeValue' => new \PHPExiftool\Driver\Tag\XMPDwc\HumanObservationSampleSizeValue(),
                'HumanObservationSamplingEffort' => new \PHPExiftool\Driver\Tag\XMPDwc\HumanObservationSamplingEffort(),
                'HumanObservationSamplingProtocol' => new \PHPExiftool\Driver\Tag\XMPDwc\HumanObservationSamplingProtocol(),
                'HumanObservationStartDayOfYear' => new \PHPExiftool\Driver\Tag\XMPDwc\HumanObservationStartDayOfYear(),
                'HumanObservationVerbatimEventDate' => new \PHPExiftool\Driver\Tag\XMPDwc\HumanObservationVerbatimEventDate(),
                'HumanObservationYear' => new \PHPExiftool\Driver\Tag\XMPDwc\HumanObservationYear(),
                'Identification' => new \PHPExiftool\Driver\Tag\XMPDwc\Identification(),
                'DateIdentified' => new \PHPExiftool\Driver\Tag\XMPDwc\DateIdentified(),
                'IdentificationID' => new \PHPExiftool\Driver\Tag\XMPDwc\IdentificationID(),
                'IdentificationQualifier' => new \PHPExiftool\Driver\Tag\XMPDwc\IdentificationQualifier(),
                'IdentificationReferences' => new \PHPExiftool\Driver\Tag\XMPDwc\IdentificationReferences(),
                'IdentificationRemarks' => new \PHPExiftool\Driver\Tag\XMPDwc\IdentificationRemarks(),
                'IdentificationVerificationStatus' => new \PHPExiftool\Driver\Tag\XMPDwc\IdentificationVerificationStatus(),
                'IdentifiedBy' => new \PHPExiftool\Driver\Tag\XMPDwc\IdentifiedBy(),
                'TypeStatus' => new \PHPExiftool\Driver\Tag\XMPDwc\TypeStatus(),
                'LivingSpecimen' => new \PHPExiftool\Driver\Tag\XMPDwc\LivingSpecimen(),
                'LivingSpecimenMaterialSampleID' => new \PHPExiftool\Driver\Tag\XMPDwc\LivingSpecimenMaterialSampleID(),
                'MachineObservation' => new \PHPExiftool\Driver\Tag\XMPDwc\MachineObservation(),
                'MachineObservationDay' => new \PHPExiftool\Driver\Tag\XMPDwc\MachineObservationDay(),
                'MachineObservationEarliestDate' => new \PHPExiftool\Driver\Tag\XMPDwc\MachineObservationEarliestDate(),
                'MachineObservationEndDayOfYear' => new \PHPExiftool\Driver\Tag\XMPDwc\MachineObservationEndDayOfYear(),
                'MachineObservationEventDate' => new \PHPExiftool\Driver\Tag\XMPDwc\MachineObservationEventDate(),
                'MachineObservationEventID' => new \PHPExiftool\Driver\Tag\XMPDwc\MachineObservationEventID(),
                'MachineObservationEventRemarks' => new \PHPExiftool\Driver\Tag\XMPDwc\MachineObservationEventRemarks(),
                'MachineObservationEventTime' => new \PHPExiftool\Driver\Tag\XMPDwc\MachineObservationEventTime(),
                'MachineObservationFieldNotes' => new \PHPExiftool\Driver\Tag\XMPDwc\MachineObservationFieldNotes(),
                'MachineObservationFieldNumber' => new \PHPExiftool\Driver\Tag\XMPDwc\MachineObservationFieldNumber(),
                'MachineObservationHabitat' => new \PHPExiftool\Driver\Tag\XMPDwc\MachineObservationHabitat(),
                'MachineObservationLatestDate' => new \PHPExiftool\Driver\Tag\XMPDwc\MachineObservationLatestDate(),
                'MachineObservationMonth' => new \PHPExiftool\Driver\Tag\XMPDwc\MachineObservationMonth(),
                'MachineObservationParentEventID' => new \PHPExiftool\Driver\Tag\XMPDwc\MachineObservationParentEventID(),
                'MachineObservationSampleSizeUnit' => new \PHPExiftool\Driver\Tag\XMPDwc\MachineObservationSampleSizeUnit(),
                'MachineObservationSampleSizeValue' => new \PHPExiftool\Driver\Tag\XMPDwc\MachineObservationSampleSizeValue(),
                'MachineObservationSamplingEffort' => new \PHPExiftool\Driver\Tag\XMPDwc\MachineObservationSamplingEffort(),
                'MachineObservationSamplingProtocol' => new \PHPExiftool\Driver\Tag\XMPDwc\MachineObservationSamplingProtocol(),
                'MachineObservationStartDayOfYear' => new \PHPExiftool\Driver\Tag\XMPDwc\MachineObservationStartDayOfYear(),
                'MachineObservationVerbatimEventDate' => new \PHPExiftool\Driver\Tag\XMPDwc\MachineObservationVerbatimEventDate(),
                'MachineObservationYear' => new \PHPExiftool\Driver\Tag\XMPDwc\MachineObservationYear(),
                'MaterialSample' => new \PHPExiftool\Driver\Tag\XMPDwc\MaterialSample(),
                'MaterialSampleID' => new \PHPExiftool\Driver\Tag\XMPDwc\MaterialSampleID(),
                'MeasurementOrFact' => new \PHPExiftool\Driver\Tag\XMPDwc\MeasurementOrFact(),
                'MeasurementAccuracy' => new \PHPExiftool\Driver\Tag\XMPDwc\MeasurementAccuracy(),
                'MeasurementDeterminedBy' => new \PHPExiftool\Driver\Tag\XMPDwc\MeasurementDeterminedBy(),
                'MeasurementDeterminedDate' => new \PHPExiftool\Driver\Tag\XMPDwc\MeasurementDeterminedDate(),
                'MeasurementID' => new \PHPExiftool\Driver\Tag\XMPDwc\MeasurementID(),
                'MeasurementMethod' => new \PHPExiftool\Driver\Tag\XMPDwc\MeasurementMethod(),
                'MeasurementRemarks' => new \PHPExiftool\Driver\Tag\XMPDwc\MeasurementRemarks(),
                'MeasurementType' => new \PHPExiftool\Driver\Tag\XMPDwc\MeasurementType(),
                'MeasurementUnit' => new \PHPExiftool\Driver\Tag\XMPDwc\MeasurementUnit(),
                'MeasurementValue' => new \PHPExiftool\Driver\Tag\XMPDwc\MeasurementValue(),
                'Occurrence' => new \PHPExiftool\Driver\Tag\XMPDwc\Occurrence(),
                'OccurrenceAssociatedMedia' => new \PHPExiftool\Driver\Tag\XMPDwc\OccurrenceAssociatedMedia(),
                'OccurrenceAssociatedOccurrences' => new \PHPExiftool\Driver\Tag\XMPDwc\OccurrenceAssociatedOccurrences(),
                'OccurrenceAssociatedReferences' => new \PHPExiftool\Driver\Tag\XMPDwc\OccurrenceAssociatedReferences(),
                'OccurrenceAssociatedSequences' => new \PHPExiftool\Driver\Tag\XMPDwc\OccurrenceAssociatedSequences(),
                'OccurrenceAssociatedTaxa' => new \PHPExiftool\Driver\Tag\XMPDwc\OccurrenceAssociatedTaxa(),
                'OccurrenceBehavior' => new \PHPExiftool\Driver\Tag\XMPDwc\OccurrenceBehavior(),
                'OccurrenceCatalogNumber' => new \PHPExiftool\Driver\Tag\XMPDwc\OccurrenceCatalogNumber(),
                'OccurrenceDisposition' => new \PHPExiftool\Driver\Tag\XMPDwc\OccurrenceDisposition(),
                'OccurrenceEstablishmentMeans' => new \PHPExiftool\Driver\Tag\XMPDwc\OccurrenceEstablishmentMeans(),
                'OccurrenceIndividualCount' => new \PHPExiftool\Driver\Tag\XMPDwc\OccurrenceIndividualCount(),
                'OccurrenceIndividualID' => new \PHPExiftool\Driver\Tag\XMPDwc\OccurrenceIndividualID(),
                'OccurrenceLifeStage' => new \PHPExiftool\Driver\Tag\XMPDwc\OccurrenceLifeStage(),
                'OccurrenceDetails' => new \PHPExiftool\Driver\Tag\XMPDwc\OccurrenceDetails(),
                'OccurrenceID' => new \PHPExiftool\Driver\Tag\XMPDwc\OccurrenceID(),
                'OccurrenceRemarks' => new \PHPExiftool\Driver\Tag\XMPDwc\OccurrenceRemarks(),
                'OccurrenceStatus' => new \PHPExiftool\Driver\Tag\XMPDwc\OccurrenceStatus(),
                'OccurrenceOrganismQuantity' => new \PHPExiftool\Driver\Tag\XMPDwc\OccurrenceOrganismQuantity(),
                'OccurrenceOrganismQuantityType' => new \PHPExiftool\Driver\Tag\XMPDwc\OccurrenceOrganismQuantityType(),
                'OccurrenceOtherCatalogNumbers' => new \PHPExiftool\Driver\Tag\XMPDwc\OccurrenceOtherCatalogNumbers(),
                'OccurrencePreparations' => new \PHPExiftool\Driver\Tag\XMPDwc\OccurrencePreparations(),
                'OccurrencePreviousIdentifications' => new \PHPExiftool\Driver\Tag\XMPDwc\OccurrencePreviousIdentifications(),
                'OccurrenceRecordNumber' => new \PHPExiftool\Driver\Tag\XMPDwc\OccurrenceRecordNumber(),
                'OccurrenceRecordedBy' => new \PHPExiftool\Driver\Tag\XMPDwc\OccurrenceRecordedBy(),
                'OccurrenceReproductiveCondition' => new \PHPExiftool\Driver\Tag\XMPDwc\OccurrenceReproductiveCondition(),
                'OccurrenceSex' => new \PHPExiftool\Driver\Tag\XMPDwc\OccurrenceSex(),
                'Organism' => new \PHPExiftool\Driver\Tag\XMPDwc\Organism(),
                'OrganismAssociatedOccurrences' => new \PHPExiftool\Driver\Tag\XMPDwc\OrganismAssociatedOccurrences(),
                'OrganismAssociatedOrganisms' => new \PHPExiftool\Driver\Tag\XMPDwc\OrganismAssociatedOrganisms(),
                'OrganismID' => new \PHPExiftool\Driver\Tag\XMPDwc\OrganismID(),
                'OrganismName' => new \PHPExiftool\Driver\Tag\XMPDwc\OrganismName(),
                'OrganismRemarks' => new \PHPExiftool\Driver\Tag\XMPDwc\OrganismRemarks(),
                'OrganismScope' => new \PHPExiftool\Driver\Tag\XMPDwc\OrganismScope(),
                'OrganismPreviousIdentifications' => new \PHPExiftool\Driver\Tag\XMPDwc\OrganismPreviousIdentifications(),
                'PreservedSpecimen' => new \PHPExiftool\Driver\Tag\XMPDwc\PreservedSpecimen(),
                'PreservedSpecimenMaterialSampleID' => new \PHPExiftool\Driver\Tag\XMPDwc\PreservedSpecimenMaterialSampleID(),
                'Record' => new \PHPExiftool\Driver\Tag\XMPDwc\Record(),
                'RecordBasisOfRecord' => new \PHPExiftool\Driver\Tag\XMPDwc\RecordBasisOfRecord(),
                'RecordCollectionCode' => new \PHPExiftool\Driver\Tag\XMPDwc\RecordCollectionCode(),
                'RecordCollectionID' => new \PHPExiftool\Driver\Tag\XMPDwc\RecordCollectionID(),
                'RecordDataGeneralizations' => new \PHPExiftool\Driver\Tag\XMPDwc\RecordDataGeneralizations(),
                'RecordDatasetID' => new \PHPExiftool\Driver\Tag\XMPDwc\RecordDatasetID(),
                'RecordDatasetName' => new \PHPExiftool\Driver\Tag\XMPDwc\RecordDatasetName(),
                'RecordDynamicProperties' => new \PHPExiftool\Driver\Tag\XMPDwc\RecordDynamicProperties(),
                'RecordInformationWithheld' => new \PHPExiftool\Driver\Tag\XMPDwc\RecordInformationWithheld(),
                'RecordInstitutionCode' => new \PHPExiftool\Driver\Tag\XMPDwc\RecordInstitutionCode(),
                'RecordInstitutionID' => new \PHPExiftool\Driver\Tag\XMPDwc\RecordInstitutionID(),
                'RecordOwnerInstitutionCode' => new \PHPExiftool\Driver\Tag\XMPDwc\RecordOwnerInstitutionCode(),
                'ResourceRelationship' => new \PHPExiftool\Driver\Tag\XMPDwc\ResourceRelationship(),
                'RelatedResourceID' => new \PHPExiftool\Driver\Tag\XMPDwc\RelatedResourceID(),
                'RelationshipAccordingTo' => new \PHPExiftool\Driver\Tag\XMPDwc\RelationshipAccordingTo(),
                'RelationshipEstablishedDate' => new \PHPExiftool\Driver\Tag\XMPDwc\RelationshipEstablishedDate(),
                'RelationshipOfResource' => new \PHPExiftool\Driver\Tag\XMPDwc\RelationshipOfResource(),
                'RelationshipRemarks' => new \PHPExiftool\Driver\Tag\XMPDwc\RelationshipRemarks(),
                'ResourceID' => new \PHPExiftool\Driver\Tag\XMPDwc\ResourceID(),
                'ResourceRelationshipID' => new \PHPExiftool\Driver\Tag\XMPDwc\ResourceRelationshipID(),
                'Taxon' => new \PHPExiftool\Driver\Tag\XMPDwc\Taxon(),
                'TaxonAcceptedNameUsage' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonAcceptedNameUsage(),
                'TaxonAcceptedNameUsageID' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonAcceptedNameUsageID(),
                'TaxonClass' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonClass(),
                'TaxonFamily' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonFamily(),
                'TaxonGenus' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonGenus(),
                'TaxonHigherClassification' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonHigherClassification(),
                'TaxonInfraspecificEpithet' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonInfraspecificEpithet(),
                'TaxonKingdom' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonKingdom(),
                'TaxonNameAccordingTo' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonNameAccordingTo(),
                'TaxonNameAccordingToID' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonNameAccordingToID(),
                'TaxonNamePublishedIn' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonNamePublishedIn(),
                'TaxonNamePublishedInID' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonNamePublishedInID(),
                'TaxonNamePublishedInYear' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonNamePublishedInYear(),
                'TaxonNomenclaturalCode' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonNomenclaturalCode(),
                'TaxonNomenclaturalStatus' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonNomenclaturalStatus(),
                'TaxonOrder' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonOrder(),
                'TaxonOriginalNameUsage' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonOriginalNameUsage(),
                'TaxonOriginalNameUsageID' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonOriginalNameUsageID(),
                'TaxonParentNameUsage' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonParentNameUsage(),
                'TaxonParentNameUsageID' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonParentNameUsageID(),
                'TaxonPhylum' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonPhylum(),
                'TaxonScientificName' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonScientificName(),
                'TaxonScientificNameAuthorship' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonScientificNameAuthorship(),
                'TaxonScientificNameID' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonScientificNameID(),
                'TaxonSpecificEpithet' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonSpecificEpithet(),
                'TaxonSubgenus' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonSubgenus(),
                'TaxonConceptID' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonConceptID(),
                'TaxonID' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonID(),
                'TaxonRank' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonRank(),
                'TaxonRemarks' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonRemarks(),
                'TaxonTaxonomicStatus' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonTaxonomicStatus(),
                'TaxonVerbatimTaxonRank' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonVerbatimTaxonRank(),
                'TaxonVernacularName' => new \PHPExiftool\Driver\Tag\XMPDwc\TaxonVernacularName(),
                'DCTermsLocation' => new \PHPExiftool\Driver\Tag\XMPDwc\DCTermsLocation(),
                'DCContinent' => new \PHPExiftool\Driver\Tag\XMPDwc\DCContinent(),
                'DCCoordinatePrecision' => new \PHPExiftool\Driver\Tag\XMPDwc\DCCoordinatePrecision(),
                'DCCoordinateUncertaintyInMeters' => new \PHPExiftool\Driver\Tag\XMPDwc\DCCoordinateUncertaintyInMeters(),
                'DCCountry' => new \PHPExiftool\Driver\Tag\XMPDwc\DCCountry(),
                'DCCountryCode' => new \PHPExiftool\Driver\Tag\XMPDwc\DCCountryCode(),
                'DCCounty' => new \PHPExiftool\Driver\Tag\XMPDwc\DCCounty(),
                'DCDecimalLatitude' => new \PHPExiftool\Driver\Tag\XMPDwc\DCDecimalLatitude(),
                'DCDecimalLongitude' => new \PHPExiftool\Driver\Tag\XMPDwc\DCDecimalLongitude(),
                'DCFootprintSRS' => new \PHPExiftool\Driver\Tag\XMPDwc\DCFootprintSRS(),
                'DCFootprintSpatialFit' => new \PHPExiftool\Driver\Tag\XMPDwc\DCFootprintSpatialFit(),
                'DCFootprintWKT' => new \PHPExiftool\Driver\Tag\XMPDwc\DCFootprintWKT(),
                'DCGeodeticDatum' => new \PHPExiftool\Driver\Tag\XMPDwc\DCGeodeticDatum(),
                'DCGeoreferenceProtocol' => new \PHPExiftool\Driver\Tag\XMPDwc\DCGeoreferenceProtocol(),
                'DCGeoreferenceRemarks' => new \PHPExiftool\Driver\Tag\XMPDwc\DCGeoreferenceRemarks(),
                'DCGeoreferenceSources' => new \PHPExiftool\Driver\Tag\XMPDwc\DCGeoreferenceSources(),
                'DCGeoreferenceVerificationStatus' => new \PHPExiftool\Driver\Tag\XMPDwc\DCGeoreferenceVerificationStatus(),
                'DCGeoreferencedBy' => new \PHPExiftool\Driver\Tag\XMPDwc\DCGeoreferencedBy(),
                'DCGeoreferencedDate' => new \PHPExiftool\Driver\Tag\XMPDwc\DCGeoreferencedDate(),
                'DCHigherGeography' => new \PHPExiftool\Driver\Tag\XMPDwc\DCHigherGeography(),
                'DCHigherGeographyID' => new \PHPExiftool\Driver\Tag\XMPDwc\DCHigherGeographyID(),
                'DCIsland' => new \PHPExiftool\Driver\Tag\XMPDwc\DCIsland(),
                'DCIslandGroup' => new \PHPExiftool\Driver\Tag\XMPDwc\DCIslandGroup(),
                'DCLocality' => new \PHPExiftool\Driver\Tag\XMPDwc\DCLocality(),
                'DCLocationAccordingTo' => new \PHPExiftool\Driver\Tag\XMPDwc\DCLocationAccordingTo(),
                'DCLocationID' => new \PHPExiftool\Driver\Tag\XMPDwc\DCLocationID(),
                'DCLocationRemarks' => new \PHPExiftool\Driver\Tag\XMPDwc\DCLocationRemarks(),
                'DCMaximumDepthInMeters' => new \PHPExiftool\Driver\Tag\XMPDwc\DCMaximumDepthInMeters(),
                'DCMaximumDistanceAboveSurfaceInMeters' => new \PHPExiftool\Driver\Tag\XMPDwc\DCMaximumDistanceAboveSurfaceInMeters(),
                'DCMaximumElevationInMeters' => new \PHPExiftool\Driver\Tag\XMPDwc\DCMaximumElevationInMeters(),
                'DCMinimumDepthInMeters' => new \PHPExiftool\Driver\Tag\XMPDwc\DCMinimumDepthInMeters(),
                'DCMinimumDistanceAboveSurfaceInMeters' => new \PHPExiftool\Driver\Tag\XMPDwc\DCMinimumDistanceAboveSurfaceInMeters(),
                'DCMinimumElevationInMeters' => new \PHPExiftool\Driver\Tag\XMPDwc\DCMinimumElevationInMeters(),
                'DCMunicipality' => new \PHPExiftool\Driver\Tag\XMPDwc\DCMunicipality(),
                'DCPointRadiusSpatialFit' => new \PHPExiftool\Driver\Tag\XMPDwc\DCPointRadiusSpatialFit(),
                'DCStateProvince' => new \PHPExiftool\Driver\Tag\XMPDwc\DCStateProvince(),
                'DCVerbatimCoordinateSystem' => new \PHPExiftool\Driver\Tag\XMPDwc\DCVerbatimCoordinateSystem(),
                'DCVerbatimCoordinates' => new \PHPExiftool\Driver\Tag\XMPDwc\DCVerbatimCoordinates(),
                'DCVerbatimDepth' => new \PHPExiftool\Driver\Tag\XMPDwc\DCVerbatimDepth(),
                'DCVerbatimElevation' => new \PHPExiftool\Driver\Tag\XMPDwc\DCVerbatimElevation(),
                'DCVerbatimLatitude' => new \PHPExiftool\Driver\Tag\XMPDwc\DCVerbatimLatitude(),
                'DCVerbatimLocality' => new \PHPExiftool\Driver\Tag\XMPDwc\DCVerbatimLocality(),
                'DCVerbatimLongitude' => new \PHPExiftool\Driver\Tag\XMPDwc\DCVerbatimLongitude(),
                'DCVerbatimSRS' => new \PHPExiftool\Driver\Tag\XMPDwc\DCVerbatimSRS(),
                'DCWaterBody' => new \PHPExiftool\Driver\Tag\XMPDwc\DCWaterBody(),
            );
        });
        $this['DjVu'] = $this->share(function(){
            return array(
                'SubfileType' => new \PHPExiftool\Driver\Tag\DjVu\SubfileType(),
                'ImageWidth' => new \PHPExiftool\Driver\Tag\DjVu\ImageWidth(),
                'ImageHeight' => new \PHPExiftool\Driver\Tag\DjVu\ImageHeight(),
                'DjVuVersion' => new \PHPExiftool\Driver\Tag\DjVu\DjVuVersion(),
                'SpatialResolution' => new \PHPExiftool\Driver\Tag\DjVu\SpatialResolution(),
                'Gamma' => new \PHPExiftool\Driver\Tag\DjVu\Gamma(),
                'Orientation' => new \PHPExiftool\Driver\Tag\DjVu\Orientation(),
                'IncludedFileID' => new \PHPExiftool\Driver\Tag\DjVu\IncludedFileID(),
            );
        });
        $this['DjVu-Meta'] = $this->share(function(){
            return array(
                'Author' => new \PHPExiftool\Driver\Tag\DjVuMeta\Author(),
                'CreateDate' => new \PHPExiftool\Driver\Tag\DjVuMeta\CreateDate(),
                'Creator' => new \PHPExiftool\Driver\Tag\DjVuMeta\Creator(),
                'Keywords' => new \PHPExiftool\Driver\Tag\DjVuMeta\Keywords(),
                'ModifyDate' => new \PHPExiftool\Driver\Tag\DjVuMeta\ModifyDate(),
                'Producer' => new \PHPExiftool\Driver\Tag\DjVuMeta\Producer(),
                'Subject' => new \PHPExiftool\Driver\Tag\DjVuMeta\Subject(),
                'Title' => new \PHPExiftool\Driver\Tag\DjVuMeta\Title(),
                'Trapped' => new \PHPExiftool\Driver\Tag\DjVuMeta\Trapped(),
                'Address' => new \PHPExiftool\Driver\Tag\DjVuMeta\Address(),
                'Annotation' => new \PHPExiftool\Driver\Tag\DjVuMeta\Annotation(),
                'BookTitle' => new \PHPExiftool\Driver\Tag\DjVuMeta\BookTitle(),
                'Chapter' => new \PHPExiftool\Driver\Tag\DjVuMeta\Chapter(),
                'CrossRef' => new \PHPExiftool\Driver\Tag\DjVuMeta\CrossRef(),
                'Edition' => new \PHPExiftool\Driver\Tag\DjVuMeta\Edition(),
                'EPrint' => new \PHPExiftool\Driver\Tag\DjVuMeta\EPrint(),
                'HowPublished' => new \PHPExiftool\Driver\Tag\DjVuMeta\HowPublished(),
                'Institution' => new \PHPExiftool\Driver\Tag\DjVuMeta\Institution(),
                'Journal' => new \PHPExiftool\Driver\Tag\DjVuMeta\Journal(),
                'Key' => new \PHPExiftool\Driver\Tag\DjVuMeta\Key(),
                'Month' => new \PHPExiftool\Driver\Tag\DjVuMeta\Month(),
                'Note' => new \PHPExiftool\Driver\Tag\DjVuMeta\Note(),
                'Number' => new \PHPExiftool\Driver\Tag\DjVuMeta\Number(),
                'Organization' => new \PHPExiftool\Driver\Tag\DjVuMeta\Organization(),
                'Pages' => new \PHPExiftool\Driver\Tag\DjVuMeta\Pages(),
                'Publisher' => new \PHPExiftool\Driver\Tag\DjVuMeta\Publisher(),
                'School' => new \PHPExiftool\Driver\Tag\DjVuMeta\School(),
                'Series' => new \PHPExiftool\Driver\Tag\DjVuMeta\Series(),
                'Type' => new \PHPExiftool\Driver\Tag\DjVuMeta\Type(),
                'URL' => new \PHPExiftool\Driver\Tag\DjVuMeta\URL(),
                'Volume' => new \PHPExiftool\Driver\Tag\DjVuMeta\Volume(),
                'Year' => new \PHPExiftool\Driver\Tag\DjVuMeta\Year(),
            );
        });
        $this['Adobe'] = $this->share(function(){
            return array(
                'Adobe' => new \PHPExiftool\Driver\Tag\Adobe\Adobe(),
                'DCTEncodeVersion' => new \PHPExiftool\Driver\Tag\Adobe\DCTEncodeVersion(),
                'APP14Flags0' => new \PHPExiftool\Driver\Tag\Adobe\APP14Flags0(),
                'APP14Flags1' => new \PHPExiftool\Driver\Tag\Adobe\APP14Flags1(),
                'ColorTransform' => new \PHPExiftool\Driver\Tag\Adobe\ColorTransform(),
            );
        });
 
        $this['EXIF'] = $this->share(function(){
            return array(
                'EXIF' => new \PHPExiftool\Driver\Tag\EXIF\EXIF(),
            );
        });
        $this['ExifTool'] = $this->share(function(){
            return array(
                'Error' => new \PHPExiftool\Driver\Tag\ExifTool\Error(),
                'ExifToolVersion' => new \PHPExiftool\Driver\Tag\ExifTool\ExifToolVersion(),
                'FileSequence' => new \PHPExiftool\Driver\Tag\ExifTool\FileSequence(),
                'NewGUID' => new \PHPExiftool\Driver\Tag\ExifTool\NewGUID(),
                'Now' => new \PHPExiftool\Driver\Tag\ExifTool\Now(),
                'ProcessingTime' => new \PHPExiftool\Driver\Tag\ExifTool\ProcessingTime(),
                'Warning' => new \PHPExiftool\Driver\Tag\ExifTool\Warning(),
            );
        });
        
        $this['IPTC'] = $this->share(function(){
            return array(
                'IPTC' => new \PHPExiftool\Driver\Tag\IPTC\IPTC(),
                'ObjectTypeReference' => new \PHPExiftool\Driver\Tag\IPTC\ObjectTypeReference(),
                'ObjectName' => new \PHPExiftool\Driver\Tag\IPTC\ObjectName(),
                'EditStatus' => new \PHPExiftool\Driver\Tag\IPTC\EditStatus(),              
                'SubjectReference' => new \PHPExiftool\Driver\Tag\IPTC\SubjectReference(),
                'FixtureIdentifier' => new \PHPExiftool\Driver\Tag\IPTC\FixtureIdentifier(),
                'Keywords' => new \PHPExiftool\Driver\Tag\IPTC\Keywords(),
                'ExpirationDate' => new \PHPExiftool\Driver\Tag\IPTC\ExpirationDate(),
                'ExpirationTime' => new \PHPExiftool\Driver\Tag\IPTC\ExpirationTime(),
                'DateCreated' => new \PHPExiftool\Driver\Tag\IPTC\DateCreated(),
                'TimeCreated' => new \PHPExiftool\Driver\Tag\IPTC\TimeCreated(),
                'DigitalCreationDate' => new \PHPExiftool\Driver\Tag\IPTC\DigitalCreationDate(),
                'DigitalCreationTime' => new \PHPExiftool\Driver\Tag\IPTC\DigitalCreationTime(),
                'OriginatingProgram' => new \PHPExiftool\Driver\Tag\IPTC\OriginatingProgram(),
                'ProgramVersion' => new \PHPExiftool\Driver\Tag\IPTC\ProgramVersion(),
                'ObjectCycle' => new \PHPExiftool\Driver\Tag\IPTC\ObjectCycle(),
                'By-line' => new \PHPExiftool\Driver\Tag\IPTC\ByLine(),
                'By-lineTitle' => new \PHPExiftool\Driver\Tag\IPTC\ByLineTitle(),
                'City' => new \PHPExiftool\Driver\Tag\IPTC\City(),
                'Sub-location' => new \PHPExiftool\Driver\Tag\IPTC\SubLocation(),
                'Headline' => new \PHPExiftool\Driver\Tag\IPTC\Headline(),
                'Credit' => new \PHPExiftool\Driver\Tag\IPTC\Credit(),
                'Source' => new \PHPExiftool\Driver\Tag\IPTC\Source(),
                'CopyrightNotice' => new \PHPExiftool\Driver\Tag\IPTC\CopyrightNotice(),
                'Contact' => new \PHPExiftool\Driver\Tag\IPTC\Contact(),
                'Caption-Abstract' => new \PHPExiftool\Driver\Tag\IPTC\CaptionAbstract(),
                'LocalCaption' => new \PHPExiftool\Driver\Tag\IPTC\LocalCaption(),
                'Writer-Editor' => new \PHPExiftool\Driver\Tag\IPTC\WriterEditor(),
                'ImageType' => new \PHPExiftool\Driver\Tag\IPTC\ImageType(),
                'ImageOrientation' => new \PHPExiftool\Driver\Tag\IPTC\ImageOrientation(),
                'JobID' => new \PHPExiftool\Driver\Tag\IPTC\JobID(),
                'MasterDocumentID' => new \PHPExiftool\Driver\Tag\IPTC\MasterDocumentID(),
                'OwnerID' => new \PHPExiftool\Driver\Tag\IPTC\OwnerID(),
                'ObjectPreviewFileFormat' => new \PHPExiftool\Driver\Tag\IPTC\ObjectPreviewFileFormat(),
                'ObjectPreviewFileVersion' => new \PHPExiftool\Driver\Tag\IPTC\ObjectPreviewFileVersion(),
                'ObjectPreviewData' => new \PHPExiftool\Driver\Tag\IPTC\ObjectPreviewData(),
                'ExifCameraInfo' => new \PHPExiftool\Driver\Tag\IPTC\ExifCameraInfo(),
                'Destination' => new \PHPExiftool\Driver\Tag\IPTC\Destination(),
                'FileFormat' => new \PHPExiftool\Driver\Tag\IPTC\FileFormat(),
                'FileVersion' => new \PHPExiftool\Driver\Tag\IPTC\FileVersion(),
                'ProductID' => new \PHPExiftool\Driver\Tag\IPTC\ProductID(),
                'DateSent' => new \PHPExiftool\Driver\Tag\IPTC\DateSent(),
                'TimeSent' => new \PHPExiftool\Driver\Tag\IPTC\TimeSent(),
                'CodedCharacterSet' => new \PHPExiftool\Driver\Tag\IPTC\CodedCharacterSet(),
                'IPTCPictureNumber' => new \PHPExiftool\Driver\Tag\IPTC\IPTCPictureNumber(),
                'IPTCImageWidth' => new \PHPExiftool\Driver\Tag\IPTC\IPTCImageWidth(),
                'IPTCImageHeight' => new \PHPExiftool\Driver\Tag\IPTC\IPTCImageHeight(),
                'IPTCPixelWidth' => new \PHPExiftool\Driver\Tag\IPTC\IPTCPixelWidth(),
                'IPTCPixelHeight' => new \PHPExiftool\Driver\Tag\IPTC\IPTCPixelHeight(),  
                'InterchangeColorSpace' => new \PHPExiftool\Driver\Tag\IPTC\InterchangeColorSpace(),           
                'ICC_Profile' => new \PHPExiftool\Driver\Tag\IPTC\ICCProfile(),
                'LookupTable' => new \PHPExiftool\Driver\Tag\IPTC\LookupTable(),
                'IPTCBitsPerSample' => new \PHPExiftool\Driver\Tag\IPTC\IPTCBitsPerSample(),
                'IPTCImageRotation' => new \PHPExiftool\Driver\Tag\IPTC\IPTCImageRotation(),
                'SubFile' => new \PHPExiftool\Driver\Tag\IPTC\SubFile(),
                'ObjectSizeAnnounced' => new \PHPExiftool\Driver\Tag\IPTC\ObjectSizeAnnounced(),
            );
        });
        $this['XMP'] = $this->share(function(){
            return array(
                'XMP' => new \PHPExiftool\Driver\Tag\XMP\XMP(),
            );
        });
      
        $this['FotoStation'] = $this->share(function(){
            return array(
                'ThumbnailImage' => new \PHPExiftool\Driver\Tag\FotoStation\ThumbnailImage(),
                'PreviewImage' => new \PHPExiftool\Driver\Tag\FotoStation\PreviewImage(),
                'OriginalImageWidth' => new \PHPExiftool\Driver\Tag\FotoStation\OriginalImageWidth(),
                'OriginalImageHeight' => new \PHPExiftool\Driver\Tag\FotoStation\OriginalImageHeight(),
                'ColorPlanes' => new \PHPExiftool\Driver\Tag\FotoStation\ColorPlanes(),
                'XYResolution' => new \PHPExiftool\Driver\Tag\FotoStation\XYResolution(),
                'Rotation' => new \PHPExiftool\Driver\Tag\FotoStation\Rotation(),
                'CropLeft' => new \PHPExiftool\Driver\Tag\FotoStation\CropLeft(),
                'CropTop' => new \PHPExiftool\Driver\Tag\FotoStation\CropTop(),
                'CropRight' => new \PHPExiftool\Driver\Tag\FotoStation\CropRight(),
                'CropBottom' => new \PHPExiftool\Driver\Tag\FotoStation\CropBottom(),
                'CropRotation' => new \PHPExiftool\Driver\Tag\FotoStation\CropRotation(),
            );
        });
      
       
        $this['AdobeCM'] = $this->share(function(){
            return array(
                'AdobeCMType' => new \PHPExiftool\Driver\Tag\AdobeCM\AdobeCMType(),
            );
        });

        $this['JPEG'] = $this->share(function(){
            return array(
                'PreviewImage' => new \PHPExiftool\Driver\Tag\JPEG\PreviewImage(),
                'Comment' => new \PHPExiftool\Driver\Tag\JPEG\Comment(),
                'Adobe' => new \PHPExiftool\Driver\Tag\JPEG\Adobe(),
                'DefineQuantizationTable' => new \PHPExiftool\Driver\Tag\JPEG\DefineQuantizationTable(),
                'EmbeddedVideo' => new \PHPExiftool\Driver\Tag\JPEG\EmbeddedVideo(),
            );
        });
 
       
        $this['MetaIFD'] = $this->share(function(){
            return array(
                'FilmProductCode' => new \PHPExiftool\Driver\Tag\MetaIFD\FilmProductCode(),
                'ImageSourceEK' => new \PHPExiftool\Driver\Tag\MetaIFD\ImageSourceEK(),
                'CaptureConditionsPAR' => new \PHPExiftool\Driver\Tag\MetaIFD\CaptureConditionsPAR(),
                'CameraOwner' => new \PHPExiftool\Driver\Tag\MetaIFD\CameraOwner(),
                'SerialNumber' => new \PHPExiftool\Driver\Tag\MetaIFD\SerialNumber(),
                'UserSelectGroupTitle' => new \PHPExiftool\Driver\Tag\MetaIFD\UserSelectGroupTitle(),
                'DealerIDNumber' => new \PHPExiftool\Driver\Tag\MetaIFD\DealerIDNumber(),
                'CaptureDeviceFID' => new \PHPExiftool\Driver\Tag\MetaIFD\CaptureDeviceFID(),
                'EnvelopeNumber' => new \PHPExiftool\Driver\Tag\MetaIFD\EnvelopeNumber(),
                'FrameNumber' => new \PHPExiftool\Driver\Tag\MetaIFD\FrameNumber(),
                'FilmCategory' => new \PHPExiftool\Driver\Tag\MetaIFD\FilmCategory(),
                'FilmGencode' => new \PHPExiftool\Driver\Tag\MetaIFD\FilmGencode(),
                'ModelAndVersion' => new \PHPExiftool\Driver\Tag\MetaIFD\ModelAndVersion(),
                'FilmSize' => new \PHPExiftool\Driver\Tag\MetaIFD\FilmSize(),
                'SBA_RGBShifts' => new \PHPExiftool\Driver\Tag\MetaIFD\SBARGBShifts(),
                'SBAInputImageColorspace' => new \PHPExiftool\Driver\Tag\MetaIFD\SBAInputImageColorspace(),
                'SBAInputImageBitDepth' => new \PHPExiftool\Driver\Tag\MetaIFD\SBAInputImageBitDepth(),
                'SBAExposureRecord' => new \PHPExiftool\Driver\Tag\MetaIFD\SBAExposureRecord(),
                'UserAdjSBA_RGBShifts' => new \PHPExiftool\Driver\Tag\MetaIFD\UserAdjSBARGBShifts(),
                'ImageRotationStatus' => new \PHPExiftool\Driver\Tag\MetaIFD\ImageRotationStatus(),
                'RollGuidElements' => new \PHPExiftool\Driver\Tag\MetaIFD\RollGuidElements(),
                'MetadataNumber' => new \PHPExiftool\Driver\Tag\MetaIFD\MetadataNumber(),
                'EditTagArray' => new \PHPExiftool\Driver\Tag\MetaIFD\EditTagArray(),
                'Magnification' => new \PHPExiftool\Driver\Tag\MetaIFD\Magnification(),
                'NativeXResolution' => new \PHPExiftool\Driver\Tag\MetaIFD\NativeXResolution(),
                'NativeYResolution' => new \PHPExiftool\Driver\Tag\MetaIFD\NativeYResolution(),
                'NativeResolutionUnit' => new \PHPExiftool\Driver\Tag\MetaIFD\NativeResolutionUnit(),
                'SourceImageDirectory' => new \PHPExiftool\Driver\Tag\MetaIFD\SourceImageDirectory(),
                'SourceImageFileName' => new \PHPExiftool\Driver\Tag\MetaIFD\SourceImageFileName(),
                'SourceImageVolumeName' => new \PHPExiftool\Driver\Tag\MetaIFD\SourceImageVolumeName(),
                'PrintQuality' => new \PHPExiftool\Driver\Tag\MetaIFD\PrintQuality(),
                'ImagePrintStatus' => new \PHPExiftool\Driver\Tag\MetaIFD\ImagePrintStatus(),
            );
        });
        $this['MIE-Image'] = $this->share(function(){
            return array(
                'FullSizeImageType' => new \PHPExiftool\Driver\Tag\MIEImage\FullSizeImageType(),
                'FullSizeImageName' => new \PHPExiftool\Driver\Tag\MIEImage\FullSizeImageName(),
                'BitDepth' => new \PHPExiftool\Driver\Tag\MIEImage\BitDepth(),
                'ColorSpace' => new \PHPExiftool\Driver\Tag\MIEImage\ColorSpace(),
                'ComponentsConfiguration' => new \PHPExiftool\Driver\Tag\MIEImage\ComponentsConfiguration(),
                'CompressionRatio' => new \PHPExiftool\Driver\Tag\MIEImage\CompressionRatio(),
                'ImageSize' => new \PHPExiftool\Driver\Tag\MIEImage\ImageSize(),
                'Resolution' => new \PHPExiftool\Driver\Tag\MIEImage\Resolution(),
                'FullSizeImage' => new \PHPExiftool\Driver\Tag\MIEImage\FullSizeImage(),
            );
        });
        $this['MPImage'] = $this->share(function(){
            return array(
                'MPImageFlags' => new \PHPExiftool\Driver\Tag\MPImage\MPImageFlags(),
                'MPImageFormat' => new \PHPExiftool\Driver\Tag\MPImage\MPImageFormat(),
                'MPImageType' => new \PHPExiftool\Driver\Tag\MPImage\MPImageType(),
                'MPImageLength' => new \PHPExiftool\Driver\Tag\MPImage\MPImageLength(),
                'MPImageStart' => new \PHPExiftool\Driver\Tag\MPImage\MPImageStart(),
                'DependentImage1EntryNumber' => new \PHPExiftool\Driver\Tag\MPImage\DependentImage1EntryNumber(),
                'DependentImage2EntryNumber' => new \PHPExiftool\Driver\Tag\MPImage\DependentImage2EntryNumber(),
            );
        });
        $this['MXF'] = $this->share(function(){
            return array(
                'MXFVersion' => new \PHPExiftool\Driver\Tag\MXF\MXFVersion(),
                'FooterPosition' => new \PHPExiftool\Driver\Tag\MXF\FooterPosition(),
                'HeaderSize' => new \PHPExiftool\Driver\Tag\MXF\HeaderSize(),
                'OrganizationID' => new \PHPExiftool\Driver\Tag\MXF\OrganizationID(),
                'UPID' => new \PHPExiftool\Driver\Tag\MXF\UPID(),
                'UPN' => new \PHPExiftool\Driver\Tag\MXF\UPN(),
                'IBTN' => new \PHPExiftool\Driver\Tag\MXF\IBTN(),
                'ISAN' => new \PHPExiftool\Driver\Tag\MXF\ISAN(),
                'ISBN' => new \PHPExiftool\Driver\Tag\MXF\ISBN(),
                'ISSN' => new \PHPExiftool\Driver\Tag\MXF\ISSN(),
                'ISWC' => new \PHPExiftool\Driver\Tag\MXF\ISWC(),
                'ISMN' => new \PHPExiftool\Driver\Tag\MXF\ISMN(),
                'ISCI' => new \PHPExiftool\Driver\Tag\MXF\ISCI(),
                'ISRC' => new \PHPExiftool\Driver\Tag\MXF\ISRC(),
                'ISRN' => new \PHPExiftool\Driver\Tag\MXF\ISRN(),
                'ISBD' => new \PHPExiftool\Driver\Tag\MXF\ISBD(),
                'ISTC' => new \PHPExiftool\Driver\Tag\MXF\ISTC(),
                'SICI' => new \PHPExiftool\Driver\Tag\MXF\SICI(),
                'BICI' => new \PHPExiftool\Driver\Tag\MXF\BICI(),
                'AICI' => new \PHPExiftool\Driver\Tag\MXF\AICI(),
                'PII' => new \PHPExiftool\Driver\Tag\MXF\PII(),
                'DOI' => new \PHPExiftool\Driver\Tag\MXF\DOI(),
                'InstanceUID' => new \PHPExiftool\Driver\Tag\MXF\InstanceUID(),
                'PackageID' => new \PHPExiftool\Driver\Tag\MXF\PackageID(),
                'DeviceDesignation' => new \PHPExiftool\Driver\Tag\MXF\DeviceDesignation(),
                'DeviceModel' => new \PHPExiftool\Driver\Tag\MXF\DeviceModel(),
                'DeviceSerialNumber' => new \PHPExiftool\Driver\Tag\MXF\DeviceSerialNumber(),
                'URL' => new \PHPExiftool\Driver\Tag\MXF\URL(),
                'PURL' => new \PHPExiftool\Driver\Tag\MXF\PURL(),
                'URN' => new \PHPExiftool\Driver\Tag\MXF\URN(),
                'TransmissionID' => new \PHPExiftool\Driver\Tag\MXF\TransmissionID(),
                'ArchiveID' => new \PHPExiftool\Driver\Tag\MXF\ArchiveID(),
                'ItemID' => new \PHPExiftool\Driver\Tag\MXF\ItemID(),
                'AccountingReferenceNumber' => new \PHPExiftool\Driver\Tag\MXF\AccountingReferenceNumber(),
                'TrafficID' => new \PHPExiftool\Driver\Tag\MXF\TrafficID(),
                'ReelOrRollNumber' => new \PHPExiftool\Driver\Tag\MXF\ReelOrRollNumber(),
                'LocalTapeNumber' => new \PHPExiftool\Driver\Tag\MXF\LocalTapeNumber(),
                'LUID' => new \PHPExiftool\Driver\Tag\MXF\LUID(),
                'PackageName' => new \PHPExiftool\Driver\Tag\MXF\PackageName(),
                'LocalFilePath' => new \PHPExiftool\Driver\Tag\MXF\LocalFilePath(),
                'EdgeCode' => new \PHPExiftool\Driver\Tag\MXF\EdgeCode(),
                'FrameCode' => new \PHPExiftool\Driver\Tag\MXF\FrameCode(),
                'KeyCode' => new \PHPExiftool\Driver\Tag\MXF\KeyCode(),
                'InkNumber' => new \PHPExiftool\Driver\Tag\MXF\InkNumber(),
                'KeyText' => new \PHPExiftool\Driver\Tag\MXF\KeyText(),
                'KeyFrame' => new \PHPExiftool\Driver\Tag\MXF\KeyFrame(),
                'KeySound' => new \PHPExiftool\Driver\Tag\MXF\KeySound(),
                'KeyDataOrProgram' => new \PHPExiftool\Driver\Tag\MXF\KeyDataOrProgram(),
                'TitleKind' => new \PHPExiftool\Driver\Tag\MXF\TitleKind(),
                'MainTitle' => new \PHPExiftool\Driver\Tag\MXF\MainTitle(),
                'SecondaryTitle' => new \PHPExiftool\Driver\Tag\MXF\SecondaryTitle(),
                'SeriesNumber' => new \PHPExiftool\Driver\Tag\MXF\SeriesNumber(),
                'EpisodeNumber' => new \PHPExiftool\Driver\Tag\MXF\EpisodeNumber(),
                'SceneNumber' => new \PHPExiftool\Driver\Tag\MXF\SceneNumber(),
                'TakeNumber' => new \PHPExiftool\Driver\Tag\MXF\TakeNumber(),
                'CISACLegalEntityID' => new \PHPExiftool\Driver\Tag\MXF\CISACLegalEntityID(),
                'AGICOAID' => new \PHPExiftool\Driver\Tag\MXF\AGICOAID(),
                'SourceOrganization' => new \PHPExiftool\Driver\Tag\MXF\SourceOrganization(),
                'SupplyContractNumber' => new \PHPExiftool\Driver\Tag\MXF\SupplyContractNumber(),
                'OriginalProducerName' => new \PHPExiftool\Driver\Tag\MXF\OriginalProducerName(),
                'TotalEpisodeCount' => new \PHPExiftool\Driver\Tag\MXF\TotalEpisodeCount(),
                'CopyrightStatus' => new \PHPExiftool\Driver\Tag\MXF\CopyrightStatus(),
                'CopyrightOwnerName' => new \PHPExiftool\Driver\Tag\MXF\CopyrightOwnerName(),
                'IntellectualPropertyDescription' => new \PHPExiftool\Driver\Tag\MXF\IntellectualPropertyDescription(),
                'IntellectualPropertyRights' => new \PHPExiftool\Driver\Tag\MXF\IntellectualPropertyRights(),
                'Rightsholder' => new \PHPExiftool\Driver\Tag\MXF\Rightsholder(),
                'RightsManagementAuthority' => new \PHPExiftool\Driver\Tag\MXF\RightsManagementAuthority(),
                'InterestedPartyName' => new \PHPExiftool\Driver\Tag\MXF\InterestedPartyName(),
                'MaximumUseCount' => new \PHPExiftool\Driver\Tag\MXF\MaximumUseCount(),
                'LicenseOptionsDescription' => new \PHPExiftool\Driver\Tag\MXF\LicenseOptionsDescription(),
                'CurrencyCode' => new \PHPExiftool\Driver\Tag\MXF\CurrencyCode(),
                'RoyaltyPaymentInformation' => new \PHPExiftool\Driver\Tag\MXF\RoyaltyPaymentInformation(),
                'RoyaltyIncomeInformation' => new \PHPExiftool\Driver\Tag\MXF\RoyaltyIncomeInformation(),
                'RestrictionsonUse' => new \PHPExiftool\Driver\Tag\MXF\RestrictionsonUse(),
                'ExCCIData' => new \PHPExiftool\Driver\Tag\MXF\ExCCIData(),
                'UserName' => new \PHPExiftool\Driver\Tag\MXF\UserName(),
                'Password' => new \PHPExiftool\Driver\Tag\MXF\Password(),
                'ScramblingKeyKind' => new \PHPExiftool\Driver\Tag\MXF\ScramblingKeyKind(),
                'ScramblingKeyValue' => new \PHPExiftool\Driver\Tag\MXF\ScramblingKeyValue(),
                'BroadcastOrganizationName' => new \PHPExiftool\Driver\Tag\MXF\BroadcastOrganizationName(),
                'BroadcastChannel' => new \PHPExiftool\Driver\Tag\MXF\BroadcastChannel(),
                'BroadcastMediumKind' => new \PHPExiftool\Driver\Tag\MXF\BroadcastMediumKind(),
                'BroadcastRegion' => new \PHPExiftool\Driver\Tag\MXF\BroadcastRegion(),
                'FirstBroadcastFlag' => new \PHPExiftool\Driver\Tag\MXF\FirstBroadcastFlag(),
                'CurrentRepeatNumber' => new \PHPExiftool\Driver\Tag\MXF\CurrentRepeatNumber(),
                'PreviousRepeatNumber' => new \PHPExiftool\Driver\Tag\MXF\PreviousRepeatNumber(),
                'AudienceRating' => new \PHPExiftool\Driver\Tag\MXF\AudienceRating(),
                'AudienceReach' => new \PHPExiftool\Driver\Tag\MXF\AudienceReach(),
                'NatureOfPersonality' => new \PHPExiftool\Driver\Tag\MXF\NatureOfPersonality(),
                'ContributionStatus' => new \PHPExiftool\Driver\Tag\MXF\ContributionStatus(),
                'SupportOrAdministrationStatus' => new \PHPExiftool\Driver\Tag\MXF\SupportOrAdministrationStatus(),
                'OrganizationKind' => new \PHPExiftool\Driver\Tag\MXF\OrganizationKind(),
                'ProductionOrganizationRole' => new \PHPExiftool\Driver\Tag\MXF\ProductionOrganizationRole(),
                'SupportOrganizationRole' => new \PHPExiftool\Driver\Tag\MXF\SupportOrganizationRole(),
                'JobFunctionName' => new \PHPExiftool\Driver\Tag\MXF\JobFunctionName(),
                'RoleName' => new \PHPExiftool\Driver\Tag\MXF\RoleName(),
                'ContactKind' => new \PHPExiftool\Driver\Tag\MXF\ContactKind(),
                'ContactDepartmentName' => new \PHPExiftool\Driver\Tag\MXF\ContactDepartmentName(),
                'FamilyName' => new \PHPExiftool\Driver\Tag\MXF\FamilyName(),
                'FirstGivenName' => new \PHPExiftool\Driver\Tag\MXF\FirstGivenName(),
                'SecondGivenName' => new \PHPExiftool\Driver\Tag\MXF\SecondGivenName(),
                'ThirdGivenName' => new \PHPExiftool\Driver\Tag\MXF\ThirdGivenName(),
                'MainName' => new \PHPExiftool\Driver\Tag\MXF\MainName(),
                'SupplementaryName' => new \PHPExiftool\Driver\Tag\MXF\SupplementaryName(),
                'OrganizationMainName' => new \PHPExiftool\Driver\Tag\MXF\OrganizationMainName(),
                'SupplementaryOrganizationName' => new \PHPExiftool\Driver\Tag\MXF\SupplementaryOrganizationName(),
                'ISO3166CountryCode' => new \PHPExiftool\Driver\Tag\MXF\ISO3166CountryCode(),
                'ISO639-1LanguageCode' => new \PHPExiftool\Driver\Tag\MXF\ISO6391LanguageCode(),
                'OperatingSystemInterpretations' => new \PHPExiftool\Driver\Tag\MXF\OperatingSystemInterpretations(),
                'ByteOrder' => new \PHPExiftool\Driver\Tag\MXF\ByteOrder(),
                'EssenceIsIdentified' => new \PHPExiftool\Driver\Tag\MXF\EssenceIsIdentified(),
                'LengthSystemName' => new \PHPExiftool\Driver\Tag\MXF\LengthSystemName(),
                'LengthUnitKind' => new \PHPExiftool\Driver\Tag\MXF\LengthUnitKind(),
                'AngularUnitKind' => new \PHPExiftool\Driver\Tag\MXF\AngularUnitKind(),
                'TimeSystemOffset' => new \PHPExiftool\Driver\Tag\MXF\TimeSystemOffset(),
                'TimeUnitKind' => new \PHPExiftool\Driver\Tag\MXF\TimeUnitKind(),
                'ContentCodingSystem' => new \PHPExiftool\Driver\Tag\MXF\ContentCodingSystem(),
                'ProgramKind' => new \PHPExiftool\Driver\Tag\MXF\ProgramKind(),
                'Genre' => new \PHPExiftool\Driver\Tag\MXF\Genre(),
                'TargetAudience' => new \PHPExiftool\Driver\Tag\MXF\TargetAudience(),
                'CatalogDataStatus' => new \PHPExiftool\Driver\Tag\MXF\CatalogDataStatus(),
                'ThesaurusName' => new \PHPExiftool\Driver\Tag\MXF\ThesaurusName(),
                'Theme' => new \PHPExiftool\Driver\Tag\MXF\Theme(),
                'ContentClassification' => new \PHPExiftool\Driver\Tag\MXF\ContentClassification(),
                'Keywords' => new \PHPExiftool\Driver\Tag\MXF\Keywords(),
                'KeyFrames' => new \PHPExiftool\Driver\Tag\MXF\KeyFrames(),
                'KeySounds' => new \PHPExiftool\Driver\Tag\MXF\KeySounds(),
                'KeyData' => new \PHPExiftool\Driver\Tag\MXF\KeyData(),
                'Abstract' => new \PHPExiftool\Driver\Tag\MXF\Abstract0(),
                'Purpose' => new \PHPExiftool\Driver\Tag\MXF\Purpose(),
                'Description' => new \PHPExiftool\Driver\Tag\MXF\Description(),
                'ColorDescriptor' => new \PHPExiftool\Driver\Tag\MXF\ColorDescriptor(),
                'FormatDescriptor' => new \PHPExiftool\Driver\Tag\MXF\FormatDescriptor(),
                'StratumKind' => new \PHPExiftool\Driver\Tag\MXF\StratumKind(),
                'IndividualAwardName' => new \PHPExiftool\Driver\Tag\MXF\IndividualAwardName(),
                'ProgramAwardName' => new \PHPExiftool\Driver\Tag\MXF\ProgramAwardName(),
                'AssetValue' => new \PHPExiftool\Driver\Tag\MXF\AssetValue(),
                'ContentValue' => new \PHPExiftool\Driver\Tag\MXF\ContentValue(),
                'CulturalValue' => new \PHPExiftool\Driver\Tag\MXF\CulturalValue(),
                'AestheticValue' => new \PHPExiftool\Driver\Tag\MXF\AestheticValue(),
                'HistoricalValue' => new \PHPExiftool\Driver\Tag\MXF\HistoricalValue(),
                'TechnicalValue' => new \PHPExiftool\Driver\Tag\MXF\TechnicalValue(),
                'OtherValues' => new \PHPExiftool\Driver\Tag\MXF\OtherValues(),
                'CatalogingSystemName' => new \PHPExiftool\Driver\Tag\MXF\CatalogingSystemName(),
                'ComputedKeywords' => new \PHPExiftool\Driver\Tag\MXF\ComputedKeywords(),
                'ComputedKeyFrames' => new \PHPExiftool\Driver\Tag\MXF\ComputedKeyFrames(),
                'ComputedKeySounds' => new \PHPExiftool\Driver\Tag\MXF\ComputedKeySounds(),
                'ComputedKeyData' => new \PHPExiftool\Driver\Tag\MXF\ComputedKeyData(),
                'ComputedStratumKind' => new \PHPExiftool\Driver\Tag\MXF\ComputedStratumKind(),
                'PresentationAspectRatio' => new \PHPExiftool\Driver\Tag\MXF\PresentationAspectRatio(),
                'CaptureAspectRatio' => new \PHPExiftool\Driver\Tag\MXF\CaptureAspectRatio(),
                'CaptureGammaEquation' => new \PHPExiftool\Driver\Tag\MXF\CaptureGammaEquation(),
                'LumaEquation' => new \PHPExiftool\Driver\Tag\MXF\LumaEquation(),
                'ColorimetryCode' => new \PHPExiftool\Driver\Tag\MXF\ColorimetryCode(),
                'SignalFormCode' => new \PHPExiftool\Driver\Tag\MXF\SignalFormCode(),
                'ColorFieldCode' => new \PHPExiftool\Driver\Tag\MXF\ColorFieldCode(),
                'FieldRate' => new \PHPExiftool\Driver\Tag\MXF\FieldRate(),
                'FrameRate' => new \PHPExiftool\Driver\Tag\MXF\FrameRate(),
                'FrameLayout' => new \PHPExiftool\Driver\Tag\MXF\FrameLayout(),
                'SamplingStructureCode' => new \PHPExiftool\Driver\Tag\MXF\SamplingStructureCode(),
                'TotalLinesperFrame' => new \PHPExiftool\Driver\Tag\MXF\TotalLinesperFrame(),
                'ActiveLinesperFrame' => new \PHPExiftool\Driver\Tag\MXF\ActiveLinesperFrame(),
                'LeadingLines' => new \PHPExiftool\Driver\Tag\MXF\LeadingLines(),
                'TrailingLines' => new \PHPExiftool\Driver\Tag\MXF\TrailingLines(),
                'AnalogVideoSystemName' => new \PHPExiftool\Driver\Tag\MXF\AnalogVideoSystemName(),
                'LuminanceSampleRate' => new \PHPExiftool\Driver\Tag\MXF\LuminanceSampleRate(),
                'ActiveSamplesperLine' => new \PHPExiftool\Driver\Tag\MXF\ActiveSamplesperLine(),
                'TotalSamplesperLine' => new \PHPExiftool\Driver\Tag\MXF\TotalSamplesperLine(),
                'SamplingHierarchyCode' => new \PHPExiftool\Driver\Tag\MXF\SamplingHierarchyCode(),
                'HorizontalSubsampling' => new \PHPExiftool\Driver\Tag\MXF\HorizontalSubsampling(),
                'ColorSiting' => new \PHPExiftool\Driver\Tag\MXF\ColorSiting(),
                'SampledHeight' => new \PHPExiftool\Driver\Tag\MXF\SampledHeight(),
                'SampledWidth' => new \PHPExiftool\Driver\Tag\MXF\SampledWidth(),
                'SampledXOffset' => new \PHPExiftool\Driver\Tag\MXF\SampledXOffset(),
                'SampledYOffset' => new \PHPExiftool\Driver\Tag\MXF\SampledYOffset(),
                'DisplayHeight' => new \PHPExiftool\Driver\Tag\MXF\DisplayHeight(),
                'DisplayWidth' => new \PHPExiftool\Driver\Tag\MXF\DisplayWidth(),
                'DisplayXOffset' => new \PHPExiftool\Driver\Tag\MXF\DisplayXOffset(),
                'DisplayYOffset' => new \PHPExiftool\Driver\Tag\MXF\DisplayYOffset(),
                'FilteringCode' => new \PHPExiftool\Driver\Tag\MXF\FilteringCode(),
                'ImageHeight' => new \PHPExiftool\Driver\Tag\MXF\ImageHeight(),
                'ImageWidth' => new \PHPExiftool\Driver\Tag\MXF\ImageWidth(),
                'BitsPerPixel' => new \PHPExiftool\Driver\Tag\MXF\BitsPerPixel(),
                'RoundingMethodCode' => new \PHPExiftool\Driver\Tag\MXF\RoundingMethodCode(),
                'BlackReferenceLevel' => new \PHPExiftool\Driver\Tag\MXF\BlackReferenceLevel(),
                'WhiteReferenceLevel' => new \PHPExiftool\Driver\Tag\MXF\WhiteReferenceLevel(),
                'FieldFrameTypeCode' => new \PHPExiftool\Driver\Tag\MXF\FieldFrameTypeCode(),
                'PulldownSequence' => new \PHPExiftool\Driver\Tag\MXF\PulldownSequence(),
                'PulldownFieldDominance' => new \PHPExiftool\Driver\Tag\MXF\PulldownFieldDominance(),
                'VideoAndFilmFrameRelationship' => new \PHPExiftool\Driver\Tag\MXF\VideoAndFilmFrameRelationship(),
                'CaptureFilmFrameRate' => new \PHPExiftool\Driver\Tag\MXF\CaptureFilmFrameRate(),
                'TransferFilmFrameRate' => new \PHPExiftool\Driver\Tag\MXF\TransferFilmFrameRate(),
                'VideoTestParameter' => new \PHPExiftool\Driver\Tag\MXF\VideoTestParameter(),
                'VideoTestResult' => new \PHPExiftool\Driver\Tag\MXF\VideoTestResult(),
                'FilmTestParameter' => new \PHPExiftool\Driver\Tag\MXF\FilmTestParameter(),
                'FilmTestResult' => new \PHPExiftool\Driver\Tag\MXF\FilmTestResult(),
                'ElectrospatialFormulation' => new \PHPExiftool\Driver\Tag\MXF\ElectrospatialFormulation(),
                'FilteringApplied' => new \PHPExiftool\Driver\Tag\MXF\FilteringApplied(),
                'AudioReferenceLevel' => new \PHPExiftool\Driver\Tag\MXF\AudioReferenceLevel(),
                'AudioMonoChannelCount' => new \PHPExiftool\Driver\Tag\MXF\AudioMonoChannelCount(),
                'AudioStereoChannelCount' => new \PHPExiftool\Driver\Tag\MXF\AudioStereoChannelCount(),
                'AnalogSystem' => new \PHPExiftool\Driver\Tag\MXF\AnalogSystem(),
                'AudioSampleRate' => new \PHPExiftool\Driver\Tag\MXF\AudioSampleRate(),
                'BitsPerSample' => new \PHPExiftool\Driver\Tag\MXF\BitsPerSample(),
                'RoundingLaw' => new \PHPExiftool\Driver\Tag\MXF\RoundingLaw(),
                'Dither' => new \PHPExiftool\Driver\Tag\MXF\Dither(),
                'OpticalTrack' => new \PHPExiftool\Driver\Tag\MXF\OpticalTrack(),
                'MagneticTrack' => new \PHPExiftool\Driver\Tag\MXF\MagneticTrack(),
                'Signal-to-NoiseRatio' => new \PHPExiftool\Driver\Tag\MXF\SignalToNoiseRatio(),
                'Weighting' => new \PHPExiftool\Driver\Tag\MXF\Weighting(),
                'AnalogDataCodingKind' => new \PHPExiftool\Driver\Tag\MXF\AnalogDataCodingKind(),
                'TimecodeKind' => new \PHPExiftool\Driver\Tag\MXF\TimecodeKind(),
                'TimecodeTimebase' => new \PHPExiftool\Driver\Tag\MXF\TimecodeTimebase(),
                'TimecodeUserBitsFlag' => new \PHPExiftool\Driver\Tag\MXF\TimecodeUserBitsFlag(),
                'IncludeSync' => new \PHPExiftool\Driver\Tag\MXF\IncludeSync(),
                'DropFrame' => new \PHPExiftool\Driver\Tag\MXF\DropFrame(),
                'TimecodeSourceKind' => new \PHPExiftool\Driver\Tag\MXF\TimecodeSourceKind(),
                'AnalogMetadataCarrier' => new \PHPExiftool\Driver\Tag\MXF\AnalogMetadataCarrier(),
                'DigitalMetadataCarrier' => new \PHPExiftool\Driver\Tag\MXF\DigitalMetadataCarrier(),
                'AnalogMonitoringAndControlCodingKind' => new \PHPExiftool\Driver\Tag\MXF\AnalogMonitoringAndControlCodingKind(),
                'SampleRate' => new \PHPExiftool\Driver\Tag\MXF\SampleRate(),
                'EssenceLength' => new \PHPExiftool\Driver\Tag\MXF\EssenceLength(),
                'FilmColorProcess' => new \PHPExiftool\Driver\Tag\MXF\FilmColorProcess(),
                'EdgeCodeFormat' => new \PHPExiftool\Driver\Tag\MXF\EdgeCodeFormat(),
                'FilmFormatName' => new \PHPExiftool\Driver\Tag\MXF\FilmFormatName(),
                'FilmStockKind' => new \PHPExiftool\Driver\Tag\MXF\FilmStockKind(),
                'FilmStockManufacturerName' => new \PHPExiftool\Driver\Tag\MXF\FilmStockManufacturerName(),
                'PhysicalMediaLength' => new \PHPExiftool\Driver\Tag\MXF\PhysicalMediaLength(),
                'FilmCaptureAperture' => new \PHPExiftool\Driver\Tag\MXF\FilmCaptureAperture(),
                'ImageCategory' => new \PHPExiftool\Driver\Tag\MXF\ImageCategory(),
                'ImageSourceDeviceKind' => new \PHPExiftool\Driver\Tag\MXF\ImageSourceDeviceKind(),
                'OpticalTestParameterName' => new \PHPExiftool\Driver\Tag\MXF\OpticalTestParameterName(),
                'OpticalTestResult' => new \PHPExiftool\Driver\Tag\MXF\OpticalTestResult(),
                'SensorType' => new \PHPExiftool\Driver\Tag\MXF\SensorType(),
                'PolarCharacteristic' => new \PHPExiftool\Driver\Tag\MXF\PolarCharacteristic(),
                'IntegrationIndication' => new \PHPExiftool\Driver\Tag\MXF\IntegrationIndication(),
                'EventIndication' => new \PHPExiftool\Driver\Tag\MXF\EventIndication(),
                'QualityFlag' => new \PHPExiftool\Driver\Tag\MXF\QualityFlag(),
                'PhysicalInstanceKind' => new \PHPExiftool\Driver\Tag\MXF\PhysicalInstanceKind(),
                'DigitalOrAnalogOrigination' => new \PHPExiftool\Driver\Tag\MXF\DigitalOrAnalogOrigination(),
                'MicrophonePlacementTechniques' => new \PHPExiftool\Driver\Tag\MXF\MicrophonePlacementTechniques(),
                'SimpleFlaggingCount' => new \PHPExiftool\Driver\Tag\MXF\SimpleFlaggingCount(),
                'CopyCount' => new \PHPExiftool\Driver\Tag\MXF\CopyCount(),
                'CloneCount' => new \PHPExiftool\Driver\Tag\MXF\CloneCount(),
                'Work-in-ProgressFlag' => new \PHPExiftool\Driver\Tag\MXF\WorkInProgressFlag(),
                'VideoOrImageCompressionAlgorithm' => new \PHPExiftool\Driver\Tag\MXF\VideoOrImageCompressionAlgorithm(),
                'SplicingMetadata' => new \PHPExiftool\Driver\Tag\MXF\SplicingMetadata(),
                'AudioCompressionAlgorithm' => new \PHPExiftool\Driver\Tag\MXF\AudioCompressionAlgorithm(),
                'VideoNoiseReductionAlgorithm' => new \PHPExiftool\Driver\Tag\MXF\VideoNoiseReductionAlgorithm(),
                'AudioNoiseReductionAlgorithm' => new \PHPExiftool\Driver\Tag\MXF\AudioNoiseReductionAlgorithm(),
                'EnhancementOrModificationDescription' => new \PHPExiftool\Driver\Tag\MXF\EnhancementOrModificationDescription(),
                'VideoDeviceKind' => new \PHPExiftool\Driver\Tag\MXF\VideoDeviceKind(),
                'VideoDeviceParameterName' => new \PHPExiftool\Driver\Tag\MXF\VideoDeviceParameterName(),
                'VideoDeviceParameterSetting' => new \PHPExiftool\Driver\Tag\MXF\VideoDeviceParameterSetting(),
                'AudioEnhancementOrModificationDescription' => new \PHPExiftool\Driver\Tag\MXF\AudioEnhancementOrModificationDescription(),
                'AudioFirstMix-DownProcess' => new \PHPExiftool\Driver\Tag\MXF\AudioFirstMixDownProcess(),
                'AudioDeviceKind' => new \PHPExiftool\Driver\Tag\MXF\AudioDeviceKind(),
                'AudioDeviceParameter' => new \PHPExiftool\Driver\Tag\MXF\AudioDeviceParameter(),
                'AudioDeviceParameterSetting' => new \PHPExiftool\Driver\Tag\MXF\AudioDeviceParameterSetting(),
                'DataEnhancementOrModificationDescription' => new \PHPExiftool\Driver\Tag\MXF\DataEnhancementOrModificationDescription(),
                'DataDeviceKind' => new \PHPExiftool\Driver\Tag\MXF\DataDeviceKind(),
                'DataDeviceParameterName' => new \PHPExiftool\Driver\Tag\MXF\DataDeviceParameterName(),
                'DataDeviceParameterSetting' => new \PHPExiftool\Driver\Tag\MXF\DataDeviceParameterSetting(),
                'DefaultFadeType' => new \PHPExiftool\Driver\Tag\MXF\DefaultFadeType(),
                'ActiveState' => new \PHPExiftool\Driver\Tag\MXF\ActiveState(),
                'Fade-InType' => new \PHPExiftool\Driver\Tag\MXF\FadeInType(),
                'Fade-OutType' => new \PHPExiftool\Driver\Tag\MXF\FadeOutType(),
                'SpeedChangeEffectFlag' => new \PHPExiftool\Driver\Tag\MXF\SpeedChangeEffectFlag(),
                'InputSegmentCount' => new \PHPExiftool\Driver\Tag\MXF\InputSegmentCount(),
                'Bypass' => new \PHPExiftool\Driver\Tag\MXF\Bypass(),
                'VideoCompressionAlgorithm' => new \PHPExiftool\Driver\Tag\MXF\VideoCompressionAlgorithm(),
                'MPEGVideoRecodingDataset' => new \PHPExiftool\Driver\Tag\MXF\MPEGVideoRecodingDataset(),
                'UpstreamAudioCompressionAlgorithm' => new \PHPExiftool\Driver\Tag\MXF\UpstreamAudioCompressionAlgorithm(),
                'MPEGAudioRecodingDataset' => new \PHPExiftool\Driver\Tag\MXF\MPEGAudioRecodingDataset(),
                'ProgramSupportMaterialReference' => new \PHPExiftool\Driver\Tag\MXF\ProgramSupportMaterialReference(),
                'AdvertisingMaterialReference' => new \PHPExiftool\Driver\Tag\MXF\AdvertisingMaterialReference(),
                'ProgramCommercialMaterialReference' => new \PHPExiftool\Driver\Tag\MXF\ProgramCommercialMaterialReference(),
                'ContiguousDataFlag' => new \PHPExiftool\Driver\Tag\MXF\ContiguousDataFlag(),
                'PositionInSequence' => new \PHPExiftool\Driver\Tag\MXF\PositionInSequence(),
                'RelativePositionInSequenceOffset' => new \PHPExiftool\Driver\Tag\MXF\RelativePositionInSequenceOffset(),
                'RelativePositionInSequenceName' => new \PHPExiftool\Driver\Tag\MXF\RelativePositionInSequenceName(),
                'ImageCoordinateSystem' => new \PHPExiftool\Driver\Tag\MXF\ImageCoordinateSystem(),
                'MapDatumUsed' => new \PHPExiftool\Driver\Tag\MXF\MapDatumUsed(),
                'LocalDatumAbsolutePositionAccuracy' => new \PHPExiftool\Driver\Tag\MXF\LocalDatumAbsolutePositionAccuracy(),
                'DeviceAbsolutePositionalAccuracy' => new \PHPExiftool\Driver\Tag\MXF\DeviceAbsolutePositionalAccuracy(),
                'DeviceAltitude' => new \PHPExiftool\Driver\Tag\MXF\DeviceAltitude(),
                'DeviceLatitude' => new \PHPExiftool\Driver\Tag\MXF\DeviceLatitude(),
                'DeviceLongitude' => new \PHPExiftool\Driver\Tag\MXF\DeviceLongitude(),
                'DeviceXDimension' => new \PHPExiftool\Driver\Tag\MXF\DeviceXDimension(),
                'DeviceYDimension' => new \PHPExiftool\Driver\Tag\MXF\DeviceYDimension(),
                'FramePositionalAccuracy' => new \PHPExiftool\Driver\Tag\MXF\FramePositionalAccuracy(),
                'FrameCenterLatitude' => new \PHPExiftool\Driver\Tag\MXF\FrameCenterLatitude(),
                'FrameCenterLongitude' => new \PHPExiftool\Driver\Tag\MXF\FrameCenterLongitude(),
                'FrameCenterLatitudeLongitude' => new \PHPExiftool\Driver\Tag\MXF\FrameCenterLatitudeLongitude(),
                'LocalDatumRelativePositionAccuracy' => new \PHPExiftool\Driver\Tag\MXF\LocalDatumRelativePositionAccuracy(),
                'DeviceRelativePositionalAccuracy' => new \PHPExiftool\Driver\Tag\MXF\DeviceRelativePositionalAccuracy(),
                'DeviceRelativePositionX' => new \PHPExiftool\Driver\Tag\MXF\DeviceRelativePositionX(),
                'DeviceRelativePositionY' => new \PHPExiftool\Driver\Tag\MXF\DeviceRelativePositionY(),
                'DeviceRelativePositionZ' => new \PHPExiftool\Driver\Tag\MXF\DeviceRelativePositionZ(),
                'SubjectRelativePositionalAccuracy' => new \PHPExiftool\Driver\Tag\MXF\SubjectRelativePositionalAccuracy(),
                'PositionWithinViewportImageXCoordinate' => new \PHPExiftool\Driver\Tag\MXF\PositionWithinViewportImageXCoordinate(),
                'PositionWithinViewportImageYCoordinate' => new \PHPExiftool\Driver\Tag\MXF\PositionWithinViewportImageYCoordinate(),
                'SourceImageCenterXCoordinate' => new \PHPExiftool\Driver\Tag\MXF\SourceImageCenterXCoordinate(),
                'SourceImageCenterYCoordinate' => new \PHPExiftool\Driver\Tag\MXF\SourceImageCenterYCoordinate(),
                'ViewportImageCenterCCoordinate' => new \PHPExiftool\Driver\Tag\MXF\ViewportImageCenterCCoordinate(),
                'ViewportImageCenterYCoordinate' => new \PHPExiftool\Driver\Tag\MXF\ViewportImageCenterYCoordinate(),
                'DeviceAbsoluteSpeed' => new \PHPExiftool\Driver\Tag\MXF\DeviceAbsoluteSpeed(),
                'DeviceAbsoluteHeading' => new \PHPExiftool\Driver\Tag\MXF\DeviceAbsoluteHeading(),
                'SubjectAbsoluteSpeed' => new \PHPExiftool\Driver\Tag\MXF\SubjectAbsoluteSpeed(),
                'SubjectAbsoluteHeading' => new \PHPExiftool\Driver\Tag\MXF\SubjectAbsoluteHeading(),
                'DeviceRelativeSpeed' => new \PHPExiftool\Driver\Tag\MXF\DeviceRelativeSpeed(),
                'DeviceRelativeHeading' => new \PHPExiftool\Driver\Tag\MXF\DeviceRelativeHeading(),
                'SubjectRelativeSpeed' => new \PHPExiftool\Driver\Tag\MXF\SubjectRelativeSpeed(),
                'SubjectRelativeHeading' => new \PHPExiftool\Driver\Tag\MXF\SubjectRelativeHeading(),
                'SlantRange' => new \PHPExiftool\Driver\Tag\MXF\SlantRange(),
                'TargetWidth' => new \PHPExiftool\Driver\Tag\MXF\TargetWidth(),
                'ViewportHeight' => new \PHPExiftool\Driver\Tag\MXF\ViewportHeight(),
                'ViewportWidth' => new \PHPExiftool\Driver\Tag\MXF\ViewportWidth(),
                'SensorRollAngle' => new \PHPExiftool\Driver\Tag\MXF\SensorRollAngle(),
                'AngleToNorth' => new \PHPExiftool\Driver\Tag\MXF\AngleToNorth(),
                'ObliquityAngle' => new \PHPExiftool\Driver\Tag\MXF\ObliquityAngle(),
                'PlaceKeyword' => new \PHPExiftool\Driver\Tag\MXF\PlaceKeyword(),
                'ObjectCountryCode' => new \PHPExiftool\Driver\Tag\MXF\ObjectCountryCode(),
                'ShootingCountryCode' => new \PHPExiftool\Driver\Tag\MXF\ShootingCountryCode(),
                'SettingCountryCode' => new \PHPExiftool\Driver\Tag\MXF\SettingCountryCode(),
                'CopyrightLicenseCountryCode' => new \PHPExiftool\Driver\Tag\MXF\CopyrightLicenseCountryCode(),
                'IntellectualPropertyLicenseCountryCode' => new \PHPExiftool\Driver\Tag\MXF\IntellectualPropertyLicenseCountryCode(),
                'ObjectRegionCode' => new \PHPExiftool\Driver\Tag\MXF\ObjectRegionCode(),
                'ShootingRegionCode' => new \PHPExiftool\Driver\Tag\MXF\ShootingRegionCode(),
                'SettingRegionCode' => new \PHPExiftool\Driver\Tag\MXF\SettingRegionCode(),
                'CopyrightLicenseRegionCode' => new \PHPExiftool\Driver\Tag\MXF\CopyrightLicenseRegionCode(),
                'IntellectualPropertyLicenseRegionCode' => new \PHPExiftool\Driver\Tag\MXF\IntellectualPropertyLicenseRegionCode(),
                'RoomNumber' => new \PHPExiftool\Driver\Tag\MXF\RoomNumber(),
                'StreetNumber' => new \PHPExiftool\Driver\Tag\MXF\StreetNumber(),
                'StreetName' => new \PHPExiftool\Driver\Tag\MXF\StreetName(),
                'PostalTown' => new \PHPExiftool\Driver\Tag\MXF\PostalTown(),
                'CityName' => new \PHPExiftool\Driver\Tag\MXF\CityName(),
                'StateOrProvinceOrCountyName' => new \PHPExiftool\Driver\Tag\MXF\StateOrProvinceOrCountyName(),
                'PostalCode' => new \PHPExiftool\Driver\Tag\MXF\PostalCode(),
                'CountryName' => new \PHPExiftool\Driver\Tag\MXF\CountryName(),
                'SettingRoomNumber' => new \PHPExiftool\Driver\Tag\MXF\SettingRoomNumber(),
                'SettingStreetNumberOrBuildingName' => new \PHPExiftool\Driver\Tag\MXF\SettingStreetNumberOrBuildingName(),
                'SettingStreetName' => new \PHPExiftool\Driver\Tag\MXF\SettingStreetName(),
                'SettingTownName' => new \PHPExiftool\Driver\Tag\MXF\SettingTownName(),
                'SettingCityName' => new \PHPExiftool\Driver\Tag\MXF\SettingCityName(),
                'SettingStateOrProvinceOrCountyName' => new \PHPExiftool\Driver\Tag\MXF\SettingStateOrProvinceOrCountyName(),
                'SettingPostalCode' => new \PHPExiftool\Driver\Tag\MXF\SettingPostalCode(),
                'SettingCountryName' => new \PHPExiftool\Driver\Tag\MXF\SettingCountryName(),
                'TelephoneNumber' => new \PHPExiftool\Driver\Tag\MXF\TelephoneNumber(),
                'FaxNumber' => new \PHPExiftool\Driver\Tag\MXF\FaxNumber(),
                'E-mailAddress' => new \PHPExiftool\Driver\Tag\MXF\EMailAddress(),
                'SettingDescription' => new \PHPExiftool\Driver\Tag\MXF\SettingDescription(),
                'UTCUserDateTime' => new \PHPExiftool\Driver\Tag\MXF\UTCUserDateTime(),
                'LocalUserDateTime' => new \PHPExiftool\Driver\Tag\MXF\LocalUserDateTime(),
                'SMPTE309MUserDateTime' => new \PHPExiftool\Driver\Tag\MXF\SMPTE309MUserDateTime(),
                'SMPTE12MUserDateTime' => new \PHPExiftool\Driver\Tag\MXF\SMPTE12MUserDateTime(),
                'UTCStartDateTime' => new \PHPExiftool\Driver\Tag\MXF\UTCStartDateTime(),
                'LocalStartDateTime' => new \PHPExiftool\Driver\Tag\MXF\LocalStartDateTime(),
                'TimecodeStartDateTime' => new \PHPExiftool\Driver\Tag\MXF\TimecodeStartDateTime(),
                'UTCEndDateTime' => new \PHPExiftool\Driver\Tag\MXF\UTCEndDateTime(),
                'LocalEndDateTime' => new \PHPExiftool\Driver\Tag\MXF\LocalEndDateTime(),
                'TimecodeEndDateTime' => new \PHPExiftool\Driver\Tag\MXF\TimecodeEndDateTime(),
                'UTCLastModifyDate' => new \PHPExiftool\Driver\Tag\MXF\UTCLastModifyDate(),
                'LocalLastModifyDate' => new \PHPExiftool\Driver\Tag\MXF\LocalLastModifyDate(),
                'TimecodeLastModifyDate' => new \PHPExiftool\Driver\Tag\MXF\TimecodeLastModifyDate(),
                'UTCEventStartDateTime' => new \PHPExiftool\Driver\Tag\MXF\UTCEventStartDateTime(),
                'LocalEventStartDateTime' => new \PHPExiftool\Driver\Tag\MXF\LocalEventStartDateTime(),
                'TimecodeEventStartDateTime' => new \PHPExiftool\Driver\Tag\MXF\TimecodeEventStartDateTime(),
                'UTCEventEndDateTime' => new \PHPExiftool\Driver\Tag\MXF\UTCEventEndDateTime(),
                'LocalEventEndDateTime' => new \PHPExiftool\Driver\Tag\MXF\LocalEventEndDateTime(),
                'TimecodeEventEndDateTime' => new \PHPExiftool\Driver\Tag\MXF\TimecodeEventEndDateTime(),
                'StartTimeRelativeToReference' => new \PHPExiftool\Driver\Tag\MXF\StartTimeRelativeToReference(),
                'StartTimecodeRelativeToReference' => new \PHPExiftool\Driver\Tag\MXF\StartTimecodeRelativeToReference(),
                'MaterialEndTimeOffset' => new \PHPExiftool\Driver\Tag\MXF\MaterialEndTimeOffset(),
                'MaterialEndTimecodeOffset' => new \PHPExiftool\Driver\Tag\MXF\MaterialEndTimecodeOffset(),
                'EventStartTimeOffset' => new \PHPExiftool\Driver\Tag\MXF\EventStartTimeOffset(),
                'EventStartTimecodeOffset' => new \PHPExiftool\Driver\Tag\MXF\EventStartTimecodeOffset(),
                'EventEndTimeOffset' => new \PHPExiftool\Driver\Tag\MXF\EventEndTimeOffset(),
                'EventEndTimecodeOffset' => new \PHPExiftool\Driver\Tag\MXF\EventEndTimecodeOffset(),
                'FrameCountOffset' => new \PHPExiftool\Driver\Tag\MXF\FrameCountOffset(),
                'TimePeriodName' => new \PHPExiftool\Driver\Tag\MXF\TimePeriodName(),
                'LocalCreationDateTime' => new \PHPExiftool\Driver\Tag\MXF\LocalCreationDateTime(),
                'TimecodeCreationDateTime' => new \PHPExiftool\Driver\Tag\MXF\TimecodeCreationDateTime(),
                'LocalModifyDate' => new \PHPExiftool\Driver\Tag\MXF\LocalModifyDate(),
                'TimecodeModifyDate' => new \PHPExiftool\Driver\Tag\MXF\TimecodeModifyDate(),
                'FrameCount' => new \PHPExiftool\Driver\Tag\MXF\FrameCount(),
                'MaterialAbsoluteDuration' => new \PHPExiftool\Driver\Tag\MXF\MaterialAbsoluteDuration(),
                'TextlessBlackDuration' => new \PHPExiftool\Driver\Tag\MXF\TextlessBlackDuration(),
                'EventAbsoluteDurationFrameCount' => new \PHPExiftool\Driver\Tag\MXF\EventAbsoluteDurationFrameCount(),
                'EventAbsoluteDuration' => new \PHPExiftool\Driver\Tag\MXF\EventAbsoluteDuration(),
                'BufferDelay' => new \PHPExiftool\Driver\Tag\MXF\BufferDelay(),
                'ProgramIdentifier' => new \PHPExiftool\Driver\Tag\MXF\ProgramIdentifier(),
                'ProgramIdentifierString' => new \PHPExiftool\Driver\Tag\MXF\ProgramIdentifierString(),
                'ShimName' => new \PHPExiftool\Driver\Tag\MXF\ShimName(),
                'SignalStandard' => new \PHPExiftool\Driver\Tag\MXF\SignalStandard(),
                'IntendedAFD' => new \PHPExiftool\Driver\Tag\MXF\IntendedAFD(),
                'SlateTitle' => new \PHPExiftool\Driver\Tag\MXF\SlateTitle(),
                'NOLACode' => new \PHPExiftool\Driver\Tag\MXF\NOLACode(),
                'Rating' => new \PHPExiftool\Driver\Tag\MXF\Rating(),
                'NielsenStreamIdentifier' => new \PHPExiftool\Driver\Tag\MXF\NielsenStreamIdentifier(),
                'IsRecording' => new \PHPExiftool\Driver\Tag\MXF\IsRecording(),
                'IsLiveProduction' => new \PHPExiftool\Driver\Tag\MXF\IsLiveProduction(),
                'IsLiveTransmission' => new \PHPExiftool\Driver\Tag\MXF\IsLiveTransmission(),
                'IsDubbed' => new \PHPExiftool\Driver\Tag\MXF\IsDubbed(),
                'IsVoiceover' => new \PHPExiftool\Driver\Tag\MXF\IsVoiceover(),
                'HasAudioWatermark' => new \PHPExiftool\Driver\Tag\MXF\HasAudioWatermark(),
                'AudioWatermarkKind' => new \PHPExiftool\Driver\Tag\MXF\AudioWatermarkKind(),
                'HasVideoWatermark' => new \PHPExiftool\Driver\Tag\MXF\HasVideoWatermark(),
                'VideoWatermarkKind' => new \PHPExiftool\Driver\Tag\MXF\VideoWatermarkKind(),
                'SubtitlesPresent' => new \PHPExiftool\Driver\Tag\MXF\SubtitlesPresent(),
                'CaptionTitles' => new \PHPExiftool\Driver\Tag\MXF\CaptionTitles(),
                'CaptionsViaTeletext' => new \PHPExiftool\Driver\Tag\MXF\CaptionsViaTeletext(),
                'TextlessMaterial' => new \PHPExiftool\Driver\Tag\MXF\TextlessMaterial(),
                'StorageDeviceKind' => new \PHPExiftool\Driver\Tag\MXF\StorageDeviceKind(),
                'StorageMediaKind' => new \PHPExiftool\Driver\Tag\MXF\StorageMediaKind(),
                'StorageMediaID' => new \PHPExiftool\Driver\Tag\MXF\StorageMediaID(),
                'BroadcastDate' => new \PHPExiftool\Driver\Tag\MXF\BroadcastDate(),
                'BroadcastTime' => new \PHPExiftool\Driver\Tag\MXF\BroadcastTime(),
                'IsRepeat' => new \PHPExiftool\Driver\Tag\MXF\IsRepeat(),
                'FirstTransmissionInfo' => new \PHPExiftool\Driver\Tag\MXF\FirstTransmissionInfo(),
                'TeletextSubtitlesAvailable' => new \PHPExiftool\Driver\Tag\MXF\TeletextSubtitlesAvailable(),
                'SeasonEpisodeNumber' => new \PHPExiftool\Driver\Tag\MXF\SeasonEpisodeNumber(),
                'SeasonEpisodeTitle' => new \PHPExiftool\Driver\Tag\MXF\SeasonEpisodeTitle(),
                'EPGProgramSynopsis' => new \PHPExiftool\Driver\Tag\MXF\EPGProgramSynopsis(),
                'DVBParentalRating' => new \PHPExiftool\Driver\Tag\MXF\DVBParentalRating(),
                'ContentMaturityRating' => new \PHPExiftool\Driver\Tag\MXF\ContentMaturityRating(),
                'ContentMaturityDescription' => new \PHPExiftool\Driver\Tag\MXF\ContentMaturityDescription(),
                'ContentMaturityGraphic' => new \PHPExiftool\Driver\Tag\MXF\ContentMaturityGraphic(),
                'ContractEntity' => new \PHPExiftool\Driver\Tag\MXF\ContractEntity(),
                'ContractTypeLink' => new \PHPExiftool\Driver\Tag\MXF\ContractTypeLink(),
                'ConsumerRightsToCopy' => new \PHPExiftool\Driver\Tag\MXF\ConsumerRightsToCopy(),
                'BroadcasterRightsToCopy' => new \PHPExiftool\Driver\Tag\MXF\BroadcasterRightsToCopy(),
                'DirectorName' => new \PHPExiftool\Driver\Tag\MXF\DirectorName(),
                'ProducerName' => new \PHPExiftool\Driver\Tag\MXF\ProducerName(),
                'FemaleLeadActressName' => new \PHPExiftool\Driver\Tag\MXF\FemaleLeadActressName(),
                'MaleLeadActorName' => new \PHPExiftool\Driver\Tag\MXF\MaleLeadActorName(),
                'PresenterName' => new \PHPExiftool\Driver\Tag\MXF\PresenterName(),
                'MainSponsorName' => new \PHPExiftool\Driver\Tag\MXF\MainSponsorName(),
                'VoiceTalentName' => new \PHPExiftool\Driver\Tag\MXF\VoiceTalentName(),
                'PostboxNumber' => new \PHPExiftool\Driver\Tag\MXF\PostboxNumber(),
                'PostCodeForPostbox' => new \PHPExiftool\Driver\Tag\MXF\PostCodeForPostbox(),
                'ProgramNumber' => new \PHPExiftool\Driver\Tag\MXF\ProgramNumber(),
                'DefinitionObjectID' => new \PHPExiftool\Driver\Tag\MXF\DefinitionObjectID(),
                'IEEEDeviceID' => new \PHPExiftool\Driver\Tag\MXF\IEEEDeviceID(),
                'ProjectNumber' => new \PHPExiftool\Driver\Tag\MXF\ProjectNumber(),
                'EdgeCodeHeader' => new \PHPExiftool\Driver\Tag\MXF\EdgeCodeHeader(),
                'ChannelHandle' => new \PHPExiftool\Driver\Tag\MXF\ChannelHandle(),
                'PhysicalMediaLocation' => new \PHPExiftool\Driver\Tag\MXF\PhysicalMediaLocation(),
                'MediaLocation' => new \PHPExiftool\Driver\Tag\MXF\MediaLocation(),
                'TrackNumber' => new \PHPExiftool\Driver\Tag\MXF\TrackNumber(),
                'EdgeCodeStart' => new \PHPExiftool\Driver\Tag\MXF\EdgeCodeStart(),
                'VersionTitle' => new \PHPExiftool\Driver\Tag\MXF\VersionTitle(),
                'TrackID' => new \PHPExiftool\Driver\Tag\MXF\TrackID(),
                'TrackName' => new \PHPExiftool\Driver\Tag\MXF\TrackName(),
                'DefinitionObjectName' => new \PHPExiftool\Driver\Tag\MXF\DefinitionObjectName(),
                'ContentPackageMetadataLink' => new \PHPExiftool\Driver\Tag\MXF\ContentPackageMetadataLink(),
                'DefinedName' => new \PHPExiftool\Driver\Tag\MXF\DefinedName(),
                'DeviceManufacturerName' => new \PHPExiftool\Driver\Tag\MXF\DeviceManufacturerName(),
                'ManufacturerID' => new \PHPExiftool\Driver\Tag\MXF\ManufacturerID(),
                'IEEEManufacturerID' => new \PHPExiftool\Driver\Tag\MXF\IEEEManufacturerID(),
                'AAFManufacturerID' => new \PHPExiftool\Driver\Tag\MXF\AAFManufacturerID(),
                'SupplyingDepartmentName' => new \PHPExiftool\Driver\Tag\MXF\SupplyingDepartmentName(),
                'AudienceShare' => new \PHPExiftool\Driver\Tag\MXF\AudienceShare(),
                'AudienceAppreciation' => new \PHPExiftool\Driver\Tag\MXF\AudienceAppreciation(),
                'Salutation' => new \PHPExiftool\Driver\Tag\MXF\Salutation(),
                'HonorsAndQualifications' => new \PHPExiftool\Driver\Tag\MXF\HonorsAndQualifications(),
                'ObjectModelVersion' => new \PHPExiftool\Driver\Tag\MXF\ObjectModelVersion(),
                'SDKVersion' => new \PHPExiftool\Driver\Tag\MXF\SDKVersion(),
                'IsOptional' => new \PHPExiftool\Driver\Tag\MXF\IsOptional(),
                'IsSearchable' => new \PHPExiftool\Driver\Tag\MXF\IsSearchable(),
                'UseDefaultValue' => new \PHPExiftool\Driver\Tag\MXF\UseDefaultValue(),
                'DefaultDataValue' => new \PHPExiftool\Driver\Tag\MXF\DefaultDataValue(),
                'Size' => new \PHPExiftool\Driver\Tag\MXF\Size(),
                'IsSigned' => new \PHPExiftool\Driver\Tag\MXF\IsSigned(),
                'ElementCount' => new \PHPExiftool\Driver\Tag\MXF\ElementCount(),
                'ElementNameList' => new \PHPExiftool\Driver\Tag\MXF\ElementNameList(),
                'TypeDefinitionElementValueList' => new \PHPExiftool\Driver\Tag\MXF\TypeDefinitionElementValueList(),
                'MemberNameList' => new \PHPExiftool\Driver\Tag\MXF\MemberNameList(),
                'ExtendibleElementNameList' => new \PHPExiftool\Driver\Tag\MXF\ExtendibleElementNameList(),
                'TypeDefinitionExtendibleElementValues' => new \PHPExiftool\Driver\Tag\MXF\TypeDefinitionExtendibleElementValues(),
                'TargetSet' => new \PHPExiftool\Driver\Tag\MXF\TargetSet(),
                'FillerData' => new \PHPExiftool\Driver\Tag\MXF\FillerData(),
                'KLVDataValue' => new \PHPExiftool\Driver\Tag\MXF\KLVDataValue(),
                'PackageKLVData' => new \PHPExiftool\Driver\Tag\MXF\PackageKLVData(),
                'ComponentKLVData' => new \PHPExiftool\Driver\Tag\MXF\ComponentKLVData(),
                'AssignedCategoryName' => new \PHPExiftool\Driver\Tag\MXF\AssignedCategoryName(),
                'AssignedCategoryValue' => new \PHPExiftool\Driver\Tag\MXF\AssignedCategoryValue(),
                'ShotList' => new \PHPExiftool\Driver\Tag\MXF\ShotList(),
                'PackageUserComments' => new \PHPExiftool\Driver\Tag\MXF\PackageUserComments(),
                'Cue-InWords' => new \PHPExiftool\Driver\Tag\MXF\CueInWords(),
                'Cue-OutWords' => new \PHPExiftool\Driver\Tag\MXF\CueOutWords(),
                'ObjectKind' => new \PHPExiftool\Driver\Tag\MXF\ObjectKind(),
                'ObjectDescription' => new \PHPExiftool\Driver\Tag\MXF\ObjectDescription(),
                'ObjectName' => new \PHPExiftool\Driver\Tag\MXF\ObjectName(),
                'MetadataItemName' => new \PHPExiftool\Driver\Tag\MXF\MetadataItemName(),
                'ShotCommentKind' => new \PHPExiftool\Driver\Tag\MXF\ShotCommentKind(),
                'ShotComment' => new \PHPExiftool\Driver\Tag\MXF\ShotComment(),
                'ComputedObjectKind' => new \PHPExiftool\Driver\Tag\MXF\ComputedObjectKind(),
                'VersionNumberString' => new \PHPExiftool\Driver\Tag\MXF\VersionNumberString(),
                'VersionNumber' => new \PHPExiftool\Driver\Tag\MXF\VersionNumber(),
                'WAVESummary' => new \PHPExiftool\Driver\Tag\MXF\WAVESummary(),
                'AIFCSummary' => new \PHPExiftool\Driver\Tag\MXF\AIFCSummary(),
                'TIFFSummary' => new \PHPExiftool\Driver\Tag\MXF\TIFFSummary(),
                'ViewportAspectRatio' => new \PHPExiftool\Driver\Tag\MXF\ViewportAspectRatio(),
                'PresentationGammaEquation' => new \PHPExiftool\Driver\Tag\MXF\PresentationGammaEquation(),
                'FieldDominance' => new \PHPExiftool\Driver\Tag\MXF\FieldDominance(),
                'VideoLineMap' => new \PHPExiftool\Driver\Tag\MXF\VideoLineMap(),
                'VerticalSub-sampling' => new \PHPExiftool\Driver\Tag\MXF\VerticalSubSampling(),
                'ColorRangeLevels' => new \PHPExiftool\Driver\Tag\MXF\ColorRangeLevels(),
                'PixelLayout' => new \PHPExiftool\Driver\Tag\MXF\PixelLayout(),
                'AlphaSampleDepth' => new \PHPExiftool\Driver\Tag\MXF\AlphaSampleDepth(),
                'Palette' => new \PHPExiftool\Driver\Tag\MXF\Palette(),
                'PaletteLayout' => new \PHPExiftool\Driver\Tag\MXF\PaletteLayout(),
                'ComponentDepth' => new \PHPExiftool\Driver\Tag\MXF\ComponentDepth(),
                'VideoCodingSchemeID' => new \PHPExiftool\Driver\Tag\MXF\VideoCodingSchemeID(),
                'RoundedCaptureFilmFrameRate' => new \PHPExiftool\Driver\Tag\MXF\RoundedCaptureFilmFrameRate(),
                'AudioAverageBitrate' => new \PHPExiftool\Driver\Tag\MXF\AudioAverageBitrate(),
                'AudioFixedBitrateFlag' => new \PHPExiftool\Driver\Tag\MXF\AudioFixedBitrateFlag(),
                'CodingLawKind' => new \PHPExiftool\Driver\Tag\MXF\CodingLawKind(),
                'AudioCodingSchemeID' => new \PHPExiftool\Driver\Tag\MXF\AudioCodingSchemeID(),
                'LayerNumber' => new \PHPExiftool\Driver\Tag\MXF\LayerNumber(),
                'RoundedTimecodeTimebase' => new \PHPExiftool\Driver\Tag\MXF\RoundedTimecodeTimebase(),
                'ComponentDataDefinition' => new \PHPExiftool\Driver\Tag\MXF\ComponentDataDefinition(),
                'StreamData' => new \PHPExiftool\Driver\Tag\MXF\StreamData(),
                'TimecodeStreamData' => new \PHPExiftool\Driver\Tag\MXF\TimecodeStreamData(),
                'RecordedFormat' => new \PHPExiftool\Driver\Tag\MXF\RecordedFormat(),
                'TapeShellKind' => new \PHPExiftool\Driver\Tag\MXF\TapeShellKind(),
                'TapeFormulation' => new \PHPExiftool\Driver\Tag\MXF\TapeFormulation(),
                'TapeCapacity' => new \PHPExiftool\Driver\Tag\MXF\TapeCapacity(),
                'TapeManufacturer' => new \PHPExiftool\Driver\Tag\MXF\TapeManufacturer(),
                'TapeStock' => new \PHPExiftool\Driver\Tag\MXF\TapeStock(),
                'TapeBatchNumber' => new \PHPExiftool\Driver\Tag\MXF\TapeBatchNumber(),
                'PerforationsPerFrame' => new \PHPExiftool\Driver\Tag\MXF\PerforationsPerFrame(),
                'FilmBatchNumber' => new \PHPExiftool\Driver\Tag\MXF\FilmBatchNumber(),
                'FilmGauge' => new \PHPExiftool\Driver\Tag\MXF\FilmGauge(),
                'EdgeCodeFilmGauge' => new \PHPExiftool\Driver\Tag\MXF\EdgeCodeFilmGauge(),
                'ExposedAspectRatio' => new \PHPExiftool\Driver\Tag\MXF\ExposedAspectRatio(),
                'ImageAlignmentOffset' => new \PHPExiftool\Driver\Tag\MXF\ImageAlignmentOffset(),
                'ImageStartOffset' => new \PHPExiftool\Driver\Tag\MXF\ImageStartOffset(),
                'ImageEndOffset' => new \PHPExiftool\Driver\Tag\MXF\ImageEndOffset(),
                'PaddingBits' => new \PHPExiftool\Driver\Tag\MXF\PaddingBits(),
                'FocalLength' => new \PHPExiftool\Driver\Tag\MXF\FocalLength(),
                'SensorSize' => new \PHPExiftool\Driver\Tag\MXF\SensorSize(),
                'FNumber' => new \PHPExiftool\Driver\Tag\MXF\FNumber(),
                'SensorTypeCode' => new \PHPExiftool\Driver\Tag\MXF\SensorTypeCode(),
                'FieldOfViewHorizontal' => new \PHPExiftool\Driver\Tag\MXF\FieldOfViewHorizontal(),
                'AnamorphicLensCharacteristic' => new \PHPExiftool\Driver\Tag\MXF\AnamorphicLensCharacteristic(),
                'UniformDataFlag' => new \PHPExiftool\Driver\Tag\MXF\UniformDataFlag(),
                'JPEGTableID' => new \PHPExiftool\Driver\Tag\MXF\JPEGTableID(),
                'AlphaTransparency' => new \PHPExiftool\Driver\Tag\MXF\AlphaTransparency(),
                'GenerationID' => new \PHPExiftool\Driver\Tag\MXF\GenerationID(),
                'ApplicationSupplierName' => new \PHPExiftool\Driver\Tag\MXF\ApplicationSupplierName(),
                'ApplicationName' => new \PHPExiftool\Driver\Tag\MXF\ApplicationName(),
                'ApplicationVersionNumber' => new \PHPExiftool\Driver\Tag\MXF\ApplicationVersionNumber(),
                'ApplicationVersionString' => new \PHPExiftool\Driver\Tag\MXF\ApplicationVersionString(),
                'ApplicationPlatform' => new \PHPExiftool\Driver\Tag\MXF\ApplicationPlatform(),
                'ApplicationProductID' => new \PHPExiftool\Driver\Tag\MXF\ApplicationProductID(),
                'LinkedGenerationID' => new \PHPExiftool\Driver\Tag\MXF\LinkedGenerationID(),
                'ContainerVersion' => new \PHPExiftool\Driver\Tag\MXF\ContainerVersion(),
                'ToolkitVersion' => new \PHPExiftool\Driver\Tag\MXF\ToolkitVersion(),
                'Plug-InCategoryID' => new \PHPExiftool\Driver\Tag\MXF\PlugInCategoryID(),
                'Plug-InPlatformID' => new \PHPExiftool\Driver\Tag\MXF\PlugInPlatformID(),
                'MinimumSupportedPlatformVersion' => new \PHPExiftool\Driver\Tag\MXF\MinimumSupportedPlatformVersion(),
                'MaximumSupportedPlatformVersion' => new \PHPExiftool\Driver\Tag\MXF\MaximumSupportedPlatformVersion(),
                'Plug-InEngineID' => new \PHPExiftool\Driver\Tag\MXF\PlugInEngineID(),
                'MinimumSupportedEngineVersion' => new \PHPExiftool\Driver\Tag\MXF\MinimumSupportedEngineVersion(),
                'MaximumSupportedEngineVersion' => new \PHPExiftool\Driver\Tag\MXF\MaximumSupportedEngineVersion(),
                'Plug-InAPIID' => new \PHPExiftool\Driver\Tag\MXF\PlugInAPIID(),
                'MinimumAPIVersion' => new \PHPExiftool\Driver\Tag\MXF\MinimumAPIVersion(),
                'MaximumAPIVersion' => new \PHPExiftool\Driver\Tag\MXF\MaximumAPIVersion(),
                'Software-OnlySupportFlag' => new \PHPExiftool\Driver\Tag\MXF\SoftwareOnlySupportFlag(),
                'HardwareAcceleratorFlag' => new \PHPExiftool\Driver\Tag\MXF\HardwareAcceleratorFlag(),
                'Plug-InLocatorSet' => new \PHPExiftool\Driver\Tag\MXF\PlugInLocatorSet(),
                'AuthenticationFlag' => new \PHPExiftool\Driver\Tag\MXF\AuthenticationFlag(),
                'AssociatedMetadataDefinition' => new \PHPExiftool\Driver\Tag\MXF\AssociatedMetadataDefinition(),
                'EventTrackEditRate' => new \PHPExiftool\Driver\Tag\MXF\EventTrackEditRate(),
                'DefaultFadeEditRate' => new \PHPExiftool\Driver\Tag\MXF\DefaultFadeEditRate(),
                'EditingEventComment' => new \PHPExiftool\Driver\Tag\MXF\EditingEventComment(),
                'EditRate' => new \PHPExiftool\Driver\Tag\MXF\EditRate(),
                'OperationDefinitionID' => new \PHPExiftool\Driver\Tag\MXF\OperationDefinitionID(),
                'Value' => new \PHPExiftool\Driver\Tag\MXF\Value(),
                'EditHint' => new \PHPExiftool\Driver\Tag\MXF\EditHint(),
                'OperationDataDefinition' => new \PHPExiftool\Driver\Tag\MXF\OperationDataDefinition(),
                'OperationCategory' => new \PHPExiftool\Driver\Tag\MXF\OperationCategory(),
                'DisplayUnits' => new \PHPExiftool\Driver\Tag\MXF\DisplayUnits(),
                'BypassOverride' => new \PHPExiftool\Driver\Tag\MXF\BypassOverride(),
                'TimepointValue' => new \PHPExiftool\Driver\Tag\MXF\TimepointValue(),
                'BeginAnchor' => new \PHPExiftool\Driver\Tag\MXF\BeginAnchor(),
                'EndAnchor' => new \PHPExiftool\Driver\Tag\MXF\EndAnchor(),
                'FilmToVideoTransferDirection' => new \PHPExiftool\Driver\Tag\MXF\FilmToVideoTransferDirection(),
                'FilmToVideoTransferKind' => new \PHPExiftool\Driver\Tag\MXF\FilmToVideoTransferKind(),
                'FilmToVideoTransferPhase' => new \PHPExiftool\Driver\Tag\MXF\FilmToVideoTransferPhase(),
                'TeletextSubtitlesFlag' => new \PHPExiftool\Driver\Tag\MXF\TeletextSubtitlesFlag(),
                'SubtitleDatafileFlag' => new \PHPExiftool\Driver\Tag\MXF\SubtitleDatafileFlag(),
                'ClosedCaptionSubtitlesFlag' => new \PHPExiftool\Driver\Tag\MXF\ClosedCaptionSubtitlesFlag(),
                'SampleIndex' => new \PHPExiftool\Driver\Tag\MXF\SampleIndex(),
                'SourcePackageID' => new \PHPExiftool\Driver\Tag\MXF\SourcePackageID(),
                'SourceTrackID' => new \PHPExiftool\Driver\Tag\MXF\SourceTrackID(),
                'RelativeScope' => new \PHPExiftool\Driver\Tag\MXF\RelativeScope(),
                'RelativeTrack' => new \PHPExiftool\Driver\Tag\MXF\RelativeTrack(),
                'ObjectClass' => new \PHPExiftool\Driver\Tag\MXF\ObjectClass(),
                'EssenceContainerFormat' => new \PHPExiftool\Driver\Tag\MXF\EssenceContainerFormat(),
                'CodecDefinition' => new \PHPExiftool\Driver\Tag\MXF\CodecDefinition(),
                'ParameterDefinition' => new \PHPExiftool\Driver\Tag\MXF\ParameterDefinition(),
                'Interpolation' => new \PHPExiftool\Driver\Tag\MXF\Interpolation(),
                'ParameterDataType' => new \PHPExiftool\Driver\Tag\MXF\ParameterDataType(),
                'CodecEssenceDescriptor' => new \PHPExiftool\Driver\Tag\MXF\CodecEssenceDescriptor(),
                'ContentStorage' => new \PHPExiftool\Driver\Tag\MXF\ContentStorage(),
                'Dictionary' => new \PHPExiftool\Driver\Tag\MXF\Dictionary(),
                'EssenceDescription' => new \PHPExiftool\Driver\Tag\MXF\EssenceDescription(),
                'Sequence' => new \PHPExiftool\Driver\Tag\MXF\Sequence(),
                'TransitionEffect' => new \PHPExiftool\Driver\Tag\MXF\TransitionEffect(),
                'EffectRendering' => new \PHPExiftool\Driver\Tag\MXF\EffectRendering(),
                'InputSegment' => new \PHPExiftool\Driver\Tag\MXF\InputSegment(),
                'StillFrame' => new \PHPExiftool\Driver\Tag\MXF\StillFrame(),
                'Selected' => new \PHPExiftool\Driver\Tag\MXF\Selected(),
                'Annotation' => new \PHPExiftool\Driver\Tag\MXF\Annotation(),
                'ManufacturerInformationObject' => new \PHPExiftool\Driver\Tag\MXF\ManufacturerInformationObject(),
                'CodecEssenceKinds' => new \PHPExiftool\Driver\Tag\MXF\CodecEssenceKinds(),
                'OperationParameters' => new \PHPExiftool\Driver\Tag\MXF\OperationParameters(),
                'DegradedEffects' => new \PHPExiftool\Driver\Tag\MXF\DegradedEffects(),
                'Packages' => new \PHPExiftool\Driver\Tag\MXF\Packages(),
                'EssenceData' => new \PHPExiftool\Driver\Tag\MXF\EssenceData(),
                'OperationDefinitions' => new \PHPExiftool\Driver\Tag\MXF\OperationDefinitions(),
                'ParameterDefinitions' => new \PHPExiftool\Driver\Tag\MXF\ParameterDefinitions(),
                'DataDefinitions' => new \PHPExiftool\Driver\Tag\MXF\DataDefinitions(),
                'Plug-InDefinitions' => new \PHPExiftool\Driver\Tag\MXF\PlugInDefinitions(),
                'CodecDefinitions' => new \PHPExiftool\Driver\Tag\MXF\CodecDefinitions(),
                'ContainerDefinitions' => new \PHPExiftool\Driver\Tag\MXF\ContainerDefinitions(),
                'InterpolationDefinitions' => new \PHPExiftool\Driver\Tag\MXF\InterpolationDefinitions(),
                'AvailableRepresentations' => new \PHPExiftool\Driver\Tag\MXF\AvailableRepresentations(),
                'InputSegments' => new \PHPExiftool\Driver\Tag\MXF\InputSegments(),
                'EssenceLocators' => new \PHPExiftool\Driver\Tag\MXF\EssenceLocators(),
                'IdentificationList' => new \PHPExiftool\Driver\Tag\MXF\IdentificationList(),
                'Tracks' => new \PHPExiftool\Driver\Tag\MXF\Tracks(),
                'ControlPointList' => new \PHPExiftool\Driver\Tag\MXF\ControlPointList(),
                'PackageTracks' => new \PHPExiftool\Driver\Tag\MXF\PackageTracks(),
                'Alternates' => new \PHPExiftool\Driver\Tag\MXF\Alternates(),
                'ComponentsInSequence' => new \PHPExiftool\Driver\Tag\MXF\ComponentsInSequence(),
                'Parameters' => new \PHPExiftool\Driver\Tag\MXF\Parameters(),
                'LinkedPackageID' => new \PHPExiftool\Driver\Tag\MXF\LinkedPackageID(),
                'ParentClass' => new \PHPExiftool\Driver\Tag\MXF\ParentClass(),
                'Properties' => new \PHPExiftool\Driver\Tag\MXF\Properties(),
                'IsConcrete' => new \PHPExiftool\Driver\Tag\MXF\IsConcrete(),
                'PropertyType' => new \PHPExiftool\Driver\Tag\MXF\PropertyType(),
                'LocalID' => new \PHPExiftool\Driver\Tag\MXF\LocalID(),
                'IsUniqueIdentifier' => new \PHPExiftool\Driver\Tag\MXF\IsUniqueIdentifier(),
                'ClassDefinitions' => new \PHPExiftool\Driver\Tag\MXF\ClassDefinitions(),
                'TypeDefinitions' => new \PHPExiftool\Driver\Tag\MXF\TypeDefinitions(),
                'TargetClassOfStrongReference' => new \PHPExiftool\Driver\Tag\MXF\TargetClassOfStrongReference(),
                'TargetClassOfWeakReference' => new \PHPExiftool\Driver\Tag\MXF\TargetClassOfWeakReference(),
                'EnumerationUnderlyingIntegerType' => new \PHPExiftool\Driver\Tag\MXF\EnumerationUnderlyingIntegerType(),
                'FixedArrayElementType' => new \PHPExiftool\Driver\Tag\MXF\FixedArrayElementType(),
                'VariableArrayElementType' => new \PHPExiftool\Driver\Tag\MXF\VariableArrayElementType(),
                'SetElementType' => new \PHPExiftool\Driver\Tag\MXF\SetElementType(),
                'StringElementType' => new \PHPExiftool\Driver\Tag\MXF\StringElementType(),
                'StreamElementType' => new \PHPExiftool\Driver\Tag\MXF\StreamElementType(),
                'MemberTypes' => new \PHPExiftool\Driver\Tag\MXF\MemberTypes(),
                'RenamedType' => new \PHPExiftool\Driver\Tag\MXF\RenamedType(),
                'DictionaryIdentifier' => new \PHPExiftool\Driver\Tag\MXF\DictionaryIdentifier(),
                'DictionaryDescription' => new \PHPExiftool\Driver\Tag\MXF\DictionaryDescription(),
                'BlockContinuityCount' => new \PHPExiftool\Driver\Tag\MXF\BlockContinuityCount(),
                'StreamPositionIndicator' => new \PHPExiftool\Driver\Tag\MXF\StreamPositionIndicator(),
                'Origin' => new \PHPExiftool\Driver\Tag\MXF\Origin(),
                'StartTimecode' => new \PHPExiftool\Driver\Tag\MXF\StartTimecode(),
                'CutPoint' => new \PHPExiftool\Driver\Tag\MXF\CutPoint(),
                'EventStart' => new \PHPExiftool\Driver\Tag\MXF\EventStart(),
                'ControlPointTime' => new \PHPExiftool\Driver\Tag\MXF\ControlPointTime(),
                'CreateDate' => new \PHPExiftool\Driver\Tag\MXF\CreateDate(),
                'ModifyDate' => new \PHPExiftool\Driver\Tag\MXF\ModifyDate(),
                'ContainerLastModifyDate' => new \PHPExiftool\Driver\Tag\MXF\ContainerLastModifyDate(),
                'PackageLastModifyDate' => new \PHPExiftool\Driver\Tag\MXF\PackageLastModifyDate(),
                'Duration' => new \PHPExiftool\Driver\Tag\MXF\Duration(),
                'DefaultFadeDuration' => new \PHPExiftool\Driver\Tag\MXF\DefaultFadeDuration(),
                'Fade-InDuration' => new \PHPExiftool\Driver\Tag\MXF\FadeInDuration(),
                'Fade-OutDuration' => new \PHPExiftool\Driver\Tag\MXF\FadeOutDuration(),
                'TapeFormat' => new \PHPExiftool\Driver\Tag\MXF\TapeFormat(),
                'GlobalNumber' => new \PHPExiftool\Driver\Tag\MXF\GlobalNumber(),
                'DeviceIDKind' => new \PHPExiftool\Driver\Tag\MXF\DeviceIDKind(),
                'DeviceKind' => new \PHPExiftool\Driver\Tag\MXF\DeviceKind(),
                'DeviceKindCode' => new \PHPExiftool\Driver\Tag\MXF\DeviceKindCode(),
                'PlatformDesignation' => new \PHPExiftool\Driver\Tag\MXF\PlatformDesignation(),
                'PlatformModel' => new \PHPExiftool\Driver\Tag\MXF\PlatformModel(),
                'PlatformSerialNumber' => new \PHPExiftool\Driver\Tag\MXF\PlatformSerialNumber(),
                'LocalTargetID' => new \PHPExiftool\Driver\Tag\MXF\LocalTargetID(),
                'MagneticDiskNumber' => new \PHPExiftool\Driver\Tag\MXF\MagneticDiskNumber(),
                'OpticalDiscNumber' => new \PHPExiftool\Driver\Tag\MXF\OpticalDiscNumber(),
                'StreamID' => new \PHPExiftool\Driver\Tag\MXF\StreamID(),
                'TransportStreamID' => new \PHPExiftool\Driver\Tag\MXF\TransportStreamID(),
                'OrganizationalProgramNumber' => new \PHPExiftool\Driver\Tag\MXF\OrganizationalProgramNumber(),
                'ItemDesignatorID' => new \PHPExiftool\Driver\Tag\MXF\ItemDesignatorID(),
                'MissionID' => new \PHPExiftool\Driver\Tag\MXF\MissionID(),
                'RecordingLabelName' => new \PHPExiftool\Driver\Tag\MXF\RecordingLabelName(),
                'CollectionName' => new \PHPExiftool\Driver\Tag\MXF\CollectionName(),
                'OriginCode' => new \PHPExiftool\Driver\Tag\MXF\OriginCode(),
                'MainCatalogNumber' => new \PHPExiftool\Driver\Tag\MXF\MainCatalogNumber(),
                'CatalogPrefixNumber' => new \PHPExiftool\Driver\Tag\MXF\CatalogPrefixNumber(),
                'SideNumber' => new \PHPExiftool\Driver\Tag\MXF\SideNumber(),
                'RecordedTrackNumber' => new \PHPExiftool\Driver\Tag\MXF\RecordedTrackNumber(),
                'SeriesinaSeriesGroupCount' => new \PHPExiftool\Driver\Tag\MXF\SeriesinaSeriesGroupCount(),
                'ProgrammingGroupKind' => new \PHPExiftool\Driver\Tag\MXF\ProgrammingGroupKind(),
                'PurchasingOrganizationName' => new \PHPExiftool\Driver\Tag\MXF\PurchasingOrganizationName(),
                'SalesContractNumber' => new \PHPExiftool\Driver\Tag\MXF\SalesContractNumber(),
                'PurchasingDepartment' => new \PHPExiftool\Driver\Tag\MXF\PurchasingDepartment(),
                'ContractType' => new \PHPExiftool\Driver\Tag\MXF\ContractType(),
                'ContractTypeCode' => new \PHPExiftool\Driver\Tag\MXF\ContractTypeCode(),
                'ContractClauseDescription' => new \PHPExiftool\Driver\Tag\MXF\ContractClauseDescription(),
                'ContractLineCode' => new \PHPExiftool\Driver\Tag\MXF\ContractLineCode(),
                'ContractLineName' => new \PHPExiftool\Driver\Tag\MXF\ContractLineName(),
                'ContractTermsOfBusiness' => new \PHPExiftool\Driver\Tag\MXF\ContractTermsOfBusiness(),
                'ContractInstallmentPercentage' => new \PHPExiftool\Driver\Tag\MXF\ContractInstallmentPercentage(),
                'Jurisdiction' => new \PHPExiftool\Driver\Tag\MXF\Jurisdiction(),
                'RightsConditionDescription' => new \PHPExiftool\Driver\Tag\MXF\RightsConditionDescription(),
                'CurrencyName' => new \PHPExiftool\Driver\Tag\MXF\CurrencyName(),
                'TotalPayment' => new \PHPExiftool\Driver\Tag\MXF\TotalPayment(),
                'PayeeAccountName' => new \PHPExiftool\Driver\Tag\MXF\PayeeAccountName(),
                'PayeeAccountNumber' => new \PHPExiftool\Driver\Tag\MXF\PayeeAccountNumber(),
                'PayeeAccountSortCode' => new \PHPExiftool\Driver\Tag\MXF\PayeeAccountSortCode(),
                'TotalIncome' => new \PHPExiftool\Driver\Tag\MXF\TotalIncome(),
                'PayerAccountName' => new \PHPExiftool\Driver\Tag\MXF\PayerAccountName(),
                'PayerAccountNumber' => new \PHPExiftool\Driver\Tag\MXF\PayerAccountNumber(),
                'PayerAccountSortCode' => new \PHPExiftool\Driver\Tag\MXF\PayerAccountSortCode(),
                'SecurityClassification' => new \PHPExiftool\Driver\Tag\MXF\SecurityClassification(),
                'SecurityClassificationCaveats' => new \PHPExiftool\Driver\Tag\MXF\SecurityClassificationCaveats(),
                'ClassifiedBy' => new \PHPExiftool\Driver\Tag\MXF\ClassifiedBy(),
                'ClassificationReason' => new \PHPExiftool\Driver\Tag\MXF\ClassificationReason(),
                'DeclassificationDate' => new \PHPExiftool\Driver\Tag\MXF\DeclassificationDate(),
                'DerivedFrom' => new \PHPExiftool\Driver\Tag\MXF\DerivedFrom(),
                'ClassificationComment' => new \PHPExiftool\Driver\Tag\MXF\ClassificationComment(),
                'ClassificationAndMarkingSystem' => new \PHPExiftool\Driver\Tag\MXF\ClassificationAndMarkingSystem(),
                'BroadcastServiceName' => new \PHPExiftool\Driver\Tag\MXF\BroadcastServiceName(),
                'BroadcastMediumCode' => new \PHPExiftool\Driver\Tag\MXF\BroadcastMediumCode(),
                'JobFunctionCode' => new \PHPExiftool\Driver\Tag\MXF\JobFunctionCode(),
                'JobTitle' => new \PHPExiftool\Driver\Tag\MXF\JobTitle(),
                'PersonDescription' => new \PHPExiftool\Driver\Tag\MXF\PersonDescription(),
                'RegionCode' => new \PHPExiftool\Driver\Tag\MXF\RegionCode(),
                'RegionName' => new \PHPExiftool\Driver\Tag\MXF\RegionName(),
                'LanguageName' => new \PHPExiftool\Driver\Tag\MXF\LanguageName(),
                'TerminatingFillerData' => new \PHPExiftool\Driver\Tag\MXF\TerminatingFillerData(),
                'TimingBiasCorrection' => new \PHPExiftool\Driver\Tag\MXF\TimingBiasCorrection(),
                'TimingBiasCorrectionDescription' => new \PHPExiftool\Driver\Tag\MXF\TimingBiasCorrectionDescription(),
                'ProgramMaterialClassificationCode' => new \PHPExiftool\Driver\Tag\MXF\ProgramMaterialClassificationCode(),
                'SubjectName' => new \PHPExiftool\Driver\Tag\MXF\SubjectName(),
                'KeyFrameSampleCount' => new \PHPExiftool\Driver\Tag\MXF\KeyFrameSampleCount(),
                'IntentDescriptor' => new \PHPExiftool\Driver\Tag\MXF\IntentDescriptor(),
                'TextualDescriptionKind' => new \PHPExiftool\Driver\Tag\MXF\TextualDescriptionKind(),
                'FestivalName' => new \PHPExiftool\Driver\Tag\MXF\FestivalName(),
                'ObjectDescriptionCode' => new \PHPExiftool\Driver\Tag\MXF\ObjectDescriptionCode(),
                'DescriptionKind' => new \PHPExiftool\Driver\Tag\MXF\DescriptionKind(),
                'DescriptiveComment' => new \PHPExiftool\Driver\Tag\MXF\DescriptiveComment(),
                'ContextDescription' => new \PHPExiftool\Driver\Tag\MXF\ContextDescription(),
                'ObjectIdentificationConfidence' => new \PHPExiftool\Driver\Tag\MXF\ObjectIdentificationConfidence(),
                'ObjectHorizontalAverageDimension' => new \PHPExiftool\Driver\Tag\MXF\ObjectHorizontalAverageDimension(),
                'ObjectVerticalAverageDimension' => new \PHPExiftool\Driver\Tag\MXF\ObjectVerticalAverageDimension(),
                'ObjectAreaDimension' => new \PHPExiftool\Driver\Tag\MXF\ObjectAreaDimension(),
                'HorizontalActionSafePercentage' => new \PHPExiftool\Driver\Tag\MXF\HorizontalActionSafePercentage(),
                'VerticalActionSafePercentage' => new \PHPExiftool\Driver\Tag\MXF\VerticalActionSafePercentage(),
                'HorizontalGraphicsSafePercentage' => new \PHPExiftool\Driver\Tag\MXF\HorizontalGraphicsSafePercentage(),
                'VerticalGraphicsSafePercentage' => new \PHPExiftool\Driver\Tag\MXF\VerticalGraphicsSafePercentage(),
                'PerceivedDisplayFormatName' => new \PHPExiftool\Driver\Tag\MXF\PerceivedDisplayFormatName(),
                'PerceivedDisplayFormatCode' => new \PHPExiftool\Driver\Tag\MXF\PerceivedDisplayFormatCode(),
                'VideoColorKind' => new \PHPExiftool\Driver\Tag\MXF\VideoColorKind(),
                'PictureDisplayRate' => new \PHPExiftool\Driver\Tag\MXF\PictureDisplayRate(),
                'VideoAverageBitrate' => new \PHPExiftool\Driver\Tag\MXF\VideoAverageBitrate(),
                'VideoFixedBitrate' => new \PHPExiftool\Driver\Tag\MXF\VideoFixedBitrate(),
                'DigitalVideoFileFormat' => new \PHPExiftool\Driver\Tag\MXF\DigitalVideoFileFormat(),
                'CodingLawName' => new \PHPExiftool\Driver\Tag\MXF\CodingLawName(),
                'AudioCodingSchemeCode' => new \PHPExiftool\Driver\Tag\MXF\AudioCodingSchemeCode(),
                'AudioCodingSchemeName' => new \PHPExiftool\Driver\Tag\MXF\AudioCodingSchemeName(),
                'DigitalEncodingBitrate' => new \PHPExiftool\Driver\Tag\MXF\DigitalEncodingBitrate(),
                'DataEssenceCodingID' => new \PHPExiftool\Driver\Tag\MXF\DataEssenceCodingID(),
                'StorageKind' => new \PHPExiftool\Driver\Tag\MXF\StorageKind(),
                'StorageKindCode' => new \PHPExiftool\Driver\Tag\MXF\StorageKindCode(),
                'TapePartitionCapacity' => new \PHPExiftool\Driver\Tag\MXF\TapePartitionCapacity(),
                'DiscPartitionCapacity' => new \PHPExiftool\Driver\Tag\MXF\DiscPartitionCapacity(),
                'FieldOfViewVertical' => new \PHPExiftool\Driver\Tag\MXF\FieldOfViewVertical(),
                'SystemNameOrNumber' => new \PHPExiftool\Driver\Tag\MXF\SystemNameOrNumber(),
                'LogoFlag' => new \PHPExiftool\Driver\Tag\MXF\LogoFlag(),
                'GraphicKind' => new \PHPExiftool\Driver\Tag\MXF\GraphicKind(),
                'GraphicUsageKind' => new \PHPExiftool\Driver\Tag\MXF\GraphicUsageKind(),
                'SignatureTuneFlag' => new \PHPExiftool\Driver\Tag\MXF\SignatureTuneFlag(),
                'BackgroundMusicFlag' => new \PHPExiftool\Driver\Tag\MXF\BackgroundMusicFlag(),
                'ProductionScriptReference' => new \PHPExiftool\Driver\Tag\MXF\ProductionScriptReference(),
                'TranscriptReference' => new \PHPExiftool\Driver\Tag\MXF\TranscriptReference(),
                'HorizontalDatum' => new \PHPExiftool\Driver\Tag\MXF\HorizontalDatum(),
                'VerticalDatum' => new \PHPExiftool\Driver\Tag\MXF\VerticalDatum(),
                'CornerLatitudePoint1' => new \PHPExiftool\Driver\Tag\MXF\CornerLatitudePoint1(),
                'CornerLatitudePoint2' => new \PHPExiftool\Driver\Tag\MXF\CornerLatitudePoint2(),
                'CornerLatitudePoint3' => new \PHPExiftool\Driver\Tag\MXF\CornerLatitudePoint3(),
                'CornerLatitudePoint4' => new \PHPExiftool\Driver\Tag\MXF\CornerLatitudePoint4(),
                'CornerLongitudePoint1' => new \PHPExiftool\Driver\Tag\MXF\CornerLongitudePoint1(),
                'CornerLongitudePoint2' => new \PHPExiftool\Driver\Tag\MXF\CornerLongitudePoint2(),
                'CornerLongitudePoint3' => new \PHPExiftool\Driver\Tag\MXF\CornerLongitudePoint3(),
                'CornerLongitudePoint4' => new \PHPExiftool\Driver\Tag\MXF\CornerLongitudePoint4(),
                'SubjectDistance' => new \PHPExiftool\Driver\Tag\MXF\SubjectDistance(),
                'ObjectCountryCodeMethod' => new \PHPExiftool\Driver\Tag\MXF\ObjectCountryCodeMethod(),
                'CountryCodeMethod' => new \PHPExiftool\Driver\Tag\MXF\CountryCodeMethod(),
                'Non-USClassifyingCountryCode' => new \PHPExiftool\Driver\Tag\MXF\NonUSClassifyingCountryCode(),
                'ReleasableCountryCode' => new \PHPExiftool\Driver\Tag\MXF\ReleasableCountryCode(),
                'ObjectRegionName' => new \PHPExiftool\Driver\Tag\MXF\ObjectRegionName(),
                'ShootingRegionName' => new \PHPExiftool\Driver\Tag\MXF\ShootingRegionName(),
                'SettingRegionName' => new \PHPExiftool\Driver\Tag\MXF\SettingRegionName(),
                'CopyrightLicenseRegionName' => new \PHPExiftool\Driver\Tag\MXF\CopyrightLicenseRegionName(),
                'IntellectualPropertyLicenseRegionName' => new \PHPExiftool\Driver\Tag\MXF\IntellectualPropertyLicenseRegionName(),
                'POSIXMicroseconds' => new \PHPExiftool\Driver\Tag\MXF\POSIXMicroseconds(),
                'EventElapsedTimeToStart' => new \PHPExiftool\Driver\Tag\MXF\EventElapsedTimeToStart(),
                'EventElapsedTimeToEnd' => new \PHPExiftool\Driver\Tag\MXF\EventElapsedTimeToEnd(),
                'OrganizationIDKind' => new \PHPExiftool\Driver\Tag\MXF\OrganizationIDKind(),
                'SMPTEUL' => new \PHPExiftool\Driver\Tag\MXF\SMPTEUL(),
                'EssenceContainerArray' => new \PHPExiftool\Driver\Tag\MXF\EssenceContainerArray(),
                'EssenceStreamID' => new \PHPExiftool\Driver\Tag\MXF\EssenceStreamID(),
                'IndexStreamID' => new \PHPExiftool\Driver\Tag\MXF\IndexStreamID(),
                'WorkingTitle' => new \PHPExiftool\Driver\Tag\MXF\WorkingTitle(),
                'OriginalTitle' => new \PHPExiftool\Driver\Tag\MXF\OriginalTitle(),
                'ClipNumber' => new \PHPExiftool\Driver\Tag\MXF\ClipNumber(),
                'DescriptiveMetadataTrackIDs' => new \PHPExiftool\Driver\Tag\MXF\DescriptiveMetadataTrackIDs(),
                'IdentifierKind' => new \PHPExiftool\Driver\Tag\MXF\IdentifierKind(),
                'IdentifierValue' => new \PHPExiftool\Driver\Tag\MXF\IdentifierValue(),
                'OrganizationCode' => new \PHPExiftool\Driver\Tag\MXF\OrganizationCode(),
                'SupplierIdentificationKind' => new \PHPExiftool\Driver\Tag\MXF\SupplierIdentificationKind(),
                'SupplierIdentificationValue' => new \PHPExiftool\Driver\Tag\MXF\SupplierIdentificationValue(),
                'SupplierAccountNumber' => new \PHPExiftool\Driver\Tag\MXF\SupplierAccountNumber(),
                'SupplierAccountName' => new \PHPExiftool\Driver\Tag\MXF\SupplierAccountName(),
                'EpisodeStartNumber' => new \PHPExiftool\Driver\Tag\MXF\EpisodeStartNumber(),
                'EpisodeEndNumber' => new \PHPExiftool\Driver\Tag\MXF\EpisodeEndNumber(),
                'PurchaserIdentificationKind' => new \PHPExiftool\Driver\Tag\MXF\PurchaserIdentificationKind(),
                'PurchaserIdentificationValue' => new \PHPExiftool\Driver\Tag\MXF\PurchaserIdentificationValue(),
                'PurchaserAccountNumber' => new \PHPExiftool\Driver\Tag\MXF\PurchaserAccountNumber(),
                'PurchaserAccountName' => new \PHPExiftool\Driver\Tag\MXF\PurchaserAccountName(),
                'TotalCurrencyAmount' => new \PHPExiftool\Driver\Tag\MXF\TotalCurrencyAmount(),
                'InstallmentNumber' => new \PHPExiftool\Driver\Tag\MXF\InstallmentNumber(),
                'IdentifierIssuingAuthority' => new \PHPExiftool\Driver\Tag\MXF\IdentifierIssuingAuthority(),
                'PublishingOrganizationName' => new \PHPExiftool\Driver\Tag\MXF\PublishingOrganizationName(),
                'PublishingServiceName' => new \PHPExiftool\Driver\Tag\MXF\PublishingServiceName(),
                'PublishingMediumName' => new \PHPExiftool\Driver\Tag\MXF\PublishingMediumName(),
                'PublishingRegionName' => new \PHPExiftool\Driver\Tag\MXF\PublishingRegionName(),
                'OtherGivenNames' => new \PHPExiftool\Driver\Tag\MXF\OtherGivenNames(),
                'AlternateName' => new \PHPExiftool\Driver\Tag\MXF\AlternateName(),
                'ISO639TextLanguageCode' => new \PHPExiftool\Driver\Tag\MXF\ISO639TextLanguageCode(),
                'ISO639CaptionsLanguageCode' => new \PHPExiftool\Driver\Tag\MXF\ISO639CaptionsLanguageCode(),
                'PrimarySpokenLanguageCode' => new \PHPExiftool\Driver\Tag\MXF\PrimarySpokenLanguageCode(),
                'SecondarySpokenLanguageCode' => new \PHPExiftool\Driver\Tag\MXF\SecondarySpokenLanguageCode(),
                'PrimaryOriginalLanguageCode' => new \PHPExiftool\Driver\Tag\MXF\PrimaryOriginalLanguageCode(),
                'SecondaryOriginalLanguageCode' => new \PHPExiftool\Driver\Tag\MXF\SecondaryOriginalLanguageCode(),
                'MajorVersion' => new \PHPExiftool\Driver\Tag\MXF\MajorVersion(),
                'MinorVersion' => new \PHPExiftool\Driver\Tag\MXF\MinorVersion(),
                'SectorSize' => new \PHPExiftool\Driver\Tag\MXF\SectorSize(),
                'ElementLength' => new \PHPExiftool\Driver\Tag\MXF\ElementLength(),
                'KeypointKind' => new \PHPExiftool\Driver\Tag\MXF\KeypointKind(),
                'KeypointValue' => new \PHPExiftool\Driver\Tag\MXF\KeypointValue(),
                'AwardName' => new \PHPExiftool\Driver\Tag\MXF\AwardName(),
                'AwardCategory' => new \PHPExiftool\Driver\Tag\MXF\AwardCategory(),
                'SlateInformation' => new \PHPExiftool\Driver\Tag\MXF\SlateInformation(),
                'LockedIndicator' => new \PHPExiftool\Driver\Tag\MXF\LockedIndicator(),
                'BitsPerAudioSample' => new \PHPExiftool\Driver\Tag\MXF\BitsPerAudioSample(),
                'CaptionKind' => new \PHPExiftool\Driver\Tag\MXF\CaptionKind(),
                'SliceCount' => new \PHPExiftool\Driver\Tag\MXF\SliceCount(),
                'SliceNumber' => new \PHPExiftool\Driver\Tag\MXF\SliceNumber(),
                'ElementDelta' => new \PHPExiftool\Driver\Tag\MXF\ElementDelta(),
                'PositionTableIndexing' => new \PHPExiftool\Driver\Tag\MXF\PositionTableIndexing(),
                'SliceOffsetList' => new \PHPExiftool\Driver\Tag\MXF\SliceOffsetList(),
                'PosTableArray' => new \PHPExiftool\Driver\Tag\MXF\PosTableArray(),
                'StreamOffset' => new \PHPExiftool\Driver\Tag\MXF\StreamOffset(),
                'EditUnitFlags' => new \PHPExiftool\Driver\Tag\MXF\EditUnitFlags(),
                'TemporalOffset' => new \PHPExiftool\Driver\Tag\MXF\TemporalOffset(),
                'AnchorOffset' => new \PHPExiftool\Driver\Tag\MXF\AnchorOffset(),
                'EditUnitLength' => new \PHPExiftool\Driver\Tag\MXF\EditUnitLength(),
                'HeaderByteCount' => new \PHPExiftool\Driver\Tag\MXF\HeaderByteCount(),
                'IndexByteCount' => new \PHPExiftool\Driver\Tag\MXF\IndexByteCount(),
                'PackLength' => new \PHPExiftool\Driver\Tag\MXF\PackLength(),
                'PrimaryPackage' => new \PHPExiftool\Driver\Tag\MXF\PrimaryPackage(),
                'DescriptiveMetadataSets' => new \PHPExiftool\Driver\Tag\MXF\DescriptiveMetadataSets(),
                'DescriptiveMetadataSetReferences' => new \PHPExiftool\Driver\Tag\MXF\DescriptiveMetadataSetReferences(),
                'FileDescriptors' => new \PHPExiftool\Driver\Tag\MXF\FileDescriptors(),
                'OffsetToMetadata' => new \PHPExiftool\Driver\Tag\MXF\OffsetToMetadata(),
                'OffsetToIndexTable' => new \PHPExiftool\Driver\Tag\MXF\OffsetToIndexTable(),
                'ByteOffset' => new \PHPExiftool\Driver\Tag\MXF\ByteOffset(),
                'ReversePlay' => new \PHPExiftool\Driver\Tag\MXF\ReversePlay(),
                'FirstNumberInSequence' => new \PHPExiftool\Driver\Tag\MXF\FirstNumberInSequence(),
                'PreviousNumberInSequence' => new \PHPExiftool\Driver\Tag\MXF\PreviousNumberInSequence(),
                'CurrentNumberInSequence' => new \PHPExiftool\Driver\Tag\MXF\CurrentNumberInSequence(),
                'NextNumberInSequence' => new \PHPExiftool\Driver\Tag\MXF\NextNumberInSequence(),
                'LastNumberInSequence' => new \PHPExiftool\Driver\Tag\MXF\LastNumberInSequence(),
                'CentralTelephoneNumber' => new \PHPExiftool\Driver\Tag\MXF\CentralTelephoneNumber(),
                'MobileTelephoneNumber' => new \PHPExiftool\Driver\Tag\MXF\MobileTelephoneNumber(),
                'LocationDescription' => new \PHPExiftool\Driver\Tag\MXF\LocationDescription(),
                'LocationKind' => new \PHPExiftool\Driver\Tag\MXF\LocationKind(),
                'KeyTimePoint' => new \PHPExiftool\Driver\Tag\MXF\KeyTimePoint(),
                'SettingDateTime' => new \PHPExiftool\Driver\Tag\MXF\SettingDateTime(),
                'ContractDateTime' => new \PHPExiftool\Driver\Tag\MXF\ContractDateTime(),
                'RightsStartDateTime' => new \PHPExiftool\Driver\Tag\MXF\RightsStartDateTime(),
                'RightsStopDateTime' => new \PHPExiftool\Driver\Tag\MXF\RightsStopDateTime(),
                'PaymentDueDateTime' => new \PHPExiftool\Driver\Tag\MXF\PaymentDueDateTime(),
                'ClipID' => new \PHPExiftool\Driver\Tag\MXF\ClipID(),
                'DeviceAssetNumber' => new \PHPExiftool\Driver\Tag\MXF\DeviceAssetNumber(),
                'IdentificationUL' => new \PHPExiftool\Driver\Tag\MXF\IdentificationUL(),
                'OperationalPatternUL' => new \PHPExiftool\Driver\Tag\MXF\OperationalPatternUL(),
                'EssenceContainers' => new \PHPExiftool\Driver\Tag\MXF\EssenceContainers(),
                'DescriptiveMetadataSchemes' => new \PHPExiftool\Driver\Tag\MXF\DescriptiveMetadataSchemes(),
                'ProjectName' => new \PHPExiftool\Driver\Tag\MXF\ProjectName(),
                'LocalTagValue' => new \PHPExiftool\Driver\Tag\MXF\LocalTagValue(),
                'LocalTagUniqueID' => new \PHPExiftool\Driver\Tag\MXF\LocalTagUniqueID(),
                'BrandMainTitle' => new \PHPExiftool\Driver\Tag\MXF\BrandMainTitle(),
                'BrandOriginalTitle' => new \PHPExiftool\Driver\Tag\MXF\BrandOriginalTitle(),
                'FrameworkTitle' => new \PHPExiftool\Driver\Tag\MXF\FrameworkTitle(),
                'SourceTrackIDs' => new \PHPExiftool\Driver\Tag\MXF\SourceTrackIDs(),
                'ShotTrackIDs' => new \PHPExiftool\Driver\Tag\MXF\ShotTrackIDs(),
                'ProgrammingGroupTitle' => new \PHPExiftool\Driver\Tag\MXF\ProgrammingGroupTitle(),
                'LinkingName' => new \PHPExiftool\Driver\Tag\MXF\LinkingName(),
                'NameSuffix' => new \PHPExiftool\Driver\Tag\MXF\NameSuffix(),
                'FormerFamilyName' => new \PHPExiftool\Driver\Tag\MXF\FormerFamilyName(),
                'Nationality' => new \PHPExiftool\Driver\Tag\MXF\Nationality(),
                'Citizenship' => new \PHPExiftool\Driver\Tag\MXF\Citizenship(),
                'FrameworkTextLanguageCode' => new \PHPExiftool\Driver\Tag\MXF\FrameworkTextLanguageCode(),
                'KAGSize' => new \PHPExiftool\Driver\Tag\MXF\KAGSize(),
                'ReversedByteOrder' => new \PHPExiftool\Driver\Tag\MXF\ReversedByteOrder(),
                'ItemName' => new \PHPExiftool\Driver\Tag\MXF\ItemName(),
                'ItemValue' => new \PHPExiftool\Driver\Tag\MXF\ItemValue(),
                'XMLDocumentText' => new \PHPExiftool\Driver\Tag\MXF\XMLDocumentText(),
                'FrameworkThesaurusName' => new \PHPExiftool\Driver\Tag\MXF\FrameworkThesaurusName(),
                'GroupSynopsis' => new \PHPExiftool\Driver\Tag\MXF\GroupSynopsis(),
                'AnnotationSynopsis' => new \PHPExiftool\Driver\Tag\MXF\AnnotationSynopsis(),
                'AnnotationDescription' => new \PHPExiftool\Driver\Tag\MXF\AnnotationDescription(),
                'ScriptingKind' => new \PHPExiftool\Driver\Tag\MXF\ScriptingKind(),
                'ScriptingText' => new \PHPExiftool\Driver\Tag\MXF\ScriptingText(),
                'ShotDescription' => new \PHPExiftool\Driver\Tag\MXF\ShotDescription(),
                'AnnotationKind' => new \PHPExiftool\Driver\Tag\MXF\AnnotationKind(),
                'RelatedMaterialDescription' => new \PHPExiftool\Driver\Tag\MXF\RelatedMaterialDescription(),
                'ClipKind' => new \PHPExiftool\Driver\Tag\MXF\ClipKind(),
                'DeviceUsageDescription' => new \PHPExiftool\Driver\Tag\MXF\DeviceUsageDescription(),
                'DisplayF2Offset' => new \PHPExiftool\Driver\Tag\MXF\DisplayF2Offset(),
                'StoredF2Offset' => new \PHPExiftool\Driver\Tag\MXF\StoredF2Offset(),
                'ActiveFormatDescriptor' => new \PHPExiftool\Driver\Tag\MXF\ActiveFormatDescriptor(),
                'LineNumber' => new \PHPExiftool\Driver\Tag\MXF\LineNumber(),
                'ScanningDirection' => new \PHPExiftool\Driver\Tag\MXF\ScanningDirection(),
                'ComponentMaximumRef' => new \PHPExiftool\Driver\Tag\MXF\ComponentMaximumRef(),
                'ComponentMinimumRef' => new \PHPExiftool\Driver\Tag\MXF\ComponentMinimumRef(),
                'AlphaMaximumRef' => new \PHPExiftool\Driver\Tag\MXF\AlphaMaximumRef(),
                'AlphaMinimumRef' => new \PHPExiftool\Driver\Tag\MXF\AlphaMinimumRef(),
                'VideoPayloadIdentifier' => new \PHPExiftool\Driver\Tag\MXF\VideoPayloadIdentifier(),
                'VideoPayloadIdentifier2002' => new \PHPExiftool\Driver\Tag\MXF\VideoPayloadIdentifier2002(),
                'SingleSequenceFlag' => new \PHPExiftool\Driver\Tag\MXF\SingleSequenceFlag(),
                'ConstantBPictureFlag' => new \PHPExiftool\Driver\Tag\MXF\ConstantBPictureFlag(),
                'CodedContentScanningKind' => new \PHPExiftool\Driver\Tag\MXF\CodedContentScanningKind(),
                'LowDelayIndicator' => new \PHPExiftool\Driver\Tag\MXF\LowDelayIndicator(),
                'ClosedGOPIndicator' => new \PHPExiftool\Driver\Tag\MXF\ClosedGOPIndicator(),
                'IdenticalGOPIndicator' => new \PHPExiftool\Driver\Tag\MXF\IdenticalGOPIndicator(),
                'MaximumGOPSize' => new \PHPExiftool\Driver\Tag\MXF\MaximumGOPSize(),
                'MaximumBPictureCount' => new \PHPExiftool\Driver\Tag\MXF\MaximumBPictureCount(),
                'ProfileAndLevel' => new \PHPExiftool\Driver\Tag\MXF\ProfileAndLevel(),
                'Bitrate' => new \PHPExiftool\Driver\Tag\MXF\Bitrate(),
                'ChannelCount' => new \PHPExiftool\Driver\Tag\MXF\ChannelCount(),
                'PeakEnvelope' => new \PHPExiftool\Driver\Tag\MXF\PeakEnvelope(),
                'PeakEnvelopeData' => new \PHPExiftool\Driver\Tag\MXF\PeakEnvelopeData(),
                'BlockAlign' => new \PHPExiftool\Driver\Tag\MXF\BlockAlign(),
                'SequenceOffset' => new \PHPExiftool\Driver\Tag\MXF\SequenceOffset(),
                'BlockStartOffset' => new \PHPExiftool\Driver\Tag\MXF\BlockStartOffset(),
                'FileSecurityReport' => new \PHPExiftool\Driver\Tag\MXF\FileSecurityReport(),
                'FileSecurityWave' => new \PHPExiftool\Driver\Tag\MXF\FileSecurityWave(),
                'AverageBytesPerSecond' => new \PHPExiftool\Driver\Tag\MXF\AverageBytesPerSecond(),
                'AuxiliaryBitsMode' => new \PHPExiftool\Driver\Tag\MXF\AuxiliaryBitsMode(),
                'ChannelStatusMode' => new \PHPExiftool\Driver\Tag\MXF\ChannelStatusMode(),
                'FixedChannelStatusData' => new \PHPExiftool\Driver\Tag\MXF\FixedChannelStatusData(),
                'UserDataMode' => new \PHPExiftool\Driver\Tag\MXF\UserDataMode(),
                'FixedUserData' => new \PHPExiftool\Driver\Tag\MXF\FixedUserData(),
                'Emphasis' => new \PHPExiftool\Driver\Tag\MXF\Emphasis(),
                'BextCodingHistory' => new \PHPExiftool\Driver\Tag\MXF\BextCodingHistory(),
                'QltyBasicData' => new \PHPExiftool\Driver\Tag\MXF\QltyBasicData(),
                'QltyStartOfModulation' => new \PHPExiftool\Driver\Tag\MXF\QltyStartOfModulation(),
                'QltyQualityEvent' => new \PHPExiftool\Driver\Tag\MXF\QltyQualityEvent(),
                'QltyEndOfModulation' => new \PHPExiftool\Driver\Tag\MXF\QltyEndOfModulation(),
                'QltyQualityParameter' => new \PHPExiftool\Driver\Tag\MXF\QltyQualityParameter(),
                'QltyOperatorComment' => new \PHPExiftool\Driver\Tag\MXF\QltyOperatorComment(),
                'QltyCueSheet' => new \PHPExiftool\Driver\Tag\MXF\QltyCueSheet(),
                'DialNorm' => new \PHPExiftool\Driver\Tag\MXF\DialNorm(),
                'DataEssenceCoding' => new \PHPExiftool\Driver\Tag\MXF\DataEssenceCoding(),
                'DateTimeRate' => new \PHPExiftool\Driver\Tag\MXF\DateTimeRate(),
                'DateTimeDropFrameFlag' => new \PHPExiftool\Driver\Tag\MXF\DateTimeDropFrameFlag(),
                'DateTimeEmbeddedFlag' => new \PHPExiftool\Driver\Tag\MXF\DateTimeEmbeddedFlag(),
                'DateTimeKind' => new \PHPExiftool\Driver\Tag\MXF\DateTimeKind(),
                'DeltaEntryArray' => new \PHPExiftool\Driver\Tag\MXF\DeltaEntryArray(),
                'PositionTableCount' => new \PHPExiftool\Driver\Tag\MXF\PositionTableCount(),
                'PositionTable' => new \PHPExiftool\Driver\Tag\MXF\PositionTable(),
                'IndexEntryArray' => new \PHPExiftool\Driver\Tag\MXF\IndexEntryArray(),
                'DataDefinition' => new \PHPExiftool\Driver\Tag\MXF\DataDefinition(),
                'GenerationCopyNumber' => new \PHPExiftool\Driver\Tag\MXF\GenerationCopyNumber(),
                'GenerationCloneNumber' => new \PHPExiftool\Driver\Tag\MXF\GenerationCloneNumber(),
                'ThemeMusicFlag' => new \PHPExiftool\Driver\Tag\MXF\ThemeMusicFlag(),
                'InsertMusicFlag' => new \PHPExiftool\Driver\Tag\MXF\InsertMusicFlag(),
                'IndexEditRate' => new \PHPExiftool\Driver\Tag\MXF\IndexEditRate(),
                'LinkedTrackID' => new \PHPExiftool\Driver\Tag\MXF\LinkedTrackID(),
                'DescriptiveMetadataFramework' => new \PHPExiftool\Driver\Tag\MXF\DescriptiveMetadataFramework(),
                'GroupSet' => new \PHPExiftool\Driver\Tag\MXF\GroupSet(),
                'BankDetailsSet' => new \PHPExiftool\Driver\Tag\MXF\BankDetailsSet(),
                'ImageFormatSet' => new \PHPExiftool\Driver\Tag\MXF\ImageFormatSet(),
                'ProcessingSet' => new \PHPExiftool\Driver\Tag\MXF\ProcessingSet(),
                'ProjectSet' => new \PHPExiftool\Driver\Tag\MXF\ProjectSet(),
                'ContactsListSet' => new \PHPExiftool\Driver\Tag\MXF\ContactsListSet(),
                'AnnotationCueWordsSet' => new \PHPExiftool\Driver\Tag\MXF\AnnotationCueWordsSet(),
                'ShotCueWordsSet' => new \PHPExiftool\Driver\Tag\MXF\ShotCueWordsSet(),
                'AwardParticipantSets' => new \PHPExiftool\Driver\Tag\MXF\AwardParticipantSets(),
                'ContractParticipantSets' => new \PHPExiftool\Driver\Tag\MXF\ContractParticipantSets(),
                'PersonSets' => new \PHPExiftool\Driver\Tag\MXF\PersonSets(),
                'ParticipantOrganizationSets' => new \PHPExiftool\Driver\Tag\MXF\ParticipantOrganizationSets(),
                'PersonOrganizationSets' => new \PHPExiftool\Driver\Tag\MXF\PersonOrganizationSets(),
                'LocationSets' => new \PHPExiftool\Driver\Tag\MXF\LocationSets(),
                'TitlesSets' => new \PHPExiftool\Driver\Tag\MXF\TitlesSets(),
                'GroupSets' => new \PHPExiftool\Driver\Tag\MXF\GroupSets(),
                'IdentificationSets' => new \PHPExiftool\Driver\Tag\MXF\IdentificationSets(),
                'EpisodicItemSets' => new \PHPExiftool\Driver\Tag\MXF\EpisodicItemSets(),
                'BrandingSets' => new \PHPExiftool\Driver\Tag\MXF\BrandingSets(),
                'EventSets' => new \PHPExiftool\Driver\Tag\MXF\EventSets(),
                'PublicationSets' => new \PHPExiftool\Driver\Tag\MXF\PublicationSets(),
                'AwardSets' => new \PHPExiftool\Driver\Tag\MXF\AwardSets(),
                'CaptionDescriptionSets' => new \PHPExiftool\Driver\Tag\MXF\CaptionDescriptionSets(),
                'AnnotationSets' => new \PHPExiftool\Driver\Tag\MXF\AnnotationSets(),
                'ProductionSettingPeriodSets' => new \PHPExiftool\Driver\Tag\MXF\ProductionSettingPeriodSets(),
                'SceneSettingPeriodSets' => new \PHPExiftool\Driver\Tag\MXF\SceneSettingPeriodSets(),
                'ScriptingSets' => new \PHPExiftool\Driver\Tag\MXF\ScriptingSets(),
                'ClassificationSets' => new \PHPExiftool\Driver\Tag\MXF\ClassificationSets(),
                'SceneShotSets' => new \PHPExiftool\Driver\Tag\MXF\SceneShotSets(),
                'ClipShotSets' => new \PHPExiftool\Driver\Tag\MXF\ClipShotSets(),
                'KeyPointSets' => new \PHPExiftool\Driver\Tag\MXF\KeyPointSets(),
                'ShotParticipantRoleSets' => new \PHPExiftool\Driver\Tag\MXF\ShotParticipantRoleSets(),
                'ShotPersonSets' => new \PHPExiftool\Driver\Tag\MXF\ShotPersonSets(),
                'OrganizationSets' => new \PHPExiftool\Driver\Tag\MXF\OrganizationSets(),
                'ShotLocationSets' => new \PHPExiftool\Driver\Tag\MXF\ShotLocationSets(),
                'AddressSets' => new \PHPExiftool\Driver\Tag\MXF\AddressSets(),
                'CommunicationSets' => new \PHPExiftool\Driver\Tag\MXF\CommunicationSets(),
                'ContractSets' => new \PHPExiftool\Driver\Tag\MXF\ContractSets(),
                'RightsSets' => new \PHPExiftool\Driver\Tag\MXF\RightsSets(),
                'PaymentsSets' => new \PHPExiftool\Driver\Tag\MXF\PaymentsSets(),
                'DeviceParametersSets' => new \PHPExiftool\Driver\Tag\MXF\DeviceParametersSets(),
                'ClassificationNameValueSets' => new \PHPExiftool\Driver\Tag\MXF\ClassificationNameValueSets(),
                'ContactNameValueSets' => new \PHPExiftool\Driver\Tag\MXF\ContactNameValueSets(),
                'DeviceParameterNameValueSets' => new \PHPExiftool\Driver\Tag\MXF\DeviceParameterNameValueSets(),
                'MetadataServerLocators' => new \PHPExiftool\Driver\Tag\MXF\MetadataServerLocators(),
                'RelatedMaterialLocators' => new \PHPExiftool\Driver\Tag\MXF\RelatedMaterialLocators(),
                'LocalTagEntries' => new \PHPExiftool\Driver\Tag\MXF\LocalTagEntries(),
                'TotalNumberInSequence' => new \PHPExiftool\Driver\Tag\MXF\TotalNumberInSequence(),
                'RoomOrSuiteName' => new \PHPExiftool\Driver\Tag\MXF\RoomOrSuiteName(),
                'BuildingName' => new \PHPExiftool\Driver\Tag\MXF\BuildingName(),
                'LocalFestivalDateTime' => new \PHPExiftool\Driver\Tag\MXF\LocalFestivalDateTime(),
                'ShotStartPosition' => new \PHPExiftool\Driver\Tag\MXF\ShotStartPosition(),
                'IndexingStartPosition' => new \PHPExiftool\Driver\Tag\MXF\IndexingStartPosition(),
                'EventOrigin' => new \PHPExiftool\Driver\Tag\MXF\EventOrigin(),
                'SettingPeriodDescription' => new \PHPExiftool\Driver\Tag\MXF\SettingPeriodDescription(),
                'IndexDuration' => new \PHPExiftool\Driver\Tag\MXF\IndexDuration(),
                'ShotDuration' => new \PHPExiftool\Driver\Tag\MXF\ShotDuration(),
                'ExtendedClipID' => new \PHPExiftool\Driver\Tag\MXF\ExtendedClipID(),
                'ClipIDArray' => new \PHPExiftool\Driver\Tag\MXF\ClipIDArray(),
                'ExtendedClipIDArray' => new \PHPExiftool\Driver\Tag\MXF\ExtendedClipIDArray(),
                'TrackNumberBatch' => new \PHPExiftool\Driver\Tag\MXF\TrackNumberBatch(),
                'ExtendedTextLanguageCode' => new \PHPExiftool\Driver\Tag\MXF\ExtendedTextLanguageCode(),
                'ExtendedCaptionsLanguageCode' => new \PHPExiftool\Driver\Tag\MXF\ExtendedCaptionsLanguageCode(),
                'FrameworkExtendedTextLanguageCode' => new \PHPExiftool\Driver\Tag\MXF\FrameworkExtendedTextLanguageCode(),
                'PrimaryExtendedSpokenLanguageCode' => new \PHPExiftool\Driver\Tag\MXF\PrimaryExtendedSpokenLanguageCode(),
                'SecondaryExtendedSpokenLanguageCode' => new \PHPExiftool\Driver\Tag\MXF\SecondaryExtendedSpokenLanguageCode(),
                'OriginalExtendedSpokenPrimaryLanguageCode' => new \PHPExiftool\Driver\Tag\MXF\OriginalExtendedSpokenPrimaryLanguageCode(),
                'SecondaryOriginalExtendedSpokenLanguageCode' => new \PHPExiftool\Driver\Tag\MXF\SecondaryOriginalExtendedSpokenLanguageCode(),
                'KLVMetadataSequence' => new \PHPExiftool\Driver\Tag\MXF\KLVMetadataSequence(),
                'PackageAttributes' => new \PHPExiftool\Driver\Tag\MXF\PackageAttributes(),
                'ComponentAttributes' => new \PHPExiftool\Driver\Tag\MXF\ComponentAttributes(),
                'MPEG7BiMDecoderInitFrame1' => new \PHPExiftool\Driver\Tag\MXF\MPEG7BiMDecoderInitFrame1(),
                'MPEG7BiMDecoderInitFrame2' => new \PHPExiftool\Driver\Tag\MXF\MPEG7BiMDecoderInitFrame2(),
                'MPEG7BiMDecoderInitFrame3' => new \PHPExiftool\Driver\Tag\MXF\MPEG7BiMDecoderInitFrame3(),
                'MPEG7BiMDecoderInitFrame4' => new \PHPExiftool\Driver\Tag\MXF\MPEG7BiMDecoderInitFrame4(),
                'MPEG7BiMDecoderInitFrame5' => new \PHPExiftool\Driver\Tag\MXF\MPEG7BiMDecoderInitFrame5(),
                'MPEG7BiMDecoderInitFrame6' => new \PHPExiftool\Driver\Tag\MXF\MPEG7BiMDecoderInitFrame6(),
                'MPEG7BiMDecoderInitFrame7' => new \PHPExiftool\Driver\Tag\MXF\MPEG7BiMDecoderInitFrame7(),
                'MPEG7BiMDecoderInitFrame8' => new \PHPExiftool\Driver\Tag\MXF\MPEG7BiMDecoderInitFrame8(),
                'MPEG7BiMAccessUnitFrame1' => new \PHPExiftool\Driver\Tag\MXF\MPEG7BiMAccessUnitFrame1(),
                'MPEG7BiMAccessUnitFrame2' => new \PHPExiftool\Driver\Tag\MXF\MPEG7BiMAccessUnitFrame2(),
                'MPEG7BiMAccessUnitFrame3' => new \PHPExiftool\Driver\Tag\MXF\MPEG7BiMAccessUnitFrame3(),
                'MPEG7BiMAccessUnitFrame4' => new \PHPExiftool\Driver\Tag\MXF\MPEG7BiMAccessUnitFrame4(),
                'MPEG7BiMAccessUnitFrame5' => new \PHPExiftool\Driver\Tag\MXF\MPEG7BiMAccessUnitFrame5(),
                'MPEG7BiMAccessUnitFrame6' => new \PHPExiftool\Driver\Tag\MXF\MPEG7BiMAccessUnitFrame6(),
                'MPEG7BiMAccessUnitFrame7' => new \PHPExiftool\Driver\Tag\MXF\MPEG7BiMAccessUnitFrame7(),
                'MPEG7BiMAccessUnitFrame8' => new \PHPExiftool\Driver\Tag\MXF\MPEG7BiMAccessUnitFrame8(),
                'ComponentUserComments' => new \PHPExiftool\Driver\Tag\MXF\ComponentUserComments(),
                'SensorMode' => new \PHPExiftool\Driver\Tag\MXF\SensorMode(),
                'ChannelAssignment' => new \PHPExiftool\Driver\Tag\MXF\ChannelAssignment(),
                'ContentPackageIndexArray' => new \PHPExiftool\Driver\Tag\MXF\ContentPackageIndexArray(),
                'VideoIndexArray' => new \PHPExiftool\Driver\Tag\MXF\VideoIndexArray(),
                'ApproximateImageContainerSize' => new \PHPExiftool\Driver\Tag\MXF\ApproximateImageContainerSize(),
                'MetadataEncodingSchemeCode' => new \PHPExiftool\Driver\Tag\MXF\MetadataEncodingSchemeCode(),
                'MIMEMediaType' => new \PHPExiftool\Driver\Tag\MXF\MIMEMediaType(),
                'FieldOfViewVerticalFP' => new \PHPExiftool\Driver\Tag\MXF\FieldOfViewVerticalFP(),
                'PackageUsageKind' => new \PHPExiftool\Driver\Tag\MXF\PackageUsageKind(),
                'ChannelID' => new \PHPExiftool\Driver\Tag\MXF\ChannelID(),
                'ChannelIDs' => new \PHPExiftool\Driver\Tag\MXF\ChannelIDs(),
                'KLVDataType' => new \PHPExiftool\Driver\Tag\MXF\KLVDataType(),
                'KLVDataParentProperties' => new \PHPExiftool\Driver\Tag\MXF\KLVDataParentProperties(),
                'TaggedValueParentProperties' => new \PHPExiftool\Driver\Tag\MXF\TaggedValueParentProperties(),
                'AnnotationParticipantSets' => new \PHPExiftool\Driver\Tag\MXF\AnnotationParticipantSets(),
                'KLVDataDefinitions' => new \PHPExiftool\Driver\Tag\MXF\KLVDataDefinitions(),
                'TaggedValueDefinitions' => new \PHPExiftool\Driver\Tag\MXF\TaggedValueDefinitions(),
                'AddressNameValueSets' => new \PHPExiftool\Driver\Tag\MXF\AddressNameValueSets(),
                'NMEADocumentText' => new \PHPExiftool\Driver\Tag\MXF\NMEADocumentText(),
                'PlatformRollAngle' => new \PHPExiftool\Driver\Tag\MXF\PlatformRollAngle(),
                'PlatformPitchAngle' => new \PHPExiftool\Driver\Tag\MXF\PlatformPitchAngle(),
                'PlatformHeadingAngle' => new \PHPExiftool\Driver\Tag\MXF\PlatformHeadingAngle(),
                'AddressLine' => new \PHPExiftool\Driver\Tag\MXF\AddressLine(),
                'PlaceName' => new \PHPExiftool\Driver\Tag\MXF\PlaceName(),
                'GeographicalCoordinates' => new \PHPExiftool\Driver\Tag\MXF\GeographicalCoordinates(),
                'AstronomicalBodyName' => new \PHPExiftool\Driver\Tag\MXF\AstronomicalBodyName(),
                'TimecodeArray' => new \PHPExiftool\Driver\Tag\MXF\TimecodeArray(),
                'MarkIn' => new \PHPExiftool\Driver\Tag\MXF\MarkIn(),
                'UserPosition' => new \PHPExiftool\Driver\Tag\MXF\UserPosition(),
                'MarkOut' => new \PHPExiftool\Driver\Tag\MXF\MarkOut(),
                'ClipCreationDateTime' => new \PHPExiftool\Driver\Tag\MXF\ClipCreationDateTime(),
                'VideoClipDuration' => new \PHPExiftool\Driver\Tag\MXF\VideoClipDuration(),
                'ParticipantID' => new \PHPExiftool\Driver\Tag\MXF\ParticipantID(),
                'ContactID' => new \PHPExiftool\Driver\Tag\MXF\ContactID(),
                'DefaultNamespaceURI' => new \PHPExiftool\Driver\Tag\MXF\DefaultNamespaceURI(),
                'NamespaceURI' => new \PHPExiftool\Driver\Tag\MXF\NamespaceURI(),
                'NamespaceURIs' => new \PHPExiftool\Driver\Tag\MXF\NamespaceURIs(),
                'HTMLDOCTYPE' => new \PHPExiftool\Driver\Tag\MXF\HTMLDOCTYPE(),
                'NamespacePrefix' => new \PHPExiftool\Driver\Tag\MXF\NamespacePrefix(),
                'NamespacePrefixes' => new \PHPExiftool\Driver\Tag\MXF\NamespacePrefixes(),
                'RightsComment' => new \PHPExiftool\Driver\Tag\MXF\RightsComment(),
                'NominationCategory' => new \PHPExiftool\Driver\Tag\MXF\NominationCategory(),
                'PeakEnvelopeVersion' => new \PHPExiftool\Driver\Tag\MXF\PeakEnvelopeVersion(),
                'PeakEnvelopeFormat' => new \PHPExiftool\Driver\Tag\MXF\PeakEnvelopeFormat(),
                'PointsPerPeakValue' => new \PHPExiftool\Driver\Tag\MXF\PointsPerPeakValue(),
                'PeakEnvelopeBlockSize' => new \PHPExiftool\Driver\Tag\MXF\PeakEnvelopeBlockSize(),
                'PeakChannelCount' => new \PHPExiftool\Driver\Tag\MXF\PeakChannelCount(),
                'PeakFrameCount' => new \PHPExiftool\Driver\Tag\MXF\PeakFrameCount(),
                'PeakOfPeaksPosition' => new \PHPExiftool\Driver\Tag\MXF\PeakOfPeaksPosition(),
                'PeakEnvelopeTimestamp' => new \PHPExiftool\Driver\Tag\MXF\PeakEnvelopeTimestamp(),
                'RIFFChunkID' => new \PHPExiftool\Driver\Tag\MXF\RIFFChunkID(),
                'RIFFChunkLength' => new \PHPExiftool\Driver\Tag\MXF\RIFFChunkLength(),
                'RIFFChunkData' => new \PHPExiftool\Driver\Tag\MXF\RIFFChunkData(),
                'MIMECharSet' => new \PHPExiftool\Driver\Tag\MXF\MIMECharSet(),
                'MIMEEncoding' => new \PHPExiftool\Driver\Tag\MXF\MIMEEncoding(),
                'MonoSourceTrackIDs' => new \PHPExiftool\Driver\Tag\MXF\MonoSourceTrackIDs(),
                'CompositionRendering' => new \PHPExiftool\Driver\Tag\MXF\CompositionRendering(),
                'CaptionsDescriptionParticipantSets' => new \PHPExiftool\Driver\Tag\MXF\CaptionsDescriptionParticipantSets(),
                'EventAnnotationSets' => new \PHPExiftool\Driver\Tag\MXF\EventAnnotationSets(),
                'ScriptingLocators' => new \PHPExiftool\Driver\Tag\MXF\ScriptingLocators(),
                'UnknownBWFChunks' => new \PHPExiftool\Driver\Tag\MXF\UnknownBWFChunks(),
                'CryptographicContextID' => new \PHPExiftool\Driver\Tag\MXF\CryptographicContextID(),
                'NITFLayerTargetID' => new \PHPExiftool\Driver\Tag\MXF\NITFLayerTargetID(),
                'RP217DataStreamPID' => new \PHPExiftool\Driver\Tag\MXF\RP217DataStreamPID(),
                'RP217VideoStreamPID' => new \PHPExiftool\Driver\Tag\MXF\RP217VideoStreamPID(),
                'CipherAlgorithm' => new \PHPExiftool\Driver\Tag\MXF\CipherAlgorithm(),
                'CryptographicKeyID' => new \PHPExiftool\Driver\Tag\MXF\CryptographicKeyID(),
                'EncryptedSourceValue' => new \PHPExiftool\Driver\Tag\MXF\EncryptedSourceValue(),
                'MICAlgorithm' => new \PHPExiftool\Driver\Tag\MXF\MICAlgorithm(),
                'MIC' => new \PHPExiftool\Driver\Tag\MXF\MIC(),
                'JFIFMarkerDescription' => new \PHPExiftool\Driver\Tag\MXF\JFIFMarkerDescription(),
                'HTMLMetaDescription' => new \PHPExiftool\Driver\Tag\MXF\HTMLMetaDescription(),
                'ColorPrimaries' => new \PHPExiftool\Driver\Tag\MXF\ColorPrimaries(),
                'ProductFormat' => new \PHPExiftool\Driver\Tag\MXF\ProductFormat(),
                'SourceLength' => new \PHPExiftool\Driver\Tag\MXF\SourceLength(),
                'SourceContainerFormat' => new \PHPExiftool\Driver\Tag\MXF\SourceContainerFormat(),
                'SourceKey' => new \PHPExiftool\Driver\Tag\MXF\SourceKey(),
                'DynamicSourcePackageID' => new \PHPExiftool\Driver\Tag\MXF\DynamicSourcePackageID(),
                'DynamicSourceTrackIDs' => new \PHPExiftool\Driver\Tag\MXF\DynamicSourceTrackIDs(),
                'SourceIndex' => new \PHPExiftool\Driver\Tag\MXF\SourceIndex(),
                'SourceSpecies' => new \PHPExiftool\Driver\Tag\MXF\SourceSpecies(),
                'SourceValue' => new \PHPExiftool\Driver\Tag\MXF\SourceValue(),
                'CryptographicContextObject' => new \PHPExiftool\Driver\Tag\MXF\CryptographicContextObject(),
                'mixed' => new \PHPExiftool\Driver\Tag\MXF\SubDescriptors(),
                'EncryptedTrackFileID' => new \PHPExiftool\Driver\Tag\MXF\EncryptedTrackFileID(),
                'CryptographicContextLink' => new \PHPExiftool\Driver\Tag\MXF\CryptographicContextLink(),
                'PlaintextOffset' => new \PHPExiftool\Driver\Tag\MXF\PlaintextOffset(),
                'TripletSequenceNumber' => new \PHPExiftool\Driver\Tag\MXF\TripletSequenceNumber(),
                'BoundingRectangle' => new \PHPExiftool\Driver\Tag\MXF\BoundingRectangle(),
                'GeographicLocation' => new \PHPExiftool\Driver\Tag\MXF\GeographicLocation(),
                'GeographicPolygonCoordinates' => new \PHPExiftool\Driver\Tag\MXF\GeographicPolygonCoordinates(),
                'GeographicAreaNorthwest' => new \PHPExiftool\Driver\Tag\MXF\GeographicAreaNorthwest(),
                'GeographicAreaSoutheast' => new \PHPExiftool\Driver\Tag\MXF\GeographicAreaSoutheast(),
                'GeographicAreaSourceDatum' => new \PHPExiftool\Driver\Tag\MXF\GeographicAreaSourceDatum(),
                'GeographicPolygonSourceDatum' => new \PHPExiftool\Driver\Tag\MXF\GeographicPolygonSourceDatum(),
                'ClassifyingCountryCode' => new \PHPExiftool\Driver\Tag\MXF\ClassifyingCountryCode(),
                'UTCInstantDateTime' => new \PHPExiftool\Driver\Tag\MXF\UTCInstantDateTime(),
                'ToleranceMode' => new \PHPExiftool\Driver\Tag\MXF\ToleranceMode(),
                'ToleranceWindow' => new \PHPExiftool\Driver\Tag\MXF\ToleranceWindow(),
                'ToleranceInterpolationMethod' => new \PHPExiftool\Driver\Tag\MXF\ToleranceInterpolationMethod(),
                'VBILineCount' => new \PHPExiftool\Driver\Tag\MXF\VBILineCount(),
                'StoredVBILineNumber' => new \PHPExiftool\Driver\Tag\MXF\StoredVBILineNumber(),
                'VBIWrappingType' => new \PHPExiftool\Driver\Tag\MXF\VBIWrappingType(),
                'VBIPayloadSampleCount' => new \PHPExiftool\Driver\Tag\MXF\VBIPayloadSampleCount(),
                'VBIPayloadByteArray' => new \PHPExiftool\Driver\Tag\MXF\VBIPayloadByteArray(),
                'ANCPacketCount' => new \PHPExiftool\Driver\Tag\MXF\ANCPacketCount(),
                'StoredANCLineNumber' => new \PHPExiftool\Driver\Tag\MXF\StoredANCLineNumber(),
                'ANCWrappingType' => new \PHPExiftool\Driver\Tag\MXF\ANCWrappingType(),
                'ANCPayloadSampleCount' => new \PHPExiftool\Driver\Tag\MXF\ANCPayloadSampleCount(),
                'ANCPayloadByteArray' => new \PHPExiftool\Driver\Tag\MXF\ANCPayloadByteArray(),
                'VBIPayloadSampleCoding' => new \PHPExiftool\Driver\Tag\MXF\VBIPayloadSampleCoding(),
                'ANCPayloadSampleCoding' => new \PHPExiftool\Driver\Tag\MXF\ANCPayloadSampleCoding(),
                'Rsiz' => new \PHPExiftool\Driver\Tag\MXF\Rsiz(),
                'Xsiz' => new \PHPExiftool\Driver\Tag\MXF\Xsiz(),
                'Ysiz' => new \PHPExiftool\Driver\Tag\MXF\Ysiz(),
                'XOsiz' => new \PHPExiftool\Driver\Tag\MXF\XOsiz(),
                'YOsiz' => new \PHPExiftool\Driver\Tag\MXF\YOsiz(),
                'XTsiz' => new \PHPExiftool\Driver\Tag\MXF\XTsiz(),
                'YTsiz' => new \PHPExiftool\Driver\Tag\MXF\YTsiz(),
                'XTOsiz' => new \PHPExiftool\Driver\Tag\MXF\XTOsiz(),
                'YTOsiz' => new \PHPExiftool\Driver\Tag\MXF\YTOsiz(),
                'Csiz' => new \PHPExiftool\Driver\Tag\MXF\Csiz(),
                'PictureComponentSizing' => new \PHPExiftool\Driver\Tag\MXF\PictureComponentSizing(),
                'CodingStyleDefault' => new \PHPExiftool\Driver\Tag\MXF\CodingStyleDefault(),
                'QuantizationDefault' => new \PHPExiftool\Driver\Tag\MXF\QuantizationDefault(),
                'MPEGAudioBitrate' => new \PHPExiftool\Driver\Tag\MXF\MPEGAudioBitrate(),
                'CBEStartOffset' => new \PHPExiftool\Driver\Tag\MXF\CBEStartOffset(),
                'VBEEndOffset' => new \PHPExiftool\Driver\Tag\MXF\VBEEndOffset(),
                'SubDescriptor' => new \PHPExiftool\Driver\Tag\MXF\SubDescriptor(),
                'RootMetaDictionary' => new \PHPExiftool\Driver\Tag\MXF\RootMetaDictionary(),
                'RootPreface' => new \PHPExiftool\Driver\Tag\MXF\RootPreface(),
                'RootObjectDirectory' => new \PHPExiftool\Driver\Tag\MXF\RootObjectDirectory(),
                'RootFormatVersion' => new \PHPExiftool\Driver\Tag\MXF\RootFormatVersion(),
                'FrameCenterElevation' => new \PHPExiftool\Driver\Tag\MXF\FrameCenterElevation(),
                'PackageMarkInPosition' => new \PHPExiftool\Driver\Tag\MXF\PackageMarkInPosition(),
                'PackageMarkOutPosition' => new \PHPExiftool\Driver\Tag\MXF\PackageMarkOutPosition(),
                'Ad-ID' => new \PHPExiftool\Driver\Tag\MXF\AdID(),
                'ResourceID' => new \PHPExiftool\Driver\Tag\MXF\ResourceID(),
                'AncillaryResourceID' => new \PHPExiftool\Driver\Tag\MXF\AncillaryResourceID(),
                'ApplicationSchemeBatch' => new \PHPExiftool\Driver\Tag\MXF\ApplicationSchemeBatch(),
                'RegisterKind' => new \PHPExiftool\Driver\Tag\MXF\RegisterKind(),
                'RegisterVersion' => new \PHPExiftool\Driver\Tag\MXF\RegisterVersion(),
                'RegisterEditorName' => new \PHPExiftool\Driver\Tag\MXF\RegisterEditorName(),
                'RegisterStatusKind' => new \PHPExiftool\Driver\Tag\MXF\RegisterStatusKind(),
                'RegisterItemName' => new \PHPExiftool\Driver\Tag\MXF\RegisterItemName(),
                'RegisterItemDefinition' => new \PHPExiftool\Driver\Tag\MXF\RegisterItemDefinition(),
                'RegisterItemSymbol' => new \PHPExiftool\Driver\Tag\MXF\RegisterItemSymbol(),
                'RegisterItemDefiningDocumentName' => new \PHPExiftool\Driver\Tag\MXF\RegisterItemDefiningDocumentName(),
                'RegisterItemUL' => new \PHPExiftool\Driver\Tag\MXF\RegisterItemUL(),
                'RegisterItemNotes' => new \PHPExiftool\Driver\Tag\MXF\RegisterItemNotes(),
                'RegisterItemIntroductionVersion' => new \PHPExiftool\Driver\Tag\MXF\RegisterItemIntroductionVersion(),
                'RegisterItemHierarchyLevel' => new \PHPExiftool\Driver\Tag\MXF\RegisterItemHierarchyLevel(),
                'RegisterEntryStatus' => new \PHPExiftool\Driver\Tag\MXF\RegisterEntryStatus(),
                'RegisterAction' => new \PHPExiftool\Driver\Tag\MXF\RegisterAction(),
                'RegisterApproverName' => new \PHPExiftool\Driver\Tag\MXF\RegisterApproverName(),
                'RegisterCreationTime' => new \PHPExiftool\Driver\Tag\MXF\RegisterCreationTime(),
                'RegistrantName' => new \PHPExiftool\Driver\Tag\MXF\RegistrantName(),
                'RegisterItemOriginatorName' => new \PHPExiftool\Driver\Tag\MXF\RegisterItemOriginatorName(),
                'RegisterUserName' => new \PHPExiftool\Driver\Tag\MXF\RegisterUserName(),
                'RegisterUserTime' => new \PHPExiftool\Driver\Tag\MXF\RegisterUserTime(),
                'RegisterAdministrationNotes' => new \PHPExiftool\Driver\Tag\MXF\RegisterAdministrationNotes(),
                'AFDAndBarData' => new \PHPExiftool\Driver\Tag\MXF\AFDAndBarData(),
                'PanScanInformation' => new \PHPExiftool\Driver\Tag\MXF\PanScanInformation(),
                'VC-1InitializationMetadata' => new \PHPExiftool\Driver\Tag\MXF\VC1InitializationMetadata(),
                'VC-1SingleSequence' => new \PHPExiftool\Driver\Tag\MXF\VC1SingleSequence(),
                'VC-1CodedContentType' => new \PHPExiftool\Driver\Tag\MXF\VC1CodedContentType(),
                'VC-1IdenticalGOP' => new \PHPExiftool\Driver\Tag\MXF\VC1IdenticalGOP(),
                'VC-1MaximumGOP' => new \PHPExiftool\Driver\Tag\MXF\VC1MaximumGOP(),
                'VC-1BPictureCount' => new \PHPExiftool\Driver\Tag\MXF\VC1BPictureCount(),
                'VC-1AverageBitrate' => new \PHPExiftool\Driver\Tag\MXF\VC1AverageBitrate(),
                'VC-1MaximumBitrate' => new \PHPExiftool\Driver\Tag\MXF\VC1MaximumBitrate(),
                'VC-1Profile' => new \PHPExiftool\Driver\Tag\MXF\VC1Profile(),
                'VC-1Level' => new \PHPExiftool\Driver\Tag\MXF\VC1Level(),
                'LinkedTimecodeTrackID' => new \PHPExiftool\Driver\Tag\MXF\LinkedTimecodeTrackID(),
                'SMPTE337MDataStreamNumber' => new \PHPExiftool\Driver\Tag\MXF\SMPTE337MDataStreamNumber(),
                'ApplicationScheme' => new \PHPExiftool\Driver\Tag\MXF\ApplicationScheme(),
                'DescriptiveMetadataScheme' => new \PHPExiftool\Driver\Tag\MXF\DescriptiveMetadataScheme(),
                'UCSEncoding' => new \PHPExiftool\Driver\Tag\MXF\UCSEncoding(),
                'LinkedApplicationPlug-InInstanceID' => new \PHPExiftool\Driver\Tag\MXF\LinkedApplicationPlugInInstanceID(),
                'LinkedDescriptiveFrameworkPlug-InID' => new \PHPExiftool\Driver\Tag\MXF\LinkedDescriptiveFrameworkPlugInID(),
                'ApplicationPlug-InInstanceID' => new \PHPExiftool\Driver\Tag\MXF\ApplicationPlugInInstanceID(),
                'DescriptiveMetadataPlug-InID' => new \PHPExiftool\Driver\Tag\MXF\DescriptiveMetadataPlugInID(),
                'ApplicationEnvironmentID' => new \PHPExiftool\Driver\Tag\MXF\ApplicationEnvironmentID(),
                'DescriptiveMetadataApplicationEnvironmentID' => new \PHPExiftool\Driver\Tag\MXF\DescriptiveMetadataApplicationEnvironmentID(),
                'LinkedDescriptiveObjectPlug-InID' => new \PHPExiftool\Driver\Tag\MXF\LinkedDescriptiveObjectPlugInID(),
                'TimebaseReferenceTrackID' => new \PHPExiftool\Driver\Tag\MXF\TimebaseReferenceTrackID(),
                'ObjectClassDefinition' => new \PHPExiftool\Driver\Tag\MXF\ObjectClassDefinition(),
                'ApplicationPlug-InBatch' => new \PHPExiftool\Driver\Tag\MXF\ApplicationPlugInBatch(),
                'PackageMarker' => new \PHPExiftool\Driver\Tag\MXF\PackageMarker(),
                'PackageTimelineMarkerRef' => new \PHPExiftool\Driver\Tag\MXF\PackageTimelineMarkerRef(),
                'RegisterAdministrationObject' => new \PHPExiftool\Driver\Tag\MXF\RegisterAdministrationObject(),
                'RegisterEntryAdministrationObject' => new \PHPExiftool\Driver\Tag\MXF\RegisterEntryAdministrationObject(),
                'GenericPayloads' => new \PHPExiftool\Driver\Tag\MXF\GenericPayloads(),
                'RegisterEntryArray' => new \PHPExiftool\Driver\Tag\MXF\RegisterEntryArray(),
                'RegisterAdministrationArray' => new \PHPExiftool\Driver\Tag\MXF\RegisterAdministrationArray(),
                'ApplicationInformationArray' => new \PHPExiftool\Driver\Tag\MXF\ApplicationInformationArray(),
                'RegisterChildEntryArray' => new \PHPExiftool\Driver\Tag\MXF\RegisterChildEntryArray(),
                'RegisterReleaseDateTime' => new \PHPExiftool\Driver\Tag\MXF\RegisterReleaseDateTime(),
                'RegisterItemStatusChangeDateTime' => new \PHPExiftool\Driver\Tag\MXF\RegisterItemStatusChangeDateTime(),
                'OpenBodyPartition' => new \PHPExiftool\Driver\Tag\MXF\OpenBodyPartition(),
                'ClosedBodyPartition' => new \PHPExiftool\Driver\Tag\MXF\ClosedBodyPartition(),
                'OpenCompleteBodyPartition' => new \PHPExiftool\Driver\Tag\MXF\OpenCompleteBodyPartition(),
                'ClosedCompleteBodyPartition' => new \PHPExiftool\Driver\Tag\MXF\ClosedCompleteBodyPartition(),
                'Footer' => new \PHPExiftool\Driver\Tag\MXF\Footer(),
                'CompleteFooter' => new \PHPExiftool\Driver\Tag\MXF\CompleteFooter(),
                'RandomIndexMetadataV10' => new \PHPExiftool\Driver\Tag\MXF\RandomIndexMetadataV10(),
                'RandomIndexMetadata' => new \PHPExiftool\Driver\Tag\MXF\RandomIndexMetadata(),
                'PartitionMetadata' => new \PHPExiftool\Driver\Tag\MXF\PartitionMetadata(),
                'SourceClip' => new \PHPExiftool\Driver\Tag\MXF\SourceClip(),
                'V10IndexTableSegment' => new \PHPExiftool\Driver\Tag\MXF\V10IndexTableSegment(),
                'IndexTableSegment' => new \PHPExiftool\Driver\Tag\MXF\IndexTableSegment(),
                'DefaultObject' => new \PHPExiftool\Driver\Tag\MXF\DefaultObject(),
                'CipherAlgorithmAES128CBC' => new \PHPExiftool\Driver\Tag\MXF\CipherAlgorithmAES128CBC(),
                'HMACAlgorithmSHA1128' => new \PHPExiftool\Driver\Tag\MXF\HMACAlgorithmSHA1128(),
                'EncryptedContainerLabel' => new \PHPExiftool\Driver\Tag\MXF\EncryptedContainerLabel(),
                'CryptographicFrameworkLabel' => new \PHPExiftool\Driver\Tag\MXF\CryptographicFrameworkLabel(),
            );
        });
        $this['MacOS'] = $this->share(function(){
            return array(
                'MDItemAccountHandles' => new \PHPExiftool\Driver\Tag\MacOS\MDItemAccountHandles(),
                'MDItemAccountIdentifier' => new \PHPExiftool\Driver\Tag\MacOS\MDItemAccountIdentifier(),
                'MDItemAcquisitionMake' => new \PHPExiftool\Driver\Tag\MacOS\MDItemAcquisitionMake(),
                'MDItemAcquisitionModel' => new \PHPExiftool\Driver\Tag\MacOS\MDItemAcquisitionModel(),
                'MDItemAltitude' => new \PHPExiftool\Driver\Tag\MacOS\MDItemAltitude(),
                'MDItemAperture' => new \PHPExiftool\Driver\Tag\MacOS\MDItemAperture(),
                'MDItemAudioBitRate' => new \PHPExiftool\Driver\Tag\MacOS\MDItemAudioBitRate(),
                'MDItemAudioChannelCount' => new \PHPExiftool\Driver\Tag\MacOS\MDItemAudioChannelCount(),
                'MDItemAuthorEmailAddresses' => new \PHPExiftool\Driver\Tag\MacOS\MDItemAuthorEmailAddresses(),
                'MDItemAuthors' => new \PHPExiftool\Driver\Tag\MacOS\MDItemAuthors(),
                'MDItemBitsPerSample' => new \PHPExiftool\Driver\Tag\MacOS\MDItemBitsPerSample(),
                'MDItemBundleIdentifier' => new \PHPExiftool\Driver\Tag\MacOS\MDItemBundleIdentifier(),
                'MDItemCity' => new \PHPExiftool\Driver\Tag\MacOS\MDItemCity(),
                'MDItemCodecs' => new \PHPExiftool\Driver\Tag\MacOS\MDItemCodecs(),
                'MDItemColorSpace' => new \PHPExiftool\Driver\Tag\MacOS\MDItemColorSpace(),
                'MDItemComment' => new \PHPExiftool\Driver\Tag\MacOS\MDItemComment(),
                'MDItemContentCreationDate' => new \PHPExiftool\Driver\Tag\MacOS\MDItemContentCreationDate(),
                'mixed' => new \PHPExiftool\Driver\Tag\MacOS\MDItemInterestingDateRanking(),
                'MDItemContentModificationDate' => new \PHPExiftool\Driver\Tag\MacOS\MDItemContentModificationDate(),
                'MDItemContentType' => new \PHPExiftool\Driver\Tag\MacOS\MDItemContentType(),
                'MDItemContentTypeTree' => new \PHPExiftool\Driver\Tag\MacOS\MDItemContentTypeTree(),
                'MDItemContributors' => new \PHPExiftool\Driver\Tag\MacOS\MDItemContributors(),
                'MDItemCopyright' => new \PHPExiftool\Driver\Tag\MacOS\MDItemCopyright(),
                'MDItemCountry' => new \PHPExiftool\Driver\Tag\MacOS\MDItemCountry(),
                'MDItemCreator' => new \PHPExiftool\Driver\Tag\MacOS\MDItemCreator(),
                'MDItemDateAdded' => new \PHPExiftool\Driver\Tag\MacOS\MDItemDateAdded(),
                'MDItemDateAdded_Ranking' => new \PHPExiftool\Driver\Tag\MacOS\MDItemDateAddedRanking(),
                'MDItemDescription' => new \PHPExiftool\Driver\Tag\MacOS\MDItemDescription(),
                'MDItemDisplayName' => new \PHPExiftool\Driver\Tag\MacOS\MDItemDisplayName(),
                'MDItemDownloadedDate' => new \PHPExiftool\Driver\Tag\MacOS\MDItemDownloadedDate(),
                'MDItemDurationSeconds' => new \PHPExiftool\Driver\Tag\MacOS\MDItemDurationSeconds(),
                'MDItemEXIFGPSVersion' => new \PHPExiftool\Driver\Tag\MacOS\MDItemEXIFGPSVersion(),
                'MDItemEXIFVersion' => new \PHPExiftool\Driver\Tag\MacOS\MDItemEXIFVersion(),
                'MDItemEmailConversationID' => new \PHPExiftool\Driver\Tag\MacOS\MDItemEmailConversationID(),
                'MDItemEncodingApplications' => new \PHPExiftool\Driver\Tag\MacOS\MDItemEncodingApplications(),
                'MDItemExposureMode' => new \PHPExiftool\Driver\Tag\MacOS\MDItemExposureMode(),
                'MDItemExposureProgram' => new \PHPExiftool\Driver\Tag\MacOS\MDItemExposureProgram(),
                'MDItemExposureTimeSeconds' => new \PHPExiftool\Driver\Tag\MacOS\MDItemExposureTimeSeconds(),
                'MDItemFNumber' => new \PHPExiftool\Driver\Tag\MacOS\MDItemFNumber(),
                'MDItemFSContentChangeDate' => new \PHPExiftool\Driver\Tag\MacOS\MDItemFSContentChangeDate(),
                'MDItemFSCreationDate' => new \PHPExiftool\Driver\Tag\MacOS\MDItemFSCreationDate(),
                'MDItemFSCreatorCode' => new \PHPExiftool\Driver\Tag\MacOS\MDItemFSCreatorCode(),
                'MDItemFSFinderFlags' => new \PHPExiftool\Driver\Tag\MacOS\MDItemFSFinderFlags(),
                'MDItemFSHasCustomIcon' => new \PHPExiftool\Driver\Tag\MacOS\MDItemFSHasCustomIcon(),
                'MDItemFSInvisible' => new \PHPExiftool\Driver\Tag\MacOS\MDItemFSInvisible(),
                'MDItemFSIsExtensionHidden' => new \PHPExiftool\Driver\Tag\MacOS\MDItemFSIsExtensionHidden(),
                'MDItemFSIsStationery' => new \PHPExiftool\Driver\Tag\MacOS\MDItemFSIsStationery(),
                'MDItemFSLabel' => new \PHPExiftool\Driver\Tag\MacOS\MDItemFSLabel(),
                'MDItemFSName' => new \PHPExiftool\Driver\Tag\MacOS\MDItemFSName(),
                'MDItemFSNodeCount' => new \PHPExiftool\Driver\Tag\MacOS\MDItemFSNodeCount(),
                'MDItemFSOwnerGroupID' => new \PHPExiftool\Driver\Tag\MacOS\MDItemFSOwnerGroupID(),
                'MDItemFSOwnerUserID' => new \PHPExiftool\Driver\Tag\MacOS\MDItemFSOwnerUserID(),
                'MDItemFSSize' => new \PHPExiftool\Driver\Tag\MacOS\MDItemFSSize(),
                'MDItemFSTypeCode' => new \PHPExiftool\Driver\Tag\MacOS\MDItemFSTypeCode(),
                'MDItemFinderComment' => new \PHPExiftool\Driver\Tag\MacOS\MDItemFinderComment(),
                'MDItemFlashOnOff' => new \PHPExiftool\Driver\Tag\MacOS\MDItemFlashOnOff(),
                'MDItemFocalLength' => new \PHPExiftool\Driver\Tag\MacOS\MDItemFocalLength(),
                'MDItemGPSDateStamp' => new \PHPExiftool\Driver\Tag\MacOS\MDItemGPSDateStamp(),
                'MDItemGPSStatus' => new \PHPExiftool\Driver\Tag\MacOS\MDItemGPSStatus(),
                'MDItemGPSTrack' => new \PHPExiftool\Driver\Tag\MacOS\MDItemGPSTrack(),
                'MDItemHasAlphaChannel' => new \PHPExiftool\Driver\Tag\MacOS\MDItemHasAlphaChannel(),
                'MDItemISOSpeed' => new \PHPExiftool\Driver\Tag\MacOS\MDItemISOSpeed(),
                'MDItemIdentifier' => new \PHPExiftool\Driver\Tag\MacOS\MDItemIdentifier(),
                'MDItemImageDirection' => new \PHPExiftool\Driver\Tag\MacOS\MDItemImageDirection(),
                'MDItemIsApplicationManaged' => new \PHPExiftool\Driver\Tag\MacOS\MDItemIsApplicationManaged(),
                'MDItemIsExistingThread' => new \PHPExiftool\Driver\Tag\MacOS\MDItemIsExistingThread(),
                'MDItemIsLikelyJunk' => new \PHPExiftool\Driver\Tag\MacOS\MDItemIsLikelyJunk(),
                'MDItemKeywords' => new \PHPExiftool\Driver\Tag\MacOS\MDItemKeywords(),
                'MDItemKind' => new \PHPExiftool\Driver\Tag\MacOS\MDItemKind(),
                'MDItemLastUsedDate' => new \PHPExiftool\Driver\Tag\MacOS\MDItemLastUsedDate(),
                'MDItemLastUsedDate_Ranking' => new \PHPExiftool\Driver\Tag\MacOS\MDItemLastUsedDateRanking(),
                'MDItemLatitude' => new \PHPExiftool\Driver\Tag\MacOS\MDItemLatitude(),
                'MDItemLensModel' => new \PHPExiftool\Driver\Tag\MacOS\MDItemLensModel(),
                'MDItemLogicalSize' => new \PHPExiftool\Driver\Tag\MacOS\MDItemLogicalSize(),
                'MDItemLongitude' => new \PHPExiftool\Driver\Tag\MacOS\MDItemLongitude(),
                'MDItemMailDateReceived_Ranking' => new \PHPExiftool\Driver\Tag\MacOS\MDItemMailDateReceivedRanking(),
                'MDItemMailboxes' => new \PHPExiftool\Driver\Tag\MacOS\MDItemMailboxes(),
                'MDItemMediaTypes' => new \PHPExiftool\Driver\Tag\MacOS\MDItemMediaTypes(),
                'MDItemNumberOfPages' => new \PHPExiftool\Driver\Tag\MacOS\MDItemNumberOfPages(),
                'MDItemOrientation' => new \PHPExiftool\Driver\Tag\MacOS\MDItemOrientation(),
                'MDItemOriginApplicationIdentifier' => new \PHPExiftool\Driver\Tag\MacOS\MDItemOriginApplicationIdentifier(),
                'MDItemOriginMessageID' => new \PHPExiftool\Driver\Tag\MacOS\MDItemOriginMessageID(),
                'MDItemOriginSenderDisplayName' => new \PHPExiftool\Driver\Tag\MacOS\MDItemOriginSenderDisplayName(),
                'MDItemOriginSenderHandle' => new \PHPExiftool\Driver\Tag\MacOS\MDItemOriginSenderHandle(),
                'MDItemOriginSubject' => new \PHPExiftool\Driver\Tag\MacOS\MDItemOriginSubject(),
                'MDItemPageHeight' => new \PHPExiftool\Driver\Tag\MacOS\MDItemPageHeight(),
                'MDItemPageWidth' => new \PHPExiftool\Driver\Tag\MacOS\MDItemPageWidth(),
                'MDItemPhysicalSize' => new \PHPExiftool\Driver\Tag\MacOS\MDItemPhysicalSize(),
                'MDItemPixelCount' => new \PHPExiftool\Driver\Tag\MacOS\MDItemPixelCount(),
                'MDItemPixelHeight' => new \PHPExiftool\Driver\Tag\MacOS\MDItemPixelHeight(),
                'MDItemPixelWidth' => new \PHPExiftool\Driver\Tag\MacOS\MDItemPixelWidth(),
                'MDItemPrimaryRecipientEmailAddresses' => new \PHPExiftool\Driver\Tag\MacOS\MDItemPrimaryRecipientEmailAddresses(),
                'MDItemProfileName' => new \PHPExiftool\Driver\Tag\MacOS\MDItemProfileName(),
                'MDItemRecipients' => new \PHPExiftool\Driver\Tag\MacOS\MDItemRecipients(),
                'MDItemRedEyeOnOff' => new \PHPExiftool\Driver\Tag\MacOS\MDItemRedEyeOnOff(),
                'MDItemResolutionHeightDPI' => new \PHPExiftool\Driver\Tag\MacOS\MDItemResolutionHeightDPI(),
                'MDItemResolutionWidthDPI' => new \PHPExiftool\Driver\Tag\MacOS\MDItemResolutionWidthDPI(),
                'MDItemSecurityMethod' => new \PHPExiftool\Driver\Tag\MacOS\MDItemSecurityMethod(),
                'MDItemSpeed' => new \PHPExiftool\Driver\Tag\MacOS\MDItemSpeed(),
                'MDItemStateOrProvince' => new \PHPExiftool\Driver\Tag\MacOS\MDItemStateOrProvince(),
                'MDItemStreamable' => new \PHPExiftool\Driver\Tag\MacOS\MDItemStreamable(),
                'MDItemSubject' => new \PHPExiftool\Driver\Tag\MacOS\MDItemSubject(),
                'MDItemTimestamp' => new \PHPExiftool\Driver\Tag\MacOS\MDItemTimestamp(),
                'MDItemTitle' => new \PHPExiftool\Driver\Tag\MacOS\MDItemTitle(),
                'MDItemTotalBitRate' => new \PHPExiftool\Driver\Tag\MacOS\MDItemTotalBitRate(),
                'MDItemUseCount' => new \PHPExiftool\Driver\Tag\MacOS\MDItemUseCount(),
                'MDItemUsedDates' => new \PHPExiftool\Driver\Tag\MacOS\MDItemUsedDates(),
                'MDItemUserDownloadedDate' => new \PHPExiftool\Driver\Tag\MacOS\MDItemUserDownloadedDate(),
                'MDItemUserDownloadedUserHandle' => new \PHPExiftool\Driver\Tag\MacOS\MDItemUserDownloadedUserHandle(),
                'MDItemUserSharedReceivedDate' => new \PHPExiftool\Driver\Tag\MacOS\MDItemUserSharedReceivedDate(),
                'MDItemUserSharedReceivedRecipient' => new \PHPExiftool\Driver\Tag\MacOS\MDItemUserSharedReceivedRecipient(),
                'MDItemUserSharedReceivedRecipientHandle' => new \PHPExiftool\Driver\Tag\MacOS\MDItemUserSharedReceivedRecipientHandle(),
                'MDItemUserSharedReceivedSender' => new \PHPExiftool\Driver\Tag\MacOS\MDItemUserSharedReceivedSender(),
                'MDItemUserSharedReceivedSenderHandle' => new \PHPExiftool\Driver\Tag\MacOS\MDItemUserSharedReceivedSenderHandle(),
                'MDItemUserSharedReceivedTransport' => new \PHPExiftool\Driver\Tag\MacOS\MDItemUserSharedReceivedTransport(),
                'MDItemUserTags' => new \PHPExiftool\Driver\Tag\MacOS\MDItemUserTags(),
                'MDItemVersion' => new \PHPExiftool\Driver\Tag\MacOS\MDItemVersion(),
                'MDItemVideoBitRate' => new \PHPExiftool\Driver\Tag\MacOS\MDItemVideoBitRate(),
                'MDItemWhereFroms' => new \PHPExiftool\Driver\Tag\MacOS\MDItemWhereFroms(),
                'MDItemWhiteBalance' => new \PHPExiftool\Driver\Tag\MacOS\MDItemWhiteBalance(),
                'AppleMailDateReceived' => new \PHPExiftool\Driver\Tag\MacOS\AppleMailDateReceived(),
                'AppleMailDateSent' => new \PHPExiftool\Driver\Tag\MacOS\AppleMailDateSent(),
                'AppleMailFlagged' => new \PHPExiftool\Driver\Tag\MacOS\AppleMailFlagged(),
                'AppleMailIsRemoteAttachment' => new \PHPExiftool\Driver\Tag\MacOS\AppleMailIsRemoteAttachment(),
                'AppleMailMessageID' => new \PHPExiftool\Driver\Tag\MacOS\AppleMailMessageID(),
                'AppleMailPriority' => new \PHPExiftool\Driver\Tag\MacOS\AppleMailPriority(),
                'AppleMailRead' => new \PHPExiftool\Driver\Tag\MacOS\AppleMailRead(),
                'AppleMailRepliedTo' => new \PHPExiftool\Driver\Tag\MacOS\AppleMailRepliedTo(),
                'XAttrFinderInfo' => new \PHPExiftool\Driver\Tag\MacOS\XAttrFinderInfo(),
                'XAttrResourceFork' => new \PHPExiftool\Driver\Tag\MacOS\XAttrResourceFork(),
                'XAttrLastUsedDate' => new \PHPExiftool\Driver\Tag\MacOS\XAttrLastUsedDate(),
                'XAttrAppleMailDateReceived' => new \PHPExiftool\Driver\Tag\MacOS\XAttrAppleMailDateReceived(),
                'XAttrAppleMailDateSent' => new \PHPExiftool\Driver\Tag\MacOS\XAttrAppleMailDateSent(),
                'XAttrAppleMailIsRemoteAttachment' => new \PHPExiftool\Driver\Tag\MacOS\XAttrAppleMailIsRemoteAttachment(),
                'XAttrMDItemDownloadedDate' => new \PHPExiftool\Driver\Tag\MacOS\XAttrMDItemDownloadedDate(),
                'XAttrMDItemFinderComment' => new \PHPExiftool\Driver\Tag\MacOS\XAttrMDItemFinderComment(),
                'XAttrMDItemWhereFroms' => new \PHPExiftool\Driver\Tag\MacOS\XAttrMDItemWhereFroms(),
                'XAttrMDLabel' => new \PHPExiftool\Driver\Tag\MacOS\XAttrMDLabel(),
                'XAttrQuarantine' => new \PHPExiftool\Driver\Tag\MacOS\XAttrQuarantine(),
            );
        });
        $this['Matroska'] = $this->share(function(){
            return array(
                'TrackType' => new \PHPExiftool\Driver\Tag\Matroska\TrackType(),
                'ChapterString' => new \PHPExiftool\Driver\Tag\Matroska\ChapterString(),
                'VideoCodecID' => new \PHPExiftool\Driver\Tag\Matroska\VideoCodecID(),
                'AudioCodecID' => new \PHPExiftool\Driver\Tag\Matroska\AudioCodecID(),
                'CodecID' => new \PHPExiftool\Driver\Tag\Matroska\CodecID(),
                'TrackDefault' => new \PHPExiftool\Driver\Tag\Matroska\TrackDefault(),
                'ChapterTrackNumber' => new \PHPExiftool\Driver\Tag\Matroska\ChapterTrackNumber(),
                'ChapterTimeStart' => new \PHPExiftool\Driver\Tag\Matroska\ChapterTimeStart(),
                'ChapterTimeEnd' => new \PHPExiftool\Driver\Tag\Matroska\ChapterTimeEnd(),
                'CueRefTime' => new \PHPExiftool\Driver\Tag\Matroska\CueRefTime(),
                'CueRefCluster' => new \PHPExiftool\Driver\Tag\Matroska\CueRefCluster(),
                'ChapterFlagHidden' => new \PHPExiftool\Driver\Tag\Matroska\ChapterFlagHidden(),
                'VideoScanType' => new \PHPExiftool\Driver\Tag\Matroska\VideoScanType(),
                'BlockDuration' => new \PHPExiftool\Driver\Tag\Matroska\BlockDuration(),
                'TrackLacing' => new \PHPExiftool\Driver\Tag\Matroska\TrackLacing(),
                'AudioChannels' => new \PHPExiftool\Driver\Tag\Matroska\AudioChannels(),
                'Block' => new \PHPExiftool\Driver\Tag\Matroska\Block(),
                'BlockVirtual' => new \PHPExiftool\Driver\Tag\Matroska\BlockVirtual(),
                'SimpleBlock' => new \PHPExiftool\Driver\Tag\Matroska\SimpleBlock(),
                'CodecState' => new \PHPExiftool\Driver\Tag\Matroska\CodecState(),
                'BlockAdditional' => new \PHPExiftool\Driver\Tag\Matroska\BlockAdditional(),
                'Position' => new \PHPExiftool\Driver\Tag\Matroska\Position(),
                'CodecDecodeAll' => new \PHPExiftool\Driver\Tag\Matroska\CodecDecodeAll(),
                'PrevSize' => new \PHPExiftool\Driver\Tag\Matroska\PrevSize(),
                'EncryptedBlock' => new \PHPExiftool\Driver\Tag\Matroska\EncryptedBlock(),
                'ImageWidth' => new \PHPExiftool\Driver\Tag\Matroska\ImageWidth(),
                'CueTime' => new \PHPExiftool\Driver\Tag\Matroska\CueTime(),
                'AudioSampleRate' => new \PHPExiftool\Driver\Tag\Matroska\AudioSampleRate(),
                'TrackUsed' => new \PHPExiftool\Driver\Tag\Matroska\TrackUsed(),
                'ImageHeight' => new \PHPExiftool\Driver\Tag\Matroska\ImageHeight(),
                'CRC-32' => new \PHPExiftool\Driver\Tag\Matroska\CRC32(),
                'BlockAdditionalID' => new \PHPExiftool\Driver\Tag\Matroska\BlockAdditionalID(),
                'LaceNumber' => new \PHPExiftool\Driver\Tag\Matroska\LaceNumber(),
                'FrameNumber' => new \PHPExiftool\Driver\Tag\Matroska\FrameNumber(),
                'Delay' => new \PHPExiftool\Driver\Tag\Matroska\Delay(),
                'ClusterDuration' => new \PHPExiftool\Driver\Tag\Matroska\ClusterDuration(),
                'TrackNumber' => new \PHPExiftool\Driver\Tag\Matroska\TrackNumber(),
                'TimeCode' => new \PHPExiftool\Driver\Tag\Matroska\TimeCode(),
                'CueCodecState' => new \PHPExiftool\Driver\Tag\Matroska\CueCodecState(),
                'CueRefCodecState' => new \PHPExiftool\Driver\Tag\Matroska\CueRefCodecState(),
                'Void' => new \PHPExiftool\Driver\Tag\Matroska\Void0(),
                'BlockAddID' => new \PHPExiftool\Driver\Tag\Matroska\BlockAddID(),
                'CueClusterPosition' => new \PHPExiftool\Driver\Tag\Matroska\CueClusterPosition(),
                'CueTrack' => new \PHPExiftool\Driver\Tag\Matroska\CueTrack(),
                'ReferencePriority' => new \PHPExiftool\Driver\Tag\Matroska\ReferencePriority(),
                'ReferenceBlock' => new \PHPExiftool\Driver\Tag\Matroska\ReferenceBlock(),
                'ReferenceVirtual' => new \PHPExiftool\Driver\Tag\Matroska\ReferenceVirtual(),
                'ContentCompressionAlgorithm' => new \PHPExiftool\Driver\Tag\Matroska\ContentCompressionAlgorithm(),
                'ContentCompressionSettings' => new \PHPExiftool\Driver\Tag\Matroska\ContentCompressionSettings(),
                'DocType' => new \PHPExiftool\Driver\Tag\Matroska\DocType(),
                'DocTypeReadVersion' => new \PHPExiftool\Driver\Tag\Matroska\DocTypeReadVersion(),
                'EBMLVersion' => new \PHPExiftool\Driver\Tag\Matroska\EBMLVersion(),
                'DocTypeVersion' => new \PHPExiftool\Driver\Tag\Matroska\DocTypeVersion(),
                'EBMLMaxIDLength' => new \PHPExiftool\Driver\Tag\Matroska\EBMLMaxIDLength(),
                'EBMLMaxSizeLength' => new \PHPExiftool\Driver\Tag\Matroska\EBMLMaxSizeLength(),
                'EBMLReadVersion' => new \PHPExiftool\Driver\Tag\Matroska\EBMLReadVersion(),
                'ChapterLanguage' => new \PHPExiftool\Driver\Tag\Matroska\ChapterLanguage(),
                'ChapterCountry' => new \PHPExiftool\Driver\Tag\Matroska\ChapterCountry(),
                'SegmentFamily' => new \PHPExiftool\Driver\Tag\Matroska\SegmentFamily(),
                'DateTimeOriginal' => new \PHPExiftool\Driver\Tag\Matroska\DateTimeOriginal(),
                'TagLanguage' => new \PHPExiftool\Driver\Tag\Matroska\TagLanguage(),
                'TagDefault' => new \PHPExiftool\Driver\Tag\Matroska\TagDefault(),
                'TagBinary' => new \PHPExiftool\Driver\Tag\Matroska\TagBinary(),
                'TagString' => new \PHPExiftool\Driver\Tag\Matroska\TagString(),
                'Duration' => new \PHPExiftool\Driver\Tag\Matroska\Duration(),
                'ChapterProcessPrivate' => new \PHPExiftool\Driver\Tag\Matroska\ChapterProcessPrivate(),
                'ChapterFlagEnabled' => new \PHPExiftool\Driver\Tag\Matroska\ChapterFlagEnabled(),
                'TagName' => new \PHPExiftool\Driver\Tag\Matroska\TagName(),
                'EditionUID' => new \PHPExiftool\Driver\Tag\Matroska\EditionUID(),
                'EditionFlagHidden' => new \PHPExiftool\Driver\Tag\Matroska\EditionFlagHidden(),
                'EditionFlagDefault' => new \PHPExiftool\Driver\Tag\Matroska\EditionFlagDefault(),
                'EditionFlagOrdered' => new \PHPExiftool\Driver\Tag\Matroska\EditionFlagOrdered(),
                'AttachedFileData' => new \PHPExiftool\Driver\Tag\Matroska\AttachedFileData(),
                'AttachedFileMIMEType' => new \PHPExiftool\Driver\Tag\Matroska\AttachedFileMIMEType(),
                'AttachedFileName' => new \PHPExiftool\Driver\Tag\Matroska\AttachedFileName(),
                'AttachedFileReferral' => new \PHPExiftool\Driver\Tag\Matroska\AttachedFileReferral(),
                'AttachedFileDescription' => new \PHPExiftool\Driver\Tag\Matroska\AttachedFileDescription(),
                'AttachedFileUID' => new \PHPExiftool\Driver\Tag\Matroska\AttachedFileUID(),
                'ContentEncryptionAlgorithm' => new \PHPExiftool\Driver\Tag\Matroska\ContentEncryptionAlgorithm(),
                'ContentEncryptionKeyID' => new \PHPExiftool\Driver\Tag\Matroska\ContentEncryptionKeyID(),
                'ContentSignature' => new \PHPExiftool\Driver\Tag\Matroska\ContentSignature(),
                'ContentSignatureKeyID' => new \PHPExiftool\Driver\Tag\Matroska\ContentSignatureKeyID(),
                'ContentSignatureAlgorithm' => new \PHPExiftool\Driver\Tag\Matroska\ContentSignatureAlgorithm(),
                'ContentSignatureHashAlgorithm' => new \PHPExiftool\Driver\Tag\Matroska\ContentSignatureHashAlgorithm(),
                'MuxingApp' => new \PHPExiftool\Driver\Tag\Matroska\MuxingApp(),
                'ContentEncodingOrder' => new \PHPExiftool\Driver\Tag\Matroska\ContentEncodingOrder(),
                'ContentEncodingScope' => new \PHPExiftool\Driver\Tag\Matroska\ContentEncodingScope(),
                'ContentEncodingType' => new \PHPExiftool\Driver\Tag\Matroska\ContentEncodingType(),
                'CueRefNumber' => new \PHPExiftool\Driver\Tag\Matroska\CueRefNumber(),
                'TrackName' => new \PHPExiftool\Driver\Tag\Matroska\TrackName(),
                'CueBlockNumber' => new \PHPExiftool\Driver\Tag\Matroska\CueBlockNumber(),
                'TrackOffset' => new \PHPExiftool\Driver\Tag\Matroska\TrackOffset(),
                'SeekID' => new \PHPExiftool\Driver\Tag\Matroska\SeekID(),
                'SeekPosition' => new \PHPExiftool\Driver\Tag\Matroska\SeekPosition(),
                'Stereo3DMode' => new \PHPExiftool\Driver\Tag\Matroska\Stereo3DMode(),
                'CropBottom' => new \PHPExiftool\Driver\Tag\Matroska\CropBottom(),
                'DisplayWidth' => new \PHPExiftool\Driver\Tag\Matroska\DisplayWidth(),
                'DisplayUnit' => new \PHPExiftool\Driver\Tag\Matroska\DisplayUnit(),
                'AspectRatioType' => new \PHPExiftool\Driver\Tag\Matroska\AspectRatioType(),
                'DisplayHeight' => new \PHPExiftool\Driver\Tag\Matroska\DisplayHeight(),
                'CropTop' => new \PHPExiftool\Driver\Tag\Matroska\CropTop(),
                'CropLeft' => new \PHPExiftool\Driver\Tag\Matroska\CropLeft(),
                'CropRight' => new \PHPExiftool\Driver\Tag\Matroska\CropRight(),
                'TrackForced' => new \PHPExiftool\Driver\Tag\Matroska\TrackForced(),
                'MaxBlockAdditionID' => new \PHPExiftool\Driver\Tag\Matroska\MaxBlockAdditionID(),
                'WritingApp' => new \PHPExiftool\Driver\Tag\Matroska\WritingApp(),
                'SilentTrackNumber' => new \PHPExiftool\Driver\Tag\Matroska\SilentTrackNumber(),
                'AudioBitsPerSample' => new \PHPExiftool\Driver\Tag\Matroska\AudioBitsPerSample(),
                'CodecPrivate' => new \PHPExiftool\Driver\Tag\Matroska\CodecPrivate(),
                'ChapterPhysicalEquivalent' => new \PHPExiftool\Driver\Tag\Matroska\ChapterPhysicalEquivalent(),
                'TagChapterUID' => new \PHPExiftool\Driver\Tag\Matroska\TagChapterUID(),
                'TagTrackUID' => new \PHPExiftool\Driver\Tag\Matroska\TagTrackUID(),
                'TagAttachmentUID' => new \PHPExiftool\Driver\Tag\Matroska\TagAttachmentUID(),
                'TagEditionUID' => new \PHPExiftool\Driver\Tag\Matroska\TagEditionUID(),
                'TargetType' => new \PHPExiftool\Driver\Tag\Matroska\TargetType(),
                'SignedElement' => new \PHPExiftool\Driver\Tag\Matroska\SignedElement(),
                'TrackTranslateTrackID' => new \PHPExiftool\Driver\Tag\Matroska\TrackTranslateTrackID(),
                'TrackTranslateCodec' => new \PHPExiftool\Driver\Tag\Matroska\TrackTranslateCodec(),
                'TrackTranslateEditionUID' => new \PHPExiftool\Driver\Tag\Matroska\TrackTranslateEditionUID(),
                'TargetTypeValue' => new \PHPExiftool\Driver\Tag\Matroska\TargetTypeValue(),
                'ChapterProcessTime' => new \PHPExiftool\Driver\Tag\Matroska\ChapterProcessTime(),
                'ChapterProcessData' => new \PHPExiftool\Driver\Tag\Matroska\ChapterProcessData(),
                'ChapterProcessCodecID' => new \PHPExiftool\Driver\Tag\Matroska\ChapterProcessCodecID(),
                'ChapterTranslateID' => new \PHPExiftool\Driver\Tag\Matroska\ChapterTranslateID(),
                'ChapterTranslateCodec' => new \PHPExiftool\Driver\Tag\Matroska\ChapterTranslateCodec(),
                'ChapterTranslateEditionUID' => new \PHPExiftool\Driver\Tag\Matroska\ChapterTranslateEditionUID(),
                'MinCache' => new \PHPExiftool\Driver\Tag\Matroska\MinCache(),
                'MaxCache' => new \PHPExiftool\Driver\Tag\Matroska\MaxCache(),
                'ChapterSegmentUID' => new \PHPExiftool\Driver\Tag\Matroska\ChapterSegmentUID(),
                'ChapterSegmentEditionUID' => new \PHPExiftool\Driver\Tag\Matroska\ChapterSegmentEditionUID(),
                'TrackOverlay' => new \PHPExiftool\Driver\Tag\Matroska\TrackOverlay(),
                'SegmentFileName' => new \PHPExiftool\Driver\Tag\Matroska\SegmentFileName(),
                'SegmentUID' => new \PHPExiftool\Driver\Tag\Matroska\SegmentUID(),
                'ChapterUID' => new \PHPExiftool\Driver\Tag\Matroska\ChapterUID(),
                'TrackUID' => new \PHPExiftool\Driver\Tag\Matroska\TrackUID(),
                'TrackAttachmentUID' => new \PHPExiftool\Driver\Tag\Matroska\TrackAttachmentUID(),
                'OutputAudioSampleRate' => new \PHPExiftool\Driver\Tag\Matroska\OutputAudioSampleRate(),
                'Title' => new \PHPExiftool\Driver\Tag\Matroska\Title(),
                'ChannelPositions' => new \PHPExiftool\Driver\Tag\Matroska\ChannelPositions(),
                'SignatureAlgo' => new \PHPExiftool\Driver\Tag\Matroska\SignatureAlgo(),
                'SignatureHash' => new \PHPExiftool\Driver\Tag\Matroska\SignatureHash(),
                'SignaturePublicKey' => new \PHPExiftool\Driver\Tag\Matroska\SignaturePublicKey(),
                'Signature' => new \PHPExiftool\Driver\Tag\Matroska\Signature(),
                'TrackLanguage' => new \PHPExiftool\Driver\Tag\Matroska\TrackLanguage(),
                'TrackTimecodeScale' => new \PHPExiftool\Driver\Tag\Matroska\TrackTimecodeScale(),
                'FrameRate' => new \PHPExiftool\Driver\Tag\Matroska\FrameRate(),
                'VideoFrameRate' => new \PHPExiftool\Driver\Tag\Matroska\VideoFrameRate(),
                'DefaultDuration' => new \PHPExiftool\Driver\Tag\Matroska\DefaultDuration(),
                'VideoCodecName' => new \PHPExiftool\Driver\Tag\Matroska\VideoCodecName(),
                'AudioCodecName' => new \PHPExiftool\Driver\Tag\Matroska\AudioCodecName(),
                'CodecName' => new \PHPExiftool\Driver\Tag\Matroska\CodecName(),
                'CodecDownloadURL' => new \PHPExiftool\Driver\Tag\Matroska\CodecDownloadURL(),
                'TimecodeScale' => new \PHPExiftool\Driver\Tag\Matroska\TimecodeScale(),
                'ColorSpace' => new \PHPExiftool\Driver\Tag\Matroska\ColorSpace(),
                'Gamma' => new \PHPExiftool\Driver\Tag\Matroska\Gamma(),
                'CodecSettings' => new \PHPExiftool\Driver\Tag\Matroska\CodecSettings(),
                'CodecInfoURL' => new \PHPExiftool\Driver\Tag\Matroska\CodecInfoURL(),
                'PrevFileName' => new \PHPExiftool\Driver\Tag\Matroska\PrevFileName(),
                'PrevUID' => new \PHPExiftool\Driver\Tag\Matroska\PrevUID(),
                'NextFileName' => new \PHPExiftool\Driver\Tag\Matroska\NextFileName(),
                'NextUID' => new \PHPExiftool\Driver\Tag\Matroska\NextUID(),
                'ProjectionType' => new \PHPExiftool\Driver\Tag\Matroska\ProjectionType(),
                'ProjectionPosYaw' => new \PHPExiftool\Driver\Tag\Matroska\ProjectionPosYaw(),
                'ProjectionPosPitch' => new \PHPExiftool\Driver\Tag\Matroska\ProjectionPosPitch(),
                'ProjectionPosRoll' => new \PHPExiftool\Driver\Tag\Matroska\ProjectionPosRoll(),
            );
        });
        $this['XMP-MP'] = $this->share(function(){
            return array(
                'RegionInfoMP' => new \PHPExiftool\Driver\Tag\XMPMP\RegionInfoMP(),
                'RegionInfoDateRegionsValid' => new \PHPExiftool\Driver\Tag\XMPMP\RegionInfoDateRegionsValid(),
                'RegionInfoRegions' => new \PHPExiftool\Driver\Tag\XMPMP\RegionInfoRegions(),
                'RegionPersonDisplayName' => new \PHPExiftool\Driver\Tag\XMPMP\RegionPersonDisplayName(),
                'RegionPersonEmailDigest' => new \PHPExiftool\Driver\Tag\XMPMP\RegionPersonEmailDigest(),
                'RegionPersonLiveIdCID' => new \PHPExiftool\Driver\Tag\XMPMP\RegionPersonLiveIdCID(),
                'RegionPersonSourceID' => new \PHPExiftool\Driver\Tag\XMPMP\RegionPersonSourceID(),
                'RegionRectangle' => new \PHPExiftool\Driver\Tag\XMPMP\RegionRectangle(),
            );
        });
        $this['XMP-MP1'] = $this->share(function(){
            return array(
                'Brightness' => new \PHPExiftool\Driver\Tag\XMPMP1\Brightness(),
                'CameraModelID' => new \PHPExiftool\Driver\Tag\XMPMP1\CameraModelID(),
                'Contrast' => new \PHPExiftool\Driver\Tag\XMPMP1\Contrast(),
                'ExposureCompensation' => new \PHPExiftool\Driver\Tag\XMPMP1\ExposureCompensation(),
                'PanoramicStitchCameraMotion' => new \PHPExiftool\Driver\Tag\XMPMP1\PanoramicStitchCameraMotion(),
                'PanoramicStitchMapType' => new \PHPExiftool\Driver\Tag\XMPMP1\PanoramicStitchMapType(),
                'PanoramicStitchPhi0' => new \PHPExiftool\Driver\Tag\XMPMP1\PanoramicStitchPhi0(),
                'PanoramicStitchPhi1' => new \PHPExiftool\Driver\Tag\XMPMP1\PanoramicStitchPhi1(),
                'PanoramicStitchTheta0' => new \PHPExiftool\Driver\Tag\XMPMP1\PanoramicStitchTheta0(),
                'PanoramicStitchTheta1' => new \PHPExiftool\Driver\Tag\XMPMP1\PanoramicStitchTheta1(),
                'PipelineVersion' => new \PHPExiftool\Driver\Tag\XMPMP1\PipelineVersion(),
                'StreamType' => new \PHPExiftool\Driver\Tag\XMPMP1\StreamType(),
                'WhiteBalance0' => new \PHPExiftool\Driver\Tag\XMPMP1\WhiteBalance0(),
                'WhiteBalance1' => new \PHPExiftool\Driver\Tag\XMPMP1\WhiteBalance1(),
                'WhiteBalance2' => new \PHPExiftool\Driver\Tag\XMPMP1\WhiteBalance2(),
            );
        });
       
        $this['PreviewIFD'] = $this->share(function(){
            return array(
                'SubfileType' => new \PHPExiftool\Driver\Tag\PreviewIFD\SubfileType(),
                'Compression' => new \PHPExiftool\Driver\Tag\PreviewIFD\Compression(),
                'XResolution' => new \PHPExiftool\Driver\Tag\PreviewIFD\XResolution(),
                'YResolution' => new \PHPExiftool\Driver\Tag\PreviewIFD\YResolution(),
                'ResolutionUnit' => new \PHPExiftool\Driver\Tag\PreviewIFD\ResolutionUnit(),
                'PreviewImageStart' => new \PHPExiftool\Driver\Tag\PreviewIFD\PreviewImageStart(),
                'PreviewImageLength' => new \PHPExiftool\Driver\Tag\PreviewIFD\PreviewImageLength(),
                'YCbCrPositioning' => new \PHPExiftool\Driver\Tag\PreviewIFD\YCbCrPositioning(),
            );
        });
       
        $this['PDF'] = $this->share(function(){
            return array(
                'ContainerVersion' => new \PHPExiftool\Driver\Tag\PDF\ContainerVersion(),
                'CreatorVersion' => new \PHPExiftool\Driver\Tag\PDF\CreatorVersion(),
                'RoundTripVersion' => new \PHPExiftool\Driver\Tag\PDF\RoundTripVersion(),
                'HasXFA' => new \PHPExiftool\Driver\Tag\PDF\HasXFA(),
                'Encryption' => new \PHPExiftool\Driver\Tag\PDF\Encryption(),
                'UserAccess' => new \PHPExiftool\Driver\Tag\PDF\UserAccess(),
                'EmbeddedImageColorSpace' => new \PHPExiftool\Driver\Tag\PDF\EmbeddedImageColorSpace(),
                'EmbeddedImageFilter' => new \PHPExiftool\Driver\Tag\PDF\EmbeddedImageFilter(),
                'EmbeddedImageHeight' => new \PHPExiftool\Driver\Tag\PDF\EmbeddedImageHeight(),
                'EmbeddedImage' => new \PHPExiftool\Driver\Tag\PDF\EmbeddedImage(),
                'EmbeddedImageWidth' => new \PHPExiftool\Driver\Tag\PDF\EmbeddedImageWidth(),
                'AppleKeywords' => new \PHPExiftool\Driver\Tag\PDF\AppleKeywords(),
                'Author' => new \PHPExiftool\Driver\Tag\PDF\Author(),
                'CreateDate' => new \PHPExiftool\Driver\Tag\PDF\CreateDate(),
                'Creator' => new \PHPExiftool\Driver\Tag\PDF\Creator(),
                'Keywords' => new \PHPExiftool\Driver\Tag\PDF\Keywords(),
                'ModifyDate' => new \PHPExiftool\Driver\Tag\PDF\ModifyDate(),
                'Producer' => new \PHPExiftool\Driver\Tag\PDF\Producer(),
                'Subject' => new \PHPExiftool\Driver\Tag\PDF\Subject(),
                'Title' => new \PHPExiftool\Driver\Tag\PDF\Title(),
                'Trapped' => new \PHPExiftool\Driver\Tag\PDF\Trapped(),
                'Linearized' => new \PHPExiftool\Driver\Tag\PDF\Linearized(),
                'TaggedPDF' => new \PHPExiftool\Driver\Tag\PDF\TaggedPDF(),
                'PageCount' => new \PHPExiftool\Driver\Tag\PDF\PageCount(),
                'Language' => new \PHPExiftool\Driver\Tag\PDF\Language(),
                'PageLayout' => new \PHPExiftool\Driver\Tag\PDF\PageLayout(),
                'PageMode' => new \PHPExiftool\Driver\Tag\PDF\PageMode(),
                'PDFVersion' => new \PHPExiftool\Driver\Tag\PDF\PDFVersion(),
                'SignerContactInfo' => new \PHPExiftool\Driver\Tag\PDF\SignerContactInfo(),
                'SigningLocation' => new \PHPExiftool\Driver\Tag\PDF\SigningLocation(),
                'SigningDate' => new \PHPExiftool\Driver\Tag\PDF\SigningDate(),
                'SigningAuthority' => new \PHPExiftool\Driver\Tag\PDF\SigningAuthority(),
                'AuthenticationTime' => new \PHPExiftool\Driver\Tag\PDF\AuthenticationTime(),
                'AuthenticationType' => new \PHPExiftool\Driver\Tag\PDF\AuthenticationType(),
                'SigningReason' => new \PHPExiftool\Driver\Tag\PDF\SigningReason(),
                'FieldPermissions' => new \PHPExiftool\Driver\Tag\PDF\FieldPermissions(),
                'AnnotationUsageRights' => new \PHPExiftool\Driver\Tag\PDF\AnnotationUsageRights(),
                'DocumentUsageRights' => new \PHPExiftool\Driver\Tag\PDF\DocumentUsageRights(),
                'EmbeddedFileUsageRights' => new \PHPExiftool\Driver\Tag\PDF\EmbeddedFileUsageRights(),
                'FormFields' => new \PHPExiftool\Driver\Tag\PDF\FormFields(),
                'FormUsageRights' => new \PHPExiftool\Driver\Tag\PDF\FormUsageRights(),
                'FormExtraUsageRights' => new \PHPExiftool\Driver\Tag\PDF\FormExtraUsageRights(),
                'UsageRightsMessage' => new \PHPExiftool\Driver\Tag\PDF\UsageRightsMessage(),
                'ModificationPermissions' => new \PHPExiftool\Driver\Tag\PDF\ModificationPermissions(),
                'SignatureUsageRights' => new \PHPExiftool\Driver\Tag\PDF\SignatureUsageRights(),
            );
        });
       
        $this['XMP-plus'] = $this->share(function(){
            return array(
                'AdultContentWarning' => new \PHPExiftool\Driver\Tag\XMPPlus\AdultContentWarning(),
                'CopyrightOwner' => new \PHPExiftool\Driver\Tag\XMPPlus\CopyrightOwner(),
                'CopyrightOwnerID' => new \PHPExiftool\Driver\Tag\XMPPlus\CopyrightOwnerID(),
                'CopyrightOwnerName' => new \PHPExiftool\Driver\Tag\XMPPlus\CopyrightOwnerName(),
                'CopyrightOwnerImageID' => new \PHPExiftool\Driver\Tag\XMPPlus\CopyrightOwnerImageID(),
                'CopyrightRegistrationNumber' => new \PHPExiftool\Driver\Tag\XMPPlus\CopyrightRegistrationNumber(),
                'CopyrightStatus' => new \PHPExiftool\Driver\Tag\XMPPlus\CopyrightStatus(),
                'CreditLineRequired' => new \PHPExiftool\Driver\Tag\XMPPlus\CreditLineRequired(),
                'Custom1' => new \PHPExiftool\Driver\Tag\XMPPlus\Custom1(),
                'Custom10' => new \PHPExiftool\Driver\Tag\XMPPlus\Custom10(),
                'Custom2' => new \PHPExiftool\Driver\Tag\XMPPlus\Custom2(),
                'Custom3' => new \PHPExiftool\Driver\Tag\XMPPlus\Custom3(),
                'Custom4' => new \PHPExiftool\Driver\Tag\XMPPlus\Custom4(),
                'Custom5' => new \PHPExiftool\Driver\Tag\XMPPlus\Custom5(),
                'Custom6' => new \PHPExiftool\Driver\Tag\XMPPlus\Custom6(),
                'Custom7' => new \PHPExiftool\Driver\Tag\XMPPlus\Custom7(),
                'Custom8' => new \PHPExiftool\Driver\Tag\XMPPlus\Custom8(),
                'Custom9' => new \PHPExiftool\Driver\Tag\XMPPlus\Custom9(),
                'EndUser' => new \PHPExiftool\Driver\Tag\XMPPlus\EndUser(),
                'EndUserID' => new \PHPExiftool\Driver\Tag\XMPPlus\EndUserID(),
                'EndUserName' => new \PHPExiftool\Driver\Tag\XMPPlus\EndUserName(),
                'FileNameAsDelivered' => new \PHPExiftool\Driver\Tag\XMPPlus\FileNameAsDelivered(),
                'FirstPublicationDate' => new \PHPExiftool\Driver\Tag\XMPPlus\FirstPublicationDate(),
                'ImageAlterationConstraints' => new \PHPExiftool\Driver\Tag\XMPPlus\ImageAlterationConstraints(),
                'ImageCreator' => new \PHPExiftool\Driver\Tag\XMPPlus\ImageCreator(),
                'ImageCreatorID' => new \PHPExiftool\Driver\Tag\XMPPlus\ImageCreatorID(),
                'ImageCreatorName' => new \PHPExiftool\Driver\Tag\XMPPlus\ImageCreatorName(),
                'ImageCreatorImageID' => new \PHPExiftool\Driver\Tag\XMPPlus\ImageCreatorImageID(),
                'ImageDuplicationConstraints' => new \PHPExiftool\Driver\Tag\XMPPlus\ImageDuplicationConstraints(),
                'ImageFileConstraints' => new \PHPExiftool\Driver\Tag\XMPPlus\ImageFileConstraints(),
                'ImageFileFormatAsDelivered' => new \PHPExiftool\Driver\Tag\XMPPlus\ImageFileFormatAsDelivered(),
                'ImageFileSizeAsDelivered' => new \PHPExiftool\Driver\Tag\XMPPlus\ImageFileSizeAsDelivered(),
                'ImageSupplier' => new \PHPExiftool\Driver\Tag\XMPPlus\ImageSupplier(),
                'ImageSupplierImageID' => new \PHPExiftool\Driver\Tag\XMPPlus\ImageSupplierImageID(),
                'ImageSupplierID' => new \PHPExiftool\Driver\Tag\XMPPlus\ImageSupplierID(),
                'ImageSupplierName' => new \PHPExiftool\Driver\Tag\XMPPlus\ImageSupplierName(),
                'ImageType' => new \PHPExiftool\Driver\Tag\XMPPlus\ImageType(),
                'LicenseEndDate' => new \PHPExiftool\Driver\Tag\XMPPlus\LicenseEndDate(),
                'LicenseID' => new \PHPExiftool\Driver\Tag\XMPPlus\LicenseID(),
                'LicenseStartDate' => new \PHPExiftool\Driver\Tag\XMPPlus\LicenseStartDate(),
                'LicenseTransactionDate' => new \PHPExiftool\Driver\Tag\XMPPlus\LicenseTransactionDate(),
                'Licensee' => new \PHPExiftool\Driver\Tag\XMPPlus\Licensee(),
                'LicenseeImageID' => new \PHPExiftool\Driver\Tag\XMPPlus\LicenseeImageID(),
                'LicenseeImageNotes' => new \PHPExiftool\Driver\Tag\XMPPlus\LicenseeImageNotes(),
                'LicenseeID' => new \PHPExiftool\Driver\Tag\XMPPlus\LicenseeID(),
                'LicenseeName' => new \PHPExiftool\Driver\Tag\XMPPlus\LicenseeName(),
                'LicenseeProjectReference' => new \PHPExiftool\Driver\Tag\XMPPlus\LicenseeProjectReference(),
                'LicenseeTransactionID' => new \PHPExiftool\Driver\Tag\XMPPlus\LicenseeTransactionID(),
                'Licensor' => new \PHPExiftool\Driver\Tag\XMPPlus\Licensor(),
                'LicensorImageID' => new \PHPExiftool\Driver\Tag\XMPPlus\LicensorImageID(),
                'LicensorCity' => new \PHPExiftool\Driver\Tag\XMPPlus\LicensorCity(),
                'LicensorCountry' => new \PHPExiftool\Driver\Tag\XMPPlus\LicensorCountry(),
                'LicensorEmail' => new \PHPExiftool\Driver\Tag\XMPPlus\LicensorEmail(),
                'LicensorExtendedAddress' => new \PHPExiftool\Driver\Tag\XMPPlus\LicensorExtendedAddress(),
                'LicensorID' => new \PHPExiftool\Driver\Tag\XMPPlus\LicensorID(),
                'LicensorName' => new \PHPExiftool\Driver\Tag\XMPPlus\LicensorName(),
                'LicensorPostalCode' => new \PHPExiftool\Driver\Tag\XMPPlus\LicensorPostalCode(),
                'LicensorRegion' => new \PHPExiftool\Driver\Tag\XMPPlus\LicensorRegion(),
                'LicensorStreetAddress' => new \PHPExiftool\Driver\Tag\XMPPlus\LicensorStreetAddress(),
                'LicensorTelephone1' => new \PHPExiftool\Driver\Tag\XMPPlus\LicensorTelephone1(),
                'LicensorTelephone2' => new \PHPExiftool\Driver\Tag\XMPPlus\LicensorTelephone2(),
                'LicensorTelephoneType1' => new \PHPExiftool\Driver\Tag\XMPPlus\LicensorTelephoneType1(),
                'LicensorTelephoneType2' => new \PHPExiftool\Driver\Tag\XMPPlus\LicensorTelephoneType2(),
                'LicensorURL' => new \PHPExiftool\Driver\Tag\XMPPlus\LicensorURL(),
                'LicensorNotes' => new \PHPExiftool\Driver\Tag\XMPPlus\LicensorNotes(),
                'LicensorTransactionID' => new \PHPExiftool\Driver\Tag\XMPPlus\LicensorTransactionID(),
                'MediaConstraints' => new \PHPExiftool\Driver\Tag\XMPPlus\MediaConstraints(),
                'MediaSummaryCode' => new \PHPExiftool\Driver\Tag\XMPPlus\MediaSummaryCode(),
                'MinorModelAgeDisclosure' => new \PHPExiftool\Driver\Tag\XMPPlus\MinorModelAgeDisclosure(),
                'ModelReleaseID' => new \PHPExiftool\Driver\Tag\XMPPlus\ModelReleaseID(),
                'ModelReleaseStatus' => new \PHPExiftool\Driver\Tag\XMPPlus\ModelReleaseStatus(),
                'OtherConditions' => new \PHPExiftool\Driver\Tag\XMPPlus\OtherConditions(),
                'OtherConstraints' => new \PHPExiftool\Driver\Tag\XMPPlus\OtherConstraints(),
                'OtherImageInfo' => new \PHPExiftool\Driver\Tag\XMPPlus\OtherImageInfo(),
                'OtherLicenseDocuments' => new \PHPExiftool\Driver\Tag\XMPPlus\OtherLicenseDocuments(),
                'OtherLicenseInfo' => new \PHPExiftool\Driver\Tag\XMPPlus\OtherLicenseInfo(),
                'OtherLicenseRequirements' => new \PHPExiftool\Driver\Tag\XMPPlus\OtherLicenseRequirements(),
                'ProductOrServiceConstraints' => new \PHPExiftool\Driver\Tag\XMPPlus\ProductOrServiceConstraints(),
                'PropertyReleaseID' => new \PHPExiftool\Driver\Tag\XMPPlus\PropertyReleaseID(),
                'PropertyReleaseStatus' => new \PHPExiftool\Driver\Tag\XMPPlus\PropertyReleaseStatus(),
                'RegionConstraints' => new \PHPExiftool\Driver\Tag\XMPPlus\RegionConstraints(),
                'Reuse' => new \PHPExiftool\Driver\Tag\XMPPlus\Reuse(),
                'TermsAndConditionsText' => new \PHPExiftool\Driver\Tag\XMPPlus\TermsAndConditionsText(),
                'TermsAndConditionsURL' => new \PHPExiftool\Driver\Tag\XMPPlus\TermsAndConditionsURL(),
                'PLUSVersion' => new \PHPExiftool\Driver\Tag\XMPPlus\PLUSVersion(),
            );
        });
        $this['PNG'] = $this->share(function(){
            return array(
                'AnimationFrames' => new \PHPExiftool\Driver\Tag\PNG\AnimationFrames(),
                'AnimationPlays' => new \PHPExiftool\Driver\Tag\PNG\AnimationPlays(),
                'ImageWidth' => new \PHPExiftool\Driver\Tag\PNG\ImageWidth(),
                'ImageHeight' => new \PHPExiftool\Driver\Tag\PNG\ImageHeight(),
                'BitDepth' => new \PHPExiftool\Driver\Tag\PNG\BitDepth(),
                'ColorType' => new \PHPExiftool\Driver\Tag\PNG\ColorType(),
                'Compression' => new \PHPExiftool\Driver\Tag\PNG\Compression(),
                'Filter' => new \PHPExiftool\Driver\Tag\PNG\Filter(),
                'Interlace' => new \PHPExiftool\Driver\Tag\PNG\Interlace(),
                'Palette' => new \PHPExiftool\Driver\Tag\PNG\Palette(),
                'BackgroundColor' => new \PHPExiftool\Driver\Tag\PNG\BackgroundColor(),
                'DigitalSignature' => new \PHPExiftool\Driver\Tag\PNG\DigitalSignature(),
                'FractalParameters' => new \PHPExiftool\Driver\Tag\PNG\FractalParameters(),
                'Gamma' => new \PHPExiftool\Driver\Tag\PNG\Gamma(),
                'GIFGraphicControlExtension' => new \PHPExiftool\Driver\Tag\PNG\GIFGraphicControlExtension(),
                'GIFPlainTextExtension' => new \PHPExiftool\Driver\Tag\PNG\GIFPlainTextExtension(),
                'GIFApplicationExtension' => new \PHPExiftool\Driver\Tag\PNG\GIFApplicationExtension(),
                'PaletteHistogram' => new \PHPExiftool\Driver\Tag\PNG\PaletteHistogram(),
                'ProfileName' => new \PHPExiftool\Driver\Tag\PNG\ProfileName(),
                'ImageOffset' => new \PHPExiftool\Driver\Tag\PNG\ImageOffset(),
                'PixelCalibration' => new \PHPExiftool\Driver\Tag\PNG\PixelCalibration(),
                'SignificantBits' => new \PHPExiftool\Driver\Tag\PNG\SignificantBits(),
                'SuggestedPalette' => new \PHPExiftool\Driver\Tag\PNG\SuggestedPalette(),
                'SRGBRendering' => new \PHPExiftool\Driver\Tag\PNG\SRGBRendering(),
                'ModifyDate' => new \PHPExiftool\Driver\Tag\PNG\ModifyDate(),
                'Transparency' => new \PHPExiftool\Driver\Tag\PNG\Transparency(),
                'WhitePointX' => new \PHPExiftool\Driver\Tag\PNG\WhitePointX(),
                'WhitePointY' => new \PHPExiftool\Driver\Tag\PNG\WhitePointY(),
                'RedX' => new \PHPExiftool\Driver\Tag\PNG\RedX(),
                'RedY' => new \PHPExiftool\Driver\Tag\PNG\RedY(),
                'GreenX' => new \PHPExiftool\Driver\Tag\PNG\GreenX(),
                'GreenY' => new \PHPExiftool\Driver\Tag\PNG\GreenY(),
                'BlueX' => new \PHPExiftool\Driver\Tag\PNG\BlueX(),
                'BlueY' => new \PHPExiftool\Driver\Tag\PNG\BlueY(),
                'StereoMode' => new \PHPExiftool\Driver\Tag\PNG\StereoMode(),
                'SubjectUnits' => new \PHPExiftool\Driver\Tag\PNG\SubjectUnits(),
                'SubjectPixelWidth' => new \PHPExiftool\Driver\Tag\PNG\SubjectPixelWidth(),
                'SubjectPixelHeight' => new \PHPExiftool\Driver\Tag\PNG\SubjectPixelHeight(),
                'Artist' => new \PHPExiftool\Driver\Tag\PNG\Artist(),
                'Author' => new \PHPExiftool\Driver\Tag\PNG\Author(),
                'Collection' => new \PHPExiftool\Driver\Tag\PNG\Collection(),
                'Comment' => new \PHPExiftool\Driver\Tag\PNG\Comment(),
                'Copyright' => new \PHPExiftool\Driver\Tag\PNG\Copyright(),
                'CreationTime' => new \PHPExiftool\Driver\Tag\PNG\CreationTime(),
                'Description' => new \PHPExiftool\Driver\Tag\PNG\Description(),
                'Disclaimer' => new \PHPExiftool\Driver\Tag\PNG\Disclaimer(),
                'Document' => new \PHPExiftool\Driver\Tag\PNG\Document(),
                'Label' => new \PHPExiftool\Driver\Tag\PNG\Label(),
                'Make' => new \PHPExiftool\Driver\Tag\PNG\Make(),
                'Model' => new \PHPExiftool\Driver\Tag\PNG\Model(),
                'Software' => new \PHPExiftool\Driver\Tag\PNG\Software(),
                'Source' => new \PHPExiftool\Driver\Tag\PNG\Source(),
                'TimeStamp' => new \PHPExiftool\Driver\Tag\PNG\TimeStamp(),
                'Title' => new \PHPExiftool\Driver\Tag\PNG\Title(),
                'URL' => new \PHPExiftool\Driver\Tag\PNG\URL(),
                'PNGWarning' => new \PHPExiftool\Driver\Tag\PNG\PNGWarning(),
                'CreateDate' => new \PHPExiftool\Driver\Tag\PNG\CreateDate(),
                'ModDate' => new \PHPExiftool\Driver\Tag\PNG\ModDate(),
                'VirtualImageWidth' => new \PHPExiftool\Driver\Tag\PNG\VirtualImageWidth(),
                'VirtualImageHeight' => new \PHPExiftool\Driver\Tag\PNG\VirtualImageHeight(),
                'VirtualPageUnits' => new \PHPExiftool\Driver\Tag\PNG\VirtualPageUnits(),
            );
        });
        $this['PNG-pHYs'] = $this->share(function(){
            return array(
                'PixelsPerUnitX' => new \PHPExiftool\Driver\Tag\PNGPHYs\PixelsPerUnitX(),
                'PixelsPerUnitY' => new \PHPExiftool\Driver\Tag\PNGPHYs\PixelsPerUnitY(),
                'PixelUnits' => new \PHPExiftool\Driver\Tag\PNGPHYs\PixelUnits(),
            );
        });
        $this['PhotoMechanic'] = $this->share(function(){
            return array(
                'RawCropLeft' => new \PHPExiftool\Driver\Tag\PhotoMechanic\RawCropLeft(),
                'RawCropTop' => new \PHPExiftool\Driver\Tag\PhotoMechanic\RawCropTop(),
                'RawCropRight' => new \PHPExiftool\Driver\Tag\PhotoMechanic\RawCropRight(),
                'RawCropBottom' => new \PHPExiftool\Driver\Tag\PhotoMechanic\RawCropBottom(),
                'ConstrainedCropWidth' => new \PHPExiftool\Driver\Tag\PhotoMechanic\ConstrainedCropWidth(),
                'ConstrainedCropHeight' => new \PHPExiftool\Driver\Tag\PhotoMechanic\ConstrainedCropHeight(),
                'FrameNum' => new \PHPExiftool\Driver\Tag\PhotoMechanic\FrameNum(),
                'Rotation' => new \PHPExiftool\Driver\Tag\PhotoMechanic\Rotation(),
                'CropLeft' => new \PHPExiftool\Driver\Tag\PhotoMechanic\CropLeft(),
                'CropTop' => new \PHPExiftool\Driver\Tag\PhotoMechanic\CropTop(),
                'CropRight' => new \PHPExiftool\Driver\Tag\PhotoMechanic\CropRight(),
                'CropBottom' => new \PHPExiftool\Driver\Tag\PhotoMechanic\CropBottom(),
                'Tagged' => new \PHPExiftool\Driver\Tag\PhotoMechanic\Tagged(),
                'ColorClass' => new \PHPExiftool\Driver\Tag\PhotoMechanic\ColorClass(),
                'Rating' => new \PHPExiftool\Driver\Tag\PhotoMechanic\Rating(),
                'PreviewCropLeft' => new \PHPExiftool\Driver\Tag\PhotoMechanic\PreviewCropLeft(),
                'PreviewCropTop' => new \PHPExiftool\Driver\Tag\PhotoMechanic\PreviewCropTop(),
                'PreviewCropRight' => new \PHPExiftool\Driver\Tag\PhotoMechanic\PreviewCropRight(),
                'PreviewCropBottom' => new \PHPExiftool\Driver\Tag\PhotoMechanic\PreviewCropBottom(),
            );
        });
        $this['XMP-photomech'] = $this->share(function(){
            return array(
                'ColorClass' => new \PHPExiftool\Driver\Tag\XMPPhotomech\ColorClass(),
                'CountryCode' => new \PHPExiftool\Driver\Tag\XMPPhotomech\CountryCode(),
                'EditStatus' => new \PHPExiftool\Driver\Tag\XMPPhotomech\EditStatus(),
                'PMVersion' => new \PHPExiftool\Driver\Tag\XMPPhotomech\PMVersion(),
                'Prefs' => new \PHPExiftool\Driver\Tag\XMPPhotomech\Prefs(),
                'Tagged' => new \PHPExiftool\Driver\Tag\XMPPhotomech\Tagged(),
                'TimeCreated' => new \PHPExiftool\Driver\Tag\XMPPhotomech\TimeCreated(),
            );
        });
        
        $this['MakerNotes'] = $this->share(function(){
            return array(
                'PreviewImageWidth' => new \PHPExiftool\Driver\Tag\MakerNotes\PreviewImageWidth(),
                'PreviewImageHeight' => new \PHPExiftool\Driver\Tag\MakerNotes\PreviewImageHeight(),
                'PreviewImageLength' => new \PHPExiftool\Driver\Tag\MakerNotes\PreviewImageLength(),
                'SerialNumber' => new \PHPExiftool\Driver\Tag\MakerNotes\SerialNumber(),
                'PreviewImage' => new \PHPExiftool\Driver\Tag\MakerNotes\PreviewImage(),
                'Model' => new \PHPExiftool\Driver\Tag\MakerNotes\Model(),
                'Firmware' => new \PHPExiftool\Driver\Tag\MakerNotes\Firmware(),
                'Parameters' => new \PHPExiftool\Driver\Tag\MakerNotes\Parameters(),
            );
        });
        $this['ItemList'] = $this->share(function(){
            return array(
                'ParentShortTitle' => new \PHPExiftool\Driver\Tag\ItemList\ParentShortTitle(),
                'ParentProductID' => new \PHPExiftool\Driver\Tag\ItemList\ParentProductID(),
                'ParentTitle' => new \PHPExiftool\Driver\Tag\ItemList\ParentTitle(),
                'ShortTitle' => new \PHPExiftool\Driver\Tag\ItemList\ShortTitle(),
                'Unknown_AACR' => new \PHPExiftool\Driver\Tag\ItemList\UnknownAACR(),
                'Unknown_CDEK' => new \PHPExiftool\Driver\Tag\ItemList\UnknownCDEK(),
                'Unknown_CDET' => new \PHPExiftool\Driver\Tag\ItemList\UnknownCDET(),
                'GUID' => new \PHPExiftool\Driver\Tag\ItemList\GUID(),
                'ProductVersion' => new \PHPExiftool\Driver\Tag\ItemList\ProductVersion(),
                'AlbumArtist' => new \PHPExiftool\Driver\Tag\ItemList\AlbumArtist(),
                'AppleStoreAccountType' => new \PHPExiftool\Driver\Tag\ItemList\AppleStoreAccountType(),
                'Album' => new \PHPExiftool\Driver\Tag\ItemList\Album(),
                'AppleStoreAccount' => new \PHPExiftool\Driver\Tag\ItemList\AppleStoreAccount(),
                'AlbumTitleID' => new \PHPExiftool\Driver\Tag\ItemList\AlbumTitleID(),
                'Author' => new \PHPExiftool\Driver\Tag\ItemList\Author(),
                'Category' => new \PHPExiftool\Driver\Tag\ItemList\Category(),
                'AppleStoreCatalogID' => new \PHPExiftool\Driver\Tag\ItemList\AppleStoreCatalogID(),
                'CoverArt' => new \PHPExiftool\Driver\Tag\ItemList\CoverArt(),
                'Compilation' => new \PHPExiftool\Driver\Tag\ItemList\Compilation(),
                'Copyright' => new \PHPExiftool\Driver\Tag\ItemList\Copyright(),
                'Description' => new \PHPExiftool\Driver\Tag\ItemList\Description(),
                'DiskNumber' => new \PHPExiftool\Driver\Tag\ItemList\DiskNumber(),
                'EpisodeGlobalUniqueID' => new \PHPExiftool\Driver\Tag\ItemList\EpisodeGlobalUniqueID(),
                'GenreID' => new \PHPExiftool\Driver\Tag\ItemList\GenreID(),
                'Genre' => new \PHPExiftool\Driver\Tag\ItemList\Genre(),
                'Grouping' => new \PHPExiftool\Driver\Tag\ItemList\Grouping(),
                'GoogleHostHeader' => new \PHPExiftool\Driver\Tag\ItemList\GoogleHostHeader(),
                'GooglePingMessage' => new \PHPExiftool\Driver\Tag\ItemList\GooglePingMessage(),
                'GooglePingURL' => new \PHPExiftool\Driver\Tag\ItemList\GooglePingURL(),
                'GoogleSourceData' => new \PHPExiftool\Driver\Tag\ItemList\GoogleSourceData(),
                'GoogleStartTime' => new \PHPExiftool\Driver\Tag\ItemList\GoogleStartTime(),
                'GoogleTrackDuration' => new \PHPExiftool\Driver\Tag\ItemList\GoogleTrackDuration(),
                'HDVideo' => new \PHPExiftool\Driver\Tag\ItemList\HDVideo(),
                'iTunesU' => new \PHPExiftool\Driver\Tag\ItemList\ITunesU(),
                'Keyword' => new \PHPExiftool\Driver\Tag\ItemList\Keyword(),
                'LongDescription' => new \PHPExiftool\Driver\Tag\ItemList\LongDescription(),
                'Podcast' => new \PHPExiftool\Driver\Tag\ItemList\Podcast(),
                'Performer' => new \PHPExiftool\Driver\Tag\ItemList\Performer(),
                'PlayGap' => new \PHPExiftool\Driver\Tag\ItemList\PlayGap(),
                'PlayListID' => new \PHPExiftool\Driver\Tag\ItemList\PlayListID(),
                'ProductID' => new \PHPExiftool\Driver\Tag\ItemList\ProductID(),
                'PurchaseDate' => new \PHPExiftool\Driver\Tag\ItemList\PurchaseDate(),
                'PodcastURL' => new \PHPExiftool\Driver\Tag\ItemList\PodcastURL(),
                'RatingPercent' => new \PHPExiftool\Driver\Tag\ItemList\RatingPercent(),
                'ReleaseDate' => new \PHPExiftool\Driver\Tag\ItemList\ReleaseDate(),
                'Rating' => new \PHPExiftool\Driver\Tag\ItemList\Rating(),
                'AppleStoreCountry' => new \PHPExiftool\Driver\Tag\ItemList\AppleStoreCountry(),
                'SortAlbumArtist' => new \PHPExiftool\Driver\Tag\ItemList\SortAlbumArtist(),
                'SortAlbum' => new \PHPExiftool\Driver\Tag\ItemList\SortAlbum(),
                'SortArtist' => new \PHPExiftool\Driver\Tag\ItemList\SortArtist(),
                'SortComposer' => new \PHPExiftool\Driver\Tag\ItemList\SortComposer(),
                'SortName' => new \PHPExiftool\Driver\Tag\ItemList\SortName(),
                'SortShow' => new \PHPExiftool\Driver\Tag\ItemList\SortShow(),
                'MediaType' => new \PHPExiftool\Driver\Tag\ItemList\MediaType(),
                'Title' => new \PHPExiftool\Driver\Tag\ItemList\Title(),
                'BeatsPerMinute' => new \PHPExiftool\Driver\Tag\ItemList\BeatsPerMinute(),
                'TrackNumber' => new \PHPExiftool\Driver\Tag\ItemList\TrackNumber(),
                'TVEpisodeID' => new \PHPExiftool\Driver\Tag\ItemList\TVEpisodeID(),
                'TVEpisode' => new \PHPExiftool\Driver\Tag\ItemList\TVEpisode(),
                'TVNetworkName' => new \PHPExiftool\Driver\Tag\ItemList\TVNetworkName(),
                'TVShow' => new \PHPExiftool\Driver\Tag\ItemList\TVShow(),
                'TVSeason' => new \PHPExiftool\Driver\Tag\ItemList\TVSeason(),
                'Year' => new \PHPExiftool\Driver\Tag\ItemList\Year(),
                'Artist' => new \PHPExiftool\Driver\Tag\ItemList\Artist(),
                'Comment' => new \PHPExiftool\Driver\Tag\ItemList\Comment(),
                'Composer' => new \PHPExiftool\Driver\Tag\ItemList\Composer(),
                'ContentCreateDate' => new \PHPExiftool\Driver\Tag\ItemList\ContentCreateDate(),
                'EncodedBy' => new \PHPExiftool\Driver\Tag\ItemList\EncodedBy(),
                'Lyrics' => new \PHPExiftool\Driver\Tag\ItemList\Lyrics(),
                'Narrator' => new \PHPExiftool\Driver\Tag\ItemList\Narrator(),
                'Publisher' => new \PHPExiftool\Driver\Tag\ItemList\Publisher(),
                'Encoder' => new \PHPExiftool\Driver\Tag\ItemList\Encoder(),
                'Track' => new \PHPExiftool\Driver\Tag\ItemList\Track(),
            );
        });
        $this['Keys'] = $this->share(function(){
            return array(
                'EncodedWith' => new \PHPExiftool\Driver\Tag\Keys\EncodedWith(),
                'Album' => new \PHPExiftool\Driver\Tag\Keys\Album(),
                'Artist' => new \PHPExiftool\Driver\Tag\Keys\Artist(),
                'Artwork' => new \PHPExiftool\Driver\Tag\Keys\Artwork(),
                'Author' => new \PHPExiftool\Driver\Tag\Keys\Author(),
                'FrameReadoutTime' => new \PHPExiftool\Driver\Tag\Keys\FrameReadoutTime(),
                'CameraIdentifier' => new \PHPExiftool\Driver\Tag\Keys\CameraIdentifier(),
                'UserCollection' => new \PHPExiftool\Driver\Tag\Keys\UserCollection(),
                'AndroidVersion' => new \PHPExiftool\Driver\Tag\Keys\AndroidVersion(),
                'CaptureMode' => new \PHPExiftool\Driver\Tag\Keys\CaptureMode(),
                'Comment' => new \PHPExiftool\Driver\Tag\Keys\Comment(),
                'Copyright' => new \PHPExiftool\Driver\Tag\Keys\Copyright(),
                'CreationDate' => new \PHPExiftool\Driver\Tag\Keys\CreationDate(),
                'Description' => new \PHPExiftool\Driver\Tag\Keys\Description(),
                'DetectedFaceBounds' => new \PHPExiftool\Driver\Tag\Keys\DetectedFaceBounds(),
                'DetectedFaceID' => new \PHPExiftool\Driver\Tag\Keys\DetectedFaceID(),
                'DetectedFaceRollAngle' => new \PHPExiftool\Driver\Tag\Keys\DetectedFaceRollAngle(),
                'DetectedFaceYawAngle' => new \PHPExiftool\Driver\Tag\Keys\DetectedFaceYawAngle(),
                'CameraDirection' => new \PHPExiftool\Driver\Tag\Keys\CameraDirection(),
                'CameraMotion' => new \PHPExiftool\Driver\Tag\Keys\CameraMotion(),
                'Director' => new \PHPExiftool\Driver\Tag\Keys\Director(),
                'DisplayName' => new \PHPExiftool\Driver\Tag\Keys\DisplayName(),
                'Genre' => new \PHPExiftool\Driver\Tag\Keys\Genre(),
                'Information' => new \PHPExiftool\Driver\Tag\Keys\Information(),
                'Keywords' => new \PHPExiftool\Driver\Tag\Keys\Keywords(),
                'LivePhotoInfo' => new \PHPExiftool\Driver\Tag\Keys\LivePhotoInfo(),
                'GPSCoordinates' => new \PHPExiftool\Driver\Tag\Keys\GPSCoordinates(),
                'LocationBody' => new \PHPExiftool\Driver\Tag\Keys\LocationBody(),
                'LocationDate' => new \PHPExiftool\Driver\Tag\Keys\LocationDate(),
                'LocationName' => new \PHPExiftool\Driver\Tag\Keys\LocationName(),
                'LocationNote' => new \PHPExiftool\Driver\Tag\Keys\LocationNote(),
                'LocationRole' => new \PHPExiftool\Driver\Tag\Keys\LocationRole(),
                'Make' => new \PHPExiftool\Driver\Tag\Keys\Make(),
                'Model' => new \PHPExiftool\Driver\Tag\Keys\Model(),
                'Balance' => new \PHPExiftool\Driver\Tag\Keys\Balance(),
                'Bass' => new \PHPExiftool\Driver\Tag\Keys\Bass(),
                'AudioGain' => new \PHPExiftool\Driver\Tag\Keys\AudioGain(),
                'Mute' => new \PHPExiftool\Driver\Tag\Keys\Mute(),
                'PitchShift' => new \PHPExiftool\Driver\Tag\Keys\PitchShift(),
                'Trebel' => new \PHPExiftool\Driver\Tag\Keys\Trebel(),
                'Brightness' => new \PHPExiftool\Driver\Tag\Keys\Brightness(),
                'Color' => new \PHPExiftool\Driver\Tag\Keys\Color(),
                'Contrast' => new \PHPExiftool\Driver\Tag\Keys\Contrast(),
                'Tint' => new \PHPExiftool\Driver\Tag\Keys\Tint(),
                'PlayerVersion' => new \PHPExiftool\Driver\Tag\Keys\PlayerVersion(),
                'Producer' => new \PHPExiftool\Driver\Tag\Keys\Producer(),
                'Publisher' => new \PHPExiftool\Driver\Tag\Keys\Publisher(),
                'UserRating' => new \PHPExiftool\Driver\Tag\Keys\UserRating(),
                'Software' => new \PHPExiftool\Driver\Tag\Keys\Software(),
                'StillImageTime' => new \PHPExiftool\Driver\Tag\Keys\StillImageTime(),
                'Title' => new \PHPExiftool\Driver\Tag\Keys\Title(),
                'Version' => new \PHPExiftool\Driver\Tag\Keys\Version(),
                'VideoOrientation' => new \PHPExiftool\Driver\Tag\Keys\VideoOrientation(),
                'Year' => new \PHPExiftool\Driver\Tag\Keys\Year(),
            );
        });
        $this['Track#'] = $this->share(function(){
            return array(
                'MediaHeaderVersion' => new \PHPExiftool\Driver\Tag\Track\MediaHeaderVersion(),
                'MediaCreateDate' => new \PHPExiftool\Driver\Tag\Track\MediaCreateDate(),
                'MediaModifyDate' => new \PHPExiftool\Driver\Tag\Track\MediaModifyDate(),
                'MediaTimeScale' => new \PHPExiftool\Driver\Tag\Track\MediaTimeScale(),
                'MediaDuration' => new \PHPExiftool\Driver\Tag\Track\MediaDuration(),
                'MediaLanguageCode' => new \PHPExiftool\Driver\Tag\Track\MediaLanguageCode(),
                'NullMediaHeader' => new \PHPExiftool\Driver\Tag\Track\NullMediaHeader(),
                'UUID-Unknown' => new \PHPExiftool\Driver\Tag\Track\UUIDUnknown(),
                'CleanApertureDimensions' => new \PHPExiftool\Driver\Tag\Track\CleanApertureDimensions(),
                'EncodedPixelsDimensions' => new \PHPExiftool\Driver\Tag\Track\EncodedPixelsDimensions(),
                'ProductionApertureDimensions' => new \PHPExiftool\Driver\Tag\Track\ProductionApertureDimensions(),
                'TrackHeaderVersion' => new \PHPExiftool\Driver\Tag\Track\TrackHeaderVersion(),
                'TrackCreateDate' => new \PHPExiftool\Driver\Tag\Track\TrackCreateDate(),
                'TrackModifyDate' => new \PHPExiftool\Driver\Tag\Track\TrackModifyDate(),
                'TrackID' => new \PHPExiftool\Driver\Tag\Track\TrackID(),
                'TrackDuration' => new \PHPExiftool\Driver\Tag\Track\TrackDuration(),
                'ImageSizeLookahead' => new \PHPExiftool\Driver\Tag\Track\ImageSizeLookahead(),
                'TrackLayer' => new \PHPExiftool\Driver\Tag\Track\TrackLayer(),
                'TrackVolume' => new \PHPExiftool\Driver\Tag\Track\TrackVolume(),
                'MatrixStructure' => new \PHPExiftool\Driver\Tag\Track\MatrixStructure(),
                'ImageWidth' => new \PHPExiftool\Driver\Tag\Track\ImageWidth(),
                'ImageHeight' => new \PHPExiftool\Driver\Tag\Track\ImageHeight(),
                'ContentDescribes' => new \PHPExiftool\Driver\Tag\Track\ContentDescribes(),
                'ChapterListTrackID' => new \PHPExiftool\Driver\Tag\Track\ChapterListTrackID(),
                'ElementaryStreamTrack' => new \PHPExiftool\Driver\Tag\Track\ElementaryStreamTrack(),
                'TimeCode' => new \PHPExiftool\Driver\Tag\Track\TimeCode(),
            );
        });
        $this['Meta'] = $this->share(function(){
            return array(
                'BinaryXML' => new \PHPExiftool\Driver\Tag\Meta\BinaryXML(),
                'Free' => new \PHPExiftool\Driver\Tag\Meta\Free(),
                'ItemLocation' => new \PHPExiftool\Driver\Tag\Meta\ItemLocation(),
                'IPMPControl' => new \PHPExiftool\Driver\Tag\Meta\IPMPControl(),
                'ItemProtection' => new \PHPExiftool\Driver\Tag\Meta\ItemProtection(),
                'PrimaryItemReference' => new \PHPExiftool\Driver\Tag\Meta\PrimaryItemReference(),
            );
        });
        $this['UserData'] = $this->share(function(){
            return array(
                'PlayAllFrames' => new \PHPExiftool\Driver\Tag\UserData\PlayAllFrames(),
                'SerialNumberHash' => new \PHPExiftool\Driver\Tag\UserData\SerialNumberHash(),
                'CompressorVersion' => new \PHPExiftool\Driver\Tag\UserData\CompressorVersion(),
                'FirmwareVersion' => new \PHPExiftool\Driver\Tag\UserData\FirmwareVersion(),
                'Model' => new \PHPExiftool\Driver\Tag\UserData\Model(),
                'FieldOfView' => new \PHPExiftool\Driver\Tag\UserData\FieldOfView(),
                'GoProType' => new \PHPExiftool\Driver\Tag\UserData\GoProType(),
                'LensSerialNumber' => new \PHPExiftool\Driver\Tag\UserData\LensSerialNumber(),
                'LoopStyle' => new \PHPExiftool\Driver\Tag\UserData\LoopStyle(),
                'LevelMeter' => new \PHPExiftool\Driver\Tag\UserData\LevelMeter(),
                'MakerNotePentaxUnknown' => new \PHPExiftool\Driver\Tag\UserData\MakerNotePentaxUnknown(),
                'PreviewImage' => new \PHPExiftool\Driver\Tag\UserData\PreviewImage(),
                'PlayMode' => new \PHPExiftool\Driver\Tag\UserData\PlayMode(),
                'SerialNumber' => new \PHPExiftool\Driver\Tag\UserData\SerialNumber(),
                'PlaySelection' => new \PHPExiftool\Driver\Tag\UserData\PlaySelection(),
                'UnknownTags' => new \PHPExiftool\Driver\Tag\UserData\UnknownTags(),
                'WindowLocation' => new \PHPExiftool\Driver\Tag\UserData\WindowLocation(),
                'CX' => new \PHPExiftool\Driver\Tag\UserData\CX(),
                'CY' => new \PHPExiftool\Driver\Tag\UserData\CY(),
                'Yaw' => new \PHPExiftool\Driver\Tag\UserData\Yaw(),
                'Unknown_adzc' => new \PHPExiftool\Driver\Tag\UserData\UnknownAdzc(),
                'Unknown_adze' => new \PHPExiftool\Driver\Tag\UserData\UnknownAdze(),
                'Unknown_adzm' => new \PHPExiftool\Driver\Tag\UserData\UnknownAdzm(),
                'Album' => new \PHPExiftool\Driver\Tag\UserData\Album(),
                'AlbumArtist' => new \PHPExiftool\Driver\Tag\UserData\AlbumArtist(),
                'CameraAngle' => new \PHPExiftool\Driver\Tag\UserData\CameraAngle(),
                'ApertureMode' => new \PHPExiftool\Driver\Tag\UserData\ApertureMode(),
                'Author' => new \PHPExiftool\Driver\Tag\UserData\Author(),
                'ContentID' => new \PHPExiftool\Driver\Tag\UserData\ContentID(),
                'ContentDistributorID' => new \PHPExiftool\Driver\Tag\UserData\ContentDistributorID(),
                'ChapterList' => new \PHPExiftool\Driver\Tag\UserData\ChapterList(),
                'ClipFileName' => new \PHPExiftool\Driver\Tag\UserData\ClipFileName(),
                'ClipID' => new \PHPExiftool\Driver\Tag\UserData\ClipID(),
                'Classification' => new \PHPExiftool\Driver\Tag\UserData\Classification(),
                'CameraID' => new \PHPExiftool\Driver\Tag\UserData\CameraID(),
                'CollectionName' => new \PHPExiftool\Driver\Tag\UserData\CollectionName(),
                'Copyright' => new \PHPExiftool\Driver\Tag\UserData\Copyright(),
                'CodeVersion' => new \PHPExiftool\Driver\Tag\UserData\CodeVersion(),
                'CoverURI' => new \PHPExiftool\Driver\Tag\UserData\CoverURI(),
                'DateTimeOriginal' => new \PHPExiftool\Driver\Tag\UserData\DateTimeOriginal(),
                'Description' => new \PHPExiftool\Driver\Tag\UserData\Description(),
                'Genre' => new \PHPExiftool\Driver\Tag\UserData\Genre(),
                'HintVersion' => new \PHPExiftool\Driver\Tag\UserData\HintVersion(),
                'IconURI' => new \PHPExiftool\Driver\Tag\UserData\IconURI(),
                'InfoURL' => new \PHPExiftool\Driver\Tag\UserData\InfoURL(),
                'TrackType' => new \PHPExiftool\Driver\Tag\UserData\TrackType(),
                'Keywords' => new \PHPExiftool\Driver\Tag\UserData\Keywords(),
                'LocationInformation' => new \PHPExiftool\Driver\Tag\UserData\LocationInformation(),
                'LyricsURI' => new \PHPExiftool\Driver\Tag\UserData\LyricsURI(),
                'Make' => new \PHPExiftool\Driver\Tag\UserData\Make(),
                'Name' => new \PHPExiftool\Driver\Tag\UserData\Name(),
                'Performer' => new \PHPExiftool\Driver\Tag\UserData\Performer(),
                'Pitch' => new \PHPExiftool\Driver\Tag\UserData\Pitch(),
                'Rads' => new \PHPExiftool\Driver\Tag\UserData\Rads(),
                'ReelName' => new \PHPExiftool\Driver\Tag\UserData\ReelName(),
                'Roll' => new \PHPExiftool\Driver\Tag\UserData\Roll(),
                'Rating' => new \PHPExiftool\Driver\Tag\UserData\Rating(),
                'Scene' => new \PHPExiftool\Driver\Tag\UserData\Scene(),
                'ShotName' => new \PHPExiftool\Driver\Tag\UserData\ShotName(),
                'ThumbnailImage' => new \PHPExiftool\Driver\Tag\UserData\ThumbnailImage(),
                'ThumbnailPNG' => new \PHPExiftool\Driver\Tag\UserData\ThumbnailPNG(),
                'UnknownThumbnail' => new \PHPExiftool\Driver\Tag\UserData\UnknownThumbnail(),
                'Title' => new \PHPExiftool\Driver\Tag\UserData\Title(),
                'UserRating' => new \PHPExiftool\Driver\Tag\UserData\UserRating(),
                'Vendor' => new \PHPExiftool\Driver\Tag\UserData\Vendor(),
                'Year' => new \PHPExiftool\Driver\Tag\UserData\Year(),
                'Artist' => new \PHPExiftool\Driver\Tag\UserData\Artist(),
                'StartTimecode' => new \PHPExiftool\Driver\Tag\UserData\StartTimecode(),
                'StartTimeScale' => new \PHPExiftool\Driver\Tag\UserData\StartTimeScale(),
                'StartTimeSampleSize' => new \PHPExiftool\Driver\Tag\UserData\StartTimeSampleSize(),
                'Arranger' => new \PHPExiftool\Driver\Tag\UserData\Arranger(),
                'ArrangerKeywords' => new \PHPExiftool\Driver\Tag\UserData\ArrangerKeywords(),
                'Comment' => new \PHPExiftool\Driver\Tag\UserData\Comment(),
                'ComposerKeywords' => new \PHPExiftool\Driver\Tag\UserData\ComposerKeywords(),
                'Composer' => new \PHPExiftool\Driver\Tag\UserData\Composer(),
                'ContentCreateDate' => new \PHPExiftool\Driver\Tag\UserData\ContentCreateDate(),
                'Director' => new \PHPExiftool\Driver\Tag\UserData\Director(),
                'UserData_dji' => new \PHPExiftool\Driver\Tag\UserData\UserDataDji(),
                'Edit1' => new \PHPExiftool\Driver\Tag\UserData\Edit1(),
                'Edit2' => new \PHPExiftool\Driver\Tag\UserData\Edit2(),
                'Edit3' => new \PHPExiftool\Driver\Tag\UserData\Edit3(),
                'Edit4' => new \PHPExiftool\Driver\Tag\UserData\Edit4(),
                'Edit5' => new \PHPExiftool\Driver\Tag\UserData\Edit5(),
                'Edit6' => new \PHPExiftool\Driver\Tag\UserData\Edit6(),
                'Edit7' => new \PHPExiftool\Driver\Tag\UserData\Edit7(),
                'Edit8' => new \PHPExiftool\Driver\Tag\UserData\Edit8(),
                'Edit9' => new \PHPExiftool\Driver\Tag\UserData\Edit9(),
                'EncoderID' => new \PHPExiftool\Driver\Tag\UserData\EncoderID(),
                'Format' => new \PHPExiftool\Driver\Tag\UserData\Format(),
                'CameraPitch' => new \PHPExiftool\Driver\Tag\UserData\CameraPitch(),
                'CameraRoll' => new \PHPExiftool\Driver\Tag\UserData\CameraRoll(),
                'Grouping' => new \PHPExiftool\Driver\Tag\UserData\Grouping(),
                'CameraYaw' => new \PHPExiftool\Driver\Tag\UserData\CameraYaw(),
                'Information' => new \PHPExiftool\Driver\Tag\UserData\Information(),
                'ISRCCode' => new \PHPExiftool\Driver\Tag\UserData\ISRCCode(),
                'RecordLabelName' => new \PHPExiftool\Driver\Tag\UserData\RecordLabelName(),
                'RecordLabelURL' => new \PHPExiftool\Driver\Tag\UserData\RecordLabelURL(),
                'Lyrics' => new \PHPExiftool\Driver\Tag\UserData\Lyrics(),
                'MakerURL' => new \PHPExiftool\Driver\Tag\UserData\MakerURL(),
                'ProducerKeywords' => new \PHPExiftool\Driver\Tag\UserData\ProducerKeywords(),
                'RecordingCopyright' => new \PHPExiftool\Driver\Tag\UserData\RecordingCopyright(),
                'Producer' => new \PHPExiftool\Driver\Tag\UserData\Producer(),
                'Performers' => new \PHPExiftool\Driver\Tag\UserData\Performers(),
                'PerformerKeywords' => new \PHPExiftool\Driver\Tag\UserData\PerformerKeywords(),
                'PerformerURL' => new \PHPExiftool\Driver\Tag\UserData\PerformerURL(),
                'Requirements' => new \PHPExiftool\Driver\Tag\UserData\Requirements(),
                'UserData_res' => new \PHPExiftool\Driver\Tag\UserData\UserDataRes(),
                'SubtitleKeywords' => new \PHPExiftool\Driver\Tag\UserData\SubtitleKeywords(),
                'Subtitle' => new \PHPExiftool\Driver\Tag\UserData\Subtitle(),
                'SourceCredits' => new \PHPExiftool\Driver\Tag\UserData\SourceCredits(),
                'SongWriter' => new \PHPExiftool\Driver\Tag\UserData\SongWriter(),
                'SongWriterKeywords' => new \PHPExiftool\Driver\Tag\UserData\SongWriterKeywords(),
                'SoftwareVersion' => new \PHPExiftool\Driver\Tag\UserData\SoftwareVersion(),
                'Encoder' => new \PHPExiftool\Driver\Tag\UserData\Encoder(),
                'Track' => new \PHPExiftool\Driver\Tag\UserData\Track(),
                'UserData_uid' => new \PHPExiftool\Driver\Tag\UserData\UserDataUid(),
                'SpeedX' => new \PHPExiftool\Driver\Tag\UserData\SpeedX(),
                'GPSCoordinates' => new \PHPExiftool\Driver\Tag\UserData\GPSCoordinates(),
                'SpeedY' => new \PHPExiftool\Driver\Tag\UserData\SpeedY(),
                'SpeedZ' => new \PHPExiftool\Driver\Tag\UserData\SpeedZ(),
            );
        });
        $this['RIFF'] = $this->share(function(){
            return array(
                'AlphaPreprocessing' => new \PHPExiftool\Driver\Tag\RIFF\AlphaPreprocessing(),
                'AlphaFiltering' => new \PHPExiftool\Driver\Tag\RIFF\AlphaFiltering(),
                'AlphaCompression' => new \PHPExiftool\Driver\Tag\RIFF\AlphaCompression(),
                'BackgroundColor' => new \PHPExiftool\Driver\Tag\RIFF\BackgroundColor(),
                'AnimationLoopCount' => new \PHPExiftool\Driver\Tag\RIFF\AnimationLoopCount(),
                'Duration' => new \PHPExiftool\Driver\Tag\RIFF\Duration(),
                'FrameRate' => new \PHPExiftool\Driver\Tag\RIFF\FrameRate(),
                'MaxDataRate' => new \PHPExiftool\Driver\Tag\RIFF\MaxDataRate(),
                'FrameCount' => new \PHPExiftool\Driver\Tag\RIFF\FrameCount(),
                'StreamCount' => new \PHPExiftool\Driver\Tag\RIFF\StreamCount(),
                'ImageWidth' => new \PHPExiftool\Driver\Tag\RIFF\ImageWidth(),
                'ImageHeight' => new \PHPExiftool\Driver\Tag\RIFF\ImageHeight(),
                'Encoding' => new \PHPExiftool\Driver\Tag\RIFF\Encoding(),
                'NumChannels' => new \PHPExiftool\Driver\Tag\RIFF\NumChannels(),
                'SampleRate' => new \PHPExiftool\Driver\Tag\RIFF\SampleRate(),
                'AvgBytesPerSec' => new \PHPExiftool\Driver\Tag\RIFF\AvgBytesPerSec(),
                'BitsPerSample' => new \PHPExiftool\Driver\Tag\RIFF\BitsPerSample(),
                'Description' => new \PHPExiftool\Driver\Tag\RIFF\Description(),
                'Originator' => new \PHPExiftool\Driver\Tag\RIFF\Originator(),
                'OriginatorReference' => new \PHPExiftool\Driver\Tag\RIFF\OriginatorReference(),
                'DateTimeOriginal' => new \PHPExiftool\Driver\Tag\RIFF\DateTimeOriginal(),
                'TimeReference' => new \PHPExiftool\Driver\Tag\RIFF\TimeReference(),
                'BWFVersion' => new \PHPExiftool\Driver\Tag\RIFF\BWFVersion(),
                'BWF_UMID' => new \PHPExiftool\Driver\Tag\RIFF\BWFUMID(),
                'CodingHistory' => new \PHPExiftool\Driver\Tag\RIFF\CodingHistory(),
                'CodePage' => new \PHPExiftool\Driver\Tag\RIFF\CodePage(),
                'CountryCode' => new \PHPExiftool\Driver\Tag\RIFF\CountryCode(),
                'LanguageCode' => new \PHPExiftool\Driver\Tag\RIFF\LanguageCode(),
                'Dialect' => new \PHPExiftool\Driver\Tag\RIFF\Dialect(),
                'RIFFSize64' => new \PHPExiftool\Driver\Tag\RIFF\RIFFSize64(),
                'DataSize64' => new \PHPExiftool\Driver\Tag\RIFF\DataSize64(),
                'NumberOfSamples64' => new \PHPExiftool\Driver\Tag\RIFF\NumberOfSamples64(),
                'Make' => new \PHPExiftool\Driver\Tag\RIFF\Make(),
                'Model' => new \PHPExiftool\Driver\Tag\RIFF\Model(),
                'MakerNotes' => new \PHPExiftool\Driver\Tag\RIFF\MakerNotes(),
                'RelatedImageFile' => new \PHPExiftool\Driver\Tag\RIFF\RelatedImageFile(),
                'TimeCreated' => new \PHPExiftool\Driver\Tag\RIFF\TimeCreated(),
                'UserComment' => new \PHPExiftool\Driver\Tag\RIFF\UserComment(),
                'ExifVersion' => new \PHPExiftool\Driver\Tag\RIFF\ExifVersion(),
                'TotalFrameCount' => new \PHPExiftool\Driver\Tag\RIFF\TotalFrameCount(),
                'TimeCode' => new \PHPExiftool\Driver\Tag\RIFF\TimeCode(),
                'Rated' => new \PHPExiftool\Driver\Tag\RIFF\Rated(),
                'Comment' => new \PHPExiftool\Driver\Tag\RIFF\Comment(),
                'EncodedBy' => new \PHPExiftool\Driver\Tag\RIFF\EncodedBy(),
                'Comments' => new \PHPExiftool\Driver\Tag\RIFF\Comments(),
                'Directory' => new \PHPExiftool\Driver\Tag\RIFF\Directory(),
                'SoundSchemeTitle' => new \PHPExiftool\Driver\Tag\RIFF\SoundSchemeTitle(),
                'Genre' => new \PHPExiftool\Driver\Tag\RIFF\Genre(),
                'ArchivalLocation' => new \PHPExiftool\Driver\Tag\RIFF\ArchivalLocation(),
                'Artist' => new \PHPExiftool\Driver\Tag\RIFF\Artist(),
                'FirstLanguage' => new \PHPExiftool\Driver\Tag\RIFF\FirstLanguage(),
                'SecondLanguage' => new \PHPExiftool\Driver\Tag\RIFF\SecondLanguage(),
                'ThirdLanguage' => new \PHPExiftool\Driver\Tag\RIFF\ThirdLanguage(),
                'FourthLanguage' => new \PHPExiftool\Driver\Tag\RIFF\FourthLanguage(),
                'FifthLanguage' => new \PHPExiftool\Driver\Tag\RIFF\FifthLanguage(),
                'SixthLanguage' => new \PHPExiftool\Driver\Tag\RIFF\SixthLanguage(),
                'SeventhLanguage' => new \PHPExiftool\Driver\Tag\RIFF\SeventhLanguage(),
                'EighthLanguage' => new \PHPExiftool\Driver\Tag\RIFF\EighthLanguage(),
                'NinthLanguage' => new \PHPExiftool\Driver\Tag\RIFF\NinthLanguage(),
                'BaseURL' => new \PHPExiftool\Driver\Tag\RIFF\BaseURL(),
                'DefaultAudioStream' => new \PHPExiftool\Driver\Tag\RIFF\DefaultAudioStream(),
                'CostumeDesigner' => new \PHPExiftool\Driver\Tag\RIFF\CostumeDesigner(),
                'Commissioned' => new \PHPExiftool\Driver\Tag\RIFF\Commissioned(),
                'Cinematographer' => new \PHPExiftool\Driver\Tag\RIFF\Cinematographer(),
                'Country' => new \PHPExiftool\Driver\Tag\RIFF\Country(),
                'Copyright' => new \PHPExiftool\Driver\Tag\RIFF\Copyright(),
                'DateCreated' => new \PHPExiftool\Driver\Tag\RIFF\DateCreated(),
                'Cropped' => new \PHPExiftool\Driver\Tag\RIFF\Cropped(),
                'Dimensions' => new \PHPExiftool\Driver\Tag\RIFF\Dimensions(),
                'DotsPerInch' => new \PHPExiftool\Driver\Tag\RIFF\DotsPerInch(),
                'DistributedBy' => new \PHPExiftool\Driver\Tag\RIFF\DistributedBy(),
                'EditedBy' => new \PHPExiftool\Driver\Tag\RIFF\EditedBy(),
                'Engineer' => new \PHPExiftool\Driver\Tag\RIFF\Engineer(),
                'Keywords' => new \PHPExiftool\Driver\Tag\RIFF\Keywords(),
                'Lightness' => new \PHPExiftool\Driver\Tag\RIFF\Lightness(),
                'LogoURL' => new \PHPExiftool\Driver\Tag\RIFF\LogoURL(),
                'LogoIconURL' => new \PHPExiftool\Driver\Tag\RIFF\LogoIconURL(),
                'Language' => new \PHPExiftool\Driver\Tag\RIFF\Language(),
                'MoreInfoBannerImage' => new \PHPExiftool\Driver\Tag\RIFF\MoreInfoBannerImage(),
                'MoreInfoBannerURL' => new \PHPExiftool\Driver\Tag\RIFF\MoreInfoBannerURL(),
                'Medium' => new \PHPExiftool\Driver\Tag\RIFF\Medium(),
                'MoreInfoText' => new \PHPExiftool\Driver\Tag\RIFF\MoreInfoText(),
                'MoreInfoURL' => new \PHPExiftool\Driver\Tag\RIFF\MoreInfoURL(),
                'MusicBy' => new \PHPExiftool\Driver\Tag\RIFF\MusicBy(),
                'Title' => new \PHPExiftool\Driver\Tag\RIFF\Title(),
                'ProductionDesigner' => new \PHPExiftool\Driver\Tag\RIFF\ProductionDesigner(),
                'NumColors' => new \PHPExiftool\Driver\Tag\RIFF\NumColors(),
                'Product' => new \PHPExiftool\Driver\Tag\RIFF\Product(),
                'ProducedBy' => new \PHPExiftool\Driver\Tag\RIFF\ProducedBy(),
                'RippedBy' => new \PHPExiftool\Driver\Tag\RIFF\RippedBy(),
                'Rating' => new \PHPExiftool\Driver\Tag\RIFF\Rating(),
                'Subject' => new \PHPExiftool\Driver\Tag\RIFF\Subject(),
                'Software' => new \PHPExiftool\Driver\Tag\RIFF\Software(),
                'SecondaryGenre' => new \PHPExiftool\Driver\Tag\RIFF\SecondaryGenre(),
                'Sharpness' => new \PHPExiftool\Driver\Tag\RIFF\Sharpness(),
                'Source' => new \PHPExiftool\Driver\Tag\RIFF\Source(),
                'SourceForm' => new \PHPExiftool\Driver\Tag\RIFF\SourceForm(),
                'ProductionStudio' => new \PHPExiftool\Driver\Tag\RIFF\ProductionStudio(),
                'Starring' => new \PHPExiftool\Driver\Tag\RIFF\Starring(),
                'Technician' => new \PHPExiftool\Driver\Tag\RIFF\Technician(),
                'WatermarkURL' => new \PHPExiftool\Driver\Tag\RIFF\WatermarkURL(),
                'WrittenBy' => new \PHPExiftool\Driver\Tag\RIFF\WrittenBy(),
                'Location' => new \PHPExiftool\Driver\Tag\RIFF\Location(),
                'Part' => new \PHPExiftool\Driver\Tag\RIFF\Part(),
                'NumberOfParts' => new \PHPExiftool\Driver\Tag\RIFF\NumberOfParts(),
                'Rate' => new \PHPExiftool\Driver\Tag\RIFF\Rate(),
                'Statistics' => new \PHPExiftool\Driver\Tag\RIFF\Statistics(),
                'TapeName' => new \PHPExiftool\Driver\Tag\RIFF\TapeName(),
                'EndTimecode' => new \PHPExiftool\Driver\Tag\RIFF\EndTimecode(),
                'StartTimecode' => new \PHPExiftool\Driver\Tag\RIFF\StartTimecode(),
                'Length' => new \PHPExiftool\Driver\Tag\RIFF\Length(),
                'Organization' => new \PHPExiftool\Driver\Tag\RIFF\Organization(),
                'TrackNumber' => new \PHPExiftool\Driver\Tag\RIFF\TrackNumber(),
                'URL' => new \PHPExiftool\Driver\Tag\RIFF\URL(),
                'Version' => new \PHPExiftool\Driver\Tag\RIFF\Version(),
                'VegasVersionMajor' => new \PHPExiftool\Driver\Tag\RIFF\VegasVersionMajor(),
                'VegasVersionMinor' => new \PHPExiftool\Driver\Tag\RIFF\VegasVersionMinor(),
                'Year' => new \PHPExiftool\Driver\Tag\RIFF\Year(),
                'LabelID' => new \PHPExiftool\Driver\Tag\RIFF\LabelID(),
                'LabelText' => new \PHPExiftool\Driver\Tag\RIFF\LabelText(),
                'TextJunk' => new \PHPExiftool\Driver\Tag\RIFF\TextJunk(),
                'OldXMP' => new \PHPExiftool\Driver\Tag\RIFF\OldXMP(),
                'Afsp' => new \PHPExiftool\Driver\Tag\RIFF\Afsp(),
                'CuePoints' => new \PHPExiftool\Driver\Tag\RIFF\CuePoints(),
                'NumberOfSamples' => new \PHPExiftool\Driver\Tag\RIFF\NumberOfSamples(),
                'ListType' => new \PHPExiftool\Driver\Tag\RIFF\ListType(),
                'StreamName' => new \PHPExiftool\Driver\Tag\RIFF\StreamName(),
                'VendorName' => new \PHPExiftool\Driver\Tag\RIFF\VendorName(),
                'UnknownData' => new \PHPExiftool\Driver\Tag\RIFF\UnknownData(),
                'StreamType' => new \PHPExiftool\Driver\Tag\RIFF\StreamType(),
                'AudioCodec' => new \PHPExiftool\Driver\Tag\RIFF\AudioCodec(),
                'VideoCodec' => new \PHPExiftool\Driver\Tag\RIFF\VideoCodec(),
                'Codec' => new \PHPExiftool\Driver\Tag\RIFF\Codec(),
                'AudioSampleRate' => new \PHPExiftool\Driver\Tag\RIFF\AudioSampleRate(),
                'VideoFrameRate' => new \PHPExiftool\Driver\Tag\RIFF\VideoFrameRate(),
                'StreamSampleRate' => new \PHPExiftool\Driver\Tag\RIFF\StreamSampleRate(),
                'AudioSampleCount' => new \PHPExiftool\Driver\Tag\RIFF\AudioSampleCount(),
                'VideoFrameCount' => new \PHPExiftool\Driver\Tag\RIFF\VideoFrameCount(),
                'StreamSampleCount' => new \PHPExiftool\Driver\Tag\RIFF\StreamSampleCount(),
                'Quality' => new \PHPExiftool\Driver\Tag\RIFF\Quality(),
                'SampleSize' => new \PHPExiftool\Driver\Tag\RIFF\SampleSize(),
                'VP8Version' => new \PHPExiftool\Driver\Tag\RIFF\VP8Version(),
                'HorizontalScale' => new \PHPExiftool\Driver\Tag\RIFF\HorizontalScale(),
                'VerticalScale' => new \PHPExiftool\Driver\Tag\RIFF\VerticalScale(),
            );
        });
        $this['RSRC'] = $this->share(function(){
            return array(
                'ApplicationMissingMsg' => new \PHPExiftool\Driver\Tag\RSRC\ApplicationMissingMsg(),
                'CreatorApplication' => new \PHPExiftool\Driver\Tag\RSRC\CreatorApplication(),
                'Keywords' => new \PHPExiftool\Driver\Tag\RSRC\Keywords(),
                'Description' => new \PHPExiftool\Driver\Tag\RSRC\Description(),
                'OpenWithApplication' => new \PHPExiftool\Driver\Tag\RSRC\OpenWithApplication(),
                'ApplicationVersion' => new \PHPExiftool\Driver\Tag\RSRC\ApplicationVersion(),
            );
        });
        $this['RTF'] = $this->share(function(){
            return array(
                'Author' => new \PHPExiftool\Driver\Tag\RTF\Author(),
                'BackupTime' => new \PHPExiftool\Driver\Tag\RTF\BackupTime(),
                'Category' => new \PHPExiftool\Driver\Tag\RTF\Category(),
                'Comment' => new \PHPExiftool\Driver\Tag\RTF\Comment(),
                'Company' => new \PHPExiftool\Driver\Tag\RTF\Company(),
                'Copyright' => new \PHPExiftool\Driver\Tag\RTF\Copyright(),
                'CreateDate' => new \PHPExiftool\Driver\Tag\RTF\CreateDate(),
                'Comments' => new \PHPExiftool\Driver\Tag\RTF\Comments(),
                'TotalEditTime' => new \PHPExiftool\Driver\Tag\RTF\TotalEditTime(),
                'HyperlinkBase' => new \PHPExiftool\Driver\Tag\RTF\HyperlinkBase(),
                'InternalIDNumber' => new \PHPExiftool\Driver\Tag\RTF\InternalIDNumber(),
                'Keywords' => new \PHPExiftool\Driver\Tag\RTF\Keywords(),
                'Manager' => new \PHPExiftool\Driver\Tag\RTF\Manager(),
                'Characters' => new \PHPExiftool\Driver\Tag\RTF\Characters(),
                'CharactersWithSpaces' => new \PHPExiftool\Driver\Tag\RTF\CharactersWithSpaces(),
                'Pages' => new \PHPExiftool\Driver\Tag\RTF\Pages(),
                'Words' => new \PHPExiftool\Driver\Tag\RTF\Words(),
                'LastModifiedBy' => new \PHPExiftool\Driver\Tag\RTF\LastModifiedBy(),
                'LastPrinted' => new \PHPExiftool\Driver\Tag\RTF\LastPrinted(),
                'ModifyDate' => new \PHPExiftool\Driver\Tag\RTF\ModifyDate(),
                'Subject' => new \PHPExiftool\Driver\Tag\RTF\Subject(),
                'Title' => new \PHPExiftool\Driver\Tag\RTF\Title(),
                'InternalVersionNumber' => new \PHPExiftool\Driver\Tag\RTF\InternalVersionNumber(),
                'RevisionNumber' => new \PHPExiftool\Driver\Tag\RTF\RevisionNumber(),
            );
        });
        $this['Radiance'] = $this->share(function(){
            return array(
                'Command' => new \PHPExiftool\Driver\Tag\Radiance\Command(),
                'Orientation' => new \PHPExiftool\Driver\Tag\Radiance\Orientation(),
                'ColorCorrection' => new \PHPExiftool\Driver\Tag\Radiance\ColorCorrection(),
                'Exposure' => new \PHPExiftool\Driver\Tag\Radiance\Exposure(),
                'Format' => new \PHPExiftool\Driver\Tag\Radiance\Format(),
                'Gamma' => new \PHPExiftool\Driver\Tag\Radiance\Gamma(),
                'PixelAspectRatio' => new \PHPExiftool\Driver\Tag\Radiance\PixelAspectRatio(),
                'ColorPrimaries' => new \PHPExiftool\Driver\Tag\Radiance\ColorPrimaries(),
                'Software' => new \PHPExiftool\Driver\Tag\Radiance\Software(),
                'View' => new \PHPExiftool\Driver\Tag\Radiance\View(),
            );
        });
        $this['Rawzor'] = $this->share(function(){
            return array(
                'CompressionFactor' => new \PHPExiftool\Driver\Tag\Rawzor\CompressionFactor(),
                'OriginalFileSize' => new \PHPExiftool\Driver\Tag\Rawzor\OriginalFileSize(),
                'OriginalFileType' => new \PHPExiftool\Driver\Tag\Rawzor\OriginalFileType(),
                'RawzorCreatorVersion' => new \PHPExiftool\Driver\Tag\Rawzor\RawzorCreatorVersion(),
                'RawzorRequiredVersion' => new \PHPExiftool\Driver\Tag\Rawzor\RawzorRequiredVersion(),
            );
        });
        $this['Real'] = $this->share(function(){
            return array(
                'Text' => new \PHPExiftool\Driver\Tag\Real\Text(),
                'URL' => new \PHPExiftool\Driver\Tag\Real\URL(),
            );
        });
        $this['Real-PROP'] = $this->share(function(){
            return array(
                'MaxBitrate' => new \PHPExiftool\Driver\Tag\RealPROP\MaxBitrate(),
                'AvgBitrate' => new \PHPExiftool\Driver\Tag\RealPROP\AvgBitrate(),
                'MaxPacketSize' => new \PHPExiftool\Driver\Tag\RealPROP\MaxPacketSize(),
                'AvgPacketSize' => new \PHPExiftool\Driver\Tag\RealPROP\AvgPacketSize(),
                'NumPackets' => new \PHPExiftool\Driver\Tag\RealPROP\NumPackets(),
                'Duration' => new \PHPExiftool\Driver\Tag\RealPROP\Duration(),
                'Preroll' => new \PHPExiftool\Driver\Tag\RealPROP\Preroll(),
                'IndexOffset' => new \PHPExiftool\Driver\Tag\RealPROP\IndexOffset(),
                'DataOffset' => new \PHPExiftool\Driver\Tag\RealPROP\DataOffset(),
                'NumStreams' => new \PHPExiftool\Driver\Tag\RealPROP\NumStreams(),
                'Flags' => new \PHPExiftool\Driver\Tag\RealPROP\Flags(),
            );
        });
        $this['Reconyx'] = $this->share(function(){
            return array(
                'MakerNoteVersion' => new \PHPExiftool\Driver\Tag\Reconyx\MakerNoteVersion(),
                'FirmwareVersion' => new \PHPExiftool\Driver\Tag\Reconyx\FirmwareVersion(),
                'FirmwareDate' => new \PHPExiftool\Driver\Tag\Reconyx\FirmwareDate(),
                'TriggerMode' => new \PHPExiftool\Driver\Tag\Reconyx\TriggerMode(),
                'Sequence' => new \PHPExiftool\Driver\Tag\Reconyx\Sequence(),
                'EventNumber' => new \PHPExiftool\Driver\Tag\Reconyx\EventNumber(),
                'DateTimeOriginal' => new \PHPExiftool\Driver\Tag\Reconyx\DateTimeOriginal(),
                'MoonPhase' => new \PHPExiftool\Driver\Tag\Reconyx\MoonPhase(),
                'AmbientTemperatureFahrenheit' => new \PHPExiftool\Driver\Tag\Reconyx\AmbientTemperatureFahrenheit(),
                'AmbientTemperature' => new \PHPExiftool\Driver\Tag\Reconyx\AmbientTemperature(),
                'SerialNumber' => new \PHPExiftool\Driver\Tag\Reconyx\SerialNumber(),
                'Contrast' => new \PHPExiftool\Driver\Tag\Reconyx\Contrast(),
                'Brightness' => new \PHPExiftool\Driver\Tag\Reconyx\Brightness(),
                'Sharpness' => new \PHPExiftool\Driver\Tag\Reconyx\Sharpness(),
                'Saturation' => new \PHPExiftool\Driver\Tag\Reconyx\Saturation(),
                'InfraredIlluminator' => new \PHPExiftool\Driver\Tag\Reconyx\InfraredIlluminator(),
                'MotionSensitivity' => new \PHPExiftool\Driver\Tag\Reconyx\MotionSensitivity(),
                'BatteryVoltage' => new \PHPExiftool\Driver\Tag\Reconyx\BatteryVoltage(),
                'UserLabel' => new \PHPExiftool\Driver\Tag\Reconyx\UserLabel(),
                'Micro1Version' => new \PHPExiftool\Driver\Tag\Reconyx\Micro1Version(),
                'BootLoaderVersion' => new \PHPExiftool\Driver\Tag\Reconyx\BootLoaderVersion(),
                'Micro2Version' => new \PHPExiftool\Driver\Tag\Reconyx\Micro2Version(),
                'DayOfWeek' => new \PHPExiftool\Driver\Tag\Reconyx\DayOfWeek(),
                'Illumination' => new \PHPExiftool\Driver\Tag\Reconyx\Illumination(),
                'FileNumber' => new \PHPExiftool\Driver\Tag\Reconyx\FileNumber(),
                'DirectoryNumber' => new \PHPExiftool\Driver\Tag\Reconyx\DirectoryNumber(),
                'Flash' => new \PHPExiftool\Driver\Tag\Reconyx\Flash(),
                'AmbientInfrared' => new \PHPExiftool\Driver\Tag\Reconyx\AmbientInfrared(),
                'AmbientLight' => new \PHPExiftool\Driver\Tag\Reconyx\AmbientLight(),
                'BatteryVoltageAvg' => new \PHPExiftool\Driver\Tag\Reconyx\BatteryVoltageAvg(),
                'BatteryType' => new \PHPExiftool\Driver\Tag\Reconyx\BatteryType(),
            );
        });
        $this['Red'] = $this->share(function(){
            return array(
                'StartEdgeCode' => new \PHPExiftool\Driver\Tag\Red\StartEdgeCode(),
                'StartTimecode' => new \PHPExiftool\Driver\Tag\Red\StartTimecode(),
                'OtherDate1' => new \PHPExiftool\Driver\Tag\Red\OtherDate1(),
                'OtherDate2' => new \PHPExiftool\Driver\Tag\Red\OtherDate2(),
                'OtherDate3' => new \PHPExiftool\Driver\Tag\Red\OtherDate3(),
                'DateTimeOriginal' => new \PHPExiftool\Driver\Tag\Red\DateTimeOriginal(),
                'SerialNumber' => new \PHPExiftool\Driver\Tag\Red\SerialNumber(),
                'CameraType' => new \PHPExiftool\Driver\Tag\Red\CameraType(),
                'ReelNumber' => new \PHPExiftool\Driver\Tag\Red\ReelNumber(),
                'Take' => new \PHPExiftool\Driver\Tag\Red\Take(),
                'DateCreated' => new \PHPExiftool\Driver\Tag\Red\DateCreated(),
                'TimeCreated' => new \PHPExiftool\Driver\Tag\Red\TimeCreated(),
                'FirmwareVersion' => new \PHPExiftool\Driver\Tag\Red\FirmwareVersion(),
                'ReelTimecode' => new \PHPExiftool\Driver\Tag\Red\ReelTimecode(),
                'StorageType' => new \PHPExiftool\Driver\Tag\Red\StorageType(),
                'StorageFormatDate' => new \PHPExiftool\Driver\Tag\Red\StorageFormatDate(),
                'StorageFormatTime' => new \PHPExiftool\Driver\Tag\Red\StorageFormatTime(),
                'StorageSerialNumber' => new \PHPExiftool\Driver\Tag\Red\StorageSerialNumber(),
                'StorageModel' => new \PHPExiftool\Driver\Tag\Red\StorageModel(),
                'AspectRatio' => new \PHPExiftool\Driver\Tag\Red\AspectRatio(),
                'Revision' => new \PHPExiftool\Driver\Tag\Red\Revision(),
                'OriginalFileName' => new \PHPExiftool\Driver\Tag\Red\OriginalFileName(),
                'LensMake' => new \PHPExiftool\Driver\Tag\Red\LensMake(),
                'LensNumber' => new \PHPExiftool\Driver\Tag\Red\LensNumber(),
                'LensModel' => new \PHPExiftool\Driver\Tag\Red\LensModel(),
                'Model' => new \PHPExiftool\Driver\Tag\Red\Model(),
                'CameraOperator' => new \PHPExiftool\Driver\Tag\Red\CameraOperator(),
                'VideoFormat' => new \PHPExiftool\Driver\Tag\Red\VideoFormat(),
                'Filter' => new \PHPExiftool\Driver\Tag\Red\Filter(),
                'Brain' => new \PHPExiftool\Driver\Tag\Red\Brain(),
                'Sensor' => new \PHPExiftool\Driver\Tag\Red\Sensor(),
                'ColorTemperature' => new \PHPExiftool\Driver\Tag\Red\ColorTemperature(),
                'RGBCurves' => new \PHPExiftool\Driver\Tag\Red\RGBCurves(),
                'OriginalFrameRate' => new \PHPExiftool\Driver\Tag\Red\OriginalFrameRate(),
                'CropArea' => new \PHPExiftool\Driver\Tag\Red\CropArea(),
                'ISO' => new \PHPExiftool\Driver\Tag\Red\ISO(),
                'FNumber' => new \PHPExiftool\Driver\Tag\Red\FNumber(),
                'FocalLength' => new \PHPExiftool\Driver\Tag\Red\FocalLength(),
                'FocusDistance' => new \PHPExiftool\Driver\Tag\Red\FocusDistance(),
                'RedcodeVersion' => new \PHPExiftool\Driver\Tag\Red\RedcodeVersion(),
                'ImageWidth' => new \PHPExiftool\Driver\Tag\Red\ImageWidth(),
                'ImageHeight' => new \PHPExiftool\Driver\Tag\Red\ImageHeight(),
                'FrameRate' => new \PHPExiftool\Driver\Tag\Red\FrameRate(),
            );
        });
        $this['Ricoh'] = $this->share(function(){
            return array(
                'RicohRDC2' => new \PHPExiftool\Driver\Tag\Ricoh\RicohRDC2(),
                'ThumbnailImage' => new \PHPExiftool\Driver\Tag\Ricoh\ThumbnailImage(),
                'Comment' => new \PHPExiftool\Driver\Tag\Ricoh\Comment(),
                'FacesDetected' => new \PHPExiftool\Driver\Tag\Ricoh\FacesDetected(),
                'FaceDetectFrameSize' => new \PHPExiftool\Driver\Tag\Ricoh\FaceDetectFrameSize(),
                'Face1Position' => new \PHPExiftool\Driver\Tag\Ricoh\Face1Position(),
                'Face2Position' => new \PHPExiftool\Driver\Tag\Ricoh\Face2Position(),
                'Face3Position' => new \PHPExiftool\Driver\Tag\Ricoh\Face3Position(),
                'Face4Position' => new \PHPExiftool\Driver\Tag\Ricoh\Face4Position(),
                'Face5Position' => new \PHPExiftool\Driver\Tag\Ricoh\Face5Position(),
                'Face6Position' => new \PHPExiftool\Driver\Tag\Ricoh\Face6Position(),
                'Face7Position' => new \PHPExiftool\Driver\Tag\Ricoh\Face7Position(),
                'Face8Position' => new \PHPExiftool\Driver\Tag\Ricoh\Face8Position(),
                'FirmwareRevision' => new \PHPExiftool\Driver\Tag\Ricoh\FirmwareRevision(),
                'FirmwareRevision2' => new \PHPExiftool\Driver\Tag\Ricoh\FirmwareRevision2(),
                'RicohImageWidth' => new \PHPExiftool\Driver\Tag\Ricoh\RicohImageWidth(),
                'RicohImageHeight' => new \PHPExiftool\Driver\Tag\Ricoh\RicohImageHeight(),
                'RicohDate' => new \PHPExiftool\Driver\Tag\Ricoh\RicohDate(),
                'PreviewImageStart' => new \PHPExiftool\Driver\Tag\Ricoh\PreviewImageStart(),
                'PreviewImageLength' => new \PHPExiftool\Driver\Tag\Ricoh\PreviewImageLength(),
                'FlashMode' => new \PHPExiftool\Driver\Tag\Ricoh\FlashMode(),
                'Macro' => new \PHPExiftool\Driver\Tag\Ricoh\Macro(),
                'Sharpness' => new \PHPExiftool\Driver\Tag\Ricoh\Sharpness(),
                'WhiteBalance' => new \PHPExiftool\Driver\Tag\Ricoh\WhiteBalance(),
                'ISOSetting' => new \PHPExiftool\Driver\Tag\Ricoh\ISOSetting(),
                'Saturation' => new \PHPExiftool\Driver\Tag\Ricoh\Saturation(),
                'MakerNoteType' => new \PHPExiftool\Driver\Tag\Ricoh\MakerNoteType(),
                'FirmwareVersion' => new \PHPExiftool\Driver\Tag\Ricoh\FirmwareVersion(),
                'SerialNumber' => new \PHPExiftool\Driver\Tag\Ricoh\SerialNumber(),
                'InternalSerialNumber' => new \PHPExiftool\Driver\Tag\Ricoh\InternalSerialNumber(),
                'RecordingFormat' => new \PHPExiftool\Driver\Tag\Ricoh\RecordingFormat(),
                'ExposureProgram' => new \PHPExiftool\Driver\Tag\Ricoh\ExposureProgram(),
                'DriveMode' => new \PHPExiftool\Driver\Tag\Ricoh\DriveMode(),
                'WhiteBalanceFineTune' => new \PHPExiftool\Driver\Tag\Ricoh\WhiteBalanceFineTune(),
                'FocusMode' => new \PHPExiftool\Driver\Tag\Ricoh\FocusMode(),
                'AutoBracketing' => new \PHPExiftool\Driver\Tag\Ricoh\AutoBracketing(),
                'MacroMode' => new \PHPExiftool\Driver\Tag\Ricoh\MacroMode(),
                'FlashExposureComp' => new \PHPExiftool\Driver\Tag\Ricoh\FlashExposureComp(),
                'ManualFlashOutput' => new \PHPExiftool\Driver\Tag\Ricoh\ManualFlashOutput(),
                'FullPressSnap' => new \PHPExiftool\Driver\Tag\Ricoh\FullPressSnap(),
                'DynamicRangeExpansion' => new \PHPExiftool\Driver\Tag\Ricoh\DynamicRangeExpansion(),
                'NoiseReduction' => new \PHPExiftool\Driver\Tag\Ricoh\NoiseReduction(),
                'ImageEffects' => new \PHPExiftool\Driver\Tag\Ricoh\ImageEffects(),
                'Vignetting' => new \PHPExiftool\Driver\Tag\Ricoh\Vignetting(),
                'Contrast' => new \PHPExiftool\Driver\Tag\Ricoh\Contrast(),
                'ToningEffect' => new \PHPExiftool\Driver\Tag\Ricoh\ToningEffect(),
                'HueAdjust' => new \PHPExiftool\Driver\Tag\Ricoh\HueAdjust(),
                'WideAdapter' => new \PHPExiftool\Driver\Tag\Ricoh\WideAdapter(),
                'CropMode' => new \PHPExiftool\Driver\Tag\Ricoh\CropMode(),
                'NDFilter' => new \PHPExiftool\Driver\Tag\Ricoh\NDFilter(),
                'WBBracketShotNumber' => new \PHPExiftool\Driver\Tag\Ricoh\WBBracketShotNumber(),
                'AFStatus' => new \PHPExiftool\Driver\Tag\Ricoh\AFStatus(),
                'AFAreaXPosition1' => new \PHPExiftool\Driver\Tag\Ricoh\AFAreaXPosition1(),
                'AFAreaYPosition1' => new \PHPExiftool\Driver\Tag\Ricoh\AFAreaYPosition1(),
                'AFAreaXPosition' => new \PHPExiftool\Driver\Tag\Ricoh\AFAreaXPosition(),
                'AFAreaYPosition' => new \PHPExiftool\Driver\Tag\Ricoh\AFAreaYPosition(),
                'AFAreaMode' => new \PHPExiftool\Driver\Tag\Ricoh\AFAreaMode(),
                'ColorTempKelvin' => new \PHPExiftool\Driver\Tag\Ricoh\ColorTempKelvin(),
                'ColorTemperature' => new \PHPExiftool\Driver\Tag\Ricoh\ColorTemperature(),
                'FocalLength' => new \PHPExiftool\Driver\Tag\Ricoh\FocalLength(),
                'SensorWidth' => new \PHPExiftool\Driver\Tag\Ricoh\SensorWidth(),
                'SensorHeight' => new \PHPExiftool\Driver\Tag\Ricoh\SensorHeight(),
                'CroppedImageWidth' => new \PHPExiftool\Driver\Tag\Ricoh\CroppedImageWidth(),
                'CroppedImageHeight' => new \PHPExiftool\Driver\Tag\Ricoh\CroppedImageHeight(),
                'BodyFirmware' => new \PHPExiftool\Driver\Tag\Ricoh\BodyFirmware(),
                'BodySerialNumber' => new \PHPExiftool\Driver\Tag\Ricoh\BodySerialNumber(),
                'LensFirmware' => new \PHPExiftool\Driver\Tag\Ricoh\LensFirmware(),
                'LensSerialNumber' => new \PHPExiftool\Driver\Tag\Ricoh\LensSerialNumber(),
                'ManufactureDate1' => new \PHPExiftool\Driver\Tag\Ricoh\ManufactureDate1(),
                'ManufactureDate2' => new \PHPExiftool\Driver\Tag\Ricoh\ManufactureDate2(),
                'BlueGain' => new \PHPExiftool\Driver\Tag\Ricoh\BlueGain(),
                'GreenGain' => new \PHPExiftool\Driver\Tag\Ricoh\GreenGain(),
                'RedGain' => new \PHPExiftool\Driver\Tag\Ricoh\RedGain(),
                'Accelerometer' => new \PHPExiftool\Driver\Tag\Ricoh\Accelerometer(),
                'Compass' => new \PHPExiftool\Driver\Tag\Ricoh\Compass(),
                'TimeZone' => new \PHPExiftool\Driver\Tag\Ricoh\TimeZone(),
                'RicohModel' => new \PHPExiftool\Driver\Tag\Ricoh\RicohModel(),
                'RicohMake' => new \PHPExiftool\Driver\Tag\Ricoh\RicohMake(),
            );
        });
        $this['RMETA'] = $this->share(function(){
            return array(
                'Azimuth' => new \PHPExiftool\Driver\Tag\RMETA\Azimuth(),
                'Condition' => new \PHPExiftool\Driver\Tag\RMETA\Condition(),
                'Lit' => new \PHPExiftool\Driver\Tag\RMETA\Lit(),
                'Location' => new \PHPExiftool\Driver\Tag\RMETA\Location(),
                'SignType' => new \PHPExiftool\Driver\Tag\RMETA\SignType(),
                'SoundFile' => new \PHPExiftool\Driver\Tag\RMETA\SoundFile(),
            );
        });
        $this['Samsung'] = $this->share(function(){
            return array(
                'UniqueID' => new \PHPExiftool\Driver\Tag\Samsung\UniqueID(),
                'DualShotDummy' => new \PHPExiftool\Driver\Tag\Samsung\DualShotDummy(),
                'DepthMapWidth' => new \PHPExiftool\Driver\Tag\Samsung\DepthMapWidth(),
                'DepthMapHeight' => new \PHPExiftool\Driver\Tag\Samsung\DepthMapHeight(),
                'Effect' => new \PHPExiftool\Driver\Tag\Samsung\Effect(),
                'Quality' => new \PHPExiftool\Driver\Tag\Samsung\Quality(),
                'Make' => new \PHPExiftool\Driver\Tag\Samsung\Make(),
                'Model' => new \PHPExiftool\Driver\Tag\Samsung\Model(),
                'ExposureTime' => new \PHPExiftool\Driver\Tag\Samsung\ExposureTime(),
                'FNumber' => new \PHPExiftool\Driver\Tag\Samsung\FNumber(),
                'ExposureCompensation' => new \PHPExiftool\Driver\Tag\Samsung\ExposureCompensation(),
                'ISO' => new \PHPExiftool\Driver\Tag\Samsung\ISO(),
                'Software' => new \PHPExiftool\Driver\Tag\Samsung\Software(),
                'MakerNoteVersion' => new \PHPExiftool\Driver\Tag\Samsung\MakerNoteVersion(),
                'PreviewImageStart' => new \PHPExiftool\Driver\Tag\Samsung\PreviewImageStart(),
                'PreviewImageLength' => new \PHPExiftool\Driver\Tag\Samsung\PreviewImageLength(),
                'YawAngle' => new \PHPExiftool\Driver\Tag\Samsung\YawAngle(),
                'PitchAngle' => new \PHPExiftool\Driver\Tag\Samsung\PitchAngle(),
                'RollAngle' => new \PHPExiftool\Driver\Tag\Samsung\RollAngle(),
                'PictureWizardMode' => new \PHPExiftool\Driver\Tag\Samsung\PictureWizardMode(),
                'PictureWizardColor' => new \PHPExiftool\Driver\Tag\Samsung\PictureWizardColor(),
                'PictureWizardSaturation' => new \PHPExiftool\Driver\Tag\Samsung\PictureWizardSaturation(),
                'PictureWizardSharpness' => new \PHPExiftool\Driver\Tag\Samsung\PictureWizardSharpness(),
                'PictureWizardContrast' => new \PHPExiftool\Driver\Tag\Samsung\PictureWizardContrast(),
                'BeautyColorLevel' => new \PHPExiftool\Driver\Tag\Samsung\BeautyColorLevel(),
                'BeautyRetouchLevel' => new \PHPExiftool\Driver\Tag\Samsung\BeautyRetouchLevel(),
                'BlurStrength' => new \PHPExiftool\Driver\Tag\Samsung\BlurStrength(),
                'BokehShape' => new \PHPExiftool\Driver\Tag\Samsung\BokehShape(),
                'ColorpopStrength' => new \PHPExiftool\Driver\Tag\Samsung\ColorpopStrength(),
                'DepthHWHeight' => new \PHPExiftool\Driver\Tag\Samsung\DepthHWHeight(),
                'DepthHWWidth' => new \PHPExiftool\Driver\Tag\Samsung\DepthHWWidth(),
                'DepthSWHeight' => new \PHPExiftool\Driver\Tag\Samsung\DepthSWHeight(),
                'DepthSWWidth' => new \PHPExiftool\Driver\Tag\Samsung\DepthSWWidth(),
                'DeviceOrientation' => new \PHPExiftool\Driver\Tag\Samsung\DeviceOrientation(),
                'EffectStrength' => new \PHPExiftool\Driver\Tag\Samsung\EffectStrength(),
                'EffectType' => new \PHPExiftool\Driver\Tag\Samsung\EffectType(),
                'FlipStatus' => new \PHPExiftool\Driver\Tag\Samsung\FlipStatus(),
                'InputHeight' => new \PHPExiftool\Driver\Tag\Samsung\InputHeight(),
                'InputWidth' => new \PHPExiftool\Driver\Tag\Samsung\InputWidth(),
                'IsArtBokeh' => new \PHPExiftool\Driver\Tag\Samsung\IsArtBokeh(),
                'LensFacing' => new \PHPExiftool\Driver\Tag\Samsung\LensFacing(),
                'MonoStrength' => new \PHPExiftool\Driver\Tag\Samsung\MonoStrength(),
                'ObjectOrientation' => new \PHPExiftool\Driver\Tag\Samsung\ObjectOrientation(),
                'OutputHeight' => new \PHPExiftool\Driver\Tag\Samsung\OutputHeight(),
                'OutputWidth' => new \PHPExiftool\Driver\Tag\Samsung\OutputWidth(),
                'PerfMode' => new \PHPExiftool\Driver\Tag\Samsung\PerfMode(),
                'SegHeight' => new \PHPExiftool\Driver\Tag\Samsung\SegHeight(),
                'SegWidth' => new \PHPExiftool\Driver\Tag\Samsung\SegWidth(),
                'SidelightStrength' => new \PHPExiftool\Driver\Tag\Samsung\SidelightStrength(),
                'SpinStrength' => new \PHPExiftool\Driver\Tag\Samsung\SpinStrength(),
                'VintageStrength' => new \PHPExiftool\Driver\Tag\Samsung\VintageStrength(),
                'ZoomStrength' => new \PHPExiftool\Driver\Tag\Samsung\ZoomStrength(),
                'ThumbnailWidth' => new \PHPExiftool\Driver\Tag\Samsung\ThumbnailWidth(),
                'ThumbnailHeight' => new \PHPExiftool\Driver\Tag\Samsung\ThumbnailHeight(),
                'ThumbnailLength' => new \PHPExiftool\Driver\Tag\Samsung\ThumbnailLength(),
                'ThumbnailOffset' => new \PHPExiftool\Driver\Tag\Samsung\ThumbnailOffset(),
                'EmbeddedImage' => new \PHPExiftool\Driver\Tag\Samsung\EmbeddedImage(),
                'EmbeddedImageName' => new \PHPExiftool\Driver\Tag\Samsung\EmbeddedImageName(),
                'EmbeddedAudioFile' => new \PHPExiftool\Driver\Tag\Samsung\EmbeddedAudioFile(),
                'EmbeddedAudioFileName' => new \PHPExiftool\Driver\Tag\Samsung\EmbeddedAudioFileName(),
                'SurroundShotVideo' => new \PHPExiftool\Driver\Tag\Samsung\SurroundShotVideo(),
                'SurroundShotVideoName' => new \PHPExiftool\Driver\Tag\Samsung\SurroundShotVideoName(),
                'TimeStamp' => new \PHPExiftool\Driver\Tag\Samsung\TimeStamp(),
                'DualCameraImage' => new \PHPExiftool\Driver\Tag\Samsung\DualCameraImage(),
                'DualCameraImageName' => new \PHPExiftool\Driver\Tag\Samsung\DualCameraImageName(),
                'EmbeddedVideoFile' => new \PHPExiftool\Driver\Tag\Samsung\EmbeddedVideoFile(),
                'EmbeddedVideoType' => new \PHPExiftool\Driver\Tag\Samsung\EmbeddedVideoType(),
                'DepthMapData' => new \PHPExiftool\Driver\Tag\Samsung\DepthMapData(),
                'DepthMapName' => new \PHPExiftool\Driver\Tag\Samsung\DepthMapName(),
                'SingleShotDepthMap' => new \PHPExiftool\Driver\Tag\Samsung\SingleShotDepthMap(),
                'DeviceType' => new \PHPExiftool\Driver\Tag\Samsung\DeviceType(),
                'SamsungModelID' => new \PHPExiftool\Driver\Tag\Samsung\SamsungModelID(),
                'SmartAlbumColor' => new \PHPExiftool\Driver\Tag\Samsung\SmartAlbumColor(),
                'PictureWizard' => new \PHPExiftool\Driver\Tag\Samsung\PictureWizard(),
                'LocalLocationName' => new \PHPExiftool\Driver\Tag\Samsung\LocalLocationName(),
                'LocationName' => new \PHPExiftool\Driver\Tag\Samsung\LocationName(),
                'RawDataByteOrder' => new \PHPExiftool\Driver\Tag\Samsung\RawDataByteOrder(),
                'WhiteBalanceSetup' => new \PHPExiftool\Driver\Tag\Samsung\WhiteBalanceSetup(),
                'CameraTemperature' => new \PHPExiftool\Driver\Tag\Samsung\CameraTemperature(),
                'RawDataCFAPattern' => new \PHPExiftool\Driver\Tag\Samsung\RawDataCFAPattern(),
                'FaceDetect' => new \PHPExiftool\Driver\Tag\Samsung\FaceDetect(),
                'FaceRecognition' => new \PHPExiftool\Driver\Tag\Samsung\FaceRecognition(),
                'FaceName' => new \PHPExiftool\Driver\Tag\Samsung\FaceName(),
                'FirmwareName' => new \PHPExiftool\Driver\Tag\Samsung\FirmwareName(),
                'SerialNumber' => new \PHPExiftool\Driver\Tag\Samsung\SerialNumber(),
                'LensType' => new \PHPExiftool\Driver\Tag\Samsung\LensType(),
                'LensFirmware' => new \PHPExiftool\Driver\Tag\Samsung\LensFirmware(),
                'InternalLensSerialNumber' => new \PHPExiftool\Driver\Tag\Samsung\InternalLensSerialNumber(),
                'SensorAreas' => new \PHPExiftool\Driver\Tag\Samsung\SensorAreas(),
                'ColorSpace' => new \PHPExiftool\Driver\Tag\Samsung\ColorSpace(),
                'SmartRange' => new \PHPExiftool\Driver\Tag\Samsung\SmartRange(),
                'FocalLengthIn35mmFormat' => new \PHPExiftool\Driver\Tag\Samsung\FocalLengthIn35mmFormat(),
                'EncryptionKey' => new \PHPExiftool\Driver\Tag\Samsung\EncryptionKey(),
                'WB_RGGBLevelsUncorrected' => new \PHPExiftool\Driver\Tag\Samsung\WBRGGBLevelsUncorrected(),
                'WB_RGGBLevelsAuto' => new \PHPExiftool\Driver\Tag\Samsung\WBRGGBLevelsAuto(),
                'WB_RGGBLevelsIlluminator1' => new \PHPExiftool\Driver\Tag\Samsung\WBRGGBLevelsIlluminator1(),
                'WB_RGGBLevelsIlluminator2' => new \PHPExiftool\Driver\Tag\Samsung\WBRGGBLevelsIlluminator2(),
                'HighlightLinearityLimit' => new \PHPExiftool\Driver\Tag\Samsung\HighlightLinearityLimit(),
                'WB_RGGBLevelsBlack' => new \PHPExiftool\Driver\Tag\Samsung\WBRGGBLevelsBlack(),
                'ColorMatrix' => new \PHPExiftool\Driver\Tag\Samsung\ColorMatrix(),
                'ColorMatrixSRGB' => new \PHPExiftool\Driver\Tag\Samsung\ColorMatrixSRGB(),
                'ColorMatrixAdobeRGB' => new \PHPExiftool\Driver\Tag\Samsung\ColorMatrixAdobeRGB(),
                'CbCrMatrixDefault' => new \PHPExiftool\Driver\Tag\Samsung\CbCrMatrixDefault(),
                'CbCrMatrix' => new \PHPExiftool\Driver\Tag\Samsung\CbCrMatrix(),
                'CbCrGainDefault' => new \PHPExiftool\Driver\Tag\Samsung\CbCrGainDefault(),
                'CbCrGain' => new \PHPExiftool\Driver\Tag\Samsung\CbCrGain(),
                'ToneCurveSRGBDefault' => new \PHPExiftool\Driver\Tag\Samsung\ToneCurveSRGBDefault(),
                'ToneCurveAdobeRGBDefault' => new \PHPExiftool\Driver\Tag\Samsung\ToneCurveAdobeRGBDefault(),
                'ToneCurveSRGB' => new \PHPExiftool\Driver\Tag\Samsung\ToneCurveSRGB(),
                'ToneCurveAdobeRGB' => new \PHPExiftool\Driver\Tag\Samsung\ToneCurveAdobeRGB(),
                'RawData' => new \PHPExiftool\Driver\Tag\Samsung\RawData(),
                'Distortion' => new \PHPExiftool\Driver\Tag\Samsung\Distortion(),
                'ChromaticAberration' => new \PHPExiftool\Driver\Tag\Samsung\ChromaticAberration(),
                'Vignetting' => new \PHPExiftool\Driver\Tag\Samsung\Vignetting(),
                'VignettingCorrection' => new \PHPExiftool\Driver\Tag\Samsung\VignettingCorrection(),
                'VignettingSetting' => new \PHPExiftool\Driver\Tag\Samsung\VignettingSetting(),
                'Samsung_Type2_0xa055' => new \PHPExiftool\Driver\Tag\Samsung\SamsungType20xa055(),
                'Samsung_Type2_0xa056' => new \PHPExiftool\Driver\Tag\Samsung\SamsungType20xa056(),
                'Samsung_Type2_0xa057' => new \PHPExiftool\Driver\Tag\Samsung\SamsungType20xa057(),
                'ThumbnailImage' => new \PHPExiftool\Driver\Tag\Samsung\ThumbnailImage(),
            );
        });
        $this['Sanyo'] = $this->share(function(){
            return array(
                'FacesDetected' => new \PHPExiftool\Driver\Tag\Sanyo\FacesDetected(),
                'FacePosition' => new \PHPExiftool\Driver\Tag\Sanyo\FacePosition(),
                'Make' => new \PHPExiftool\Driver\Tag\Sanyo\Make(),
                'Model' => new \PHPExiftool\Driver\Tag\Sanyo\Model(),
                'ExposureTime' => new \PHPExiftool\Driver\Tag\Sanyo\ExposureTime(),
                'FNumber' => new \PHPExiftool\Driver\Tag\Sanyo\FNumber(),
                'ExposureCompensation' => new \PHPExiftool\Driver\Tag\Sanyo\ExposureCompensation(),
                'WhiteBalance' => new \PHPExiftool\Driver\Tag\Sanyo\WhiteBalance(),
                'FocalLength' => new \PHPExiftool\Driver\Tag\Sanyo\FocalLength(),
                'ISO' => new \PHPExiftool\Driver\Tag\Sanyo\ISO(),
                'Software' => new \PHPExiftool\Driver\Tag\Sanyo\Software(),
                'MakerNoteOffset' => new \PHPExiftool\Driver\Tag\Sanyo\MakerNoteOffset(),
                'SanyoThumbnail' => new \PHPExiftool\Driver\Tag\Sanyo\SanyoThumbnail(),
                'SpecialMode' => new \PHPExiftool\Driver\Tag\Sanyo\SpecialMode(),
                'SanyoQuality' => new \PHPExiftool\Driver\Tag\Sanyo\SanyoQuality(),
                'Macro' => new \PHPExiftool\Driver\Tag\Sanyo\Macro(),
                'DigitalZoom' => new \PHPExiftool\Driver\Tag\Sanyo\DigitalZoom(),
                'SoftwareVersion' => new \PHPExiftool\Driver\Tag\Sanyo\SoftwareVersion(),
                'PictInfo' => new \PHPExiftool\Driver\Tag\Sanyo\PictInfo(),
                'CameraID' => new \PHPExiftool\Driver\Tag\Sanyo\CameraID(),
                'SequentialShot' => new \PHPExiftool\Driver\Tag\Sanyo\SequentialShot(),
                'WideRange' => new \PHPExiftool\Driver\Tag\Sanyo\WideRange(),
                'ColorAdjustmentMode' => new \PHPExiftool\Driver\Tag\Sanyo\ColorAdjustmentMode(),
                'QuickShot' => new \PHPExiftool\Driver\Tag\Sanyo\QuickShot(),
                'SelfTimer' => new \PHPExiftool\Driver\Tag\Sanyo\SelfTimer(),
                'VoiceMemo' => new \PHPExiftool\Driver\Tag\Sanyo\VoiceMemo(),
                'RecordShutterRelease' => new \PHPExiftool\Driver\Tag\Sanyo\RecordShutterRelease(),
                'FlickerReduce' => new \PHPExiftool\Driver\Tag\Sanyo\FlickerReduce(),
                'OpticalZoomOn' => new \PHPExiftool\Driver\Tag\Sanyo\OpticalZoomOn(),
                'DigitalZoomOn' => new \PHPExiftool\Driver\Tag\Sanyo\DigitalZoomOn(),
                'LightSourceSpecial' => new \PHPExiftool\Driver\Tag\Sanyo\LightSourceSpecial(),
                'Resaved' => new \PHPExiftool\Driver\Tag\Sanyo\Resaved(),
                'SceneSelect' => new \PHPExiftool\Driver\Tag\Sanyo\SceneSelect(),
                'ManualFocusDistance' => new \PHPExiftool\Driver\Tag\Sanyo\ManualFocusDistance(),
                'SequenceShotInterval' => new \PHPExiftool\Driver\Tag\Sanyo\SequenceShotInterval(),
                'FlashMode' => new \PHPExiftool\Driver\Tag\Sanyo\FlashMode(),
                'DataDump' => new \PHPExiftool\Driver\Tag\Sanyo\DataDump(),
                'ThumbnailWidth' => new \PHPExiftool\Driver\Tag\Sanyo\ThumbnailWidth(),
                'ThumbnailHeight' => new \PHPExiftool\Driver\Tag\Sanyo\ThumbnailHeight(),
                'ThumbnailLength' => new \PHPExiftool\Driver\Tag\Sanyo\ThumbnailLength(),
                'ThumbnailOffset' => new \PHPExiftool\Driver\Tag\Sanyo\ThumbnailOffset(),
            );
        });
        $this['Scalado'] = $this->share(function(){
            return array(
                'PreviewImageHeight' => new \PHPExiftool\Driver\Tag\Scalado\PreviewImageHeight(),
                'PreviewQuality' => new \PHPExiftool\Driver\Tag\Scalado\PreviewQuality(),
                'DataLength' => new \PHPExiftool\Driver\Tag\Scalado\DataLength(),
                'PreviewImageWidth' => new \PHPExiftool\Driver\Tag\Scalado\PreviewImageWidth(),
            );
        });
        $this['Sigma'] = $this->share(function(){
            return array(
                'SerialNumber' => new \PHPExiftool\Driver\Tag\Sigma\SerialNumber(),
                'DriveMode' => new \PHPExiftool\Driver\Tag\Sigma\DriveMode(),
                'ResolutionMode' => new \PHPExiftool\Driver\Tag\Sigma\ResolutionMode(),
                'AFMode' => new \PHPExiftool\Driver\Tag\Sigma\AFMode(),
                'FocusSetting' => new \PHPExiftool\Driver\Tag\Sigma\FocusSetting(),
                'WhiteBalance' => new \PHPExiftool\Driver\Tag\Sigma\WhiteBalance(),
                'ExposureMode' => new \PHPExiftool\Driver\Tag\Sigma\ExposureMode(),
                'MeteringMode' => new \PHPExiftool\Driver\Tag\Sigma\MeteringMode(),
                'LensFocalRange' => new \PHPExiftool\Driver\Tag\Sigma\LensFocalRange(),
                'ColorSpace' => new \PHPExiftool\Driver\Tag\Sigma\ColorSpace(),
                'ExposureCompensation' => new \PHPExiftool\Driver\Tag\Sigma\ExposureCompensation(),
                'ExposureAdjust' => new \PHPExiftool\Driver\Tag\Sigma\ExposureAdjust(),
                'Contrast' => new \PHPExiftool\Driver\Tag\Sigma\Contrast(),
                'Shadow' => new \PHPExiftool\Driver\Tag\Sigma\Shadow(),
                'Highlight' => new \PHPExiftool\Driver\Tag\Sigma\Highlight(),
                'Saturation' => new \PHPExiftool\Driver\Tag\Sigma\Saturation(),
                'Sharpness' => new \PHPExiftool\Driver\Tag\Sigma\Sharpness(),
                'X3FillLight' => new \PHPExiftool\Driver\Tag\Sigma\X3FillLight(),
                'ColorAdjustment' => new \PHPExiftool\Driver\Tag\Sigma\ColorAdjustment(),
                'AdjustmentMode' => new \PHPExiftool\Driver\Tag\Sigma\AdjustmentMode(),
                'Quality' => new \PHPExiftool\Driver\Tag\Sigma\Quality(),
                'Firmware' => new \PHPExiftool\Driver\Tag\Sigma\Firmware(),
                'Software' => new \PHPExiftool\Driver\Tag\Sigma\Software(),
                'AutoBracket' => new \PHPExiftool\Driver\Tag\Sigma\AutoBracket(),
                'PreviewImageStart' => new \PHPExiftool\Driver\Tag\Sigma\PreviewImageStart(),
                'ChrominanceNoiseReduction' => new \PHPExiftool\Driver\Tag\Sigma\ChrominanceNoiseReduction(),
                'PreviewImageLength' => new \PHPExiftool\Driver\Tag\Sigma\PreviewImageLength(),
                'LuminanceNoiseReduction' => new \PHPExiftool\Driver\Tag\Sigma\LuminanceNoiseReduction(),
                'PreviewImageSize' => new \PHPExiftool\Driver\Tag\Sigma\PreviewImageSize(),
                'MakerNoteVersion' => new \PHPExiftool\Driver\Tag\Sigma\MakerNoteVersion(),
                'AFPoint' => new \PHPExiftool\Driver\Tag\Sigma\AFPoint(),
                'FileFormat' => new \PHPExiftool\Driver\Tag\Sigma\FileFormat(),
                'Calibration' => new \PHPExiftool\Driver\Tag\Sigma\Calibration(),
                'LensType' => new \PHPExiftool\Driver\Tag\Sigma\LensType(),
                'LensMaxApertureRange' => new \PHPExiftool\Driver\Tag\Sigma\LensMaxApertureRange(),
                'ColorMode' => new \PHPExiftool\Driver\Tag\Sigma\ColorMode(),
                'LensApertureRange' => new \PHPExiftool\Driver\Tag\Sigma\LensApertureRange(),
                'FNumber' => new \PHPExiftool\Driver\Tag\Sigma\FNumber(),
                'ExposureTime' => new \PHPExiftool\Driver\Tag\Sigma\ExposureTime(),
                'ExposureTime2' => new \PHPExiftool\Driver\Tag\Sigma\ExposureTime2(),
                'BurstShot' => new \PHPExiftool\Driver\Tag\Sigma\BurstShot(),
                'SensorTemperature' => new \PHPExiftool\Driver\Tag\Sigma\SensorTemperature(),
                'FlashExposureComp' => new \PHPExiftool\Driver\Tag\Sigma\FlashExposureComp(),
                'PictureMode' => new \PHPExiftool\Driver\Tag\Sigma\PictureMode(),
                'Firmware2' => new \PHPExiftool\Driver\Tag\Sigma\Firmware2(),
                'DigitalFilter' => new \PHPExiftool\Driver\Tag\Sigma\DigitalFilter(),
                'Model' => new \PHPExiftool\Driver\Tag\Sigma\Model(),
                'ISO' => new \PHPExiftool\Driver\Tag\Sigma\ISO(),
                'CameraCalibration' => new \PHPExiftool\Driver\Tag\Sigma\CameraCalibration(),
                'WB_RGBLevelsAuto' => new \PHPExiftool\Driver\Tag\Sigma\WBRGBLevelsAuto(),
                'WB_RGBLevelsDaylight' => new \PHPExiftool\Driver\Tag\Sigma\WBRGBLevelsDaylight(),
                'WB_RGBLevelsShade' => new \PHPExiftool\Driver\Tag\Sigma\WBRGBLevelsShade(),
                'WB_RGBLevelsOvercast' => new \PHPExiftool\Driver\Tag\Sigma\WBRGBLevelsOvercast(),
                'WB_RGBLevelsIncandescent' => new \PHPExiftool\Driver\Tag\Sigma\WBRGBLevelsIncandescent(),
                'WB_RGBLevelsFluorescent' => new \PHPExiftool\Driver\Tag\Sigma\WBRGBLevelsFluorescent(),
                'WB_RGBLevelsFlash' => new \PHPExiftool\Driver\Tag\Sigma\WBRGBLevelsFlash(),
                'WB_RGBLevelsCustom1' => new \PHPExiftool\Driver\Tag\Sigma\WBRGBLevelsCustom1(),
                'WB_RGBLevelsCustom2' => new \PHPExiftool\Driver\Tag\Sigma\WBRGBLevelsCustom2(),
                'WB_RGBLevelsCustom3' => new \PHPExiftool\Driver\Tag\Sigma\WBRGBLevelsCustom3(),
                'WB_RGBLevelsUnknown0' => new \PHPExiftool\Driver\Tag\Sigma\WBRGBLevelsUnknown0(),
                'WB_RGBLevelsUnknown1' => new \PHPExiftool\Driver\Tag\Sigma\WBRGBLevelsUnknown1(),
                'WB_RGBLevelsUnknown2' => new \PHPExiftool\Driver\Tag\Sigma\WBRGBLevelsUnknown2(),
                'WB_RGBLevelsUnknown3' => new \PHPExiftool\Driver\Tag\Sigma\WBRGBLevelsUnknown3(),
                'WB_RGBLevelsUnknown4' => new \PHPExiftool\Driver\Tag\Sigma\WBRGBLevelsUnknown4(),
                'WB_RGBLevelsUnknown5' => new \PHPExiftool\Driver\Tag\Sigma\WBRGBLevelsUnknown5(),
                'WB_RGBLevelsUnknown6' => new \PHPExiftool\Driver\Tag\Sigma\WBRGBLevelsUnknown6(),
                'WB_RGBLevelsUnknown7' => new \PHPExiftool\Driver\Tag\Sigma\WBRGBLevelsUnknown7(),
                'WB_RGBLevelsUnknown8' => new \PHPExiftool\Driver\Tag\Sigma\WBRGBLevelsUnknown8(),
                'WB_RGBLevelsUnknown9' => new \PHPExiftool\Driver\Tag\Sigma\WBRGBLevelsUnknown9(),
            );
        });
        $this['SigmaRaw'] = $this->share(function(){
            return array(
                'FileVersion' => new \PHPExiftool\Driver\Tag\SigmaRaw\FileVersion(),
                'ImageUniqueID' => new \PHPExiftool\Driver\Tag\SigmaRaw\ImageUniqueID(),
                'MarkBits' => new \PHPExiftool\Driver\Tag\SigmaRaw\MarkBits(),
                'ImageWidth' => new \PHPExiftool\Driver\Tag\SigmaRaw\ImageWidth(),
                'ImageHeight' => new \PHPExiftool\Driver\Tag\SigmaRaw\ImageHeight(),
                'Rotation' => new \PHPExiftool\Driver\Tag\SigmaRaw\Rotation(),
                'WhiteBalance' => new \PHPExiftool\Driver\Tag\SigmaRaw\WhiteBalance(),
                'SceneCaptureType' => new \PHPExiftool\Driver\Tag\SigmaRaw\SceneCaptureType(),
                'Unused' => new \PHPExiftool\Driver\Tag\SigmaRaw\Unused(),
                'ExposureAdjust' => new \PHPExiftool\Driver\Tag\SigmaRaw\ExposureAdjust(),
                'Contrast' => new \PHPExiftool\Driver\Tag\SigmaRaw\Contrast(),
                'Shadow' => new \PHPExiftool\Driver\Tag\SigmaRaw\Shadow(),
                'Highlight' => new \PHPExiftool\Driver\Tag\SigmaRaw\Highlight(),
                'Saturation' => new \PHPExiftool\Driver\Tag\SigmaRaw\Saturation(),
                'Sharpness' => new \PHPExiftool\Driver\Tag\SigmaRaw\Sharpness(),
                'RedAdjust' => new \PHPExiftool\Driver\Tag\SigmaRaw\RedAdjust(),
                'GreenAdjust' => new \PHPExiftool\Driver\Tag\SigmaRaw\GreenAdjust(),
                'BlueAdjust' => new \PHPExiftool\Driver\Tag\SigmaRaw\BlueAdjust(),
                'X3FillLight' => new \PHPExiftool\Driver\Tag\SigmaRaw\X3FillLight(),
                'PreviewImage' => new \PHPExiftool\Driver\Tag\SigmaRaw\PreviewImage(),
                'JpgFromRaw' => new \PHPExiftool\Driver\Tag\SigmaRaw\JpgFromRaw(),
                'MeteringMode' => new \PHPExiftool\Driver\Tag\SigmaRaw\MeteringMode(),
                'AFArea' => new \PHPExiftool\Driver\Tag\SigmaRaw\AFArea(),
                'AFInFocus' => new \PHPExiftool\Driver\Tag\SigmaRaw\AFInFocus(),
                'FocusMode' => new \PHPExiftool\Driver\Tag\SigmaRaw\FocusMode(),
                'FNumber' => new \PHPExiftool\Driver\Tag\SigmaRaw\FNumber(),
                'ApertureDisplayed' => new \PHPExiftool\Driver\Tag\SigmaRaw\ApertureDisplayed(),
                'BracketShot' => new \PHPExiftool\Driver\Tag\SigmaRaw\BracketShot(),
                'BurstShot' => new \PHPExiftool\Driver\Tag\SigmaRaw\BurstShot(),
                'Make' => new \PHPExiftool\Driver\Tag\SigmaRaw\Make(),
                'Model' => new \PHPExiftool\Driver\Tag\SigmaRaw\Model(),
                'CameraName' => new \PHPExiftool\Driver\Tag\SigmaRaw\CameraName(),
                'SerialNumber' => new \PHPExiftool\Driver\Tag\SigmaRaw\SerialNumber(),
                'ColorSpace' => new \PHPExiftool\Driver\Tag\SigmaRaw\ColorSpace(),
                'DriveMode' => new \PHPExiftool\Driver\Tag\SigmaRaw\DriveMode(),
                'EvalState' => new \PHPExiftool\Driver\Tag\SigmaRaw\EvalState(),
                'ExposureCompensation' => new \PHPExiftool\Driver\Tag\SigmaRaw\ExposureCompensation(),
                'NetExposureCompensation' => new \PHPExiftool\Driver\Tag\SigmaRaw\NetExposureCompensation(),
                'IntegrationTime' => new \PHPExiftool\Driver\Tag\SigmaRaw\IntegrationTime(),
                'FirmwareVersion' => new \PHPExiftool\Driver\Tag\SigmaRaw\FirmwareVersion(),
                'FlashMode' => new \PHPExiftool\Driver\Tag\SigmaRaw\FlashMode(),
                'FlashExpComp' => new \PHPExiftool\Driver\Tag\SigmaRaw\FlashExpComp(),
                'FlashPower' => new \PHPExiftool\Driver\Tag\SigmaRaw\FlashPower(),
                'FlashTTLMode' => new \PHPExiftool\Driver\Tag\SigmaRaw\FlashTTLMode(),
                'FlashType' => new \PHPExiftool\Driver\Tag\SigmaRaw\FlashType(),
                'FocalLength' => new \PHPExiftool\Driver\Tag\SigmaRaw\FocalLength(),
                'FocalLengthIn35mmFormat' => new \PHPExiftool\Driver\Tag\SigmaRaw\FocalLengthIn35mmFormat(),
                'Focus' => new \PHPExiftool\Driver\Tag\SigmaRaw\Focus(),
                'ImageBoardID' => new \PHPExiftool\Driver\Tag\SigmaRaw\ImageBoardID(),
                'ImagerBoardID' => new \PHPExiftool\Driver\Tag\SigmaRaw\ImagerBoardID(),
                'SensorTemperature' => new \PHPExiftool\Driver\Tag\SigmaRaw\SensorTemperature(),
                'ISO' => new \PHPExiftool\Driver\Tag\SigmaRaw\ISO(),
                'LensApertureRange' => new \PHPExiftool\Driver\Tag\SigmaRaw\LensApertureRange(),
                'LensFocalRange' => new \PHPExiftool\Driver\Tag\SigmaRaw\LensFocalRange(),
                'LensType' => new \PHPExiftool\Driver\Tag\SigmaRaw\LensType(),
                'ExposureProgram' => new \PHPExiftool\Driver\Tag\SigmaRaw\ExposureProgram(),
                'Quality' => new \PHPExiftool\Driver\Tag\SigmaRaw\Quality(),
                'SensorID' => new \PHPExiftool\Driver\Tag\SigmaRaw\SensorID(),
                'ExposureTime' => new \PHPExiftool\Driver\Tag\SigmaRaw\ExposureTime(),
                'ShutterSpeedDisplayed' => new \PHPExiftool\Driver\Tag\SigmaRaw\ShutterSpeedDisplayed(),
                'DateTimeOriginal' => new \PHPExiftool\Driver\Tag\SigmaRaw\DateTimeOriginal(),
                'VersionBF' => new \PHPExiftool\Driver\Tag\SigmaRaw\VersionBF(),
            );
        });
        $this['Sony'] = $this->share(function(){
            return array(
                'AFType' => new \PHPExiftool\Driver\Tag\Sony\AFType(),
                'AFStatusActiveSensor' => new \PHPExiftool\Driver\Tag\Sony\AFStatusActiveSensor(),
                'FocusMode' => new \PHPExiftool\Driver\Tag\Sony\FocusMode(),
                'AFPoint' => new \PHPExiftool\Driver\Tag\Sony\AFPoint(),
                'AFPointInFocus' => new \PHPExiftool\Driver\Tag\Sony\AFPointInFocus(),
                'AFPointAtShutterRelease' => new \PHPExiftool\Driver\Tag\Sony\AFPointAtShutterRelease(),
                'AFAreaMode' => new \PHPExiftool\Driver\Tag\Sony\AFAreaMode(),
                'AFPointsUsed' => new \PHPExiftool\Driver\Tag\Sony\AFPointsUsed(),
                'ExposureProgram' => new \PHPExiftool\Driver\Tag\Sony\ExposureProgram(),
                'AFMicroAdj' => new \PHPExiftool\Driver\Tag\Sony\AFMicroAdj(),
                'AFStatusUpper-left' => new \PHPExiftool\Driver\Tag\Sony\AFStatusUpperLeft(),
                'AFStatusLeft' => new \PHPExiftool\Driver\Tag\Sony\AFStatusLeft(),
                'AFStatusLower-left' => new \PHPExiftool\Driver\Tag\Sony\AFStatusLowerLeft(),
                'AFStatusFarLeft' => new \PHPExiftool\Driver\Tag\Sony\AFStatusFarLeft(),
                'AFStatusTopHorizontal' => new \PHPExiftool\Driver\Tag\Sony\AFStatusTopHorizontal(),
                'AFStatusNearRight' => new \PHPExiftool\Driver\Tag\Sony\AFStatusNearRight(),
                'mixed' => new \PHPExiftool\Driver\Tag\Sony\AFStatusCenterVertical(),
                'AFStatusNearLeft' => new \PHPExiftool\Driver\Tag\Sony\AFStatusNearLeft(),
                'AFStatusBottomHorizontal' => new \PHPExiftool\Driver\Tag\Sony\AFStatusBottomHorizontal(),
                'AFStatusTopVertical' => new \PHPExiftool\Driver\Tag\Sony\AFStatusTopVertical(),
                'AFStatusBottomVertical' => new \PHPExiftool\Driver\Tag\Sony\AFStatusBottomVertical(),
                'AFStatusFarRight' => new \PHPExiftool\Driver\Tag\Sony\AFStatusFarRight(),
                'AFStatusUpper-right' => new \PHPExiftool\Driver\Tag\Sony\AFStatusUpperRight(),
                'AFStatusRight' => new \PHPExiftool\Driver\Tag\Sony\AFStatusRight(),
                'AFStatusLower-right' => new \PHPExiftool\Driver\Tag\Sony\AFStatusLowerRight(),
                'AFStatusUpper-middle' => new \PHPExiftool\Driver\Tag\Sony\AFStatusUpperMiddle(),
                'AFStatusLower-middle' => new \PHPExiftool\Driver\Tag\Sony\AFStatusLowerMiddle(),
                'AFStatusUpperFarLeft' => new \PHPExiftool\Driver\Tag\Sony\AFStatusUpperFarLeft(),
                'AFStatusUpper-leftHorizontal' => new \PHPExiftool\Driver\Tag\Sony\AFStatusUpperLeftHorizontal(),
                'AFStatusFarLeftHorizontal' => new \PHPExiftool\Driver\Tag\Sony\AFStatusFarLeftHorizontal(),
                'AFStatusLeftHorizontal' => new \PHPExiftool\Driver\Tag\Sony\AFStatusLeftHorizontal(),
                'AFStatusLowerFarLeft' => new \PHPExiftool\Driver\Tag\Sony\AFStatusLowerFarLeft(),
                'AFStatusLower-leftHorizontal' => new \PHPExiftool\Driver\Tag\Sony\AFStatusLowerLeftHorizontal(),
                'AFStatusUpper-leftVertical' => new \PHPExiftool\Driver\Tag\Sony\AFStatusUpperLeftVertical(),
                'AFStatusLeftVertical' => new \PHPExiftool\Driver\Tag\Sony\AFStatusLeftVertical(),
                'AFStatusLower-leftVertical' => new \PHPExiftool\Driver\Tag\Sony\AFStatusLowerLeftVertical(),
                'AFStatusFarLeftVertical' => new \PHPExiftool\Driver\Tag\Sony\AFStatusFarLeftVertical(),
                'AFStatusUpperFarRight' => new \PHPExiftool\Driver\Tag\Sony\AFStatusUpperFarRight(),
                'AFStatusUpper-rightHorizontal' => new \PHPExiftool\Driver\Tag\Sony\AFStatusUpperRightHorizontal(),
                'AFStatusFarRightHorizontal' => new \PHPExiftool\Driver\Tag\Sony\AFStatusFarRightHorizontal(),
                'AFStatusRightHorizontal' => new \PHPExiftool\Driver\Tag\Sony\AFStatusRightHorizontal(),
                'AFStatusLowerFarRight' => new \PHPExiftool\Driver\Tag\Sony\AFStatusLowerFarRight(),
                'AFStatusLower-rightHorizontal' => new \PHPExiftool\Driver\Tag\Sony\AFStatusLowerRightHorizontal(),
                'AFStatusFarRightVertical' => new \PHPExiftool\Driver\Tag\Sony\AFStatusFarRightVertical(),
                'AFStatusUpper-rightVertical' => new \PHPExiftool\Driver\Tag\Sony\AFStatusUpperRightVertical(),
                'AFStatusRightVertical' => new \PHPExiftool\Driver\Tag\Sony\AFStatusRightVertical(),
                'AFStatusLower-rightVertical' => new \PHPExiftool\Driver\Tag\Sony\AFStatusLowerRightVertical(),
                'AFStatus_00_B4' => new \PHPExiftool\Driver\Tag\Sony\AFStatus00B4(),
                'AFStatus_01_C4' => new \PHPExiftool\Driver\Tag\Sony\AFStatus01C4(),
                'AFStatus_02_D4' => new \PHPExiftool\Driver\Tag\Sony\AFStatus02D4(),
                'AFStatus_03_E4' => new \PHPExiftool\Driver\Tag\Sony\AFStatus03E4(),
                'AFStatus_04_F4' => new \PHPExiftool\Driver\Tag\Sony\AFStatus04F4(),
                'AFStatus_05_G4' => new \PHPExiftool\Driver\Tag\Sony\AFStatus05G4(),
                'AFStatus_06_H4' => new \PHPExiftool\Driver\Tag\Sony\AFStatus06H4(),
                'AFStatus_07_B3' => new \PHPExiftool\Driver\Tag\Sony\AFStatus07B3(),
                'AFStatus_08_C3' => new \PHPExiftool\Driver\Tag\Sony\AFStatus08C3(),
                'AFStatus_09_D3' => new \PHPExiftool\Driver\Tag\Sony\AFStatus09D3(),
                'AFStatus_10_E3' => new \PHPExiftool\Driver\Tag\Sony\AFStatus10E3(),
                'AFStatus_11_F3' => new \PHPExiftool\Driver\Tag\Sony\AFStatus11F3(),
                'AFStatus_12_G3' => new \PHPExiftool\Driver\Tag\Sony\AFStatus12G3(),
                'AFStatus_13_H3' => new \PHPExiftool\Driver\Tag\Sony\AFStatus13H3(),
                'AFStatus_14_B2' => new \PHPExiftool\Driver\Tag\Sony\AFStatus14B2(),
                'AFStatus_15_C2' => new \PHPExiftool\Driver\Tag\Sony\AFStatus15C2(),
                'AFStatus_16_D2' => new \PHPExiftool\Driver\Tag\Sony\AFStatus16D2(),
                'AFStatus_17_E2' => new \PHPExiftool\Driver\Tag\Sony\AFStatus17E2(),
                'AFStatus_18_F2' => new \PHPExiftool\Driver\Tag\Sony\AFStatus18F2(),
                'AFStatus_19_G2' => new \PHPExiftool\Driver\Tag\Sony\AFStatus19G2(),
                'AFStatus_20_H2' => new \PHPExiftool\Driver\Tag\Sony\AFStatus20H2(),
                'AFStatus_21_C1' => new \PHPExiftool\Driver\Tag\Sony\AFStatus21C1(),
                'AFStatus_22_D1' => new \PHPExiftool\Driver\Tag\Sony\AFStatus22D1(),
                'AFStatus_23_E1' => new \PHPExiftool\Driver\Tag\Sony\AFStatus23E1(),
                'AFStatus_24_F1' => new \PHPExiftool\Driver\Tag\Sony\AFStatus24F1(),
                'AFStatus_25_G1' => new \PHPExiftool\Driver\Tag\Sony\AFStatus25G1(),
                'AFStatus_26_A7_Vertical' => new \PHPExiftool\Driver\Tag\Sony\AFStatus26A7Vertical(),
                'AFStatus_27_A6_Vertical' => new \PHPExiftool\Driver\Tag\Sony\AFStatus27A6Vertical(),
                'AFStatus_28_A5_Vertical' => new \PHPExiftool\Driver\Tag\Sony\AFStatus28A5Vertical(),
                'AFStatus_29_C7_Vertical' => new \PHPExiftool\Driver\Tag\Sony\AFStatus29C7Vertical(),
                'AFStatus_30_C6_Vertical' => new \PHPExiftool\Driver\Tag\Sony\AFStatus30C6Vertical(),
                'AFStatus_31_C5_Vertical' => new \PHPExiftool\Driver\Tag\Sony\AFStatus31C5Vertical(),
                'AFStatus_32_E7_Vertical' => new \PHPExiftool\Driver\Tag\Sony\AFStatus32E7Vertical(),
                'AFStatus_33_E6_Center_Vertical' => new \PHPExiftool\Driver\Tag\Sony\AFStatus33E6CenterVertical(),
                'AFStatus_34_E5_Vertical' => new \PHPExiftool\Driver\Tag\Sony\AFStatus34E5Vertical(),
                'AFStatus_35_G7_Vertical' => new \PHPExiftool\Driver\Tag\Sony\AFStatus35G7Vertical(),
                'AFStatus_36_G6_Vertical' => new \PHPExiftool\Driver\Tag\Sony\AFStatus36G6Vertical(),
                'AFStatus_37_G5_Vertical' => new \PHPExiftool\Driver\Tag\Sony\AFStatus37G5Vertical(),
                'AFStatus_38_I7_Vertical' => new \PHPExiftool\Driver\Tag\Sony\AFStatus38I7Vertical(),
                'AFStatus_39_I6_Vertical' => new \PHPExiftool\Driver\Tag\Sony\AFStatus39I6Vertical(),
                'AFStatus_40_I5_Vertical' => new \PHPExiftool\Driver\Tag\Sony\AFStatus40I5Vertical(),
                'AFStatus_41_A7' => new \PHPExiftool\Driver\Tag\Sony\AFStatus41A7(),
                'AFStatus_42_B7' => new \PHPExiftool\Driver\Tag\Sony\AFStatus42B7(),
                'AFStatus_43_C7' => new \PHPExiftool\Driver\Tag\Sony\AFStatus43C7(),
                'AFStatus_44_D7' => new \PHPExiftool\Driver\Tag\Sony\AFStatus44D7(),
                'AFStatus_45_E7' => new \PHPExiftool\Driver\Tag\Sony\AFStatus45E7(),
                'AFStatus_46_F7' => new \PHPExiftool\Driver\Tag\Sony\AFStatus46F7(),
                'AFStatus_47_G7' => new \PHPExiftool\Driver\Tag\Sony\AFStatus47G7(),
                'AFStatus_48_H7' => new \PHPExiftool\Driver\Tag\Sony\AFStatus48H7(),
                'AFStatus_49_I7' => new \PHPExiftool\Driver\Tag\Sony\AFStatus49I7(),
                'AFStatus_50_A6' => new \PHPExiftool\Driver\Tag\Sony\AFStatus50A6(),
                'AFStatus_51_B6' => new \PHPExiftool\Driver\Tag\Sony\AFStatus51B6(),
                'AFStatus_52_C6' => new \PHPExiftool\Driver\Tag\Sony\AFStatus52C6(),
                'AFStatus_53_D6' => new \PHPExiftool\Driver\Tag\Sony\AFStatus53D6(),
                'AFStatus_54_E6_Center' => new \PHPExiftool\Driver\Tag\Sony\AFStatus54E6Center(),
                'AFStatus_55_F6' => new \PHPExiftool\Driver\Tag\Sony\AFStatus55F6(),
                'AFStatus_56_G6' => new \PHPExiftool\Driver\Tag\Sony\AFStatus56G6(),
                'AFStatus_57_H6' => new \PHPExiftool\Driver\Tag\Sony\AFStatus57H6(),
                'AFStatus_58_I6' => new \PHPExiftool\Driver\Tag\Sony\AFStatus58I6(),
                'AFStatus_59_A5' => new \PHPExiftool\Driver\Tag\Sony\AFStatus59A5(),
                'AFStatus_60_B5' => new \PHPExiftool\Driver\Tag\Sony\AFStatus60B5(),
                'AFStatus_61_C5' => new \PHPExiftool\Driver\Tag\Sony\AFStatus61C5(),
                'AFStatus_62_D5' => new \PHPExiftool\Driver\Tag\Sony\AFStatus62D5(),
                'AFStatus_63_E5' => new \PHPExiftool\Driver\Tag\Sony\AFStatus63E5(),
                'AFStatus_64_F5' => new \PHPExiftool\Driver\Tag\Sony\AFStatus64F5(),
                'AFStatus_65_G5' => new \PHPExiftool\Driver\Tag\Sony\AFStatus65G5(),
                'AFStatus_66_H5' => new \PHPExiftool\Driver\Tag\Sony\AFStatus66H5(),
                'AFStatus_67_I5' => new \PHPExiftool\Driver\Tag\Sony\AFStatus67I5(),
                'AFStatus_68_C11' => new \PHPExiftool\Driver\Tag\Sony\AFStatus68C11(),
                'AFStatus_69_D11' => new \PHPExiftool\Driver\Tag\Sony\AFStatus69D11(),
                'AFStatus_70_E11' => new \PHPExiftool\Driver\Tag\Sony\AFStatus70E11(),
                'AFStatus_71_F11' => new \PHPExiftool\Driver\Tag\Sony\AFStatus71F11(),
                'AFStatus_72_G11' => new \PHPExiftool\Driver\Tag\Sony\AFStatus72G11(),
                'AFStatus_73_B10' => new \PHPExiftool\Driver\Tag\Sony\AFStatus73B10(),
                'AFStatus_74_C10' => new \PHPExiftool\Driver\Tag\Sony\AFStatus74C10(),
                'AFStatus_75_D10' => new \PHPExiftool\Driver\Tag\Sony\AFStatus75D10(),
                'AFStatus_76_E10' => new \PHPExiftool\Driver\Tag\Sony\AFStatus76E10(),
                'AFStatus_77_F10' => new \PHPExiftool\Driver\Tag\Sony\AFStatus77F10(),
                'AFStatus_78_G10' => new \PHPExiftool\Driver\Tag\Sony\AFStatus78G10(),
                'AFStatus_79_H10' => new \PHPExiftool\Driver\Tag\Sony\AFStatus79H10(),
                'AFStatus_80_B9' => new \PHPExiftool\Driver\Tag\Sony\AFStatus80B9(),
                'AFStatus_81_C9' => new \PHPExiftool\Driver\Tag\Sony\AFStatus81C9(),
                'AFStatus_82_D9' => new \PHPExiftool\Driver\Tag\Sony\AFStatus82D9(),
                'AFStatus_83_E9' => new \PHPExiftool\Driver\Tag\Sony\AFStatus83E9(),
                'AFStatus_84_F9' => new \PHPExiftool\Driver\Tag\Sony\AFStatus84F9(),
                'AFStatus_85_G9' => new \PHPExiftool\Driver\Tag\Sony\AFStatus85G9(),
                'AFStatus_86_H9' => new \PHPExiftool\Driver\Tag\Sony\AFStatus86H9(),
                'AFStatus_87_B8' => new \PHPExiftool\Driver\Tag\Sony\AFStatus87B8(),
                'AFStatus_88_C8' => new \PHPExiftool\Driver\Tag\Sony\AFStatus88C8(),
                'AFStatus_89_D8' => new \PHPExiftool\Driver\Tag\Sony\AFStatus89D8(),
                'AFStatus_90_E8' => new \PHPExiftool\Driver\Tag\Sony\AFStatus90E8(),
                'AFStatus_91_F8' => new \PHPExiftool\Driver\Tag\Sony\AFStatus91F8(),
                'AFStatus_92_G8' => new \PHPExiftool\Driver\Tag\Sony\AFStatus92G8(),
                'AFStatus_93_H8' => new \PHPExiftool\Driver\Tag\Sony\AFStatus93H8(),
                'AFStatus_94_E6_Center_F2-8' => new \PHPExiftool\Driver\Tag\Sony\AFStatus94E6CenterF28(),
                'LensSpec' => new \PHPExiftool\Driver\Tag\Sony\LensSpec(),
                'FocusModeSetting' => new \PHPExiftool\Driver\Tag\Sony\FocusModeSetting(),
                'AFPointSelected' => new \PHPExiftool\Driver\Tag\Sony\AFPointSelected(),
                'AFStatusBottomAssist-left' => new \PHPExiftool\Driver\Tag\Sony\AFStatusBottomAssistLeft(),
                'AFStatusBottom' => new \PHPExiftool\Driver\Tag\Sony\AFStatusBottom(),
                'AFStatusBottomAssist-right' => new \PHPExiftool\Driver\Tag\Sony\AFStatusBottomAssistRight(),
                'AFStatusCenter-7' => new \PHPExiftool\Driver\Tag\Sony\AFStatusCenter7(),
                'AFStatusCenter-9' => new \PHPExiftool\Driver\Tag\Sony\AFStatusCenter9(),
                'AFStatusCenter-10' => new \PHPExiftool\Driver\Tag\Sony\AFStatusCenter10(),
                'AFStatusCenter-11' => new \PHPExiftool\Driver\Tag\Sony\AFStatusCenter11(),
                'AFStatusCenter-12' => new \PHPExiftool\Driver\Tag\Sony\AFStatusCenter12(),
                'AFStatusCenter-14' => new \PHPExiftool\Driver\Tag\Sony\AFStatusCenter14(),
                'AFStatusTopAssist-left' => new \PHPExiftool\Driver\Tag\Sony\AFStatusTopAssistLeft(),
                'AFStatusTop' => new \PHPExiftool\Driver\Tag\Sony\AFStatusTop(),
                'AFStatusTopAssist-right' => new \PHPExiftool\Driver\Tag\Sony\AFStatusTopAssistRight(),
                'AFStatusCenterF2-8' => new \PHPExiftool\Driver\Tag\Sony\AFStatusCenterF28(),
                'AFMicroAdjValue' => new \PHPExiftool\Driver\Tag\Sony\AFMicroAdjValue(),
                'AFMicroAdjMode' => new \PHPExiftool\Driver\Tag\Sony\AFMicroAdjMode(),
                'AFMicroAdjRegisteredLenses' => new \PHPExiftool\Driver\Tag\Sony\AFMicroAdjRegisteredLenses(),
                'AFStatusTop-right' => new \PHPExiftool\Driver\Tag\Sony\AFStatusTopRight(),
                'AFStatusBottom-right' => new \PHPExiftool\Driver\Tag\Sony\AFStatusBottomRight(),
                'AFStatusMiddleHorizontal' => new \PHPExiftool\Driver\Tag\Sony\AFStatusMiddleHorizontal(),
                'AFStatusTop-left' => new \PHPExiftool\Driver\Tag\Sony\AFStatusTopLeft(),
                'AFStatusBottom-left' => new \PHPExiftool\Driver\Tag\Sony\AFStatusBottomLeft(),
                'FocalLength' => new \PHPExiftool\Driver\Tag\Sony\FocalLength(),
                'FocalLengthTeleZoom' => new \PHPExiftool\Driver\Tag\Sony\FocalLengthTeleZoom(),
                'FocusStatus' => new \PHPExiftool\Driver\Tag\Sony\FocusStatus(),
                'ExposureTime' => new \PHPExiftool\Driver\Tag\Sony\ExposureTime(),
                'FNumber' => new \PHPExiftool\Driver\Tag\Sony\FNumber(),
                'HighSpeedSync' => new \PHPExiftool\Driver\Tag\Sony\HighSpeedSync(),
                'ExposureCompensationSet' => new \PHPExiftool\Driver\Tag\Sony\ExposureCompensationSet(),
                'DriveMode' => new \PHPExiftool\Driver\Tag\Sony\DriveMode(),
                'WhiteBalanceSetting' => new \PHPExiftool\Driver\Tag\Sony\WhiteBalanceSetting(),
                'WhiteBalanceFineTune' => new \PHPExiftool\Driver\Tag\Sony\WhiteBalanceFineTune(),
                'ColorTemperatureSet' => new \PHPExiftool\Driver\Tag\Sony\ColorTemperatureSet(),
                'ColorCompensationFilterSet' => new \PHPExiftool\Driver\Tag\Sony\ColorCompensationFilterSet(),
                'ColorTemperatureCustom' => new \PHPExiftool\Driver\Tag\Sony\ColorTemperatureCustom(),
                'ColorCompensationFilterCustom' => new \PHPExiftool\Driver\Tag\Sony\ColorCompensationFilterCustom(),
                'WhiteBalance' => new \PHPExiftool\Driver\Tag\Sony\WhiteBalance(),
                'AFPointSetting' => new \PHPExiftool\Driver\Tag\Sony\AFPointSetting(),
                'FlashMode' => new \PHPExiftool\Driver\Tag\Sony\FlashMode(),
                'FlashExposureCompSet' => new \PHPExiftool\Driver\Tag\Sony\FlashExposureCompSet(),
                'MeteringMode' => new \PHPExiftool\Driver\Tag\Sony\MeteringMode(),
                'ISOSetting' => new \PHPExiftool\Driver\Tag\Sony\ISOSetting(),
                'DynamicRangeOptimizerMode' => new \PHPExiftool\Driver\Tag\Sony\DynamicRangeOptimizerMode(),
                'DynamicRangeOptimizerLevel' => new \PHPExiftool\Driver\Tag\Sony\DynamicRangeOptimizerLevel(),
                'CreativeStyle' => new \PHPExiftool\Driver\Tag\Sony\CreativeStyle(),
                'ColorSpace' => new \PHPExiftool\Driver\Tag\Sony\ColorSpace(),
                'Sharpness' => new \PHPExiftool\Driver\Tag\Sony\Sharpness(),
                'Contrast' => new \PHPExiftool\Driver\Tag\Sony\Contrast(),
                'Saturation' => new \PHPExiftool\Driver\Tag\Sony\Saturation(),
                'ZoneMatchingValue' => new \PHPExiftool\Driver\Tag\Sony\ZoneMatchingValue(),
                'Brightness' => new \PHPExiftool\Driver\Tag\Sony\Brightness(),
                'FlashControl' => new \PHPExiftool\Driver\Tag\Sony\FlashControl(),
                'PrioritySetupShutterRelease' => new \PHPExiftool\Driver\Tag\Sony\PrioritySetupShutterRelease(),
                'AFIlluminator' => new \PHPExiftool\Driver\Tag\Sony\AFIlluminator(),
                'AFWithShutter' => new \PHPExiftool\Driver\Tag\Sony\AFWithShutter(),
                'LongExposureNoiseReduction' => new \PHPExiftool\Driver\Tag\Sony\LongExposureNoiseReduction(),
                'HighISONoiseReduction' => new \PHPExiftool\Driver\Tag\Sony\HighISONoiseReduction(),
                'ImageStyle' => new \PHPExiftool\Driver\Tag\Sony\ImageStyle(),
                'FocusModeSwitch' => new \PHPExiftool\Driver\Tag\Sony\FocusModeSwitch(),
                'ShutterSpeedSetting' => new \PHPExiftool\Driver\Tag\Sony\ShutterSpeedSetting(),
                'ApertureSetting' => new \PHPExiftool\Driver\Tag\Sony\ApertureSetting(),
                'ImageStabilizationSetting' => new \PHPExiftool\Driver\Tag\Sony\ImageStabilizationSetting(),
                'FlashAction' => new \PHPExiftool\Driver\Tag\Sony\FlashAction(),
                'Rotation' => new \PHPExiftool\Driver\Tag\Sony\Rotation(),
                'AELock' => new \PHPExiftool\Driver\Tag\Sony\AELock(),
                'FlashAction2' => new \PHPExiftool\Driver\Tag\Sony\FlashAction2(),
                'BatteryState' => new \PHPExiftool\Driver\Tag\Sony\BatteryState(),
                'BatteryLevel' => new \PHPExiftool\Driver\Tag\Sony\BatteryLevel(),
                'SonyImageSize' => new \PHPExiftool\Driver\Tag\Sony\SonyImageSize(),
                'AspectRatio' => new \PHPExiftool\Driver\Tag\Sony\AspectRatio(),
                'Quality' => new \PHPExiftool\Driver\Tag\Sony\Quality(),
                'ExposureLevelIncrements' => new \PHPExiftool\Driver\Tag\Sony\ExposureLevelIncrements(),
                'RedEyeReduction' => new \PHPExiftool\Driver\Tag\Sony\RedEyeReduction(),
                'FolderNumber' => new \PHPExiftool\Driver\Tag\Sony\FolderNumber(),
                'ImageNumber' => new \PHPExiftool\Driver\Tag\Sony\ImageNumber(),
                'CustomWB_RGBLevels' => new \PHPExiftool\Driver\Tag\Sony\CustomWBRGBLevels(),
                'DriveModeSetting' => new \PHPExiftool\Driver\Tag\Sony\DriveModeSetting(),
                'DynamicRangeOptimizerSetting' => new \PHPExiftool\Driver\Tag\Sony\DynamicRangeOptimizerSetting(),
                'CreativeStyleSetting' => new \PHPExiftool\Driver\Tag\Sony\CreativeStyleSetting(),
                'ContrastSetting' => new \PHPExiftool\Driver\Tag\Sony\ContrastSetting(),
                'SaturationSetting' => new \PHPExiftool\Driver\Tag\Sony\SaturationSetting(),
                'SharpnessSetting' => new \PHPExiftool\Driver\Tag\Sony\SharpnessSetting(),
                'ColorTemperatureSetting' => new \PHPExiftool\Driver\Tag\Sony\ColorTemperatureSetting(),
                'SmileShutterMode' => new \PHPExiftool\Driver\Tag\Sony\SmileShutterMode(),
                'HDRSetting' => new \PHPExiftool\Driver\Tag\Sony\HDRSetting(),
                'HDRLevel' => new \PHPExiftool\Driver\Tag\Sony\HDRLevel(),
                'ViewingMode' => new \PHPExiftool\Driver\Tag\Sony\ViewingMode(),
                'FaceDetection' => new \PHPExiftool\Driver\Tag\Sony\FaceDetection(),
                'SmileShutter' => new \PHPExiftool\Driver\Tag\Sony\SmileShutter(),
                'SweepPanoramaSize' => new \PHPExiftool\Driver\Tag\Sony\SweepPanoramaSize(),
                'SweepPanoramaDirection' => new \PHPExiftool\Driver\Tag\Sony\SweepPanoramaDirection(),
                'MultiFrameNoiseReduction' => new \PHPExiftool\Driver\Tag\Sony\MultiFrameNoiseReduction(),
                'LiveViewAFSetting' => new \PHPExiftool\Driver\Tag\Sony\LiveViewAFSetting(),
                'PanoramaSize3D' => new \PHPExiftool\Driver\Tag\Sony\PanoramaSize3D(),
                'AFButtonPressed' => new \PHPExiftool\Driver\Tag\Sony\AFButtonPressed(),
                'LiveViewMetering' => new \PHPExiftool\Driver\Tag\Sony\LiveViewMetering(),
                'ViewingMode2' => new \PHPExiftool\Driver\Tag\Sony\ViewingMode2(),
                'FlashStatusBuilt-in' => new \PHPExiftool\Driver\Tag\Sony\FlashStatusBuiltIn(),
                'FlashStatusExternal' => new \PHPExiftool\Driver\Tag\Sony\FlashStatusExternal(),
                'LiveViewFocusMode' => new \PHPExiftool\Driver\Tag\Sony\LiveViewFocusMode(),
                'LensMount' => new \PHPExiftool\Driver\Tag\Sony\LensMount(),
                'SequenceNumber' => new \PHPExiftool\Driver\Tag\Sony\SequenceNumber(),
                'ShotNumberSincePowerUp2' => new \PHPExiftool\Driver\Tag\Sony\ShotNumberSincePowerUp2(),
                'LensE-mountVersion' => new \PHPExiftool\Driver\Tag\Sony\LensEMountVersion(),
                'LensFirmwareVersion' => new \PHPExiftool\Driver\Tag\Sony\LensFirmwareVersion(),
                'LensType2' => new \PHPExiftool\Driver\Tag\Sony\LensType2(),
                'PreviewImageStart' => new \PHPExiftool\Driver\Tag\Sony\PreviewImageStart(),
                'PreviewImageLength' => new \PHPExiftool\Driver\Tag\Sony\PreviewImageLength(),
                'MakerNoteVersion' => new \PHPExiftool\Driver\Tag\Sony\MakerNoteVersion(),
                'BatteryTemperature' => new \PHPExiftool\Driver\Tag\Sony\BatteryTemperature(),
                'BatteryUnknown' => new \PHPExiftool\Driver\Tag\Sony\BatteryUnknown(),
                'BatteryVoltage' => new \PHPExiftool\Driver\Tag\Sony\BatteryVoltage(),
                'ImageStabilization2' => new \PHPExiftool\Driver\Tag\Sony\ImageStabilization2(),
                'ExtraInfoVersion' => new \PHPExiftool\Driver\Tag\Sony\ExtraInfoVersion(),
                'ImageStabilization' => new \PHPExiftool\Driver\Tag\Sony\ImageStabilization(),
                'BatteryVoltage1' => new \PHPExiftool\Driver\Tag\Sony\BatteryVoltage1(),
                'BatteryVoltage2' => new \PHPExiftool\Driver\Tag\Sony\BatteryVoltage2(),
                'ModeDialPosition' => new \PHPExiftool\Driver\Tag\Sony\ModeDialPosition(),
                'MemoryCardConfiguration' => new \PHPExiftool\Driver\Tag\Sony\MemoryCardConfiguration(),
                'CameraOrientation' => new \PHPExiftool\Driver\Tag\Sony\CameraOrientation(),
                'FacesDetected' => new \PHPExiftool\Driver\Tag\Sony\FacesDetected(),
                'Face1Position' => new \PHPExiftool\Driver\Tag\Sony\Face1Position(),
                'Face2Position' => new \PHPExiftool\Driver\Tag\Sony\Face2Position(),
                'Face3Position' => new \PHPExiftool\Driver\Tag\Sony\Face3Position(),
                'Face4Position' => new \PHPExiftool\Driver\Tag\Sony\Face4Position(),
                'Face5Position' => new \PHPExiftool\Driver\Tag\Sony\Face5Position(),
                'Face6Position' => new \PHPExiftool\Driver\Tag\Sony\Face6Position(),
                'Face7Position' => new \PHPExiftool\Driver\Tag\Sony\Face7Position(),
                'Face8Position' => new \PHPExiftool\Driver\Tag\Sony\Face8Position(),
                'FaceTest2' => new \PHPExiftool\Driver\Tag\Sony\FaceTest2(),
                'FaceTest8' => new \PHPExiftool\Driver\Tag\Sony\FaceTest8(),
                'PotentialFace1Position' => new \PHPExiftool\Driver\Tag\Sony\PotentialFace1Position(),
                'PotentialFace2Position' => new \PHPExiftool\Driver\Tag\Sony\PotentialFace2Position(),
                'PotentialFace3Position' => new \PHPExiftool\Driver\Tag\Sony\PotentialFace3Position(),
                'PotentialFace4Position' => new \PHPExiftool\Driver\Tag\Sony\PotentialFace4Position(),
                'PotentialFace5Position' => new \PHPExiftool\Driver\Tag\Sony\PotentialFace5Position(),
                'PotentialFace6Position' => new \PHPExiftool\Driver\Tag\Sony\PotentialFace6Position(),
                'PotentialFace7Position' => new \PHPExiftool\Driver\Tag\Sony\PotentialFace7Position(),
                'PotentialFace8Position' => new \PHPExiftool\Driver\Tag\Sony\PotentialFace8Position(),
                'DriveMode2' => new \PHPExiftool\Driver\Tag\Sony\DriveMode2(),
                'BracketShotNumber' => new \PHPExiftool\Driver\Tag\Sony\BracketShotNumber(),
                'WhiteBalanceBracketing' => new \PHPExiftool\Driver\Tag\Sony\WhiteBalanceBracketing(),
                'BracketShotNumber2' => new \PHPExiftool\Driver\Tag\Sony\BracketShotNumber2(),
                'DynamicRangeOptimizerBracket' => new \PHPExiftool\Driver\Tag\Sony\DynamicRangeOptimizerBracket(),
                'ExposureBracketShotNumber' => new \PHPExiftool\Driver\Tag\Sony\ExposureBracketShotNumber(),
                'ISO' => new \PHPExiftool\Driver\Tag\Sony\ISO(),
                'ShutterCount' => new \PHPExiftool\Driver\Tag\Sony\ShutterCount(),
                'FocusPosition' => new \PHPExiftool\Driver\Tag\Sony\FocusPosition(),
                'TiffMeteringImage' => new \PHPExiftool\Driver\Tag\Sony\TiffMeteringImage(),
                'ISOAutoMin' => new \PHPExiftool\Driver\Tag\Sony\ISOAutoMin(),
                'ISOAutoMax' => new \PHPExiftool\Driver\Tag\Sony\ISOAutoMax(),
                'FlashExposureComp' => new \PHPExiftool\Driver\Tag\Sony\FlashExposureComp(),
                'Teleconverter' => new \PHPExiftool\Driver\Tag\Sony\Teleconverter(),
                'MultiBurstMode' => new \PHPExiftool\Driver\Tag\Sony\MultiBurstMode(),
                'MultiBurstImageWidth' => new \PHPExiftool\Driver\Tag\Sony\MultiBurstImageWidth(),
                'MultiBurstImageHeight' => new \PHPExiftool\Driver\Tag\Sony\MultiBurstImageHeight(),
                'PreviewImage' => new \PHPExiftool\Driver\Tag\Sony\PreviewImage(),
                'Rating' => new \PHPExiftool\Driver\Tag\Sony\Rating(),
                'HDR' => new \PHPExiftool\Driver\Tag\Sony\HDR(),
                'PictureEffect' => new \PHPExiftool\Driver\Tag\Sony\PictureEffect(),
                'SoftSkinEffect' => new \PHPExiftool\Driver\Tag\Sony\SoftSkinEffect(),
                'Tag_0x2010' => new \PHPExiftool\Driver\Tag\Sony\Tag0x2010(),
                'VignettingCorrection' => new \PHPExiftool\Driver\Tag\Sony\VignettingCorrection(),
                'LateralChromaticAberration' => new \PHPExiftool\Driver\Tag\Sony\LateralChromaticAberration(),
                'DistortionCorrectionSetting' => new \PHPExiftool\Driver\Tag\Sony\DistortionCorrectionSetting(),
                'WBShiftAB_GM' => new \PHPExiftool\Driver\Tag\Sony\WBShiftABGM(),
                'AutoPortraitFramed' => new \PHPExiftool\Driver\Tag\Sony\AutoPortraitFramed(),
                'ElectronicFrontCurtainShutter' => new \PHPExiftool\Driver\Tag\Sony\ElectronicFrontCurtainShutter(),
                'AFAreaModeSetting' => new \PHPExiftool\Driver\Tag\Sony\AFAreaModeSetting(),
                'FlexibleSpotPosition' => new \PHPExiftool\Driver\Tag\Sony\FlexibleSpotPosition(),
                'AFTracking' => new \PHPExiftool\Driver\Tag\Sony\AFTracking(),
                'FocalPlaneAFPointsUsed' => new \PHPExiftool\Driver\Tag\Sony\FocalPlaneAFPointsUsed(),
                'MultiFrameNREffect' => new \PHPExiftool\Driver\Tag\Sony\MultiFrameNREffect(),
                'WBShiftAB_GM_Precise' => new \PHPExiftool\Driver\Tag\Sony\WBShiftABGMPrecise(),
                'FocusLocation' => new \PHPExiftool\Driver\Tag\Sony\FocusLocation(),
                'VariableLowPassFilter' => new \PHPExiftool\Driver\Tag\Sony\VariableLowPassFilter(),
                'RAWFileType' => new \PHPExiftool\Driver\Tag\Sony\RAWFileType(),
                'PrioritySetInAWB' => new \PHPExiftool\Driver\Tag\Sony\PrioritySetInAWB(),
                'MeteringMode2' => new \PHPExiftool\Driver\Tag\Sony\MeteringMode2(),
                'ExposureStandardAdjustment' => new \PHPExiftool\Driver\Tag\Sony\ExposureStandardAdjustment(),
                'PixelShiftInfo' => new \PHPExiftool\Driver\Tag\Sony\PixelShiftInfo(),
                'SerialNumber' => new \PHPExiftool\Driver\Tag\Sony\SerialNumber(),
                'Sony_0x9050' => new \PHPExiftool\Driver\Tag\Sony\Sony0x9050(),
                'Sony_0x9400' => new \PHPExiftool\Driver\Tag\Sony\Sony0x9400(),
                'Sony_0x9402' => new \PHPExiftool\Driver\Tag\Sony\Sony0x9402(),
                'Sony_0x9404' => new \PHPExiftool\Driver\Tag\Sony\Sony0x9404(),
                'Sony_0x9405' => new \PHPExiftool\Driver\Tag\Sony\Sony0x9405(),
                'Sony_0x9406' => new \PHPExiftool\Driver\Tag\Sony\Sony0x9406(),
                'Sony_0x9407' => new \PHPExiftool\Driver\Tag\Sony\Sony0x9407(),
                'Sony_0x9408' => new \PHPExiftool\Driver\Tag\Sony\Sony0x9408(),
                'Sony_0x9409' => new \PHPExiftool\Driver\Tag\Sony\Sony0x9409(),
                'Sony_0x940a' => new \PHPExiftool\Driver\Tag\Sony\Sony0x940a(),
                'Sony_0x940b' => new \PHPExiftool\Driver\Tag\Sony\Sony0x940b(),
                'Sony_0x940c' => new \PHPExiftool\Driver\Tag\Sony\Sony0x940c(),
                'Sony_0x940d' => new \PHPExiftool\Driver\Tag\Sony\Sony0x940d(),
                'Sony_0x940e' => new \PHPExiftool\Driver\Tag\Sony\Sony0x940e(),
                'Sony_0x940f' => new \PHPExiftool\Driver\Tag\Sony\Sony0x940f(),
                'Sony_0x9411' => new \PHPExiftool\Driver\Tag\Sony\Sony0x9411(),
                'FileFormat' => new \PHPExiftool\Driver\Tag\Sony\FileFormat(),
                'SonyModelID' => new \PHPExiftool\Driver\Tag\Sony\SonyModelID(),
                'ColorTemperature' => new \PHPExiftool\Driver\Tag\Sony\ColorTemperature(),
                'ColorCompensationFilter' => new \PHPExiftool\Driver\Tag\Sony\ColorCompensationFilter(),
                'SceneMode' => new \PHPExiftool\Driver\Tag\Sony\SceneMode(),
                'ZoneMatching' => new \PHPExiftool\Driver\Tag\Sony\ZoneMatching(),
                'DynamicRangeOptimizer' => new \PHPExiftool\Driver\Tag\Sony\DynamicRangeOptimizer(),
                'LensType' => new \PHPExiftool\Driver\Tag\Sony\LensType(),
                'ColorMode' => new \PHPExiftool\Driver\Tag\Sony\ColorMode(),
                'FullImageSize' => new \PHPExiftool\Driver\Tag\Sony\FullImageSize(),
                'PreviewImageSize' => new \PHPExiftool\Driver\Tag\Sony\PreviewImageSize(),
                'Macro' => new \PHPExiftool\Driver\Tag\Sony\Macro(),
                'ExposureMode' => new \PHPExiftool\Driver\Tag\Sony\ExposureMode(),
                'JPEGQuality' => new \PHPExiftool\Driver\Tag\Sony\JPEGQuality(),
                'FlashLevel' => new \PHPExiftool\Driver\Tag\Sony\FlashLevel(),
                'ReleaseMode' => new \PHPExiftool\Driver\Tag\Sony\ReleaseMode(),
                'Anti-Blur' => new \PHPExiftool\Driver\Tag\Sony\AntiBlur(),
                'HighISONoiseReduction2' => new \PHPExiftool\Driver\Tag\Sony\HighISONoiseReduction2(),
                'IntelligentAuto' => new \PHPExiftool\Driver\Tag\Sony\IntelligentAuto(),
                'MeterInfo1Row1' => new \PHPExiftool\Driver\Tag\Sony\MeterInfo1Row1(),
                'MeterInfo1Row2' => new \PHPExiftool\Driver\Tag\Sony\MeterInfo1Row2(),
                'MeterInfo1Row3' => new \PHPExiftool\Driver\Tag\Sony\MeterInfo1Row3(),
                'MeterInfo1Row4' => new \PHPExiftool\Driver\Tag\Sony\MeterInfo1Row4(),
                'MeterInfo1Row5' => new \PHPExiftool\Driver\Tag\Sony\MeterInfo1Row5(),
                'MeterInfo1Row6' => new \PHPExiftool\Driver\Tag\Sony\MeterInfo1Row6(),
                'MeterInfo1Row7' => new \PHPExiftool\Driver\Tag\Sony\MeterInfo1Row7(),
                'MeterInfo2Row1' => new \PHPExiftool\Driver\Tag\Sony\MeterInfo2Row1(),
                'MeterInfo2Row2' => new \PHPExiftool\Driver\Tag\Sony\MeterInfo2Row2(),
                'MeterInfo2Row3' => new \PHPExiftool\Driver\Tag\Sony\MeterInfo2Row3(),
                'MeterInfo2Row4' => new \PHPExiftool\Driver\Tag\Sony\MeterInfo2Row4(),
                'MeterInfo2Row5' => new \PHPExiftool\Driver\Tag\Sony\MeterInfo2Row5(),
                'MeterInfo2Row6' => new \PHPExiftool\Driver\Tag\Sony\MeterInfo2Row6(),
                'MeterInfo2Row7' => new \PHPExiftool\Driver\Tag\Sony\MeterInfo2Row7(),
                'MeterInfo2Row8' => new \PHPExiftool\Driver\Tag\Sony\MeterInfo2Row8(),
                'MeterInfo2Row9' => new \PHPExiftool\Driver\Tag\Sony\MeterInfo2Row9(),
                'ImageCount' => new \PHPExiftool\Driver\Tag\Sony\ImageCount(),
                'ShotNumberSincePowerUp' => new \PHPExiftool\Driver\Tag\Sony\ShotNumberSincePowerUp(),
                'CustomWB_RBLevels' => new \PHPExiftool\Driver\Tag\Sony\CustomWBRBLevels(),
                'BrightnessValue' => new \PHPExiftool\Driver\Tag\Sony\BrightnessValue(),
                'LiveViewAFMethod' => new \PHPExiftool\Driver\Tag\Sony\LiveViewAFMethod(),
                'FocalLength2' => new \PHPExiftool\Driver\Tag\Sony\FocalLength2(),
                'ExposureCompensation2' => new \PHPExiftool\Driver\Tag\Sony\ExposureCompensation2(),
                'FlashExposureCompSet2' => new \PHPExiftool\Driver\Tag\Sony\FlashExposureCompSet2(),
                'Orientation2' => new \PHPExiftool\Driver\Tag\Sony\Orientation2(),
                'FocusPosition2' => new \PHPExiftool\Driver\Tag\Sony\FocusPosition2(),
                'FocusMode2' => new \PHPExiftool\Driver\Tag\Sony\FocusMode2(),
                'FlashActionExternal' => new \PHPExiftool\Driver\Tag\Sony\FlashActionExternal(),
                'FlashStatus' => new \PHPExiftool\Driver\Tag\Sony\FlashStatus(),
                'Barcode' => new \PHPExiftool\Driver\Tag\Sony\Barcode(),
                'SensorTemperature' => new \PHPExiftool\Driver\Tag\Sony\SensorTemperature(),
                'FirmwareVersion' => new \PHPExiftool\Driver\Tag\Sony\FirmwareVersion(),
                'CameraTemperature' => new \PHPExiftool\Driver\Tag\Sony\CameraTemperature(),
                'BoardTemperature' => new \PHPExiftool\Driver\Tag\Sony\BoardTemperature(),
                'TextInfo1' => new \PHPExiftool\Driver\Tag\Sony\TextInfo1(),
                'TextInfo2' => new \PHPExiftool\Driver\Tag\Sony\TextInfo2(),
                'VibrationReduction' => new \PHPExiftool\Driver\Tag\Sony\VibrationReduction(),
                'JpgFromRawStart' => new \PHPExiftool\Driver\Tag\Sony\JpgFromRawStart(),
                'JpgFromRawLength' => new \PHPExiftool\Driver\Tag\Sony\JpgFromRawLength(),
                'SonyImageWidth' => new \PHPExiftool\Driver\Tag\Sony\SonyImageWidth(),
                'SonyImageHeight' => new \PHPExiftool\Driver\Tag\Sony\SonyImageHeight(),
                'Orientation' => new \PHPExiftool\Driver\Tag\Sony\Orientation(),
                'ImageQuality' => new \PHPExiftool\Driver\Tag\Sony\ImageQuality(),
                'Comment' => new \PHPExiftool\Driver\Tag\Sony\Comment(),
                'DateTimeOriginal' => new \PHPExiftool\Driver\Tag\Sony\DateTimeOriginal(),
                'ModifyDate' => new \PHPExiftool\Driver\Tag\Sony\ModifyDate(),
                'ExposureCompensation' => new \PHPExiftool\Driver\Tag\Sony\ExposureCompensation(),
                'Flash' => new \PHPExiftool\Driver\Tag\Sony\Flash(),
                'PanoramaFullWidth' => new \PHPExiftool\Driver\Tag\Sony\PanoramaFullWidth(),
                'PanoramaFullHeight' => new \PHPExiftool\Driver\Tag\Sony\PanoramaFullHeight(),
                'PanoramaDirection' => new \PHPExiftool\Driver\Tag\Sony\PanoramaDirection(),
                'PanoramaCropLeft' => new \PHPExiftool\Driver\Tag\Sony\PanoramaCropLeft(),
                'PanoramaCropTop' => new \PHPExiftool\Driver\Tag\Sony\PanoramaCropTop(),
                'PanoramaCropRight' => new \PHPExiftool\Driver\Tag\Sony\PanoramaCropRight(),
                'PanoramaCropBottom' => new \PHPExiftool\Driver\Tag\Sony\PanoramaCropBottom(),
                'PanoramaFrameWidth' => new \PHPExiftool\Driver\Tag\Sony\PanoramaFrameWidth(),
                'PanoramaFrameHeight' => new \PHPExiftool\Driver\Tag\Sony\PanoramaFrameHeight(),
                'PanoramaSourceWidth' => new \PHPExiftool\Driver\Tag\Sony\PanoramaSourceWidth(),
                'PanoramaSourceHeight' => new \PHPExiftool\Driver\Tag\Sony\PanoramaSourceHeight(),
                'FaceInfoOffset' => new \PHPExiftool\Driver\Tag\Sony\FaceInfoOffset(),
                'SonyDateTime' => new \PHPExiftool\Driver\Tag\Sony\SonyDateTime(),
                'FaceInfoLength' => new \PHPExiftool\Driver\Tag\Sony\FaceInfoLength(),
                'MetaVersion' => new \PHPExiftool\Driver\Tag\Sony\MetaVersion(),
                'ReleaseMode3' => new \PHPExiftool\Driver\Tag\Sony\ReleaseMode3(),
                'ReleaseMode2' => new \PHPExiftool\Driver\Tag\Sony\ReleaseMode2(),
                'SelfTimer' => new \PHPExiftool\Driver\Tag\Sony\SelfTimer(),
                'StopsAboveBaseISO' => new \PHPExiftool\Driver\Tag\Sony\StopsAboveBaseISO(),
                'PictureProfile' => new \PHPExiftool\Driver\Tag\Sony\PictureProfile(),
                'PictureEffect2' => new \PHPExiftool\Driver\Tag\Sony\PictureEffect2(),
                'Quality2' => new \PHPExiftool\Driver\Tag\Sony\Quality2(),
                'WB_RGBLevels' => new \PHPExiftool\Driver\Tag\Sony\WBRGBLevels(),
                'SequenceImageNumber' => new \PHPExiftool\Driver\Tag\Sony\SequenceImageNumber(),
                'SequenceFileNumber' => new \PHPExiftool\Driver\Tag\Sony\SequenceFileNumber(),
                'SonyISO' => new \PHPExiftool\Driver\Tag\Sony\SonyISO(),
                'DistortionCorrParams' => new \PHPExiftool\Driver\Tag\Sony\DistortionCorrParams(),
                'DigitalZoomRatio' => new \PHPExiftool\Driver\Tag\Sony\DigitalZoomRatio(),
                'MinFocalLength' => new \PHPExiftool\Driver\Tag\Sony\MinFocalLength(),
                'MaxFocalLength' => new \PHPExiftool\Driver\Tag\Sony\MaxFocalLength(),
                'LensFormat' => new \PHPExiftool\Driver\Tag\Sony\LensFormat(),
                'DistortionCorrParamsPresent' => new \PHPExiftool\Driver\Tag\Sony\DistortionCorrParamsPresent(),
                'DistortionCorrParamsNumber' => new \PHPExiftool\Driver\Tag\Sony\DistortionCorrParamsNumber(),
                'FocalPlaneAFPointArea' => new \PHPExiftool\Driver\Tag\Sony\FocalPlaneAFPointArea(),
                'FocalPlaneAFPointLocation1' => new \PHPExiftool\Driver\Tag\Sony\FocalPlaneAFPointLocation1(),
                'FocalPlaneAFPointLocation2' => new \PHPExiftool\Driver\Tag\Sony\FocalPlaneAFPointLocation2(),
                'FocalPlaneAFPointLocation3' => new \PHPExiftool\Driver\Tag\Sony\FocalPlaneAFPointLocation3(),
                'FocalPlaneAFPointLocation4' => new \PHPExiftool\Driver\Tag\Sony\FocalPlaneAFPointLocation4(),
                'FocalPlaneAFPointLocation5' => new \PHPExiftool\Driver\Tag\Sony\FocalPlaneAFPointLocation5(),
                'FocalPlaneAFPointLocation6' => new \PHPExiftool\Driver\Tag\Sony\FocalPlaneAFPointLocation6(),
                'FocalPlaneAFPointLocation7' => new \PHPExiftool\Driver\Tag\Sony\FocalPlaneAFPointLocation7(),
                'FocalPlaneAFPointLocation8' => new \PHPExiftool\Driver\Tag\Sony\FocalPlaneAFPointLocation8(),
                'FocalPlaneAFPointLocation9' => new \PHPExiftool\Driver\Tag\Sony\FocalPlaneAFPointLocation9(),
                'FocalPlaneAFPointLocation10' => new \PHPExiftool\Driver\Tag\Sony\FocalPlaneAFPointLocation10(),
                'FocalPlaneAFPointLocation11' => new \PHPExiftool\Driver\Tag\Sony\FocalPlaneAFPointLocation11(),
                'FocalPlaneAFPointLocation12' => new \PHPExiftool\Driver\Tag\Sony\FocalPlaneAFPointLocation12(),
                'FocalPlaneAFPointLocation13' => new \PHPExiftool\Driver\Tag\Sony\FocalPlaneAFPointLocation13(),
                'FocalPlaneAFPointLocation14' => new \PHPExiftool\Driver\Tag\Sony\FocalPlaneAFPointLocation14(),
                'FocalPlaneAFPointLocation15' => new \PHPExiftool\Driver\Tag\Sony\FocalPlaneAFPointLocation15(),
                'SonyMaxAperture' => new \PHPExiftool\Driver\Tag\Sony\SonyMaxAperture(),
                'SonyMinAperture' => new \PHPExiftool\Driver\Tag\Sony\SonyMinAperture(),
                'Shutter' => new \PHPExiftool\Driver\Tag\Sony\Shutter(),
                'SonyExposureTime' => new \PHPExiftool\Driver\Tag\Sony\SonyExposureTime(),
                'SonyFNumber' => new \PHPExiftool\Driver\Tag\Sony\SonyFNumber(),
                'ShutterCount2' => new \PHPExiftool\Driver\Tag\Sony\ShutterCount2(),
                'SonyDateTime2' => new \PHPExiftool\Driver\Tag\Sony\SonyDateTime2(),
                'InternalSerialNumber' => new \PHPExiftool\Driver\Tag\Sony\InternalSerialNumber(),
                'APS-CSizeCapture' => new \PHPExiftool\Driver\Tag\Sony\APSCSizeCapture(),
                'LensSpecFeatures' => new \PHPExiftool\Driver\Tag\Sony\LensSpecFeatures(),
                'ShutterCount3' => new \PHPExiftool\Driver\Tag\Sony\ShutterCount3(),
                'SonyTimeMinSec' => new \PHPExiftool\Driver\Tag\Sony\SonyTimeMinSec(),
                'DigitalZoom' => new \PHPExiftool\Driver\Tag\Sony\DigitalZoom(),
                'SequenceLength' => new \PHPExiftool\Driver\Tag\Sony\SequenceLength(),
                'ModelReleaseYear' => new \PHPExiftool\Driver\Tag\Sony\ModelReleaseYear(),
                'Ver9401' => new \PHPExiftool\Driver\Tag\Sony\Ver9401(),
                'TempTest1' => new \PHPExiftool\Driver\Tag\Sony\TempTest1(),
                'AmbientTemperature' => new \PHPExiftool\Driver\Tag\Sony\AmbientTemperature(),
                'TempTest2' => new \PHPExiftool\Driver\Tag\Sony\TempTest2(),
                'LensZoomPosition' => new \PHPExiftool\Driver\Tag\Sony\LensZoomPosition(),
                'DistortionCorrection' => new \PHPExiftool\Driver\Tag\Sony\DistortionCorrection(),
                'VignettingCorrParams' => new \PHPExiftool\Driver\Tag\Sony\VignettingCorrParams(),
                'ChromaticAberrationCorrParams' => new \PHPExiftool\Driver\Tag\Sony\ChromaticAberrationCorrParams(),
                'BaseISO' => new \PHPExiftool\Driver\Tag\Sony\BaseISO(),
                'SonyExposureTime2' => new \PHPExiftool\Driver\Tag\Sony\SonyExposureTime2(),
                'SonyMaxApertureValue' => new \PHPExiftool\Driver\Tag\Sony\SonyMaxApertureValue(),
                'SonyImageWidthMax' => new \PHPExiftool\Driver\Tag\Sony\SonyImageWidthMax(),
                'SonyImageHeightMax' => new \PHPExiftool\Driver\Tag\Sony\SonyImageHeightMax(),
                'BatteryLevelGrip1' => new \PHPExiftool\Driver\Tag\Sony\BatteryLevelGrip1(),
                'BatteryLevelGrip2' => new \PHPExiftool\Driver\Tag\Sony\BatteryLevelGrip2(),
                'AFPointsSelected' => new \PHPExiftool\Driver\Tag\Sony\AFPointsSelected(),
                'LensMount2' => new \PHPExiftool\Driver\Tag\Sony\LensMount2(),
                'LensType3' => new \PHPExiftool\Driver\Tag\Sony\LensType3(),
                'CameraE-mountVersion' => new \PHPExiftool\Driver\Tag\Sony\CameraEMountVersion(),
                'TiffMeteringImageWidth' => new \PHPExiftool\Driver\Tag\Sony\TiffMeteringImageWidth(),
                'TiffMeteringImageHeight' => new \PHPExiftool\Driver\Tag\Sony\TiffMeteringImageHeight(),
                'Sony_rtmd_0x060e' => new \PHPExiftool\Driver\Tag\Sony\SonyRtmd0x060e(),
                'Sony_rtmd_0x3210' => new \PHPExiftool\Driver\Tag\Sony\SonyRtmd0x3210(),
                'Sony_rtmd_0x3219' => new \PHPExiftool\Driver\Tag\Sony\SonyRtmd0x3219(),
                'Sony_rtmd_0x321a' => new \PHPExiftool\Driver\Tag\Sony\SonyRtmd0x321a(),
                'Sony_rtmd_0x8000' => new \PHPExiftool\Driver\Tag\Sony\SonyRtmd0x8000(),
                'Sony_rtmd_0x8001' => new \PHPExiftool\Driver\Tag\Sony\SonyRtmd0x8001(),
                'Sony_rtmd_0x8100' => new \PHPExiftool\Driver\Tag\Sony\SonyRtmd0x8100(),
                'Sony_rtmd_0x8101' => new \PHPExiftool\Driver\Tag\Sony\SonyRtmd0x8101(),
                'Sony_rtmd_0x8109' => new \PHPExiftool\Driver\Tag\Sony\SonyRtmd0x8109(),
                'Sony_rtmd_0x810a' => new \PHPExiftool\Driver\Tag\Sony\SonyRtmd0x810a(),
                'Sony_rtmd_0x810b' => new \PHPExiftool\Driver\Tag\Sony\SonyRtmd0x810b(),
                'Sony_rtmd_0x810c' => new \PHPExiftool\Driver\Tag\Sony\SonyRtmd0x810c(),
                'Sony_rtmd_0x810d' => new \PHPExiftool\Driver\Tag\Sony\SonyRtmd0x810d(),
                'Sony_rtmd_0xe000' => new \PHPExiftool\Driver\Tag\Sony\SonyRtmd0xe000(),
                'Sony_rtmd_0xe300' => new \PHPExiftool\Driver\Tag\Sony\SonyRtmd0xe300(),
                'Sony_rtmd_0xe301' => new \PHPExiftool\Driver\Tag\Sony\SonyRtmd0xe301(),
                'Sony_rtmd_0xe302' => new \PHPExiftool\Driver\Tag\Sony\SonyRtmd0xe302(),
                'Sony_rtmd_0xe303' => new \PHPExiftool\Driver\Tag\Sony\SonyRtmd0xe303(),
                'DateTime' => new \PHPExiftool\Driver\Tag\Sony\DateTime(),
            );
        });
        $this['SR2DataIFD'] = $this->share(function(){
            return array(
                'ColorMode' => new \PHPExiftool\Driver\Tag\SR2DataIFD\ColorMode(),
            );
        });
        $this['SR2'] = $this->share(function(){
            return array(
                'SR2SubIFDOffset' => new \PHPExiftool\Driver\Tag\SR2\SR2SubIFDOffset(),
                'SR2SubIFDLength' => new \PHPExiftool\Driver\Tag\SR2\SR2SubIFDLength(),
                'SR2SubIFDKey' => new \PHPExiftool\Driver\Tag\SR2\SR2SubIFDKey(),
            );
        });
        $this['SR2SubIFD'] = $this->share(function(){
            return array(
                'BlackLevel' => new \PHPExiftool\Driver\Tag\SR2SubIFD\BlackLevel(),
                'WB_GRBGLevelsAuto' => new \PHPExiftool\Driver\Tag\SR2SubIFD\WBGRBGLevelsAuto(),
                'WB_GRBGLevels' => new \PHPExiftool\Driver\Tag\SR2SubIFD\WBGRBGLevels(),
                'WB_RGGBLevelsAuto' => new \PHPExiftool\Driver\Tag\SR2SubIFD\WBRGGBLevelsAuto(),
                'WB_RGGBLevels' => new \PHPExiftool\Driver\Tag\SR2SubIFD\WBRGGBLevels(),
                'WB_RGBLevelsDaylight' => new \PHPExiftool\Driver\Tag\SR2SubIFD\WBRGBLevelsDaylight(),
                'WB_RGBLevelsCloudy' => new \PHPExiftool\Driver\Tag\SR2SubIFD\WBRGBLevelsCloudy(),
                'WB_RGBLevelsTungsten' => new \PHPExiftool\Driver\Tag\SR2SubIFD\WBRGBLevelsTungsten(),
                'WB_RGBLevelsFlash' => new \PHPExiftool\Driver\Tag\SR2SubIFD\WBRGBLevelsFlash(),
                'WB_RGBLevels4500K' => new \PHPExiftool\Driver\Tag\SR2SubIFD\WBRGBLevels4500K(),
                'WB_RGBLevelsFluorescent' => new \PHPExiftool\Driver\Tag\SR2SubIFD\WBRGBLevelsFluorescent(),
                'MaxApertureAtMaxFocal' => new \PHPExiftool\Driver\Tag\SR2SubIFD\MaxApertureAtMaxFocal(),
                'MaxApertureAtMinFocal' => new \PHPExiftool\Driver\Tag\SR2SubIFD\MaxApertureAtMinFocal(),
                'MaxFocalLength' => new \PHPExiftool\Driver\Tag\SR2SubIFD\MaxFocalLength(),
                'MinFocalLength' => new \PHPExiftool\Driver\Tag\SR2SubIFD\MinFocalLength(),
                'ColorMatrix' => new \PHPExiftool\Driver\Tag\SR2SubIFD\ColorMatrix(),
                'WB_RGBLevelsShade' => new \PHPExiftool\Driver\Tag\SR2SubIFD\WBRGBLevelsShade(),
                'WB_RGBLevelsFluorescentP1' => new \PHPExiftool\Driver\Tag\SR2SubIFD\WBRGBLevelsFluorescentP1(),
                'WB_RGBLevelsFluorescentP2' => new \PHPExiftool\Driver\Tag\SR2SubIFD\WBRGBLevelsFluorescentP2(),
                'WB_RGBLevelsFluorescentM1' => new \PHPExiftool\Driver\Tag\SR2SubIFD\WBRGBLevelsFluorescentM1(),
                'WB_RGBLevels8500K' => new \PHPExiftool\Driver\Tag\SR2SubIFD\WBRGBLevels8500K(),
                'WB_RGBLevels6000K' => new \PHPExiftool\Driver\Tag\SR2SubIFD\WBRGBLevels6000K(),
                'WB_RGBLevels3200K' => new \PHPExiftool\Driver\Tag\SR2SubIFD\WBRGBLevels3200K(),
                'WB_RGBLevels2500K' => new \PHPExiftool\Driver\Tag\SR2SubIFD\WBRGBLevels2500K(),
                'WhiteLevel' => new \PHPExiftool\Driver\Tag\SR2SubIFD\WhiteLevel(),
                'VignettingCorrParams' => new \PHPExiftool\Driver\Tag\SR2SubIFD\VignettingCorrParams(),
                'ChromaticAberrationCorrParams' => new \PHPExiftool\Driver\Tag\SR2SubIFD\ChromaticAberrationCorrParams(),
                'DistortionCorrParams' => new \PHPExiftool\Driver\Tag\SR2SubIFD\DistortionCorrParams(),
            );
        });
        $this['SRF#'] = $this->share(function(){
            return array(
                'SRF2Key' => new \PHPExiftool\Driver\Tag\SRF\SRF2Key(),
                'DataKey' => new \PHPExiftool\Driver\Tag\SRF\DataKey(),
                'SRF6Offset' => new \PHPExiftool\Driver\Tag\SRF\SRF6Offset(),
                'SRFDataOffset' => new \PHPExiftool\Driver\Tag\SRF\SRFDataOffset(),
                'RawDataOffset' => new \PHPExiftool\Driver\Tag\SRF\RawDataOffset(),
                'RawDataLength' => new \PHPExiftool\Driver\Tag\SRF\RawDataLength(),
                'MaxApertureAtMaxFocal' => new \PHPExiftool\Driver\Tag\SRF\MaxApertureAtMaxFocal(),
                'MaxApertureAtMinFocal' => new \PHPExiftool\Driver\Tag\SRF\MaxApertureAtMinFocal(),
                'MinFocalLength' => new \PHPExiftool\Driver\Tag\SRF\MinFocalLength(),
                'MaxFocalLength' => new \PHPExiftool\Driver\Tag\SRF\MaxFocalLength(),
                'WBRedDaylight' => new \PHPExiftool\Driver\Tag\SRF\WBRedDaylight(),
                'WBGreenDaylight' => new \PHPExiftool\Driver\Tag\SRF\WBGreenDaylight(),
                'WBBlueDaylight' => new \PHPExiftool\Driver\Tag\SRF\WBBlueDaylight(),
                'WBRedCloudy' => new \PHPExiftool\Driver\Tag\SRF\WBRedCloudy(),
                'WBGreenCloudy' => new \PHPExiftool\Driver\Tag\SRF\WBGreenCloudy(),
                'WBBlueCloudy' => new \PHPExiftool\Driver\Tag\SRF\WBBlueCloudy(),
                'WBRedFluorescent' => new \PHPExiftool\Driver\Tag\SRF\WBRedFluorescent(),
                'WBGreenFluorescent' => new \PHPExiftool\Driver\Tag\SRF\WBGreenFluorescent(),
                'WBBlueFluorescent' => new \PHPExiftool\Driver\Tag\SRF\WBBlueFluorescent(),
                'WBRedTungsten' => new \PHPExiftool\Driver\Tag\SRF\WBRedTungsten(),
                'WBGreenTungsten' => new \PHPExiftool\Driver\Tag\SRF\WBGreenTungsten(),
                'WBBlueTungsten' => new \PHPExiftool\Driver\Tag\SRF\WBBlueTungsten(),
                'WBRedFlash' => new \PHPExiftool\Driver\Tag\SRF\WBRedFlash(),
                'WBGreenFlash' => new \PHPExiftool\Driver\Tag\SRF\WBGreenFlash(),
                'WBBlueFlash' => new \PHPExiftool\Driver\Tag\SRF\WBBlueFlash(),
                'WBRedAsShot' => new \PHPExiftool\Driver\Tag\SRF\WBRedAsShot(),
                'WBGreenAsShot' => new \PHPExiftool\Driver\Tag\SRF\WBGreenAsShot(),
                'WBBlueAsShot' => new \PHPExiftool\Driver\Tag\SRF\WBBlueAsShot(),
            );
        });
        $this['SonyIDC'] = $this->share(function(){
            return array(
                'IDCPreviewStart' => new \PHPExiftool\Driver\Tag\SonyIDC\IDCPreviewStart(),
                'IDCPreviewLength' => new \PHPExiftool\Driver\Tag\SonyIDC\IDCPreviewLength(),
                'IDCCreativeStyle' => new \PHPExiftool\Driver\Tag\SonyIDC\IDCCreativeStyle(),
                'CreativeStyleWasChanged' => new \PHPExiftool\Driver\Tag\SonyIDC\CreativeStyleWasChanged(),
                'PresetWhiteBalance' => new \PHPExiftool\Driver\Tag\SonyIDC\PresetWhiteBalance(),
                'ColorTemperatureAdj' => new \PHPExiftool\Driver\Tag\SonyIDC\ColorTemperatureAdj(),
                'PresetWhiteBalanceAdj' => new \PHPExiftool\Driver\Tag\SonyIDC\PresetWhiteBalanceAdj(),
                'ColorCorrection' => new \PHPExiftool\Driver\Tag\SonyIDC\ColorCorrection(),
                'SaturationAdj' => new \PHPExiftool\Driver\Tag\SonyIDC\SaturationAdj(),
                'ContrastAdj' => new \PHPExiftool\Driver\Tag\SonyIDC\ContrastAdj(),
                'BrightnessAdj' => new \PHPExiftool\Driver\Tag\SonyIDC\BrightnessAdj(),
                'HueAdj' => new \PHPExiftool\Driver\Tag\SonyIDC\HueAdj(),
                'SharpnessAdj' => new \PHPExiftool\Driver\Tag\SonyIDC\SharpnessAdj(),
                'SharpnessOvershoot' => new \PHPExiftool\Driver\Tag\SonyIDC\SharpnessOvershoot(),
                'SharpnessUndershoot' => new \PHPExiftool\Driver\Tag\SonyIDC\SharpnessUndershoot(),
                'SharpnessThreshold' => new \PHPExiftool\Driver\Tag\SonyIDC\SharpnessThreshold(),
                'NoiseReductionMode' => new \PHPExiftool\Driver\Tag\SonyIDC\NoiseReductionMode(),
                'GrayPoint' => new \PHPExiftool\Driver\Tag\SonyIDC\GrayPoint(),
                'D-RangeOptimizerMode' => new \PHPExiftool\Driver\Tag\SonyIDC\DRangeOptimizerMode(),
                'D-RangeOptimizerValue' => new \PHPExiftool\Driver\Tag\SonyIDC\DRangeOptimizerValue(),
                'D-RangeOptimizerHighlight' => new \PHPExiftool\Driver\Tag\SonyIDC\DRangeOptimizerHighlight(),
                'HighlightColorDistortReduct' => new \PHPExiftool\Driver\Tag\SonyIDC\HighlightColorDistortReduct(),
                'NoiseReductionValue' => new \PHPExiftool\Driver\Tag\SonyIDC\NoiseReductionValue(),
                'EdgeNoiseReduction' => new \PHPExiftool\Driver\Tag\SonyIDC\EdgeNoiseReduction(),
                'ColorNoiseReduction' => new \PHPExiftool\Driver\Tag\SonyIDC\ColorNoiseReduction(),
                'D-RangeOptimizerShadow' => new \PHPExiftool\Driver\Tag\SonyIDC\DRangeOptimizerShadow(),
                'PeripheralIllumCentralRadius' => new \PHPExiftool\Driver\Tag\SonyIDC\PeripheralIllumCentralRadius(),
                'PeripheralIllumCentralValue' => new \PHPExiftool\Driver\Tag\SonyIDC\PeripheralIllumCentralValue(),
                'PeripheralIllumPeriphValue' => new \PHPExiftool\Driver\Tag\SonyIDC\PeripheralIllumPeriphValue(),
                'DistortionCompensation' => new \PHPExiftool\Driver\Tag\SonyIDC\DistortionCompensation(),
                'ToneCurveBrightnessX' => new \PHPExiftool\Driver\Tag\SonyIDC\ToneCurveBrightnessX(),
                'ToneCurveRedX' => new \PHPExiftool\Driver\Tag\SonyIDC\ToneCurveRedX(),
                'ToneCurveGreenX' => new \PHPExiftool\Driver\Tag\SonyIDC\ToneCurveGreenX(),
                'ToneCurveBlueX' => new \PHPExiftool\Driver\Tag\SonyIDC\ToneCurveBlueX(),
                'ToneCurveBrightnessY' => new \PHPExiftool\Driver\Tag\SonyIDC\ToneCurveBrightnessY(),
                'ToneCurveRedY' => new \PHPExiftool\Driver\Tag\SonyIDC\ToneCurveRedY(),
                'ToneCurveGreenY' => new \PHPExiftool\Driver\Tag\SonyIDC\ToneCurveGreenY(),
                'ToneCurveBlueY' => new \PHPExiftool\Driver\Tag\SonyIDC\ToneCurveBlueY(),
                'ChromaticAberrationCorrection' => new \PHPExiftool\Driver\Tag\SonyIDC\ChromaticAberrationCorrection(),
                'InclinationCorrection' => new \PHPExiftool\Driver\Tag\SonyIDC\InclinationCorrection(),
                'InclinationAngle' => new \PHPExiftool\Driver\Tag\SonyIDC\InclinationAngle(),
                'Cropping' => new \PHPExiftool\Driver\Tag\SonyIDC\Cropping(),
                'CropArea' => new \PHPExiftool\Driver\Tag\SonyIDC\CropArea(),
                'PreviewImageSize' => new \PHPExiftool\Driver\Tag\SonyIDC\PreviewImageSize(),
                'PxShiftPeriphEdgeNR' => new \PHPExiftool\Driver\Tag\SonyIDC\PxShiftPeriphEdgeNR(),
                'PxShiftPeriphEdgeNRValue' => new \PHPExiftool\Driver\Tag\SonyIDC\PxShiftPeriphEdgeNRValue(),
                'WhitesAdj' => new \PHPExiftool\Driver\Tag\SonyIDC\WhitesAdj(),
                'BlacksAdj' => new \PHPExiftool\Driver\Tag\SonyIDC\BlacksAdj(),
                'HighlightsAdj' => new \PHPExiftool\Driver\Tag\SonyIDC\HighlightsAdj(),
                'ShadowsAdj' => new \PHPExiftool\Driver\Tag\SonyIDC\ShadowsAdj(),
                'CurrentVersion' => new \PHPExiftool\Driver\Tag\SonyIDC\CurrentVersion(),
                'VersionCreateDate' => new \PHPExiftool\Driver\Tag\SonyIDC\VersionCreateDate(),
                'VersionModifyDate' => new \PHPExiftool\Driver\Tag\SonyIDC\VersionModifyDate(),
            );
        });
        $this['Stim'] = $this->share(function(){
            return array(
                'CropXCommonOffset' => new \PHPExiftool\Driver\Tag\Stim\CropXCommonOffset(),
                'CropXViewpointNumber' => new \PHPExiftool\Driver\Tag\Stim\CropXViewpointNumber(),
                'CropXOffset' => new \PHPExiftool\Driver\Tag\Stim\CropXOffset(),
                'CropXViewpointNumber2' => new \PHPExiftool\Driver\Tag\Stim\CropXViewpointNumber2(),
                'CropXOffset2' => new \PHPExiftool\Driver\Tag\Stim\CropXOffset2(),
                'CropYCommonOffset' => new \PHPExiftool\Driver\Tag\Stim\CropYCommonOffset(),
                'CropYViewpointNumber' => new \PHPExiftool\Driver\Tag\Stim\CropYViewpointNumber(),
                'CropYOffset' => new \PHPExiftool\Driver\Tag\Stim\CropYOffset(),
                'CropYViewpointNumber2' => new \PHPExiftool\Driver\Tag\Stim\CropYViewpointNumber2(),
                'CropYOffset2' => new \PHPExiftool\Driver\Tag\Stim\CropYOffset2(),
                'StimVersion' => new \PHPExiftool\Driver\Tag\Stim\StimVersion(),
                'ApplicationData' => new \PHPExiftool\Driver\Tag\Stim\ApplicationData(),
                'ImageArrangement' => new \PHPExiftool\Driver\Tag\Stim\ImageArrangement(),
                'ImageRotation' => new \PHPExiftool\Driver\Tag\Stim\ImageRotation(),
                'ScalingFactor' => new \PHPExiftool\Driver\Tag\Stim\ScalingFactor(),
                'CropXSize' => new \PHPExiftool\Driver\Tag\Stim\CropXSize(),
                'CropYSize' => new \PHPExiftool\Driver\Tag\Stim\CropYSize(),
                'ViewType' => new \PHPExiftool\Driver\Tag\Stim\ViewType(),
                'RepresentativeImage' => new \PHPExiftool\Driver\Tag\Stim\RepresentativeImage(),
                'ConvergenceBaseImage' => new \PHPExiftool\Driver\Tag\Stim\ConvergenceBaseImage(),
                'AssumedDisplaySize' => new \PHPExiftool\Driver\Tag\Stim\AssumedDisplaySize(),
                'AssumedDistanceView' => new \PHPExiftool\Driver\Tag\Stim\AssumedDistanceView(),
                'RepresentativeDisparityNear' => new \PHPExiftool\Driver\Tag\Stim\RepresentativeDisparityNear(),
                'RepresentativeDisparityFar' => new \PHPExiftool\Driver\Tag\Stim\RepresentativeDisparityFar(),
                'InitialDisplayEffect' => new \PHPExiftool\Driver\Tag\Stim\InitialDisplayEffect(),
                'ConvergenceDistance' => new \PHPExiftool\Driver\Tag\Stim\ConvergenceDistance(),
                'CameraArrangementInterval' => new \PHPExiftool\Driver\Tag\Stim\CameraArrangementInterval(),
                'ShootingCount' => new \PHPExiftool\Driver\Tag\Stim\ShootingCount(),
            );
        });
        $this['Theora'] = $this->share(function(){
            return array(
                'TheoraVersion' => new \PHPExiftool\Driver\Tag\Theora\TheoraVersion(),
                'ImageWidth' => new \PHPExiftool\Driver\Tag\Theora\ImageWidth(),
                'ImageHeight' => new \PHPExiftool\Driver\Tag\Theora\ImageHeight(),
                'XOffset' => new \PHPExiftool\Driver\Tag\Theora\XOffset(),
                'YOffset' => new \PHPExiftool\Driver\Tag\Theora\YOffset(),
                'FrameRate' => new \PHPExiftool\Driver\Tag\Theora\FrameRate(),
                'PixelAspectRatio' => new \PHPExiftool\Driver\Tag\Theora\PixelAspectRatio(),
                'ColorSpace' => new \PHPExiftool\Driver\Tag\Theora\ColorSpace(),
                'NominalVideoBitrate' => new \PHPExiftool\Driver\Tag\Theora\NominalVideoBitrate(),
                'Quality' => new \PHPExiftool\Driver\Tag\Theora\Quality(),
                'PixelFormat' => new \PHPExiftool\Driver\Tag\Theora\PixelFormat(),
            );
        });
        $this['Torrent'] = $this->share(function(){
            return array(
                'File1Length' => new \PHPExiftool\Driver\Tag\Torrent\File1Length(),
                'File1MD5Sum' => new \PHPExiftool\Driver\Tag\Torrent\File1MD5Sum(),
                'File1Path' => new \PHPExiftool\Driver\Tag\Torrent\File1Path(),
                'File1PathUTF-8' => new \PHPExiftool\Driver\Tag\Torrent\File1PathUTF8(),
                'File1Duration' => new \PHPExiftool\Driver\Tag\Torrent\File1Duration(),
                'File1Media' => new \PHPExiftool\Driver\Tag\Torrent\File1Media(),
                'Length' => new \PHPExiftool\Driver\Tag\Torrent\Length(),
                'MD5Sum' => new \PHPExiftool\Driver\Tag\Torrent\MD5Sum(),
                'Name' => new \PHPExiftool\Driver\Tag\Torrent\Name(),
                'NameUTF-8' => new \PHPExiftool\Driver\Tag\Torrent\NameUTF8(),
                'PieceLength' => new \PHPExiftool\Driver\Tag\Torrent\PieceLength(),
                'Pieces' => new \PHPExiftool\Driver\Tag\Torrent\Pieces(),
                'Private' => new \PHPExiftool\Driver\Tag\Torrent\Private0(),
                'Announce' => new \PHPExiftool\Driver\Tag\Torrent\Announce(),
                'AnnounceList1' => new \PHPExiftool\Driver\Tag\Torrent\AnnounceList1(),
                'Comment' => new \PHPExiftool\Driver\Tag\Torrent\Comment(),
                'Creator' => new \PHPExiftool\Driver\Tag\Torrent\Creator(),
                'CreateDate' => new \PHPExiftool\Driver\Tag\Torrent\CreateDate(),
                'Encoding' => new \PHPExiftool\Driver\Tag\Torrent\Encoding(),
                'URLList1' => new \PHPExiftool\Driver\Tag\Torrent\URLList1(),
                'Profile1AudioCodec' => new \PHPExiftool\Driver\Tag\Torrent\Profile1AudioCodec(),
                'Profile1Height' => new \PHPExiftool\Driver\Tag\Torrent\Profile1Height(),
                'Profile1VideoCodec' => new \PHPExiftool\Driver\Tag\Torrent\Profile1VideoCodec(),
                'Profile1Width' => new \PHPExiftool\Driver\Tag\Torrent\Profile1Width(),
            );
        });
        $this['VCard'] = $this->share(function(){
            return array(
                'Address' => new \PHPExiftool\Driver\Tag\VCard\Address(),
                'Anniversary' => new \PHPExiftool\Driver\Tag\VCard\Anniversary(),
                'Birthday' => new \PHPExiftool\Driver\Tag\VCard\Birthday(),
                'Email' => new \PHPExiftool\Driver\Tag\VCard\Email(),
                'FormattedName' => new \PHPExiftool\Driver\Tag\VCard\FormattedName(),
                'Gender' => new \PHPExiftool\Driver\Tag\VCard\Gender(),
                'Geolocation' => new \PHPExiftool\Driver\Tag\VCard\Geolocation(),
                'IMPP' => new \PHPExiftool\Driver\Tag\VCard\IMPP(),
                'Language' => new \PHPExiftool\Driver\Tag\VCard\Language(),
                'Logo' => new \PHPExiftool\Driver\Tag\VCard\Logo(),
                'Name' => new \PHPExiftool\Driver\Tag\VCard\Name(),
                'Nickname' => new \PHPExiftool\Driver\Tag\VCard\Nickname(),
                'Note' => new \PHPExiftool\Driver\Tag\VCard\Note(),
                'Organization' => new \PHPExiftool\Driver\Tag\VCard\Organization(),
                'Photo' => new \PHPExiftool\Driver\Tag\VCard\Photo(),
                'Software' => new \PHPExiftool\Driver\Tag\VCard\Software(),
                'Revision' => new \PHPExiftool\Driver\Tag\VCard\Revision(),
                'Sound' => new \PHPExiftool\Driver\Tag\VCard\Sound(),
                'Telephone' => new \PHPExiftool\Driver\Tag\VCard\Telephone(),
                'JobTitle' => new \PHPExiftool\Driver\Tag\VCard\JobTitle(),
                'TimeZone' => new \PHPExiftool\Driver\Tag\VCard\TimeZone(),
                'UID' => new \PHPExiftool\Driver\Tag\VCard\UID(),
                'URL' => new \PHPExiftool\Driver\Tag\VCard\URL(),
                'VCardVersion' => new \PHPExiftool\Driver\Tag\VCard\VCardVersion(),
                'ABDate' => new \PHPExiftool\Driver\Tag\VCard\ABDate(),
                'ABLabel' => new \PHPExiftool\Driver\Tag\VCard\ABLabel(),
                'ABRelatedNames' => new \PHPExiftool\Driver\Tag\VCard\ABRelatedNames(),
                'AB_UID' => new \PHPExiftool\Driver\Tag\VCard\ABUID(),
                'AIM' => new \PHPExiftool\Driver\Tag\VCard\AIM(),
                'ICQ' => new \PHPExiftool\Driver\Tag\VCard\ICQ(),
                'SocialProfile' => new \PHPExiftool\Driver\Tag\VCard\SocialProfile(),
            );
        });
        $this['VCalendar'] = $this->share(function(){
            return array(
                'Acknowledged' => new \PHPExiftool\Driver\Tag\VCalendar\Acknowledged(),
                'Action' => new \PHPExiftool\Driver\Tag\VCalendar\Action(),
                'Attachment' => new \PHPExiftool\Driver\Tag\VCalendar\Attachment(),
                'Attendee' => new \PHPExiftool\Driver\Tag\VCalendar\Attendee(),
                'CalendarScale' => new \PHPExiftool\Driver\Tag\VCalendar\CalendarScale(),
                'Categories' => new \PHPExiftool\Driver\Tag\VCalendar\Categories(),
                'Classification' => new \PHPExiftool\Driver\Tag\VCalendar\Classification(),
                'Comment' => new \PHPExiftool\Driver\Tag\VCalendar\Comment(),
                'DateTimeCompleted' => new \PHPExiftool\Driver\Tag\VCalendar\DateTimeCompleted(),
                'Contact' => new \PHPExiftool\Driver\Tag\VCalendar\Contact(),
                'DateCreated' => new \PHPExiftool\Driver\Tag\VCalendar\DateCreated(),
                'Description' => new \PHPExiftool\Driver\Tag\VCalendar\Description(),
                'DateTimeEnd' => new \PHPExiftool\Driver\Tag\VCalendar\DateTimeEnd(),
                'DateTimeStamp' => new \PHPExiftool\Driver\Tag\VCalendar\DateTimeStamp(),
                'DateTimeStart' => new \PHPExiftool\Driver\Tag\VCalendar\DateTimeStart(),
                'DateTimeDue' => new \PHPExiftool\Driver\Tag\VCalendar\DateTimeDue(),
                'Duration' => new \PHPExiftool\Driver\Tag\VCalendar\Duration(),
                'ExceptionDateTimes' => new \PHPExiftool\Driver\Tag\VCalendar\ExceptionDateTimes(),
                'FreeBusyTime' => new \PHPExiftool\Driver\Tag\VCalendar\FreeBusyTime(),
                'Geolocation' => new \PHPExiftool\Driver\Tag\VCalendar\Geolocation(),
                'ModifyDate' => new \PHPExiftool\Driver\Tag\VCalendar\ModifyDate(),
                'Location' => new \PHPExiftool\Driver\Tag\VCalendar\Location(),
                'Method' => new \PHPExiftool\Driver\Tag\VCalendar\Method(),
                'Organizer' => new \PHPExiftool\Driver\Tag\VCalendar\Organizer(),
                'PercentComplete' => new \PHPExiftool\Driver\Tag\VCalendar\PercentComplete(),
                'Priority' => new \PHPExiftool\Driver\Tag\VCalendar\Priority(),
                'Software' => new \PHPExiftool\Driver\Tag\VCalendar\Software(),
                'RecurrenceDateTimes' => new \PHPExiftool\Driver\Tag\VCalendar\RecurrenceDateTimes(),
                'RecurrenceID' => new \PHPExiftool\Driver\Tag\VCalendar\RecurrenceID(),
                'RelatedTo' => new \PHPExiftool\Driver\Tag\VCalendar\RelatedTo(),
                'Repeat' => new \PHPExiftool\Driver\Tag\VCalendar\Repeat(),
                'RequestStatus' => new \PHPExiftool\Driver\Tag\VCalendar\RequestStatus(),
                'Resources' => new \PHPExiftool\Driver\Tag\VCalendar\Resources(),
                'RecurrenceRule' => new \PHPExiftool\Driver\Tag\VCalendar\RecurrenceRule(),
                'SequenceNumber' => new \PHPExiftool\Driver\Tag\VCalendar\SequenceNumber(),
                'Status' => new \PHPExiftool\Driver\Tag\VCalendar\Status(),
                'Summary' => new \PHPExiftool\Driver\Tag\VCalendar\Summary(),
                'TimeTransparency' => new \PHPExiftool\Driver\Tag\VCalendar\TimeTransparency(),
                'Trigger' => new \PHPExiftool\Driver\Tag\VCalendar\Trigger(),
                'TimezoneID' => new \PHPExiftool\Driver\Tag\VCalendar\TimezoneID(),
                'TimezoneName' => new \PHPExiftool\Driver\Tag\VCalendar\TimezoneName(),
                'TimezoneOffsetFrom' => new \PHPExiftool\Driver\Tag\VCalendar\TimezoneOffsetFrom(),
                'TimezoneOffsetTo' => new \PHPExiftool\Driver\Tag\VCalendar\TimezoneOffsetTo(),
                'TimeZoneURL' => new \PHPExiftool\Driver\Tag\VCalendar\TimeZoneURL(),
                'UID' => new \PHPExiftool\Driver\Tag\VCalendar\UID(),
                'URL' => new \PHPExiftool\Driver\Tag\VCalendar\URL(),
                'VCalendarVersion' => new \PHPExiftool\Driver\Tag\VCalendar\VCalendarVersion(),
                'CalendarColor' => new \PHPExiftool\Driver\Tag\VCalendar\CalendarColor(),
                'DefaultAlarm' => new \PHPExiftool\Driver\Tag\VCalendar\DefaultAlarm(),
                'LocalDefaultAlarm' => new \PHPExiftool\Driver\Tag\VCalendar\LocalDefaultAlarm(),
                'AllDayEvent' => new \PHPExiftool\Driver\Tag\VCalendar\AllDayEvent(),
                'AppointmentSequence' => new \PHPExiftool\Driver\Tag\VCalendar\AppointmentSequence(),
                'BusyStatus' => new \PHPExiftool\Driver\Tag\VCalendar\BusyStatus(),
                'Importance' => new \PHPExiftool\Driver\Tag\VCalendar\Importance(),
                'InstanceType' => new \PHPExiftool\Driver\Tag\VCalendar\InstanceType(),
                'IntendedBusyStatus' => new \PHPExiftool\Driver\Tag\VCalendar\IntendedBusyStatus(),
                'OwnerAppointmentID' => new \PHPExiftool\Driver\Tag\VCalendar\OwnerAppointmentID(),
                'DisallowCounterProposal' => new \PHPExiftool\Driver\Tag\VCalendar\DisallowCounterProposal(),
                'DoNotForwardMeeting' => new \PHPExiftool\Driver\Tag\VCalendar\DoNotForwardMeeting(),
                'MeetingLocations' => new \PHPExiftool\Driver\Tag\VCalendar\MeetingLocations(),
                'AlarmUID' => new \PHPExiftool\Driver\Tag\VCalendar\AlarmUID(),
                'CalendarDescription' => new \PHPExiftool\Driver\Tag\VCalendar\CalendarDescription(),
                'CalendarName' => new \PHPExiftool\Driver\Tag\VCalendar\CalendarName(),
                'CalendarID' => new \PHPExiftool\Driver\Tag\VCalendar\CalendarID(),
                'TimeZone2' => new \PHPExiftool\Driver\Tag\VCalendar\TimeZone2(),
            );
        });
        $this['Vorbis'] = $this->share(function(){
            return array(
                'Actor' => new \PHPExiftool\Driver\Tag\Vorbis\Actor(),
                'Album' => new \PHPExiftool\Driver\Tag\Vorbis\Album(),
                'Artist' => new \PHPExiftool\Driver\Tag\Vorbis\Artist(),
                'Comment' => new \PHPExiftool\Driver\Tag\Vorbis\Comment(),
                'Composer' => new \PHPExiftool\Driver\Tag\Vorbis\Composer(),
                'Contact' => new \PHPExiftool\Driver\Tag\Vorbis\Contact(),
                'Copyright' => new \PHPExiftool\Driver\Tag\Vorbis\Copyright(),
                'CoverArt' => new \PHPExiftool\Driver\Tag\Vorbis\CoverArt(),
                'CoverArtMIMEType' => new \PHPExiftool\Driver\Tag\Vorbis\CoverArtMIMEType(),
                'Date' => new \PHPExiftool\Driver\Tag\Vorbis\Date(),
                'Description' => new \PHPExiftool\Driver\Tag\Vorbis\Description(),
                'Director' => new \PHPExiftool\Driver\Tag\Vorbis\Director(),
                'EncodedBy' => new \PHPExiftool\Driver\Tag\Vorbis\EncodedBy(),
                'EncodedUsing' => new \PHPExiftool\Driver\Tag\Vorbis\EncodedUsing(),
                'Encoder' => new \PHPExiftool\Driver\Tag\Vorbis\Encoder(),
                'EncoderOptions' => new \PHPExiftool\Driver\Tag\Vorbis\EncoderOptions(),
                'Genre' => new \PHPExiftool\Driver\Tag\Vorbis\Genre(),
                'ISRCNumber' => new \PHPExiftool\Driver\Tag\Vorbis\ISRCNumber(),
                'License' => new \PHPExiftool\Driver\Tag\Vorbis\License(),
                'Location' => new \PHPExiftool\Driver\Tag\Vorbis\Location(),
                'Organization' => new \PHPExiftool\Driver\Tag\Vorbis\Organization(),
                'Performer' => new \PHPExiftool\Driver\Tag\Vorbis\Performer(),
                'Producer' => new \PHPExiftool\Driver\Tag\Vorbis\Producer(),
                'ReplayGainAlbumGain' => new \PHPExiftool\Driver\Tag\Vorbis\ReplayGainAlbumGain(),
                'ReplayGainAlbumPeak' => new \PHPExiftool\Driver\Tag\Vorbis\ReplayGainAlbumPeak(),
                'ReplayGainTrackGain' => new \PHPExiftool\Driver\Tag\Vorbis\ReplayGainTrackGain(),
                'ReplayGainTrackPeak' => new \PHPExiftool\Driver\Tag\Vorbis\ReplayGainTrackPeak(),
                'Title' => new \PHPExiftool\Driver\Tag\Vorbis\Title(),
                'TrackNumber' => new \PHPExiftool\Driver\Tag\Vorbis\TrackNumber(),
                'Version' => new \PHPExiftool\Driver\Tag\Vorbis\Version(),
                'Vendor' => new \PHPExiftool\Driver\Tag\Vorbis\Vendor(),
                'VorbisVersion' => new \PHPExiftool\Driver\Tag\Vorbis\VorbisVersion(),
                'AudioChannels' => new \PHPExiftool\Driver\Tag\Vorbis\AudioChannels(),
                'SampleRate' => new \PHPExiftool\Driver\Tag\Vorbis\SampleRate(),
                'MaximumBitrate' => new \PHPExiftool\Driver\Tag\Vorbis\MaximumBitrate(),
                'NominalBitrate' => new \PHPExiftool\Driver\Tag\Vorbis\NominalBitrate(),
                'MinimumBitrate' => new \PHPExiftool\Driver\Tag\Vorbis\MinimumBitrate(),
            );
        });
        $this['WTV'] = $this->share(function(){
            return array(
                'Duration' => new \PHPExiftool\Driver\Tag\WTV\Duration(),
                'Title' => new \PHPExiftool\Driver\Tag\WTV\Title(),
                'Genre' => new \PHPExiftool\Driver\Tag\WTV\Genre(),
                'Language' => new \PHPExiftool\Driver\Tag\WTV\Language(),
                'MediaClassPrimaryID' => new \PHPExiftool\Driver\Tag\WTV\MediaClassPrimaryID(),
                'MediaClassSecondaryID' => new \PHPExiftool\Driver\Tag\WTV\MediaClassSecondaryID(),
                'MediaCredits' => new \PHPExiftool\Driver\Tag\WTV\MediaCredits(),
                'MediaIsDelay' => new \PHPExiftool\Driver\Tag\WTV\MediaIsDelay(),
                'MediaIsFinale' => new \PHPExiftool\Driver\Tag\WTV\MediaIsFinale(),
                'MediaIsLive' => new \PHPExiftool\Driver\Tag\WTV\MediaIsLive(),
                'MediaIsMovie' => new \PHPExiftool\Driver\Tag\WTV\MediaIsMovie(),
                'MediaIsPremiere' => new \PHPExiftool\Driver\Tag\WTV\MediaIsPremiere(),
                'MediaIsRepeat' => new \PHPExiftool\Driver\Tag\WTV\MediaIsRepeat(),
                'MediaIsSAP' => new \PHPExiftool\Driver\Tag\WTV\MediaIsSAP(),
                'MediaIsSport' => new \PHPExiftool\Driver\Tag\WTV\MediaIsSport(),
                'MediaIsStereo' => new \PHPExiftool\Driver\Tag\WTV\MediaIsStereo(),
                'MediaIsSubtitled' => new \PHPExiftool\Driver\Tag\WTV\MediaIsSubtitled(),
                'MediaIsTape' => new \PHPExiftool\Driver\Tag\WTV\MediaIsTape(),
                'MediaNetworkAffiliation' => new \PHPExiftool\Driver\Tag\WTV\MediaNetworkAffiliation(),
                'MediaOriginalBroadcastDateTime' => new \PHPExiftool\Driver\Tag\WTV\MediaOriginalBroadcastDateTime(),
                'MediaOriginalChannel' => new \PHPExiftool\Driver\Tag\WTV\MediaOriginalChannel(),
                'MediaOriginalChannelSubNumber' => new \PHPExiftool\Driver\Tag\WTV\MediaOriginalChannelSubNumber(),
                'MediaOriginalRunTime' => new \PHPExiftool\Driver\Tag\WTV\MediaOriginalRunTime(),
                'MediaStationCallSign' => new \PHPExiftool\Driver\Tag\WTV\MediaStationCallSign(),
                'MediaStationName' => new \PHPExiftool\Driver\Tag\WTV\MediaStationName(),
                'MediaThumbAspectRatioX' => new \PHPExiftool\Driver\Tag\WTV\MediaThumbAspectRatioX(),
                'MediaThumbAspectRatioY' => new \PHPExiftool\Driver\Tag\WTV\MediaThumbAspectRatioY(),
                'MediaThumbHeight' => new \PHPExiftool\Driver\Tag\WTV\MediaThumbHeight(),
                'MediaThumbRatingAttributes' => new \PHPExiftool\Driver\Tag\WTV\MediaThumbRatingAttributes(),
                'MediaThumbRatingLevel' => new \PHPExiftool\Driver\Tag\WTV\MediaThumbRatingLevel(),
                'MediaThumbRatingSystem' => new \PHPExiftool\Driver\Tag\WTV\MediaThumbRatingSystem(),
                'MediaThumbRet' => new \PHPExiftool\Driver\Tag\WTV\MediaThumbRet(),
                'MediaThumbStride' => new \PHPExiftool\Driver\Tag\WTV\MediaThumbStride(),
                'MediaThumbTimeStamp' => new \PHPExiftool\Driver\Tag\WTV\MediaThumbTimeStamp(),
                'MediaThumbWidth' => new \PHPExiftool\Driver\Tag\WTV\MediaThumbWidth(),
                'OriginalReleaseTime' => new \PHPExiftool\Driver\Tag\WTV\OriginalReleaseTime(),
                'ParentalRating' => new \PHPExiftool\Driver\Tag\WTV\ParentalRating(),
                'ParentalRatingReason' => new \PHPExiftool\Driver\Tag\WTV\ParentalRatingReason(),
                'Provider' => new \PHPExiftool\Driver\Tag\WTV\Provider(),
                'ProviderCopyright' => new \PHPExiftool\Driver\Tag\WTV\ProviderCopyright(),
                'ProviderRating' => new \PHPExiftool\Driver\Tag\WTV\ProviderRating(),
                'Subtitle' => new \PHPExiftool\Driver\Tag\WTV\Subtitle(),
                'SubtitleDescription' => new \PHPExiftool\Driver\Tag\WTV\SubtitleDescription(),
                'VideoClosedCaptioning' => new \PHPExiftool\Driver\Tag\WTV\VideoClosedCaptioning(),
                'ATSCContent' => new \PHPExiftool\Driver\Tag\WTV\ATSCContent(),
                'ActualSoftPostPadding' => new \PHPExiftool\Driver\Tag\WTV\ActualSoftPostPadding(),
                'ActualSoftPrePadding' => new \PHPExiftool\Driver\Tag\WTV\ActualSoftPrePadding(),
                'Bitrate' => new \PHPExiftool\Driver\Tag\WTV\Bitrate(),
                'BrandingImageID' => new \PHPExiftool\Driver\Tag\WTV\BrandingImageID(),
                'BrandingName' => new \PHPExiftool\Driver\Tag\WTV\BrandingName(),
                'ContentProtected' => new \PHPExiftool\Driver\Tag\WTV\ContentProtected(),
                'ContentProtectedPercent' => new \PHPExiftool\Driver\Tag\WTV\ContentProtectedPercent(),
                'DTVContent' => new \PHPExiftool\Driver\Tag\WTV\DTVContent(),
                'EncodeTime' => new \PHPExiftool\Driver\Tag\WTV\EncodeTime(),
                'EndTime' => new \PHPExiftool\Driver\Tag\WTV\EndTime(),
                'ExpirationDate' => new \PHPExiftool\Driver\Tag\WTV\ExpirationDate(),
                'ExpirationSpan' => new \PHPExiftool\Driver\Tag\WTV\ExpirationSpan(),
                'HDContent' => new \PHPExiftool\Driver\Tag\WTV\HDContent(),
                'HardPostPadding' => new \PHPExiftool\Driver\Tag\WTV\HardPostPadding(),
                'HardPrePadding' => new \PHPExiftool\Driver\Tag\WTV\HardPrePadding(),
                'InBandRatingAttributes' => new \PHPExiftool\Driver\Tag\WTV\InBandRatingAttributes(),
                'InBandRatingLevel' => new \PHPExiftool\Driver\Tag\WTV\InBandRatingLevel(),
                'InBandRatingSystem' => new \PHPExiftool\Driver\Tag\WTV\InBandRatingSystem(),
                'KeepUntil' => new \PHPExiftool\Driver\Tag\WTV\KeepUntil(),
                'OriginalSoftPostPadding' => new \PHPExiftool\Driver\Tag\WTV\OriginalSoftPostPadding(),
                'OriginalSoftPrePadding' => new \PHPExiftool\Driver\Tag\WTV\OriginalSoftPrePadding(),
                'ProgramID' => new \PHPExiftool\Driver\Tag\WTV\ProgramID(),
                'Quality' => new \PHPExiftool\Driver\Tag\WTV\Quality(),
                'RequestID' => new \PHPExiftool\Driver\Tag\WTV\RequestID(),
                'ScheduleItemID' => new \PHPExiftool\Driver\Tag\WTV\ScheduleItemID(),
                'SeriesUID' => new \PHPExiftool\Driver\Tag\WTV\SeriesUID(),
                'ServiceID' => new \PHPExiftool\Driver\Tag\WTV\ServiceID(),
                'Watched' => new \PHPExiftool\Driver\Tag\WTV\Watched(),
            );
        });
        $this['XMP-album'] = $this->share(function(){
            return array(
                'Notes' => new \PHPExiftool\Driver\Tag\XMPAlbum\Notes(),
            );
        });
        $this['XMP-DICOM'] = $this->share(function(){
            return array(
                'EquipmentInstitution' => new \PHPExiftool\Driver\Tag\XMPDICOM\EquipmentInstitution(),
                'EquipmentManufacturer' => new \PHPExiftool\Driver\Tag\XMPDICOM\EquipmentManufacturer(),
                'PatientBirthDate' => new \PHPExiftool\Driver\Tag\XMPDICOM\PatientBirthDate(),
                'PatientID' => new \PHPExiftool\Driver\Tag\XMPDICOM\PatientID(),
                'PatientName' => new \PHPExiftool\Driver\Tag\XMPDICOM\PatientName(),
                'PatientSex' => new \PHPExiftool\Driver\Tag\XMPDICOM\PatientSex(),
                'SeriesDateTime' => new \PHPExiftool\Driver\Tag\XMPDICOM\SeriesDateTime(),
                'SeriesDescription' => new \PHPExiftool\Driver\Tag\XMPDICOM\SeriesDescription(),
                'SeriesModality' => new \PHPExiftool\Driver\Tag\XMPDICOM\SeriesModality(),
                'SeriesNumber' => new \PHPExiftool\Driver\Tag\XMPDICOM\SeriesNumber(),
                'StudyDateTime' => new \PHPExiftool\Driver\Tag\XMPDICOM\StudyDateTime(),
                'StudyDescription' => new \PHPExiftool\Driver\Tag\XMPDICOM\StudyDescription(),
                'StudyID' => new \PHPExiftool\Driver\Tag\XMPDICOM\StudyID(),
                'StudyPhysician' => new \PHPExiftool\Driver\Tag\XMPDICOM\StudyPhysician(),
            );
        });
        $this['XMP-expressionmedia'] = $this->share(function(){
            return array(
                'CatalogSets' => new \PHPExiftool\Driver\Tag\XMPExpressionmedia\CatalogSets(),
                'Event' => new \PHPExiftool\Driver\Tag\XMPExpressionmedia\Event(),
                'People' => new \PHPExiftool\Driver\Tag\XMPExpressionmedia\People(),
                'Status' => new \PHPExiftool\Driver\Tag\XMPExpressionmedia\Status(),
            );
        });
        $this['XMP-GAudio'] = $this->share(function(){
            return array(
                'AudioData' => new \PHPExiftool\Driver\Tag\XMPGAudio\AudioData(),
                'AudioMimeType' => new \PHPExiftool\Driver\Tag\XMPGAudio\AudioMimeType(),
            );
        });
        $this['XMP-GCamera'] = $this->share(function(){
            return array(
                'BurstID' => new \PHPExiftool\Driver\Tag\XMPGCamera\BurstID(),
                'BurstPrimary' => new \PHPExiftool\Driver\Tag\XMPGCamera\BurstPrimary(),
                'DisableAutoCreation' => new \PHPExiftool\Driver\Tag\XMPGCamera\DisableAutoCreation(),
                'HDRPMakerNote' => new \PHPExiftool\Driver\Tag\XMPGCamera\HDRPMakerNote(),
                'PortraitNote' => new \PHPExiftool\Driver\Tag\XMPGCamera\PortraitNote(),
                'PortraitRequest' => new \PHPExiftool\Driver\Tag\XMPGCamera\PortraitRequest(),
                'PortraitVersion' => new \PHPExiftool\Driver\Tag\XMPGCamera\PortraitVersion(),
                'SpecialTypeID' => new \PHPExiftool\Driver\Tag\XMPGCamera\SpecialTypeID(),
            );
        });
        $this['XMP-GCreations'] = $this->share(function(){
            return array(
                'CameraBurstID' => new \PHPExiftool\Driver\Tag\XMPGCreations\CameraBurstID(),
            );
        });
        $this['XMP-GDepth'] = $this->share(function(){
            return array(
                'Confidence' => new \PHPExiftool\Driver\Tag\XMPGDepth\Confidence(),
                'ConfidenceMime' => new \PHPExiftool\Driver\Tag\XMPGDepth\ConfidenceMime(),
                'DepthImage' => new \PHPExiftool\Driver\Tag\XMPGDepth\DepthImage(),
                'Far' => new \PHPExiftool\Driver\Tag\XMPGDepth\Far(),
                'Format' => new \PHPExiftool\Driver\Tag\XMPGDepth\Format(),
                'ImageHeight' => new \PHPExiftool\Driver\Tag\XMPGDepth\ImageHeight(),
                'ImageWidth' => new \PHPExiftool\Driver\Tag\XMPGDepth\ImageWidth(),
                'Manufacturer' => new \PHPExiftool\Driver\Tag\XMPGDepth\Manufacturer(),
                'MeasureType' => new \PHPExiftool\Driver\Tag\XMPGDepth\MeasureType(),
                'Mime' => new \PHPExiftool\Driver\Tag\XMPGDepth\Mime(),
                'Model' => new \PHPExiftool\Driver\Tag\XMPGDepth\Model(),
                'Near' => new \PHPExiftool\Driver\Tag\XMPGDepth\Near(),
                'Software' => new \PHPExiftool\Driver\Tag\XMPGDepth\Software(),
                'Units' => new \PHPExiftool\Driver\Tag\XMPGDepth\Units(),
            );
        });
        $this['XMP-GFocus'] = $this->share(function(){
            return array(
                'BlurAtInfinity' => new \PHPExiftool\Driver\Tag\XMPGFocus\BlurAtInfinity(),
                'FocalDistance' => new \PHPExiftool\Driver\Tag\XMPGFocus\FocalDistance(),
                'FocalPointX' => new \PHPExiftool\Driver\Tag\XMPGFocus\FocalPointX(),
                'FocalPointY' => new \PHPExiftool\Driver\Tag\XMPGFocus\FocalPointY(),
            );
        });
        $this['XMP-GImage'] = $this->share(function(){
            return array(
                'ImageData' => new \PHPExiftool\Driver\Tag\XMPGImage\ImageData(),
                'ImageMimeType' => new \PHPExiftool\Driver\Tag\XMPGImage\ImageMimeType(),
            );
        });
        $this['XMP-GPano'] = $this->share(function(){
            return array(
                'CaptureSoftware' => new \PHPExiftool\Driver\Tag\XMPGPano\CaptureSoftware(),
                'CroppedAreaImageHeightPixels' => new \PHPExiftool\Driver\Tag\XMPGPano\CroppedAreaImageHeightPixels(),
                'CroppedAreaImageWidthPixels' => new \PHPExiftool\Driver\Tag\XMPGPano\CroppedAreaImageWidthPixels(),
                'CroppedAreaLeftPixels' => new \PHPExiftool\Driver\Tag\XMPGPano\CroppedAreaLeftPixels(),
                'CroppedAreaTopPixels' => new \PHPExiftool\Driver\Tag\XMPGPano\CroppedAreaTopPixels(),
                'ExposureLockUsed' => new \PHPExiftool\Driver\Tag\XMPGPano\ExposureLockUsed(),
                'FirstPhotoDate' => new \PHPExiftool\Driver\Tag\XMPGPano\FirstPhotoDate(),
                'FullPanoHeightPixels' => new \PHPExiftool\Driver\Tag\XMPGPano\FullPanoHeightPixels(),
                'FullPanoWidthPixels' => new \PHPExiftool\Driver\Tag\XMPGPano\FullPanoWidthPixels(),
                'InitialCameraDolly' => new \PHPExiftool\Driver\Tag\XMPGPano\InitialCameraDolly(),
                'InitialHorizontalFOVDegrees' => new \PHPExiftool\Driver\Tag\XMPGPano\InitialHorizontalFOVDegrees(),
                'InitialViewHeadingDegrees' => new \PHPExiftool\Driver\Tag\XMPGPano\InitialViewHeadingDegrees(),
                'InitialViewPitchDegrees' => new \PHPExiftool\Driver\Tag\XMPGPano\InitialViewPitchDegrees(),
                'InitialViewRollDegrees' => new \PHPExiftool\Driver\Tag\XMPGPano\InitialViewRollDegrees(),
                'LargestValidInteriorRectHeight' => new \PHPExiftool\Driver\Tag\XMPGPano\LargestValidInteriorRectHeight(),
                'LargestValidInteriorRectLeft' => new \PHPExiftool\Driver\Tag\XMPGPano\LargestValidInteriorRectLeft(),
                'LargestValidInteriorRectTop' => new \PHPExiftool\Driver\Tag\XMPGPano\LargestValidInteriorRectTop(),
                'LargestValidInteriorRectWidth' => new \PHPExiftool\Driver\Tag\XMPGPano\LargestValidInteriorRectWidth(),
                'LastPhotoDate' => new \PHPExiftool\Driver\Tag\XMPGPano\LastPhotoDate(),
                'PoseHeadingDegrees' => new \PHPExiftool\Driver\Tag\XMPGPano\PoseHeadingDegrees(),
                'PosePitchDegrees' => new \PHPExiftool\Driver\Tag\XMPGPano\PosePitchDegrees(),
                'PoseRollDegrees' => new \PHPExiftool\Driver\Tag\XMPGPano\PoseRollDegrees(),
                'ProjectionType' => new \PHPExiftool\Driver\Tag\XMPGPano\ProjectionType(),
                'SourcePhotosCount' => new \PHPExiftool\Driver\Tag\XMPGPano\SourcePhotosCount(),
                'StitchingSoftware' => new \PHPExiftool\Driver\Tag\XMPGPano\StitchingSoftware(),
                'UsePanoramaViewer' => new \PHPExiftool\Driver\Tag\XMPGPano\UsePanoramaViewer(),
            );
        });
        $this['GSpherical'] = $this->share(function(){
            return array(
                'CroppedAreaImageHeightPixels' => new \PHPExiftool\Driver\Tag\GSpherical\CroppedAreaImageHeightPixels(),
                'CroppedAreaImageWidthPixels' => new \PHPExiftool\Driver\Tag\GSpherical\CroppedAreaImageWidthPixels(),
                'CroppedAreaLeftPixels' => new \PHPExiftool\Driver\Tag\GSpherical\CroppedAreaLeftPixels(),
                'CroppedAreaTopPixels' => new \PHPExiftool\Driver\Tag\GSpherical\CroppedAreaTopPixels(),
                'FullPanoHeightPixels' => new \PHPExiftool\Driver\Tag\GSpherical\FullPanoHeightPixels(),
                'FullPanoWidthPixels' => new \PHPExiftool\Driver\Tag\GSpherical\FullPanoWidthPixels(),
                'InitialViewHeadingDegrees' => new \PHPExiftool\Driver\Tag\GSpherical\InitialViewHeadingDegrees(),
                'InitialViewPitchDegrees' => new \PHPExiftool\Driver\Tag\GSpherical\InitialViewPitchDegrees(),
                'InitialViewRollDegrees' => new \PHPExiftool\Driver\Tag\GSpherical\InitialViewRollDegrees(),
                'ProjectionType' => new \PHPExiftool\Driver\Tag\GSpherical\ProjectionType(),
                'SourceCount' => new \PHPExiftool\Driver\Tag\GSpherical\SourceCount(),
                'Spherical' => new \PHPExiftool\Driver\Tag\GSpherical\Spherical(),
                'StereoMode' => new \PHPExiftool\Driver\Tag\GSpherical\StereoMode(),
                'Stitched' => new \PHPExiftool\Driver\Tag\GSpherical\Stitched(),
                'StitchingSoftware' => new \PHPExiftool\Driver\Tag\GSpherical\StitchingSoftware(),
                'TimeStamp' => new \PHPExiftool\Driver\Tag\GSpherical\TimeStamp(),
            );
        });
        $this['XMP-getty'] = $this->share(function(){
            return array(
                'AssetID' => new \PHPExiftool\Driver\Tag\XMPGetty\AssetID(),
                'CallForImage' => new \PHPExiftool\Driver\Tag\XMPGetty\CallForImage(),
                'CameraFilename' => new \PHPExiftool\Driver\Tag\XMPGetty\CameraFilename(),
                'CameraMakeModel' => new \PHPExiftool\Driver\Tag\XMPGetty\CameraMakeModel(),
                'CameraSerialNumber' => new \PHPExiftool\Driver\Tag\XMPGetty\CameraSerialNumber(),
                'Composition' => new \PHPExiftool\Driver\Tag\XMPGetty\Composition(),
                'ExclusiveCoverage' => new \PHPExiftool\Driver\Tag\XMPGetty\ExclusiveCoverage(),
                'GIFTFtpPriority' => new \PHPExiftool\Driver\Tag\XMPGetty\GIFTFtpPriority(),
                'ImageRank' => new \PHPExiftool\Driver\Tag\XMPGetty\ImageRank(),
                'MediaEventIdDate' => new \PHPExiftool\Driver\Tag\XMPGetty\MediaEventIdDate(),
                'OriginalCreateDateTime' => new \PHPExiftool\Driver\Tag\XMPGetty\OriginalCreateDateTime(),
                'OriginalFileName' => new \PHPExiftool\Driver\Tag\XMPGetty\OriginalFileName(),
                'ParentMediaEventID' => new \PHPExiftool\Driver\Tag\XMPGetty\ParentMediaEventID(),
                'ParentMEID' => new \PHPExiftool\Driver\Tag\XMPGetty\ParentMEID(),
                'Personality' => new \PHPExiftool\Driver\Tag\XMPGetty\Personality(),
                'PrimaryFTP' => new \PHPExiftool\Driver\Tag\XMPGetty\PrimaryFTP(),
                'RoutingDestinations' => new \PHPExiftool\Driver\Tag\XMPGetty\RoutingDestinations(),
                'RoutingExclusions' => new \PHPExiftool\Driver\Tag\XMPGetty\RoutingExclusions(),
                'SecondaryFTP' => new \PHPExiftool\Driver\Tag\XMPGetty\SecondaryFTP(),
                'TimeShot' => new \PHPExiftool\Driver\Tag\XMPGetty\TimeShot(),
            );
        });
        $this['XMP-LImage'] = $this->share(function(){
            return array(
                'MajorVersion' => new \PHPExiftool\Driver\Tag\XMPLImage\MajorVersion(),
                'MinorVersion' => new \PHPExiftool\Driver\Tag\XMPLImage\MinorVersion(),
                'RightAlbedo' => new \PHPExiftool\Driver\Tag\XMPLImage\RightAlbedo(),
            );
        });
        $this['XMP-lr'] = $this->share(function(){
            return array(
                'HierarchicalSubject' => new \PHPExiftool\Driver\Tag\XMPLr\HierarchicalSubject(),
                'PrivateRTKInfo' => new \PHPExiftool\Driver\Tag\XMPLr\PrivateRTKInfo(),
            );
        });
        $this['XMP-mediapro'] = $this->share(function(){
            return array(
                'CatalogSets' => new \PHPExiftool\Driver\Tag\XMPMediapro\CatalogSets(),
                'Event' => new \PHPExiftool\Driver\Tag\XMPMediapro\Event(),
                'Location' => new \PHPExiftool\Driver\Tag\XMPMediapro\Location(),
                'People' => new \PHPExiftool\Driver\Tag\XMPMediapro\People(),
                'Status' => new \PHPExiftool\Driver\Tag\XMPMediapro\Status(),
                'UserFields' => new \PHPExiftool\Driver\Tag\XMPMediapro\UserFields(),
            );
        });
        $this['XMP-PixelLive'] = $this->share(function(){
            return array(
                'Author' => new \PHPExiftool\Driver\Tag\XMPPixelLive\Author(),
                'Comments' => new \PHPExiftool\Driver\Tag\XMPPixelLive\Comments(),
                'Copyright' => new \PHPExiftool\Driver\Tag\XMPPixelLive\Copyright(),
                'Date' => new \PHPExiftool\Driver\Tag\XMPPixelLive\Date(),
                'Genre' => new \PHPExiftool\Driver\Tag\XMPPixelLive\Genre(),
                'Title' => new \PHPExiftool\Driver\Tag\XMPPixelLive\Title(),
            );
        });
        $this['SVG'] = $this->share(function(){
            return array(
                'ImageHeight' => new \PHPExiftool\Driver\Tag\SVG\ImageHeight(),
                'ID' => new \PHPExiftool\Driver\Tag\SVG\ID(),
                'MetadataID' => new \PHPExiftool\Driver\Tag\SVG\MetadataID(),
                'SVGVersion' => new \PHPExiftool\Driver\Tag\SVG\SVGVersion(),
                'ImageWidth' => new \PHPExiftool\Driver\Tag\SVG\ImageWidth(),
            );
        });
        $this['XMP-aas'] = $this->share(function(){
            return array(
                'AffineA' => new \PHPExiftool\Driver\Tag\XMPAas\AffineA(),
                'AffineB' => new \PHPExiftool\Driver\Tag\XMPAas\AffineB(),
                'AffineC' => new \PHPExiftool\Driver\Tag\XMPAas\AffineC(),
                'AffineD' => new \PHPExiftool\Driver\Tag\XMPAas\AffineD(),
                'AffineX' => new \PHPExiftool\Driver\Tag\XMPAas\AffineX(),
                'AffineY' => new \PHPExiftool\Driver\Tag\XMPAas\AffineY(),
                'CropH' => new \PHPExiftool\Driver\Tag\XMPAas\CropH(),
                'CropW' => new \PHPExiftool\Driver\Tag\XMPAas\CropW(),
                'CropX' => new \PHPExiftool\Driver\Tag\XMPAas\CropX(),
                'CropY' => new \PHPExiftool\Driver\Tag\XMPAas\CropY(),
                'Curve0x' => new \PHPExiftool\Driver\Tag\XMPAas\Curve0x(),
                'Curve0y' => new \PHPExiftool\Driver\Tag\XMPAas\Curve0y(),
                'Curve1x' => new \PHPExiftool\Driver\Tag\XMPAas\Curve1x(),
                'Curve1y' => new \PHPExiftool\Driver\Tag\XMPAas\Curve1y(),
                'Curve2x' => new \PHPExiftool\Driver\Tag\XMPAas\Curve2x(),
                'Curve2y' => new \PHPExiftool\Driver\Tag\XMPAas\Curve2y(),
                'Curve3x' => new \PHPExiftool\Driver\Tag\XMPAas\Curve3x(),
                'Curve3y' => new \PHPExiftool\Driver\Tag\XMPAas\Curve3y(),
                'Curve4x' => new \PHPExiftool\Driver\Tag\XMPAas\Curve4x(),
                'Curve4y' => new \PHPExiftool\Driver\Tag\XMPAas\Curve4y(),
                'FaceBalanceOrigI' => new \PHPExiftool\Driver\Tag\XMPAas\FaceBalanceOrigI(),
                'FaceBalanceOrigQ' => new \PHPExiftool\Driver\Tag\XMPAas\FaceBalanceOrigQ(),
                'FaceBalanceStrength' => new \PHPExiftool\Driver\Tag\XMPAas\FaceBalanceStrength(),
                'FaceBalanceWarmth' => new \PHPExiftool\Driver\Tag\XMPAas\FaceBalanceWarmth(),
                'Highlights' => new \PHPExiftool\Driver\Tag\XMPAas\Highlights(),
                'Shadows' => new \PHPExiftool\Driver\Tag\XMPAas\Shadows(),
                'Vibrance' => new \PHPExiftool\Driver\Tag\XMPAas\Vibrance(),
            );
        });
        $this['XMP-acdsee'] = $this->share(function(){
            return array(
                'Author' => new \PHPExiftool\Driver\Tag\XMPAcdsee\Author(),
                'Caption' => new \PHPExiftool\Driver\Tag\XMPAcdsee\Caption(),
                'Categories' => new \PHPExiftool\Driver\Tag\XMPAcdsee\Categories(),
                'Collections' => new \PHPExiftool\Driver\Tag\XMPAcdsee\Collections(),
                'DateTime' => new \PHPExiftool\Driver\Tag\XMPAcdsee\DateTime(),
                'DPP' => new \PHPExiftool\Driver\Tag\XMPAcdsee\DPP(),
                'EditStatus' => new \PHPExiftool\Driver\Tag\XMPAcdsee\EditStatus(),
                'FixtureIdentifier' => new \PHPExiftool\Driver\Tag\XMPAcdsee\FixtureIdentifier(),
                'Keywords' => new \PHPExiftool\Driver\Tag\XMPAcdsee\Keywords(),
                'Notes' => new \PHPExiftool\Driver\Tag\XMPAcdsee\Notes(),
                'ObjectCycle' => new \PHPExiftool\Driver\Tag\XMPAcdsee\ObjectCycle(),
                'OriginatingProgram' => new \PHPExiftool\Driver\Tag\XMPAcdsee\OriginatingProgram(),
                'Rating' => new \PHPExiftool\Driver\Tag\XMPAcdsee\Rating(),
                'Rawrppused' => new \PHPExiftool\Driver\Tag\XMPAcdsee\Rawrppused(),
                'ReleaseDate' => new \PHPExiftool\Driver\Tag\XMPAcdsee\ReleaseDate(),
                'ReleaseTime' => new \PHPExiftool\Driver\Tag\XMPAcdsee\ReleaseTime(),
                'RPP' => new \PHPExiftool\Driver\Tag\XMPAcdsee\RPP(),
                'Snapshots' => new \PHPExiftool\Driver\Tag\XMPAcdsee\Snapshots(),
                'Tagged' => new \PHPExiftool\Driver\Tag\XMPAcdsee\Tagged(),
            );
        });
        $this['XMP-apple-fi'] = $this->share(function(){
            return array(
                'AngleInfoRoll' => new \PHPExiftool\Driver\Tag\XMPAppleFi\AngleInfoRoll(),
                'AngleInfoYaw' => new \PHPExiftool\Driver\Tag\XMPAppleFi\AngleInfoYaw(),
                'ConfidenceLevel' => new \PHPExiftool\Driver\Tag\XMPAppleFi\ConfidenceLevel(),
                'FaceID' => new \PHPExiftool\Driver\Tag\XMPAppleFi\FaceID(),
                'TimeStamp' => new \PHPExiftool\Driver\Tag\XMPAppleFi\TimeStamp(),
            );
        });
        $this['XMP-aux'] = $this->share(function(){
            return array(
                'ApproximateFocusDistance' => new \PHPExiftool\Driver\Tag\XMPAux\ApproximateFocusDistance(),
                'DistortionCorrectionAlreadyApplied' => new \PHPExiftool\Driver\Tag\XMPAux\DistortionCorrectionAlreadyApplied(),
                'Firmware' => new \PHPExiftool\Driver\Tag\XMPAux\Firmware(),
                'FlashCompensation' => new \PHPExiftool\Driver\Tag\XMPAux\FlashCompensation(),
                'ImageNumber' => new \PHPExiftool\Driver\Tag\XMPAux\ImageNumber(),
                'IsMergedHDR' => new \PHPExiftool\Driver\Tag\XMPAux\IsMergedHDR(),
                'IsMergedPanorama' => new \PHPExiftool\Driver\Tag\XMPAux\IsMergedPanorama(),
                'LateralChromaticAberrationCorrectionAlreadyApplied' => new \PHPExiftool\Driver\Tag\XMPAux\LateralChromaticAberrationCorrectionAlreadyApplied(),
                'Lens' => new \PHPExiftool\Driver\Tag\XMPAux\Lens(),
                'LensDistortInfo' => new \PHPExiftool\Driver\Tag\XMPAux\LensDistortInfo(),
                'LensID' => new \PHPExiftool\Driver\Tag\XMPAux\LensID(),
                'LensInfo' => new \PHPExiftool\Driver\Tag\XMPAux\LensInfo(),
                'LensSerialNumber' => new \PHPExiftool\Driver\Tag\XMPAux\LensSerialNumber(),
                'OwnerName' => new \PHPExiftool\Driver\Tag\XMPAux\OwnerName(),
                'SerialNumber' => new \PHPExiftool\Driver\Tag\XMPAux\SerialNumber(),
                'VignetteCorrectionAlreadyApplied' => new \PHPExiftool\Driver\Tag\XMPAux\VignetteCorrectionAlreadyApplied(),
            );
        });
        $this['XMP-cc'] = $this->share(function(){
            return array(
                'AttributionName' => new \PHPExiftool\Driver\Tag\XMPCc\AttributionName(),
                'AttributionURL' => new \PHPExiftool\Driver\Tag\XMPCc\AttributionURL(),
                'DeprecatedOn' => new \PHPExiftool\Driver\Tag\XMPCc\DeprecatedOn(),
                'Jurisdiction' => new \PHPExiftool\Driver\Tag\XMPCc\Jurisdiction(),
                'LegalCode' => new \PHPExiftool\Driver\Tag\XMPCc\LegalCode(),
                'License' => new \PHPExiftool\Driver\Tag\XMPCc\License(),
                'MorePermissions' => new \PHPExiftool\Driver\Tag\XMPCc\MorePermissions(),
                'Permits' => new \PHPExiftool\Driver\Tag\XMPCc\Permits(),
                'Prohibits' => new \PHPExiftool\Driver\Tag\XMPCc\Prohibits(),
                'Requires' => new \PHPExiftool\Driver\Tag\XMPCc\Requires(),
                'UseGuidelines' => new \PHPExiftool\Driver\Tag\XMPCc\UseGuidelines(),
            );
        });
        $this['XMP-cell'] = $this->share(function(){
            return array(
                'CellTowerID' => new \PHPExiftool\Driver\Tag\XMPCell\CellTowerID(),
                'CellGlobalID' => new \PHPExiftool\Driver\Tag\XMPCell\CellGlobalID(),
                'LocationAreaCode' => new \PHPExiftool\Driver\Tag\XMPCell\LocationAreaCode(),
                'MobileCountryCode' => new \PHPExiftool\Driver\Tag\XMPCell\MobileCountryCode(),
                'MobileNetworkCode' => new \PHPExiftool\Driver\Tag\XMPCell\MobileNetworkCode(),
                'CellR' => new \PHPExiftool\Driver\Tag\XMPCell\CellR(),
            );
        });
        $this['XMP-crd'] = $this->share(function(){
            return array(
                'AlreadyApplied' => new \PHPExiftool\Driver\Tag\XMPCrd\AlreadyApplied(),
                'AutoBrightness' => new \PHPExiftool\Driver\Tag\XMPCrd\AutoBrightness(),
                'AutoContrast' => new \PHPExiftool\Driver\Tag\XMPCrd\AutoContrast(),
                'AutoExposure' => new \PHPExiftool\Driver\Tag\XMPCrd\AutoExposure(),
                'AutoLateralCA' => new \PHPExiftool\Driver\Tag\XMPCrd\AutoLateralCA(),
                'AutoShadows' => new \PHPExiftool\Driver\Tag\XMPCrd\AutoShadows(),
                'AutoTone' => new \PHPExiftool\Driver\Tag\XMPCrd\AutoTone(),
                'AutoWhiteVersion' => new \PHPExiftool\Driver\Tag\XMPCrd\AutoWhiteVersion(),
                'Blacks2012' => new \PHPExiftool\Driver\Tag\XMPCrd\Blacks2012(),
                'BlueHue' => new \PHPExiftool\Driver\Tag\XMPCrd\BlueHue(),
                'BlueSaturation' => new \PHPExiftool\Driver\Tag\XMPCrd\BlueSaturation(),
                'Brightness' => new \PHPExiftool\Driver\Tag\XMPCrd\Brightness(),
                'CameraProfile' => new \PHPExiftool\Driver\Tag\XMPCrd\CameraProfile(),
                'CameraProfileDigest' => new \PHPExiftool\Driver\Tag\XMPCrd\CameraProfileDigest(),
                'ChromaticAberrationB' => new \PHPExiftool\Driver\Tag\XMPCrd\ChromaticAberrationB(),
                'ChromaticAberrationR' => new \PHPExiftool\Driver\Tag\XMPCrd\ChromaticAberrationR(),
                'CircularGradientBasedCorrections' => new \PHPExiftool\Driver\Tag\XMPCrd\CircularGradientBasedCorrections(),
                'CircGradBasedCorrActive' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrActive(),
                'CircGradBasedCorrAmount' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrAmount(),
                'CircGradBasedCorrMasks' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMasks(),
                'CircGradBasedCorrMaskAlpha' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskAlpha(),
                'CircGradBasedCorrMaskAngle' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskAngle(),
                'CircGradBasedCorrMaskBottom' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskBottom(),
                'CircGradBasedCorrMaskCenterValue' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskCenterValue(),
                'CircGradBasedCorrMaskCenterWeight' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskCenterWeight(),
                'CircGradBasedCorrMaskDabs' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskDabs(),
                'CircGradBasedCorrMaskFeather' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskFeather(),
                'CircGradBasedCorrMaskFlipped' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskFlipped(),
                'CircGradBasedCorrMaskFlow' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskFlow(),
                'CircGradBasedCorrMaskFullX' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskFullX(),
                'CircGradBasedCorrMaskFullY' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskFullY(),
                'CircGradBasedCorrMaskLeft' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskLeft(),
                'CircGradBasedCorrMaskValue' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskValue(),
                'CircGradBasedCorrMaskMidpoint' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskMidpoint(),
                'CircGradBasedCorrMaskPerimeterValue' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskPerimeterValue(),
                'CircGradBasedCorrMaskRadius' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskRadius(),
                'CircGradBasedCorrMaskRight' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskRight(),
                'CircGradBasedCorrMaskRoundness' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskRoundness(),
                'CircGradBasedCorrMaskSizeX' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskSizeX(),
                'CircGradBasedCorrMaskSizeY' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskSizeY(),
                'CircGradBasedCorrMaskTop' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskTop(),
                'CircGradBasedCorrMaskVersion' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskVersion(),
                'CircGradBasedCorrMaskWhat' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskWhat(),
                'CircGradBasedCorrMaskX' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskX(),
                'CircGradBasedCorrMaskY' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskY(),
                'CircGradBasedCorrMaskZeroX' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskZeroX(),
                'CircGradBasedCorrMaskZeroY' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskZeroY(),
                'CircGradBasedCorrBrightness' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrBrightness(),
                'CircGradBasedCorrClarity' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrClarity(),
                'CircGradBasedCorrClarity2012' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrClarity2012(),
                'CircGradBasedCorrContrast' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrContrast(),
                'CircGradBasedCorrContrast2012' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrContrast2012(),
                'CircGradBasedCorrDefringe' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrDefringe(),
                'CircGradBasedCorrExposure' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrExposure(),
                'CircGradBasedCorrExposure2012' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrExposure2012(),
                'CircGradBasedCorrHighlights2012' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrHighlights2012(),
                'CircGradBasedCorrLuminanceNoise' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrLuminanceNoise(),
                'CircGradBasedCorrMoire' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMoire(),
                'CircGradBasedCorrSaturation' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrSaturation(),
                'CircGradBasedCorrShadows2012' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrShadows2012(),
                'CircGradBasedCorrSharpness' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrSharpness(),
                'CircGradBasedCorrTemperature' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrTemperature(),
                'CircGradBasedCorrTint' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrTint(),
                'CircGradBasedCorrHue' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrHue(),
                'CircGradBasedCorrWhat' => new \PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrWhat(),
                'Clarity' => new \PHPExiftool\Driver\Tag\XMPCrd\Clarity(),
                'Clarity2012' => new \PHPExiftool\Driver\Tag\XMPCrd\Clarity2012(),
                'ColorNoiseReduction' => new \PHPExiftool\Driver\Tag\XMPCrd\ColorNoiseReduction(),
                'ColorNoiseReductionDetail' => new \PHPExiftool\Driver\Tag\XMPCrd\ColorNoiseReductionDetail(),
                'ColorNoiseReductionSmoothness' => new \PHPExiftool\Driver\Tag\XMPCrd\ColorNoiseReductionSmoothness(),
                'Contrast' => new \PHPExiftool\Driver\Tag\XMPCrd\Contrast(),
                'Contrast2012' => new \PHPExiftool\Driver\Tag\XMPCrd\Contrast2012(),
                'Converter' => new \PHPExiftool\Driver\Tag\XMPCrd\Converter(),
                'ConvertToGrayscale' => new \PHPExiftool\Driver\Tag\XMPCrd\ConvertToGrayscale(),
                'CropAngle' => new \PHPExiftool\Driver\Tag\XMPCrd\CropAngle(),
                'CropBottom' => new \PHPExiftool\Driver\Tag\XMPCrd\CropBottom(),
                'CropConstrainToWarp' => new \PHPExiftool\Driver\Tag\XMPCrd\CropConstrainToWarp(),
                'CropHeight' => new \PHPExiftool\Driver\Tag\XMPCrd\CropHeight(),
                'CropLeft' => new \PHPExiftool\Driver\Tag\XMPCrd\CropLeft(),
                'CropRight' => new \PHPExiftool\Driver\Tag\XMPCrd\CropRight(),
                'CropTop' => new \PHPExiftool\Driver\Tag\XMPCrd\CropTop(),
                'CropUnit' => new \PHPExiftool\Driver\Tag\XMPCrd\CropUnit(),
                'CropUnits' => new \PHPExiftool\Driver\Tag\XMPCrd\CropUnits(),
                'CropWidth' => new \PHPExiftool\Driver\Tag\XMPCrd\CropWidth(),
                'DefaultAutoGray' => new \PHPExiftool\Driver\Tag\XMPCrd\DefaultAutoGray(),
                'DefaultAutoTone' => new \PHPExiftool\Driver\Tag\XMPCrd\DefaultAutoTone(),
                'DefaultsSpecificToISO' => new \PHPExiftool\Driver\Tag\XMPCrd\DefaultsSpecificToISO(),
                'DefaultsSpecificToSerial' => new \PHPExiftool\Driver\Tag\XMPCrd\DefaultsSpecificToSerial(),
                'Defringe' => new \PHPExiftool\Driver\Tag\XMPCrd\Defringe(),
                'DefringeGreenAmount' => new \PHPExiftool\Driver\Tag\XMPCrd\DefringeGreenAmount(),
                'DefringeGreenHueHi' => new \PHPExiftool\Driver\Tag\XMPCrd\DefringeGreenHueHi(),
                'DefringeGreenHueLo' => new \PHPExiftool\Driver\Tag\XMPCrd\DefringeGreenHueLo(),
                'DefringePurpleAmount' => new \PHPExiftool\Driver\Tag\XMPCrd\DefringePurpleAmount(),
                'DefringePurpleHueHi' => new \PHPExiftool\Driver\Tag\XMPCrd\DefringePurpleHueHi(),
                'DefringePurpleHueLo' => new \PHPExiftool\Driver\Tag\XMPCrd\DefringePurpleHueLo(),
                'Dehaze' => new \PHPExiftool\Driver\Tag\XMPCrd\Dehaze(),
                'DNGIgnoreSidecars' => new \PHPExiftool\Driver\Tag\XMPCrd\DNGIgnoreSidecars(),
                'Exposure' => new \PHPExiftool\Driver\Tag\XMPCrd\Exposure(),
                'Exposure2012' => new \PHPExiftool\Driver\Tag\XMPCrd\Exposure2012(),
                'FillLight' => new \PHPExiftool\Driver\Tag\XMPCrd\FillLight(),
                'GradientBasedCorrections' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrections(),
                'GradientBasedCorrActive' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrActive(),
                'GradientBasedCorrAmount' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrAmount(),
                'GradientBasedCorrMasks' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMasks(),
                'GradientBasedCorrMaskAlpha' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskAlpha(),
                'GradientBasedCorrMaskAngle' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskAngle(),
                'GradientBasedCorrMaskBottom' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskBottom(),
                'GradientBasedCorrMaskCenterValue' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskCenterValue(),
                'GradientBasedCorrMaskCenterWeight' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskCenterWeight(),
                'GradientBasedCorrMaskDabs' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskDabs(),
                'GradientBasedCorrMaskFeather' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskFeather(),
                'GradientBasedCorrMaskFlipped' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskFlipped(),
                'GradientBasedCorrMaskFlow' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskFlow(),
                'GradientBasedCorrMaskFullX' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskFullX(),
                'GradientBasedCorrMaskFullY' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskFullY(),
                'GradientBasedCorrMaskLeft' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskLeft(),
                'GradientBasedCorrMaskValue' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskValue(),
                'GradientBasedCorrMaskMidpoint' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskMidpoint(),
                'GradientBasedCorrMaskPerimeterValue' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskPerimeterValue(),
                'GradientBasedCorrMaskRadius' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskRadius(),
                'GradientBasedCorrMaskRight' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskRight(),
                'GradientBasedCorrMaskRoundness' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskRoundness(),
                'GradientBasedCorrMaskSizeX' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskSizeX(),
                'GradientBasedCorrMaskSizeY' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskSizeY(),
                'GradientBasedCorrMaskTop' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskTop(),
                'GradientBasedCorrMaskVersion' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskVersion(),
                'GradientBasedCorrMaskWhat' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskWhat(),
                'GradientBasedCorrMaskX' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskX(),
                'GradientBasedCorrMaskY' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskY(),
                'GradientBasedCorrMaskZeroX' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskZeroX(),
                'GradientBasedCorrMaskZeroY' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskZeroY(),
                'GradientBasedCorrBrightness' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrBrightness(),
                'GradientBasedCorrClarity' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrClarity(),
                'GradientBasedCorrClarity2012' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrClarity2012(),
                'GradientBasedCorrContrast' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrContrast(),
                'GradientBasedCorrContrast2012' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrContrast2012(),
                'GradientBasedCorrDefringe' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrDefringe(),
                'GradientBasedCorrExposure' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrExposure(),
                'GradientBasedCorrExposure2012' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrExposure2012(),
                'GradientBasedCorrHighlights2012' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrHighlights2012(),
                'GradientBasedCorrLuminanceNoise' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrLuminanceNoise(),
                'GradientBasedCorrMoire' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMoire(),
                'GradientBasedCorrSaturation' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrSaturation(),
                'GradientBasedCorrShadows2012' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrShadows2012(),
                'GradientBasedCorrSharpness' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrSharpness(),
                'GradientBasedCorrTemperature' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrTemperature(),
                'GradientBasedCorrTint' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrTint(),
                'GradientBasedCorrHue' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrHue(),
                'GradientBasedCorrWhat' => new \PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrWhat(),
                'GrainAmount' => new \PHPExiftool\Driver\Tag\XMPCrd\GrainAmount(),
                'GrainFrequency' => new \PHPExiftool\Driver\Tag\XMPCrd\GrainFrequency(),
                'GrainSize' => new \PHPExiftool\Driver\Tag\XMPCrd\GrainSize(),
                'GrayMixerAqua' => new \PHPExiftool\Driver\Tag\XMPCrd\GrayMixerAqua(),
                'GrayMixerBlue' => new \PHPExiftool\Driver\Tag\XMPCrd\GrayMixerBlue(),
                'GrayMixerGreen' => new \PHPExiftool\Driver\Tag\XMPCrd\GrayMixerGreen(),
                'GrayMixerMagenta' => new \PHPExiftool\Driver\Tag\XMPCrd\GrayMixerMagenta(),
                'GrayMixerOrange' => new \PHPExiftool\Driver\Tag\XMPCrd\GrayMixerOrange(),
                'GrayMixerPurple' => new \PHPExiftool\Driver\Tag\XMPCrd\GrayMixerPurple(),
                'GrayMixerRed' => new \PHPExiftool\Driver\Tag\XMPCrd\GrayMixerRed(),
                'GrayMixerYellow' => new \PHPExiftool\Driver\Tag\XMPCrd\GrayMixerYellow(),
                'GreenHue' => new \PHPExiftool\Driver\Tag\XMPCrd\GreenHue(),
                'GreenSaturation' => new \PHPExiftool\Driver\Tag\XMPCrd\GreenSaturation(),
                'HasCrop' => new \PHPExiftool\Driver\Tag\XMPCrd\HasCrop(),
                'HasSettings' => new \PHPExiftool\Driver\Tag\XMPCrd\HasSettings(),
                'Highlight2012' => new \PHPExiftool\Driver\Tag\XMPCrd\Highlight2012(),
                'HighlightRecovery' => new \PHPExiftool\Driver\Tag\XMPCrd\HighlightRecovery(),
                'Highlights2012' => new \PHPExiftool\Driver\Tag\XMPCrd\Highlights2012(),
                'HueAdjustmentAqua' => new \PHPExiftool\Driver\Tag\XMPCrd\HueAdjustmentAqua(),
                'HueAdjustmentBlue' => new \PHPExiftool\Driver\Tag\XMPCrd\HueAdjustmentBlue(),
                'HueAdjustmentGreen' => new \PHPExiftool\Driver\Tag\XMPCrd\HueAdjustmentGreen(),
                'HueAdjustmentMagenta' => new \PHPExiftool\Driver\Tag\XMPCrd\HueAdjustmentMagenta(),
                'HueAdjustmentOrange' => new \PHPExiftool\Driver\Tag\XMPCrd\HueAdjustmentOrange(),
                'HueAdjustmentPurple' => new \PHPExiftool\Driver\Tag\XMPCrd\HueAdjustmentPurple(),
                'HueAdjustmentRed' => new \PHPExiftool\Driver\Tag\XMPCrd\HueAdjustmentRed(),
                'HueAdjustmentYellow' => new \PHPExiftool\Driver\Tag\XMPCrd\HueAdjustmentYellow(),
                'IncrementalTemperature' => new \PHPExiftool\Driver\Tag\XMPCrd\IncrementalTemperature(),
                'IncrementalTint' => new \PHPExiftool\Driver\Tag\XMPCrd\IncrementalTint(),
                'JPEGHandling' => new \PHPExiftool\Driver\Tag\XMPCrd\JPEGHandling(),
                'LensManualDistortionAmount' => new \PHPExiftool\Driver\Tag\XMPCrd\LensManualDistortionAmount(),
                'LensProfileChromaticAberrationScale' => new \PHPExiftool\Driver\Tag\XMPCrd\LensProfileChromaticAberrationScale(),
                'LensProfileDigest' => new \PHPExiftool\Driver\Tag\XMPCrd\LensProfileDigest(),
                'LensProfileDistortionScale' => new \PHPExiftool\Driver\Tag\XMPCrd\LensProfileDistortionScale(),
                'LensProfileEnable' => new \PHPExiftool\Driver\Tag\XMPCrd\LensProfileEnable(),
                'LensProfileFilename' => new \PHPExiftool\Driver\Tag\XMPCrd\LensProfileFilename(),
                'LensProfileMatchKeyCameraModelName' => new \PHPExiftool\Driver\Tag\XMPCrd\LensProfileMatchKeyCameraModelName(),
                'LensProfileMatchKeyExifMake' => new \PHPExiftool\Driver\Tag\XMPCrd\LensProfileMatchKeyExifMake(),
                'LensProfileMatchKeyExifModel' => new \PHPExiftool\Driver\Tag\XMPCrd\LensProfileMatchKeyExifModel(),
                'LensProfileMatchKeyIsRaw' => new \PHPExiftool\Driver\Tag\XMPCrd\LensProfileMatchKeyIsRaw(),
                'LensProfileMatchKeyLensID' => new \PHPExiftool\Driver\Tag\XMPCrd\LensProfileMatchKeyLensID(),
                'LensProfileMatchKeyLensInfo' => new \PHPExiftool\Driver\Tag\XMPCrd\LensProfileMatchKeyLensInfo(),
                'LensProfileMatchKeyLensName' => new \PHPExiftool\Driver\Tag\XMPCrd\LensProfileMatchKeyLensName(),
                'LensProfileMatchKeySensorFormatFactor' => new \PHPExiftool\Driver\Tag\XMPCrd\LensProfileMatchKeySensorFormatFactor(),
                'LensProfileName' => new \PHPExiftool\Driver\Tag\XMPCrd\LensProfileName(),
                'LensProfileSetup' => new \PHPExiftool\Driver\Tag\XMPCrd\LensProfileSetup(),
                'LensProfileVignettingScale' => new \PHPExiftool\Driver\Tag\XMPCrd\LensProfileVignettingScale(),
                'Look' => new \PHPExiftool\Driver\Tag\XMPCrd\Look(),
                'LookName' => new \PHPExiftool\Driver\Tag\XMPCrd\LookName(),
                'LuminanceAdjustmentAqua' => new \PHPExiftool\Driver\Tag\XMPCrd\LuminanceAdjustmentAqua(),
                'LuminanceAdjustmentBlue' => new \PHPExiftool\Driver\Tag\XMPCrd\LuminanceAdjustmentBlue(),
                'LuminanceAdjustmentGreen' => new \PHPExiftool\Driver\Tag\XMPCrd\LuminanceAdjustmentGreen(),
                'LuminanceAdjustmentMagenta' => new \PHPExiftool\Driver\Tag\XMPCrd\LuminanceAdjustmentMagenta(),
                'LuminanceAdjustmentOrange' => new \PHPExiftool\Driver\Tag\XMPCrd\LuminanceAdjustmentOrange(),
                'LuminanceAdjustmentPurple' => new \PHPExiftool\Driver\Tag\XMPCrd\LuminanceAdjustmentPurple(),
                'LuminanceAdjustmentRed' => new \PHPExiftool\Driver\Tag\XMPCrd\LuminanceAdjustmentRed(),
                'LuminanceAdjustmentYellow' => new \PHPExiftool\Driver\Tag\XMPCrd\LuminanceAdjustmentYellow(),
                'LuminanceNoiseReductionContrast' => new \PHPExiftool\Driver\Tag\XMPCrd\LuminanceNoiseReductionContrast(),
                'LuminanceNoiseReductionDetail' => new \PHPExiftool\Driver\Tag\XMPCrd\LuminanceNoiseReductionDetail(),
                'LuminanceSmoothing' => new \PHPExiftool\Driver\Tag\XMPCrd\LuminanceSmoothing(),
                'MoireFilter' => new \PHPExiftool\Driver\Tag\XMPCrd\MoireFilter(),
                'NegativeCacheLargePreviewSize' => new \PHPExiftool\Driver\Tag\XMPCrd\NegativeCacheLargePreviewSize(),
                'NegativeCacheMaximumSize' => new \PHPExiftool\Driver\Tag\XMPCrd\NegativeCacheMaximumSize(),
                'NegativeCachePath' => new \PHPExiftool\Driver\Tag\XMPCrd\NegativeCachePath(),
                'OverrideLookVignette' => new \PHPExiftool\Driver\Tag\XMPCrd\OverrideLookVignette(),
                'PaintBasedCorrections' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintBasedCorrections(),
                'PaintCorrectionActive' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionActive(),
                'PaintCorrectionAmount' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionAmount(),
                'PaintBasedCorrectionMasks' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintBasedCorrectionMasks(),
                'PaintCorrectionMaskAlpha' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskAlpha(),
                'PaintCorrectionMaskAngle' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskAngle(),
                'PaintCorrectionMaskBottom' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskBottom(),
                'PaintCorrectionMaskCenterValue' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskCenterValue(),
                'PaintCorrectionMaskCenterWeight' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskCenterWeight(),
                'PaintCorrectionMaskDabs' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskDabs(),
                'PaintCorrectionMaskFeather' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskFeather(),
                'PaintCorrectionMaskFlipped' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskFlipped(),
                'PaintCorrectionMaskFlow' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskFlow(),
                'PaintCorrectionMaskFullX' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskFullX(),
                'PaintCorrectionMaskFullY' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskFullY(),
                'PaintCorrectionMaskLeft' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskLeft(),
                'PaintCorrectionMaskValue' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskValue(),
                'PaintCorrectionMaskMidpoint' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskMidpoint(),
                'PaintCorrectionMaskPerimeterValue' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskPerimeterValue(),
                'PaintCorrectionMaskRadius' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskRadius(),
                'PaintCorrectionMaskRight' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskRight(),
                'PaintCorrectionMaskRoundness' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskRoundness(),
                'PaintCorrectionMaskSizeX' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskSizeX(),
                'PaintCorrectionMaskSizeY' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskSizeY(),
                'PaintCorrectionMaskTop' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskTop(),
                'PaintCorrectionMaskVersion' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskVersion(),
                'PaintCorrectionMaskWhat' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskWhat(),
                'PaintCorrectionMaskX' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskX(),
                'PaintCorrectionMaskY' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskY(),
                'PaintCorrectionMaskZeroX' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskZeroX(),
                'PaintCorrectionMaskZeroY' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskZeroY(),
                'PaintCorrectionBrightness' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionBrightness(),
                'PaintCorrectionClarity' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionClarity(),
                'PaintCorrectionClarity2012' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionClarity2012(),
                'PaintCorrectionContrast' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionContrast(),
                'PaintCorrectionContrast2012' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionContrast2012(),
                'PaintCorrectionDefringe' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionDefringe(),
                'PaintCorrectionExposure' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionExposure(),
                'PaintCorrectionExposure2012' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionExposure2012(),
                'PaintCorrectionHighlights2012' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionHighlights2012(),
                'PaintCorrectionLuminanceNoise' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionLuminanceNoise(),
                'PaintCorrectionMoire' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMoire(),
                'PaintCorrectionSaturation' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionSaturation(),
                'PaintCorrectionShadows2012' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionShadows2012(),
                'PaintCorrectionSharpness' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionSharpness(),
                'PaintCorrectionTemperature' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionTemperature(),
                'PaintCorrectionTint' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionTint(),
                'PaintCorrectionHue' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionHue(),
                'PaintCorrectionWhat' => new \PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionWhat(),
                'ParametricDarks' => new \PHPExiftool\Driver\Tag\XMPCrd\ParametricDarks(),
                'ParametricHighlights' => new \PHPExiftool\Driver\Tag\XMPCrd\ParametricHighlights(),
                'ParametricHighlightSplit' => new \PHPExiftool\Driver\Tag\XMPCrd\ParametricHighlightSplit(),
                'ParametricLights' => new \PHPExiftool\Driver\Tag\XMPCrd\ParametricLights(),
                'ParametricMidtoneSplit' => new \PHPExiftool\Driver\Tag\XMPCrd\ParametricMidtoneSplit(),
                'ParametricShadows' => new \PHPExiftool\Driver\Tag\XMPCrd\ParametricShadows(),
                'ParametricShadowSplit' => new \PHPExiftool\Driver\Tag\XMPCrd\ParametricShadowSplit(),
                'PerspectiveAspect' => new \PHPExiftool\Driver\Tag\XMPCrd\PerspectiveAspect(),
                'PerspectiveHorizontal' => new \PHPExiftool\Driver\Tag\XMPCrd\PerspectiveHorizontal(),
                'PerspectiveRotate' => new \PHPExiftool\Driver\Tag\XMPCrd\PerspectiveRotate(),
                'PerspectiveScale' => new \PHPExiftool\Driver\Tag\XMPCrd\PerspectiveScale(),
                'PerspectiveUpright' => new \PHPExiftool\Driver\Tag\XMPCrd\PerspectiveUpright(),
                'PerspectiveVertical' => new \PHPExiftool\Driver\Tag\XMPCrd\PerspectiveVertical(),
                'PerspectiveX' => new \PHPExiftool\Driver\Tag\XMPCrd\PerspectiveX(),
                'PerspectiveY' => new \PHPExiftool\Driver\Tag\XMPCrd\PerspectiveY(),
                'PostCropVignetteAmount' => new \PHPExiftool\Driver\Tag\XMPCrd\PostCropVignetteAmount(),
                'PostCropVignetteFeather' => new \PHPExiftool\Driver\Tag\XMPCrd\PostCropVignetteFeather(),
                'PostCropVignetteHighlightContrast' => new \PHPExiftool\Driver\Tag\XMPCrd\PostCropVignetteHighlightContrast(),
                'PostCropVignetteMidpoint' => new \PHPExiftool\Driver\Tag\XMPCrd\PostCropVignetteMidpoint(),
                'PostCropVignetteRoundness' => new \PHPExiftool\Driver\Tag\XMPCrd\PostCropVignetteRoundness(),
                'PostCropVignetteStyle' => new \PHPExiftool\Driver\Tag\XMPCrd\PostCropVignetteStyle(),
                'ProcessVersion' => new \PHPExiftool\Driver\Tag\XMPCrd\ProcessVersion(),
                'RawFileName' => new \PHPExiftool\Driver\Tag\XMPCrd\RawFileName(),
                'RedEyeInfo' => new \PHPExiftool\Driver\Tag\XMPCrd\RedEyeInfo(),
                'RedHue' => new \PHPExiftool\Driver\Tag\XMPCrd\RedHue(),
                'RedSaturation' => new \PHPExiftool\Driver\Tag\XMPCrd\RedSaturation(),
                'RetouchAreas' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreas(),
                'RetouchAreaFeather' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaFeather(),
                'RetouchAreaMasks' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMasks(),
                'RetouchAreaMaskAlpha' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskAlpha(),
                'RetouchAreaMaskAngle' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskAngle(),
                'RetouchAreaMaskBottom' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskBottom(),
                'RetouchAreaMaskCenterValue' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskCenterValue(),
                'RetouchAreaMaskCenterWeight' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskCenterWeight(),
                'RetouchAreaMaskDabs' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskDabs(),
                'RetouchAreaMaskFeather' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskFeather(),
                'RetouchAreaMaskFlipped' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskFlipped(),
                'RetouchAreaMaskFlow' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskFlow(),
                'RetouchAreaMaskFullX' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskFullX(),
                'RetouchAreaMaskFullY' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskFullY(),
                'RetouchAreaMaskLeft' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskLeft(),
                'RetouchAreaMaskValue' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskValue(),
                'RetouchAreaMaskMidpoint' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskMidpoint(),
                'RetouchAreaMaskPerimeterValue' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskPerimeterValue(),
                'RetouchAreaMaskRadius' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskRadius(),
                'RetouchAreaMaskRight' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskRight(),
                'RetouchAreaMaskRoundness' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskRoundness(),
                'RetouchAreaMaskSizeX' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskSizeX(),
                'RetouchAreaMaskSizeY' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskSizeY(),
                'RetouchAreaMaskTop' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskTop(),
                'RetouchAreaMaskVersion' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskVersion(),
                'RetouchAreaMaskWhat' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskWhat(),
                'RetouchAreaMaskX' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskX(),
                'RetouchAreaMaskY' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskY(),
                'RetouchAreaMaskZeroX' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskZeroX(),
                'RetouchAreaMaskZeroY' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskZeroY(),
                'RetouchAreaMethod' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMethod(),
                'RetouchAreaOffsetY' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaOffsetY(),
                'RetouchAreaOpacity' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaOpacity(),
                'RetouchAreaSeed' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaSeed(),
                'RetouchAreaSourceState' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaSourceState(),
                'RetouchAreaSourceX' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaSourceX(),
                'RetouchAreaSpotType' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaSpotType(),
                'RetouchInfo' => new \PHPExiftool\Driver\Tag\XMPCrd\RetouchInfo(),
                'Saturation' => new \PHPExiftool\Driver\Tag\XMPCrd\Saturation(),
                'SaturationAdjustmentAqua' => new \PHPExiftool\Driver\Tag\XMPCrd\SaturationAdjustmentAqua(),
                'SaturationAdjustmentBlue' => new \PHPExiftool\Driver\Tag\XMPCrd\SaturationAdjustmentBlue(),
                'SaturationAdjustmentGreen' => new \PHPExiftool\Driver\Tag\XMPCrd\SaturationAdjustmentGreen(),
                'SaturationAdjustmentMagenta' => new \PHPExiftool\Driver\Tag\XMPCrd\SaturationAdjustmentMagenta(),
                'SaturationAdjustmentOrange' => new \PHPExiftool\Driver\Tag\XMPCrd\SaturationAdjustmentOrange(),
                'SaturationAdjustmentPurple' => new \PHPExiftool\Driver\Tag\XMPCrd\SaturationAdjustmentPurple(),
                'SaturationAdjustmentRed' => new \PHPExiftool\Driver\Tag\XMPCrd\SaturationAdjustmentRed(),
                'SaturationAdjustmentYellow' => new \PHPExiftool\Driver\Tag\XMPCrd\SaturationAdjustmentYellow(),
                'Shadows' => new \PHPExiftool\Driver\Tag\XMPCrd\Shadows(),
                'Shadows2012' => new \PHPExiftool\Driver\Tag\XMPCrd\Shadows2012(),
                'ShadowTint' => new \PHPExiftool\Driver\Tag\XMPCrd\ShadowTint(),
                'SharpenDetail' => new \PHPExiftool\Driver\Tag\XMPCrd\SharpenDetail(),
                'SharpenEdgeMasking' => new \PHPExiftool\Driver\Tag\XMPCrd\SharpenEdgeMasking(),
                'SharpenRadius' => new \PHPExiftool\Driver\Tag\XMPCrd\SharpenRadius(),
                'Sharpness' => new \PHPExiftool\Driver\Tag\XMPCrd\Sharpness(),
                'Smoothness' => new \PHPExiftool\Driver\Tag\XMPCrd\Smoothness(),
                'SplitToningBalance' => new \PHPExiftool\Driver\Tag\XMPCrd\SplitToningBalance(),
                'SplitToningHighlightHue' => new \PHPExiftool\Driver\Tag\XMPCrd\SplitToningHighlightHue(),
                'SplitToningHighlightSaturation' => new \PHPExiftool\Driver\Tag\XMPCrd\SplitToningHighlightSaturation(),
                'SplitToningShadowHue' => new \PHPExiftool\Driver\Tag\XMPCrd\SplitToningShadowHue(),
                'SplitToningShadowSaturation' => new \PHPExiftool\Driver\Tag\XMPCrd\SplitToningShadowSaturation(),
                'ColorTemperature' => new \PHPExiftool\Driver\Tag\XMPCrd\ColorTemperature(),
                'Texture' => new \PHPExiftool\Driver\Tag\XMPCrd\Texture(),
                'TIFFHandling' => new \PHPExiftool\Driver\Tag\XMPCrd\TIFFHandling(),
                'Tint' => new \PHPExiftool\Driver\Tag\XMPCrd\Tint(),
                'ToneCurve' => new \PHPExiftool\Driver\Tag\XMPCrd\ToneCurve(),
                'ToneCurveBlue' => new \PHPExiftool\Driver\Tag\XMPCrd\ToneCurveBlue(),
                'ToneCurveGreen' => new \PHPExiftool\Driver\Tag\XMPCrd\ToneCurveGreen(),
                'ToneCurveName' => new \PHPExiftool\Driver\Tag\XMPCrd\ToneCurveName(),
                'ToneCurveName2012' => new \PHPExiftool\Driver\Tag\XMPCrd\ToneCurveName2012(),
                'ToneCurvePV2012' => new \PHPExiftool\Driver\Tag\XMPCrd\ToneCurvePV2012(),
                'ToneCurvePV2012Blue' => new \PHPExiftool\Driver\Tag\XMPCrd\ToneCurvePV2012Blue(),
                'ToneCurvePV2012Green' => new \PHPExiftool\Driver\Tag\XMPCrd\ToneCurvePV2012Green(),
                'ToneCurvePV2012Red' => new \PHPExiftool\Driver\Tag\XMPCrd\ToneCurvePV2012Red(),
                'ToneCurveRed' => new \PHPExiftool\Driver\Tag\XMPCrd\ToneCurveRed(),
                'ToneMapStrength' => new \PHPExiftool\Driver\Tag\XMPCrd\ToneMapStrength(),
                'UprightCenterMode' => new \PHPExiftool\Driver\Tag\XMPCrd\UprightCenterMode(),
                'UprightCenterNormX' => new \PHPExiftool\Driver\Tag\XMPCrd\UprightCenterNormX(),
                'UprightCenterNormY' => new \PHPExiftool\Driver\Tag\XMPCrd\UprightCenterNormY(),
                'UprightDependentDigest' => new \PHPExiftool\Driver\Tag\XMPCrd\UprightDependentDigest(),
                'UprightFocalLength35mm' => new \PHPExiftool\Driver\Tag\XMPCrd\UprightFocalLength35mm(),
                'UprightFocalMode' => new \PHPExiftool\Driver\Tag\XMPCrd\UprightFocalMode(),
                'UprightFourSegmentsCount' => new \PHPExiftool\Driver\Tag\XMPCrd\UprightFourSegmentsCount(),
                'UprightPreview' => new \PHPExiftool\Driver\Tag\XMPCrd\UprightPreview(),
                'UprightTransform_0' => new \PHPExiftool\Driver\Tag\XMPCrd\UprightTransform0(),
                'UprightTransform_1' => new \PHPExiftool\Driver\Tag\XMPCrd\UprightTransform1(),
                'UprightTransform_2' => new \PHPExiftool\Driver\Tag\XMPCrd\UprightTransform2(),
                'UprightTransform_3' => new \PHPExiftool\Driver\Tag\XMPCrd\UprightTransform3(),
                'UprightTransform_4' => new \PHPExiftool\Driver\Tag\XMPCrd\UprightTransform4(),
                'UprightTransform_5' => new \PHPExiftool\Driver\Tag\XMPCrd\UprightTransform5(),
                'UprightTransformCount' => new \PHPExiftool\Driver\Tag\XMPCrd\UprightTransformCount(),
                'UprightVersion' => new \PHPExiftool\Driver\Tag\XMPCrd\UprightVersion(),
                'Version' => new \PHPExiftool\Driver\Tag\XMPCrd\Version(),
                'Vibrance' => new \PHPExiftool\Driver\Tag\XMPCrd\Vibrance(),
                'VignetteAmount' => new \PHPExiftool\Driver\Tag\XMPCrd\VignetteAmount(),
                'VignetteMidpoint' => new \PHPExiftool\Driver\Tag\XMPCrd\VignetteMidpoint(),
                'What' => new \PHPExiftool\Driver\Tag\XMPCrd\What(),
                'WhiteBalance' => new \PHPExiftool\Driver\Tag\XMPCrd\WhiteBalance(),
                'Whites2012' => new \PHPExiftool\Driver\Tag\XMPCrd\Whites2012(),
            );
        });
        $this['XMP-creatorAtom'] = $this->share(function(){
            return array(
                'AeProjectLink' => new \PHPExiftool\Driver\Tag\XMPCreatorAtom\AeProjectLink(),
                'AeProjectLinkCompositionID' => new \PHPExiftool\Driver\Tag\XMPCreatorAtom\AeProjectLinkCompositionID(),
                'AeProjectLinkFullPath' => new \PHPExiftool\Driver\Tag\XMPCreatorAtom\AeProjectLinkFullPath(),
                'AeProjectLinkRenderOutputModuleIndex' => new \PHPExiftool\Driver\Tag\XMPCreatorAtom\AeProjectLinkRenderOutputModuleIndex(),
                'AeProjectLinkRenderQueueItemID' => new \PHPExiftool\Driver\Tag\XMPCreatorAtom\AeProjectLinkRenderQueueItemID(),
                'AeProjectLinkRenderTimeStamp' => new \PHPExiftool\Driver\Tag\XMPCreatorAtom\AeProjectLinkRenderTimeStamp(),
                'MacAtom' => new \PHPExiftool\Driver\Tag\XMPCreatorAtom\MacAtom(),
                'MacAtomApplicationCode' => new \PHPExiftool\Driver\Tag\XMPCreatorAtom\MacAtomApplicationCode(),
                'MacAtomInvocationAppleEvent' => new \PHPExiftool\Driver\Tag\XMPCreatorAtom\MacAtomInvocationAppleEvent(),
                'MacAtomPosixProjectPath' => new \PHPExiftool\Driver\Tag\XMPCreatorAtom\MacAtomPosixProjectPath(),
                'WindowsAtom' => new \PHPExiftool\Driver\Tag\XMPCreatorAtom\WindowsAtom(),
                'WindowsAtomExtension' => new \PHPExiftool\Driver\Tag\XMPCreatorAtom\WindowsAtomExtension(),
                'WindowsAtomInvocationFlags' => new \PHPExiftool\Driver\Tag\XMPCreatorAtom\WindowsAtomInvocationFlags(),
                'WindowsAtomUncProjectPath' => new \PHPExiftool\Driver\Tag\XMPCreatorAtom\WindowsAtomUncProjectPath(),
            );
        });
        $this['XMP-crs'] = $this->share(function(){
            return array(
                'AlreadyApplied' => new \PHPExiftool\Driver\Tag\XMPCrs\AlreadyApplied(),
                'AutoBrightness' => new \PHPExiftool\Driver\Tag\XMPCrs\AutoBrightness(),
                'AutoContrast' => new \PHPExiftool\Driver\Tag\XMPCrs\AutoContrast(),
                'AutoExposure' => new \PHPExiftool\Driver\Tag\XMPCrs\AutoExposure(),
                'AutoLateralCA' => new \PHPExiftool\Driver\Tag\XMPCrs\AutoLateralCA(),
                'AutoShadows' => new \PHPExiftool\Driver\Tag\XMPCrs\AutoShadows(),
                'AutoTone' => new \PHPExiftool\Driver\Tag\XMPCrs\AutoTone(),
                'AutoWhiteVersion' => new \PHPExiftool\Driver\Tag\XMPCrs\AutoWhiteVersion(),
                'Blacks2012' => new \PHPExiftool\Driver\Tag\XMPCrs\Blacks2012(),
                'BlueHue' => new \PHPExiftool\Driver\Tag\XMPCrs\BlueHue(),
                'BlueSaturation' => new \PHPExiftool\Driver\Tag\XMPCrs\BlueSaturation(),
                'Brightness' => new \PHPExiftool\Driver\Tag\XMPCrs\Brightness(),
                'CameraProfile' => new \PHPExiftool\Driver\Tag\XMPCrs\CameraProfile(),
                'CameraProfileDigest' => new \PHPExiftool\Driver\Tag\XMPCrs\CameraProfileDigest(),
                'ChromaticAberrationB' => new \PHPExiftool\Driver\Tag\XMPCrs\ChromaticAberrationB(),
                'ChromaticAberrationR' => new \PHPExiftool\Driver\Tag\XMPCrs\ChromaticAberrationR(),
                'CircularGradientBasedCorrections' => new \PHPExiftool\Driver\Tag\XMPCrs\CircularGradientBasedCorrections(),
                'CircGradBasedCorrActive' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrActive(),
                'CircGradBasedCorrAmount' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrAmount(),
                'CircGradBasedCorrMasks' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMasks(),
                'CircGradBasedCorrMaskAlpha' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskAlpha(),
                'CircGradBasedCorrMaskAngle' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskAngle(),
                'CircGradBasedCorrMaskBottom' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskBottom(),
                'CircGradBasedCorrMaskCenterValue' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskCenterValue(),
                'CircGradBasedCorrMaskCenterWeight' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskCenterWeight(),
                'CircGradBasedCorrMaskDabs' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskDabs(),
                'CircGradBasedCorrMaskFeather' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskFeather(),
                'CircGradBasedCorrMaskFlipped' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskFlipped(),
                'CircGradBasedCorrMaskFlow' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskFlow(),
                'CircGradBasedCorrMaskFullX' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskFullX(),
                'CircGradBasedCorrMaskFullY' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskFullY(),
                'CircGradBasedCorrMaskLeft' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskLeft(),
                'CircGradBasedCorrMaskValue' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskValue(),
                'CircGradBasedCorrMaskMidpoint' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskMidpoint(),
                'CircGradBasedCorrMaskPerimeterValue' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskPerimeterValue(),
                'CircGradBasedCorrMaskRadius' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskRadius(),
                'CircGradBasedCorrMaskRight' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskRight(),
                'CircGradBasedCorrMaskRoundness' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskRoundness(),
                'CircGradBasedCorrMaskSizeX' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskSizeX(),
                'CircGradBasedCorrMaskSizeY' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskSizeY(),
                'CircGradBasedCorrMaskTop' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskTop(),
                'CircGradBasedCorrMaskVersion' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskVersion(),
                'CircGradBasedCorrMaskWhat' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskWhat(),
                'CircGradBasedCorrMaskX' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskX(),
                'CircGradBasedCorrMaskY' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskY(),
                'CircGradBasedCorrMaskZeroX' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskZeroX(),
                'CircGradBasedCorrMaskZeroY' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskZeroY(),
                'CircGradBasedCorrBrightness' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrBrightness(),
                'CircGradBasedCorrClarity' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrClarity(),
                'CircGradBasedCorrClarity2012' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrClarity2012(),
                'CircGradBasedCorrContrast' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrContrast(),
                'CircGradBasedCorrContrast2012' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrContrast2012(),
                'CircGradBasedCorrDefringe' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrDefringe(),
                'CircGradBasedCorrExposure' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrExposure(),
                'CircGradBasedCorrExposure2012' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrExposure2012(),
                'CircGradBasedCorrHighlights2012' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrHighlights2012(),
                'CircGradBasedCorrLuminanceNoise' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrLuminanceNoise(),
                'CircGradBasedCorrMoire' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMoire(),
                'CircGradBasedCorrSaturation' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrSaturation(),
                'CircGradBasedCorrShadows2012' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrShadows2012(),
                'CircGradBasedCorrSharpness' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrSharpness(),
                'CircGradBasedCorrTemperature' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrTemperature(),
                'CircGradBasedCorrTint' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrTint(),
                'CircGradBasedCorrHue' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrHue(),
                'CircGradBasedCorrWhat' => new \PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrWhat(),
                'Clarity' => new \PHPExiftool\Driver\Tag\XMPCrs\Clarity(),
                'Clarity2012' => new \PHPExiftool\Driver\Tag\XMPCrs\Clarity2012(),
                'ColorNoiseReduction' => new \PHPExiftool\Driver\Tag\XMPCrs\ColorNoiseReduction(),
                'ColorNoiseReductionDetail' => new \PHPExiftool\Driver\Tag\XMPCrs\ColorNoiseReductionDetail(),
                'ColorNoiseReductionSmoothness' => new \PHPExiftool\Driver\Tag\XMPCrs\ColorNoiseReductionSmoothness(),
                'Contrast' => new \PHPExiftool\Driver\Tag\XMPCrs\Contrast(),
                'Contrast2012' => new \PHPExiftool\Driver\Tag\XMPCrs\Contrast2012(),
                'Converter' => new \PHPExiftool\Driver\Tag\XMPCrs\Converter(),
                'ConvertToGrayscale' => new \PHPExiftool\Driver\Tag\XMPCrs\ConvertToGrayscale(),
                'CropAngle' => new \PHPExiftool\Driver\Tag\XMPCrs\CropAngle(),
                'CropBottom' => new \PHPExiftool\Driver\Tag\XMPCrs\CropBottom(),
                'CropConstrainToWarp' => new \PHPExiftool\Driver\Tag\XMPCrs\CropConstrainToWarp(),
                'CropHeight' => new \PHPExiftool\Driver\Tag\XMPCrs\CropHeight(),
                'CropLeft' => new \PHPExiftool\Driver\Tag\XMPCrs\CropLeft(),
                'CropRight' => new \PHPExiftool\Driver\Tag\XMPCrs\CropRight(),
                'CropTop' => new \PHPExiftool\Driver\Tag\XMPCrs\CropTop(),
                'CropUnit' => new \PHPExiftool\Driver\Tag\XMPCrs\CropUnit(),
                'CropUnits' => new \PHPExiftool\Driver\Tag\XMPCrs\CropUnits(),
                'CropWidth' => new \PHPExiftool\Driver\Tag\XMPCrs\CropWidth(),
                'DefaultAutoGray' => new \PHPExiftool\Driver\Tag\XMPCrs\DefaultAutoGray(),
                'DefaultAutoTone' => new \PHPExiftool\Driver\Tag\XMPCrs\DefaultAutoTone(),
                'DefaultsSpecificToISO' => new \PHPExiftool\Driver\Tag\XMPCrs\DefaultsSpecificToISO(),
                'DefaultsSpecificToSerial' => new \PHPExiftool\Driver\Tag\XMPCrs\DefaultsSpecificToSerial(),
                'Defringe' => new \PHPExiftool\Driver\Tag\XMPCrs\Defringe(),
                'DefringeGreenAmount' => new \PHPExiftool\Driver\Tag\XMPCrs\DefringeGreenAmount(),
                'DefringeGreenHueHi' => new \PHPExiftool\Driver\Tag\XMPCrs\DefringeGreenHueHi(),
                'DefringeGreenHueLo' => new \PHPExiftool\Driver\Tag\XMPCrs\DefringeGreenHueLo(),
                'DefringePurpleAmount' => new \PHPExiftool\Driver\Tag\XMPCrs\DefringePurpleAmount(),
                'DefringePurpleHueHi' => new \PHPExiftool\Driver\Tag\XMPCrs\DefringePurpleHueHi(),
                'DefringePurpleHueLo' => new \PHPExiftool\Driver\Tag\XMPCrs\DefringePurpleHueLo(),
                'Dehaze' => new \PHPExiftool\Driver\Tag\XMPCrs\Dehaze(),
                'DNGIgnoreSidecars' => new \PHPExiftool\Driver\Tag\XMPCrs\DNGIgnoreSidecars(),
                'Exposure' => new \PHPExiftool\Driver\Tag\XMPCrs\Exposure(),
                'Exposure2012' => new \PHPExiftool\Driver\Tag\XMPCrs\Exposure2012(),
                'FillLight' => new \PHPExiftool\Driver\Tag\XMPCrs\FillLight(),
                'GradientBasedCorrections' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrections(),
                'GradientBasedCorrActive' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrActive(),
                'GradientBasedCorrAmount' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrAmount(),
                'GradientBasedCorrMasks' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMasks(),
                'GradientBasedCorrMaskAlpha' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskAlpha(),
                'GradientBasedCorrMaskAngle' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskAngle(),
                'GradientBasedCorrMaskBottom' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskBottom(),
                'GradientBasedCorrMaskCenterValue' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskCenterValue(),
                'GradientBasedCorrMaskCenterWeight' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskCenterWeight(),
                'GradientBasedCorrMaskDabs' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskDabs(),
                'GradientBasedCorrMaskFeather' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskFeather(),
                'GradientBasedCorrMaskFlipped' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskFlipped(),
                'GradientBasedCorrMaskFlow' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskFlow(),
                'GradientBasedCorrMaskFullX' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskFullX(),
                'GradientBasedCorrMaskFullY' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskFullY(),
                'GradientBasedCorrMaskLeft' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskLeft(),
                'GradientBasedCorrMaskValue' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskValue(),
                'GradientBasedCorrMaskMidpoint' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskMidpoint(),
                'GradientBasedCorrMaskPerimeterValue' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskPerimeterValue(),
                'GradientBasedCorrMaskRadius' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskRadius(),
                'GradientBasedCorrMaskRight' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskRight(),
                'GradientBasedCorrMaskRoundness' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskRoundness(),
                'GradientBasedCorrMaskSizeX' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskSizeX(),
                'GradientBasedCorrMaskSizeY' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskSizeY(),
                'GradientBasedCorrMaskTop' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskTop(),
                'GradientBasedCorrMaskVersion' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskVersion(),
                'GradientBasedCorrMaskWhat' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskWhat(),
                'GradientBasedCorrMaskX' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskX(),
                'GradientBasedCorrMaskY' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskY(),
                'GradientBasedCorrMaskZeroX' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskZeroX(),
                'GradientBasedCorrMaskZeroY' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskZeroY(),
                'GradientBasedCorrBrightness' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrBrightness(),
                'GradientBasedCorrClarity' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrClarity(),
                'GradientBasedCorrClarity2012' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrClarity2012(),
                'GradientBasedCorrContrast' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrContrast(),
                'GradientBasedCorrContrast2012' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrContrast2012(),
                'GradientBasedCorrDefringe' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrDefringe(),
                'GradientBasedCorrExposure' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrExposure(),
                'GradientBasedCorrExposure2012' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrExposure2012(),
                'GradientBasedCorrHighlights2012' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrHighlights2012(),
                'GradientBasedCorrLuminanceNoise' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrLuminanceNoise(),
                'GradientBasedCorrMoire' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMoire(),
                'GradientBasedCorrSaturation' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrSaturation(),
                'GradientBasedCorrShadows2012' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrShadows2012(),
                'GradientBasedCorrSharpness' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrSharpness(),
                'GradientBasedCorrTemperature' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrTemperature(),
                'GradientBasedCorrTint' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrTint(),
                'GradientBasedCorrHue' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrHue(),
                'GradientBasedCorrWhat' => new \PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrWhat(),
                'GrainAmount' => new \PHPExiftool\Driver\Tag\XMPCrs\GrainAmount(),
                'GrainFrequency' => new \PHPExiftool\Driver\Tag\XMPCrs\GrainFrequency(),
                'GrainSize' => new \PHPExiftool\Driver\Tag\XMPCrs\GrainSize(),
                'GrayMixerAqua' => new \PHPExiftool\Driver\Tag\XMPCrs\GrayMixerAqua(),
                'GrayMixerBlue' => new \PHPExiftool\Driver\Tag\XMPCrs\GrayMixerBlue(),
                'GrayMixerGreen' => new \PHPExiftool\Driver\Tag\XMPCrs\GrayMixerGreen(),
                'GrayMixerMagenta' => new \PHPExiftool\Driver\Tag\XMPCrs\GrayMixerMagenta(),
                'GrayMixerOrange' => new \PHPExiftool\Driver\Tag\XMPCrs\GrayMixerOrange(),
                'GrayMixerPurple' => new \PHPExiftool\Driver\Tag\XMPCrs\GrayMixerPurple(),
                'GrayMixerRed' => new \PHPExiftool\Driver\Tag\XMPCrs\GrayMixerRed(),
                'GrayMixerYellow' => new \PHPExiftool\Driver\Tag\XMPCrs\GrayMixerYellow(),
                'GreenHue' => new \PHPExiftool\Driver\Tag\XMPCrs\GreenHue(),
                'GreenSaturation' => new \PHPExiftool\Driver\Tag\XMPCrs\GreenSaturation(),
                'HasCrop' => new \PHPExiftool\Driver\Tag\XMPCrs\HasCrop(),
                'HasSettings' => new \PHPExiftool\Driver\Tag\XMPCrs\HasSettings(),
                'Highlight2012' => new \PHPExiftool\Driver\Tag\XMPCrs\Highlight2012(),
                'HighlightRecovery' => new \PHPExiftool\Driver\Tag\XMPCrs\HighlightRecovery(),
                'Highlights2012' => new \PHPExiftool\Driver\Tag\XMPCrs\Highlights2012(),
                'HueAdjustmentAqua' => new \PHPExiftool\Driver\Tag\XMPCrs\HueAdjustmentAqua(),
                'HueAdjustmentBlue' => new \PHPExiftool\Driver\Tag\XMPCrs\HueAdjustmentBlue(),
                'HueAdjustmentGreen' => new \PHPExiftool\Driver\Tag\XMPCrs\HueAdjustmentGreen(),
                'HueAdjustmentMagenta' => new \PHPExiftool\Driver\Tag\XMPCrs\HueAdjustmentMagenta(),
                'HueAdjustmentOrange' => new \PHPExiftool\Driver\Tag\XMPCrs\HueAdjustmentOrange(),
                'HueAdjustmentPurple' => new \PHPExiftool\Driver\Tag\XMPCrs\HueAdjustmentPurple(),
                'HueAdjustmentRed' => new \PHPExiftool\Driver\Tag\XMPCrs\HueAdjustmentRed(),
                'HueAdjustmentYellow' => new \PHPExiftool\Driver\Tag\XMPCrs\HueAdjustmentYellow(),
                'IncrementalTemperature' => new \PHPExiftool\Driver\Tag\XMPCrs\IncrementalTemperature(),
                'IncrementalTint' => new \PHPExiftool\Driver\Tag\XMPCrs\IncrementalTint(),
                'JPEGHandling' => new \PHPExiftool\Driver\Tag\XMPCrs\JPEGHandling(),
                'LensManualDistortionAmount' => new \PHPExiftool\Driver\Tag\XMPCrs\LensManualDistortionAmount(),
                'LensProfileChromaticAberrationScale' => new \PHPExiftool\Driver\Tag\XMPCrs\LensProfileChromaticAberrationScale(),
                'LensProfileDigest' => new \PHPExiftool\Driver\Tag\XMPCrs\LensProfileDigest(),
                'LensProfileDistortionScale' => new \PHPExiftool\Driver\Tag\XMPCrs\LensProfileDistortionScale(),
                'LensProfileEnable' => new \PHPExiftool\Driver\Tag\XMPCrs\LensProfileEnable(),
                'LensProfileFilename' => new \PHPExiftool\Driver\Tag\XMPCrs\LensProfileFilename(),
                'LensProfileMatchKeyCameraModelName' => new \PHPExiftool\Driver\Tag\XMPCrs\LensProfileMatchKeyCameraModelName(),
                'LensProfileMatchKeyExifMake' => new \PHPExiftool\Driver\Tag\XMPCrs\LensProfileMatchKeyExifMake(),
                'LensProfileMatchKeyExifModel' => new \PHPExiftool\Driver\Tag\XMPCrs\LensProfileMatchKeyExifModel(),
                'LensProfileMatchKeyIsRaw' => new \PHPExiftool\Driver\Tag\XMPCrs\LensProfileMatchKeyIsRaw(),
                'LensProfileMatchKeyLensID' => new \PHPExiftool\Driver\Tag\XMPCrs\LensProfileMatchKeyLensID(),
                'LensProfileMatchKeyLensInfo' => new \PHPExiftool\Driver\Tag\XMPCrs\LensProfileMatchKeyLensInfo(),
                'LensProfileMatchKeyLensName' => new \PHPExiftool\Driver\Tag\XMPCrs\LensProfileMatchKeyLensName(),
                'LensProfileMatchKeySensorFormatFactor' => new \PHPExiftool\Driver\Tag\XMPCrs\LensProfileMatchKeySensorFormatFactor(),
                'LensProfileName' => new \PHPExiftool\Driver\Tag\XMPCrs\LensProfileName(),
                'LensProfileSetup' => new \PHPExiftool\Driver\Tag\XMPCrs\LensProfileSetup(),
                'LensProfileVignettingScale' => new \PHPExiftool\Driver\Tag\XMPCrs\LensProfileVignettingScale(),
                'Look' => new \PHPExiftool\Driver\Tag\XMPCrs\Look(),
                'LookName' => new \PHPExiftool\Driver\Tag\XMPCrs\LookName(),
                'LuminanceAdjustmentAqua' => new \PHPExiftool\Driver\Tag\XMPCrs\LuminanceAdjustmentAqua(),
                'LuminanceAdjustmentBlue' => new \PHPExiftool\Driver\Tag\XMPCrs\LuminanceAdjustmentBlue(),
                'LuminanceAdjustmentGreen' => new \PHPExiftool\Driver\Tag\XMPCrs\LuminanceAdjustmentGreen(),
                'LuminanceAdjustmentMagenta' => new \PHPExiftool\Driver\Tag\XMPCrs\LuminanceAdjustmentMagenta(),
                'LuminanceAdjustmentOrange' => new \PHPExiftool\Driver\Tag\XMPCrs\LuminanceAdjustmentOrange(),
                'LuminanceAdjustmentPurple' => new \PHPExiftool\Driver\Tag\XMPCrs\LuminanceAdjustmentPurple(),
                'LuminanceAdjustmentRed' => new \PHPExiftool\Driver\Tag\XMPCrs\LuminanceAdjustmentRed(),
                'LuminanceAdjustmentYellow' => new \PHPExiftool\Driver\Tag\XMPCrs\LuminanceAdjustmentYellow(),
                'LuminanceNoiseReductionContrast' => new \PHPExiftool\Driver\Tag\XMPCrs\LuminanceNoiseReductionContrast(),
                'LuminanceNoiseReductionDetail' => new \PHPExiftool\Driver\Tag\XMPCrs\LuminanceNoiseReductionDetail(),
                'LuminanceSmoothing' => new \PHPExiftool\Driver\Tag\XMPCrs\LuminanceSmoothing(),
                'MoireFilter' => new \PHPExiftool\Driver\Tag\XMPCrs\MoireFilter(),
                'NegativeCacheLargePreviewSize' => new \PHPExiftool\Driver\Tag\XMPCrs\NegativeCacheLargePreviewSize(),
                'NegativeCacheMaximumSize' => new \PHPExiftool\Driver\Tag\XMPCrs\NegativeCacheMaximumSize(),
                'NegativeCachePath' => new \PHPExiftool\Driver\Tag\XMPCrs\NegativeCachePath(),
                'OverrideLookVignette' => new \PHPExiftool\Driver\Tag\XMPCrs\OverrideLookVignette(),
                'PaintBasedCorrections' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintBasedCorrections(),
                'PaintCorrectionActive' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionActive(),
                'PaintCorrectionAmount' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionAmount(),
                'PaintBasedCorrectionMasks' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintBasedCorrectionMasks(),
                'PaintCorrectionMaskAlpha' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskAlpha(),
                'PaintCorrectionMaskAngle' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskAngle(),
                'PaintCorrectionMaskBottom' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskBottom(),
                'PaintCorrectionMaskCenterValue' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskCenterValue(),
                'PaintCorrectionMaskCenterWeight' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskCenterWeight(),
                'PaintCorrectionMaskDabs' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskDabs(),
                'PaintCorrectionMaskFeather' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskFeather(),
                'PaintCorrectionMaskFlipped' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskFlipped(),
                'PaintCorrectionMaskFlow' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskFlow(),
                'PaintCorrectionMaskFullX' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskFullX(),
                'PaintCorrectionMaskFullY' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskFullY(),
                'PaintCorrectionMaskLeft' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskLeft(),
                'PaintCorrectionMaskValue' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskValue(),
                'PaintCorrectionMaskMidpoint' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskMidpoint(),
                'PaintCorrectionMaskPerimeterValue' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskPerimeterValue(),
                'PaintCorrectionMaskRadius' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskRadius(),
                'PaintCorrectionMaskRight' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskRight(),
                'PaintCorrectionMaskRoundness' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskRoundness(),
                'PaintCorrectionMaskSizeX' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskSizeX(),
                'PaintCorrectionMaskSizeY' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskSizeY(),
                'PaintCorrectionMaskTop' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskTop(),
                'PaintCorrectionMaskVersion' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskVersion(),
                'PaintCorrectionMaskWhat' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskWhat(),
                'PaintCorrectionMaskX' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskX(),
                'PaintCorrectionMaskY' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskY(),
                'PaintCorrectionMaskZeroX' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskZeroX(),
                'PaintCorrectionMaskZeroY' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskZeroY(),
                'PaintCorrectionBrightness' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionBrightness(),
                'PaintCorrectionClarity' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionClarity(),
                'PaintCorrectionClarity2012' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionClarity2012(),
                'PaintCorrectionContrast' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionContrast(),
                'PaintCorrectionContrast2012' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionContrast2012(),
                'PaintCorrectionDefringe' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionDefringe(),
                'PaintCorrectionExposure' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionExposure(),
                'PaintCorrectionExposure2012' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionExposure2012(),
                'PaintCorrectionHighlights2012' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionHighlights2012(),
                'PaintCorrectionLuminanceNoise' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionLuminanceNoise(),
                'PaintCorrectionMoire' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMoire(),
                'PaintCorrectionSaturation' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionSaturation(),
                'PaintCorrectionShadows2012' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionShadows2012(),
                'PaintCorrectionSharpness' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionSharpness(),
                'PaintCorrectionTemperature' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionTemperature(),
                'PaintCorrectionTint' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionTint(),
                'PaintCorrectionHue' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionHue(),
                'PaintCorrectionWhat' => new \PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionWhat(),
                'ParametricDarks' => new \PHPExiftool\Driver\Tag\XMPCrs\ParametricDarks(),
                'ParametricHighlights' => new \PHPExiftool\Driver\Tag\XMPCrs\ParametricHighlights(),
                'ParametricHighlightSplit' => new \PHPExiftool\Driver\Tag\XMPCrs\ParametricHighlightSplit(),
                'ParametricLights' => new \PHPExiftool\Driver\Tag\XMPCrs\ParametricLights(),
                'ParametricMidtoneSplit' => new \PHPExiftool\Driver\Tag\XMPCrs\ParametricMidtoneSplit(),
                'ParametricShadows' => new \PHPExiftool\Driver\Tag\XMPCrs\ParametricShadows(),
                'ParametricShadowSplit' => new \PHPExiftool\Driver\Tag\XMPCrs\ParametricShadowSplit(),
                'PerspectiveAspect' => new \PHPExiftool\Driver\Tag\XMPCrs\PerspectiveAspect(),
                'PerspectiveHorizontal' => new \PHPExiftool\Driver\Tag\XMPCrs\PerspectiveHorizontal(),
                'PerspectiveRotate' => new \PHPExiftool\Driver\Tag\XMPCrs\PerspectiveRotate(),
                'PerspectiveScale' => new \PHPExiftool\Driver\Tag\XMPCrs\PerspectiveScale(),
                'PerspectiveUpright' => new \PHPExiftool\Driver\Tag\XMPCrs\PerspectiveUpright(),
                'PerspectiveVertical' => new \PHPExiftool\Driver\Tag\XMPCrs\PerspectiveVertical(),
                'PerspectiveX' => new \PHPExiftool\Driver\Tag\XMPCrs\PerspectiveX(),
                'PerspectiveY' => new \PHPExiftool\Driver\Tag\XMPCrs\PerspectiveY(),
                'PostCropVignetteAmount' => new \PHPExiftool\Driver\Tag\XMPCrs\PostCropVignetteAmount(),
                'PostCropVignetteFeather' => new \PHPExiftool\Driver\Tag\XMPCrs\PostCropVignetteFeather(),
                'PostCropVignetteHighlightContrast' => new \PHPExiftool\Driver\Tag\XMPCrs\PostCropVignetteHighlightContrast(),
                'PostCropVignetteMidpoint' => new \PHPExiftool\Driver\Tag\XMPCrs\PostCropVignetteMidpoint(),
                'PostCropVignetteRoundness' => new \PHPExiftool\Driver\Tag\XMPCrs\PostCropVignetteRoundness(),
                'PostCropVignetteStyle' => new \PHPExiftool\Driver\Tag\XMPCrs\PostCropVignetteStyle(),
                'ProcessVersion' => new \PHPExiftool\Driver\Tag\XMPCrs\ProcessVersion(),
                'RawFileName' => new \PHPExiftool\Driver\Tag\XMPCrs\RawFileName(),
                'RedEyeInfo' => new \PHPExiftool\Driver\Tag\XMPCrs\RedEyeInfo(),
                'RedHue' => new \PHPExiftool\Driver\Tag\XMPCrs\RedHue(),
                'RedSaturation' => new \PHPExiftool\Driver\Tag\XMPCrs\RedSaturation(),
                'RetouchAreas' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreas(),
                'RetouchAreaFeather' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaFeather(),
                'RetouchAreaMasks' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMasks(),
                'RetouchAreaMaskAlpha' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskAlpha(),
                'RetouchAreaMaskAngle' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskAngle(),
                'RetouchAreaMaskBottom' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskBottom(),
                'RetouchAreaMaskCenterValue' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskCenterValue(),
                'RetouchAreaMaskCenterWeight' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskCenterWeight(),
                'RetouchAreaMaskDabs' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskDabs(),
                'RetouchAreaMaskFeather' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskFeather(),
                'RetouchAreaMaskFlipped' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskFlipped(),
                'RetouchAreaMaskFlow' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskFlow(),
                'RetouchAreaMaskFullX' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskFullX(),
                'RetouchAreaMaskFullY' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskFullY(),
                'RetouchAreaMaskLeft' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskLeft(),
                'RetouchAreaMaskValue' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskValue(),
                'RetouchAreaMaskMidpoint' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskMidpoint(),
                'RetouchAreaMaskPerimeterValue' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskPerimeterValue(),
                'RetouchAreaMaskRadius' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskRadius(),
                'RetouchAreaMaskRight' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskRight(),
                'RetouchAreaMaskRoundness' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskRoundness(),
                'RetouchAreaMaskSizeX' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskSizeX(),
                'RetouchAreaMaskSizeY' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskSizeY(),
                'RetouchAreaMaskTop' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskTop(),
                'RetouchAreaMaskVersion' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskVersion(),
                'RetouchAreaMaskWhat' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskWhat(),
                'RetouchAreaMaskX' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskX(),
                'RetouchAreaMaskY' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskY(),
                'RetouchAreaMaskZeroX' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskZeroX(),
                'RetouchAreaMaskZeroY' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskZeroY(),
                'RetouchAreaMethod' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMethod(),
                'RetouchAreaOffsetY' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaOffsetY(),
                'RetouchAreaOpacity' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaOpacity(),
                'RetouchAreaSeed' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaSeed(),
                'RetouchAreaSourceState' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaSourceState(),
                'RetouchAreaSourceX' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaSourceX(),
                'RetouchAreaSpotType' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaSpotType(),
                'RetouchInfo' => new \PHPExiftool\Driver\Tag\XMPCrs\RetouchInfo(),
                'Saturation' => new \PHPExiftool\Driver\Tag\XMPCrs\Saturation(),
                'SaturationAdjustmentAqua' => new \PHPExiftool\Driver\Tag\XMPCrs\SaturationAdjustmentAqua(),
                'SaturationAdjustmentBlue' => new \PHPExiftool\Driver\Tag\XMPCrs\SaturationAdjustmentBlue(),
                'SaturationAdjustmentGreen' => new \PHPExiftool\Driver\Tag\XMPCrs\SaturationAdjustmentGreen(),
                'SaturationAdjustmentMagenta' => new \PHPExiftool\Driver\Tag\XMPCrs\SaturationAdjustmentMagenta(),
                'SaturationAdjustmentOrange' => new \PHPExiftool\Driver\Tag\XMPCrs\SaturationAdjustmentOrange(),
                'SaturationAdjustmentPurple' => new \PHPExiftool\Driver\Tag\XMPCrs\SaturationAdjustmentPurple(),
                'SaturationAdjustmentRed' => new \PHPExiftool\Driver\Tag\XMPCrs\SaturationAdjustmentRed(),
                'SaturationAdjustmentYellow' => new \PHPExiftool\Driver\Tag\XMPCrs\SaturationAdjustmentYellow(),
                'Shadows' => new \PHPExiftool\Driver\Tag\XMPCrs\Shadows(),
                'Shadows2012' => new \PHPExiftool\Driver\Tag\XMPCrs\Shadows2012(),
                'ShadowTint' => new \PHPExiftool\Driver\Tag\XMPCrs\ShadowTint(),
                'SharpenDetail' => new \PHPExiftool\Driver\Tag\XMPCrs\SharpenDetail(),
                'SharpenEdgeMasking' => new \PHPExiftool\Driver\Tag\XMPCrs\SharpenEdgeMasking(),
                'SharpenRadius' => new \PHPExiftool\Driver\Tag\XMPCrs\SharpenRadius(),
                'Sharpness' => new \PHPExiftool\Driver\Tag\XMPCrs\Sharpness(),
                'Smoothness' => new \PHPExiftool\Driver\Tag\XMPCrs\Smoothness(),
                'SplitToningBalance' => new \PHPExiftool\Driver\Tag\XMPCrs\SplitToningBalance(),
                'SplitToningHighlightHue' => new \PHPExiftool\Driver\Tag\XMPCrs\SplitToningHighlightHue(),
                'SplitToningHighlightSaturation' => new \PHPExiftool\Driver\Tag\XMPCrs\SplitToningHighlightSaturation(),
                'SplitToningShadowHue' => new \PHPExiftool\Driver\Tag\XMPCrs\SplitToningShadowHue(),
                'SplitToningShadowSaturation' => new \PHPExiftool\Driver\Tag\XMPCrs\SplitToningShadowSaturation(),
                'ColorTemperature' => new \PHPExiftool\Driver\Tag\XMPCrs\ColorTemperature(),
                'Texture' => new \PHPExiftool\Driver\Tag\XMPCrs\Texture(),
                'TIFFHandling' => new \PHPExiftool\Driver\Tag\XMPCrs\TIFFHandling(),
                'Tint' => new \PHPExiftool\Driver\Tag\XMPCrs\Tint(),
                'ToneCurve' => new \PHPExiftool\Driver\Tag\XMPCrs\ToneCurve(),
                'ToneCurveBlue' => new \PHPExiftool\Driver\Tag\XMPCrs\ToneCurveBlue(),
                'ToneCurveGreen' => new \PHPExiftool\Driver\Tag\XMPCrs\ToneCurveGreen(),
                'ToneCurveName' => new \PHPExiftool\Driver\Tag\XMPCrs\ToneCurveName(),
                'ToneCurveName2012' => new \PHPExiftool\Driver\Tag\XMPCrs\ToneCurveName2012(),
                'ToneCurvePV2012' => new \PHPExiftool\Driver\Tag\XMPCrs\ToneCurvePV2012(),
                'ToneCurvePV2012Blue' => new \PHPExiftool\Driver\Tag\XMPCrs\ToneCurvePV2012Blue(),
                'ToneCurvePV2012Green' => new \PHPExiftool\Driver\Tag\XMPCrs\ToneCurvePV2012Green(),
                'ToneCurvePV2012Red' => new \PHPExiftool\Driver\Tag\XMPCrs\ToneCurvePV2012Red(),
                'ToneCurveRed' => new \PHPExiftool\Driver\Tag\XMPCrs\ToneCurveRed(),
                'ToneMapStrength' => new \PHPExiftool\Driver\Tag\XMPCrs\ToneMapStrength(),
                'UprightCenterMode' => new \PHPExiftool\Driver\Tag\XMPCrs\UprightCenterMode(),
                'UprightCenterNormX' => new \PHPExiftool\Driver\Tag\XMPCrs\UprightCenterNormX(),
                'UprightCenterNormY' => new \PHPExiftool\Driver\Tag\XMPCrs\UprightCenterNormY(),
                'UprightDependentDigest' => new \PHPExiftool\Driver\Tag\XMPCrs\UprightDependentDigest(),
                'UprightFocalLength35mm' => new \PHPExiftool\Driver\Tag\XMPCrs\UprightFocalLength35mm(),
                'UprightFocalMode' => new \PHPExiftool\Driver\Tag\XMPCrs\UprightFocalMode(),
                'UprightFourSegmentsCount' => new \PHPExiftool\Driver\Tag\XMPCrs\UprightFourSegmentsCount(),
                'UprightPreview' => new \PHPExiftool\Driver\Tag\XMPCrs\UprightPreview(),
                'UprightTransform_0' => new \PHPExiftool\Driver\Tag\XMPCrs\UprightTransform0(),
                'UprightTransform_1' => new \PHPExiftool\Driver\Tag\XMPCrs\UprightTransform1(),
                'UprightTransform_2' => new \PHPExiftool\Driver\Tag\XMPCrs\UprightTransform2(),
                'UprightTransform_3' => new \PHPExiftool\Driver\Tag\XMPCrs\UprightTransform3(),
                'UprightTransform_4' => new \PHPExiftool\Driver\Tag\XMPCrs\UprightTransform4(),
                'UprightTransform_5' => new \PHPExiftool\Driver\Tag\XMPCrs\UprightTransform5(),
                'UprightTransformCount' => new \PHPExiftool\Driver\Tag\XMPCrs\UprightTransformCount(),
                'UprightVersion' => new \PHPExiftool\Driver\Tag\XMPCrs\UprightVersion(),
                'Version' => new \PHPExiftool\Driver\Tag\XMPCrs\Version(),
                'Vibrance' => new \PHPExiftool\Driver\Tag\XMPCrs\Vibrance(),
                'VignetteAmount' => new \PHPExiftool\Driver\Tag\XMPCrs\VignetteAmount(),
                'VignetteMidpoint' => new \PHPExiftool\Driver\Tag\XMPCrs\VignetteMidpoint(),
                'What' => new \PHPExiftool\Driver\Tag\XMPCrs\What(),
                'WhiteBalance' => new \PHPExiftool\Driver\Tag\XMPCrs\WhiteBalance(),
                'Whites2012' => new \PHPExiftool\Driver\Tag\XMPCrs\Whites2012(),
            );
        });
        $this['XMP-dc'] = $this->share(function(){
            return array(
                'Contributor' => new \PHPExiftool\Driver\Tag\XMPDc\Contributor(),
                'Coverage' => new \PHPExiftool\Driver\Tag\XMPDc\Coverage(),
                'Creator' => new \PHPExiftool\Driver\Tag\XMPDc\Creator(),
                'Date' => new \PHPExiftool\Driver\Tag\XMPDc\Date(),
                'Description' => new \PHPExiftool\Driver\Tag\XMPDc\Description(),
                'Format' => new \PHPExiftool\Driver\Tag\XMPDc\Format(),
                'Identifier' => new \PHPExiftool\Driver\Tag\XMPDc\Identifier(),
                'Language' => new \PHPExiftool\Driver\Tag\XMPDc\Language(),
                'Publisher' => new \PHPExiftool\Driver\Tag\XMPDc\Publisher(),
                'Relation' => new \PHPExiftool\Driver\Tag\XMPDc\Relation(),
                'Rights' => new \PHPExiftool\Driver\Tag\XMPDc\Rights(),
                'Source' => new \PHPExiftool\Driver\Tag\XMPDc\Source(),
                'Subject' => new \PHPExiftool\Driver\Tag\XMPDc\Subject(),
                'Title' => new \PHPExiftool\Driver\Tag\XMPDc\Title(),
                'Type' => new \PHPExiftool\Driver\Tag\XMPDc\Type(),
            );
        });
        $this['XMP-dex'] = $this->share(function(){
            return array(
                'CRC32' => new \PHPExiftool\Driver\Tag\XMPDex\CRC32(),
                'FFID' => new \PHPExiftool\Driver\Tag\XMPDex\FFID(),
                'LicenseType' => new \PHPExiftool\Driver\Tag\XMPDex\LicenseType(),
                'OS' => new \PHPExiftool\Driver\Tag\XMPDex\OS(),
                'Rating' => new \PHPExiftool\Driver\Tag\XMPDex\Rating(),
                'Revision' => new \PHPExiftool\Driver\Tag\XMPDex\Revision(),
                'ShortDescription' => new \PHPExiftool\Driver\Tag\XMPDex\ShortDescription(),
                'Source' => new \PHPExiftool\Driver\Tag\XMPDex\Source(),
            );
        });
        $this['XMP-digiKam'] = $this->share(function(){
            return array(
                'CaptionsAuthorNames' => new \PHPExiftool\Driver\Tag\XMPDigiKam\CaptionsAuthorNames(),
                'CaptionsDateTimeStamps' => new \PHPExiftool\Driver\Tag\XMPDigiKam\CaptionsDateTimeStamps(),
                'ColorLabel' => new \PHPExiftool\Driver\Tag\XMPDigiKam\ColorLabel(),
                'ImageHistory' => new \PHPExiftool\Driver\Tag\XMPDigiKam\ImageHistory(),
                'ImageUniqueID' => new \PHPExiftool\Driver\Tag\XMPDigiKam\ImageUniqueID(),
                'LensCorrectionSettings' => new \PHPExiftool\Driver\Tag\XMPDigiKam\LensCorrectionSettings(),
                'PickLabel' => new \PHPExiftool\Driver\Tag\XMPDigiKam\PickLabel(),
                'TagsList' => new \PHPExiftool\Driver\Tag\XMPDigiKam\TagsList(),
            );
        });
          
            
        $this['XMP-extensis'] = $this->share(function(){
            return array(
                'Approved' => new \PHPExiftool\Driver\Tag\XMPExtensis\Approved(),
                'ApprovedBy' => new \PHPExiftool\Driver\Tag\XMPExtensis\ApprovedBy(),
                'ClientName' => new \PHPExiftool\Driver\Tag\XMPExtensis\ClientName(),
                'JobName' => new \PHPExiftool\Driver\Tag\XMPExtensis\JobName(),
                'JobStatus' => new \PHPExiftool\Driver\Tag\XMPExtensis\JobStatus(),
                'RoutedTo' => new \PHPExiftool\Driver\Tag\XMPExtensis\RoutedTo(),
                'RoutingNotes' => new \PHPExiftool\Driver\Tag\XMPExtensis\RoutingNotes(),
                'WorkToDo' => new \PHPExiftool\Driver\Tag\XMPExtensis\WorkToDo(),
            );
        });
        $this['XMP-fpv'] = $this->share(function(){
            return array(
                'RichTextComment' => new \PHPExiftool\Driver\Tag\XMPFpv\RichTextComment(),
            );
        });
        $this['XMP-ics'] = $this->share(function(){
            return array(
                'AppVersion' => new \PHPExiftool\Driver\Tag\XMPIcs\AppVersion(),
                'ImageRef' => new \PHPExiftool\Driver\Tag\XMPIcs\ImageRef(),
                'SubVersions' => new \PHPExiftool\Driver\Tag\XMPIcs\SubVersions(),
                'SubVersionFileName' => new \PHPExiftool\Driver\Tag\XMPIcs\SubVersionFileName(),
                'SubVersionReference' => new \PHPExiftool\Driver\Tag\XMPIcs\SubVersionReference(),
                'TagStructure' => new \PHPExiftool\Driver\Tag\XMPIcs\TagStructure(),
                'LabelName1' => new \PHPExiftool\Driver\Tag\XMPIcs\LabelName1(),
                'ParentReference1' => new \PHPExiftool\Driver\Tag\XMPIcs\ParentReference1(),
                'Reference1' => new \PHPExiftool\Driver\Tag\XMPIcs\Reference1(),
                'SubLabels1' => new \PHPExiftool\Driver\Tag\XMPIcs\SubLabels1(),
                'LabelName2' => new \PHPExiftool\Driver\Tag\XMPIcs\LabelName2(),
                'ParentReference2' => new \PHPExiftool\Driver\Tag\XMPIcs\ParentReference2(),
                'Reference2' => new \PHPExiftool\Driver\Tag\XMPIcs\Reference2(),
                'SubLabels2' => new \PHPExiftool\Driver\Tag\XMPIcs\SubLabels2(),
                'LabelName3' => new \PHPExiftool\Driver\Tag\XMPIcs\LabelName3(),
                'ParentReference3' => new \PHPExiftool\Driver\Tag\XMPIcs\ParentReference3(),
                'Reference3' => new \PHPExiftool\Driver\Tag\XMPIcs\Reference3(),
                'SubLabels3' => new \PHPExiftool\Driver\Tag\XMPIcs\SubLabels3(),
                'LabelName4' => new \PHPExiftool\Driver\Tag\XMPIcs\LabelName4(),
                'ParentReference4' => new \PHPExiftool\Driver\Tag\XMPIcs\ParentReference4(),
                'Reference4' => new \PHPExiftool\Driver\Tag\XMPIcs\Reference4(),
                'SubLabels4' => new \PHPExiftool\Driver\Tag\XMPIcs\SubLabels4(),
                'LabelName5' => new \PHPExiftool\Driver\Tag\XMPIcs\LabelName5(),
                'ParentReference5' => new \PHPExiftool\Driver\Tag\XMPIcs\ParentReference5(),
                'Reference5' => new \PHPExiftool\Driver\Tag\XMPIcs\Reference5(),
                'SubLabels5' => new \PHPExiftool\Driver\Tag\XMPIcs\SubLabels5(),
                'LabelName6' => new \PHPExiftool\Driver\Tag\XMPIcs\LabelName6(),
                'ParentReference6' => new \PHPExiftool\Driver\Tag\XMPIcs\ParentReference6(),
                'Reference6' => new \PHPExiftool\Driver\Tag\XMPIcs\Reference6(),
                'TimeStamp' => new \PHPExiftool\Driver\Tag\XMPIcs\TimeStamp(),
            );
        });
        
            
        $this['XMP-iptcExt'] = $this->share(function(){
            return array(
                
                'RegistryID' => new \PHPExiftool\Driver\Tag\XMPIptcExt\RegistryID(),
                'RegistryEntryRole' => new \PHPExiftool\Driver\Tag\XMPIptcExt\RegistryEntryRole(),
                'RegistryItemID' => new \PHPExiftool\Driver\Tag\XMPIptcExt\RegistryItemID(),
                'RegistryOrganisationID' => new \PHPExiftool\Driver\Tag\XMPIptcExt\RegistryOrganisationID(),
                
            );
        });
        $this['XMP-pdf'] = $this->share(function(){
            return array(
                'Author' => new \PHPExiftool\Driver\Tag\XMPPdf\Author(),
                'Copyright' => new \PHPExiftool\Driver\Tag\XMPPdf\Copyright(),
                'CreationDate' => new \PHPExiftool\Driver\Tag\XMPPdf\CreationDate(),
                'Creator' => new \PHPExiftool\Driver\Tag\XMPPdf\Creator(),
                'Keywords' => new \PHPExiftool\Driver\Tag\XMPPdf\Keywords(),
                'Marked' => new \PHPExiftool\Driver\Tag\XMPPdf\Marked(),
                'ModDate' => new \PHPExiftool\Driver\Tag\XMPPdf\ModDate(),
                'PDFVersion' => new \PHPExiftool\Driver\Tag\XMPPdf\PDFVersion(),
                'Producer' => new \PHPExiftool\Driver\Tag\XMPPdf\Producer(),
                'Subject' => new \PHPExiftool\Driver\Tag\XMPPdf\Subject(),
                'Title' => new \PHPExiftool\Driver\Tag\XMPPdf\Title(),
                'Trapped' => new \PHPExiftool\Driver\Tag\XMPPdf\Trapped(),
            );
        });
        $this['XMP-photoshop'] = $this->share(function(){
            return array(
                'CaptionWriter' => new \PHPExiftool\Driver\Tag\XMPPhotoshop\CaptionWriter(),              
                'City' => new \PHPExiftool\Driver\Tag\XMPPhotoshop\City(),
                'Credit' => new \PHPExiftool\Driver\Tag\XMPPhotoshop\Credit(),
                'Headline' => new \PHPExiftool\Driver\Tag\XMPPhotoshop\Headline(),
                'Source' => new \PHPExiftool\Driver\Tag\XMPPhotoshop\Source(),               
            );
        });
        $this['XMP-pmi'] = $this->share(function(){
            return array(
                'Color' => new \PHPExiftool\Driver\Tag\XMPPmi\Color(),
                'ContactInfo' => new \PHPExiftool\Driver\Tag\XMPPmi\ContactInfo(),
                'DisplayName' => new \PHPExiftool\Driver\Tag\XMPPmi\DisplayName(),
                'DistributorProductID' => new \PHPExiftool\Driver\Tag\XMPPmi\DistributorProductID(),
                'EventAlias' => new \PHPExiftool\Driver\Tag\XMPPmi\EventAlias(),
                'EventEnd' => new \PHPExiftool\Driver\Tag\XMPPmi\EventEnd(),
                'EventStart' => new \PHPExiftool\Driver\Tag\XMPPmi\EventStart(),
                'EventSubtype' => new \PHPExiftool\Driver\Tag\XMPPmi\EventSubtype(),
                'EventType' => new \PHPExiftool\Driver\Tag\XMPPmi\EventType(),
                'Field' => new \PHPExiftool\Driver\Tag\XMPPmi\Field(),
                'Framing' => new \PHPExiftool\Driver\Tag\XMPPmi\Framing(),
                'Location' => new \PHPExiftool\Driver\Tag\XMPPmi\Location(),
                'Make' => new \PHPExiftool\Driver\Tag\XMPPmi\Make(),
                'Manufacturer' => new \PHPExiftool\Driver\Tag\XMPPmi\Manufacturer(),
                'Model' => new \PHPExiftool\Driver\Tag\XMPPmi\Model(),
                'ModelYear' => new \PHPExiftool\Driver\Tag\XMPPmi\ModelYear(),
                'ObjectDescription' => new \PHPExiftool\Driver\Tag\XMPPmi\ObjectDescription(),
                'ObjectSubtype' => new \PHPExiftool\Driver\Tag\XMPPmi\ObjectSubtype(),
                'ObjectType' => new \PHPExiftool\Driver\Tag\XMPPmi\ObjectType(),
                'Orientation' => new \PHPExiftool\Driver\Tag\XMPPmi\Orientation(),
                'PositionDescriptor' => new \PHPExiftool\Driver\Tag\XMPPmi\PositionDescriptor(),
                'ProductID' => new \PHPExiftool\Driver\Tag\XMPPmi\ProductID(),
                'ProductIDType' => new \PHPExiftool\Driver\Tag\XMPPmi\ProductIDType(),
                'Season' => new \PHPExiftool\Driver\Tag\XMPPmi\Season(),
                'SequenceName' => new \PHPExiftool\Driver\Tag\XMPPmi\SequenceName(),
                'SequenceNumber' => new \PHPExiftool\Driver\Tag\XMPPmi\SequenceNumber(),
                'SequenceTotalNumber' => new \PHPExiftool\Driver\Tag\XMPPmi\SequenceTotalNumber(),
                'Setting' => new \PHPExiftool\Driver\Tag\XMPPmi\Setting(),
                'ShootID' => new \PHPExiftool\Driver\Tag\XMPPmi\ShootID(),
                'SlideshowName' => new \PHPExiftool\Driver\Tag\XMPPmi\SlideshowName(),
                'SlideshowNumber' => new \PHPExiftool\Driver\Tag\XMPPmi\SlideshowNumber(),
                'SlideshowTotalNumber' => new \PHPExiftool\Driver\Tag\XMPPmi\SlideshowTotalNumber(),
                'Viewpoint' => new \PHPExiftool\Driver\Tag\XMPPmi\Viewpoint(),
                'VisualTechnique' => new \PHPExiftool\Driver\Tag\XMPPmi\VisualTechnique(),
            );
        });
        $this['XMP-prism'] = $this->share(function(){
            return array(
                'AcademicField' => new \PHPExiftool\Driver\Tag\XMPPrism\AcademicField(),
                'AggregateIssueNumber' => new \PHPExiftool\Driver\Tag\XMPPrism\AggregateIssueNumber(),
                'AggregationType' => new \PHPExiftool\Driver\Tag\XMPPrism\AggregationType(),
                'AlternateTitle' => new \PHPExiftool\Driver\Tag\XMPPrism\AlternateTitle(),
                'AlternateTitleA-lang' => new \PHPExiftool\Driver\Tag\XMPPrism\AlternateTitleALang(),
                'AlternateTitleA-platform' => new \PHPExiftool\Driver\Tag\XMPPrism\AlternateTitleAPlatform(),
                'AlternateTitleText' => new \PHPExiftool\Driver\Tag\XMPPrism\AlternateTitleText(),
                'BlogTitle' => new \PHPExiftool\Driver\Tag\XMPPrism\BlogTitle(),
                'BlogURL' => new \PHPExiftool\Driver\Tag\XMPPrism\BlogURL(),
                'BookEdition' => new \PHPExiftool\Driver\Tag\XMPPrism\BookEdition(),
                'ByteCount' => new \PHPExiftool\Driver\Tag\XMPPrism\ByteCount(),
                'Channel' => new \PHPExiftool\Driver\Tag\XMPPrism\Channel(),
                'ChannelA-lang' => new \PHPExiftool\Driver\Tag\XMPPrism\ChannelALang(),
                'ChannelChannel' => new \PHPExiftool\Driver\Tag\XMPPrism\ChannelChannel(),
                'ChannelSubchannel1' => new \PHPExiftool\Driver\Tag\XMPPrism\ChannelSubchannel1(),
                'ChannelSubchannel2' => new \PHPExiftool\Driver\Tag\XMPPrism\ChannelSubchannel2(),
                'ChannelSubchannel3' => new \PHPExiftool\Driver\Tag\XMPPrism\ChannelSubchannel3(),
                'ChannelSubchannel4' => new \PHPExiftool\Driver\Tag\XMPPrism\ChannelSubchannel4(),
                'ComplianceProfile' => new \PHPExiftool\Driver\Tag\XMPPrism\ComplianceProfile(),
                'ContentType' => new \PHPExiftool\Driver\Tag\XMPPrism\ContentType(),
                'CopyrightYear' => new \PHPExiftool\Driver\Tag\XMPPrism\CopyrightYear(),
                'CorporateEntity' => new \PHPExiftool\Driver\Tag\XMPPrism\CorporateEntity(),
                'CoverDate' => new \PHPExiftool\Driver\Tag\XMPPrism\CoverDate(),
                'CoverDisplayDate' => new \PHPExiftool\Driver\Tag\XMPPrism\CoverDisplayDate(),
                'CreationDate' => new \PHPExiftool\Driver\Tag\XMPPrism\CreationDate(),
                'DateRecieved' => new \PHPExiftool\Driver\Tag\XMPPrism\DateRecieved(),
                'Device' => new \PHPExiftool\Driver\Tag\XMPPrism\Device(),
                'Distributor' => new \PHPExiftool\Driver\Tag\XMPPrism\Distributor(),
                'DOI' => new \PHPExiftool\Driver\Tag\XMPPrism\DOI(),
                'Edition' => new \PHPExiftool\Driver\Tag\XMPPrism\Edition(),
                'EIssn' => new \PHPExiftool\Driver\Tag\XMPPrism\EIssn(),
                'EndingPage' => new \PHPExiftool\Driver\Tag\XMPPrism\EndingPage(),
                'Event' => new \PHPExiftool\Driver\Tag\XMPPrism\Event(),
                'Genre' => new \PHPExiftool\Driver\Tag\XMPPrism\Genre(),
                'HasAlternative' => new \PHPExiftool\Driver\Tag\XMPPrism\HasAlternative(),
                'HasCorrection' => new \PHPExiftool\Driver\Tag\XMPPrism\HasCorrection(),
                'HasCorrectionA-lang' => new \PHPExiftool\Driver\Tag\XMPPrism\HasCorrectionALang(),
                'HasCorrectionA-platform' => new \PHPExiftool\Driver\Tag\XMPPrism\HasCorrectionAPlatform(),
                'HasCorrectionText' => new \PHPExiftool\Driver\Tag\XMPPrism\HasCorrectionText(),
                'HasTranslation' => new \PHPExiftool\Driver\Tag\XMPPrism\HasTranslation(),
                'Industry' => new \PHPExiftool\Driver\Tag\XMPPrism\Industry(),
                'IsAlternativeOf' => new \PHPExiftool\Driver\Tag\XMPPrism\IsAlternativeOf(),
                'ISBN' => new \PHPExiftool\Driver\Tag\XMPPrism\ISBN(),
                'IsCorrectionOf' => new \PHPExiftool\Driver\Tag\XMPPrism\IsCorrectionOf(),
                'ISSN' => new \PHPExiftool\Driver\Tag\XMPPrism\ISSN(),
                'IssueIdentifier' => new \PHPExiftool\Driver\Tag\XMPPrism\IssueIdentifier(),
                'IssueName' => new \PHPExiftool\Driver\Tag\XMPPrism\IssueName(),
                'IssueTeaser' => new \PHPExiftool\Driver\Tag\XMPPrism\IssueTeaser(),
                'IssueType' => new \PHPExiftool\Driver\Tag\XMPPrism\IssueType(),
                'IsTranslationOf' => new \PHPExiftool\Driver\Tag\XMPPrism\IsTranslationOf(),
                'Keyword' => new \PHPExiftool\Driver\Tag\XMPPrism\Keyword(),
                'KillDate' => new \PHPExiftool\Driver\Tag\XMPPrism\KillDate(),
                'KillDateA-platform' => new \PHPExiftool\Driver\Tag\XMPPrism\KillDateAPlatform(),
                'KillDateDate' => new \PHPExiftool\Driver\Tag\XMPPrism\KillDateDate(),
                'Link' => new \PHPExiftool\Driver\Tag\XMPPrism\Link(),
                'Location' => new \PHPExiftool\Driver\Tag\XMPPrism\Location(),
                'ModificationDate' => new \PHPExiftool\Driver\Tag\XMPPrism\ModificationDate(),
                'NationalCatalogNumber' => new \PHPExiftool\Driver\Tag\XMPPrism\NationalCatalogNumber(),
                'Number' => new \PHPExiftool\Driver\Tag\XMPPrism\Number(),
                'Object' => new \PHPExiftool\Driver\Tag\XMPPrism\Object0(),
                'OffSaleDate' => new \PHPExiftool\Driver\Tag\XMPPrism\OffSaleDate(),
                'OffSaleDateA-platform' => new \PHPExiftool\Driver\Tag\XMPPrism\OffSaleDateAPlatform(),
                'OffSaleDateDate' => new \PHPExiftool\Driver\Tag\XMPPrism\OffSaleDateDate(),
                'OnSaleDate' => new \PHPExiftool\Driver\Tag\XMPPrism\OnSaleDate(),
                'OnSaleDateA-platform' => new \PHPExiftool\Driver\Tag\XMPPrism\OnSaleDateAPlatform(),
                'OnSaleDateDate' => new \PHPExiftool\Driver\Tag\XMPPrism\OnSaleDateDate(),
                'OnSaleDay' => new \PHPExiftool\Driver\Tag\XMPPrism\OnSaleDay(),
                'OnSaleDayA-platform' => new \PHPExiftool\Driver\Tag\XMPPrism\OnSaleDayAPlatform(),
                'OnSaleDayDay' => new \PHPExiftool\Driver\Tag\XMPPrism\OnSaleDayDay(),
                'Organization' => new \PHPExiftool\Driver\Tag\XMPPrism\Organization(),
                'OriginPlatform' => new \PHPExiftool\Driver\Tag\XMPPrism\OriginPlatform(),
                'PageCount' => new \PHPExiftool\Driver\Tag\XMPPrism\PageCount(),
                'PageProgressionDirection' => new \PHPExiftool\Driver\Tag\XMPPrism\PageProgressionDirection(),
                'PageRange' => new \PHPExiftool\Driver\Tag\XMPPrism\PageRange(),
                'Person' => new \PHPExiftool\Driver\Tag\XMPPrism\Person(),
                'Platform' => new \PHPExiftool\Driver\Tag\XMPPrism\Platform(),
                'ProductCode' => new \PHPExiftool\Driver\Tag\XMPPrism\ProductCode(),
                'Profession' => new \PHPExiftool\Driver\Tag\XMPPrism\Profession(),
                'PublicationDate' => new \PHPExiftool\Driver\Tag\XMPPrism\PublicationDate(),
                'PublicationDateA-platform' => new \PHPExiftool\Driver\Tag\XMPPrism\PublicationDateAPlatform(),
                'PublicationDateDate' => new \PHPExiftool\Driver\Tag\XMPPrism\PublicationDateDate(),
                'PublicationDisplayDate' => new \PHPExiftool\Driver\Tag\XMPPrism\PublicationDisplayDate(),
                'PublicationDisplayDateA-platform' => new \PHPExiftool\Driver\Tag\XMPPrism\PublicationDisplayDateAPlatform(),
                'PublicationDisplayDateDate' => new \PHPExiftool\Driver\Tag\XMPPrism\PublicationDisplayDateDate(),
                'PublicationName' => new \PHPExiftool\Driver\Tag\XMPPrism\PublicationName(),
                'PublishingFrequency' => new \PHPExiftool\Driver\Tag\XMPPrism\PublishingFrequency(),
                'Rating' => new \PHPExiftool\Driver\Tag\XMPPrism\Rating(),
                'SamplePageRange' => new \PHPExiftool\Driver\Tag\XMPPrism\SamplePageRange(),
                'Section' => new \PHPExiftool\Driver\Tag\XMPPrism\Section(),
                'SellingAgency' => new \PHPExiftool\Driver\Tag\XMPPrism\SellingAgency(),
                'SeriesNumber' => new \PHPExiftool\Driver\Tag\XMPPrism\SeriesNumber(),
                'SeriesTitle' => new \PHPExiftool\Driver\Tag\XMPPrism\SeriesTitle(),
                'Sport' => new \PHPExiftool\Driver\Tag\XMPPrism\Sport(),
                'StartingPage' => new \PHPExiftool\Driver\Tag\XMPPrism\StartingPage(),
                'Subsection1' => new \PHPExiftool\Driver\Tag\XMPPrism\Subsection1(),
                'Subsection2' => new \PHPExiftool\Driver\Tag\XMPPrism\Subsection2(),
                'Subsection3' => new \PHPExiftool\Driver\Tag\XMPPrism\Subsection3(),
                'Subsection4' => new \PHPExiftool\Driver\Tag\XMPPrism\Subsection4(),
                'Subtitle' => new \PHPExiftool\Driver\Tag\XMPPrism\Subtitle(),
                'SupplementDisplayID' => new \PHPExiftool\Driver\Tag\XMPPrism\SupplementDisplayID(),
                'SupplementStartingPage' => new \PHPExiftool\Driver\Tag\XMPPrism\SupplementStartingPage(),
                'SupplementTitle' => new \PHPExiftool\Driver\Tag\XMPPrism\SupplementTitle(),
                'Teaser' => new \PHPExiftool\Driver\Tag\XMPPrism\Teaser(),
                'Ticker' => new \PHPExiftool\Driver\Tag\XMPPrism\Ticker(),
                'TimePeriod' => new \PHPExiftool\Driver\Tag\XMPPrism\TimePeriod(),
                'URL' => new \PHPExiftool\Driver\Tag\XMPPrism\URL(),
                'URLA-platform' => new \PHPExiftool\Driver\Tag\XMPPrism\URLAPlatform(),
                'URLUrl' => new \PHPExiftool\Driver\Tag\XMPPrism\URLUrl(),
                'UspsNumber' => new \PHPExiftool\Driver\Tag\XMPPrism\UspsNumber(),
                'VersionIdentifier' => new \PHPExiftool\Driver\Tag\XMPPrism\VersionIdentifier(),
                'Volume' => new \PHPExiftool\Driver\Tag\XMPPrism\Volume(),
                'WordCount' => new \PHPExiftool\Driver\Tag\XMPPrism\WordCount(),
            );
        });
        $this['XMP-prl'] = $this->share(function(){
            return array(
                'Geography' => new \PHPExiftool\Driver\Tag\XMPPrl\Geography(),
                'Industry' => new \PHPExiftool\Driver\Tag\XMPPrl\Industry(),
                'Usage' => new \PHPExiftool\Driver\Tag\XMPPrl\Usage(),
            );
        });
        $this['XMP-prm'] = $this->share(function(){
            return array(
                'CookingEquipment' => new \PHPExiftool\Driver\Tag\XMPPrm\CookingEquipment(),
                'CookingMethod' => new \PHPExiftool\Driver\Tag\XMPPrm\CookingMethod(),
                'Course' => new \PHPExiftool\Driver\Tag\XMPPrm\Course(),
                'Cuisine' => new \PHPExiftool\Driver\Tag\XMPPrm\Cuisine(),
                'DietaryNeeds' => new \PHPExiftool\Driver\Tag\XMPPrm\DietaryNeeds(),
                'DishType' => new \PHPExiftool\Driver\Tag\XMPPrm\DishType(),
                'Duration' => new \PHPExiftool\Driver\Tag\XMPPrm\Duration(),
                'IngredientExclusion' => new \PHPExiftool\Driver\Tag\XMPPrm\IngredientExclusion(),
                'MainIngredient' => new \PHPExiftool\Driver\Tag\XMPPrm\MainIngredient(),
                'Meal' => new \PHPExiftool\Driver\Tag\XMPPrm\Meal(),
                'RecipeEndingPage' => new \PHPExiftool\Driver\Tag\XMPPrm\RecipeEndingPage(),
                'RecipePageRange' => new \PHPExiftool\Driver\Tag\XMPPrm\RecipePageRange(),
                'RecipeSource' => new \PHPExiftool\Driver\Tag\XMPPrm\RecipeSource(),
                'RecipeStartingPage' => new \PHPExiftool\Driver\Tag\XMPPrm\RecipeStartingPage(),
                'RecipeTitle' => new \PHPExiftool\Driver\Tag\XMPPrm\RecipeTitle(),
                'ServingSize' => new \PHPExiftool\Driver\Tag\XMPPrm\ServingSize(),
                'SkillLevel' => new \PHPExiftool\Driver\Tag\XMPPrm\SkillLevel(),
                'SpecialOccasion' => new \PHPExiftool\Driver\Tag\XMPPrm\SpecialOccasion(),
                'Yield' => new \PHPExiftool\Driver\Tag\XMPPrm\Yield0(),
            );
        });
        $this['XMP-pur'] = $this->share(function(){
            return array(
                'AdultContentWarning' => new \PHPExiftool\Driver\Tag\XMPPur\AdultContentWarning(),
                'Agreement' => new \PHPExiftool\Driver\Tag\XMPPur\Agreement(),
                'Copyright' => new \PHPExiftool\Driver\Tag\XMPPur\Copyright(),
                'CreditLine' => new \PHPExiftool\Driver\Tag\XMPPur\CreditLine(),
                'EmbargoDate' => new \PHPExiftool\Driver\Tag\XMPPur\EmbargoDate(),
                'ExclusivityEndDate' => new \PHPExiftool\Driver\Tag\XMPPur\ExclusivityEndDate(),
                'ExpirationDate' => new \PHPExiftool\Driver\Tag\XMPPur\ExpirationDate(),
                'ImageSizeRestriction' => new \PHPExiftool\Driver\Tag\XMPPur\ImageSizeRestriction(),
                'OptionEndDate' => new \PHPExiftool\Driver\Tag\XMPPur\OptionEndDate(),
                'Permissions' => new \PHPExiftool\Driver\Tag\XMPPur\Permissions(),
                'Restrictions' => new \PHPExiftool\Driver\Tag\XMPPur\Restrictions(),
                'ReuseProhibited' => new \PHPExiftool\Driver\Tag\XMPPur\ReuseProhibited(),
                'RightsAgent' => new \PHPExiftool\Driver\Tag\XMPPur\RightsAgent(),
                'RightsOwner' => new \PHPExiftool\Driver\Tag\XMPPur\RightsOwner(),
            );
        });
        $this['XMP-rdf'] = $this->share(function(){
            return array(
                'About' => new \PHPExiftool\Driver\Tag\XMPRdf\About(),
            );
        });
        $this['XMP-swf'] = $this->share(function(){
            return array(
                'BackgroundAlpha' => new \PHPExiftool\Driver\Tag\XMPSwf\BackgroundAlpha(),
                'ForwardLock' => new \PHPExiftool\Driver\Tag\XMPSwf\ForwardLock(),
                'MaxStorage' => new \PHPExiftool\Driver\Tag\XMPSwf\MaxStorage(),
                'Type' => new \PHPExiftool\Driver\Tag\XMPSwf\Type(),
            );
        });
        $this['XMP-tiff'] = $this->share(function(){
            return array(
                'Artist' => new \PHPExiftool\Driver\Tag\XMPTiff\Artist(),
                'BitsPerSample' => new \PHPExiftool\Driver\Tag\XMPTiff\BitsPerSample(),
                'Compression' => new \PHPExiftool\Driver\Tag\XMPTiff\Compression(),
                'Copyright' => new \PHPExiftool\Driver\Tag\XMPTiff\Copyright(),
                'DateTime' => new \PHPExiftool\Driver\Tag\XMPTiff\DateTime(),
                'ImageDescription' => new \PHPExiftool\Driver\Tag\XMPTiff\ImageDescription(),
                'ImageHeight' => new \PHPExiftool\Driver\Tag\XMPTiff\ImageHeight(),
                'ImageWidth' => new \PHPExiftool\Driver\Tag\XMPTiff\ImageWidth(),
                'Make' => new \PHPExiftool\Driver\Tag\XMPTiff\Make(),
                'Model' => new \PHPExiftool\Driver\Tag\XMPTiff\Model(),
                'NativeDigest' => new \PHPExiftool\Driver\Tag\XMPTiff\NativeDigest(),
                'Orientation' => new \PHPExiftool\Driver\Tag\XMPTiff\Orientation(),
                'PhotometricInterpretation' => new \PHPExiftool\Driver\Tag\XMPTiff\PhotometricInterpretation(),
                'PlanarConfiguration' => new \PHPExiftool\Driver\Tag\XMPTiff\PlanarConfiguration(),
                'PrimaryChromaticities' => new \PHPExiftool\Driver\Tag\XMPTiff\PrimaryChromaticities(),
                'ReferenceBlackWhite' => new \PHPExiftool\Driver\Tag\XMPTiff\ReferenceBlackWhite(),
                'ResolutionUnit' => new \PHPExiftool\Driver\Tag\XMPTiff\ResolutionUnit(),
                'SamplesPerPixel' => new \PHPExiftool\Driver\Tag\XMPTiff\SamplesPerPixel(),
                'Software' => new \PHPExiftool\Driver\Tag\XMPTiff\Software(),
                'TransferFunction' => new \PHPExiftool\Driver\Tag\XMPTiff\TransferFunction(),
                'WhitePoint' => new \PHPExiftool\Driver\Tag\XMPTiff\WhitePoint(),
                'XResolution' => new \PHPExiftool\Driver\Tag\XMPTiff\XResolution(),
                'YCbCrCoefficients' => new \PHPExiftool\Driver\Tag\XMPTiff\YCbCrCoefficients(),
                'YCbCrPositioning' => new \PHPExiftool\Driver\Tag\XMPTiff\YCbCrPositioning(),
                'YCbCrSubSampling' => new \PHPExiftool\Driver\Tag\XMPTiff\YCbCrSubSampling(),
                'YResolution' => new \PHPExiftool\Driver\Tag\XMPTiff\YResolution(),
            );
        });
        $this['XMP-x'] = $this->share(function(){
            return array(
                'XMPToolkit' => new \PHPExiftool\Driver\Tag\XMPX\XMPToolkit(),
            );
        });
        $this['XMP-xmp'] = $this->share(function(){
            return array(
                'Advisory' => new \PHPExiftool\Driver\Tag\XMPXmp\Advisory(),
                'Author' => new \PHPExiftool\Driver\Tag\XMPXmp\Author(),
                'BaseURL' => new \PHPExiftool\Driver\Tag\XMPXmp\BaseURL(),
                'CreateDate' => new \PHPExiftool\Driver\Tag\XMPXmp\CreateDate(),
                'CreatorTool' => new \PHPExiftool\Driver\Tag\XMPXmp\CreatorTool(),
                'Description' => new \PHPExiftool\Driver\Tag\XMPXmp\Description(),
                'Format' => new \PHPExiftool\Driver\Tag\XMPXmp\Format(),
                'Identifier' => new \PHPExiftool\Driver\Tag\XMPXmp\Identifier(),
                'Keywords' => new \PHPExiftool\Driver\Tag\XMPXmp\Keywords(),
                'Label' => new \PHPExiftool\Driver\Tag\XMPXmp\Label(),
                'MetadataDate' => new \PHPExiftool\Driver\Tag\XMPXmp\MetadataDate(),
                'ModifyDate' => new \PHPExiftool\Driver\Tag\XMPXmp\ModifyDate(),
                'Nickname' => new \PHPExiftool\Driver\Tag\XMPXmp\Nickname(),
                'PageInfo' => new \PHPExiftool\Driver\Tag\XMPXmp\PageInfo(),
                'PageImageFormat' => new \PHPExiftool\Driver\Tag\XMPXmp\PageImageFormat(),
                'PageImageHeight' => new \PHPExiftool\Driver\Tag\XMPXmp\PageImageHeight(),
                'PageImage' => new \PHPExiftool\Driver\Tag\XMPXmp\PageImage(),
                'PageImagePageNumber' => new \PHPExiftool\Driver\Tag\XMPXmp\PageImagePageNumber(),
                'PageImageWidth' => new \PHPExiftool\Driver\Tag\XMPXmp\PageImageWidth(),
                'Rating' => new \PHPExiftool\Driver\Tag\XMPXmp\Rating(),
                'Thumbnails' => new \PHPExiftool\Driver\Tag\XMPXmp\Thumbnails(),
                'ThumbnailFormat' => new \PHPExiftool\Driver\Tag\XMPXmp\ThumbnailFormat(),
                'ThumbnailHeight' => new \PHPExiftool\Driver\Tag\XMPXmp\ThumbnailHeight(),
                'ThumbnailImage' => new \PHPExiftool\Driver\Tag\XMPXmp\ThumbnailImage(),
                'ThumbnailWidth' => new \PHPExiftool\Driver\Tag\XMPXmp\ThumbnailWidth(),
                'Title' => new \PHPExiftool\Driver\Tag\XMPXmp\Title(),
            );
        });
        $this['XMP-xmpBJ'] = $this->share(function(){
            return array(
                'JobRef' => new \PHPExiftool\Driver\Tag\XMPXmpBJ\JobRef(),
                'JobRefId' => new \PHPExiftool\Driver\Tag\XMPXmpBJ\JobRefId(),
                'JobRefName' => new \PHPExiftool\Driver\Tag\XMPXmpBJ\JobRefName(),
                'JobRefUrl' => new \PHPExiftool\Driver\Tag\XMPXmpBJ\JobRefUrl(),
            );
        });
        $this['XMP-xmpDM'] = $this->share(function(){
            return array(
                'AbsPeakAudioFilePath' => new \PHPExiftool\Driver\Tag\XMPXmpDM\AbsPeakAudioFilePath(),
                'Album' => new \PHPExiftool\Driver\Tag\XMPXmpDM\Album(),
                'AltTapeName' => new \PHPExiftool\Driver\Tag\XMPXmpDM\AltTapeName(),
                'AltTimecode' => new \PHPExiftool\Driver\Tag\XMPXmpDM\AltTimecode(),
                'AltTimecodeTimeFormat' => new \PHPExiftool\Driver\Tag\XMPXmpDM\AltTimecodeTimeFormat(),
                'AltTimecodeTimeValue' => new \PHPExiftool\Driver\Tag\XMPXmpDM\AltTimecodeTimeValue(),
                'AltTimecodeValue' => new \PHPExiftool\Driver\Tag\XMPXmpDM\AltTimecodeValue(),
                'Artist' => new \PHPExiftool\Driver\Tag\XMPXmpDM\Artist(),
                'AudioChannelType' => new \PHPExiftool\Driver\Tag\XMPXmpDM\AudioChannelType(),
                'AudioCompressor' => new \PHPExiftool\Driver\Tag\XMPXmpDM\AudioCompressor(),
                'AudioModDate' => new \PHPExiftool\Driver\Tag\XMPXmpDM\AudioModDate(),
                'AudioSampleRate' => new \PHPExiftool\Driver\Tag\XMPXmpDM\AudioSampleRate(),
                'AudioSampleType' => new \PHPExiftool\Driver\Tag\XMPXmpDM\AudioSampleType(),
                'BeatSpliceParams' => new \PHPExiftool\Driver\Tag\XMPXmpDM\BeatSpliceParams(),
                'BeatSpliceParamsRiseInDecibel' => new \PHPExiftool\Driver\Tag\XMPXmpDM\BeatSpliceParamsRiseInDecibel(),
                'BeatSpliceParamsRiseInTimeDuration' => new \PHPExiftool\Driver\Tag\XMPXmpDM\BeatSpliceParamsRiseInTimeDuration(),
                'BeatSpliceParamsRiseInTimeDurationScale' => new \PHPExiftool\Driver\Tag\XMPXmpDM\BeatSpliceParamsRiseInTimeDurationScale(),
                'BeatSpliceParamsRiseInTimeDurationValue' => new \PHPExiftool\Driver\Tag\XMPXmpDM\BeatSpliceParamsRiseInTimeDurationValue(),
                'BeatSpliceParamsUseFileBeatsMarker' => new \PHPExiftool\Driver\Tag\XMPXmpDM\BeatSpliceParamsUseFileBeatsMarker(),
                'CameraAngle' => new \PHPExiftool\Driver\Tag\XMPXmpDM\CameraAngle(),
                'CameraLabel' => new \PHPExiftool\Driver\Tag\XMPXmpDM\CameraLabel(),
                'CameraModel' => new \PHPExiftool\Driver\Tag\XMPXmpDM\CameraModel(),
                'CameraMove' => new \PHPExiftool\Driver\Tag\XMPXmpDM\CameraMove(),
                'Client' => new \PHPExiftool\Driver\Tag\XMPXmpDM\Client(),
                'DMComment' => new \PHPExiftool\Driver\Tag\XMPXmpDM\DMComment(),
                'Composer' => new \PHPExiftool\Driver\Tag\XMPXmpDM\Composer(),
                'ContributedMedia' => new \PHPExiftool\Driver\Tag\XMPXmpDM\ContributedMedia(),
                'ContributedMediaDuration' => new \PHPExiftool\Driver\Tag\XMPXmpDM\ContributedMediaDuration(),
                'ContributedMediaDurationScale' => new \PHPExiftool\Driver\Tag\XMPXmpDM\ContributedMediaDurationScale(),
                'ContributedMediaDurationValue' => new \PHPExiftool\Driver\Tag\XMPXmpDM\ContributedMediaDurationValue(),
                'ContributedMediaManaged' => new \PHPExiftool\Driver\Tag\XMPXmpDM\ContributedMediaManaged(),
                'ContributedMediaPath' => new \PHPExiftool\Driver\Tag\XMPXmpDM\ContributedMediaPath(),
                'ContributedMediaStartTime' => new \PHPExiftool\Driver\Tag\XMPXmpDM\ContributedMediaStartTime(),
                'ContributedMediaStartTimeScale' => new \PHPExiftool\Driver\Tag\XMPXmpDM\ContributedMediaStartTimeScale(),
                'ContributedMediaStartTimeValue' => new \PHPExiftool\Driver\Tag\XMPXmpDM\ContributedMediaStartTimeValue(),
                'ContributedMediaTrack' => new \PHPExiftool\Driver\Tag\XMPXmpDM\ContributedMediaTrack(),
                'ContributedMediaWebStatement' => new \PHPExiftool\Driver\Tag\XMPXmpDM\ContributedMediaWebStatement(),
                'Copyright' => new \PHPExiftool\Driver\Tag\XMPXmpDM\Copyright(),
                'Director' => new \PHPExiftool\Driver\Tag\XMPXmpDM\Director(),
                'DirectorPhotography' => new \PHPExiftool\Driver\Tag\XMPXmpDM\DirectorPhotography(),
                'DiscNumber' => new \PHPExiftool\Driver\Tag\XMPXmpDM\DiscNumber(),
                'Duration' => new \PHPExiftool\Driver\Tag\XMPXmpDM\Duration(),
                'DurationScale' => new \PHPExiftool\Driver\Tag\XMPXmpDM\DurationScale(),
                'DurationValue' => new \PHPExiftool\Driver\Tag\XMPXmpDM\DurationValue(),
                'Engineer' => new \PHPExiftool\Driver\Tag\XMPXmpDM\Engineer(),
                'FileDataRate' => new \PHPExiftool\Driver\Tag\XMPXmpDM\FileDataRate(),
                'Genre' => new \PHPExiftool\Driver\Tag\XMPXmpDM\Genre(),
                'Good' => new \PHPExiftool\Driver\Tag\XMPXmpDM\Good(),
                'Instrument' => new \PHPExiftool\Driver\Tag\XMPXmpDM\Instrument(),
                'IntroTime' => new \PHPExiftool\Driver\Tag\XMPXmpDM\IntroTime(),
                'IntroTimeScale' => new \PHPExiftool\Driver\Tag\XMPXmpDM\IntroTimeScale(),
                'IntroTimeValue' => new \PHPExiftool\Driver\Tag\XMPXmpDM\IntroTimeValue(),
                'Key' => new \PHPExiftool\Driver\Tag\XMPXmpDM\Key(),
                'LogComment' => new \PHPExiftool\Driver\Tag\XMPXmpDM\LogComment(),
                'Loop' => new \PHPExiftool\Driver\Tag\XMPXmpDM\Loop(),
                'Lyrics' => new \PHPExiftool\Driver\Tag\XMPXmpDM\Lyrics(),
                'Markers' => new \PHPExiftool\Driver\Tag\XMPXmpDM\Markers(),
                'MarkersComment' => new \PHPExiftool\Driver\Tag\XMPXmpDM\MarkersComment(),
                'MarkersCuePointParams' => new \PHPExiftool\Driver\Tag\XMPXmpDM\MarkersCuePointParams(),
                'MarkersCuePointParamsKey' => new \PHPExiftool\Driver\Tag\XMPXmpDM\MarkersCuePointParamsKey(),
                'MarkersCuePointParamsValue' => new \PHPExiftool\Driver\Tag\XMPXmpDM\MarkersCuePointParamsValue(),
                'MarkersCuePointType' => new \PHPExiftool\Driver\Tag\XMPXmpDM\MarkersCuePointType(),
                'MarkersDuration' => new \PHPExiftool\Driver\Tag\XMPXmpDM\MarkersDuration(),
                'MarkersLocation' => new \PHPExiftool\Driver\Tag\XMPXmpDM\MarkersLocation(),
                'MarkersName' => new \PHPExiftool\Driver\Tag\XMPXmpDM\MarkersName(),
                'MarkersProbability' => new \PHPExiftool\Driver\Tag\XMPXmpDM\MarkersProbability(),
                'MarkersSpeaker' => new \PHPExiftool\Driver\Tag\XMPXmpDM\MarkersSpeaker(),
                'MarkersStartTime' => new \PHPExiftool\Driver\Tag\XMPXmpDM\MarkersStartTime(),
                'MarkersTarget' => new \PHPExiftool\Driver\Tag\XMPXmpDM\MarkersTarget(),
                'MarkersType' => new \PHPExiftool\Driver\Tag\XMPXmpDM\MarkersType(),
                'MetadataModDate' => new \PHPExiftool\Driver\Tag\XMPXmpDM\MetadataModDate(),
                'NumberOfBeats' => new \PHPExiftool\Driver\Tag\XMPXmpDM\NumberOfBeats(),
                'OutCue' => new \PHPExiftool\Driver\Tag\XMPXmpDM\OutCue(),
                'OutCueScale' => new \PHPExiftool\Driver\Tag\XMPXmpDM\OutCueScale(),
                'OutCueValue' => new \PHPExiftool\Driver\Tag\XMPXmpDM\OutCueValue(),
                'PartOfCompilation' => new \PHPExiftool\Driver\Tag\XMPXmpDM\PartOfCompilation(),
                'ProjectName' => new \PHPExiftool\Driver\Tag\XMPXmpDM\ProjectName(),
                'ProjectRef' => new \PHPExiftool\Driver\Tag\XMPXmpDM\ProjectRef(),
                'ProjectRefPath' => new \PHPExiftool\Driver\Tag\XMPXmpDM\ProjectRefPath(),
                'ProjectRefType' => new \PHPExiftool\Driver\Tag\XMPXmpDM\ProjectRefType(),
                'PullDown' => new \PHPExiftool\Driver\Tag\XMPXmpDM\PullDown(),
                'RelativePeakAudioFilePath' => new \PHPExiftool\Driver\Tag\XMPXmpDM\RelativePeakAudioFilePath(),
                'RelativeTimestamp' => new \PHPExiftool\Driver\Tag\XMPXmpDM\RelativeTimestamp(),
                'RelativeTimestampScale' => new \PHPExiftool\Driver\Tag\XMPXmpDM\RelativeTimestampScale(),
                'RelativeTimestampValue' => new \PHPExiftool\Driver\Tag\XMPXmpDM\RelativeTimestampValue(),
                'ReleaseDate' => new \PHPExiftool\Driver\Tag\XMPXmpDM\ReleaseDate(),
                'ResampleParams' => new \PHPExiftool\Driver\Tag\XMPXmpDM\ResampleParams(),
                'ResampleParamsQuality' => new \PHPExiftool\Driver\Tag\XMPXmpDM\ResampleParamsQuality(),
                'ScaleType' => new \PHPExiftool\Driver\Tag\XMPXmpDM\ScaleType(),
                'Scene' => new \PHPExiftool\Driver\Tag\XMPXmpDM\Scene(),
                'ShotDate' => new \PHPExiftool\Driver\Tag\XMPXmpDM\ShotDate(),
                'ShotDay' => new \PHPExiftool\Driver\Tag\XMPXmpDM\ShotDay(),
                'ShotLocation' => new \PHPExiftool\Driver\Tag\XMPXmpDM\ShotLocation(),
                'ShotName' => new \PHPExiftool\Driver\Tag\XMPXmpDM\ShotName(),
                'ShotNumber' => new \PHPExiftool\Driver\Tag\XMPXmpDM\ShotNumber(),
                'ShotSize' => new \PHPExiftool\Driver\Tag\XMPXmpDM\ShotSize(),
                'SpeakerPlacement' => new \PHPExiftool\Driver\Tag\XMPXmpDM\SpeakerPlacement(),
                'StartTimecode' => new \PHPExiftool\Driver\Tag\XMPXmpDM\StartTimecode(),
                'StartTimecodeTimeFormat' => new \PHPExiftool\Driver\Tag\XMPXmpDM\StartTimecodeTimeFormat(),
                'StartTimecodeTimeValue' => new \PHPExiftool\Driver\Tag\XMPXmpDM\StartTimecodeTimeValue(),
                'StartTimecodeValue' => new \PHPExiftool\Driver\Tag\XMPXmpDM\StartTimecodeValue(),
                'StartTimeSampleSize' => new \PHPExiftool\Driver\Tag\XMPXmpDM\StartTimeSampleSize(),
                'StartTimeScale' => new \PHPExiftool\Driver\Tag\XMPXmpDM\StartTimeScale(),
                'StretchMode' => new \PHPExiftool\Driver\Tag\XMPXmpDM\StretchMode(),
                'TakeNumber' => new \PHPExiftool\Driver\Tag\XMPXmpDM\TakeNumber(),
                'TapeName' => new \PHPExiftool\Driver\Tag\XMPXmpDM\TapeName(),
                'Tempo' => new \PHPExiftool\Driver\Tag\XMPXmpDM\Tempo(),
                'TimeScaleParams' => new \PHPExiftool\Driver\Tag\XMPXmpDM\TimeScaleParams(),
                'TimeScaleParamsFrameOverlappingPercentage' => new \PHPExiftool\Driver\Tag\XMPXmpDM\TimeScaleParamsFrameOverlappingPercentage(),
                'TimeScaleParamsFrameSize' => new \PHPExiftool\Driver\Tag\XMPXmpDM\TimeScaleParamsFrameSize(),
                'TimeScaleParamsQuality' => new \PHPExiftool\Driver\Tag\XMPXmpDM\TimeScaleParamsQuality(),
                'TimeSignature' => new \PHPExiftool\Driver\Tag\XMPXmpDM\TimeSignature(),
                'TrackNumber' => new \PHPExiftool\Driver\Tag\XMPXmpDM\TrackNumber(),
                'Tracks' => new \PHPExiftool\Driver\Tag\XMPXmpDM\Tracks(),
                'TracksFrameRate' => new \PHPExiftool\Driver\Tag\XMPXmpDM\TracksFrameRate(),
                'TracksMarkers' => new \PHPExiftool\Driver\Tag\XMPXmpDM\TracksMarkers(),
                'TracksMarkersComment' => new \PHPExiftool\Driver\Tag\XMPXmpDM\TracksMarkersComment(),
                'TracksMarkersCuePointParams' => new \PHPExiftool\Driver\Tag\XMPXmpDM\TracksMarkersCuePointParams(),
                'TracksMarkersCuePointParamsKey' => new \PHPExiftool\Driver\Tag\XMPXmpDM\TracksMarkersCuePointParamsKey(),
                'TracksMarkersCuePointParamsValue' => new \PHPExiftool\Driver\Tag\XMPXmpDM\TracksMarkersCuePointParamsValue(),
                'TracksMarkersCuePointType' => new \PHPExiftool\Driver\Tag\XMPXmpDM\TracksMarkersCuePointType(),
                'TracksMarkersDuration' => new \PHPExiftool\Driver\Tag\XMPXmpDM\TracksMarkersDuration(),
                'TracksMarkersLocation' => new \PHPExiftool\Driver\Tag\XMPXmpDM\TracksMarkersLocation(),
                'TracksMarkersName' => new \PHPExiftool\Driver\Tag\XMPXmpDM\TracksMarkersName(),
                'TracksMarkersProbability' => new \PHPExiftool\Driver\Tag\XMPXmpDM\TracksMarkersProbability(),
                'TracksMarkersSpeaker' => new \PHPExiftool\Driver\Tag\XMPXmpDM\TracksMarkersSpeaker(),
                'TracksMarkersStartTime' => new \PHPExiftool\Driver\Tag\XMPXmpDM\TracksMarkersStartTime(),
                'TracksMarkersTarget' => new \PHPExiftool\Driver\Tag\XMPXmpDM\TracksMarkersTarget(),
                'TracksMarkersType' => new \PHPExiftool\Driver\Tag\XMPXmpDM\TracksMarkersType(),
                'TracksTrackName' => new \PHPExiftool\Driver\Tag\XMPXmpDM\TracksTrackName(),
                'TracksTrackType' => new \PHPExiftool\Driver\Tag\XMPXmpDM\TracksTrackType(),
                'VideoAlphaMode' => new \PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaMode(),
                'VideoAlphaPremultipleColor' => new \PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColor(),
                'VideoAlphaPremultipleColorA' => new \PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorA(),
                'VideoAlphaPremultipleColorB' => new \PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorB(),
                'VideoAlphaPremultipleColorBlack' => new \PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorBlack(),
                'VideoAlphaPremultipleColorBlue' => new \PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorBlue(),
                'VideoAlphaPremultipleColorCyan' => new \PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorCyan(),
                'VideoAlphaPremultipleColorGray' => new \PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorGray(),
                'VideoAlphaPremultipleColorGreen' => new \PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorGreen(),
                'VideoAlphaPremultipleColorL' => new \PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorL(),
                'VideoAlphaPremultipleColorMagenta' => new \PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorMagenta(),
                'VideoAlphaPremultipleColorMode' => new \PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorMode(),
                'VideoAlphaPremultipleColorRed' => new \PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorRed(),
                'VideoAlphaPremultipleColorSwatchName' => new \PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorSwatchName(),
                'VideoAlphaPremultipleColorTint' => new \PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorTint(),
                'VideoAlphaPremultipleColorType' => new \PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorType(),
                'VideoAlphaPremultipleColorYellow' => new \PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorYellow(),
                'VideoAlphaUnityIsTransparent' => new \PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaUnityIsTransparent(),
                'VideoColorSpace' => new \PHPExiftool\Driver\Tag\XMPXmpDM\VideoColorSpace(),
                'VideoCompressor' => new \PHPExiftool\Driver\Tag\XMPXmpDM\VideoCompressor(),
                'VideoFieldOrder' => new \PHPExiftool\Driver\Tag\XMPXmpDM\VideoFieldOrder(),
                'VideoFrameRate' => new \PHPExiftool\Driver\Tag\XMPXmpDM\VideoFrameRate(),
                'VideoFrameSize' => new \PHPExiftool\Driver\Tag\XMPXmpDM\VideoFrameSize(),
                'VideoFrameSizeH' => new \PHPExiftool\Driver\Tag\XMPXmpDM\VideoFrameSizeH(),
                'VideoFrameSizeUnit' => new \PHPExiftool\Driver\Tag\XMPXmpDM\VideoFrameSizeUnit(),
                'VideoFrameSizeW' => new \PHPExiftool\Driver\Tag\XMPXmpDM\VideoFrameSizeW(),
                'VideoModDate' => new \PHPExiftool\Driver\Tag\XMPXmpDM\VideoModDate(),
                'VideoPixelAspectRatio' => new \PHPExiftool\Driver\Tag\XMPXmpDM\VideoPixelAspectRatio(),
                'VideoPixelDepth' => new \PHPExiftool\Driver\Tag\XMPXmpDM\VideoPixelDepth(),
            );
        });
        $this['XMP-xmpMM'] = $this->share(function(){
            return array(
                'DerivedFrom' => new \PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFrom(),
                'DerivedFromAlternatePaths' => new \PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromAlternatePaths(),
                'DerivedFromDocumentID' => new \PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromDocumentID(),
                'DerivedFromFilePath' => new \PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromFilePath(),
                'DerivedFromFromPart' => new \PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromFromPart(),
                'DerivedFromInstanceID' => new \PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromInstanceID(),
                'DerivedFromLastModifyDate' => new \PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromLastModifyDate(),
                'DerivedFromLastURL' => new \PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromLastURL(),
                'DerivedFromLinkCategory' => new \PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromLinkCategory(),
                'DerivedFromLinkForm' => new \PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromLinkForm(),
                'DerivedFromManager' => new \PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromManager(),
                'DerivedFromManagerVariant' => new \PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromManagerVariant(),
                'DerivedFromManageTo' => new \PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromManageTo(),
                'DerivedFromManageUI' => new \PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromManageUI(),
                'DerivedFromMaskMarkers' => new \PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromMaskMarkers(),
                'DerivedFromOriginalDocumentID' => new \PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromOriginalDocumentID(),
                'DerivedFromPartMapping' => new \PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromPartMapping(),
                'DerivedFromPlacedResolutionUnit' => new \PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromPlacedResolutionUnit(),
                'DerivedFromPlacedXResolution' => new \PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromPlacedXResolution(),
                'DerivedFromPlacedYResolution' => new \PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromPlacedYResolution(),
                'DerivedFromRenditionClass' => new \PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromRenditionClass(),
                'DerivedFromRenditionParams' => new \PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromRenditionParams(),
                'DerivedFromToPart' => new \PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromToPart(),
                'DerivedFromVersionID' => new \PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromVersionID(),
                'DocumentID' => new \PHPExiftool\Driver\Tag\XMPXmpMM\DocumentID(),
                'History' => new \PHPExiftool\Driver\Tag\XMPXmpMM\History(),
                'HistoryAction' => new \PHPExiftool\Driver\Tag\XMPXmpMM\HistoryAction(),
                'HistoryChanged' => new \PHPExiftool\Driver\Tag\XMPXmpMM\HistoryChanged(),
                'HistoryInstanceID' => new \PHPExiftool\Driver\Tag\XMPXmpMM\HistoryInstanceID(),
                'HistoryParameters' => new \PHPExiftool\Driver\Tag\XMPXmpMM\HistoryParameters(),
                'HistorySoftwareAgent' => new \PHPExiftool\Driver\Tag\XMPXmpMM\HistorySoftwareAgent(),
                'HistoryWhen' => new \PHPExiftool\Driver\Tag\XMPXmpMM\HistoryWhen(),
                'Ingredients' => new \PHPExiftool\Driver\Tag\XMPXmpMM\Ingredients(),
                'IngredientsAlternatePaths' => new \PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsAlternatePaths(),
                'IngredientsDocumentID' => new \PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsDocumentID(),
                'IngredientsFilePath' => new \PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsFilePath(),
                'IngredientsFromPart' => new \PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsFromPart(),
                'IngredientsInstanceID' => new \PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsInstanceID(),
                'IngredientsLastModifyDate' => new \PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsLastModifyDate(),
                'IngredientsLastURL' => new \PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsLastURL(),
                'IngredientsLinkCategory' => new \PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsLinkCategory(),
                'IngredientsLinkForm' => new \PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsLinkForm(),
                'IngredientsManager' => new \PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsManager(),
                'IngredientsManagerVariant' => new \PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsManagerVariant(),
                'IngredientsManageTo' => new \PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsManageTo(),
                'IngredientsManageUI' => new \PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsManageUI(),
                'IngredientsMaskMarkers' => new \PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsMaskMarkers(),
                'IngredientsOriginalDocumentID' => new \PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsOriginalDocumentID(),
                'IngredientsPartMapping' => new \PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsPartMapping(),
                'IngredientsPlacedResolutionUnit' => new \PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsPlacedResolutionUnit(),
                'IngredientsPlacedXResolution' => new \PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsPlacedXResolution(),
                'IngredientsPlacedYResolution' => new \PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsPlacedYResolution(),
                'IngredientsRenditionClass' => new \PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsRenditionClass(),
                'IngredientsRenditionParams' => new \PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsRenditionParams(),
                'IngredientsToPart' => new \PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsToPart(),
                'IngredientsVersionID' => new \PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsVersionID(),
                'InstanceID' => new \PHPExiftool\Driver\Tag\XMPXmpMM\InstanceID(),
                'LastURL' => new \PHPExiftool\Driver\Tag\XMPXmpMM\LastURL(),
                'ManagedFrom' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFrom(),
                'ManagedFromAlternatePaths' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromAlternatePaths(),
                'ManagedFromDocumentID' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromDocumentID(),
                'ManagedFromFilePath' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromFilePath(),
                'ManagedFromFromPart' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromFromPart(),
                'ManagedFromInstanceID' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromInstanceID(),
                'ManagedFromLastModifyDate' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromLastModifyDate(),
                'ManagedFromLastURL' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromLastURL(),
                'ManagedFromLinkCategory' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromLinkCategory(),
                'ManagedFromLinkForm' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromLinkForm(),
                'ManagedFromManager' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromManager(),
                'ManagedFromManagerVariant' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromManagerVariant(),
                'ManagedFromManageTo' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromManageTo(),
                'ManagedFromManageUI' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromManageUI(),
                'ManagedFromMaskMarkers' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromMaskMarkers(),
                'ManagedFromOriginalDocumentID' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromOriginalDocumentID(),
                'ManagedFromPartMapping' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromPartMapping(),
                'ManagedFromPlacedResolutionUnit' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromPlacedResolutionUnit(),
                'ManagedFromPlacedXResolution' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromPlacedXResolution(),
                'ManagedFromPlacedYResolution' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromPlacedYResolution(),
                'ManagedFromRenditionClass' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromRenditionClass(),
                'ManagedFromRenditionParams' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromRenditionParams(),
                'ManagedFromToPart' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromToPart(),
                'ManagedFromVersionID' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromVersionID(),
                'Manager' => new \PHPExiftool\Driver\Tag\XMPXmpMM\Manager(),
                'ManagerVariant' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManagerVariant(),
                'ManageTo' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManageTo(),
                'ManageUI' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManageUI(),
                'Manifest' => new \PHPExiftool\Driver\Tag\XMPXmpMM\Manifest(),
                'ManifestLinkForm' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManifestLinkForm(),
                'ManifestPlacedResolutionUnit' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManifestPlacedResolutionUnit(),
                'ManifestPlacedXResolution' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManifestPlacedXResolution(),
                'ManifestPlacedYResolution' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManifestPlacedYResolution(),
                'ManifestReference' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReference(),
                'ManifestReferenceAlternatePaths' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceAlternatePaths(),
                'ManifestReferenceDocumentID' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceDocumentID(),
                'ManifestReferenceFilePath' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceFilePath(),
                'ManifestReferenceFromPart' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceFromPart(),
                'ManifestReferenceInstanceID' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceInstanceID(),
                'ManifestReferenceLastModifyDate' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceLastModifyDate(),
                'ManifestReferenceLastURL' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceLastURL(),
                'ManifestReferenceLinkCategory' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceLinkCategory(),
                'ManifestReferenceLinkForm' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceLinkForm(),
                'ManifestReferenceManager' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceManager(),
                'ManifestReferenceManagerVariant' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceManagerVariant(),
                'ManifestReferenceManageTo' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceManageTo(),
                'ManifestReferenceManageUI' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceManageUI(),
                'ManifestReferenceMaskMarkers' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceMaskMarkers(),
                'ManifestReferenceOriginalDocumentID' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceOriginalDocumentID(),
                'ManifestReferencePartMapping' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferencePartMapping(),
                'ManifestReferencePlacedResolutionUnit' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferencePlacedResolutionUnit(),
                'ManifestReferencePlacedXResolution' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferencePlacedXResolution(),
                'ManifestReferencePlacedYResolution' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferencePlacedYResolution(),
                'ManifestReferenceRenditionClass' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceRenditionClass(),
                'ManifestReferenceRenditionParams' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceRenditionParams(),
                'ManifestReferenceToPart' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceToPart(),
                'ManifestReferenceVersionID' => new \PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceVersionID(),
                'OriginalDocumentID' => new \PHPExiftool\Driver\Tag\XMPXmpMM\OriginalDocumentID(),
                'Pantry' => new \PHPExiftool\Driver\Tag\XMPXmpMM\Pantry(),
                'PantryInstanceID' => new \PHPExiftool\Driver\Tag\XMPXmpMM\PantryInstanceID(),
                'PreservedFileName' => new \PHPExiftool\Driver\Tag\XMPXmpMM\PreservedFileName(),
                'RenditionClass' => new \PHPExiftool\Driver\Tag\XMPXmpMM\RenditionClass(),
                'RenditionOf' => new \PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOf(),
                'RenditionOfAlternatePaths' => new \PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfAlternatePaths(),
                'RenditionOfDocumentID' => new \PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfDocumentID(),
                'RenditionOfFilePath' => new \PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfFilePath(),
                'RenditionOfFromPart' => new \PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfFromPart(),
                'RenditionOfInstanceID' => new \PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfInstanceID(),
                'RenditionOfLastModifyDate' => new \PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfLastModifyDate(),
                'RenditionOfLastURL' => new \PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfLastURL(),
                'RenditionOfLinkCategory' => new \PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfLinkCategory(),
                'RenditionOfLinkForm' => new \PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfLinkForm(),
                'RenditionOfManager' => new \PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfManager(),
                'RenditionOfManagerVariant' => new \PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfManagerVariant(),
                'RenditionOfManageTo' => new \PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfManageTo(),
                'RenditionOfManageUI' => new \PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfManageUI(),
                'RenditionOfMaskMarkers' => new \PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfMaskMarkers(),
                'RenditionOfOriginalDocumentID' => new \PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfOriginalDocumentID(),
                'RenditionOfPartMapping' => new \PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfPartMapping(),
                'RenditionOfPlacedResolutionUnit' => new \PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfPlacedResolutionUnit(),
                'RenditionOfPlacedXResolution' => new \PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfPlacedXResolution(),
                'RenditionOfPlacedYResolution' => new \PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfPlacedYResolution(),
                'RenditionOfRenditionClass' => new \PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfRenditionClass(),
                'RenditionOfRenditionParams' => new \PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfRenditionParams(),
                'RenditionOfToPart' => new \PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfToPart(),
                'RenditionOfVersionID' => new \PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfVersionID(),
                'RenditionParams' => new \PHPExiftool\Driver\Tag\XMPXmpMM\RenditionParams(),
                'SaveID' => new \PHPExiftool\Driver\Tag\XMPXmpMM\SaveID(),
                'Subject' => new \PHPExiftool\Driver\Tag\XMPXmpMM\Subject(),
                'VersionID' => new \PHPExiftool\Driver\Tag\XMPXmpMM\VersionID(),
                'Versions' => new \PHPExiftool\Driver\Tag\XMPXmpMM\Versions(),
                'VersionsComments' => new \PHPExiftool\Driver\Tag\XMPXmpMM\VersionsComments(),
                'VersionsEvent' => new \PHPExiftool\Driver\Tag\XMPXmpMM\VersionsEvent(),
                'VersionsEventAction' => new \PHPExiftool\Driver\Tag\XMPXmpMM\VersionsEventAction(),
                'VersionsEventChanged' => new \PHPExiftool\Driver\Tag\XMPXmpMM\VersionsEventChanged(),
                'VersionsEventInstanceID' => new \PHPExiftool\Driver\Tag\XMPXmpMM\VersionsEventInstanceID(),
                'VersionsEventParameters' => new \PHPExiftool\Driver\Tag\XMPXmpMM\VersionsEventParameters(),
                'VersionsEventSoftwareAgent' => new \PHPExiftool\Driver\Tag\XMPXmpMM\VersionsEventSoftwareAgent(),
                'VersionsEventWhen' => new \PHPExiftool\Driver\Tag\XMPXmpMM\VersionsEventWhen(),
                'VersionsModifier' => new \PHPExiftool\Driver\Tag\XMPXmpMM\VersionsModifier(),
                'VersionsModifyDate' => new \PHPExiftool\Driver\Tag\XMPXmpMM\VersionsModifyDate(),
                'VersionsVersion' => new \PHPExiftool\Driver\Tag\XMPXmpMM\VersionsVersion(),
            );
        });
        $this['XMP-xmpNote'] = $this->share(function(){
            return array(
                'HasExtendedXMP' => new \PHPExiftool\Driver\Tag\XMPXmpNote\HasExtendedXMP(),
            );
        });
        $this['XMP-xmpPLUS'] = $this->share(function(){
            return array(
                'CreditLineReq' => new \PHPExiftool\Driver\Tag\XMPXmpPLUS\CreditLineReq(),
                'ReuseAllowed' => new \PHPExiftool\Driver\Tag\XMPXmpPLUS\ReuseAllowed(),
            );
        });
        $this['XMP-xmpRights'] = $this->share(function(){
            return array(
                'Certificate' => new \PHPExiftool\Driver\Tag\XMPXmpRights\Certificate(),
                'Marked' => new \PHPExiftool\Driver\Tag\XMPXmpRights\Marked(),
                'Owner' => new \PHPExiftool\Driver\Tag\XMPXmpRights\Owner(),
                'UsageTerms' => new \PHPExiftool\Driver\Tag\XMPXmpRights\UsageTerms(),
                'WebStatement' => new \PHPExiftool\Driver\Tag\XMPXmpRights\WebStatement(),
            );
        });
        $this['XMP-xmpTPg'] = $this->share(function(){
            return array(
                'Colorants' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\Colorants(),
                'ColorantA' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantA(),
                'ColorantB' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantB(),
                'ColorantBlack' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantBlack(),
                'ColorantBlue' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantBlue(),
                'ColorantCyan' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantCyan(),
                'ColorantGray' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantGray(),
                'ColorantGreen' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantGreen(),
                'ColorantL' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantL(),
                'ColorantMagenta' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantMagenta(),
                'ColorantMode' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantMode(),
                'ColorantRed' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantRed(),
                'ColorantSwatchName' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantSwatchName(),
                'ColorantTint' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantTint(),
                'ColorantType' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantType(),
                'ColorantYellow' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantYellow(),
                'Fonts' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\Fonts(),
                'ChildFontFiles' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\ChildFontFiles(),
                'FontComposite' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\FontComposite(),
                'FontFace' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\FontFace(),
                'FontFamily' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\FontFamily(),
                'FontFileName' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\FontFileName(),
                'FontName' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\FontName(),
                'FontType' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\FontType(),
                'FontVersion' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\FontVersion(),
                'HasVisibleOverprint' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\HasVisibleOverprint(),
                'HasVisibleTransparency' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\HasVisibleTransparency(),
                'MaxPageSize' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\MaxPageSize(),
                'MaxPageSizeH' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\MaxPageSizeH(),
                'MaxPageSizeUnit' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\MaxPageSizeUnit(),
                'MaxPageSizeW' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\MaxPageSizeW(),
                'NPages' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\NPages(),
                'PlateNames' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\PlateNames(),
                'SwatchGroups' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchGroups(),
                'SwatchGroupsColorants' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchGroupsColorants(),
                'SwatchColorantA' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantA(),
                'SwatchColorantB' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantB(),
                'SwatchColorantBlack' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantBlack(),
                'SwatchColorantBlue' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantBlue(),
                'SwatchColorantCyan' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantCyan(),
                'SwatchColorantGray' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantGray(),
                'SwatchColorantGreen' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantGreen(),
                'SwatchColorantL' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantL(),
                'SwatchColorantMagenta' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantMagenta(),
                'SwatchColorantMode' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantMode(),
                'SwatchColorantRed' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantRed(),
                'SwatchColorantSwatchName' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantSwatchName(),
                'SwatchColorantTint' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantTint(),
                'SwatchColorantType' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantType(),
                'SwatchColorantYellow' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantYellow(),
                'SwatchGroupName' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchGroupName(),
                'SwatchGroupType' => new \PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchGroupType(),
            );
        });
    }
    public function getAll()
    {
        return array(
            'AFCP' => $this['AFCP'],
            'AIFF' => $this['AIFF'],
            'APE' => $this['APE'],
            'MAC' => $this['MAC'],
            'Ducky' => $this['Ducky'],
            'PictureInfo' => $this['PictureInfo'],
            'ASF' => $this['ASF'],
            'Apple' => $this['Apple'],
            'Audible' => $this['Audible'],
            'File' => $this['File'],
            'Canon' => $this['Canon'],
            'CanonCustom' => $this['CanonCustom'],
            'CanonRaw' => $this['CanonRaw'],
            'CanonVRD' => $this['CanonVRD'],
            'Casio' => $this['Casio'],
            'Composite' => $this['Composite'],
            'All' => $this['All'],
            'FLIR' => $this['FLIR'],
            'DICOM' => $this['DICOM'],
            'DJI' => $this['DJI'],
            'XMP-drone-dji' => $this['XMP-drone-dji'],
            'ExifIFD' => $this['ExifIFD'],
            'DNG' => $this['DNG'],
            'DV' => $this['DV'],
            'XMP-dwc' => $this['XMP-dwc'],
            'DjVu' => $this['DjVu'],
            'DjVu-Meta' => $this['DjVu-Meta'],
            'EXE' => $this['EXE'],
            'InteropIFD' => $this['InteropIFD'],
            'IFD0' => $this['IFD0'],
            'SubIFD2' => $this['SubIFD2'],
            'SubIFD' => $this['SubIFD'],
            'Adobe' => $this['Adobe'],
            'System' => $this['System'],
            'EXIF' => $this['EXIF'],
            'ExifTool' => $this['ExifTool'],
            
            'IPTC' => $this['IPTC'],
            'XMP' => $this['XMP'],
            'FITS' => $this['FITS'],
            'FLAC' => $this['FLAC'],
            'Flash' => $this['Flash'],
            'FlashPix' => $this['FlashPix'],
            'MS-DOC' => $this['MS-DOC'],
            'Font' => $this['Font'],
            'FotoStation' => $this['FotoStation'],
            'FujiFilm' => $this['FujiFilm'],
            'FujiIFD' => $this['FujiIFD'],
            'RAF2' => $this['RAF2'],
            'RAF' => $this['RAF'],
            'GE' => $this['GE'],
            'GIF' => $this['GIF'],
            'GIMP' => $this['GIMP'],
            'GPS' => $this['GPS'],
            'GeoTiff' => $this['GeoTiff'],
            'GoPro' => $this['GoPro'],
            'H264' => $this['H264'],
            'HP' => $this['HP'],
            'HTML' => $this['HTML'],
            'HTML-office' => $this['HTML-office'],
            'HTML-dc' => $this['HTML-dc'],
            'HTTP-equiv' => $this['HTTP-equiv'],
            'HTML-ncc' => $this['HTML-ncc'],
            'HTML-prod' => $this['HTML-prod'],
            'HTML-vw96' => $this['HTML-vw96'],
            'ICC-chrm' => $this['ICC-chrm'],
            'ICC-clrt' => $this['ICC-clrt'],
            'ICC-header' => $this['ICC-header'],
            'ICC-meas' => $this['ICC-meas'],
            'ICC-meta' => $this['ICC-meta'],
            'ICC-view' => $this['ICC-view'],
            'ID3' => $this['ID3'],
            'ID3v1' => $this['ID3v1'],
            'ID3v1_Enh' => $this['ID3v1_Enh'],
            'ID3v2_2' => $this['ID3v2_2'],
            'ID3v2_3' => $this['ID3v2_3'],
            'ID3v2_4' => $this['ID3v2_4'],
            'ISO' => $this['ISO'],
            'ITC' => $this['ITC'],
            'JFXX' => $this['JFXX'],
            'JFIF' => $this['JFIF'],
            'AVI1' => $this['AVI1'],
            'AdobeCM' => $this['AdobeCM'],
            'EPPIM' => $this['EPPIM'],
            'GraphConv' => $this['GraphConv'],
            'Parrot' => $this['Parrot'],
            'JPEG' => $this['JPEG'],
            'MediaJukebox' => $this['MediaJukebox'],
            'NITF' => $this['NITF'],
            'Ocad' => $this['Ocad'],
            'SPIFF' => $this['SPIFF'],
            'JVC' => $this['JVC'],
            'KodakBordersIFD' => $this['KodakBordersIFD'],
            'Kodak' => $this['Kodak'],
            'KodakIFD' => $this['KodakIFD'],
            'KDC_IFD' => $this['KDC_IFD'],
            'MetaIFD' => $this['MetaIFD'],
            'KodakEffectsIFD' => $this['KodakEffectsIFD'],
            'KyoceraRaw' => $this['KyoceraRaw'],
            'LNK' => $this['LNK'],
            'Leaf' => $this['Leaf'],
            'Lytro' => $this['Lytro'],
            'AC3' => $this['AC3'],
            'M2TS' => $this['M2TS'],
            'MIE-Audio' => $this['MIE-Audio'],
            'MIE-Camera' => $this['MIE-Camera'],
            'MIE-Doc' => $this['MIE-Doc'],
            'MIE-Extender' => $this['MIE-Extender'],
            'MIE-Flash' => $this['MIE-Flash'],
            'MIE-GPS' => $this['MIE-GPS'],
            'MIE-Geo' => $this['MIE-Geo'],
            'MIE-Image' => $this['MIE-Image'],
            'MIE-Lens' => $this['MIE-Lens'],
            'MIE-Main' => $this['MIE-Main'],
            'MIE-Orient' => $this['MIE-Orient'],
            'MIE-Preview' => $this['MIE-Preview'],
            'MIE-Thumbnail' => $this['MIE-Thumbnail'],
            'MIE-UTM' => $this['MIE-UTM'],
            'MIE-Video' => $this['MIE-Video'],
            'MIFF' => $this['MIFF'],
            'MNG' => $this['MNG'],
            'MOI' => $this['MOI'],
            'MPC' => $this['MPC'],
            'MPEG' => $this['MPEG'],
            'MPImage' => $this['MPImage'],
            'MPF0' => $this['MPF0'],
            'XMP-mwg-coll' => $this['XMP-mwg-coll'],
            'XMP-mwg-kw' => $this['XMP-mwg-kw'],
            'XMP-mwg-rs' => $this['XMP-mwg-rs'],
            'MXF' => $this['MXF'],
            'MacOS' => $this['MacOS'],
            'Matroska' => $this['Matroska'],
            'XMP-MP' => $this['XMP-MP'],
            'XMP-MP1' => $this['XMP-MP1'],
            'Microsoft' => $this['Microsoft'],
            'XMP-microsoft' => $this['XMP-microsoft'],
            'Minolta' => $this['Minolta'],
            'MinoltaRaw' => $this['MinoltaRaw'],
            'Motorola' => $this['Motorola'],
            'Nikon' => $this['Nikon'],
            'NikonScan' => $this['NikonScan'],
            'PreviewIFD' => $this['PreviewIFD'],
            'NikonCustom' => $this['NikonCustom'],
            'NikonCapture' => $this['NikonCapture'],
            'Nintendo' => $this['Nintendo'],
            'XML' => $this['XML'],
            'Olympus' => $this['Olympus'],
            'OpenEXR' => $this['OpenEXR'],
            'Opus' => $this['Opus'],
            'PDF' => $this['PDF'],
            'PICT' => $this['PICT'],
            'XMP-plus' => $this['XMP-plus'],
            'PNG' => $this['PNG'],
            'PNG-pHYs' => $this['PNG-pHYs'],
            'PSP' => $this['PSP'],
            'MOBI' => $this['MOBI'],
            'Palm' => $this['Palm'],
            'Leica' => $this['Leica'],
            'Panasonic' => $this['Panasonic'],
            'CameraIFD' => $this['CameraIFD'],
            'PanasonicRaw' => $this['PanasonicRaw'],
            'Pentax' => $this['Pentax'],
            'PhaseOne' => $this['PhaseOne'],
            'PhotoCD' => $this['PhotoCD'],
            'PhotoMechanic' => $this['PhotoMechanic'],
            'XMP-photomech' => $this['XMP-photomech'],
            'PostScript' => $this['PostScript'],
            'PrintIM' => $this['PrintIM'],
            'Qualcomm' => $this['Qualcomm'],
            'QuickTime' => $this['QuickTime'],
            'MakerNotes' => $this['MakerNotes'],
            'ItemList' => $this['ItemList'],
            'Keys' => $this['Keys'],
            'Track#' => $this['Track#'],
            'Meta' => $this['Meta'],
            'UserData' => $this['UserData'],
            'RIFF' => $this['RIFF'],
            'RSRC' => $this['RSRC'],
            'RTF' => $this['RTF'],
            'Radiance' => $this['Radiance'],
            'Rawzor' => $this['Rawzor'],
            'Real-RA3' => $this['Real-RA3'],
            'Real-RA4' => $this['Real-RA4'],
            'Real-RA5' => $this['Real-RA5'],
            'Real-CONT' => $this['Real-CONT'],
            'Real-MDPR' => $this['Real-MDPR'],
            'Real-RJMD' => $this['Real-RJMD'],
            'Real' => $this['Real'],
            'Real-PROP' => $this['Real-PROP'],
            'Reconyx' => $this['Reconyx'],
            'Red' => $this['Red'],
            'Ricoh' => $this['Ricoh'],
            'RMETA' => $this['RMETA'],
            'Samsung' => $this['Samsung'],
            'Sanyo' => $this['Sanyo'],
            'Scalado' => $this['Scalado'],
            'Sigma' => $this['Sigma'],
            'SigmaRaw' => $this['SigmaRaw'],
            'Sony' => $this['Sony'],
            'SR2DataIFD' => $this['SR2DataIFD'],
            'SR2' => $this['SR2'],
            'SR2SubIFD' => $this['SR2SubIFD'],
            'SRF#' => $this['SRF#'],
            'SonyIDC' => $this['SonyIDC'],
            'Stim' => $this['Stim'],
            'Theora' => $this['Theora'],
            'Torrent' => $this['Torrent'],
            'VCard' => $this['VCard'],
            'VCalendar' => $this['VCalendar'],
            'Vorbis' => $this['Vorbis'],
            'WTV' => $this['WTV'],
            'XMP-album' => $this['XMP-album'],
            'XMP-DICOM' => $this['XMP-DICOM'],
            'XMP-expressionmedia' => $this['XMP-expressionmedia'],
            'XMP-GAudio' => $this['XMP-GAudio'],
            'XMP-GCamera' => $this['XMP-GCamera'],
            'XMP-GCreations' => $this['XMP-GCreations'],
            'XMP-GDepth' => $this['XMP-GDepth'],
            'XMP-GFocus' => $this['XMP-GFocus'],
            'XMP-GImage' => $this['XMP-GImage'],
            'XMP-GPano' => $this['XMP-GPano'],
            'GSpherical' => $this['GSpherical'],
            'XMP-getty' => $this['XMP-getty'],
            'XMP-LImage' => $this['XMP-LImage'],
            'XMP-lr' => $this['XMP-lr'],
            'XMP-mediapro' => $this['XMP-mediapro'],
            'XMP-PixelLive' => $this['XMP-PixelLive'],
            'SVG' => $this['SVG'],
            'XMP-aas' => $this['XMP-aas'],
            'XMP-acdsee' => $this['XMP-acdsee'],
            'XMP-apple-fi' => $this['XMP-apple-fi'],
            'XMP-aux' => $this['XMP-aux'],
            'XMP-cc' => $this['XMP-cc'],
            'XMP-cell' => $this['XMP-cell'],
            'XMP-crd' => $this['XMP-crd'],
            'XMP-creatorAtom' => $this['XMP-creatorAtom'],
            'XMP-crs' => $this['XMP-crs'],
            'XMP-dc' => $this['XMP-dc'],
            'XMP-dex' => $this['XMP-dex'],
            'XMP-digiKam' => $this['XMP-digiKam'],
            'XMP-extensis' => $this['XMP-extensis'],
            'XMP-fpv' => $this['XMP-fpv'],
            'XMP-ics' => $this['XMP-ics'],
            
            'XMP-iptcExt' => $this['XMP-iptcExt'],
            'XMP-pdf' => $this['XMP-pdf'],
            'XMP-photoshop' => $this['XMP-photoshop'],
            'XMP-pmi' => $this['XMP-pmi'],
            'XMP-prism' => $this['XMP-prism'],
            'XMP-prl' => $this['XMP-prl'],
            'XMP-prm' => $this['XMP-prm'],
            'XMP-pur' => $this['XMP-pur'],
            'XMP-rdf' => $this['XMP-rdf'],
            'XMP-swf' => $this['XMP-swf'],
            'XMP-tiff' => $this['XMP-tiff'],
            'XMP-x' => $this['XMP-x'],
            'XMP-xmp' => $this['XMP-xmp'],
            'XMP-xmpBJ' => $this['XMP-xmpBJ'],
            'XMP-xmpDM' => $this['XMP-xmpDM'],
            'XMP-xmpMM' => $this['XMP-xmpMM'],
            'XMP-xmpNote' => $this['XMP-xmpNote'],
            'XMP-xmpPLUS' => $this['XMP-xmpPLUS'],
            'XMP-xmpRights' => $this['XMP-xmpRights'],
            'XMP-xmpTPg' => $this['XMP-xmpTPg'],
            
        );
    }
    public function getLookupTable()
    {
        return array(
            'afcp' => array(
                'thumbnailimage' => array(
                    'namespace' => 'AFCP',
                    'tagname' => 'ThumbnailImage',
                    'classname' => 'PHPExiftool\Driver\Tag\AFCP\ThumbnailImage',
                ),
                'previewimage' => array(
                    'namespace' => 'AFCP',
                    'tagname' => 'PreviewImage',
                    'classname' => 'PHPExiftool\Driver\Tag\AFCP\PreviewImage',
                ),
                'text' => array(
                    'namespace' => 'AFCP',
                    'tagname' => 'Text',
                    'classname' => 'PHPExiftool\Driver\Tag\AFCP\Text',
                ),
            ),
            'mac' => array(
                'compressionlevel' => array(
                    'namespace' => 'MAC',
                    'tagname' => 'CompressionLevel',
                    'classname' => 'PHPExiftool\Driver\Tag\MAC\CompressionLevel',
                ),
                'blocksperframe' => array(
                    'namespace' => 'MAC',
                    'tagname' => 'BlocksPerFrame',
                    'classname' => 'PHPExiftool\Driver\Tag\MAC\BlocksPerFrame',
                ),
                'finalframeblocks' => array(
                    'namespace' => 'MAC',
                    'tagname' => 'FinalFrameBlocks',
                    'classname' => 'PHPExiftool\Driver\Tag\MAC\FinalFrameBlocks',
                ),
                'totalframes' => array(
                    'namespace' => 'MAC',
                    'tagname' => 'TotalFrames',
                    'classname' => 'PHPExiftool\Driver\Tag\MAC\TotalFrames',
                ),
                'bitspersample' => array(
                    'namespace' => 'MAC',
                    'tagname' => 'BitsPerSample',
                    'classname' => 'PHPExiftool\Driver\Tag\MAC\BitsPerSample',
                ),
                'channels' => array(
                    'namespace' => 'MAC',
                    'tagname' => 'Channels',
                    'classname' => 'PHPExiftool\Driver\Tag\MAC\Channels',
                ),
                'samplerate' => array(
                    'namespace' => 'MAC',
                    'tagname' => 'SampleRate',
                    'classname' => 'PHPExiftool\Driver\Tag\MAC\SampleRate',
                ),
                'apeversion' => array(
                    'namespace' => 'MAC',
                    'tagname' => 'APEVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\MAC\APEVersion',
                ),
            ),
            'ducky' => array(
                'quality' => array(
                    'namespace' => 'Ducky',
                    'tagname' => 'Quality',
                    'classname' => 'PHPExiftool\Driver\Tag\Ducky\Quality',
                ),
                'comment' => array(
                    'namespace' => 'Ducky',
                    'tagname' => 'Comment',
                    'classname' => 'PHPExiftool\Driver\Tag\Ducky\Comment',
                ),
                'copyright' => array(
                    'namespace' => 'Ducky',
                    'tagname' => 'Copyright',
                    'classname' => 'PHPExiftool\Driver\Tag\Ducky\Copyright',
                ),
            ),
            'pictureinfo' => array(
                'aperture' => array(
                    'namespace' => 'PictureInfo',
                    'tagname' => 'Aperture',
                    'classname' => 'PHPExiftool\Driver\Tag\PictureInfo\Aperture',
                ),
                'colormode' => array(
                    'namespace' => 'PictureInfo',
                    'tagname' => 'ColorMode',
                    'classname' => 'PHPExiftool\Driver\Tag\PictureInfo\ColorMode',
                ),
                'contake' => array(
                    'namespace' => 'PictureInfo',
                    'tagname' => 'ConTake',
                    'classname' => 'PHPExiftool\Driver\Tag\PictureInfo\ConTake',
                ),
                'exposurecompensation' => array(
                    'namespace' => 'PictureInfo',
                    'tagname' => 'ExposureCompensation',
                    'classname' => 'PHPExiftool\Driver\Tag\PictureInfo\ExposureCompensation',
                ),
                'fnumber' => array(
                    'namespace' => 'PictureInfo',
                    'tagname' => 'FNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\PictureInfo\FNumber',
                ),
                'firmwareversion' => array(
                    'namespace' => 'PictureInfo',
                    'tagname' => 'FirmwareVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\PictureInfo\FirmwareVersion',
                ),
                'flash' => array(
                    'namespace' => 'PictureInfo',
                    'tagname' => 'Flash',
                    'classname' => 'PHPExiftool\Driver\Tag\PictureInfo\Flash',
                ),
                'focusmode' => array(
                    'namespace' => 'PictureInfo',
                    'tagname' => 'FocusMode',
                    'classname' => 'PHPExiftool\Driver\Tag\PictureInfo\FocusMode',
                ),
                'focuspos' => array(
                    'namespace' => 'PictureInfo',
                    'tagname' => 'FocusPos',
                    'classname' => 'PHPExiftool\Driver\Tag\PictureInfo\FocusPos',
                ),
                'id' => array(
                    'namespace' => 'PictureInfo',
                    'tagname' => 'ID',
                    'classname' => 'PHPExiftool\Driver\Tag\PictureInfo\ID',
                ),
                'imagesize' => array(
                    'namespace' => 'PictureInfo',
                    'tagname' => 'ImageSize',
                    'classname' => 'PHPExiftool\Driver\Tag\PictureInfo\ImageSize',
                ),
                'lights' => array(
                    'namespace' => 'PictureInfo',
                    'tagname' => 'LightS',
                    'classname' => 'PHPExiftool\Driver\Tag\PictureInfo\LightS',
                ),
                'macro' => array(
                    'namespace' => 'PictureInfo',
                    'tagname' => 'Macro',
                    'classname' => 'PHPExiftool\Driver\Tag\PictureInfo\Macro',
                ),
                'protect' => array(
                    'namespace' => 'PictureInfo',
                    'tagname' => 'Protect',
                    'classname' => 'PHPExiftool\Driver\Tag\PictureInfo\Protect',
                ),
                'quality' => array(
                    'namespace' => 'PictureInfo',
                    'tagname' => 'Quality',
                    'classname' => 'PHPExiftool\Driver\Tag\PictureInfo\Quality',
                ),
                'resolution' => array(
                    'namespace' => 'PictureInfo',
                    'tagname' => 'Resolution',
                    'classname' => 'PHPExiftool\Driver\Tag\PictureInfo\Resolution',
                ),
                'serialnumber' => array(
                    'namespace' => 'PictureInfo',
                    'tagname' => 'SerialNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\PictureInfo\SerialNumber',
                ),
                'exposuretime' => array(
                    'namespace' => 'PictureInfo',
                    'tagname' => 'ExposureTime',
                    'classname' => 'PHPExiftool\Driver\Tag\PictureInfo\ExposureTime',
                ),
                'strobetime' => array(
                    'namespace' => 'PictureInfo',
                    'tagname' => 'StrobeTime',
                    'classname' => 'PHPExiftool\Driver\Tag\PictureInfo\StrobeTime',
                ),
                'datetimeoriginal' => array(
                    'namespace' => 'PictureInfo',
                    'tagname' => 'DateTimeOriginal',
                    'classname' => 'PHPExiftool\Driver\Tag\PictureInfo\DateTimeOriginal',
                ),
                'cameratype' => array(
                    'namespace' => 'PictureInfo',
                    'tagname' => 'CameraType',
                    'classname' => 'PHPExiftool\Driver\Tag\PictureInfo\CameraType',
                ),
                'version' => array(
                    'namespace' => 'PictureInfo',
                    'tagname' => 'Version',
                    'classname' => 'PHPExiftool\Driver\Tag\PictureInfo\Version',
                ),
                'ytarget' => array(
                    'namespace' => 'PictureInfo',
                    'tagname' => 'YTarget',
                    'classname' => 'PHPExiftool\Driver\Tag\PictureInfo\YTarget',
                ),
                'zoom' => array(
                    'namespace' => 'PictureInfo',
                    'tagname' => 'Zoom',
                    'classname' => 'PHPExiftool\Driver\Tag\PictureInfo\Zoom',
                ),
                'zoompos' => array(
                    'namespace' => 'PictureInfo',
                    'tagname' => 'ZoomPos',
                    'classname' => 'PHPExiftool\Driver\Tag\PictureInfo\ZoomPos',
                ),
                'ylevel' => array(
                    'namespace' => 'PictureInfo',
                    'tagname' => 'YLevel',
                    'classname' => 'PHPExiftool\Driver\Tag\PictureInfo\YLevel',
                ),
            ),
            'apple' => array(
                'accelerationvector' => array(
                    'namespace' => 'Apple',
                    'tagname' => 'AccelerationVector',
                    'classname' => 'PHPExiftool\Driver\Tag\Apple\AccelerationVector',
                ),
                'hdrimagetype' => array(
                    'namespace' => 'Apple',
                    'tagname' => 'HDRImageType',
                    'classname' => 'PHPExiftool\Driver\Tag\Apple\HDRImageType',
                ),
                'burstuuid' => array(
                    'namespace' => 'Apple',
                    'tagname' => 'BurstUUID',
                    'classname' => 'PHPExiftool\Driver\Tag\Apple\BurstUUID',
                ),
                'contentidentifier' => array(
                    'namespace' => 'Apple',
                    'tagname' => 'ContentIdentifier',
                    'classname' => 'PHPExiftool\Driver\Tag\Apple\ContentIdentifier',
                ),
                'imageuniqueid' => array(
                    'namespace' => 'Apple',
                    'tagname' => 'ImageUniqueID',
                    'classname' => 'PHPExiftool\Driver\Tag\Apple\ImageUniqueID',
                ),
                'runtimeepoch' => array(
                    'namespace' => 'Apple',
                    'tagname' => 'RunTimeEpoch',
                    'classname' => 'PHPExiftool\Driver\Tag\Apple\RunTimeEpoch',
                ),
                'runtimeflags' => array(
                    'namespace' => 'Apple',
                    'tagname' => 'RunTimeFlags',
                    'classname' => 'PHPExiftool\Driver\Tag\Apple\RunTimeFlags',
                ),
                'runtimescale' => array(
                    'namespace' => 'Apple',
                    'tagname' => 'RunTimeScale',
                    'classname' => 'PHPExiftool\Driver\Tag\Apple\RunTimeScale',
                ),
                'runtimevalue' => array(
                    'namespace' => 'Apple',
                    'tagname' => 'RunTimeValue',
                    'classname' => 'PHPExiftool\Driver\Tag\Apple\RunTimeValue',
                ),
            ),
            'audible' => array(
                'chaptercount' => array(
                    'namespace' => 'Audible',
                    'tagname' => 'ChapterCount',
                    'classname' => 'PHPExiftool\Driver\Tag\Audible\ChapterCount',
                ),
                'coverart' => array(
                    'namespace' => 'Audible',
                    'tagname' => 'CoverArt',
                    'classname' => 'PHPExiftool\Driver\Tag\Audible\CoverArt',
                ),
                'author' => array(
                    'namespace' => 'Audible',
                    'tagname' => 'Author',
                    'classname' => 'PHPExiftool\Driver\Tag\Audible\Author',
                ),
                'copyright' => array(
                    'namespace' => 'Audible',
                    'tagname' => 'Copyright',
                    'classname' => 'PHPExiftool\Driver\Tag\Audible\Copyright',
                ),
                'publishdatestart' => array(
                    'namespace' => 'Audible',
                    'tagname' => 'PublishDateStart',
                    'classname' => 'PHPExiftool\Driver\Tag\Audible\PublishDateStart',
                ),
                'publishdate' => array(
                    'namespace' => 'Audible',
                    'tagname' => 'PublishDate',
                    'classname' => 'PHPExiftool\Driver\Tag\Audible\PublishDate',
                ),
                'coverarttype' => array(
                    'namespace' => 'Audible',
                    'tagname' => 'CoverArtType',
                    'classname' => 'PHPExiftool\Driver\Tag\Audible\CoverArtType',
                ),
                'albumartist' => array(
                    'namespace' => 'Audible',
                    'tagname' => 'AlbumArtist',
                    'classname' => 'PHPExiftool\Driver\Tag\Audible\AlbumArtist',
                ),
                'album' => array(
                    'namespace' => 'Audible',
                    'tagname' => 'Album',
                    'classname' => 'PHPExiftool\Driver\Tag\Audible\Album',
                ),
                'artist' => array(
                    'namespace' => 'Audible',
                    'tagname' => 'Artist',
                    'classname' => 'PHPExiftool\Driver\Tag\Audible\Artist',
                ),
                'comment' => array(
                    'namespace' => 'Audible',
                    'tagname' => 'Comment',
                    'classname' => 'PHPExiftool\Driver\Tag\Audible\Comment',
                ),
                'genre' => array(
                    'namespace' => 'Audible',
                    'tagname' => 'Genre',
                    'classname' => 'PHPExiftool\Driver\Tag\Audible\Genre',
                ),
                'subtitle' => array(
                    'namespace' => 'Audible',
                    'tagname' => 'Subtitle',
                    'classname' => 'PHPExiftool\Driver\Tag\Audible\Subtitle',
                ),
                'creatortool' => array(
                    'namespace' => 'Audible',
                    'tagname' => 'CreatorTool',
                    'classname' => 'PHPExiftool\Driver\Tag\Audible\CreatorTool',
                ),
                'title' => array(
                    'namespace' => 'Audible',
                    'tagname' => 'Title',
                    'classname' => 'PHPExiftool\Driver\Tag\Audible\Title',
                ),
                'year' => array(
                    'namespace' => 'Audible',
                    'tagname' => 'Year',
                    'classname' => 'PHPExiftool\Driver\Tag\Audible\Year',
                ),
                'itunesmediatype' => array(
                    'namespace' => 'Audible',
                    'tagname' => 'iTunesMediaType',
                    'classname' => 'PHPExiftool\Driver\Tag\Audible\ITunesMediaType',
                ),
                'chaptername' => array(
                    'namespace' => 'Audible',
                    'tagname' => 'ChapterName',
                    'classname' => 'PHPExiftool\Driver\Tag\Audible\ChapterName',
                ),
                'chapternumber' => array(
                    'namespace' => 'Audible',
                    'tagname' => 'ChapterNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\Audible\ChapterNumber',
                ),
            ),
            'file' => array(
                'embeddedjpg' => array(
                    'namespace' => 'File',
                    'tagname' => 'EmbeddedJPG',
                    'classname' => 'PHPExiftool\Driver\Tag\File\EmbeddedJPG',
                ),
                'embeddedpng' => array(
                    'namespace' => 'File',
                    'tagname' => 'EmbeddedPNG',
                    'classname' => 'PHPExiftool\Driver\Tag\File\EmbeddedPNG',
                ),
                'linkedprofilename' => array(
                    'namespace' => 'File',
                    'tagname' => 'LinkedProfileName',
                    'classname' => 'PHPExiftool\Driver\Tag\File\LinkedProfileName',
                ),
                'bmpversion' => array(
                    'namespace' => 'File',
                    'tagname' => 'BMPVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\File\BMPVersion',
                ),
                'imagewidth' => array(
                    'namespace' => 'File',
                    'tagname' => 'ImageWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\File\ImageWidth',
                ),
                'imageheight' => array(
                    'namespace' => 'File',
                    'tagname' => 'ImageHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\File\ImageHeight',
                ),
                'planes' => array(
                    'namespace' => 'File',
                    'tagname' => 'Planes',
                    'classname' => 'PHPExiftool\Driver\Tag\File\Planes',
                ),
                'bitdepth' => array(
                    'namespace' => 'File',
                    'tagname' => 'BitDepth',
                    'classname' => 'PHPExiftool\Driver\Tag\File\BitDepth',
                ),
                'compression' => array(
                    'namespace' => 'File',
                    'tagname' => 'Compression',
                    'classname' => 'PHPExiftool\Driver\Tag\File\Compression',
                ),
                'imagelength' => array(
                    'namespace' => 'File',
                    'tagname' => 'ImageLength',
                    'classname' => 'PHPExiftool\Driver\Tag\File\ImageLength',
                ),
                'pixelspermeterx' => array(
                    'namespace' => 'File',
                    'tagname' => 'PixelsPerMeterX',
                    'classname' => 'PHPExiftool\Driver\Tag\File\PixelsPerMeterX',
                ),
                'pixelspermetery' => array(
                    'namespace' => 'File',
                    'tagname' => 'PixelsPerMeterY',
                    'classname' => 'PHPExiftool\Driver\Tag\File\PixelsPerMeterY',
                ),
                'numcolors' => array(
                    'namespace' => 'File',
                    'tagname' => 'NumColors',
                    'classname' => 'PHPExiftool\Driver\Tag\File\NumColors',
                ),
                'numimportantcolors' => array(
                    'namespace' => 'File',
                    'tagname' => 'NumImportantColors',
                    'classname' => 'PHPExiftool\Driver\Tag\File\NumImportantColors',
                ),
                'redmask' => array(
                    'namespace' => 'File',
                    'tagname' => 'RedMask',
                    'classname' => 'PHPExiftool\Driver\Tag\File\RedMask',
                ),
                'greenmask' => array(
                    'namespace' => 'File',
                    'tagname' => 'GreenMask',
                    'classname' => 'PHPExiftool\Driver\Tag\File\GreenMask',
                ),
                'bluemask' => array(
                    'namespace' => 'File',
                    'tagname' => 'BlueMask',
                    'classname' => 'PHPExiftool\Driver\Tag\File\BlueMask',
                ),
                'alphamask' => array(
                    'namespace' => 'File',
                    'tagname' => 'AlphaMask',
                    'classname' => 'PHPExiftool\Driver\Tag\File\AlphaMask',
                ),
                'colorspace' => array(
                    'namespace' => 'File',
                    'tagname' => 'ColorSpace',
                    'classname' => 'PHPExiftool\Driver\Tag\File\ColorSpace',
                ),
                'redendpoint' => array(
                    'namespace' => 'File',
                    'tagname' => 'RedEndpoint',
                    'classname' => 'PHPExiftool\Driver\Tag\File\RedEndpoint',
                ),
                'greenendpoint' => array(
                    'namespace' => 'File',
                    'tagname' => 'GreenEndpoint',
                    'classname' => 'PHPExiftool\Driver\Tag\File\GreenEndpoint',
                ),
                'blueendpoint' => array(
                    'namespace' => 'File',
                    'tagname' => 'BlueEndpoint',
                    'classname' => 'PHPExiftool\Driver\Tag\File\BlueEndpoint',
                ),
                'gammared' => array(
                    'namespace' => 'File',
                    'tagname' => 'GammaRed',
                    'classname' => 'PHPExiftool\Driver\Tag\File\GammaRed',
                ),
                'gammagreen' => array(
                    'namespace' => 'File',
                    'tagname' => 'GammaGreen',
                    'classname' => 'PHPExiftool\Driver\Tag\File\GammaGreen',
                ),
                'gammablue' => array(
                    'namespace' => 'File',
                    'tagname' => 'GammaBlue',
                    'classname' => 'PHPExiftool\Driver\Tag\File\GammaBlue',
                ),
                'renderingintent' => array(
                    'namespace' => 'File',
                    'tagname' => 'RenderingIntent',
                    'classname' => 'PHPExiftool\Driver\Tag\File\RenderingIntent',
                ),
                'profiledataoffset' => array(
                    'namespace' => 'File',
                    'tagname' => 'ProfileDataOffset',
                    'classname' => 'PHPExiftool\Driver\Tag\File\ProfileDataOffset',
                ),
                'profilesize' => array(
                    'namespace' => 'File',
                    'tagname' => 'ProfileSize',
                    'classname' => 'PHPExiftool\Driver\Tag\File\ProfileSize',
                ),
                'thumbnailbpg' => array(
                    'namespace' => 'File',
                    'tagname' => 'ThumbnailBPG',
                    'classname' => 'PHPExiftool\Driver\Tag\File\ThumbnailBPG',
                ),
                'animationcontrol' => array(
                    'namespace' => 'File',
                    'tagname' => 'AnimationControl',
                    'classname' => 'PHPExiftool\Driver\Tag\File\AnimationControl',
                ),
                'pixelformat' => array(
                    'namespace' => 'File',
                    'tagname' => 'PixelFormat',
                    'classname' => 'PHPExiftool\Driver\Tag\File\PixelFormat',
                ),
                'alpha' => array(
                    'namespace' => 'File',
                    'tagname' => 'Alpha',
                    'classname' => 'PHPExiftool\Driver\Tag\File\Alpha',
                ),
                'flags' => array(
                    'namespace' => 'File',
                    'tagname' => 'Flags',
                    'classname' => 'PHPExiftool\Driver\Tag\File\Flags',
                ),
                'byteorder' => array(
                    'namespace' => 'File',
                    'tagname' => 'ByteOrder',
                    'classname' => 'PHPExiftool\Driver\Tag\File\ByteOrder',
                ),
                'headerversion' => array(
                    'namespace' => 'File',
                    'tagname' => 'HeaderVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\File\HeaderVersion',
                ),
                'dpxfilesize' => array(
                    'namespace' => 'File',
                    'tagname' => 'DPXFileSize',
                    'classname' => 'PHPExiftool\Driver\Tag\File\DPXFileSize',
                ),
                'dittokey' => array(
                    'namespace' => 'File',
                    'tagname' => 'DittoKey',
                    'classname' => 'PHPExiftool\Driver\Tag\File\DittoKey',
                ),
                'imagefilename' => array(
                    'namespace' => 'File',
                    'tagname' => 'ImageFileName',
                    'classname' => 'PHPExiftool\Driver\Tag\File\ImageFileName',
                ),
                'createdate' => array(
                    'namespace' => 'File',
                    'tagname' => 'CreateDate',
                    'classname' => 'PHPExiftool\Driver\Tag\File\CreateDate',
                ),
                'creator' => array(
                    'namespace' => 'File',
                    'tagname' => 'Creator',
                    'classname' => 'PHPExiftool\Driver\Tag\File\Creator',
                ),
                'project' => array(
                    'namespace' => 'File',
                    'tagname' => 'Project',
                    'classname' => 'PHPExiftool\Driver\Tag\File\Project',
                ),
                'copyright' => array(
                    'namespace' => 'File',
                    'tagname' => 'Copyright',
                    'classname' => 'PHPExiftool\Driver\Tag\File\Copyright',
                ),
                'encryptionkey' => array(
                    'namespace' => 'File',
                    'tagname' => 'EncryptionKey',
                    'classname' => 'PHPExiftool\Driver\Tag\File\EncryptionKey',
                ),
                'orientation' => array(
                    'namespace' => 'File',
                    'tagname' => 'Orientation',
                    'classname' => 'PHPExiftool\Driver\Tag\File\Orientation',
                ),
                'imageelements' => array(
                    'namespace' => 'File',
                    'tagname' => 'ImageElements',
                    'classname' => 'PHPExiftool\Driver\Tag\File\ImageElements',
                ),
                'datasign' => array(
                    'namespace' => 'File',
                    'tagname' => 'DataSign',
                    'classname' => 'PHPExiftool\Driver\Tag\File\DataSign',
                ),
                'componentsconfiguration' => array(
                    'namespace' => 'File',
                    'tagname' => 'ComponentsConfiguration',
                    'classname' => 'PHPExiftool\Driver\Tag\File\ComponentsConfiguration',
                ),
                'imagedescription' => array(
                    'namespace' => 'File',
                    'tagname' => 'ImageDescription',
                    'classname' => 'PHPExiftool\Driver\Tag\File\ImageDescription',
                ),
                'image2description' => array(
                    'namespace' => 'File',
                    'tagname' => 'Image2Description',
                    'classname' => 'PHPExiftool\Driver\Tag\File\Image2Description',
                ),
                'image3description' => array(
                    'namespace' => 'File',
                    'tagname' => 'Image3Description',
                    'classname' => 'PHPExiftool\Driver\Tag\File\Image3Description',
                ),
                'image4description' => array(
                    'namespace' => 'File',
                    'tagname' => 'Image4Description',
                    'classname' => 'PHPExiftool\Driver\Tag\File\Image4Description',
                ),
                'image5description' => array(
                    'namespace' => 'File',
                    'tagname' => 'Image5Description',
                    'classname' => 'PHPExiftool\Driver\Tag\File\Image5Description',
                ),
                'image6description' => array(
                    'namespace' => 'File',
                    'tagname' => 'Image6Description',
                    'classname' => 'PHPExiftool\Driver\Tag\File\Image6Description',
                ),
                'image7description' => array(
                    'namespace' => 'File',
                    'tagname' => 'Image7Description',
                    'classname' => 'PHPExiftool\Driver\Tag\File\Image7Description',
                ),
                'image8description' => array(
                    'namespace' => 'File',
                    'tagname' => 'Image8Description',
                    'classname' => 'PHPExiftool\Driver\Tag\File\Image8Description',
                ),
                'sourcefilename' => array(
                    'namespace' => 'File',
                    'tagname' => 'SourceFileName',
                    'classname' => 'PHPExiftool\Driver\Tag\File\SourceFileName',
                ),
                'sourcecreatedate' => array(
                    'namespace' => 'File',
                    'tagname' => 'SourceCreateDate',
                    'classname' => 'PHPExiftool\Driver\Tag\File\SourceCreateDate',
                ),
                'inputdevicename' => array(
                    'namespace' => 'File',
                    'tagname' => 'InputDeviceName',
                    'classname' => 'PHPExiftool\Driver\Tag\File\InputDeviceName',
                ),
                'inputdeviceserialnumber' => array(
                    'namespace' => 'File',
                    'tagname' => 'InputDeviceSerialNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\File\InputDeviceSerialNumber',
                ),
                'framerate' => array(
                    'namespace' => 'File',
                    'tagname' => 'FrameRate',
                    'classname' => 'PHPExiftool\Driver\Tag\File\FrameRate',
                ),
                'frameid' => array(
                    'namespace' => 'File',
                    'tagname' => 'FrameID',
                    'classname' => 'PHPExiftool\Driver\Tag\File\FrameID',
                ),
                'slateinformation' => array(
                    'namespace' => 'File',
                    'tagname' => 'SlateInformation',
                    'classname' => 'PHPExiftool\Driver\Tag\File\SlateInformation',
                ),
                'reserved5' => array(
                    'namespace' => 'File',
                    'tagname' => 'Reserved5',
                    'classname' => 'PHPExiftool\Driver\Tag\File\Reserved5',
                ),
                'userid' => array(
                    'namespace' => 'File',
                    'tagname' => 'UserID',
                    'classname' => 'PHPExiftool\Driver\Tag\File\UserID',
                ),
                'comment' => array(
                    'namespace' => 'File',
                    'tagname' => 'Comment',
                    'classname' => 'PHPExiftool\Driver\Tag\File\Comment',
                ),
                'currentiptcdigest' => array(
                    'namespace' => 'File',
                    'tagname' => 'CurrentIPTCDigest',
                    'classname' => 'PHPExiftool\Driver\Tag\File\CurrentIPTCDigest',
                ),
                'embeddedvideo' => array(
                    'namespace' => 'File',
                    'tagname' => 'EmbeddedVideo',
                    'classname' => 'PHPExiftool\Driver\Tag\File\EmbeddedVideo',
                ),
                'exifbyteorder' => array(
                    'namespace' => 'File',
                    'tagname' => 'ExifByteOrder',
                    'classname' => 'PHPExiftool\Driver\Tag\File\ExifByteOrder',
                ),
                'exifunicodebyteorder' => array(
                    'namespace' => 'File',
                    'tagname' => 'ExifUnicodeByteOrder',
                    'classname' => 'PHPExiftool\Driver\Tag\File\ExifUnicodeByteOrder',
                ),
                'filetype' => array(
                    'namespace' => 'File',
                    'tagname' => 'FileType',
                    'classname' => 'PHPExiftool\Driver\Tag\File\FileType',
                ),
                'filetypeextension' => array(
                    'namespace' => 'File',
                    'tagname' => 'FileTypeExtension',
                    'classname' => 'PHPExiftool\Driver\Tag\File\FileTypeExtension',
                ),
                'geosync' => array(
                    'namespace' => 'File',
                    'tagname' => 'Geosync',
                    'classname' => 'PHPExiftool\Driver\Tag\File\Geosync',
                ),
                'geotag' => array(
                    'namespace' => 'File',
                    'tagname' => 'Geotag',
                    'classname' => 'PHPExiftool\Driver\Tag\File\Geotag',
                ),
                'geotime' => array(
                    'namespace' => 'File',
                    'tagname' => 'Geotime',
                    'classname' => 'PHPExiftool\Driver\Tag\File\Geotime',
                ),
                'hardlink' => array(
                    'namespace' => 'File',
                    'tagname' => 'HardLink',
                    'classname' => 'PHPExiftool\Driver\Tag\File\HardLink',
                ),
                'id3size' => array(
                    'namespace' => 'File',
                    'tagname' => 'ID3Size',
                    'classname' => 'PHPExiftool\Driver\Tag\File\ID3Size',
                ),
                'jpegdigest' => array(
                    'namespace' => 'File',
                    'tagname' => 'JPEGDigest',
                    'classname' => 'PHPExiftool\Driver\Tag\File\JPEGDigest',
                ),
                'jpegimagelength' => array(
                    'namespace' => 'File',
                    'tagname' => 'JPEGImageLength',
                    'classname' => 'PHPExiftool\Driver\Tag\File\JPEGImageLength',
                ),
                'jpegqualityestimate' => array(
                    'namespace' => 'File',
                    'tagname' => 'JPEGQualityEstimate',
                    'classname' => 'PHPExiftool\Driver\Tag\File\JPEGQualityEstimate',
                ),
                'mimetype' => array(
                    'namespace' => 'File',
                    'tagname' => 'MIMEType',
                    'classname' => 'PHPExiftool\Driver\Tag\File\MIMEType',
                ),
                'maxval' => array(
                    'namespace' => 'File',
                    'tagname' => 'MaxVal',
                    'classname' => 'PHPExiftool\Driver\Tag\File\MaxVal',
                ),
                'otherimage' => array(
                    'namespace' => 'File',
                    'tagname' => 'OtherImage',
                    'classname' => 'PHPExiftool\Driver\Tag\File\OtherImage',
                ),
                'previewpdf' => array(
                    'namespace' => 'File',
                    'tagname' => 'PreviewPDF',
                    'classname' => 'PHPExiftool\Driver\Tag\File\PreviewPDF',
                ),
                'previewpng' => array(
                    'namespace' => 'File',
                    'tagname' => 'PreviewPNG',
                    'classname' => 'PHPExiftool\Driver\Tag\File\PreviewPNG',
                ),
                'previewtiff' => array(
                    'namespace' => 'File',
                    'tagname' => 'PreviewTIFF',
                    'classname' => 'PHPExiftool\Driver\Tag\File\PreviewTIFF',
                ),
                'previewwmf' => array(
                    'namespace' => 'File',
                    'tagname' => 'PreviewWMF',
                    'classname' => 'PHPExiftool\Driver\Tag\File\PreviewWMF',
                ),
                'rafversion' => array(
                    'namespace' => 'File',
                    'tagname' => 'RAFVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\File\RAFVersion',
                ),
                'symlink' => array(
                    'namespace' => 'File',
                    'tagname' => 'SymLink',
                    'classname' => 'PHPExiftool\Driver\Tag\File\SymLink',
                ),
                'testname' => array(
                    'namespace' => 'File',
                    'tagname' => 'TestName',
                    'classname' => 'PHPExiftool\Driver\Tag\File\TestName',
                ),
                'thumbnailimage' => array(
                    'namespace' => 'File',
                    'tagname' => 'ThumbnailImage',
                    'classname' => 'PHPExiftool\Driver\Tag\File\ThumbnailImage',
                ),
                'xresolution' => array(
                    'namespace' => 'File',
                    'tagname' => 'XResolution',
                    'classname' => 'PHPExiftool\Driver\Tag\File\XResolution',
                ),
                'yresolution' => array(
                    'namespace' => 'File',
                    'tagname' => 'YResolution',
                    'classname' => 'PHPExiftool\Driver\Tag\File\YResolution',
                ),
                'imagetype' => array(
                    'namespace' => 'File',
                    'tagname' => 'ImageType',
                    'classname' => 'PHPExiftool\Driver\Tag\File\ImageType',
                ),
                'animationframes' => array(
                    'namespace' => 'File',
                    'tagname' => 'AnimationFrames',
                    'classname' => 'PHPExiftool\Driver\Tag\File\AnimationFrames',
                ),
                'encoding' => array(
                    'namespace' => 'File',
                    'tagname' => 'Encoding',
                    'classname' => 'PHPExiftool\Driver\Tag\File\Encoding',
                ),
                'bitspersample' => array(
                    'namespace' => 'File',
                    'tagname' => 'BitsPerSample',
                    'classname' => 'PHPExiftool\Driver\Tag\File\BitsPerSample',
                ),
                'colorcomponents' => array(
                    'namespace' => 'File',
                    'tagname' => 'ColorComponents',
                    'classname' => 'PHPExiftool\Driver\Tag\File\ColorComponents',
                ),
                'encodingprocess' => array(
                    'namespace' => 'File',
                    'tagname' => 'EncodingProcess',
                    'classname' => 'PHPExiftool\Driver\Tag\File\EncodingProcess',
                ),
                'ycbcrsubsampling' => array(
                    'namespace' => 'File',
                    'tagname' => 'YCbCrSubSampling',
                    'classname' => 'PHPExiftool\Driver\Tag\File\YCbCrSubSampling',
                ),
                'manufacturer' => array(
                    'namespace' => 'File',
                    'tagname' => 'Manufacturer',
                    'classname' => 'PHPExiftool\Driver\Tag\File\Manufacturer',
                ),
                'software' => array(
                    'namespace' => 'File',
                    'tagname' => 'Software',
                    'classname' => 'PHPExiftool\Driver\Tag\File\Software',
                ),
                'bitsperpixel' => array(
                    'namespace' => 'File',
                    'tagname' => 'BitsPerPixel',
                    'classname' => 'PHPExiftool\Driver\Tag\File\BitsPerPixel',
                ),
                'leftmargin' => array(
                    'namespace' => 'File',
                    'tagname' => 'LeftMargin',
                    'classname' => 'PHPExiftool\Driver\Tag\File\LeftMargin',
                ),
                'topmargin' => array(
                    'namespace' => 'File',
                    'tagname' => 'TopMargin',
                    'classname' => 'PHPExiftool\Driver\Tag\File\TopMargin',
                ),
                'colorplanes' => array(
                    'namespace' => 'File',
                    'tagname' => 'ColorPlanes',
                    'classname' => 'PHPExiftool\Driver\Tag\File\ColorPlanes',
                ),
                'bytesperline' => array(
                    'namespace' => 'File',
                    'tagname' => 'BytesPerLine',
                    'classname' => 'PHPExiftool\Driver\Tag\File\BytesPerLine',
                ),
                'colormode' => array(
                    'namespace' => 'File',
                    'tagname' => 'ColorMode',
                    'classname' => 'PHPExiftool\Driver\Tag\File\ColorMode',
                ),
                'screenwidth' => array(
                    'namespace' => 'File',
                    'tagname' => 'ScreenWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\File\ScreenWidth',
                ),
                'screenheight' => array(
                    'namespace' => 'File',
                    'tagname' => 'ScreenHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\File\ScreenHeight',
                ),
                'pgfversion' => array(
                    'namespace' => 'File',
                    'tagname' => 'PGFVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\File\PGFVersion',
                ),
                'pyramidlevels' => array(
                    'namespace' => 'File',
                    'tagname' => 'PyramidLevels',
                    'classname' => 'PHPExiftool\Driver\Tag\File\PyramidLevels',
                ),
                'quality' => array(
                    'namespace' => 'File',
                    'tagname' => 'Quality',
                    'classname' => 'PHPExiftool\Driver\Tag\File\Quality',
                ),
                'backgroundcolor' => array(
                    'namespace' => 'File',
                    'tagname' => 'BackgroundColor',
                    'classname' => 'PHPExiftool\Driver\Tag\File\BackgroundColor',
                ),
                'byteordermark' => array(
                    'namespace' => 'File',
                    'tagname' => 'ByteOrderMark',
                    'classname' => 'PHPExiftool\Driver\Tag\File\ByteOrderMark',
                ),
                'linecount' => array(
                    'namespace' => 'File',
                    'tagname' => 'LineCount',
                    'classname' => 'PHPExiftool\Driver\Tag\File\LineCount',
                ),
                'mimeencoding' => array(
                    'namespace' => 'File',
                    'tagname' => 'MIMEEncoding',
                    'classname' => 'PHPExiftool\Driver\Tag\File\MIMEEncoding',
                ),
                'newlines' => array(
                    'namespace' => 'File',
                    'tagname' => 'Newlines',
                    'classname' => 'PHPExiftool\Driver\Tag\File\Newlines',
                ),
                'wordcount' => array(
                    'namespace' => 'File',
                    'tagname' => 'WordCount',
                    'classname' => 'PHPExiftool\Driver\Tag\File\WordCount',
                ),
            ),
            'composite' => array(
                'duration' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'Duration',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\Duration',
                ),
                'runtimesincepowerup' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'RunTimeSincePowerUp',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\RunTimeSincePowerUp',
                ),
                'conditionalfec' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'ConditionalFEC',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\ConditionalFEC',
                ),
                'digitalzoom' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'DigitalZoom',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\DigitalZoom',
                ),
                'drivemode' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'DriveMode',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\DriveMode',
                ),
                'filenumber' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'FileNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\FileNumber',
                ),
                'flashtype' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'FlashType',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\FlashType',
                ),
                'iso' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'ISO',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\ISO',
                ),
                'lens' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'Lens',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\Lens',
                ),
                'lens35efl' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'Lens35efl',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\Lens35efl',
                ),
                'originaldecisiondata' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'OriginalDecisionData',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\OriginalDecisionData',
                ),
                'redeyereduction' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'RedEyeReduction',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\RedEyeReduction',
                ),
                'shootingmode' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'ShootingMode',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\ShootingMode',
                ),
                'shuttercurtainhack' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'ShutterCurtainHack',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\ShutterCurtainHack',
                ),
                'wb_rggblevels' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'WB_RGGBLevels',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\WBRGGBLevels',
                ),
                'aperture' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'Aperture',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\Aperture',
                ),
                'bluebalance' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'BlueBalance',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\BlueBalance',
                ),
                'cfapattern' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'CFAPattern',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\CFAPattern',
                ),
                'circleofconfusion' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'CircleOfConfusion',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\CircleOfConfusion',
                ),
                'dof' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'DOF',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\DOF',
                ),
                'datetimeoriginal' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'DateTimeOriginal',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\DateTimeOriginal',
                ),
                'fov' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'FOV',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\FOV',
                ),
                'focallength35efl' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'FocalLength35efl',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\FocalLength35efl',
                ),
                'gpsposition' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'GPSPosition',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\GPSPosition',
                ),
                'hyperfocaldistance' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'HyperfocalDistance',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\HyperfocalDistance',
                ),
                'imagesize' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'ImageSize',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\ImageSize',
                ),
                'lensid' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'LensID',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\LensID',
                ),
                'lightvalue' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'LightValue',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\LightValue',
                ),
                'megapixels' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'Megapixels',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\Megapixels',
                ),
                'previewimagesize' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'PreviewImageSize',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\PreviewImageSize',
                ),
                'redbalance' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'RedBalance',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\RedBalance',
                ),
                'scalefactor35efl' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'ScaleFactor35efl',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\ScaleFactor35efl',
                ),
                'shutterspeed' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'ShutterSpeed',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\ShutterSpeed',
                ),
                'subseccreatedate' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'SubSecCreateDate',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\SubSecCreateDate',
                ),
                'subsecdatetimeoriginal' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'SubSecDateTimeOriginal',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\SubSecDateTimeOriginal',
                ),
                'subsecmodifydate' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'SubSecModifyDate',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\SubSecModifyDate',
                ),
                'thumbnailtiff' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'ThumbnailTIFF',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\ThumbnailTIFF',
                ),
                'previewimage' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'PreviewImage',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\PreviewImage',
                ),
                'gpsaltitude' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'GPSAltitude',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\GPSAltitude',
                ),
                'gpsdatetime' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'GPSDateTime',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\GPSDateTime',
                ),
                'gpsdestlatitude' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'GPSDestLatitude',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\GPSDestLatitude',
                ),
                'gpsdestlongitude' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'GPSDestLongitude',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\GPSDestLongitude',
                ),
                'gpslatitude' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'GPSLatitude',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\GPSLatitude',
                ),
                'gpslongitude' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'GPSLongitude',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\GPSLongitude',
                ),
                'datetimecreated' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'DateTimeCreated',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\DateTimeCreated',
                ),
                'digitalcreationdatetime' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'DigitalCreationDateTime',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\DigitalCreationDateTime',
                ),
                'volumesize' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'VolumeSize',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\VolumeSize',
                ),
                'datecreated' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'DateCreated',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\DateCreated',
                ),
                'wb_rgblevels' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'WB_RGBLevels',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\WBRGBLevels',
                ),
                'audiobitrate' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'AudioBitrate',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\AudioBitrate',
                ),
                'mpimage' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'MPImage',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\MPImage',
                ),
                'autofocus' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'AutoFocus',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\AutoFocus',
                ),
                'lensspec' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'LensSpec',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\LensSpec',
                ),
                'extenderstatus' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'ExtenderStatus',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\ExtenderStatus',
                ),
                'lenstype' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'LensType',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\LensType',
                ),
                'zoomedpreviewimage' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'ZoomedPreviewImage',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\ZoomedPreviewImage',
                ),
                'advancedscenemode' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'AdvancedSceneMode',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\AdvancedSceneMode',
                ),
                'imageheight' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'ImageHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\ImageHeight',
                ),
                'imagewidth' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'ImageWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\ImageWidth',
                ),
                'avgbitrate' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'AvgBitrate',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\AvgBitrate',
                ),
                'cddbdiscplaytime' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'CDDBDiscPlayTime',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\CDDBDiscPlayTime',
                ),
                'cddbdisctracks' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'CDDBDiscTracks',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\CDDBDiscTracks',
                ),
                'gpsaltituderef' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'GPSAltitudeRef',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\GPSAltitudeRef',
                ),
                'rotation' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'Rotation',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\Rotation',
                ),
                'ricohpitch' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'RicohPitch',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\RicohPitch',
                ),
                'ricohroll' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'RicohRoll',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\RicohRoll',
                ),
                'depthmaptiff' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'DepthMapTiff',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\DepthMapTiff',
                ),
                'singleshotdepthmaptiff' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'SingleShotDepthMapTiff',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\SingleShotDepthMapTiff',
                ),
                'focusdistance' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'FocusDistance',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\FocusDistance',
                ),
                'focusdistance2' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'FocusDistance2',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\FocusDistance2',
                ),
                'idcpreviewimage' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'IDCPreviewImage',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\IDCPreviewImage',
                ),
                'flash' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'Flash',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\Flash',
                ),
                'gpsdestlatituderef' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'GPSDestLatitudeRef',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\GPSDestLatitudeRef',
                ),
                'gpsdestlongituderef' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'GPSDestLongitudeRef',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\GPSDestLongitudeRef',
                ),
                'gpslatituderef' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'GPSLatitudeRef',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\GPSLatitudeRef',
                ),
                'gpslongituderef' => array(
                    'namespace' => 'Composite',
                    'tagname' => 'GPSLongitudeRef',
                    'classname' => 'PHPExiftool\Driver\Tag\Composite\GPSLongitudeRef',
                ),
            ),
            'all' => array(
                'jpgfromraw' => array(
                    'namespace' => 'All',
                    'tagname' => 'JpgFromRaw',
                    'classname' => 'PHPExiftool\Driver\Tag\All\JpgFromRaw',
                ),
                'otherimage' => array(
                    'namespace' => 'All',
                    'tagname' => 'OtherImage',
                    'classname' => 'PHPExiftool\Driver\Tag\All\OtherImage',
                ),
                'previewimage' => array(
                    'namespace' => 'All',
                    'tagname' => 'PreviewImage',
                    'classname' => 'PHPExiftool\Driver\Tag\All\PreviewImage',
                ),
                'thumbnailimage' => array(
                    'namespace' => 'All',
                    'tagname' => 'ThumbnailImage',
                    'classname' => 'PHPExiftool\Driver\Tag\All\ThumbnailImage',
                ),
                'previewimagestart' => array(
                    'namespace' => 'All',
                    'tagname' => 'PreviewImageStart',
                    'classname' => 'PHPExiftool\Driver\Tag\All\PreviewImageStart',
                ),
                'previewimagelength' => array(
                    'namespace' => 'All',
                    'tagname' => 'PreviewImageLength',
                    'classname' => 'PHPExiftool\Driver\Tag\All\PreviewImageLength',
                ),
            ),
      
            'exififd' => array(
               
                'exifversion' => array(
                    'namespace' => 'ExifIFD',
                    'tagname' => 'ExifVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\ExifIFD\ExifVersion',
                ),
                'datetimeoriginal' => array(
                    'namespace' => 'ExifIFD',
                    'tagname' => 'DateTimeOriginal',
                    'classname' => 'PHPExiftool\Driver\Tag\ExifIFD\DateTimeOriginal',
                ),
                'createdate' => array(
                    'namespace' => 'ExifIFD',
                    'tagname' => 'CreateDate',
                    'classname' => 'PHPExiftool\Driver\Tag\ExifIFD\CreateDate',
                ),
             
                'offsettime' => array(
                    'namespace' => 'ExifIFD',
                    'tagname' => 'OffsetTime',
                    'classname' => 'PHPExiftool\Driver\Tag\ExifIFD\OffsetTime',
                ),
                'offsettimeoriginal' => array(
                    'namespace' => 'ExifIFD',
                    'tagname' => 'OffsetTimeOriginal',
                    'classname' => 'PHPExiftool\Driver\Tag\ExifIFD\OffsetTimeOriginal',
                ),
                'offsettimedigitized' => array(
                    'namespace' => 'ExifIFD',
                    'tagname' => 'OffsetTimeDigitized',
                    'classname' => 'PHPExiftool\Driver\Tag\ExifIFD\OffsetTimeDigitized',
                ),
              
				 'componentsconfiguration' => array(
                    'namespace' => 'ExifIFD',
                    'tagname' => 'ComponentsConfiguration',
                    'classname' => 'PHPExiftool\Driver\Tag\ExifIFD\ComponentsConfiguration',
                ),
				
				 'flashpixversion' => array(
                    'namespace' => 'ExifIFD',
                    'tagname' => 'FlashpixVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\ExifIFD\FlashpixVersion',
                ),
                'colorspace' => array(
                    'namespace' => 'ExifIFD',
                    'tagname' => 'ColorSpace',
                    'classname' => 'PHPExiftool\Driver\Tag\ExifIFD\ColorSpace',
                ),
            ),
            
             'ifd0' => array(
                'modifydate' => array(
                    'namespace' => 'IFD0',
                    'tagname' => 'ModifyDate',
                    'classname' => 'PHPExiftool\Driver\Tag\IFD0\ModifyDate',
                ),
            ),
            'subifd2' => array(
                'jpgfromrawstart' => array(
                    'namespace' => 'SubIFD2',
                    'tagname' => 'JpgFromRawStart',
                    'classname' => 'PHPExiftool\Driver\Tag\SubIFD2\JpgFromRawStart',
                ),
                'jpgfromrawlength' => array(
                    'namespace' => 'SubIFD2',
                    'tagname' => 'JpgFromRawLength',
                    'classname' => 'PHPExiftool\Driver\Tag\SubIFD2\JpgFromRawLength',
                ),
                'otherimagestart' => array(
                    'namespace' => 'SubIFD2',
                    'tagname' => 'OtherImageStart',
                    'classname' => 'PHPExiftool\Driver\Tag\SubIFD2\OtherImageStart',
                ),
                'otherimagelength' => array(
                    'namespace' => 'SubIFD2',
                    'tagname' => 'OtherImageLength',
                    'classname' => 'PHPExiftool\Driver\Tag\SubIFD2\OtherImageLength',
                ),
                'cacheversion' => array(
                    'namespace' => 'SubIFD2',
                    'tagname' => 'CacheVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\SubIFD2\CacheVersion',
                ),
            ),
			
            'xmp-dwc' => array(
                'dcevent' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCEvent',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCEvent',
                ),
                'eventday' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'EventDay',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\EventDay',
                ),
                'eventearliestdate' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'EventEarliestDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\EventEarliestDate',
                ),
                'eventenddayofyear' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'EventEndDayOfYear',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\EventEndDayOfYear',
                ),
                'eventdate' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'EventDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\EventDate',
                ),
                'eventid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'EventID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\EventID',
                ),
                'eventremarks' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'EventRemarks',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\EventRemarks',
                ),
                'eventtime' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'EventTime',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\EventTime',
                ),
                'eventfieldnotes' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'EventFieldNotes',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\EventFieldNotes',
                ),
                'eventfieldnumber' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'EventFieldNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\EventFieldNumber',
                ),
                'eventhabitat' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'EventHabitat',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\EventHabitat',
                ),
                'eventlatestdate' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'EventLatestDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\EventLatestDate',
                ),
                'eventmonth' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'EventMonth',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\EventMonth',
                ),
                'eventparenteventid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'EventParentEventID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\EventParentEventID',
                ),
                'eventsamplesizeunit' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'EventSampleSizeUnit',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\EventSampleSizeUnit',
                ),
                'eventsamplesizevalue' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'EventSampleSizeValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\EventSampleSizeValue',
                ),
                'eventsamplingeffort' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'EventSamplingEffort',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\EventSamplingEffort',
                ),
                'eventsamplingprotocol' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'EventSamplingProtocol',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\EventSamplingProtocol',
                ),
                'eventstartdayofyear' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'EventStartDayOfYear',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\EventStartDayOfYear',
                ),
                'eventverbatimeventdate' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'EventVerbatimEventDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\EventVerbatimEventDate',
                ),
                'eventyear' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'EventYear',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\EventYear',
                ),
                'fossilspecimen' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'FossilSpecimen',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\FossilSpecimen',
                ),
                'fossilspecimenmaterialsampleid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'FossilSpecimenMaterialSampleID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\FossilSpecimenMaterialSampleID',
                ),
                'geologicalcontext' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'GeologicalContext',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\GeologicalContext',
                ),
                'geologicalcontextbed' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'GeologicalContextBed',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\GeologicalContextBed',
                ),
                'earliestageorloweststage' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'EarliestAgeOrLowestStage',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\EarliestAgeOrLowestStage',
                ),
                'earliesteonorlowesteonothem' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'EarliestEonOrLowestEonothem',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\EarliestEonOrLowestEonothem',
                ),
                'earliestepochorlowestseries' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'EarliestEpochOrLowestSeries',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\EarliestEpochOrLowestSeries',
                ),
                'earliesteraorlowesterathem' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'EarliestEraOrLowestErathem',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\EarliestEraOrLowestErathem',
                ),
                'earliestperiodorlowestsystem' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'EarliestPeriodOrLowestSystem',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\EarliestPeriodOrLowestSystem',
                ),
                'geologicalcontextformation' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'GeologicalContextFormation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\GeologicalContextFormation',
                ),
                'geologicalcontextid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'GeologicalContextID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\GeologicalContextID',
                ),
                'geologicalcontextgroup' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'GeologicalContextGroup',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\GeologicalContextGroup',
                ),
                'highestbiostratigraphiczone' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'HighestBiostratigraphicZone',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\HighestBiostratigraphicZone',
                ),
                'latestageorhigheststage' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'LatestAgeOrHighestStage',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\LatestAgeOrHighestStage',
                ),
                'latesteonorhighesteonothem' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'LatestEonOrHighestEonothem',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\LatestEonOrHighestEonothem',
                ),
                'latestepochorhighestseries' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'LatestEpochOrHighestSeries',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\LatestEpochOrHighestSeries',
                ),
                'latesteraorhighesterathem' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'LatestEraOrHighestErathem',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\LatestEraOrHighestErathem',
                ),
                'latestperiodorhighestsystem' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'LatestPeriodOrHighestSystem',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\LatestPeriodOrHighestSystem',
                ),
                'lithostratigraphicterms' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'LithostratigraphicTerms',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\LithostratigraphicTerms',
                ),
                'lowestbiostratigraphiczone' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'LowestBiostratigraphicZone',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\LowestBiostratigraphicZone',
                ),
                'geologicalcontextmember' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'GeologicalContextMember',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\GeologicalContextMember',
                ),
                'humanobservation' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'HumanObservation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\HumanObservation',
                ),
                'humanobservationday' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'HumanObservationDay',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\HumanObservationDay',
                ),
                'humanobservationearliestdate' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'HumanObservationEarliestDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\HumanObservationEarliestDate',
                ),
                'humanobservationenddayofyear' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'HumanObservationEndDayOfYear',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\HumanObservationEndDayOfYear',
                ),
                'humanobservationeventdate' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'HumanObservationEventDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\HumanObservationEventDate',
                ),
                'humanobservationeventid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'HumanObservationEventID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\HumanObservationEventID',
                ),
                'humanobservationeventremarks' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'HumanObservationEventRemarks',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\HumanObservationEventRemarks',
                ),
                'humanobservationeventtime' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'HumanObservationEventTime',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\HumanObservationEventTime',
                ),
                'humanobservationfieldnotes' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'HumanObservationFieldNotes',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\HumanObservationFieldNotes',
                ),
                'humanobservationfieldnumber' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'HumanObservationFieldNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\HumanObservationFieldNumber',
                ),
                'humanobservationhabitat' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'HumanObservationHabitat',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\HumanObservationHabitat',
                ),
                'humanobservationlatestdate' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'HumanObservationLatestDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\HumanObservationLatestDate',
                ),
                'humanobservationmonth' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'HumanObservationMonth',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\HumanObservationMonth',
                ),
                'humanobservationparenteventid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'HumanObservationParentEventID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\HumanObservationParentEventID',
                ),
                'humanobservationsamplesizeunit' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'HumanObservationSampleSizeUnit',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\HumanObservationSampleSizeUnit',
                ),
                'humanobservationsamplesizevalue' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'HumanObservationSampleSizeValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\HumanObservationSampleSizeValue',
                ),
                'humanobservationsamplingeffort' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'HumanObservationSamplingEffort',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\HumanObservationSamplingEffort',
                ),
                'humanobservationsamplingprotocol' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'HumanObservationSamplingProtocol',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\HumanObservationSamplingProtocol',
                ),
                'humanobservationstartdayofyear' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'HumanObservationStartDayOfYear',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\HumanObservationStartDayOfYear',
                ),
                'humanobservationverbatimeventdate' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'HumanObservationVerbatimEventDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\HumanObservationVerbatimEventDate',
                ),
                'humanobservationyear' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'HumanObservationYear',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\HumanObservationYear',
                ),
                'identification' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'Identification',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\Identification',
                ),
                'dateidentified' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DateIdentified',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DateIdentified',
                ),
                'identificationid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'IdentificationID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\IdentificationID',
                ),
                'identificationqualifier' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'IdentificationQualifier',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\IdentificationQualifier',
                ),
                'identificationreferences' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'IdentificationReferences',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\IdentificationReferences',
                ),
                'identificationremarks' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'IdentificationRemarks',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\IdentificationRemarks',
                ),
                'identificationverificationstatus' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'IdentificationVerificationStatus',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\IdentificationVerificationStatus',
                ),
                'identifiedby' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'IdentifiedBy',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\IdentifiedBy',
                ),
                'typestatus' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TypeStatus',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TypeStatus',
                ),
                'livingspecimen' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'LivingSpecimen',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\LivingSpecimen',
                ),
                'livingspecimenmaterialsampleid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'LivingSpecimenMaterialSampleID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\LivingSpecimenMaterialSampleID',
                ),
                'machineobservation' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MachineObservation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MachineObservation',
                ),
                'machineobservationday' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MachineObservationDay',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MachineObservationDay',
                ),
                'machineobservationearliestdate' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MachineObservationEarliestDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MachineObservationEarliestDate',
                ),
                'machineobservationenddayofyear' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MachineObservationEndDayOfYear',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MachineObservationEndDayOfYear',
                ),
                'machineobservationeventdate' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MachineObservationEventDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MachineObservationEventDate',
                ),
                'machineobservationeventid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MachineObservationEventID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MachineObservationEventID',
                ),
                'machineobservationeventremarks' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MachineObservationEventRemarks',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MachineObservationEventRemarks',
                ),
                'machineobservationeventtime' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MachineObservationEventTime',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MachineObservationEventTime',
                ),
                'machineobservationfieldnotes' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MachineObservationFieldNotes',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MachineObservationFieldNotes',
                ),
                'machineobservationfieldnumber' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MachineObservationFieldNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MachineObservationFieldNumber',
                ),
                'machineobservationhabitat' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MachineObservationHabitat',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MachineObservationHabitat',
                ),
                'machineobservationlatestdate' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MachineObservationLatestDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MachineObservationLatestDate',
                ),
                'machineobservationmonth' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MachineObservationMonth',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MachineObservationMonth',
                ),
                'machineobservationparenteventid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MachineObservationParentEventID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MachineObservationParentEventID',
                ),
                'machineobservationsamplesizeunit' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MachineObservationSampleSizeUnit',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MachineObservationSampleSizeUnit',
                ),
                'machineobservationsamplesizevalue' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MachineObservationSampleSizeValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MachineObservationSampleSizeValue',
                ),
                'machineobservationsamplingeffort' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MachineObservationSamplingEffort',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MachineObservationSamplingEffort',
                ),
                'machineobservationsamplingprotocol' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MachineObservationSamplingProtocol',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MachineObservationSamplingProtocol',
                ),
                'machineobservationstartdayofyear' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MachineObservationStartDayOfYear',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MachineObservationStartDayOfYear',
                ),
                'machineobservationverbatimeventdate' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MachineObservationVerbatimEventDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MachineObservationVerbatimEventDate',
                ),
                'machineobservationyear' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MachineObservationYear',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MachineObservationYear',
                ),
                'materialsample' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MaterialSample',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MaterialSample',
                ),
                'materialsampleid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MaterialSampleID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MaterialSampleID',
                ),
                'measurementorfact' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MeasurementOrFact',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MeasurementOrFact',
                ),
                'measurementaccuracy' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MeasurementAccuracy',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MeasurementAccuracy',
                ),
                'measurementdeterminedby' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MeasurementDeterminedBy',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MeasurementDeterminedBy',
                ),
                'measurementdetermineddate' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MeasurementDeterminedDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MeasurementDeterminedDate',
                ),
                'measurementid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MeasurementID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MeasurementID',
                ),
                'measurementmethod' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MeasurementMethod',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MeasurementMethod',
                ),
                'measurementremarks' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MeasurementRemarks',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MeasurementRemarks',
                ),
                'measurementtype' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MeasurementType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MeasurementType',
                ),
                'measurementunit' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MeasurementUnit',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MeasurementUnit',
                ),
                'measurementvalue' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'MeasurementValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\MeasurementValue',
                ),
                'occurrence' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'Occurrence',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\Occurrence',
                ),
                'occurrenceassociatedmedia' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OccurrenceAssociatedMedia',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OccurrenceAssociatedMedia',
                ),
                'occurrenceassociatedoccurrences' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OccurrenceAssociatedOccurrences',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OccurrenceAssociatedOccurrences',
                ),
                'occurrenceassociatedreferences' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OccurrenceAssociatedReferences',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OccurrenceAssociatedReferences',
                ),
                'occurrenceassociatedsequences' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OccurrenceAssociatedSequences',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OccurrenceAssociatedSequences',
                ),
                'occurrenceassociatedtaxa' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OccurrenceAssociatedTaxa',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OccurrenceAssociatedTaxa',
                ),
                'occurrencebehavior' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OccurrenceBehavior',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OccurrenceBehavior',
                ),
                'occurrencecatalognumber' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OccurrenceCatalogNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OccurrenceCatalogNumber',
                ),
                'occurrencedisposition' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OccurrenceDisposition',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OccurrenceDisposition',
                ),
                'occurrenceestablishmentmeans' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OccurrenceEstablishmentMeans',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OccurrenceEstablishmentMeans',
                ),
                'occurrenceindividualcount' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OccurrenceIndividualCount',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OccurrenceIndividualCount',
                ),
                'occurrenceindividualid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OccurrenceIndividualID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OccurrenceIndividualID',
                ),
                'occurrencelifestage' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OccurrenceLifeStage',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OccurrenceLifeStage',
                ),
                'occurrencedetails' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OccurrenceDetails',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OccurrenceDetails',
                ),
                'occurrenceid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OccurrenceID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OccurrenceID',
                ),
                'occurrenceremarks' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OccurrenceRemarks',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OccurrenceRemarks',
                ),
                'occurrencestatus' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OccurrenceStatus',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OccurrenceStatus',
                ),
                'occurrenceorganismquantity' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OccurrenceOrganismQuantity',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OccurrenceOrganismQuantity',
                ),
                'occurrenceorganismquantitytype' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OccurrenceOrganismQuantityType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OccurrenceOrganismQuantityType',
                ),
                'occurrenceothercatalognumbers' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OccurrenceOtherCatalogNumbers',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OccurrenceOtherCatalogNumbers',
                ),
                'occurrencepreparations' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OccurrencePreparations',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OccurrencePreparations',
                ),
                'occurrencepreviousidentifications' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OccurrencePreviousIdentifications',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OccurrencePreviousIdentifications',
                ),
                'occurrencerecordnumber' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OccurrenceRecordNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OccurrenceRecordNumber',
                ),
                'occurrencerecordedby' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OccurrenceRecordedBy',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OccurrenceRecordedBy',
                ),
                'occurrencereproductivecondition' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OccurrenceReproductiveCondition',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OccurrenceReproductiveCondition',
                ),
                'occurrencesex' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OccurrenceSex',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OccurrenceSex',
                ),
                'organism' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'Organism',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\Organism',
                ),
                'organismassociatedoccurrences' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OrganismAssociatedOccurrences',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OrganismAssociatedOccurrences',
                ),
                'organismassociatedorganisms' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OrganismAssociatedOrganisms',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OrganismAssociatedOrganisms',
                ),
                'organismid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OrganismID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OrganismID',
                ),
                'organismname' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OrganismName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OrganismName',
                ),
                'organismremarks' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OrganismRemarks',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OrganismRemarks',
                ),
                'organismscope' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OrganismScope',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OrganismScope',
                ),
                'organismpreviousidentifications' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'OrganismPreviousIdentifications',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\OrganismPreviousIdentifications',
                ),
                'preservedspecimen' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'PreservedSpecimen',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\PreservedSpecimen',
                ),
                'preservedspecimenmaterialsampleid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'PreservedSpecimenMaterialSampleID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\PreservedSpecimenMaterialSampleID',
                ),
                'record' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'Record',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\Record',
                ),
                'recordbasisofrecord' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'RecordBasisOfRecord',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\RecordBasisOfRecord',
                ),
                'recordcollectioncode' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'RecordCollectionCode',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\RecordCollectionCode',
                ),
                'recordcollectionid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'RecordCollectionID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\RecordCollectionID',
                ),
                'recorddatageneralizations' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'RecordDataGeneralizations',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\RecordDataGeneralizations',
                ),
                'recorddatasetid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'RecordDatasetID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\RecordDatasetID',
                ),
                'recorddatasetname' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'RecordDatasetName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\RecordDatasetName',
                ),
                'recorddynamicproperties' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'RecordDynamicProperties',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\RecordDynamicProperties',
                ),
                'recordinformationwithheld' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'RecordInformationWithheld',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\RecordInformationWithheld',
                ),
                'recordinstitutioncode' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'RecordInstitutionCode',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\RecordInstitutionCode',
                ),
                'recordinstitutionid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'RecordInstitutionID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\RecordInstitutionID',
                ),
                'recordownerinstitutioncode' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'RecordOwnerInstitutionCode',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\RecordOwnerInstitutionCode',
                ),
                'resourcerelationship' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'ResourceRelationship',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\ResourceRelationship',
                ),
                'relatedresourceid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'RelatedResourceID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\RelatedResourceID',
                ),
                'relationshipaccordingto' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'RelationshipAccordingTo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\RelationshipAccordingTo',
                ),
                'relationshipestablisheddate' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'RelationshipEstablishedDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\RelationshipEstablishedDate',
                ),
                'relationshipofresource' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'RelationshipOfResource',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\RelationshipOfResource',
                ),
                'relationshipremarks' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'RelationshipRemarks',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\RelationshipRemarks',
                ),
                'resourceid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'ResourceID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\ResourceID',
                ),
                'resourcerelationshipid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'ResourceRelationshipID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\ResourceRelationshipID',
                ),
                'taxon' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'Taxon',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\Taxon',
                ),
                'taxonacceptednameusage' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonAcceptedNameUsage',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonAcceptedNameUsage',
                ),
                'taxonacceptednameusageid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonAcceptedNameUsageID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonAcceptedNameUsageID',
                ),
                'taxonclass' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonClass',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonClass',
                ),
                'taxonfamily' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonFamily',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonFamily',
                ),
                'taxongenus' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonGenus',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonGenus',
                ),
                'taxonhigherclassification' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonHigherClassification',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonHigherClassification',
                ),
                'taxoninfraspecificepithet' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonInfraspecificEpithet',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonInfraspecificEpithet',
                ),
                'taxonkingdom' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonKingdom',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonKingdom',
                ),
                'taxonnameaccordingto' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonNameAccordingTo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonNameAccordingTo',
                ),
                'taxonnameaccordingtoid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonNameAccordingToID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonNameAccordingToID',
                ),
                'taxonnamepublishedin' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonNamePublishedIn',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonNamePublishedIn',
                ),
                'taxonnamepublishedinid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonNamePublishedInID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonNamePublishedInID',
                ),
                'taxonnamepublishedinyear' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonNamePublishedInYear',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonNamePublishedInYear',
                ),
                'taxonnomenclaturalcode' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonNomenclaturalCode',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonNomenclaturalCode',
                ),
                'taxonnomenclaturalstatus' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonNomenclaturalStatus',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonNomenclaturalStatus',
                ),
                'taxonorder' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonOrder',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonOrder',
                ),
                'taxonoriginalnameusage' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonOriginalNameUsage',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonOriginalNameUsage',
                ),
                'taxonoriginalnameusageid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonOriginalNameUsageID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonOriginalNameUsageID',
                ),
                'taxonparentnameusage' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonParentNameUsage',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonParentNameUsage',
                ),
                'taxonparentnameusageid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonParentNameUsageID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonParentNameUsageID',
                ),
                'taxonphylum' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonPhylum',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonPhylum',
                ),
                'taxonscientificname' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonScientificName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonScientificName',
                ),
                'taxonscientificnameauthorship' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonScientificNameAuthorship',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonScientificNameAuthorship',
                ),
                'taxonscientificnameid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonScientificNameID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonScientificNameID',
                ),
                'taxonspecificepithet' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonSpecificEpithet',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonSpecificEpithet',
                ),
                'taxonsubgenus' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonSubgenus',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonSubgenus',
                ),
                'taxonconceptid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonConceptID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonConceptID',
                ),
                'taxonid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonID',
                ),
                'taxonrank' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonRank',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonRank',
                ),
                'taxonremarks' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonRemarks',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonRemarks',
                ),
                'taxontaxonomicstatus' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonTaxonomicStatus',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonTaxonomicStatus',
                ),
                'taxonverbatimtaxonrank' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonVerbatimTaxonRank',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonVerbatimTaxonRank',
                ),
                'taxonvernacularname' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'TaxonVernacularName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\TaxonVernacularName',
                ),
                'dctermslocation' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCTermsLocation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCTermsLocation',
                ),
                'dccontinent' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCContinent',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCContinent',
                ),
                'dccoordinateprecision' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCCoordinatePrecision',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCCoordinatePrecision',
                ),
                'dccoordinateuncertaintyinmeters' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCCoordinateUncertaintyInMeters',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCCoordinateUncertaintyInMeters',
                ),
                'dccountry' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCCountry',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCCountry',
                ),
                'dccountrycode' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCCountryCode',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCCountryCode',
                ),
                'dccounty' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCCounty',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCCounty',
                ),
                'dcdecimallatitude' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCDecimalLatitude',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCDecimalLatitude',
                ),
                'dcdecimallongitude' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCDecimalLongitude',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCDecimalLongitude',
                ),
                'dcfootprintsrs' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCFootprintSRS',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCFootprintSRS',
                ),
                'dcfootprintspatialfit' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCFootprintSpatialFit',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCFootprintSpatialFit',
                ),
                'dcfootprintwkt' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCFootprintWKT',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCFootprintWKT',
                ),
                'dcgeodeticdatum' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCGeodeticDatum',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCGeodeticDatum',
                ),
                'dcgeoreferenceprotocol' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCGeoreferenceProtocol',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCGeoreferenceProtocol',
                ),
                'dcgeoreferenceremarks' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCGeoreferenceRemarks',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCGeoreferenceRemarks',
                ),
                'dcgeoreferencesources' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCGeoreferenceSources',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCGeoreferenceSources',
                ),
                'dcgeoreferenceverificationstatus' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCGeoreferenceVerificationStatus',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCGeoreferenceVerificationStatus',
                ),
                'dcgeoreferencedby' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCGeoreferencedBy',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCGeoreferencedBy',
                ),
                'dcgeoreferenceddate' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCGeoreferencedDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCGeoreferencedDate',
                ),
                'dchighergeography' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCHigherGeography',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCHigherGeography',
                ),
                'dchighergeographyid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCHigherGeographyID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCHigherGeographyID',
                ),
                'dcisland' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCIsland',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCIsland',
                ),
                'dcislandgroup' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCIslandGroup',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCIslandGroup',
                ),
                'dclocality' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCLocality',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCLocality',
                ),
                'dclocationaccordingto' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCLocationAccordingTo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCLocationAccordingTo',
                ),
                'dclocationid' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCLocationID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCLocationID',
                ),
                'dclocationremarks' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCLocationRemarks',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCLocationRemarks',
                ),
                'dcmaximumdepthinmeters' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCMaximumDepthInMeters',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCMaximumDepthInMeters',
                ),
                'dcmaximumdistanceabovesurfaceinmeters' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCMaximumDistanceAboveSurfaceInMeters',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCMaximumDistanceAboveSurfaceInMeters',
                ),
                'dcmaximumelevationinmeters' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCMaximumElevationInMeters',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCMaximumElevationInMeters',
                ),
                'dcminimumdepthinmeters' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCMinimumDepthInMeters',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCMinimumDepthInMeters',
                ),
                'dcminimumdistanceabovesurfaceinmeters' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCMinimumDistanceAboveSurfaceInMeters',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCMinimumDistanceAboveSurfaceInMeters',
                ),
                'dcminimumelevationinmeters' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCMinimumElevationInMeters',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCMinimumElevationInMeters',
                ),
                'dcmunicipality' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCMunicipality',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCMunicipality',
                ),
                'dcpointradiusspatialfit' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCPointRadiusSpatialFit',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCPointRadiusSpatialFit',
                ),
                'dcstateprovince' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCStateProvince',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCStateProvince',
                ),
                'dcverbatimcoordinatesystem' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCVerbatimCoordinateSystem',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCVerbatimCoordinateSystem',
                ),
                'dcverbatimcoordinates' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCVerbatimCoordinates',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCVerbatimCoordinates',
                ),
                'dcverbatimdepth' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCVerbatimDepth',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCVerbatimDepth',
                ),
                'dcverbatimelevation' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCVerbatimElevation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCVerbatimElevation',
                ),
                'dcverbatimlatitude' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCVerbatimLatitude',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCVerbatimLatitude',
                ),
                'dcverbatimlocality' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCVerbatimLocality',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCVerbatimLocality',
                ),
                'dcverbatimlongitude' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCVerbatimLongitude',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCVerbatimLongitude',
                ),
                'dcverbatimsrs' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCVerbatimSRS',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCVerbatimSRS',
                ),
                'dcwaterbody' => array(
                    'namespace' => 'XMP-dwc',
                    'tagname' => 'DCWaterBody',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDwc\DCWaterBody',
                ),
            ),
           
            'adobe' => array(
                'adobe' => array(
                    'namespace' => 'Adobe',
                    'tagname' => 'Adobe',
                    'classname' => 'PHPExiftool\Driver\Tag\Adobe\Adobe',
                ),
                'dctencodeversion' => array(
                    'namespace' => 'Adobe',
                    'tagname' => 'DCTEncodeVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\Adobe\DCTEncodeVersion',
                ),
                'app14flags0' => array(
                    'namespace' => 'Adobe',
                    'tagname' => 'APP14Flags0',
                    'classname' => 'PHPExiftool\Driver\Tag\Adobe\APP14Flags0',
                ),
                'app14flags1' => array(
                    'namespace' => 'Adobe',
                    'tagname' => 'APP14Flags1',
                    'classname' => 'PHPExiftool\Driver\Tag\Adobe\APP14Flags1',
                ),
                'colortransform' => array(
                    'namespace' => 'Adobe',
                    'tagname' => 'ColorTransform',
                    'classname' => 'PHPExiftool\Driver\Tag\Adobe\ColorTransform',
                ),
            ),
            'system' => array(
                'directory' => array(
                    'namespace' => 'System',
                    'tagname' => 'Directory',
                    'classname' => 'PHPExiftool\Driver\Tag\System\Directory',
                ),
                'fileaccessdate' => array(
                    'namespace' => 'System',
                    'tagname' => 'FileAccessDate',
                    'classname' => 'PHPExiftool\Driver\Tag\System\FileAccessDate',
                ),
                'fileattributes' => array(
                    'namespace' => 'System',
                    'tagname' => 'FileAttributes',
                    'classname' => 'PHPExiftool\Driver\Tag\System\FileAttributes',
                ),
                'fileblockcount' => array(
                    'namespace' => 'System',
                    'tagname' => 'FileBlockCount',
                    'classname' => 'PHPExiftool\Driver\Tag\System\FileBlockCount',
                ),
                'fileblocksize' => array(
                    'namespace' => 'System',
                    'tagname' => 'FileBlockSize',
                    'classname' => 'PHPExiftool\Driver\Tag\System\FileBlockSize',
                ),
                'filecreatedate' => array(
                    'namespace' => 'System',
                    'tagname' => 'FileCreateDate',
                    'classname' => 'PHPExiftool\Driver\Tag\System\FileCreateDate',
                ),
                'filedeviceid' => array(
                    'namespace' => 'System',
                    'tagname' => 'FileDeviceID',
                    'classname' => 'PHPExiftool\Driver\Tag\System\FileDeviceID',
                ),
                'filedevicenumber' => array(
                    'namespace' => 'System',
                    'tagname' => 'FileDeviceNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\System\FileDeviceNumber',
                ),
                'filegroupid' => array(
                    'namespace' => 'System',
                    'tagname' => 'FileGroupID',
                    'classname' => 'PHPExiftool\Driver\Tag\System\FileGroupID',
                ),
                'filehardlinks' => array(
                    'namespace' => 'System',
                    'tagname' => 'FileHardLinks',
                    'classname' => 'PHPExiftool\Driver\Tag\System\FileHardLinks',
                ),
                'fileinodechangedate' => array(
                    'namespace' => 'System',
                    'tagname' => 'FileInodeChangeDate',
                    'classname' => 'PHPExiftool\Driver\Tag\System\FileInodeChangeDate',
                ),
                'fileinodenumber' => array(
                    'namespace' => 'System',
                    'tagname' => 'FileInodeNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\System\FileInodeNumber',
                ),
                'filemodifydate' => array(
                    'namespace' => 'System',
                    'tagname' => 'FileModifyDate',
                    'classname' => 'PHPExiftool\Driver\Tag\System\FileModifyDate',
                ),
                'filename' => array(
                    'namespace' => 'System',
                    'tagname' => 'FileName',
                    'classname' => 'PHPExiftool\Driver\Tag\System\FileName',
                ),
                'filepath' => array(
                    'namespace' => 'System',
                    'tagname' => 'FilePath',
                    'classname' => 'PHPExiftool\Driver\Tag\System\FilePath',
                ),
                'filepermissions' => array(
                    'namespace' => 'System',
                    'tagname' => 'FilePermissions',
                    'classname' => 'PHPExiftool\Driver\Tag\System\FilePermissions',
                ),
                'filesize' => array(
                    'namespace' => 'System',
                    'tagname' => 'FileSize',
                    'classname' => 'PHPExiftool\Driver\Tag\System\FileSize',
                ),
                'fileuserid' => array(
                    'namespace' => 'System',
                    'tagname' => 'FileUserID',
                    'classname' => 'PHPExiftool\Driver\Tag\System\FileUserID',
                ),
                'resourceforksize' => array(
                    'namespace' => 'System',
                    'tagname' => 'ResourceForkSize',
                    'classname' => 'PHPExiftool\Driver\Tag\System\ResourceForkSize',
                ),
            ),
            'exif' => array(
                'exif' => array(
                    'namespace' => 'EXIF',
                    'tagname' => 'EXIF',
                    'classname' => 'PHPExiftool\Driver\Tag\EXIF\EXIF',
                ),
            ),
            'exiftool' => array(
                'error' => array(
                    'namespace' => 'ExifTool',
                    'tagname' => 'Error',
                    'classname' => 'PHPExiftool\Driver\Tag\ExifTool\Error',
                ),
                'exiftoolversion' => array(
                    'namespace' => 'ExifTool',
                    'tagname' => 'ExifToolVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\ExifTool\ExifToolVersion',
                ),
                'filesequence' => array(
                    'namespace' => 'ExifTool',
                    'tagname' => 'FileSequence',
                    'classname' => 'PHPExiftool\Driver\Tag\ExifTool\FileSequence',
                ),
                'newguid' => array(
                    'namespace' => 'ExifTool',
                    'tagname' => 'NewGUID',
                    'classname' => 'PHPExiftool\Driver\Tag\ExifTool\NewGUID',
                ),
                'now' => array(
                    'namespace' => 'ExifTool',
                    'tagname' => 'Now',
                    'classname' => 'PHPExiftool\Driver\Tag\ExifTool\Now',
                ),
                'processingtime' => array(
                    'namespace' => 'ExifTool',
                    'tagname' => 'ProcessingTime',
                    'classname' => 'PHPExiftool\Driver\Tag\ExifTool\ProcessingTime',
                ),
                'warning' => array(
                    'namespace' => 'ExifTool',
                    'tagname' => 'Warning',
                    'classname' => 'PHPExiftool\Driver\Tag\ExifTool\Warning',
                ),
            ),
            
            'iptc' => array(
                'iptc' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'IPTC',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\IPTC',
                ),
               
                'objecttypereference' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'ObjectTypeReference',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\ObjectTypeReference',
                ),
               
                'objectname' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'ObjectName',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\ObjectName',
                ),
                'editstatus' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'EditStatus',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\EditStatus',
                ),
                'editorialupdate' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'EditorialUpdate',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\EditorialUpdate',
                ),
                'supplementalcategories' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'SupplementalCategories',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\SupplementalCategories',
                ),
                'fixtureidentifier' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'FixtureIdentifier',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\FixtureIdentifier',
                ),
                'keywords' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'Keywords',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\Keywords',
                ),

                'expirationdate' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'ExpirationDate',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\ExpirationDate',
                ),
                'expirationtime' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'ExpirationTime',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\ExpirationTime',
                ),
                
                'datecreated' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'DateCreated',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\DateCreated',
                ),
                'timecreated' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'TimeCreated',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\TimeCreated',
                ),
                'digitalcreationdate' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'DigitalCreationDate',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\DigitalCreationDate',
                ),
                'digitalcreationtime' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'DigitalCreationTime',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\DigitalCreationTime',
                ),
                'programversion' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'ProgramVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\ProgramVersion',
                ),
                'objectcycle' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'ObjectCycle',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\ObjectCycle',
                ),
                'by-line' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'By-line',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\ByLine',
                ),
                'by-linetitle' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'By-lineTitle',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\ByLineTitle',
                ),
                'city' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'City',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\City',
                ),
                'sub-location' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'Sub-location',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\SubLocation',
                ),
                'province-state' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'Province-State',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\ProvinceState',
                ),

              
                'headline' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'Headline',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\Headline',
                ),
                'credit' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'Credit',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\Credit',
                ),
                'source' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'Source',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\Source',
                ),
                'copyrightnotice' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'CopyrightNotice',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\CopyrightNotice',
                ),
                'contact' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'Contact',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\Contact',
                ),
                'caption-abstract' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'Caption-Abstract',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\CaptionAbstract',
                ),
                'localcaption' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'LocalCaption',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\LocalCaption',
                ),
                'writer-editor' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'Writer-Editor',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\WriterEditor',
                ),
              
                'imagetype' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'ImageType',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\ImageType',
                ),
                'imageorientation' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'ImageOrientation',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\ImageOrientation',
                ),
                'languageidentifier' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'LanguageIdentifier',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\LanguageIdentifier',
                ),
               
                'jobid' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'JobID',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\JobID',
                ),
                'masterdocumentid' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'MasterDocumentID',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\MasterDocumentID',
                ),

                'uniquedocumentid' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'UniqueDocumentID',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\UniqueDocumentID',
                ),
                'ownerid' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'OwnerID',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\OwnerID',
                ),
                'objectpreviewfileformat' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'ObjectPreviewFileFormat',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\ObjectPreviewFileFormat',
                ),
                'objectpreviewfileversion' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'ObjectPreviewFileVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\ObjectPreviewFileVersion',
                ),
                'objectpreviewdata' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'ObjectPreviewData',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\ObjectPreviewData',
                ),
                'prefs' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'Prefs',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\Prefs',
                ),
                
             
              
                'exifcamerainfo' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'ExifCameraInfo',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\ExifCameraInfo',
                ),

                'destination' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'Destination',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\Destination',
                ),
                'fileformat' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'FileFormat',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\FileFormat',
                ),
                'fileversion' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'FileVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\FileVersion',
                ),
  

                'productid' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'ProductID',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\ProductID',
                ),
               
                'datesent' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'DateSent',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\DateSent',
                ),



   
                'iptcpicturenumber' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'IPTCPictureNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\IPTCPictureNumber',
                ),
                'iptcimagewidth' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'IPTCImageWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\IPTCImageWidth',
                ),
                'iptcimageheight' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'IPTCImageHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\IPTCImageHeight',
                ),
                'iptcpixelwidth' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'IPTCPixelWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\IPTCPixelWidth',
                ),
                'iptcpixelheight' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'IPTCPixelHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\IPTCPixelHeight',
                ),

                'interchangecolorspace' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'InterchangeColorSpace',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\InterchangeColorSpace',
                ),
          
                'icc_profile' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'ICC_Profile',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\ICCProfile',
                ),
                
                'lookuptable' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'LookupTable',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\LookupTable',
                ),

                'iptcbitspersample' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'IPTCBitsPerSample',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\IPTCBitsPerSample',
                ),
               

                'iptcimagerotation' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'IPTCImageRotation',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\IPTCImageRotation',
                ),

                'subfile' => array(
                    'namespace' => 'IPTC',
                    'tagname' => 'SubFile',
                    'classname' => 'PHPExiftool\Driver\Tag\IPTC\SubFile',
                ),

            ),
            'xmp' => array(
                'xmp' => array(
                    'namespace' => 'XMP',
                    'tagname' => 'XMP',
                    'classname' => 'PHPExiftool\Driver\Tag\XMP\XMP',
                ),
            ),
            'fits' => array(
                'author' => array(
                    'namespace' => 'FITS',
                    'tagname' => 'Author',
                    'classname' => 'PHPExiftool\Driver\Tag\FITS\Author',
                ),
                'background' => array(
                    'namespace' => 'FITS',
                    'tagname' => 'Background',
                    'classname' => 'PHPExiftool\Driver\Tag\FITS\Background',
                ),
                'createdate' => array(
                    'namespace' => 'FITS',
                    'tagname' => 'CreateDate',
                    'classname' => 'PHPExiftool\Driver\Tag\FITS\CreateDate',
                ),
                'observationdateend' => array(
                    'namespace' => 'FITS',
                    'tagname' => 'ObservationDateEnd',
                    'classname' => 'PHPExiftool\Driver\Tag\FITS\ObservationDateEnd',
                ),
                'observationdate' => array(
                    'namespace' => 'FITS',
                    'tagname' => 'ObservationDate',
                    'classname' => 'PHPExiftool\Driver\Tag\FITS\ObservationDate',
                ),
                'instrument' => array(
                    'namespace' => 'FITS',
                    'tagname' => 'Instrument',
                    'classname' => 'PHPExiftool\Driver\Tag\FITS\Instrument',
                ),
                'object' => array(
                    'namespace' => 'FITS',
                    'tagname' => 'Object',
                    'classname' => 'PHPExiftool\Driver\Tag\FITS\Object0',
                ),
                'observer' => array(
                    'namespace' => 'FITS',
                    'tagname' => 'Observer',
                    'classname' => 'PHPExiftool\Driver\Tag\FITS\Observer',
                ),
                'reference' => array(
                    'namespace' => 'FITS',
                    'tagname' => 'Reference',
                    'classname' => 'PHPExiftool\Driver\Tag\FITS\Reference',
                ),
                'telescope' => array(
                    'namespace' => 'FITS',
                    'tagname' => 'Telescope',
                    'classname' => 'PHPExiftool\Driver\Tag\FITS\Telescope',
                ),
                'observationtimeend' => array(
                    'namespace' => 'FITS',
                    'tagname' => 'ObservationTimeEnd',
                    'classname' => 'PHPExiftool\Driver\Tag\FITS\ObservationTimeEnd',
                ),
                'observationtime' => array(
                    'namespace' => 'FITS',
                    'tagname' => 'ObservationTime',
                    'classname' => 'PHPExiftool\Driver\Tag\FITS\ObservationTime',
                ),
            ),
            'flac' => array(
                'padding' => array(
                    'namespace' => 'FLAC',
                    'tagname' => 'Padding',
                    'classname' => 'PHPExiftool\Driver\Tag\FLAC\Padding',
                ),
                'application' => array(
                    'namespace' => 'FLAC',
                    'tagname' => 'Application',
                    'classname' => 'PHPExiftool\Driver\Tag\FLAC\Application',
                ),
                'seektable' => array(
                    'namespace' => 'FLAC',
                    'tagname' => 'SeekTable',
                    'classname' => 'PHPExiftool\Driver\Tag\FLAC\SeekTable',
                ),
                'cuesheet' => array(
                    'namespace' => 'FLAC',
                    'tagname' => 'CueSheet',
                    'classname' => 'PHPExiftool\Driver\Tag\FLAC\CueSheet',
                ),
                'picturetype' => array(
                    'namespace' => 'FLAC',
                    'tagname' => 'PictureType',
                    'classname' => 'PHPExiftool\Driver\Tag\FLAC\PictureType',
                ),
                'picturemimetype' => array(
                    'namespace' => 'FLAC',
                    'tagname' => 'PictureMIMEType',
                    'classname' => 'PHPExiftool\Driver\Tag\FLAC\PictureMIMEType',
                ),
                'picturedescription' => array(
                    'namespace' => 'FLAC',
                    'tagname' => 'PictureDescription',
                    'classname' => 'PHPExiftool\Driver\Tag\FLAC\PictureDescription',
                ),
                'picturewidth' => array(
                    'namespace' => 'FLAC',
                    'tagname' => 'PictureWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\FLAC\PictureWidth',
                ),
                'pictureheight' => array(
                    'namespace' => 'FLAC',
                    'tagname' => 'PictureHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\FLAC\PictureHeight',
                ),
                'picturebitsperpixel' => array(
                    'namespace' => 'FLAC',
                    'tagname' => 'PictureBitsPerPixel',
                    'classname' => 'PHPExiftool\Driver\Tag\FLAC\PictureBitsPerPixel',
                ),
                'pictureindexedcolors' => array(
                    'namespace' => 'FLAC',
                    'tagname' => 'PictureIndexedColors',
                    'classname' => 'PHPExiftool\Driver\Tag\FLAC\PictureIndexedColors',
                ),
                'picturelength' => array(
                    'namespace' => 'FLAC',
                    'tagname' => 'PictureLength',
                    'classname' => 'PHPExiftool\Driver\Tag\FLAC\PictureLength',
                ),
                'picture' => array(
                    'namespace' => 'FLAC',
                    'tagname' => 'Picture',
                    'classname' => 'PHPExiftool\Driver\Tag\FLAC\Picture',
                ),
                'blocksizemin' => array(
                    'namespace' => 'FLAC',
                    'tagname' => 'BlockSizeMin',
                    'classname' => 'PHPExiftool\Driver\Tag\FLAC\BlockSizeMin',
                ),
                'blocksizemax' => array(
                    'namespace' => 'FLAC',
                    'tagname' => 'BlockSizeMax',
                    'classname' => 'PHPExiftool\Driver\Tag\FLAC\BlockSizeMax',
                ),
                'framesizemin' => array(
                    'namespace' => 'FLAC',
                    'tagname' => 'FrameSizeMin',
                    'classname' => 'PHPExiftool\Driver\Tag\FLAC\FrameSizeMin',
                ),
                'framesizemax' => array(
                    'namespace' => 'FLAC',
                    'tagname' => 'FrameSizeMax',
                    'classname' => 'PHPExiftool\Driver\Tag\FLAC\FrameSizeMax',
                ),
                'samplerate' => array(
                    'namespace' => 'FLAC',
                    'tagname' => 'SampleRate',
                    'classname' => 'PHPExiftool\Driver\Tag\FLAC\SampleRate',
                ),
                'channels' => array(
                    'namespace' => 'FLAC',
                    'tagname' => 'Channels',
                    'classname' => 'PHPExiftool\Driver\Tag\FLAC\Channels',
                ),
                'bitspersample' => array(
                    'namespace' => 'FLAC',
                    'tagname' => 'BitsPerSample',
                    'classname' => 'PHPExiftool\Driver\Tag\FLAC\BitsPerSample',
                ),
                'totalsamples' => array(
                    'namespace' => 'FLAC',
                    'tagname' => 'TotalSamples',
                    'classname' => 'PHPExiftool\Driver\Tag\FLAC\TotalSamples',
                ),
                'md5signature' => array(
                    'namespace' => 'FLAC',
                    'tagname' => 'MD5Signature',
                    'classname' => 'PHPExiftool\Driver\Tag\FLAC\MD5Signature',
                ),
            ),
            'ms-doc' => array(
                'createdate' => array(
                    'namespace' => 'MS-DOC',
                    'tagname' => 'CreateDate',
                    'classname' => 'PHPExiftool\Driver\Tag\MSDOC\CreateDate',
                ),
                'modifydate' => array(
                    'namespace' => 'MS-DOC',
                    'tagname' => 'ModifyDate',
                    'classname' => 'PHPExiftool\Driver\Tag\MSDOC\ModifyDate',
                ),
                'lastprinted' => array(
                    'namespace' => 'MS-DOC',
                    'tagname' => 'LastPrinted',
                    'classname' => 'PHPExiftool\Driver\Tag\MSDOC\LastPrinted',
                ),
                'revisionnumber' => array(
                    'namespace' => 'MS-DOC',
                    'tagname' => 'RevisionNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\MSDOC\RevisionNumber',
                ),
                'totaledittime' => array(
                    'namespace' => 'MS-DOC',
                    'tagname' => 'TotalEditTime',
                    'classname' => 'PHPExiftool\Driver\Tag\MSDOC\TotalEditTime',
                ),
                'words' => array(
                    'namespace' => 'MS-DOC',
                    'tagname' => 'Words',
                    'classname' => 'PHPExiftool\Driver\Tag\MSDOC\Words',
                ),
                'characters' => array(
                    'namespace' => 'MS-DOC',
                    'tagname' => 'Characters',
                    'classname' => 'PHPExiftool\Driver\Tag\MSDOC\Characters',
                ),
                'pages' => array(
                    'namespace' => 'MS-DOC',
                    'tagname' => 'Pages',
                    'classname' => 'PHPExiftool\Driver\Tag\MSDOC\Pages',
                ),
                'paragraphs' => array(
                    'namespace' => 'MS-DOC',
                    'tagname' => 'Paragraphs',
                    'classname' => 'PHPExiftool\Driver\Tag\MSDOC\Paragraphs',
                ),
                'lines' => array(
                    'namespace' => 'MS-DOC',
                    'tagname' => 'Lines',
                    'classname' => 'PHPExiftool\Driver\Tag\MSDOC\Lines',
                ),
                'commentby' => array(
                    'namespace' => 'MS-DOC',
                    'tagname' => 'CommentBy',
                    'classname' => 'PHPExiftool\Driver\Tag\MSDOC\CommentBy',
                ),
                'lastsavedby' => array(
                    'namespace' => 'MS-DOC',
                    'tagname' => 'LastSavedBy',
                    'classname' => 'PHPExiftool\Driver\Tag\MSDOC\LastSavedBy',
                ),
                'tableoffsets' => array(
                    'namespace' => 'MS-DOC',
                    'tagname' => 'TableOffsets',
                    'classname' => 'PHPExiftool\Driver\Tag\MSDOC\TableOffsets',
                ),
            ),
            'font' => array(
                'ascender' => array(
                    'namespace' => 'Font',
                    'tagname' => 'Ascender',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\Ascender',
                ),
                'capheight' => array(
                    'namespace' => 'Font',
                    'tagname' => 'CapHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\CapHeight',
                ),
                'characterset' => array(
                    'namespace' => 'Font',
                    'tagname' => 'CharacterSet',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\CharacterSet',
                ),
                'characters' => array(
                    'namespace' => 'Font',
                    'tagname' => 'Characters',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\Characters',
                ),
                'createdate' => array(
                    'namespace' => 'Font',
                    'tagname' => 'CreateDate',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\CreateDate',
                ),
                'descender' => array(
                    'namespace' => 'Font',
                    'tagname' => 'Descender',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\Descender',
                ),
                'encodingscheme' => array(
                    'namespace' => 'Font',
                    'tagname' => 'EncodingScheme',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\EncodingScheme',
                ),
                'escchar' => array(
                    'namespace' => 'Font',
                    'tagname' => 'EscChar',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\EscChar',
                ),
                'fontfamily' => array(
                    'namespace' => 'Font',
                    'tagname' => 'FontFamily',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\FontFamily',
                ),
                'fontname' => array(
                    'namespace' => 'Font',
                    'tagname' => 'FontName',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\FontName',
                ),
                'fullname' => array(
                    'namespace' => 'Font',
                    'tagname' => 'FullName',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\FullName',
                ),
                'isbasefont' => array(
                    'namespace' => 'Font',
                    'tagname' => 'IsBaseFont',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\IsBaseFont',
                ),
                'isfixedv' => array(
                    'namespace' => 'Font',
                    'tagname' => 'IsFixedV',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\IsFixedV',
                ),
                'mappingscheme' => array(
                    'namespace' => 'Font',
                    'tagname' => 'MappingScheme',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\MappingScheme',
                ),
                'notice' => array(
                    'namespace' => 'Font',
                    'tagname' => 'Notice',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\Notice',
                ),
                'version' => array(
                    'namespace' => 'Font',
                    'tagname' => 'Version',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\Version',
                ),
                'weight' => array(
                    'namespace' => 'Font',
                    'tagname' => 'Weight',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\Weight',
                ),
                'xheight' => array(
                    'namespace' => 'Font',
                    'tagname' => 'XHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\XHeight',
                ),
                'numfonts' => array(
                    'namespace' => 'Font',
                    'tagname' => 'NumFonts',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\NumFonts',
                ),
                'postscriptfontname' => array(
                    'namespace' => 'Font',
                    'tagname' => 'PostScriptFontName',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\PostScriptFontName',
                ),
                'copyright' => array(
                    'namespace' => 'Font',
                    'tagname' => 'Copyright',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\Copyright',
                ),
                'fontsubfamily' => array(
                    'namespace' => 'Font',
                    'tagname' => 'FontSubfamily',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\FontSubfamily',
                ),
                'fontsubfamilyid' => array(
                    'namespace' => 'Font',
                    'tagname' => 'FontSubfamilyID',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\FontSubfamilyID',
                ),
                'nametableversion' => array(
                    'namespace' => 'Font',
                    'tagname' => 'NameTableVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\NameTableVersion',
                ),
                'trademark' => array(
                    'namespace' => 'Font',
                    'tagname' => 'Trademark',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\Trademark',
                ),
                'manufacturer' => array(
                    'namespace' => 'Font',
                    'tagname' => 'Manufacturer',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\Manufacturer',
                ),
                'designer' => array(
                    'namespace' => 'Font',
                    'tagname' => 'Designer',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\Designer',
                ),
                'description' => array(
                    'namespace' => 'Font',
                    'tagname' => 'Description',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\Description',
                ),
                'vendorurl' => array(
                    'namespace' => 'Font',
                    'tagname' => 'VendorURL',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\VendorURL',
                ),
                'designerurl' => array(
                    'namespace' => 'Font',
                    'tagname' => 'DesignerURL',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\DesignerURL',
                ),
                'license' => array(
                    'namespace' => 'Font',
                    'tagname' => 'License',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\License',
                ),
                'licenseinfourl' => array(
                    'namespace' => 'Font',
                    'tagname' => 'LicenseInfoURL',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\LicenseInfoURL',
                ),
                'preferredfamily' => array(
                    'namespace' => 'Font',
                    'tagname' => 'PreferredFamily',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\PreferredFamily',
                ),
                'preferredsubfamily' => array(
                    'namespace' => 'Font',
                    'tagname' => 'PreferredSubfamily',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\PreferredSubfamily',
                ),
                'compatiblefontname' => array(
                    'namespace' => 'Font',
                    'tagname' => 'CompatibleFontName',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\CompatibleFontName',
                ),
                'sampletext' => array(
                    'namespace' => 'Font',
                    'tagname' => 'SampleText',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\SampleText',
                ),
                'wwsfamilyname' => array(
                    'namespace' => 'Font',
                    'tagname' => 'WWSFamilyName',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\WWSFamilyName',
                ),
                'wwssubfamilyname' => array(
                    'namespace' => 'Font',
                    'tagname' => 'WWSSubfamilyName',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\WWSSubfamilyName',
                ),
                'pfmversion' => array(
                    'namespace' => 'Font',
                    'tagname' => 'PFMVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\PFMVersion',
                ),
                'fonttype' => array(
                    'namespace' => 'Font',
                    'tagname' => 'FontType',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\FontType',
                ),
                'pointsize' => array(
                    'namespace' => 'Font',
                    'tagname' => 'PointSize',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\PointSize',
                ),
                'yresolution' => array(
                    'namespace' => 'Font',
                    'tagname' => 'YResolution',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\YResolution',
                ),
                'xresolution' => array(
                    'namespace' => 'Font',
                    'tagname' => 'XResolution',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\XResolution',
                ),
                'ascent' => array(
                    'namespace' => 'Font',
                    'tagname' => 'Ascent',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\Ascent',
                ),
                'internalleading' => array(
                    'namespace' => 'Font',
                    'tagname' => 'InternalLeading',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\InternalLeading',
                ),
                'externalleading' => array(
                    'namespace' => 'Font',
                    'tagname' => 'ExternalLeading',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\ExternalLeading',
                ),
                'italic' => array(
                    'namespace' => 'Font',
                    'tagname' => 'Italic',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\Italic',
                ),
                'underline' => array(
                    'namespace' => 'Font',
                    'tagname' => 'Underline',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\Underline',
                ),
                'strikeout' => array(
                    'namespace' => 'Font',
                    'tagname' => 'Strikeout',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\Strikeout',
                ),
                'pixwidth' => array(
                    'namespace' => 'Font',
                    'tagname' => 'PixWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\PixWidth',
                ),
                'pixheight' => array(
                    'namespace' => 'Font',
                    'tagname' => 'PixHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\PixHeight',
                ),
                'pitchandfamily' => array(
                    'namespace' => 'Font',
                    'tagname' => 'PitchAndFamily',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\PitchAndFamily',
                ),
                'avgwidth' => array(
                    'namespace' => 'Font',
                    'tagname' => 'AvgWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\AvgWidth',
                ),
                'maxwidth' => array(
                    'namespace' => 'Font',
                    'tagname' => 'MaxWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\MaxWidth',
                ),
                'firstchar' => array(
                    'namespace' => 'Font',
                    'tagname' => 'FirstChar',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\FirstChar',
                ),
                'lastchar' => array(
                    'namespace' => 'Font',
                    'tagname' => 'LastChar',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\LastChar',
                ),
                'defaultchar' => array(
                    'namespace' => 'Font',
                    'tagname' => 'DefaultChar',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\DefaultChar',
                ),
                'breakchar' => array(
                    'namespace' => 'Font',
                    'tagname' => 'BreakChar',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\BreakChar',
                ),
                'widthbytes' => array(
                    'namespace' => 'Font',
                    'tagname' => 'WidthBytes',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\WidthBytes',
                ),
                'fstype' => array(
                    'namespace' => 'Font',
                    'tagname' => 'FSType',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\FSType',
                ),
                'italicangle' => array(
                    'namespace' => 'Font',
                    'tagname' => 'ItalicAngle',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\ItalicAngle',
                ),
                'underlineposition' => array(
                    'namespace' => 'Font',
                    'tagname' => 'UnderlinePosition',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\UnderlinePosition',
                ),
                'underlinethickness' => array(
                    'namespace' => 'Font',
                    'tagname' => 'UnderlineThickness',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\UnderlineThickness',
                ),
                'isfixedpitch' => array(
                    'namespace' => 'Font',
                    'tagname' => 'IsFixedPitch',
                    'classname' => 'PHPExiftool\Driver\Tag\Font\IsFixedPitch',
                ),
            ),
            'fotostation' => array(
                'thumbnailimage' => array(
                    'namespace' => 'FotoStation',
                    'tagname' => 'ThumbnailImage',
                    'classname' => 'PHPExiftool\Driver\Tag\FotoStation\ThumbnailImage',
                ),
                'previewimage' => array(
                    'namespace' => 'FotoStation',
                    'tagname' => 'PreviewImage',
                    'classname' => 'PHPExiftool\Driver\Tag\FotoStation\PreviewImage',
                ),
                'originalimagewidth' => array(
                    'namespace' => 'FotoStation',
                    'tagname' => 'OriginalImageWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\FotoStation\OriginalImageWidth',
                ),
                'originalimageheight' => array(
                    'namespace' => 'FotoStation',
                    'tagname' => 'OriginalImageHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\FotoStation\OriginalImageHeight',
                ),
                'colorplanes' => array(
                    'namespace' => 'FotoStation',
                    'tagname' => 'ColorPlanes',
                    'classname' => 'PHPExiftool\Driver\Tag\FotoStation\ColorPlanes',
                ),
                'xyresolution' => array(
                    'namespace' => 'FotoStation',
                    'tagname' => 'XYResolution',
                    'classname' => 'PHPExiftool\Driver\Tag\FotoStation\XYResolution',
                ),
                'rotation' => array(
                    'namespace' => 'FotoStation',
                    'tagname' => 'Rotation',
                    'classname' => 'PHPExiftool\Driver\Tag\FotoStation\Rotation',
                ),
                'cropleft' => array(
                    'namespace' => 'FotoStation',
                    'tagname' => 'CropLeft',
                    'classname' => 'PHPExiftool\Driver\Tag\FotoStation\CropLeft',
                ),
                'croptop' => array(
                    'namespace' => 'FotoStation',
                    'tagname' => 'CropTop',
                    'classname' => 'PHPExiftool\Driver\Tag\FotoStation\CropTop',
                ),
                'cropright' => array(
                    'namespace' => 'FotoStation',
                    'tagname' => 'CropRight',
                    'classname' => 'PHPExiftool\Driver\Tag\FotoStation\CropRight',
                ),
                'cropbottom' => array(
                    'namespace' => 'FotoStation',
                    'tagname' => 'CropBottom',
                    'classname' => 'PHPExiftool\Driver\Tag\FotoStation\CropBottom',
                ),
                'croprotation' => array(
                    'namespace' => 'FotoStation',
                    'tagname' => 'CropRotation',
                    'classname' => 'PHPExiftool\Driver\Tag\FotoStation\CropRotation',
                ),
            ),
            'fujifilm' => array(
                'af-csetting' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'AF-CSetting',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\AFCSetting',
                ),
                'af-ctrackingsensitivity' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'AF-CTrackingSensitivity',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\AFCTrackingSensitivity',
                ),
                'af-cspeedtrackingsensitivity' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'AF-CSpeedTrackingSensitivity',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\AFCSpeedTrackingSensitivity',
                ),
                'af-czoneareaswitching' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'AF-CZoneAreaSwitching',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\AFCZoneAreaSwitching',
                ),
                'drivemode' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'DriveMode',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\DriveMode',
                ),
                'drivespeed' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'DriveSpeed',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\DriveSpeed',
                ),
                'moviestreamname' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'MovieStreamName',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\MovieStreamName',
                ),
                'face1birthday' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Face1Birthday',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Face1Birthday',
                ),
                'face1category' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Face1Category',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Face1Category',
                ),
                'face1name' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Face1Name',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Face1Name',
                ),
                'face2birthday' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Face2Birthday',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Face2Birthday',
                ),
                'face2category' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Face2Category',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Face2Category',
                ),
                'face2name' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Face2Name',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Face2Name',
                ),
                'face3birthday' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Face3Birthday',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Face3Birthday',
                ),
                'face3category' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Face3Category',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Face3Category',
                ),
                'face3name' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Face3Name',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Face3Name',
                ),
                'face4birthday' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Face4Birthday',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Face4Birthday',
                ),
                'face4category' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Face4Category',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Face4Category',
                ),
                'face4name' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Face4Name',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Face4Name',
                ),
                'face5birthday' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Face5Birthday',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Face5Birthday',
                ),
                'face5category' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Face5Category',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Face5Category',
                ),
                'face5name' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Face5Name',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Face5Name',
                ),
                'face6birthday' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Face6Birthday',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Face6Birthday',
                ),
                'face6category' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Face6Category',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Face6Category',
                ),
                'face6name' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Face6Name',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Face6Name',
                ),
                'face7birthday' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Face7Birthday',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Face7Birthday',
                ),
                'face7category' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Face7Category',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Face7Category',
                ),
                'face7name' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Face7Name',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Face7Name',
                ),
                'face8birthday' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Face8Birthday',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Face8Birthday',
                ),
                'face8category' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Face8Category',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Face8Category',
                ),
                'face8name' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Face8Name',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Face8Name',
                ),
                'focusmode2' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'FocusMode2',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\FocusMode2',
                ),
                'afareamode' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'AFAreaMode',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\AFAreaMode',
                ),
                'afareapointsize' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'AFAreaPointSize',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\AFAreaPointSize',
                ),
                'afareazonesize' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'AFAreaZoneSize',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\AFAreaZoneSize',
                ),
                'make' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Make',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Make',
                ),
                'model' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Model',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Model',
                ),
                'exposuretime' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'ExposureTime',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\ExposureTime',
                ),
                'fnumber' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'FNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\FNumber',
                ),
                'exposurecompensation' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'ExposureCompensation',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\ExposureCompensation',
                ),
                'version' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Version',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Version',
                ),
                'internalserialnumber' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'InternalSerialNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\InternalSerialNumber',
                ),
                'quality' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Quality',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Quality',
                ),
                'sharpness' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Sharpness',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Sharpness',
                ),
                'whitebalance' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'WhiteBalance',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\WhiteBalance',
                ),
                'saturation' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Saturation',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Saturation',
                ),
                'contrast' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Contrast',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Contrast',
                ),
                'colortemperature' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'ColorTemperature',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\ColorTemperature',
                ),
                'whitebalancefinetune' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'WhiteBalanceFineTune',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\WhiteBalanceFineTune',
                ),
                'noisereduction' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'NoiseReduction',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\NoiseReduction',
                ),
                'fujiflashmode' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'FujiFlashMode',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\FujiFlashMode',
                ),
                'flashexposurecomp' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'FlashExposureComp',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\FlashExposureComp',
                ),
                'macro' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Macro',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Macro',
                ),
                'focusmode' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'FocusMode',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\FocusMode',
                ),
                'afmode' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'AFMode',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\AFMode',
                ),
                'focuspixel' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'FocusPixel',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\FocusPixel',
                ),
                'slowsync' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'SlowSync',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\SlowSync',
                ),
                'picturemode' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'PictureMode',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\PictureMode',
                ),
                'exposurecount' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'ExposureCount',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\ExposureCount',
                ),
                'exrauto' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'EXRAuto',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\EXRAuto',
                ),
                'exrmode' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'EXRMode',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\EXRMode',
                ),
                'shadowtone' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'ShadowTone',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\ShadowTone',
                ),
                'highlighttone' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'HighlightTone',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\HighlightTone',
                ),
                'digitalzoom' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'DigitalZoom',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\DigitalZoom',
                ),
                'lensmodulationoptimizer' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'LensModulationOptimizer',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\LensModulationOptimizer',
                ),
                'graineffect' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'GrainEffect',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\GrainEffect',
                ),
                'colorchromeeffect' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'ColorChromeEffect',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\ColorChromeEffect',
                ),
                'bwadjustment' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'BWAdjustment',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\BWAdjustment',
                ),
                'cropmode' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'CropMode',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\CropMode',
                ),
                'shuttertype' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'ShutterType',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\ShutterType',
                ),
                'autobracketing' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'AutoBracketing',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\AutoBracketing',
                ),
                'sequencenumber' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'SequenceNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\SequenceNumber',
                ),
                'panoramaangle' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'PanoramaAngle',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\PanoramaAngle',
                ),
                'panoramadirection' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'PanoramaDirection',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\PanoramaDirection',
                ),
                'advancedfilter' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'AdvancedFilter',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\AdvancedFilter',
                ),
                'colormode' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'ColorMode',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\ColorMode',
                ),
                'blurwarning' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'BlurWarning',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\BlurWarning',
                ),
                'focuswarning' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'FocusWarning',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\FocusWarning',
                ),
                'exposurewarning' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'ExposureWarning',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\ExposureWarning',
                ),
                'geimagesize' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'GEImageSize',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\GEImageSize',
                ),
                'dynamicrange' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'DynamicRange',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\DynamicRange',
                ),
                'filmmode' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'FilmMode',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\FilmMode',
                ),
                'dynamicrangesetting' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'DynamicRangeSetting',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\DynamicRangeSetting',
                ),
                'developmentdynamicrange' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'DevelopmentDynamicRange',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\DevelopmentDynamicRange',
                ),
                'minfocallength' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'MinFocalLength',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\MinFocalLength',
                ),
                'maxfocallength' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'MaxFocalLength',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\MaxFocalLength',
                ),
                'maxapertureatminfocal' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'MaxApertureAtMinFocal',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\MaxApertureAtMinFocal',
                ),
                'maxapertureatmaxfocal' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'MaxApertureAtMaxFocal',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\MaxApertureAtMaxFocal',
                ),
                'autodynamicrange' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'AutoDynamicRange',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\AutoDynamicRange',
                ),
                'imagestabilization' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'ImageStabilization',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\ImageStabilization',
                ),
                'scenerecognition' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'SceneRecognition',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\SceneRecognition',
                ),
                'rating' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Rating',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Rating',
                ),
                'imagegeneration' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'ImageGeneration',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\ImageGeneration',
                ),
                'imagecount' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'ImageCount',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\ImageCount',
                ),
                'drangepriority' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'DRangePriority',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\DRangePriority',
                ),
                'drangepriorityauto' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'DRangePriorityAuto',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\DRangePriorityAuto',
                ),
                'drangepriorityfixed' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'DRangePriorityFixed',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\DRangePriorityFixed',
                ),
                'flickerreduction' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'FlickerReduction',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\FlickerReduction',
                ),
                'videorecordingmode' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'VideoRecordingMode',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\VideoRecordingMode',
                ),
                'peripherallighting' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'PeripheralLighting',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\PeripheralLighting',
                ),
                'videocompression' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'VideoCompression',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\VideoCompression',
                ),
                'framerate' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'FrameRate',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\FrameRate',
                ),
                'framewidth' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'FrameWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\FrameWidth',
                ),
                'frameheight' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'FrameHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\FrameHeight',
                ),
                'fullhdhighspeedrec' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'FullHDHighSpeedRec',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\FullHDHighSpeedRec',
                ),
                'faceelementselected' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'FaceElementSelected',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\FaceElementSelected',
                ),
                'facesdetected' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'FacesDetected',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\FacesDetected',
                ),
                'facepositions' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'FacePositions',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\FacePositions',
                ),
                'numfaceelements' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'NumFaceElements',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\NumFaceElements',
                ),
                'faceelementtypes' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'FaceElementTypes',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\FaceElementTypes',
                ),
                'faceelementpositions' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'FaceElementPositions',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\FaceElementPositions',
                ),
                'filesource' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'FileSource',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\FileSource',
                ),
                'ordernumber' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'OrderNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\OrderNumber',
                ),
                'framenumber' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'FrameNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\FrameNumber',
                ),
                'parallax' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'Parallax',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\Parallax',
                ),
                'af-spriority' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'AF-SPriority',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\AFSPriority',
                ),
                'af-cpriority' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'AF-CPriority',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\AFCPriority',
                ),
                'rawimagewidth' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'RawImageWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\RawImageWidth',
                ),
                'rawimageheight' => array(
                    'namespace' => 'FujiFilm',
                    'tagname' => 'RawImageHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiFilm\RawImageHeight',
                ),
            ),
            'fujiifd' => array(
                'rawimagefullwidth' => array(
                    'namespace' => 'FujiIFD',
                    'tagname' => 'RawImageFullWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiIFD\RawImageFullWidth',
                ),
                'rawimagefullheight' => array(
                    'namespace' => 'FujiIFD',
                    'tagname' => 'RawImageFullHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiIFD\RawImageFullHeight',
                ),
                'bitspersample' => array(
                    'namespace' => 'FujiIFD',
                    'tagname' => 'BitsPerSample',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiIFD\BitsPerSample',
                ),
                'stripoffsets' => array(
                    'namespace' => 'FujiIFD',
                    'tagname' => 'StripOffsets',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiIFD\StripOffsets',
                ),
                'stripbytecounts' => array(
                    'namespace' => 'FujiIFD',
                    'tagname' => 'StripByteCounts',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiIFD\StripByteCounts',
                ),
                'blacklevel' => array(
                    'namespace' => 'FujiIFD',
                    'tagname' => 'BlackLevel',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiIFD\BlackLevel',
                ),
                'geometricdistortionparams' => array(
                    'namespace' => 'FujiIFD',
                    'tagname' => 'GeometricDistortionParams',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiIFD\GeometricDistortionParams',
                ),
                'wb_grblevelsstandard' => array(
                    'namespace' => 'FujiIFD',
                    'tagname' => 'WB_GRBLevelsStandard',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiIFD\WBGRBLevelsStandard',
                ),
                'wb_grblevelsauto' => array(
                    'namespace' => 'FujiIFD',
                    'tagname' => 'WB_GRBLevelsAuto',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiIFD\WBGRBLevelsAuto',
                ),
                'wb_grblevels' => array(
                    'namespace' => 'FujiIFD',
                    'tagname' => 'WB_GRBLevels',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiIFD\WBGRBLevels',
                ),
                'chromaticaberrationparams' => array(
                    'namespace' => 'FujiIFD',
                    'tagname' => 'ChromaticAberrationParams',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiIFD\ChromaticAberrationParams',
                ),
                'vignettingparams' => array(
                    'namespace' => 'FujiIFD',
                    'tagname' => 'VignettingParams',
                    'classname' => 'PHPExiftool\Driver\Tag\FujiIFD\VignettingParams',
                ),
            ),
            'h264' => array(
                'aperturesetting' => array(
                    'namespace' => 'H264',
                    'tagname' => 'ApertureSetting',
                    'classname' => 'PHPExiftool\Driver\Tag\H264\ApertureSetting',
                ),
                'gain' => array(
                    'namespace' => 'H264',
                    'tagname' => 'Gain',
                    'classname' => 'PHPExiftool\Driver\Tag\H264\Gain',
                ),
                'exposureprogram' => array(
                    'namespace' => 'H264',
                    'tagname' => 'ExposureProgram',
                    'classname' => 'PHPExiftool\Driver\Tag\H264\ExposureProgram',
                ),
                'whitebalance' => array(
                    'namespace' => 'H264',
                    'tagname' => 'WhiteBalance',
                    'classname' => 'PHPExiftool\Driver\Tag\H264\WhiteBalance',
                ),
                'focus' => array(
                    'namespace' => 'H264',
                    'tagname' => 'Focus',
                    'classname' => 'PHPExiftool\Driver\Tag\H264\Focus',
                ),
                'imagestabilization' => array(
                    'namespace' => 'H264',
                    'tagname' => 'ImageStabilization',
                    'classname' => 'PHPExiftool\Driver\Tag\H264\ImageStabilization',
                ),
                'captureframerate' => array(
                    'namespace' => 'H264',
                    'tagname' => 'CaptureFrameRate',
                    'classname' => 'PHPExiftool\Driver\Tag\H264\CaptureFrameRate',
                ),
                'videoframerate' => array(
                    'namespace' => 'H264',
                    'tagname' => 'VideoFrameRate',
                    'classname' => 'PHPExiftool\Driver\Tag\H264\VideoFrameRate',
                ),
                'timecode' => array(
                    'namespace' => 'H264',
                    'tagname' => 'TimeCode',
                    'classname' => 'PHPExiftool\Driver\Tag\H264\TimeCode',
                ),
                'datetimeoriginal' => array(
                    'namespace' => 'H264',
                    'tagname' => 'DateTimeOriginal',
                    'classname' => 'PHPExiftool\Driver\Tag\H264\DateTimeOriginal',
                ),
                'exposuretime' => array(
                    'namespace' => 'H264',
                    'tagname' => 'ExposureTime',
                    'classname' => 'PHPExiftool\Driver\Tag\H264\ExposureTime',
                ),
                'fnumber' => array(
                    'namespace' => 'H264',
                    'tagname' => 'FNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\H264\FNumber',
                ),
                'brightnessvalue' => array(
                    'namespace' => 'H264',
                    'tagname' => 'BrightnessValue',
                    'classname' => 'PHPExiftool\Driver\Tag\H264\BrightnessValue',
                ),
                'exposurecompensation' => array(
                    'namespace' => 'H264',
                    'tagname' => 'ExposureCompensation',
                    'classname' => 'PHPExiftool\Driver\Tag\H264\ExposureCompensation',
                ),
                'maxaperturevalue' => array(
                    'namespace' => 'H264',
                    'tagname' => 'MaxApertureValue',
                    'classname' => 'PHPExiftool\Driver\Tag\H264\MaxApertureValue',
                ),
                'flash' => array(
                    'namespace' => 'H264',
                    'tagname' => 'Flash',
                    'classname' => 'PHPExiftool\Driver\Tag\H264\Flash',
                ),
                'customrendered' => array(
                    'namespace' => 'H264',
                    'tagname' => 'CustomRendered',
                    'classname' => 'PHPExiftool\Driver\Tag\H264\CustomRendered',
                ),
                'focallengthin35mmformat' => array(
                    'namespace' => 'H264',
                    'tagname' => 'FocalLengthIn35mmFormat',
                    'classname' => 'PHPExiftool\Driver\Tag\H264\FocalLengthIn35mmFormat',
                ),
                'scenecapturetype' => array(
                    'namespace' => 'H264',
                    'tagname' => 'SceneCaptureType',
                    'classname' => 'PHPExiftool\Driver\Tag\H264\SceneCaptureType',
                ),
                'model' => array(
                    'namespace' => 'H264',
                    'tagname' => 'Model',
                    'classname' => 'PHPExiftool\Driver\Tag\H264\Model',
                ),
                'imageheight' => array(
                    'namespace' => 'H264',
                    'tagname' => 'ImageHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\H264\ImageHeight',
                ),
                'imagewidth' => array(
                    'namespace' => 'H264',
                    'tagname' => 'ImageWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\H264\ImageWidth',
                ),
                'make' => array(
                    'namespace' => 'H264',
                    'tagname' => 'Make',
                    'classname' => 'PHPExiftool\Driver\Tag\H264\Make',
                ),
                'recordingmode' => array(
                    'namespace' => 'H264',
                    'tagname' => 'RecordingMode',
                    'classname' => 'PHPExiftool\Driver\Tag\H264\RecordingMode',
                ),
            ),
            'hp' => array(
                'serialnumber' => array(
                    'namespace' => 'HP',
                    'tagname' => 'SerialNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\HP\SerialNumber',
                ),
                'firmwareversion' => array(
                    'namespace' => 'HP',
                    'tagname' => 'FirmwareVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\HP\FirmwareVersion',
                ),
                'lensshading' => array(
                    'namespace' => 'HP',
                    'tagname' => 'LensShading',
                    'classname' => 'PHPExiftool\Driver\Tag\HP\LensShading',
                ),
                'previewimage' => array(
                    'namespace' => 'HP',
                    'tagname' => 'PreviewImage',
                    'classname' => 'PHPExiftool\Driver\Tag\HP\PreviewImage',
                ),
                'maxaperture' => array(
                    'namespace' => 'HP',
                    'tagname' => 'MaxAperture',
                    'classname' => 'PHPExiftool\Driver\Tag\HP\MaxAperture',
                ),
                'exposuretime' => array(
                    'namespace' => 'HP',
                    'tagname' => 'ExposureTime',
                    'classname' => 'PHPExiftool\Driver\Tag\HP\ExposureTime',
                ),
                'cameradatetime' => array(
                    'namespace' => 'HP',
                    'tagname' => 'CameraDateTime',
                    'classname' => 'PHPExiftool\Driver\Tag\HP\CameraDateTime',
                ),
                'iso' => array(
                    'namespace' => 'HP',
                    'tagname' => 'ISO',
                    'classname' => 'PHPExiftool\Driver\Tag\HP\ISO',
                ),
                'fnumber' => array(
                    'namespace' => 'HP',
                    'tagname' => 'FNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\HP\FNumber',
                ),
            ),
            'html' => array(
                'abstract' => array(
                    'namespace' => 'HTML',
                    'tagname' => 'Abstract',
                    'classname' => 'PHPExiftool\Driver\Tag\HTML\Abstract0',
                ),
                'author' => array(
                    'namespace' => 'HTML',
                    'tagname' => 'Author',
                    'classname' => 'PHPExiftool\Driver\Tag\HTML\Author',
                ),
                'classification' => array(
                    'namespace' => 'HTML',
                    'tagname' => 'Classification',
                    'classname' => 'PHPExiftool\Driver\Tag\HTML\Classification',
                ),
                'contentlanguage' => array(
                    'namespace' => 'HTML',
                    'tagname' => 'ContentLanguage',
                    'classname' => 'PHPExiftool\Driver\Tag\HTML\ContentLanguage',
                ),
                'copyright' => array(
                    'namespace' => 'HTML',
                    'tagname' => 'Copyright',
                    'classname' => 'PHPExiftool\Driver\Tag\HTML\Copyright',
                ),
                'description' => array(
                    'namespace' => 'HTML',
                    'tagname' => 'Description',
                    'classname' => 'PHPExiftool\Driver\Tag\HTML\Description',
                ),
                'distribution' => array(
                    'namespace' => 'HTML',
                    'tagname' => 'Distribution',
                    'classname' => 'PHPExiftool\Driver\Tag\HTML\Distribution',
                ),
                'docclass' => array(
                    'namespace' => 'HTML',
                    'tagname' => 'DocClass',
                    'classname' => 'PHPExiftool\Driver\Tag\HTML\DocClass',
                ),
                'docrights' => array(
                    'namespace' => 'HTML',
                    'tagname' => 'DocRights',
                    'classname' => 'PHPExiftool\Driver\Tag\HTML\DocRights',
                ),
                'doctype' => array(
                    'namespace' => 'HTML',
                    'tagname' => 'DocType',
                    'classname' => 'PHPExiftool\Driver\Tag\HTML\DocType',
                ),
                'formatter' => array(
                    'namespace' => 'HTML',
                    'tagname' => 'Formatter',
                    'classname' => 'PHPExiftool\Driver\Tag\HTML\Formatter',
                ),
                'generator' => array(
                    'namespace' => 'HTML',
                    'tagname' => 'Generator',
                    'classname' => 'PHPExiftool\Driver\Tag\HTML\Generator',
                ),
                'generatorversion' => array(
                    'namespace' => 'HTML',
                    'tagname' => 'GeneratorVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\HTML\GeneratorVersion',
                ),
                'googlebot' => array(
                    'namespace' => 'HTML',
                    'tagname' => 'GoogleBot',
                    'classname' => 'PHPExiftool\Driver\Tag\HTML\GoogleBot',
                ),
                'keywords' => array(
                    'namespace' => 'HTML',
                    'tagname' => 'Keywords',
                    'classname' => 'PHPExiftool\Driver\Tag\HTML\Keywords',
                ),
                'nomssmarttags' => array(
                    'namespace' => 'HTML',
                    'tagname' => 'NoMSSmartTags',
                    'classname' => 'PHPExiftool\Driver\Tag\HTML\NoMSSmartTags',
                ),
                'originator' => array(
                    'namespace' => 'HTML',
                    'tagname' => 'Originator',
                    'classname' => 'PHPExiftool\Driver\Tag\HTML\Originator',
                ),
                'owner' => array(
                    'namespace' => 'HTML',
                    'tagname' => 'Owner',
                    'classname' => 'PHPExiftool\Driver\Tag\HTML\Owner',
                ),
                'progid' => array(
                    'namespace' => 'HTML',
                    'tagname' => 'ProgID',
                    'classname' => 'PHPExiftool\Driver\Tag\HTML\ProgID',
                ),
                'rating' => array(
                    'namespace' => 'HTML',
                    'tagname' => 'Rating',
                    'classname' => 'PHPExiftool\Driver\Tag\HTML\Rating',
                ),
                'refresh' => array(
                    'namespace' => 'HTML',
                    'tagname' => 'Refresh',
                    'classname' => 'PHPExiftool\Driver\Tag\HTML\Refresh',
                ),
                'resourcetype' => array(
                    'namespace' => 'HTML',
                    'tagname' => 'ResourceType',
                    'classname' => 'PHPExiftool\Driver\Tag\HTML\ResourceType',
                ),
                'revisitafter' => array(
                    'namespace' => 'HTML',
                    'tagname' => 'RevisitAfter',
                    'classname' => 'PHPExiftool\Driver\Tag\HTML\RevisitAfter',
                ),
                'robots' => array(
                    'namespace' => 'HTML',
                    'tagname' => 'Robots',
                    'classname' => 'PHPExiftool\Driver\Tag\HTML\Robots',
                ),
                'title' => array(
                    'namespace' => 'HTML',
                    'tagname' => 'Title',
                    'classname' => 'PHPExiftool\Driver\Tag\HTML\Title',
                ),
            ),
            'html-office' => array(
                'author' => array(
                    'namespace' => 'HTML-office',
                    'tagname' => 'Author',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLOffice\Author',
                ),
                'category' => array(
                    'namespace' => 'HTML-office',
                    'tagname' => 'Category',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLOffice\Category',
                ),
                'characters' => array(
                    'namespace' => 'HTML-office',
                    'tagname' => 'Characters',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLOffice\Characters',
                ),
                'characterswithspaces' => array(
                    'namespace' => 'HTML-office',
                    'tagname' => 'CharactersWithSpaces',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLOffice\CharactersWithSpaces',
                ),
                'company' => array(
                    'namespace' => 'HTML-office',
                    'tagname' => 'Company',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLOffice\Company',
                ),
                'createdate' => array(
                    'namespace' => 'HTML-office',
                    'tagname' => 'CreateDate',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLOffice\CreateDate',
                ),
                'description' => array(
                    'namespace' => 'HTML-office',
                    'tagname' => 'Description',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLOffice\Description',
                ),
                'keywords' => array(
                    'namespace' => 'HTML-office',
                    'tagname' => 'Keywords',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLOffice\Keywords',
                ),
                'lastauthor' => array(
                    'namespace' => 'HTML-office',
                    'tagname' => 'LastAuthor',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLOffice\LastAuthor',
                ),
                'lastprinted' => array(
                    'namespace' => 'HTML-office',
                    'tagname' => 'LastPrinted',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLOffice\LastPrinted',
                ),
                'modifydate' => array(
                    'namespace' => 'HTML-office',
                    'tagname' => 'ModifyDate',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLOffice\ModifyDate',
                ),
                'lines' => array(
                    'namespace' => 'HTML-office',
                    'tagname' => 'Lines',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLOffice\Lines',
                ),
                'manager' => array(
                    'namespace' => 'HTML-office',
                    'tagname' => 'Manager',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLOffice\Manager',
                ),
                'pages' => array(
                    'namespace' => 'HTML-office',
                    'tagname' => 'Pages',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLOffice\Pages',
                ),
                'paragraphs' => array(
                    'namespace' => 'HTML-office',
                    'tagname' => 'Paragraphs',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLOffice\Paragraphs',
                ),
                'revisionnumber' => array(
                    'namespace' => 'HTML-office',
                    'tagname' => 'RevisionNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLOffice\RevisionNumber',
                ),
                'subject' => array(
                    'namespace' => 'HTML-office',
                    'tagname' => 'Subject',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLOffice\Subject',
                ),
                'template' => array(
                    'namespace' => 'HTML-office',
                    'tagname' => 'Template',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLOffice\Template',
                ),
                'totaledittime' => array(
                    'namespace' => 'HTML-office',
                    'tagname' => 'TotalEditTime',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLOffice\TotalEditTime',
                ),
                'words' => array(
                    'namespace' => 'HTML-office',
                    'tagname' => 'Words',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLOffice\Words',
                ),
            ),
            'html-dc' => array(
                'contributor' => array(
                    'namespace' => 'HTML-dc',
                    'tagname' => 'Contributor',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLDc\Contributor',
                ),
                'coverage' => array(
                    'namespace' => 'HTML-dc',
                    'tagname' => 'Coverage',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLDc\Coverage',
                ),
                'creator' => array(
                    'namespace' => 'HTML-dc',
                    'tagname' => 'Creator',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLDc\Creator',
                ),
                'date' => array(
                    'namespace' => 'HTML-dc',
                    'tagname' => 'Date',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLDc\Date',
                ),
                'description' => array(
                    'namespace' => 'HTML-dc',
                    'tagname' => 'Description',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLDc\Description',
                ),
                'format' => array(
                    'namespace' => 'HTML-dc',
                    'tagname' => 'Format',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLDc\Format',
                ),
                'identifier' => array(
                    'namespace' => 'HTML-dc',
                    'tagname' => 'Identifier',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLDc\Identifier',
                ),
                'language' => array(
                    'namespace' => 'HTML-dc',
                    'tagname' => 'Language',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLDc\Language',
                ),
                'publisher' => array(
                    'namespace' => 'HTML-dc',
                    'tagname' => 'Publisher',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLDc\Publisher',
                ),
                'relation' => array(
                    'namespace' => 'HTML-dc',
                    'tagname' => 'Relation',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLDc\Relation',
                ),
                'rights' => array(
                    'namespace' => 'HTML-dc',
                    'tagname' => 'Rights',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLDc\Rights',
                ),
                'source' => array(
                    'namespace' => 'HTML-dc',
                    'tagname' => 'Source',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLDc\Source',
                ),
                'subject' => array(
                    'namespace' => 'HTML-dc',
                    'tagname' => 'Subject',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLDc\Subject',
                ),
                'title' => array(
                    'namespace' => 'HTML-dc',
                    'tagname' => 'Title',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLDc\Title',
                ),
                'type' => array(
                    'namespace' => 'HTML-dc',
                    'tagname' => 'Type',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLDc\Type',
                ),
            ),
            'http-equiv' => array(
                'cachecontrol' => array(
                    'namespace' => 'HTTP-equiv',
                    'tagname' => 'CacheControl',
                    'classname' => 'PHPExiftool\Driver\Tag\HTTPEquiv\CacheControl',
                ),
                'contentdisposition' => array(
                    'namespace' => 'HTTP-equiv',
                    'tagname' => 'ContentDisposition',
                    'classname' => 'PHPExiftool\Driver\Tag\HTTPEquiv\ContentDisposition',
                ),
                'contentlanguage' => array(
                    'namespace' => 'HTTP-equiv',
                    'tagname' => 'ContentLanguage',
                    'classname' => 'PHPExiftool\Driver\Tag\HTTPEquiv\ContentLanguage',
                ),
                'contentscripttype' => array(
                    'namespace' => 'HTTP-equiv',
                    'tagname' => 'ContentScriptType',
                    'classname' => 'PHPExiftool\Driver\Tag\HTTPEquiv\ContentScriptType',
                ),
                'contentstyletype' => array(
                    'namespace' => 'HTTP-equiv',
                    'tagname' => 'ContentStyleType',
                    'classname' => 'PHPExiftool\Driver\Tag\HTTPEquiv\ContentStyleType',
                ),
                'contenttype' => array(
                    'namespace' => 'HTTP-equiv',
                    'tagname' => 'ContentType',
                    'classname' => 'PHPExiftool\Driver\Tag\HTTPEquiv\ContentType',
                ),
                'defaultstyle' => array(
                    'namespace' => 'HTTP-equiv',
                    'tagname' => 'DefaultStyle',
                    'classname' => 'PHPExiftool\Driver\Tag\HTTPEquiv\DefaultStyle',
                ),
                'expires' => array(
                    'namespace' => 'HTTP-equiv',
                    'tagname' => 'Expires',
                    'classname' => 'PHPExiftool\Driver\Tag\HTTPEquiv\Expires',
                ),
                'extcache' => array(
                    'namespace' => 'HTTP-equiv',
                    'tagname' => 'ExtCache',
                    'classname' => 'PHPExiftool\Driver\Tag\HTTPEquiv\ExtCache',
                ),
                'imagetoolbar' => array(
                    'namespace' => 'HTTP-equiv',
                    'tagname' => 'ImageToolbar',
                    'classname' => 'PHPExiftool\Driver\Tag\HTTPEquiv\ImageToolbar',
                ),
                'lotus' => array(
                    'namespace' => 'HTTP-equiv',
                    'tagname' => 'Lotus',
                    'classname' => 'PHPExiftool\Driver\Tag\HTTPEquiv\Lotus',
                ),
                'pageenter' => array(
                    'namespace' => 'HTTP-equiv',
                    'tagname' => 'PageEnter',
                    'classname' => 'PHPExiftool\Driver\Tag\HTTPEquiv\PageEnter',
                ),
                'pageexit' => array(
                    'namespace' => 'HTTP-equiv',
                    'tagname' => 'PageExit',
                    'classname' => 'PHPExiftool\Driver\Tag\HTTPEquiv\PageExit',
                ),
                'picslabel' => array(
                    'namespace' => 'HTTP-equiv',
                    'tagname' => 'PicsLabel',
                    'classname' => 'PHPExiftool\Driver\Tag\HTTPEquiv\PicsLabel',
                ),
                'pragma' => array(
                    'namespace' => 'HTTP-equiv',
                    'tagname' => 'Pragma',
                    'classname' => 'PHPExiftool\Driver\Tag\HTTPEquiv\Pragma',
                ),
                'refresh' => array(
                    'namespace' => 'HTTP-equiv',
                    'tagname' => 'Refresh',
                    'classname' => 'PHPExiftool\Driver\Tag\HTTPEquiv\Refresh',
                ),
                'replyto' => array(
                    'namespace' => 'HTTP-equiv',
                    'tagname' => 'ReplyTo',
                    'classname' => 'PHPExiftool\Driver\Tag\HTTPEquiv\ReplyTo',
                ),
                'setcookie' => array(
                    'namespace' => 'HTTP-equiv',
                    'tagname' => 'SetCookie',
                    'classname' => 'PHPExiftool\Driver\Tag\HTTPEquiv\SetCookie',
                ),
                'siteenter' => array(
                    'namespace' => 'HTTP-equiv',
                    'tagname' => 'SiteEnter',
                    'classname' => 'PHPExiftool\Driver\Tag\HTTPEquiv\SiteEnter',
                ),
                'siteexit' => array(
                    'namespace' => 'HTTP-equiv',
                    'tagname' => 'SiteExit',
                    'classname' => 'PHPExiftool\Driver\Tag\HTTPEquiv\SiteExit',
                ),
                'vary' => array(
                    'namespace' => 'HTTP-equiv',
                    'tagname' => 'Vary',
                    'classname' => 'PHPExiftool\Driver\Tag\HTTPEquiv\Vary',
                ),
                'windowtarget' => array(
                    'namespace' => 'HTTP-equiv',
                    'tagname' => 'WindowTarget',
                    'classname' => 'PHPExiftool\Driver\Tag\HTTPEquiv\WindowTarget',
                ),
            ),
            'html-ncc' => array(
                'characterset' => array(
                    'namespace' => 'HTML-ncc',
                    'tagname' => 'CharacterSet',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLNcc\CharacterSet',
                ),
                'depth' => array(
                    'namespace' => 'HTML-ncc',
                    'tagname' => 'Depth',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLNcc\Depth',
                ),
                'files' => array(
                    'namespace' => 'HTML-ncc',
                    'tagname' => 'Files',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLNcc\Files',
                ),
                'footnotes' => array(
                    'namespace' => 'HTML-ncc',
                    'tagname' => 'Footnotes',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLNcc\Footnotes',
                ),
                'generator' => array(
                    'namespace' => 'HTML-ncc',
                    'tagname' => 'Generator',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLNcc\Generator',
                ),
                'kbytesize' => array(
                    'namespace' => 'HTML-ncc',
                    'tagname' => 'KByteSize',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLNcc\KByteSize',
                ),
                'maxpagenormal' => array(
                    'namespace' => 'HTML-ncc',
                    'tagname' => 'MaxPageNormal',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLNcc\MaxPageNormal',
                ),
                'multimediatype' => array(
                    'namespace' => 'HTML-ncc',
                    'tagname' => 'MultimediaType',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLNcc\MultimediaType',
                ),
                'narrator' => array(
                    'namespace' => 'HTML-ncc',
                    'tagname' => 'Narrator',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLNcc\Narrator',
                ),
                'pagefront' => array(
                    'namespace' => 'HTML-ncc',
                    'tagname' => 'PageFront',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLNcc\PageFront',
                ),
                'pagenormal' => array(
                    'namespace' => 'HTML-ncc',
                    'tagname' => 'PageNormal',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLNcc\PageNormal',
                ),
                'pagespecial' => array(
                    'namespace' => 'HTML-ncc',
                    'tagname' => 'PageSpecial',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLNcc\PageSpecial',
                ),
                'prodnotes' => array(
                    'namespace' => 'HTML-ncc',
                    'tagname' => 'ProdNotes',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLNcc\ProdNotes',
                ),
                'produceddate' => array(
                    'namespace' => 'HTML-ncc',
                    'tagname' => 'ProducedDate',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLNcc\ProducedDate',
                ),
                'producer' => array(
                    'namespace' => 'HTML-ncc',
                    'tagname' => 'Producer',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLNcc\Producer',
                ),
                'revision' => array(
                    'namespace' => 'HTML-ncc',
                    'tagname' => 'Revision',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLNcc\Revision',
                ),
                'revisiondate' => array(
                    'namespace' => 'HTML-ncc',
                    'tagname' => 'RevisionDate',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLNcc\RevisionDate',
                ),
                'setinfo' => array(
                    'namespace' => 'HTML-ncc',
                    'tagname' => 'SetInfo',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLNcc\SetInfo',
                ),
                'sidebars' => array(
                    'namespace' => 'HTML-ncc',
                    'tagname' => 'Sidebars',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLNcc\Sidebars',
                ),
                'sourcedate' => array(
                    'namespace' => 'HTML-ncc',
                    'tagname' => 'SourceDate',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLNcc\SourceDate',
                ),
                'sourceedition' => array(
                    'namespace' => 'HTML-ncc',
                    'tagname' => 'SourceEdition',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLNcc\SourceEdition',
                ),
                'sourcepublisher' => array(
                    'namespace' => 'HTML-ncc',
                    'tagname' => 'SourcePublisher',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLNcc\SourcePublisher',
                ),
                'sourcerights' => array(
                    'namespace' => 'HTML-ncc',
                    'tagname' => 'SourceRights',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLNcc\SourceRights',
                ),
                'sourcetitle' => array(
                    'namespace' => 'HTML-ncc',
                    'tagname' => 'SourceTitle',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLNcc\SourceTitle',
                ),
                'tocitems' => array(
                    'namespace' => 'HTML-ncc',
                    'tagname' => 'TOCItems',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLNcc\TOCItems',
                ),
                'duration' => array(
                    'namespace' => 'HTML-ncc',
                    'tagname' => 'Duration',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLNcc\Duration',
                ),
            ),
            'html-prod' => array(
                'recengineer' => array(
                    'namespace' => 'HTML-prod',
                    'tagname' => 'RecEngineer',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLProd\RecEngineer',
                ),
                'reclocation' => array(
                    'namespace' => 'HTML-prod',
                    'tagname' => 'RecLocation',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLProd\RecLocation',
                ),
            ),
            'html-vw96' => array(
                'objecttype' => array(
                    'namespace' => 'HTML-vw96',
                    'tagname' => 'ObjectType',
                    'classname' => 'PHPExiftool\Driver\Tag\HTMLVw96\ObjectType',
                ),
            ),
            'icc-chrm' => array(
                'chromaticitychannels' => array(
                    'namespace' => 'ICC-chrm',
                    'tagname' => 'ChromaticityChannels',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCChrm\ChromaticityChannels',
                ),
                'chromaticitycolorant' => array(
                    'namespace' => 'ICC-chrm',
                    'tagname' => 'ChromaticityColorant',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCChrm\ChromaticityColorant',
                ),
                'chromaticitychannel1' => array(
                    'namespace' => 'ICC-chrm',
                    'tagname' => 'ChromaticityChannel1',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCChrm\ChromaticityChannel1',
                ),
                'chromaticitychannel2' => array(
                    'namespace' => 'ICC-chrm',
                    'tagname' => 'ChromaticityChannel2',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCChrm\ChromaticityChannel2',
                ),
                'chromaticitychannel3' => array(
                    'namespace' => 'ICC-chrm',
                    'tagname' => 'ChromaticityChannel3',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCChrm\ChromaticityChannel3',
                ),
                'chromaticitychannel4' => array(
                    'namespace' => 'ICC-chrm',
                    'tagname' => 'ChromaticityChannel4',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCChrm\ChromaticityChannel4',
                ),
            ),
            'icc-clrt' => array(
                'colorantcount' => array(
                    'namespace' => 'ICC-clrt',
                    'tagname' => 'ColorantCount',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCClrt\ColorantCount',
                ),
                'colorant1name' => array(
                    'namespace' => 'ICC-clrt',
                    'tagname' => 'Colorant1Name',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCClrt\Colorant1Name',
                ),
                'colorant1coordinates' => array(
                    'namespace' => 'ICC-clrt',
                    'tagname' => 'Colorant1Coordinates',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCClrt\Colorant1Coordinates',
                ),
                'colorant2name' => array(
                    'namespace' => 'ICC-clrt',
                    'tagname' => 'Colorant2Name',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCClrt\Colorant2Name',
                ),
                'colorant2coordinates' => array(
                    'namespace' => 'ICC-clrt',
                    'tagname' => 'Colorant2Coordinates',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCClrt\Colorant2Coordinates',
                ),
                'colorant3name' => array(
                    'namespace' => 'ICC-clrt',
                    'tagname' => 'Colorant3Name',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCClrt\Colorant3Name',
                ),
                'colorant3coordinates' => array(
                    'namespace' => 'ICC-clrt',
                    'tagname' => 'Colorant3Coordinates',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCClrt\Colorant3Coordinates',
                ),
            ),
            'icc-header' => array(
                'profilecmmtype' => array(
                    'namespace' => 'ICC-header',
                    'tagname' => 'ProfileCMMType',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCHeader\ProfileCMMType',
                ),
                'profileversion' => array(
                    'namespace' => 'ICC-header',
                    'tagname' => 'ProfileVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCHeader\ProfileVersion',
                ),
                'profileclass' => array(
                    'namespace' => 'ICC-header',
                    'tagname' => 'ProfileClass',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCHeader\ProfileClass',
                ),
                'colorspacedata' => array(
                    'namespace' => 'ICC-header',
                    'tagname' => 'ColorSpaceData',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCHeader\ColorSpaceData',
                ),
                'profileconnectionspace' => array(
                    'namespace' => 'ICC-header',
                    'tagname' => 'ProfileConnectionSpace',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCHeader\ProfileConnectionSpace',
                ),
                'profiledatetime' => array(
                    'namespace' => 'ICC-header',
                    'tagname' => 'ProfileDateTime',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCHeader\ProfileDateTime',
                ),
                'profilefilesignature' => array(
                    'namespace' => 'ICC-header',
                    'tagname' => 'ProfileFileSignature',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCHeader\ProfileFileSignature',
                ),
                'primaryplatform' => array(
                    'namespace' => 'ICC-header',
                    'tagname' => 'PrimaryPlatform',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCHeader\PrimaryPlatform',
                ),
                'cmmflags' => array(
                    'namespace' => 'ICC-header',
                    'tagname' => 'CMMFlags',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCHeader\CMMFlags',
                ),
                'devicemanufacturer' => array(
                    'namespace' => 'ICC-header',
                    'tagname' => 'DeviceManufacturer',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCHeader\DeviceManufacturer',
                ),
                'devicemodel' => array(
                    'namespace' => 'ICC-header',
                    'tagname' => 'DeviceModel',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCHeader\DeviceModel',
                ),
                'deviceattributes' => array(
                    'namespace' => 'ICC-header',
                    'tagname' => 'DeviceAttributes',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCHeader\DeviceAttributes',
                ),
                'renderingintent' => array(
                    'namespace' => 'ICC-header',
                    'tagname' => 'RenderingIntent',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCHeader\RenderingIntent',
                ),
                'connectionspaceilluminant' => array(
                    'namespace' => 'ICC-header',
                    'tagname' => 'ConnectionSpaceIlluminant',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCHeader\ConnectionSpaceIlluminant',
                ),
                'profilecreator' => array(
                    'namespace' => 'ICC-header',
                    'tagname' => 'ProfileCreator',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCHeader\ProfileCreator',
                ),
                'profileid' => array(
                    'namespace' => 'ICC-header',
                    'tagname' => 'ProfileID',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCHeader\ProfileID',
                ),
            ),
            'icc-meas' => array(
                'measurementobserver' => array(
                    'namespace' => 'ICC-meas',
                    'tagname' => 'MeasurementObserver',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCMeas\MeasurementObserver',
                ),
                'measurementbacking' => array(
                    'namespace' => 'ICC-meas',
                    'tagname' => 'MeasurementBacking',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCMeas\MeasurementBacking',
                ),
                'measurementgeometry' => array(
                    'namespace' => 'ICC-meas',
                    'tagname' => 'MeasurementGeometry',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCMeas\MeasurementGeometry',
                ),
                'measurementflare' => array(
                    'namespace' => 'ICC-meas',
                    'tagname' => 'MeasurementFlare',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCMeas\MeasurementFlare',
                ),
                'measurementilluminant' => array(
                    'namespace' => 'ICC-meas',
                    'tagname' => 'MeasurementIlluminant',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCMeas\MeasurementIlluminant',
                ),
            ),
            'icc-meta' => array(
                'manufacturername' => array(
                    'namespace' => 'ICC-meta',
                    'tagname' => 'ManufacturerName',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCMeta\ManufacturerName',
                ),
                'mediacolor' => array(
                    'namespace' => 'ICC-meta',
                    'tagname' => 'MediaColor',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCMeta\MediaColor',
                ),
                'mediaweight' => array(
                    'namespace' => 'ICC-meta',
                    'tagname' => 'MediaWeight',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCMeta\MediaWeight',
                ),
            ),
            'icc-view' => array(
                'viewingcondilluminant' => array(
                    'namespace' => 'ICC-view',
                    'tagname' => 'ViewingCondIlluminant',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCView\ViewingCondIlluminant',
                ),
                'viewingcondsurround' => array(
                    'namespace' => 'ICC-view',
                    'tagname' => 'ViewingCondSurround',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCView\ViewingCondSurround',
                ),
                'viewingcondilluminanttype' => array(
                    'namespace' => 'ICC-view',
                    'tagname' => 'ViewingCondIlluminantType',
                    'classname' => 'PHPExiftool\Driver\Tag\ICCView\ViewingCondIlluminantType',
                ),
            ),
            'id3' => array(
                'averagelevel' => array(
                    'namespace' => 'ID3',
                    'tagname' => 'AverageLevel',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3\AverageLevel',
                ),
                'peakvalue' => array(
                    'namespace' => 'ID3',
                    'tagname' => 'PeakValue',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3\PeakValue',
                ),
                'wm_mediaclassprimaryid' => array(
                    'namespace' => 'ID3',
                    'tagname' => 'WM_MediaClassPrimaryID',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3\WMMediaClassPrimaryID',
                ),
                'wm_mediaclasssecondaryid' => array(
                    'namespace' => 'ID3',
                    'tagname' => 'WM_MediaClassSecondaryID',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3\WMMediaClassSecondaryID',
                ),
                'wm_provider' => array(
                    'namespace' => 'ID3',
                    'tagname' => 'WM_Provider',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3\WMProvider',
                ),
                'wm_collectiongroupid' => array(
                    'namespace' => 'ID3',
                    'tagname' => 'WM_CollectionGroupID',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3\WMCollectionGroupID',
                ),
                'wm_collectionid' => array(
                    'namespace' => 'ID3',
                    'tagname' => 'WM_CollectionID',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3\WMCollectionID',
                ),
                'wm_contentid' => array(
                    'namespace' => 'ID3',
                    'tagname' => 'WM_ContentID',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3\WMContentID',
                ),
                'synchronizedlyricsdescription' => array(
                    'namespace' => 'ID3',
                    'tagname' => 'SynchronizedLyricsDescription',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3\SynchronizedLyricsDescription',
                ),
                'synchronizedlyricstext' => array(
                    'namespace' => 'ID3',
                    'tagname' => 'SynchronizedLyricsText',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3\SynchronizedLyricsText',
                ),
                'synchronizedlyricstype' => array(
                    'namespace' => 'ID3',
                    'tagname' => 'SynchronizedLyricsType',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3\SynchronizedLyricsType',
                ),
            ),
            'id3v1' => array(
                'title' => array(
                    'namespace' => 'ID3v1',
                    'tagname' => 'Title',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v1\Title',
                ),
                'artist' => array(
                    'namespace' => 'ID3v1',
                    'tagname' => 'Artist',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v1\Artist',
                ),
                'album' => array(
                    'namespace' => 'ID3v1',
                    'tagname' => 'Album',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v1\Album',
                ),
                'year' => array(
                    'namespace' => 'ID3v1',
                    'tagname' => 'Year',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v1\Year',
                ),
                'comment' => array(
                    'namespace' => 'ID3v1',
                    'tagname' => 'Comment',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v1\Comment',
                ),
                'track' => array(
                    'namespace' => 'ID3v1',
                    'tagname' => 'Track',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v1\Track',
                ),
                'genre' => array(
                    'namespace' => 'ID3v1',
                    'tagname' => 'Genre',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v1\Genre',
                ),
            ),
            'id3v1_enh' => array(
                'title2' => array(
                    'namespace' => 'ID3v1_Enh',
                    'tagname' => 'Title2',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v1Enh\Title2',
                ),
                'artist2' => array(
                    'namespace' => 'ID3v1_Enh',
                    'tagname' => 'Artist2',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v1Enh\Artist2',
                ),
                'album2' => array(
                    'namespace' => 'ID3v1_Enh',
                    'tagname' => 'Album2',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v1Enh\Album2',
                ),
                'speed' => array(
                    'namespace' => 'ID3v1_Enh',
                    'tagname' => 'Speed',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v1Enh\Speed',
                ),
                'genre' => array(
                    'namespace' => 'ID3v1_Enh',
                    'tagname' => 'Genre',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v1Enh\Genre',
                ),
                'starttime' => array(
                    'namespace' => 'ID3v1_Enh',
                    'tagname' => 'StartTime',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v1Enh\StartTime',
                ),
                'endtime' => array(
                    'namespace' => 'ID3v1_Enh',
                    'tagname' => 'EndTime',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v1Enh\EndTime',
                ),
            ),
            'id3v2_2' => array(
                'playcounter' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'PlayCounter',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\PlayCounter',
                ),
                'comment' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'Comment',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\Comment',
                ),
                'involvedpeople' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'InvolvedPeople',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\InvolvedPeople',
                ),
                'itunesu' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'iTunesU',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\ITunesU',
                ),
                'podcast' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'Podcast',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\Podcast',
                ),
                'picture' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'Picture',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\Picture',
                ),
                'pictureformat' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'PictureFormat',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\PictureFormat',
                ),
                'picturetype' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'PictureType',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\PictureType',
                ),
                'picturedescription' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'PictureDescription',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\PictureDescription',
                ),
                'popularimeter' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'Popularimeter',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\Popularimeter',
                ),
                'relativevolumeadjustment' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'RelativeVolumeAdjustment',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\RelativeVolumeAdjustment',
                ),
                'album' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'Album',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\Album',
                ),
                'beatsperminute' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'BeatsPerMinute',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\BeatsPerMinute',
                ),
                'composer' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'Composer',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\Composer',
                ),
                'genre' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'Genre',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\Genre',
                ),
                'compilation' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'Compilation',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\Compilation',
                ),
                'copyright' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'Copyright',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\Copyright',
                ),
                'date' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'Date',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\Date',
                ),
                'playlistdelay' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'PlaylistDelay',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\PlaylistDelay',
                ),
                'encodedby' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'EncodedBy',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\EncodedBy',
                ),
                'filetype' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'FileType',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\FileType',
                ),
                'time' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'Time',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\Time',
                ),
                'initialkey' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'InitialKey',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\InitialKey',
                ),
                'language' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'Language',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\Language',
                ),
                'length' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'Length',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\Length',
                ),
                'media' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'Media',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\Media',
                ),
                'originalartist' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'OriginalArtist',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\OriginalArtist',
                ),
                'originalfilename' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'OriginalFileName',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\OriginalFileName',
                ),
                'originallyricist' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'OriginalLyricist',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\OriginalLyricist',
                ),
                'originalreleaseyear' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'OriginalReleaseYear',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\OriginalReleaseYear',
                ),
                'originalalbum' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'OriginalAlbum',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\OriginalAlbum',
                ),
                'artist' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'Artist',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\Artist',
                ),
                'band' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'Band',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\Band',
                ),
                'conductor' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'Conductor',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\Conductor',
                ),
                'interpretedby' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'InterpretedBy',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\InterpretedBy',
                ),
                'partofset' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'PartOfSet',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\PartOfSet',
                ),
                'publisher' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'Publisher',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\Publisher',
                ),
                'isrc' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'ISRC',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\ISRC',
                ),
                'recordingdates' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'RecordingDates',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\RecordingDates',
                ),
                'track' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'Track',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\Track',
                ),
                'albumartistsortorder' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'AlbumArtistSortOrder',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\AlbumArtistSortOrder',
                ),
                'albumsortorder' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'AlbumSortOrder',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\AlbumSortOrder',
                ),
                'composersortorder' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'ComposerSortOrder',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\ComposerSortOrder',
                ),
                'size' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'Size',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\Size',
                ),
                'performersortorder' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'PerformerSortOrder',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\PerformerSortOrder',
                ),
                'encodersettings' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'EncoderSettings',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\EncoderSettings',
                ),
                'titlesortorder' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'TitleSortOrder',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\TitleSortOrder',
                ),
                'grouping' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'Grouping',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\Grouping',
                ),
                'title' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'Title',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\Title',
                ),
                'subtitle' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'Subtitle',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\Subtitle',
                ),
                'lyricist' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'Lyricist',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\Lyricist',
                ),
                'userdefinedtext' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'UserDefinedText',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\UserDefinedText',
                ),
                'year' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'Year',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\Year',
                ),
                'lyrics' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'Lyrics',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\Lyrics',
                ),
                'fileurl' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'FileURL',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\FileURL',
                ),
                'artisturl' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'ArtistURL',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\ArtistURL',
                ),
                'sourceurl' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'SourceURL',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\SourceURL',
                ),
                'commercialurl' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'CommercialURL',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\CommercialURL',
                ),
                'copyrighturl' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'CopyrightURL',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\CopyrightURL',
                ),
                'publisherurl' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'PublisherURL',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\PublisherURL',
                ),
                'userdefinedurl' => array(
                    'namespace' => 'ID3v2_2',
                    'tagname' => 'UserDefinedURL',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v22\UserDefinedURL',
                ),
            ),
            'id3v2_3' => array(
                'picture' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'Picture',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\Picture',
                ),
                'picturemimetype' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'PictureMIMEType',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\PictureMIMEType',
                ),
                'picturetype' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'PictureType',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\PictureType',
                ),
                'picturedescription' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'PictureDescription',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\PictureDescription',
                ),
                'comment' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'Comment',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\Comment',
                ),
                'involvedpeople' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'InvolvedPeople',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\InvolvedPeople',
                ),
                'itunesu' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'iTunesU',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\ITunesU',
                ),
                'musiccdidentifier' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'MusicCDIdentifier',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\MusicCDIdentifier',
                ),
                'ownership' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'Ownership',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\Ownership',
                ),
                'playcounter' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'PlayCounter',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\PlayCounter',
                ),
                'podcast' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'Podcast',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\Podcast',
                ),
                'popularimeter' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'Popularimeter',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\Popularimeter',
                ),
                'album' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'Album',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\Album',
                ),
                'beatsperminute' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'BeatsPerMinute',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\BeatsPerMinute',
                ),
                'podcastcategory' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'PodcastCategory',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\PodcastCategory',
                ),
                'compilation' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'Compilation',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\Compilation',
                ),
                'composer' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'Composer',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\Composer',
                ),
                'genre' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'Genre',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\Genre',
                ),
                'copyright' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'Copyright',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\Copyright',
                ),
                'date' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'Date',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\Date',
                ),
                'podcastdescription' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'PodcastDescription',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\PodcastDescription',
                ),
                'playlistdelay' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'PlaylistDelay',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\PlaylistDelay',
                ),
                'encodedby' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'EncodedBy',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\EncodedBy',
                ),
                'lyricist' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'Lyricist',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\Lyricist',
                ),
                'filetype' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'FileType',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\FileType',
                ),
                'podcastid' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'PodcastID',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\PodcastID',
                ),
                'time' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'Time',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\Time',
                ),
                'grouping' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'Grouping',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\Grouping',
                ),
                'title' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'Title',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\Title',
                ),
                'subtitle' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'Subtitle',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\Subtitle',
                ),
                'initialkey' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'InitialKey',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\InitialKey',
                ),
                'podcastkeywords' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'PodcastKeywords',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\PodcastKeywords',
                ),
                'language' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'Language',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\Language',
                ),
                'length' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'Length',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\Length',
                ),
                'media' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'Media',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\Media',
                ),
                'originalalbum' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'OriginalAlbum',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\OriginalAlbum',
                ),
                'originalfilename' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'OriginalFileName',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\OriginalFileName',
                ),
                'originallyricist' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'OriginalLyricist',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\OriginalLyricist',
                ),
                'originalartist' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'OriginalArtist',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\OriginalArtist',
                ),
                'originalreleaseyear' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'OriginalReleaseYear',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\OriginalReleaseYear',
                ),
                'fileowner' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'FileOwner',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\FileOwner',
                ),
                'artist' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'Artist',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\Artist',
                ),
                'band' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'Band',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\Band',
                ),
                'conductor' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'Conductor',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\Conductor',
                ),
                'interpretedby' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'InterpretedBy',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\InterpretedBy',
                ),
                'partofset' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'PartOfSet',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\PartOfSet',
                ),
                'publisher' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'Publisher',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\Publisher',
                ),
                'track' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'Track',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\Track',
                ),
                'recordingdates' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'RecordingDates',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\RecordingDates',
                ),
                'internetradiostationname' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'InternetRadioStationName',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\InternetRadioStationName',
                ),
                'internetradiostationowner' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'InternetRadioStationOwner',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\InternetRadioStationOwner',
                ),
                'size' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'Size',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\Size',
                ),
                'albumartistsortorder' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'AlbumArtistSortOrder',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\AlbumArtistSortOrder',
                ),
                'composersortorder' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'ComposerSortOrder',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\ComposerSortOrder',
                ),
                'isrc' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'ISRC',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\ISRC',
                ),
                'encodersettings' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'EncoderSettings',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\EncoderSettings',
                ),
                'userdefinedtext' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'UserDefinedText',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\UserDefinedText',
                ),
                'year' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'Year',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\Year',
                ),
                'termsofuse' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'TermsOfUse',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\TermsOfUse',
                ),
                'lyrics' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'Lyrics',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\Lyrics',
                ),
                'commercialurl' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'CommercialURL',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\CommercialURL',
                ),
                'copyrighturl' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'CopyrightURL',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\CopyrightURL',
                ),
                'podcasturl' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'PodcastURL',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\PodcastURL',
                ),
                'fileurl' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'FileURL',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\FileURL',
                ),
                'artisturl' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'ArtistURL',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\ArtistURL',
                ),
                'sourceurl' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'SourceURL',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\SourceURL',
                ),
                'internetradiostationurl' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'InternetRadioStationURL',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\InternetRadioStationURL',
                ),
                'paymenturl' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'PaymentURL',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\PaymentURL',
                ),
                'publisherurl' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'PublisherURL',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\PublisherURL',
                ),
                'userdefinedurl' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'UserDefinedURL',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\UserDefinedURL',
                ),
                'originalreleasetime' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'OriginalReleaseTime',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\OriginalReleaseTime',
                ),
                'albumsortorder' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'AlbumSortOrder',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\AlbumSortOrder',
                ),
                'performersortorder' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'PerformerSortOrder',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\PerformerSortOrder',
                ),
                'titlesortorder' => array(
                    'namespace' => 'ID3v2_3',
                    'tagname' => 'TitleSortOrder',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v23\TitleSortOrder',
                ),
            ),
            'id3v2_4' => array(
                'picture' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'Picture',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\Picture',
                ),
                'picturemimetype' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'PictureMIMEType',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\PictureMIMEType',
                ),
                'picturetype' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'PictureType',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\PictureType',
                ),
                'picturedescription' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'PictureDescription',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\PictureDescription',
                ),
                'comment' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'Comment',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\Comment',
                ),
                'itunesu' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'iTunesU',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\ITunesU',
                ),
                'musiccdidentifier' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'MusicCDIdentifier',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\MusicCDIdentifier',
                ),
                'ownership' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'Ownership',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\Ownership',
                ),
                'playcounter' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'PlayCounter',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\PlayCounter',
                ),
                'podcast' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'Podcast',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\Podcast',
                ),
                'popularimeter' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'Popularimeter',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\Popularimeter',
                ),
                'relativevolumeadjustment' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'RelativeVolumeAdjustment',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\RelativeVolumeAdjustment',
                ),
                'album' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'Album',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\Album',
                ),
                'beatsperminute' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'BeatsPerMinute',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\BeatsPerMinute',
                ),
                'podcastcategory' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'PodcastCategory',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\PodcastCategory',
                ),
                'compilation' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'Compilation',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\Compilation',
                ),
                'composer' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'Composer',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\Composer',
                ),
                'genre' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'Genre',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\Genre',
                ),
                'copyright' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'Copyright',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\Copyright',
                ),
                'encodingtime' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'EncodingTime',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\EncodingTime',
                ),
                'podcastdescription' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'PodcastDescription',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\PodcastDescription',
                ),
                'playlistdelay' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'PlaylistDelay',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\PlaylistDelay',
                ),
                'originalreleasetime' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'OriginalReleaseTime',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\OriginalReleaseTime',
                ),
                'recordingtime' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'RecordingTime',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\RecordingTime',
                ),
                'releasetime' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'ReleaseTime',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\ReleaseTime',
                ),
                'taggingtime' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'TaggingTime',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\TaggingTime',
                ),
                'encodedby' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'EncodedBy',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\EncodedBy',
                ),
                'lyricist' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'Lyricist',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\Lyricist',
                ),
                'filetype' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'FileType',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\FileType',
                ),
                'podcastid' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'PodcastID',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\PodcastID',
                ),
                'involvedpeople' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'InvolvedPeople',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\InvolvedPeople',
                ),
                'grouping' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'Grouping',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\Grouping',
                ),
                'title' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'Title',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\Title',
                ),
                'subtitle' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'Subtitle',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\Subtitle',
                ),
                'initialkey' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'InitialKey',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\InitialKey',
                ),
                'podcastkeywords' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'PodcastKeywords',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\PodcastKeywords',
                ),
                'language' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'Language',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\Language',
                ),
                'length' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'Length',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\Length',
                ),
                'musiciancredits' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'MusicianCredits',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\MusicianCredits',
                ),
                'media' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'Media',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\Media',
                ),
                'mood' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'Mood',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\Mood',
                ),
                'originalalbum' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'OriginalAlbum',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\OriginalAlbum',
                ),
                'originalfilename' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'OriginalFileName',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\OriginalFileName',
                ),
                'originallyricist' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'OriginalLyricist',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\OriginalLyricist',
                ),
                'originalartist' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'OriginalArtist',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\OriginalArtist',
                ),
                'fileowner' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'FileOwner',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\FileOwner',
                ),
                'artist' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'Artist',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\Artist',
                ),
                'band' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'Band',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\Band',
                ),
                'conductor' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'Conductor',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\Conductor',
                ),
                'interpretedby' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'InterpretedBy',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\InterpretedBy',
                ),
                'partofset' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'PartOfSet',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\PartOfSet',
                ),
                'producednotice' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'ProducedNotice',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\ProducedNotice',
                ),
                'publisher' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'Publisher',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\Publisher',
                ),
                'track' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'Track',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\Track',
                ),
                'internetradiostationname' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'InternetRadioStationName',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\InternetRadioStationName',
                ),
                'internetradiostationowner' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'InternetRadioStationOwner',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\InternetRadioStationOwner',
                ),
                'albumartistsortorder' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'AlbumArtistSortOrder',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\AlbumArtistSortOrder',
                ),
                'albumsortorder' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'AlbumSortOrder',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\AlbumSortOrder',
                ),
                'composersortorder' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'ComposerSortOrder',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\ComposerSortOrder',
                ),
                'performersortorder' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'PerformerSortOrder',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\PerformerSortOrder',
                ),
                'titlesortorder' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'TitleSortOrder',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\TitleSortOrder',
                ),
                'isrc' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'ISRC',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\ISRC',
                ),
                'encodersettings' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'EncoderSettings',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\EncoderSettings',
                ),
                'setsubtitle' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'SetSubtitle',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\SetSubtitle',
                ),
                'userdefinedtext' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'UserDefinedText',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\UserDefinedText',
                ),
                'termsofuse' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'TermsOfUse',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\TermsOfUse',
                ),
                'lyrics' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'Lyrics',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\Lyrics',
                ),
                'commercialurl' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'CommercialURL',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\CommercialURL',
                ),
                'copyrighturl' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'CopyrightURL',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\CopyrightURL',
                ),
                'podcasturl' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'PodcastURL',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\PodcastURL',
                ),
                'fileurl' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'FileURL',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\FileURL',
                ),
                'artisturl' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'ArtistURL',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\ArtistURL',
                ),
                'sourceurl' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'SourceURL',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\SourceURL',
                ),
                'internetradiostationurl' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'InternetRadioStationURL',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\InternetRadioStationURL',
                ),
                'paymenturl' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'PaymentURL',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\PaymentURL',
                ),
                'publisherurl' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'PublisherURL',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\PublisherURL',
                ),
                'userdefinedurl' => array(
                    'namespace' => 'ID3v2_4',
                    'tagname' => 'UserDefinedURL',
                    'classname' => 'PHPExiftool\Driver\Tag\ID3v24\UserDefinedURL',
                ),
            ),
            'iso' => array(
                'bootsystem' => array(
                    'namespace' => 'ISO',
                    'tagname' => 'BootSystem',
                    'classname' => 'PHPExiftool\Driver\Tag\ISO\BootSystem',
                ),
                'bootidentifier' => array(
                    'namespace' => 'ISO',
                    'tagname' => 'BootIdentifier',
                    'classname' => 'PHPExiftool\Driver\Tag\ISO\BootIdentifier',
                ),
                'system' => array(
                    'namespace' => 'ISO',
                    'tagname' => 'System',
                    'classname' => 'PHPExiftool\Driver\Tag\ISO\System',
                ),
                'volumename' => array(
                    'namespace' => 'ISO',
                    'tagname' => 'VolumeName',
                    'classname' => 'PHPExiftool\Driver\Tag\ISO\VolumeName',
                ),
                'volumeblockcount' => array(
                    'namespace' => 'ISO',
                    'tagname' => 'VolumeBlockCount',
                    'classname' => 'PHPExiftool\Driver\Tag\ISO\VolumeBlockCount',
                ),
                'volumesetdiskcount' => array(
                    'namespace' => 'ISO',
                    'tagname' => 'VolumeSetDiskCount',
                    'classname' => 'PHPExiftool\Driver\Tag\ISO\VolumeSetDiskCount',
                ),
                'volumesetdisknumber' => array(
                    'namespace' => 'ISO',
                    'tagname' => 'VolumeSetDiskNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\ISO\VolumeSetDiskNumber',
                ),
                'volumeblocksize' => array(
                    'namespace' => 'ISO',
                    'tagname' => 'VolumeBlockSize',
                    'classname' => 'PHPExiftool\Driver\Tag\ISO\VolumeBlockSize',
                ),
                'pathtablesize' => array(
                    'namespace' => 'ISO',
                    'tagname' => 'PathTableSize',
                    'classname' => 'PHPExiftool\Driver\Tag\ISO\PathTableSize',
                ),
                'pathtablelocation' => array(
                    'namespace' => 'ISO',
                    'tagname' => 'PathTableLocation',
                    'classname' => 'PHPExiftool\Driver\Tag\ISO\PathTableLocation',
                ),
                'rootdirectorycreatedate' => array(
                    'namespace' => 'ISO',
                    'tagname' => 'RootDirectoryCreateDate',
                    'classname' => 'PHPExiftool\Driver\Tag\ISO\RootDirectoryCreateDate',
                ),
                'volumesetname' => array(
                    'namespace' => 'ISO',
                    'tagname' => 'VolumeSetName',
                    'classname' => 'PHPExiftool\Driver\Tag\ISO\VolumeSetName',
                ),
                'publisher' => array(
                    'namespace' => 'ISO',
                    'tagname' => 'Publisher',
                    'classname' => 'PHPExiftool\Driver\Tag\ISO\Publisher',
                ),
                'datapreparer' => array(
                    'namespace' => 'ISO',
                    'tagname' => 'DataPreparer',
                    'classname' => 'PHPExiftool\Driver\Tag\ISO\DataPreparer',
                ),
                'software' => array(
                    'namespace' => 'ISO',
                    'tagname' => 'Software',
                    'classname' => 'PHPExiftool\Driver\Tag\ISO\Software',
                ),
                'copyrightfilename' => array(
                    'namespace' => 'ISO',
                    'tagname' => 'CopyrightFileName',
                    'classname' => 'PHPExiftool\Driver\Tag\ISO\CopyrightFileName',
                ),
                'abstractfilename' => array(
                    'namespace' => 'ISO',
                    'tagname' => 'AbstractFileName',
                    'classname' => 'PHPExiftool\Driver\Tag\ISO\AbstractFileName',
                ),
                'bibligraphicfilename' => array(
                    'namespace' => 'ISO',
                    'tagname' => 'BibligraphicFileName',
                    'classname' => 'PHPExiftool\Driver\Tag\ISO\BibligraphicFileName',
                ),
                'volumecreatedate' => array(
                    'namespace' => 'ISO',
                    'tagname' => 'VolumeCreateDate',
                    'classname' => 'PHPExiftool\Driver\Tag\ISO\VolumeCreateDate',
                ),
                'volumemodifydate' => array(
                    'namespace' => 'ISO',
                    'tagname' => 'VolumeModifyDate',
                    'classname' => 'PHPExiftool\Driver\Tag\ISO\VolumeModifyDate',
                ),
                'volumeexpirationdate' => array(
                    'namespace' => 'ISO',
                    'tagname' => 'VolumeExpirationDate',
                    'classname' => 'PHPExiftool\Driver\Tag\ISO\VolumeExpirationDate',
                ),
                'volumeeffectivedate' => array(
                    'namespace' => 'ISO',
                    'tagname' => 'VolumeEffectiveDate',
                    'classname' => 'PHPExiftool\Driver\Tag\ISO\VolumeEffectiveDate',
                ),
            ),
            'itc' => array(
                'datatype' => array(
                    'namespace' => 'ITC',
                    'tagname' => 'DataType',
                    'classname' => 'PHPExiftool\Driver\Tag\ITC\DataType',
                ),
                'libraryid' => array(
                    'namespace' => 'ITC',
                    'tagname' => 'LibraryID',
                    'classname' => 'PHPExiftool\Driver\Tag\ITC\LibraryID',
                ),
                'trackid' => array(
                    'namespace' => 'ITC',
                    'tagname' => 'TrackID',
                    'classname' => 'PHPExiftool\Driver\Tag\ITC\TrackID',
                ),
                'datalocation' => array(
                    'namespace' => 'ITC',
                    'tagname' => 'DataLocation',
                    'classname' => 'PHPExiftool\Driver\Tag\ITC\DataLocation',
                ),
                'imagetype' => array(
                    'namespace' => 'ITC',
                    'tagname' => 'ImageType',
                    'classname' => 'PHPExiftool\Driver\Tag\ITC\ImageType',
                ),
                'imagewidth' => array(
                    'namespace' => 'ITC',
                    'tagname' => 'ImageWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\ITC\ImageWidth',
                ),
                'imageheight' => array(
                    'namespace' => 'ITC',
                    'tagname' => 'ImageHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\ITC\ImageHeight',
                ),
                'imagedata' => array(
                    'namespace' => 'ITC',
                    'tagname' => 'ImageData',
                    'classname' => 'PHPExiftool\Driver\Tag\ITC\ImageData',
                ),
            ),
            'jfxx' => array(
                'thumbnailimage' => array(
                    'namespace' => 'JFXX',
                    'tagname' => 'ThumbnailImage',
                    'classname' => 'PHPExiftool\Driver\Tag\JFXX\ThumbnailImage',
                ),
                'thumbnailtiff' => array(
                    'namespace' => 'JFXX',
                    'tagname' => 'ThumbnailTIFF',
                    'classname' => 'PHPExiftool\Driver\Tag\JFXX\ThumbnailTIFF',
                ),
            ),
            'jfif' => array(
                'jfifversion' => array(
                    'namespace' => 'JFIF',
                    'tagname' => 'JFIFVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\JFIF\JFIFVersion',
                ),
                'resolutionunit' => array(
                    'namespace' => 'JFIF',
                    'tagname' => 'ResolutionUnit',
                    'classname' => 'PHPExiftool\Driver\Tag\JFIF\ResolutionUnit',
                ),
                'xresolution' => array(
                    'namespace' => 'JFIF',
                    'tagname' => 'XResolution',
                    'classname' => 'PHPExiftool\Driver\Tag\JFIF\XResolution',
                ),
                'yresolution' => array(
                    'namespace' => 'JFIF',
                    'tagname' => 'YResolution',
                    'classname' => 'PHPExiftool\Driver\Tag\JFIF\YResolution',
                ),
                'thumbnailwidth' => array(
                    'namespace' => 'JFIF',
                    'tagname' => 'ThumbnailWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\JFIF\ThumbnailWidth',
                ),
                'thumbnailheight' => array(
                    'namespace' => 'JFIF',
                    'tagname' => 'ThumbnailHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\JFIF\ThumbnailHeight',
                ),
                'thumbnailtiff' => array(
                    'namespace' => 'JFIF',
                    'tagname' => 'ThumbnailTIFF',
                    'classname' => 'PHPExiftool\Driver\Tag\JFIF\ThumbnailTIFF',
                ),
            ),
            'avi1' => array(
                'interleavedfield' => array(
                    'namespace' => 'AVI1',
                    'tagname' => 'InterleavedField',
                    'classname' => 'PHPExiftool\Driver\Tag\AVI1\InterleavedField',
                ),
            ),
            'adobecm' => array(
                'adobecmtype' => array(
                    'namespace' => 'AdobeCM',
                    'tagname' => 'AdobeCMType',
                    'classname' => 'PHPExiftool\Driver\Tag\AdobeCM\AdobeCMType',
                ),
            ),
            'eppim' => array(
                'printim' => array(
                    'namespace' => 'EPPIM',
                    'tagname' => 'PrintIM',
                    'classname' => 'PHPExiftool\Driver\Tag\EPPIM\PrintIM',
                ),
            ),
            'graphconv' => array(
                'quality' => array(
                    'namespace' => 'GraphConv',
                    'tagname' => 'Quality',
                    'classname' => 'PHPExiftool\Driver\Tag\GraphConv\Quality',
                ),
            ),
            'jpeg' => array(
                'previewimage' => array(
                    'namespace' => 'JPEG',
                    'tagname' => 'PreviewImage',
                    'classname' => 'PHPExiftool\Driver\Tag\JPEG\PreviewImage',
                ),
                'comment' => array(
                    'namespace' => 'JPEG',
                    'tagname' => 'Comment',
                    'classname' => 'PHPExiftool\Driver\Tag\JPEG\Comment',
                ),
                'adobe' => array(
                    'namespace' => 'JPEG',
                    'tagname' => 'Adobe',
                    'classname' => 'PHPExiftool\Driver\Tag\JPEG\Adobe',
                ),
                'definequantizationtable' => array(
                    'namespace' => 'JPEG',
                    'tagname' => 'DefineQuantizationTable',
                    'classname' => 'PHPExiftool\Driver\Tag\JPEG\DefineQuantizationTable',
                ),
                'embeddedvideo' => array(
                    'namespace' => 'JPEG',
                    'tagname' => 'EmbeddedVideo',
                    'classname' => 'PHPExiftool\Driver\Tag\JPEG\EmbeddedVideo',
                ),
            ),
            'mediajukebox' => array(
                'album' => array(
                    'namespace' => 'MediaJukebox',
                    'tagname' => 'Album',
                    'classname' => 'PHPExiftool\Driver\Tag\MediaJukebox\Album',
                ),
                'caption' => array(
                    'namespace' => 'MediaJukebox',
                    'tagname' => 'Caption',
                    'classname' => 'PHPExiftool\Driver\Tag\MediaJukebox\Caption',
                ),
                'date' => array(
                    'namespace' => 'MediaJukebox',
                    'tagname' => 'Date',
                    'classname' => 'PHPExiftool\Driver\Tag\MediaJukebox\Date',
                ),
                'keywords' => array(
                    'namespace' => 'MediaJukebox',
                    'tagname' => 'Keywords',
                    'classname' => 'PHPExiftool\Driver\Tag\MediaJukebox\Keywords',
                ),
                'name' => array(
                    'namespace' => 'MediaJukebox',
                    'tagname' => 'Name',
                    'classname' => 'PHPExiftool\Driver\Tag\MediaJukebox\Name',
                ),
                'people' => array(
                    'namespace' => 'MediaJukebox',
                    'tagname' => 'People',
                    'classname' => 'PHPExiftool\Driver\Tag\MediaJukebox\People',
                ),
                'places' => array(
                    'namespace' => 'MediaJukebox',
                    'tagname' => 'Places',
                    'classname' => 'PHPExiftool\Driver\Tag\MediaJukebox\Places',
                ),
                'tool_name' => array(
                    'namespace' => 'MediaJukebox',
                    'tagname' => 'Tool_Name',
                    'classname' => 'PHPExiftool\Driver\Tag\MediaJukebox\ToolName',
                ),
                'tool_version' => array(
                    'namespace' => 'MediaJukebox',
                    'tagname' => 'Tool_Version',
                    'classname' => 'PHPExiftool\Driver\Tag\MediaJukebox\ToolVersion',
                ),
            ),
            'nitf' => array(
                'nitfversion' => array(
                    'namespace' => 'NITF',
                    'tagname' => 'NITFVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\NITF\NITFVersion',
                ),
                'imageformat' => array(
                    'namespace' => 'NITF',
                    'tagname' => 'ImageFormat',
                    'classname' => 'PHPExiftool\Driver\Tag\NITF\ImageFormat',
                ),
                'blocksperrow' => array(
                    'namespace' => 'NITF',
                    'tagname' => 'BlocksPerRow',
                    'classname' => 'PHPExiftool\Driver\Tag\NITF\BlocksPerRow',
                ),
                'blockspercolumn' => array(
                    'namespace' => 'NITF',
                    'tagname' => 'BlocksPerColumn',
                    'classname' => 'PHPExiftool\Driver\Tag\NITF\BlocksPerColumn',
                ),
                'imagecolor' => array(
                    'namespace' => 'NITF',
                    'tagname' => 'ImageColor',
                    'classname' => 'PHPExiftool\Driver\Tag\NITF\ImageColor',
                ),
                'bitdepth' => array(
                    'namespace' => 'NITF',
                    'tagname' => 'BitDepth',
                    'classname' => 'PHPExiftool\Driver\Tag\NITF\BitDepth',
                ),
                'imageclass' => array(
                    'namespace' => 'NITF',
                    'tagname' => 'ImageClass',
                    'classname' => 'PHPExiftool\Driver\Tag\NITF\ImageClass',
                ),
                'jpegprocess' => array(
                    'namespace' => 'NITF',
                    'tagname' => 'JPEGProcess',
                    'classname' => 'PHPExiftool\Driver\Tag\NITF\JPEGProcess',
                ),
                'quality' => array(
                    'namespace' => 'NITF',
                    'tagname' => 'Quality',
                    'classname' => 'PHPExiftool\Driver\Tag\NITF\Quality',
                ),
                'streamcolor' => array(
                    'namespace' => 'NITF',
                    'tagname' => 'StreamColor',
                    'classname' => 'PHPExiftool\Driver\Tag\NITF\StreamColor',
                ),
                'streambitdepth' => array(
                    'namespace' => 'NITF',
                    'tagname' => 'StreamBitDepth',
                    'classname' => 'PHPExiftool\Driver\Tag\NITF\StreamBitDepth',
                ),
                'flags' => array(
                    'namespace' => 'NITF',
                    'tagname' => 'Flags',
                    'classname' => 'PHPExiftool\Driver\Tag\NITF\Flags',
                ),
            ),
            'ocad' => array(
                'ocadrevision' => array(
                    'namespace' => 'Ocad',
                    'tagname' => 'OcadRevision',
                    'classname' => 'PHPExiftool\Driver\Tag\Ocad\OcadRevision',
                ),
            ),
            'spiff' => array(
                'spiffversion' => array(
                    'namespace' => 'SPIFF',
                    'tagname' => 'SPIFFVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\SPIFF\SPIFFVersion',
                ),
                'profileid' => array(
                    'namespace' => 'SPIFF',
                    'tagname' => 'ProfileID',
                    'classname' => 'PHPExiftool\Driver\Tag\SPIFF\ProfileID',
                ),
                'colorcomponents' => array(
                    'namespace' => 'SPIFF',
                    'tagname' => 'ColorComponents',
                    'classname' => 'PHPExiftool\Driver\Tag\SPIFF\ColorComponents',
                ),
                'imageheight' => array(
                    'namespace' => 'SPIFF',
                    'tagname' => 'ImageHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\SPIFF\ImageHeight',
                ),
                'imagewidth' => array(
                    'namespace' => 'SPIFF',
                    'tagname' => 'ImageWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\SPIFF\ImageWidth',
                ),
                'colorspace' => array(
                    'namespace' => 'SPIFF',
                    'tagname' => 'ColorSpace',
                    'classname' => 'PHPExiftool\Driver\Tag\SPIFF\ColorSpace',
                ),
                'bitspersample' => array(
                    'namespace' => 'SPIFF',
                    'tagname' => 'BitsPerSample',
                    'classname' => 'PHPExiftool\Driver\Tag\SPIFF\BitsPerSample',
                ),
                'compression' => array(
                    'namespace' => 'SPIFF',
                    'tagname' => 'Compression',
                    'classname' => 'PHPExiftool\Driver\Tag\SPIFF\Compression',
                ),
                'resolutionunit' => array(
                    'namespace' => 'SPIFF',
                    'tagname' => 'ResolutionUnit',
                    'classname' => 'PHPExiftool\Driver\Tag\SPIFF\ResolutionUnit',
                ),
                'yresolution' => array(
                    'namespace' => 'SPIFF',
                    'tagname' => 'YResolution',
                    'classname' => 'PHPExiftool\Driver\Tag\SPIFF\YResolution',
                ),
                'xresolution' => array(
                    'namespace' => 'SPIFF',
                    'tagname' => 'XResolution',
                    'classname' => 'PHPExiftool\Driver\Tag\SPIFF\XResolution',
                ),
            ),
            'jvc' => array(
                'cpuversions' => array(
                    'namespace' => 'JVC',
                    'tagname' => 'CPUVersions',
                    'classname' => 'PHPExiftool\Driver\Tag\JVC\CPUVersions',
                ),
                'quality' => array(
                    'namespace' => 'JVC',
                    'tagname' => 'Quality',
                    'classname' => 'PHPExiftool\Driver\Tag\JVC\Quality',
                ),
                'makernoteversion' => array(
                    'namespace' => 'JVC',
                    'tagname' => 'MakerNoteVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\JVC\MakerNoteVersion',
                ),
            ),
           
            'metaifd' => array(
                'filmproductcode' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'FilmProductCode',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\FilmProductCode',
                ),
                'imagesourceek' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'ImageSourceEK',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\ImageSourceEK',
                ),
                'captureconditionspar' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'CaptureConditionsPAR',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\CaptureConditionsPAR',
                ),
                'cameraowner' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'CameraOwner',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\CameraOwner',
                ),
                'serialnumber' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'SerialNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\SerialNumber',
                ),
                'userselectgrouptitle' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'UserSelectGroupTitle',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\UserSelectGroupTitle',
                ),
                'dealeridnumber' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'DealerIDNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\DealerIDNumber',
                ),
                'capturedevicefid' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'CaptureDeviceFID',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\CaptureDeviceFID',
                ),
                'envelopenumber' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'EnvelopeNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\EnvelopeNumber',
                ),
                'framenumber' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'FrameNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\FrameNumber',
                ),
                'filmcategory' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'FilmCategory',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\FilmCategory',
                ),
                'filmgencode' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'FilmGencode',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\FilmGencode',
                ),
                'modelandversion' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'ModelAndVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\ModelAndVersion',
                ),
                'filmsize' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'FilmSize',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\FilmSize',
                ),
                'sba_rgbshifts' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'SBA_RGBShifts',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\SBARGBShifts',
                ),
                'sbainputimagecolorspace' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'SBAInputImageColorspace',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\SBAInputImageColorspace',
                ),
                'sbainputimagebitdepth' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'SBAInputImageBitDepth',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\SBAInputImageBitDepth',
                ),
                'sbaexposurerecord' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'SBAExposureRecord',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\SBAExposureRecord',
                ),
                'useradjsba_rgbshifts' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'UserAdjSBA_RGBShifts',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\UserAdjSBARGBShifts',
                ),
                'imagerotationstatus' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'ImageRotationStatus',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\ImageRotationStatus',
                ),
                'rollguidelements' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'RollGuidElements',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\RollGuidElements',
                ),
                'metadatanumber' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'MetadataNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\MetadataNumber',
                ),
                'edittagarray' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'EditTagArray',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\EditTagArray',
                ),
                'magnification' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'Magnification',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\Magnification',
                ),
                'nativexresolution' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'NativeXResolution',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\NativeXResolution',
                ),
                'nativeyresolution' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'NativeYResolution',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\NativeYResolution',
                ),
                'nativeresolutionunit' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'NativeResolutionUnit',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\NativeResolutionUnit',
                ),
                'sourceimagedirectory' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'SourceImageDirectory',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\SourceImageDirectory',
                ),
                'sourceimagefilename' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'SourceImageFileName',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\SourceImageFileName',
                ),
                'sourceimagevolumename' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'SourceImageVolumeName',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\SourceImageVolumeName',
                ),
                'printquality' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'PrintQuality',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\PrintQuality',
                ),
                'imageprintstatus' => array(
                    'namespace' => 'MetaIFD',
                    'tagname' => 'ImagePrintStatus',
                    'classname' => 'PHPExiftool\Driver\Tag\MetaIFD\ImagePrintStatus',
                ),
            ),
            'mie-audio' => array(
                'relatedaudiofiletype' => array(
                    'namespace' => 'MIE-Audio',
                    'tagname' => 'RelatedAudioFileType',
                    'classname' => 'PHPExiftool\Driver\Tag\MIEAudio\RelatedAudioFileType',
                ),
                'relatedaudiofilename' => array(
                    'namespace' => 'MIE-Audio',
                    'tagname' => 'RelatedAudioFileName',
                    'classname' => 'PHPExiftool\Driver\Tag\MIEAudio\RelatedAudioFileName',
                ),
                'channels' => array(
                    'namespace' => 'MIE-Audio',
                    'tagname' => 'Channels',
                    'classname' => 'PHPExiftool\Driver\Tag\MIEAudio\Channels',
                ),
                'audiocompression' => array(
                    'namespace' => 'MIE-Audio',
                    'tagname' => 'AudioCompression',
                    'classname' => 'PHPExiftool\Driver\Tag\MIEAudio\AudioCompression',
                ),
                'duration' => array(
                    'namespace' => 'MIE-Audio',
                    'tagname' => 'Duration',
                    'classname' => 'PHPExiftool\Driver\Tag\MIEAudio\Duration',
                ),
                'samplebits' => array(
                    'namespace' => 'MIE-Audio',
                    'tagname' => 'SampleBits',
                    'classname' => 'PHPExiftool\Driver\Tag\MIEAudio\SampleBits',
                ),
                'samplerate' => array(
                    'namespace' => 'MIE-Audio',
                    'tagname' => 'SampleRate',
                    'classname' => 'PHPExiftool\Driver\Tag\MIEAudio\SampleRate',
                ),
                'relatedaudiofile' => array(
                    'namespace' => 'MIE-Audio',
                    'tagname' => 'RelatedAudioFile',
                    'classname' => 'PHPExiftool\Driver\Tag\MIEAudio\RelatedAudioFile',
                ),
            ),
            'mie-camera' => array(
                'brightness' => array(
                    'namespace' => 'MIE-Camera',
                    'tagname' => 'Brightness',
                    'classname' => 'PHPExiftool\Driver\Tag\MIECamera\Brightness',
                ),
                'colorbalance' => array(
                    'namespace' => 'MIE-Camera',
                    'tagname' => 'ColorBalance',
                    'classname' => 'PHPExiftool\Driver\Tag\MIECamera\ColorBalance',
                ),
                'colortemperature' => array(
                    'namespace' => 'MIE-Camera',
                    'tagname' => 'ColorTemperature',
                    'classname' => 'PHPExiftool\Driver\Tag\MIECamera\ColorTemperature',
                ),
                'contrast' => array(
                    'namespace' => 'MIE-Camera',
                    'tagname' => 'Contrast',
                    'classname' => 'PHPExiftool\Driver\Tag\MIECamera\Contrast',
                ),
                'digitalzoom' => array(
                    'namespace' => 'MIE-Camera',
                    'tagname' => 'DigitalZoom',
                    'classname' => 'PHPExiftool\Driver\Tag\MIECamera\DigitalZoom',
                ),
                'exposurecompensation' => array(
                    'namespace' => 'MIE-Camera',
                    'tagname' => 'ExposureCompensation',
                    'classname' => 'PHPExiftool\Driver\Tag\MIECamera\ExposureCompensation',
                ),
                'exposuremode' => array(
                    'namespace' => 'MIE-Camera',
                    'tagname' => 'ExposureMode',
                    'classname' => 'PHPExiftool\Driver\Tag\MIECamera\ExposureMode',
                ),
                'exposuretime' => array(
                    'namespace' => 'MIE-Camera',
                    'tagname' => 'ExposureTime',
                    'classname' => 'PHPExiftool\Driver\Tag\MIECamera\ExposureTime',
                ),
                'firmwareversion' => array(
                    'namespace' => 'MIE-Camera',
                    'tagname' => 'FirmwareVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\MIECamera\FirmwareVersion',
                ),
                'focusmode' => array(
                    'namespace' => 'MIE-Camera',
                    'tagname' => 'FocusMode',
                    'classname' => 'PHPExiftool\Driver\Tag\MIECamera\FocusMode',
                ),
                'iso' => array(
                    'namespace' => 'MIE-Camera',
                    'tagname' => 'ISO',
                    'classname' => 'PHPExiftool\Driver\Tag\MIECamera\ISO',
                ),
                'isosetting' => array(
                    'namespace' => 'MIE-Camera',
                    'tagname' => 'ISOSetting',
                    'classname' => 'PHPExiftool\Driver\Tag\MIECamera\ISOSetting',
                ),
                'imagenumber' => array(
                    'namespace' => 'MIE-Camera',
                    'tagname' => 'ImageNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\MIECamera\ImageNumber',
                ),
                'imagequality' => array(
                    'namespace' => 'MIE-Camera',
                    'tagname' => 'ImageQuality',
                    'classname' => 'PHPExiftool\Driver\Tag\MIECamera\ImageQuality',
                ),
                'imagestabilization' => array(
                    'namespace' => 'MIE-Camera',
                    'tagname' => 'ImageStabilization',
                    'classname' => 'PHPExiftool\Driver\Tag\MIECamera\ImageStabilization',
                ),
                'make' => array(
                    'namespace' => 'MIE-Camera',
                    'tagname' => 'Make',
                    'classname' => 'PHPExiftool\Driver\Tag\MIECamera\Make',
                ),
                'measuredev' => array(
                    'namespace' => 'MIE-Camera',
                    'tagname' => 'MeasuredEV',
                    'classname' => 'PHPExiftool\Driver\Tag\MIECamera\MeasuredEV',
                ),
                'model' => array(
                    'namespace' => 'MIE-Camera',
                    'tagname' => 'Model',
                    'classname' => 'PHPExiftool\Driver\Tag\MIECamera\Model',
                ),
                'ownername' => array(
                    'namespace' => 'MIE-Camera',
                    'tagname' => 'OwnerName',
                    'classname' => 'PHPExiftool\Driver\Tag\MIECamera\OwnerName',
                ),
                'saturation' => array(
                    'namespace' => 'MIE-Camera',
                    'tagname' => 'Saturation',
                    'classname' => 'PHPExiftool\Driver\Tag\MIECamera\Saturation',
                ),
                'sensorsize' => array(
                    'namespace' => 'MIE-Camera',
                    'tagname' => 'SensorSize',
                    'classname' => 'PHPExiftool\Driver\Tag\MIECamera\SensorSize',
                ),
                'serialnumber' => array(
                    'namespace' => 'MIE-Camera',
                    'tagname' => 'SerialNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\MIECamera\SerialNumber',
                ),
                'sharpness' => array(
                    'namespace' => 'MIE-Camera',
                    'tagname' => 'Sharpness',
                    'classname' => 'PHPExiftool\Driver\Tag\MIECamera\Sharpness',
                ),
                'shootingmode' => array(
                    'namespace' => 'MIE-Camera',
                    'tagname' => 'ShootingMode',
                    'classname' => 'PHPExiftool\Driver\Tag\MIECamera\ShootingMode',
                ),
            ),
            'mie-doc' => array(
                'author' => array(
                    'namespace' => 'MIE-Doc',
                    'tagname' => 'Author',
                    'classname' => 'PHPExiftool\Driver\Tag\MIEDoc\Author',
                ),
                'comment' => array(
                    'namespace' => 'MIE-Doc',
                    'tagname' => 'Comment',
                    'classname' => 'PHPExiftool\Driver\Tag\MIEDoc\Comment',
                ),
                'contributors' => array(
                    'namespace' => 'MIE-Doc',
                    'tagname' => 'Contributors',
                    'classname' => 'PHPExiftool\Driver\Tag\MIEDoc\Contributors',
                ),
                'copyright' => array(
                    'namespace' => 'MIE-Doc',
                    'tagname' => 'Copyright',
                    'classname' => 'PHPExiftool\Driver\Tag\MIEDoc\Copyright',
                ),
                'createdate' => array(
                    'namespace' => 'MIE-Doc',
                    'tagname' => 'CreateDate',
                    'classname' => 'PHPExiftool\Driver\Tag\MIEDoc\CreateDate',
                ),
                'email' => array(
                    'namespace' => 'MIE-Doc',
                    'tagname' => 'Email',
                    'classname' => 'PHPExiftool\Driver\Tag\MIEDoc\Email',
                ),
                'keywords' => array(
                    'namespace' => 'MIE-Doc',
                    'tagname' => 'Keywords',
                    'classname' => 'PHPExiftool\Driver\Tag\MIEDoc\Keywords',
                ),
                'modifydate' => array(
                    'namespace' => 'MIE-Doc',
                    'tagname' => 'ModifyDate',
                    'classname' => 'PHPExiftool\Driver\Tag\MIEDoc\ModifyDate',
                ),
                'datetimeoriginal' => array(
                    'namespace' => 'MIE-Doc',
                    'tagname' => 'DateTimeOriginal',
                    'classname' => 'PHPExiftool\Driver\Tag\MIEDoc\DateTimeOriginal',
                ),
                'phonenumber' => array(
                    'namespace' => 'MIE-Doc',
                    'tagname' => 'PhoneNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\MIEDoc\PhoneNumber',
                ),
                'references' => array(
                    'namespace' => 'MIE-Doc',
                    'tagname' => 'References',
                    'classname' => 'PHPExiftool\Driver\Tag\MIEDoc\References',
                ),
                'software' => array(
                    'namespace' => 'MIE-Doc',
                    'tagname' => 'Software',
                    'classname' => 'PHPExiftool\Driver\Tag\MIEDoc\Software',
                ),
                'title' => array(
                    'namespace' => 'MIE-Doc',
                    'tagname' => 'Title',
                    'classname' => 'PHPExiftool\Driver\Tag\MIEDoc\Title',
                ),
                'url' => array(
                    'namespace' => 'MIE-Doc',
                    'tagname' => 'URL',
                    'classname' => 'PHPExiftool\Driver\Tag\MIEDoc\URL',
                ),
            ),
            'macos' => array(
                'mditemaccounthandles' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemAccountHandles',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemAccountHandles',
                ),
                'mditemaccountidentifier' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemAccountIdentifier',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemAccountIdentifier',
                ),
                'mditemacquisitionmake' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemAcquisitionMake',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemAcquisitionMake',
                ),
                'mditemacquisitionmodel' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemAcquisitionModel',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemAcquisitionModel',
                ),
                'mditemaltitude' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemAltitude',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemAltitude',
                ),
                'mditemaperture' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemAperture',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemAperture',
                ),
                'mditemaudiobitrate' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemAudioBitRate',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemAudioBitRate',
                ),
                'mditemaudiochannelcount' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemAudioChannelCount',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemAudioChannelCount',
                ),
                'mditemauthoremailaddresses' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemAuthorEmailAddresses',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemAuthorEmailAddresses',
                ),
                'mditemauthors' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemAuthors',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemAuthors',
                ),
                'mditembitspersample' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemBitsPerSample',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemBitsPerSample',
                ),
                'mditembundleidentifier' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemBundleIdentifier',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemBundleIdentifier',
                ),
                'mditemcity' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemCity',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemCity',
                ),
                'mditemcodecs' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemCodecs',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemCodecs',
                ),
                'mditemcolorspace' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemColorSpace',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemColorSpace',
                ),
                'mditemcomment' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemComment',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemComment',
                ),
                'mditemcontentcreationdate' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemContentCreationDate',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemContentCreationDate',
                ),
                'mixed' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'mixed',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemInterestingDateRanking',
                ),
                'mditemcontentmodificationdate' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemContentModificationDate',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemContentModificationDate',
                ),
                'mditemcontenttype' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemContentType',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemContentType',
                ),
                'mditemcontenttypetree' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemContentTypeTree',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemContentTypeTree',
                ),
                'mditemcontributors' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemContributors',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemContributors',
                ),
                'mditemcopyright' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemCopyright',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemCopyright',
                ),
                'mditemcountry' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemCountry',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemCountry',
                ),
                'mditemcreator' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemCreator',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemCreator',
                ),
                'mditemdateadded' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemDateAdded',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemDateAdded',
                ),
                'mditemdateadded_ranking' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemDateAdded_Ranking',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemDateAddedRanking',
                ),
                'mditemdescription' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemDescription',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemDescription',
                ),
                'mditemdisplayname' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemDisplayName',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemDisplayName',
                ),
                'mditemdownloadeddate' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemDownloadedDate',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemDownloadedDate',
                ),
                'mditemdurationseconds' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemDurationSeconds',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemDurationSeconds',
                ),
                'mditemexifgpsversion' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemEXIFGPSVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemEXIFGPSVersion',
                ),
                'mditemexifversion' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemEXIFVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemEXIFVersion',
                ),
                'mditememailconversationid' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemEmailConversationID',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemEmailConversationID',
                ),
                'mditemencodingapplications' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemEncodingApplications',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemEncodingApplications',
                ),
                'mditemexposuremode' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemExposureMode',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemExposureMode',
                ),
                'mditemexposureprogram' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemExposureProgram',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemExposureProgram',
                ),
                'mditemexposuretimeseconds' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemExposureTimeSeconds',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemExposureTimeSeconds',
                ),
                'mditemfnumber' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemFNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemFNumber',
                ),
                'mditemfscontentchangedate' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemFSContentChangeDate',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemFSContentChangeDate',
                ),
                'mditemfscreationdate' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemFSCreationDate',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemFSCreationDate',
                ),
                'mditemfscreatorcode' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemFSCreatorCode',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemFSCreatorCode',
                ),
                'mditemfsfinderflags' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemFSFinderFlags',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemFSFinderFlags',
                ),
                'mditemfshascustomicon' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemFSHasCustomIcon',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemFSHasCustomIcon',
                ),
                'mditemfsinvisible' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemFSInvisible',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemFSInvisible',
                ),
                'mditemfsisextensionhidden' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemFSIsExtensionHidden',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemFSIsExtensionHidden',
                ),
                'mditemfsisstationery' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemFSIsStationery',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemFSIsStationery',
                ),
                'mditemfslabel' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemFSLabel',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemFSLabel',
                ),
                'mditemfsname' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemFSName',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemFSName',
                ),
                'mditemfsnodecount' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemFSNodeCount',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemFSNodeCount',
                ),
                'mditemfsownergroupid' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemFSOwnerGroupID',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemFSOwnerGroupID',
                ),
                'mditemfsowneruserid' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemFSOwnerUserID',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemFSOwnerUserID',
                ),
                'mditemfssize' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemFSSize',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemFSSize',
                ),
                'mditemfstypecode' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemFSTypeCode',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemFSTypeCode',
                ),
                'mditemfindercomment' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemFinderComment',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemFinderComment',
                ),
                'mditemflashonoff' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemFlashOnOff',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemFlashOnOff',
                ),
                'mditemfocallength' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemFocalLength',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemFocalLength',
                ),
                'mditemgpsdatestamp' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemGPSDateStamp',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemGPSDateStamp',
                ),
                'mditemgpsstatus' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemGPSStatus',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemGPSStatus',
                ),
                'mditemgpstrack' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemGPSTrack',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemGPSTrack',
                ),
                'mditemhasalphachannel' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemHasAlphaChannel',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemHasAlphaChannel',
                ),
                'mditemisospeed' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemISOSpeed',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemISOSpeed',
                ),
                'mditemidentifier' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemIdentifier',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemIdentifier',
                ),
                'mditemimagedirection' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemImageDirection',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemImageDirection',
                ),
                'mditemisapplicationmanaged' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemIsApplicationManaged',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemIsApplicationManaged',
                ),
                'mditemisexistingthread' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemIsExistingThread',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemIsExistingThread',
                ),
                'mditemislikelyjunk' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemIsLikelyJunk',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemIsLikelyJunk',
                ),
                'mditemkeywords' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemKeywords',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemKeywords',
                ),
                'mditemkind' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemKind',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemKind',
                ),
                'mditemlastuseddate' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemLastUsedDate',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemLastUsedDate',
                ),
                'mditemlastuseddate_ranking' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemLastUsedDate_Ranking',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemLastUsedDateRanking',
                ),
                'mditemlatitude' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemLatitude',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemLatitude',
                ),
                'mditemlensmodel' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemLensModel',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemLensModel',
                ),
                'mditemlogicalsize' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemLogicalSize',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemLogicalSize',
                ),
                'mditemlongitude' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemLongitude',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemLongitude',
                ),
                'mditemmaildatereceived_ranking' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemMailDateReceived_Ranking',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemMailDateReceivedRanking',
                ),
                'mditemmailboxes' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemMailboxes',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemMailboxes',
                ),
                'mditemmediatypes' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemMediaTypes',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemMediaTypes',
                ),
                'mditemnumberofpages' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemNumberOfPages',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemNumberOfPages',
                ),
                'mditemorientation' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemOrientation',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemOrientation',
                ),
                'mditemoriginapplicationidentifier' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemOriginApplicationIdentifier',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemOriginApplicationIdentifier',
                ),
                'mditemoriginmessageid' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemOriginMessageID',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemOriginMessageID',
                ),
                'mditemoriginsenderdisplayname' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemOriginSenderDisplayName',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemOriginSenderDisplayName',
                ),
                'mditemoriginsenderhandle' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemOriginSenderHandle',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemOriginSenderHandle',
                ),
                'mditemoriginsubject' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemOriginSubject',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemOriginSubject',
                ),
                'mditempageheight' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemPageHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemPageHeight',
                ),
                'mditempagewidth' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemPageWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemPageWidth',
                ),
                'mditemphysicalsize' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemPhysicalSize',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemPhysicalSize',
                ),
                'mditempixelcount' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemPixelCount',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemPixelCount',
                ),
                'mditempixelheight' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemPixelHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemPixelHeight',
                ),
                'mditempixelwidth' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemPixelWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemPixelWidth',
                ),
                'mditemprimaryrecipientemailaddresses' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemPrimaryRecipientEmailAddresses',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemPrimaryRecipientEmailAddresses',
                ),
                'mditemprofilename' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemProfileName',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemProfileName',
                ),
                'mditemrecipients' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemRecipients',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemRecipients',
                ),
                'mditemredeyeonoff' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemRedEyeOnOff',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemRedEyeOnOff',
                ),
                'mditemresolutionheightdpi' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemResolutionHeightDPI',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemResolutionHeightDPI',
                ),
                'mditemresolutionwidthdpi' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemResolutionWidthDPI',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemResolutionWidthDPI',
                ),
                'mditemsecuritymethod' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemSecurityMethod',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemSecurityMethod',
                ),
                'mditemspeed' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemSpeed',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemSpeed',
                ),
                'mditemstateorprovince' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemStateOrProvince',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemStateOrProvince',
                ),
                'mditemstreamable' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemStreamable',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemStreamable',
                ),
                'mditemsubject' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemSubject',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemSubject',
                ),
                'mditemtimestamp' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemTimestamp',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemTimestamp',
                ),
                'mditemtitle' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemTitle',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemTitle',
                ),
                'mditemtotalbitrate' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemTotalBitRate',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemTotalBitRate',
                ),
                'mditemusecount' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemUseCount',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemUseCount',
                ),
                'mditemuseddates' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemUsedDates',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemUsedDates',
                ),
                'mditemuserdownloadeddate' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemUserDownloadedDate',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemUserDownloadedDate',
                ),
                'mditemuserdownloadeduserhandle' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemUserDownloadedUserHandle',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemUserDownloadedUserHandle',
                ),
                'mditemusersharedreceiveddate' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemUserSharedReceivedDate',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemUserSharedReceivedDate',
                ),
                'mditemusersharedreceivedrecipient' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemUserSharedReceivedRecipient',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemUserSharedReceivedRecipient',
                ),
                'mditemusersharedreceivedrecipienthandle' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemUserSharedReceivedRecipientHandle',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemUserSharedReceivedRecipientHandle',
                ),
                'mditemusersharedreceivedsender' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemUserSharedReceivedSender',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemUserSharedReceivedSender',
                ),
                'mditemusersharedreceivedsenderhandle' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemUserSharedReceivedSenderHandle',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemUserSharedReceivedSenderHandle',
                ),
                'mditemusersharedreceivedtransport' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemUserSharedReceivedTransport',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemUserSharedReceivedTransport',
                ),
                'mditemusertags' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemUserTags',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemUserTags',
                ),
                'mditemversion' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemVersion',
                ),
                'mditemvideobitrate' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemVideoBitRate',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemVideoBitRate',
                ),
                'mditemwherefroms' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemWhereFroms',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemWhereFroms',
                ),
                'mditemwhitebalance' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'MDItemWhiteBalance',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\MDItemWhiteBalance',
                ),
                'applemaildatereceived' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'AppleMailDateReceived',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\AppleMailDateReceived',
                ),
                'applemaildatesent' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'AppleMailDateSent',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\AppleMailDateSent',
                ),
                'applemailflagged' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'AppleMailFlagged',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\AppleMailFlagged',
                ),
                'applemailisremoteattachment' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'AppleMailIsRemoteAttachment',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\AppleMailIsRemoteAttachment',
                ),
                'applemailmessageid' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'AppleMailMessageID',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\AppleMailMessageID',
                ),
                'applemailpriority' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'AppleMailPriority',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\AppleMailPriority',
                ),
                'applemailread' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'AppleMailRead',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\AppleMailRead',
                ),
                'applemailrepliedto' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'AppleMailRepliedTo',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\AppleMailRepliedTo',
                ),
                'xattrfinderinfo' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'XAttrFinderInfo',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\XAttrFinderInfo',
                ),
                'xattrresourcefork' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'XAttrResourceFork',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\XAttrResourceFork',
                ),
                'xattrlastuseddate' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'XAttrLastUsedDate',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\XAttrLastUsedDate',
                ),
                'xattrapplemaildatereceived' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'XAttrAppleMailDateReceived',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\XAttrAppleMailDateReceived',
                ),
                'xattrapplemaildatesent' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'XAttrAppleMailDateSent',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\XAttrAppleMailDateSent',
                ),
                'xattrapplemailisremoteattachment' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'XAttrAppleMailIsRemoteAttachment',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\XAttrAppleMailIsRemoteAttachment',
                ),
                'xattrmditemdownloadeddate' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'XAttrMDItemDownloadedDate',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\XAttrMDItemDownloadedDate',
                ),
                'xattrmditemfindercomment' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'XAttrMDItemFinderComment',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\XAttrMDItemFinderComment',
                ),
                'xattrmditemwherefroms' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'XAttrMDItemWhereFroms',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\XAttrMDItemWhereFroms',
                ),
                'xattrmdlabel' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'XAttrMDLabel',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\XAttrMDLabel',
                ),
                'xattrquarantine' => array(
                    'namespace' => 'MacOS',
                    'tagname' => 'XAttrQuarantine',
                    'classname' => 'PHPExiftool\Driver\Tag\MacOS\XAttrQuarantine',
                ),
            ),
            
            'xmp-mp' => array(
                'regioninfomp' => array(
                    'namespace' => 'XMP-MP',
                    'tagname' => 'RegionInfoMP',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMP\RegionInfoMP',
                ),
                'regioninfodateregionsvalid' => array(
                    'namespace' => 'XMP-MP',
                    'tagname' => 'RegionInfoDateRegionsValid',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMP\RegionInfoDateRegionsValid',
                ),
                'regioninforegions' => array(
                    'namespace' => 'XMP-MP',
                    'tagname' => 'RegionInfoRegions',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMP\RegionInfoRegions',
                ),
                'regionpersondisplayname' => array(
                    'namespace' => 'XMP-MP',
                    'tagname' => 'RegionPersonDisplayName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMP\RegionPersonDisplayName',
                ),
                'regionpersonemaildigest' => array(
                    'namespace' => 'XMP-MP',
                    'tagname' => 'RegionPersonEmailDigest',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMP\RegionPersonEmailDigest',
                ),
                'regionpersonliveidcid' => array(
                    'namespace' => 'XMP-MP',
                    'tagname' => 'RegionPersonLiveIdCID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMP\RegionPersonLiveIdCID',
                ),
                'regionpersonsourceid' => array(
                    'namespace' => 'XMP-MP',
                    'tagname' => 'RegionPersonSourceID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMP\RegionPersonSourceID',
                ),
                'regionrectangle' => array(
                    'namespace' => 'XMP-MP',
                    'tagname' => 'RegionRectangle',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMP\RegionRectangle',
                ),
            ),
            'xmp-mp1' => array(
                'brightness' => array(
                    'namespace' => 'XMP-MP1',
                    'tagname' => 'Brightness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMP1\Brightness',
                ),
                'cameramodelid' => array(
                    'namespace' => 'XMP-MP1',
                    'tagname' => 'CameraModelID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMP1\CameraModelID',
                ),
                'contrast' => array(
                    'namespace' => 'XMP-MP1',
                    'tagname' => 'Contrast',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMP1\Contrast',
                ),
                'exposurecompensation' => array(
                    'namespace' => 'XMP-MP1',
                    'tagname' => 'ExposureCompensation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMP1\ExposureCompensation',
                ),
                'panoramicstitchcameramotion' => array(
                    'namespace' => 'XMP-MP1',
                    'tagname' => 'PanoramicStitchCameraMotion',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMP1\PanoramicStitchCameraMotion',
                ),
                'panoramicstitchmaptype' => array(
                    'namespace' => 'XMP-MP1',
                    'tagname' => 'PanoramicStitchMapType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMP1\PanoramicStitchMapType',
                ),
                'panoramicstitchphi0' => array(
                    'namespace' => 'XMP-MP1',
                    'tagname' => 'PanoramicStitchPhi0',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMP1\PanoramicStitchPhi0',
                ),
                'panoramicstitchphi1' => array(
                    'namespace' => 'XMP-MP1',
                    'tagname' => 'PanoramicStitchPhi1',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMP1\PanoramicStitchPhi1',
                ),
                'panoramicstitchtheta0' => array(
                    'namespace' => 'XMP-MP1',
                    'tagname' => 'PanoramicStitchTheta0',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMP1\PanoramicStitchTheta0',
                ),
                'panoramicstitchtheta1' => array(
                    'namespace' => 'XMP-MP1',
                    'tagname' => 'PanoramicStitchTheta1',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMP1\PanoramicStitchTheta1',
                ),
                'pipelineversion' => array(
                    'namespace' => 'XMP-MP1',
                    'tagname' => 'PipelineVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMP1\PipelineVersion',
                ),
                'streamtype' => array(
                    'namespace' => 'XMP-MP1',
                    'tagname' => 'StreamType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMP1\StreamType',
                ),
                'whitebalance0' => array(
                    'namespace' => 'XMP-MP1',
                    'tagname' => 'WhiteBalance0',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMP1\WhiteBalance0',
                ),
                'whitebalance1' => array(
                    'namespace' => 'XMP-MP1',
                    'tagname' => 'WhiteBalance1',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMP1\WhiteBalance1',
                ),
                'whitebalance2' => array(
                    'namespace' => 'XMP-MP1',
                    'tagname' => 'WhiteBalance2',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMP1\WhiteBalance2',
                ),
            ),
            'microsoft' => array(
                'panoramicstitchversion' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'PanoramicStitchVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\PanoramicStitchVersion',
                ),
                'panoramicstitchcameramotion' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'PanoramicStitchCameraMotion',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\PanoramicStitchCameraMotion',
                ),
                'panoramicstitchmaptype' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'PanoramicStitchMapType',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\PanoramicStitchMapType',
                ),
                'panoramicstitchtheta0' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'PanoramicStitchTheta0',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\PanoramicStitchTheta0',
                ),
                'panoramicstitchtheta1' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'PanoramicStitchTheta1',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\PanoramicStitchTheta1',
                ),
                'panoramicstitchphi0' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'PanoramicStitchPhi0',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\PanoramicStitchPhi0',
                ),
                'panoramicstitchphi1' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'PanoramicStitchPhi1',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\PanoramicStitchPhi1',
                ),
                'abstract' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Abstract',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Abstract0',
                ),
                'acquisitiontime' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'AcquisitionTime',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\AcquisitionTime',
                ),
                'acquisitiontimeday' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'AcquisitionTimeDay',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\AcquisitionTimeDay',
                ),
                'acquisitiontimemonth' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'AcquisitionTimeMonth',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\AcquisitionTimeMonth',
                ),
                'acquisitiontimeyear' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'AcquisitionTimeYear',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\AcquisitionTimeYear',
                ),
                'acquisitiontimeyearmonth' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'AcquisitionTimeYearMonth',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\AcquisitionTimeYearMonth',
                ),
                'acquisitiontimeyearmonthday' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'AcquisitionTimeYearMonthDay',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\AcquisitionTimeYearMonthDay',
                ),
                'albumartistsortorder' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'AlbumArtistSortOrder',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\AlbumArtistSortOrder',
                ),
                'albumid' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'AlbumID',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\AlbumID',
                ),
                'albumidalbumartist' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'AlbumIDAlbumArtist',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\AlbumIDAlbumArtist',
                ),
                'albumtitlesortorder' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'AlbumTitleSortOrder',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\AlbumTitleSortOrder',
                ),
                'alternatesourceurl' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'AlternateSourceURL',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\AlternateSourceURL',
                ),
                'audiobitrate' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'AudioBitrate',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\AudioBitrate',
                ),
                'audioformat' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'AudioFormat',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\AudioFormat',
                ),
                'author' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Author',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Author',
                ),
                'authorsortorder' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'AuthorSortOrder',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\AuthorSortOrder',
                ),
                'averagelevel' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'AverageLevel',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\AverageLevel',
                ),
                'bitrate' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Bitrate',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Bitrate',
                ),
                'buynow' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'BuyNow',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\BuyNow',
                ),
                'buytickets' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'BuyTickets',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\BuyTickets',
                ),
                'cdtrackenabled' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'CDTrackEnabled',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\CDTrackEnabled',
                ),
                'callletters' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'CallLetters',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\CallLetters',
                ),
                'cameramanufacturer' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'CameraManufacturer',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\CameraManufacturer',
                ),
                'cameramodel' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'CameraModel',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\CameraModel',
                ),
                'channels' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Channels',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Channels',
                ),
                'comment' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Comment',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Comment',
                ),
                'contentdistributorduration' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ContentDistributorDuration',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ContentDistributorDuration',
                ),
                'copyright' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Copyright',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Copyright',
                ),
                'count' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Count',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Count',
                ),
                'currentbitrate' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'CurrentBitrate',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\CurrentBitrate',
                ),
                'dlnaserverudn' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'DLNAServerUDN',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\DLNAServerUDN',
                ),
                'dlnasourceuri' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'DLNASourceURI',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\DLNASourceURI',
                ),
                'drmindividualizedversion' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'DRMIndividualizedVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\DRMIndividualizedVersion',
                ),
                'drmkeyid' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'DRMKeyID',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\DRMKeyID',
                ),
                'dtcpiphost' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'DTCPIPHost',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\DTCPIPHost',
                ),
                'dtcpipport' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'DTCPIPPort',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\DTCPIPPort',
                ),
                'dvdid' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'DVDID',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\DVDID',
                ),
                'description' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Description',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Description',
                ),
                'displayartist' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'DisplayArtist',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\DisplayArtist',
                ),
                'duration' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Duration',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Duration',
                ),
                'event' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Event',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Event',
                ),
                'filesize' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'FileSize',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\FileSize',
                ),
                'filetype' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'FileType',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\FileType',
                ),
                'formattag' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'FormatTag',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\FormatTag',
                ),
                'fourcc' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'FourCC',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\FourCC',
                ),
                'framerate' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'FrameRate',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\FrameRate',
                ),
                'frequency' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Frequency',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Frequency',
                ),
                'isnetworkfeed' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'IsNetworkFeed',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\IsNetworkFeed',
                ),
                'isvbr' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'IsVBR',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\IsVBR',
                ),
                'isprotected' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'IsProtected',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\IsProtected',
                ),
                'leadperformer' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'LeadPerformer',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\LeadPerformer',
                ),
                'libraryid' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'LibraryID',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\LibraryID',
                ),
                'libraryname' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'LibraryName',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\LibraryName',
                ),
                'location' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Location',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Location',
                ),
                'mediacontenttypes' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'MediaContentTypes',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\MediaContentTypes',
                ),
                'mediatype' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'MediaType',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\MediaType',
                ),
                'modifiedby' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ModifiedBy',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ModifiedBy',
                ),
                'moreinfo' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'MoreInfo',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\MoreInfo',
                ),
                'partofset' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'PartOfSet',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\PartOfSet',
                ),
                'peakvalue' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'PeakValue',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\PeakValue',
                ),
                'pixelaspectratiox' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'PixelAspectRatioX',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\PixelAspectRatioX',
                ),
                'pixelaspectratioy' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'PixelAspectRatioY',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\PixelAspectRatioY',
                ),
                'playlistindex' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'PlaylistIndex',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\PlaylistIndex',
                ),
                'provider' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Provider',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Provider',
                ),
                'providerlogourl' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ProviderLogoURL',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ProviderLogoURL',
                ),
                'providerurl' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ProviderURL',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ProviderURL',
                ),
                'radioband' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'RadioBand',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\RadioBand',
                ),
                'radioformat' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'RadioFormat',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\RadioFormat',
                ),
                'ratingorg' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'RatingOrg',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\RatingOrg',
                ),
                'recordingtime' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'RecordingTime',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\RecordingTime',
                ),
                'recordingtimeday' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'RecordingTimeDay',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\RecordingTimeDay',
                ),
                'recordingtimemonth' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'RecordingTimeMonth',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\RecordingTimeMonth',
                ),
                'recordingtimeyear' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'RecordingTimeYear',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\RecordingTimeYear',
                ),
                'recordingtimeyearmonth' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'RecordingTimeYearMonth',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\RecordingTimeYearMonth',
                ),
                'recordingtimeyearmonthday' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'RecordingTimeYearMonthDay',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\RecordingTimeYearMonthDay',
                ),
                'releasedate' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ReleaseDate',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ReleaseDate',
                ),
                'releasedateday' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ReleaseDateDay',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ReleaseDateDay',
                ),
                'releasedatemonth' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ReleaseDateMonth',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ReleaseDateMonth',
                ),
                'releasedateyear' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ReleaseDateYear',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ReleaseDateYear',
                ),
                'releasedateyearmonth' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ReleaseDateYearMonth',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ReleaseDateYearMonth',
                ),
                'releasedateyearmonthday' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ReleaseDateYearMonthDay',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ReleaseDateYearMonthDay',
                ),
                'requeststate' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'RequestState',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\RequestState',
                ),
                'shadowfilepath' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ShadowFilePath',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ShadowFilePath',
                ),
                'sourceurl' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'SourceURL',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\SourceURL',
                ),
                'subject' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Subject',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Subject',
                ),
                'sync01' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Sync01',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Sync01',
                ),
                'sync02' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Sync02',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Sync02',
                ),
                'sync03' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Sync03',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Sync03',
                ),
                'sync04' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Sync04',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Sync04',
                ),
                'sync05' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Sync05',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Sync05',
                ),
                'sync06' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Sync06',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Sync06',
                ),
                'sync07' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Sync07',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Sync07',
                ),
                'sync08' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Sync08',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Sync08',
                ),
                'sync09' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Sync09',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Sync09',
                ),
                'sync10' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Sync10',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Sync10',
                ),
                'sync11' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Sync11',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Sync11',
                ),
                'sync12' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Sync12',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Sync12',
                ),
                'sync13' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Sync13',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Sync13',
                ),
                'sync14' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Sync14',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Sync14',
                ),
                'sync15' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Sync15',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Sync15',
                ),
                'sync16' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Sync16',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Sync16',
                ),
                'synconly' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'SyncOnly',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\SyncOnly',
                ),
                'syncstate' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'SyncState',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\SyncState',
                ),
                'temporary' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Temporary',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Temporary',
                ),
                'title' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Title',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Title',
                ),
                'titlesortorder' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'TitleSortOrder',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\TitleSortOrder',
                ),
                'totalduration' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'TotalDuration',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\TotalDuration',
                ),
                'trackingid' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'TrackingID',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\TrackingID',
                ),
                'usercustom1' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'UserCustom1',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\UserCustom1',
                ),
                'usercustom2' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'UserCustom2',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\UserCustom2',
                ),
                'usereffectiverating' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'UserEffectiveRating',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\UserEffectiveRating',
                ),
                'userlastplayedtime' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'UserLastPlayedTime',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\UserLastPlayedTime',
                ),
                'userplaycount' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'UserPlayCount',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\UserPlayCount',
                ),
                'userplaycountafternoon' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'UserPlaycountAfternoon',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\UserPlaycountAfternoon',
                ),
                'userplaycountevening' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'UserPlaycountEvening',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\UserPlaycountEvening',
                ),
                'userplaycountmorning' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'UserPlaycountMorning',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\UserPlaycountMorning',
                ),
                'userplaycountnight' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'UserPlaycountNight',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\UserPlaycountNight',
                ),
                'userplaycountweekday' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'UserPlaycountWeekday',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\UserPlaycountWeekday',
                ),
                'userplaycountweekend' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'UserPlaycountWeekend',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\UserPlaycountWeekend',
                ),
                'userrating' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'UserRating',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\UserRating',
                ),
                'userservicerating' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'UserServiceRating',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\UserServiceRating',
                ),
                'videobitrate' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'VideoBitrate',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\VideoBitrate',
                ),
                'videoformat' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'VideoFormat',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\VideoFormat',
                ),
                'albumartist' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'AlbumArtist',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\AlbumArtist',
                ),
                'albumcoverurl' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'AlbumCoverURL',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\AlbumCoverURL',
                ),
                'albumtitle' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'AlbumTitle',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\AlbumTitle',
                ),
                'mixed' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'mixed',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\BeatsPerMinute',
                ),
                'category' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Category',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Category',
                ),
                'composer' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Composer',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Composer',
                ),
                'conductor' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Conductor',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Conductor',
                ),
                'contentdistributor' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ContentDistributor',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ContentDistributor',
                ),
                'contentdistributortype' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ContentDistributorType',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ContentDistributorType',
                ),
                'contentgroupdescription' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ContentGroupDescription',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ContentGroupDescription',
                ),
                'director' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Director',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Director',
                ),
                'encodingtime' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'EncodingTime',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\EncodingTime',
                ),
                'genre' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Genre',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Genre',
                ),
                'genreid' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'GenreID',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\GenreID',
                ),
                'initialkey' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'InitialKey',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\InitialKey',
                ),
                'language' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Language',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Language',
                ),
                'lyrics' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Lyrics',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Lyrics',
                ),
                'mcdi' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'MCDI',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\MCDI',
                ),
                'mediaclassprimaryid' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'MediaClassPrimaryID',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\MediaClassPrimaryID',
                ),
                'mediaclasssecondaryid' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'MediaClassSecondaryID',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\MediaClassSecondaryID',
                ),
                'mediaoriginalbroadcastdatetime' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'MediaOriginalBroadcastDateTime',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\MediaOriginalBroadcastDateTime',
                ),
                'mediaoriginalchannel' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'MediaOriginalChannel',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\MediaOriginalChannel',
                ),
                'mediastationname' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'MediaStationName',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\MediaStationName',
                ),
                'mood' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Mood',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Mood',
                ),
                'originalalbumtitle' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'OriginalAlbumTitle',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\OriginalAlbumTitle',
                ),
                'originalartist' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'OriginalArtist',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\OriginalArtist',
                ),
                'originallyricist' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'OriginalLyricist',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\OriginalLyricist',
                ),
                'parentalrating' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ParentalRating',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ParentalRating',
                ),
                'period' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Period',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Period',
                ),
                'producer' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Producer',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Producer',
                ),
                'protectiontype' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ProtectionType',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ProtectionType',
                ),
                'providerrating' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ProviderRating',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ProviderRating',
                ),
                'providerstyle' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ProviderStyle',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ProviderStyle',
                ),
                'publisher' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Publisher',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Publisher',
                ),
                'shareduserrating' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'SharedUserRating',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\SharedUserRating',
                ),
                'subtitle' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Subtitle',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Subtitle',
                ),
                'subtitledescription' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'SubtitleDescription',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\SubtitleDescription',
                ),
                'subscriptioncontentid' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'SubscriptionContentID',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\SubscriptionContentID',
                ),
                'tracknumber' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'TrackNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\TrackNumber',
                ),
                'uniquefileidentifier' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'UniqueFileIdentifier',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\UniqueFileIdentifier',
                ),
                'videoframerate' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'VideoFrameRate',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\VideoFrameRate',
                ),
                'videoheight' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'VideoHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\VideoHeight',
                ),
                'videowidth' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'VideoWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\VideoWidth',
                ),
                'wmcollectiongroupid' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'WMCollectionGroupID',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\WMCollectionGroupID',
                ),
                'wmcollectionid' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'WMCollectionID',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\WMCollectionID',
                ),
                'wmcontentid' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'WMContentID',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\WMContentID',
                ),
                'wmshadowfilesourcedrmtype' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'WMShadowFileSourceDRMType',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\WMShadowFileSourceDRMType',
                ),
                'wmshadowfilesourcefiletype' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'WMShadowFileSourceFileType',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\WMShadowFileSourceFileType',
                ),
                'writer' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Writer',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Writer',
                ),
                'year' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Year',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Year',
                ),
                'chapternum' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ChapterNum',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ChapterNum',
                ),
                'titlenum' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'TitleNum',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\TitleNum',
                ),
                'resources' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Resources',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Resources',
                ),
                'complete' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Complete',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Complete',
                ),
                'homecountry-region' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'HomeCountry-Region',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\HomeCountryRegion',
                ),
                'taskowner' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'TaskOwner',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\TaskOwner',
                ),
                'maxaperture' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'MaxAperture',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\MaxAperture',
                ),
                'optionalattendees' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'OptionalAttendees',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\OptionalAttendees',
                ),
                'homestreet' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'HomeStreet',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\HomeStreet',
                ),
                'requiredattendeeaddresses' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'RequiredAttendeeAddresses',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\RequiredAttendeeAddresses',
                ),
                'senderaddress' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'SenderAddress',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\SenderAddress',
                ),
                'fileversion' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'FileVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\FileVersion',
                ),
                'productname' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ProductName',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ProductName',
                ),
                'productversion' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ProductVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ProductVersion',
                ),
                'legaltrademarks' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'LegalTrademarks',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\LegalTrademarks',
                ),
                'sendername' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'SenderName',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\SenderName',
                ),
                'parentalratingreason' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ParentalRatingReason',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ParentalRatingReason',
                ),
                'firstname' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'FirstName',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\FirstName',
                ),
                'dateimported' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'DateImported',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\DateImported',
                ),
                'cameramaker' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'CameraMaker',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\CameraMaker',
                ),
                'orientation' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Orientation',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Orientation',
                ),
                'exposuretime' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ExposureTime',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ExposureTime',
                ),
                'f-stop' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'F-stop',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\FStop',
                ),
                'exposureprogram' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ExposureProgram',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ExposureProgram',
                ),
                'isospeed' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ISOSpeed',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ISOSpeed',
                ),
                'datepicturetaken' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'DatePictureTaken',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\DatePictureTaken',
                ),
                'exposurebias' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ExposureBias',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ExposureBias',
                ),
                'subjectdistance' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'SubjectDistance',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\SubjectDistance',
                ),
                'meteringmode' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'MeteringMode',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\MeteringMode',
                ),
                'lightsource' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'LightSource',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\LightSource',
                ),
                'flashmode' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'FlashMode',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\FlashMode',
                ),
                'focallength' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'FocalLength',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\FocalLength',
                ),
                'homephone' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'HomePhone',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\HomePhone',
                ),
                'primaryphone' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'PrimaryPhone',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\PrimaryPhone',
                ),
                'cellphone' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'CellPhone',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\CellPhone',
                ),
                'birthday' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Birthday',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Birthday',
                ),
                'primarye-mail' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'PrimaryE-mail',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\PrimaryEMail',
                ),
                'jobtitle' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'JobTitle',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\JobTitle',
                ),
                'homecity' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'HomeCity',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\HomeCity',
                ),
                'personaltitle' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'PersonalTitle',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\PersonalTitle',
                ),
                'officelocation' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'OfficeLocation',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\OfficeLocation',
                ),
                'givenname' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'GivenName',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\GivenName',
                ),
                'middlename' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'MiddleName',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\MiddleName',
                ),
                'suffix' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Suffix',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Suffix',
                ),
                'nickname' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Nickname',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Nickname',
                ),
                'postalcode' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'PostalCode',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\PostalCode',
                ),
                'stationname' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'StationName',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\StationName',
                ),
                'division' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Division',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Division',
                ),
                'kinds' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Kinds',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Kinds',
                ),
                'clientid' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ClientID',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ClientID',
                ),
                'type' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Type',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Type',
                ),
                'filecount' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'FileCount',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\FileCount',
                ),
                'totalfilesize' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'TotalFileSize',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\TotalFileSize',
                ),
                'computer' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Computer',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Computer',
                ),
                'perceivedtype' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'PerceivedType',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\PerceivedType',
                ),
                'dateacquired' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'DateAcquired',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\DateAcquired',
                ),
                'mediacreated' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'MediaCreated',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\MediaCreated',
                ),
                'isrecurring' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'IsRecurring',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\IsRecurring',
                ),
                'incomplete' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Incomplete',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Incomplete',
                ),
                'e-mail2' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'E-mail2',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\EMail2',
                ),
                'project' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Project',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Project',
                ),
                'gender' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Gender',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Gender',
                ),
                'duedate' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'DueDate',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\DueDate',
                ),
                'businesscity' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'BusinessCity',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\BusinessCity',
                ),
                'windowsfilename' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'WindowsFileName',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\WindowsFileName',
                ),
                'datearchived' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'DateArchived',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\DateArchived',
                ),
                'businessstateorprovince' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'BusinessStateOrProvince',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\BusinessStateOrProvince',
                ),
                'broadcastdate' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'BroadcastDate',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\BroadcastDate',
                ),
                'color' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Color',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Color',
                ),
                'startdate' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'StartDate',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\StartDate',
                ),
                'saturation' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Saturation',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Saturation',
                ),
                'searchranking' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'SearchRanking',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\SearchRanking',
                ),
                'otheraddress' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'OtherAddress',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\OtherAddress',
                ),
                'autosummary' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'AutoSummary',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\AutoSummary',
                ),
                'summary' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Summary',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Summary',
                ),
                'businesshomepage' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'BusinessHomePage',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\BusinessHomePage',
                ),
                'artist' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Artist',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Artist',
                ),
                'conductors' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Conductors',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Conductors',
                ),
                'free-busystatus' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Free-busyStatus',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\FreeBusyStatus',
                ),
                'url' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'URL',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\URL',
                ),
                'datevisited' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'DateVisited',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\DateVisited',
                ),
                'isdeleted' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'IsDeleted',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\IsDeleted',
                ),
                'hasflag' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'HasFlag',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\HasFlag',
                ),
                'hobbies' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Hobbies',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Hobbies',
                ),
                'fullname' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'FullName',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\FullName',
                ),
                'street' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Street',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Street',
                ),
                'dimensions' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Dimensions',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Dimensions',
                ),
                'untitled0' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Untitled0',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Untitled0',
                ),
                'untitled1' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Untitled1',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Untitled1',
                ),
                'horizontalresolution' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'HorizontalResolution',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\HorizontalResolution',
                ),
                'verticalresolution' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'VerticalResolution',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\VerticalResolution',
                ),
                'bitdepth' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'BitDepth',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\BitDepth',
                ),
                'audiosamplerate' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'AudioSampleRate',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\AudioSampleRate',
                ),
                'audiosamplesize' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'AudioSampleSize',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\AudioSampleSize',
                ),
                'videocompression' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'VideoCompression',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\VideoCompression',
                ),
                'framewidth' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'FrameWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\FrameWidth',
                ),
                'frameheight' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'FrameHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\FrameHeight',
                ),
                'totalbitrate' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'TotalBitrate',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\TotalBitrate',
                ),
                'datarate' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'DataRate',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\DataRate',
                ),
                'composers' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Composers',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Composers',
                ),
                'directors' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Directors',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Directors',
                ),
                'producers' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Producers',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Producers',
                ),
                'writers' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Writers',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Writers',
                ),
                'userweburl' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'UserWebURL',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\UserWebURL',
                ),
                'encodedby' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'EncodedBy',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\EncodedBy',
                ),
                'rating' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Rating',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Rating',
                ),
                'e-mail3' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'E-mail3',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\EMail3',
                ),
                'homefax' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'HomeFax',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\HomeFax',
                ),
                'source' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Source',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Source',
                ),
                'flagcolor' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'FlagColor',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\FlagColor',
                ),
                'businessphone' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'BusinessPhone',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\BusinessPhone',
                ),
                'programmode' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ProgramMode',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ProgramMode',
                ),
                'offlinestatus' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'OfflineStatus',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\OfflineStatus',
                ),
                'closedcaptioning' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ClosedCaptioning',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ClosedCaptioning',
                ),
                'rerun' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Rerun',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Rerun',
                ),
                'sap' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'SAP',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\SAP',
                ),
                'episodename' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'EpisodeName',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\EpisodeName',
                ),
                'programdescription' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ProgramDescription',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ProgramDescription',
                ),
                'stationcallsign' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'StationCallSign',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\StationCallSign',
                ),
                'channelnumber' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ChannelNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ChannelNumber',
                ),
                'othercity' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'OtherCity',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\OtherCity',
                ),
                'otherstateorprovince' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'OtherStateOrProvince',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\OtherStateOrProvince',
                ),
                'profession' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Profession',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Profession',
                ),
                'datecompleted' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'DateCompleted',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\DateCompleted',
                ),
                'remindertime' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ReminderTime',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ReminderTime',
                ),
                'businessaddress' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'BusinessAddress',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\BusinessAddress',
                ),
                'organizeraddress' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'OrganizerAddress',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\OrganizerAddress',
                ),
                'homepobox' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'HomePOBox',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\HomePOBox',
                ),
                'e-maillist' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'E-mailList',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\EMailList',
                ),
                'companymainphone' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'CompanyMainPhone',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\CompanyMainPhone',
                ),
                'homepostalcode' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'HomePostalCode',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\HomePostalCode',
                ),
                'otherpobox' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'OtherPOBox',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\OtherPOBox',
                ),
                'othercountry-region' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'OtherCountry-Region',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\OtherCountryRegion',
                ),
                'lastname' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'LastName',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\LastName',
                ),
                'carphone' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'CarPhone',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\CarPhone',
                ),
                'businessfax' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'BusinessFax',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\BusinessFax',
                ),
                'entrytype' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'EntryType',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\EntryType',
                ),
                'otherpostalcode' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'OtherPostalCode',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\OtherPostalCode',
                ),
                'label' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Label',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Label',
                ),
                'homeaddress' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'HomeAddress',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\HomeAddress',
                ),
                'assistantsphone' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'AssistantsPhone',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\AssistantsPhone',
                ),
                'anniversary' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Anniversary',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Anniversary',
                ),
                'owner' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Owner',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Owner',
                ),
                'spacefree' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'SpaceFree',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\SpaceFree',
                ),
                'totalsize' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'TotalSize',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\TotalSize',
                ),
                'spaceused' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'SpaceUsed',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\SpaceUsed',
                ),
                'priority' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Priority',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Priority',
                ),
                'hasattachments' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'HasAttachments',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\HasAttachments',
                ),
                'spouse' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Spouse',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Spouse',
                ),
                'focallength35mm' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'FocalLength35mm',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\FocalLength35mm',
                ),
                'iscompleted' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'IsCompleted',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\IsCompleted',
                ),
                'offlineavailability' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'OfflineAvailability',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\OfflineAvailability',
                ),
                'organizername' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'OrganizerName',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\OrganizerName',
                ),
                'tty-ttdphone' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'TTY-TTDPhone',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\TTYTTDPhone',
                ),
                'protected' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Protected',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Protected0',
                ),
                'businesscountry-region' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'BusinessCountry-Region',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\BusinessCountryRegion',
                ),
                'requiredattendees' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'RequiredAttendees',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\RequiredAttendees',
                ),
                'name' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Name',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Name',
                ),
                'size' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Size',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Size',
                ),
                'attributes' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Attributes',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Attributes',
                ),
                'datemodified' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'DateModified',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\DateModified',
                ),
                'datecreated' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'DateCreated',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\DateCreated',
                ),
                'dateaccessed' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'DateAccessed',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\DateAccessed',
                ),
                'foldername' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'FolderName',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\FolderName',
                ),
                'linktarget' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'LinkTarget',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\LinkTarget',
                ),
                'linkstatus' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'LinkStatus',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\LinkStatus',
                ),
                'businesspobox' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'BusinessPOBox',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\BusinessPOBox',
                ),
                'todotitle' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ToDoTitle',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ToDoTitle',
                ),
                'callbacknumber' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'CallbackNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\CallbackNumber',
                ),
                'isonline' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'IsOnline',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\IsOnline',
                ),
                'mailingaddress' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'MailingAddress',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\MailingAddress',
                ),
                'telex' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Telex',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Telex',
                ),
                'enddate' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'EndDate',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\EndDate',
                ),
                'homestateorprovince' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'HomeStateOrProvince',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\HomeStateOrProvince',
                ),
                'city' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'City',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\City',
                ),
                'e-maildisplayname' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'E-mailDisplayName',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\EMailDisplayName',
                ),
                'assistantsname' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'AssistantsName',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\AssistantsName',
                ),
                'creator' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Creator',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Creator',
                ),
                'exifversion' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ExifVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ExifVersion',
                ),
                'billinginformation' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'BillingInformation',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\BillingInformation',
                ),
                'children' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Children',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Children',
                ),
                'participants' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Participants',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Participants',
                ),
                'optionalattendeeaddresses' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'OptionalAttendeeAddresses',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\OptionalAttendeeAddresses',
                ),
                'company' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Company',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Company',
                ),
                'contenttype' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ContentType',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ContentType',
                ),
                'status' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Status',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Status',
                ),
                'slides' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Slides',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Slides',
                ),
                'pager' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Pager',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Pager',
                ),
                'imaddresses' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'IMAddresses',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\IMAddresses',
                ),
                'folder' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Folder',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Folder',
                ),
                'conversationid' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ConversationID',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ConversationID',
                ),
                'businessstreet' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'BusinessStreet',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\BusinessStreet',
                ),
                'datereleased' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'DateReleased',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\DateReleased',
                ),
                'pobox' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'POBox',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\POBox',
                ),
                'contactnames' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ContactNames',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ContactNames',
                ),
                'documentid' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'DocumentID',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\DocumentID',
                ),
                'lensmodel' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'LensModel',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\LensModel',
                ),
                'businesspostalcode' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'BusinessPostalCode',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\BusinessPostalCode',
                ),
                'readstatus' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ReadStatus',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ReadStatus',
                ),
                'importance' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Importance',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Importance',
                ),
                'flagstatus' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'FlagStatus',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\FlagStatus',
                ),
                'fromaddresses' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'FromAddresses',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\FromAddresses',
                ),
                'fromnames' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'FromNames',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\FromNames',
                ),
                'store' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Store',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Store',
                ),
                'toaddresses' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ToAddresses',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ToAddresses',
                ),
                'tonames' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ToNames',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ToNames',
                ),
                'webpage' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Webpage',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Webpage',
                ),
                'datesent' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'DateSent',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\DateSent',
                ),
                'bccaddresses' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'BccAddresses',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\BccAddresses',
                ),
                'datereceived' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'DateReceived',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\DateReceived',
                ),
                'attachments' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Attachments',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Attachments',
                ),
                'bccnames' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'BccNames',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\BccNames',
                ),
                'ccaddresses' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'CcAddresses',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\CcAddresses',
                ),
                'ccnames' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'CcNames',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\CcNames',
                ),
                'folderpath' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'FolderPath',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\FolderPath',
                ),
                'path' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Path',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Path',
                ),
                'accountname' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'AccountName',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\AccountName',
                ),
                'country-region' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Country-Region',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\CountryRegion',
                ),
                'lensmaker' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'LensMaker',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\LensMaker',
                ),
                'whitebalance' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'WhiteBalance',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\WhiteBalance',
                ),
                'shared' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Shared',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Shared',
                ),
                'sharedwith' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'SharedWith',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\SharedWith',
                ),
                'stateorprovince' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'StateOrProvince',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\StateOrProvince',
                ),
                'fileas' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'FileAs',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\FileAs',
                ),
                'isattachment' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'IsAttachment',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\IsAttachment',
                ),
                'totaleditingtime' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'TotalEditingTime',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\TotalEditingTime',
                ),
                'lastprinted' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'LastPrinted',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\LastPrinted',
                ),
                'untitled2' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Untitled2',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Untitled2',
                ),
                'datelastsaved' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'DateLastSaved',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\DateLastSaved',
                ),
                'pages' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Pages',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Pages',
                ),
                'wordcount' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'WordCount',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\WordCount',
                ),
                'programname' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'ProgramName',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\ProgramName',
                ),
                'keywords' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Keywords',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Keywords',
                ),
                'comments' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Comments',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Comments',
                ),
                'contributors' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Contributors',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Contributors',
                ),
                'initials' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Initials',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Initials',
                ),
                'date' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Date',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Date',
                ),
                'sensitivity' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Sensitivity',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Sensitivity',
                ),
                'e-mailaddress' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'E-mailAddress',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\EMailAddress',
                ),
                'department' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Department',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Department',
                ),
                'mileage' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'Mileage',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\Mileage',
                ),
                'otherstreet' => array(
                    'namespace' => 'Microsoft',
                    'tagname' => 'OtherStreet',
                    'classname' => 'PHPExiftool\Driver\Tag\Microsoft\OtherStreet',
                ),
            ),
            'xmp-microsoft' => array(
                'cameraserialnumber' => array(
                    'namespace' => 'XMP-microsoft',
                    'tagname' => 'CameraSerialNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMicrosoft\CameraSerialNumber',
                ),
                'creatorappid' => array(
                    'namespace' => 'XMP-microsoft',
                    'tagname' => 'CreatorAppID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMicrosoft\CreatorAppID',
                ),
                'creatoropenwithuioptions' => array(
                    'namespace' => 'XMP-microsoft',
                    'tagname' => 'CreatorOpenWithUIOptions',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMicrosoft\CreatorOpenWithUIOptions',
                ),
                'dateacquired' => array(
                    'namespace' => 'XMP-microsoft',
                    'tagname' => 'DateAcquired',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMicrosoft\DateAcquired',
                ),
                'flashmanufacturer' => array(
                    'namespace' => 'XMP-microsoft',
                    'tagname' => 'FlashManufacturer',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMicrosoft\FlashManufacturer',
                ),
                'flashmodel' => array(
                    'namespace' => 'XMP-microsoft',
                    'tagname' => 'FlashModel',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMicrosoft\FlashModel',
                ),
                'itemsubtype' => array(
                    'namespace' => 'XMP-microsoft',
                    'tagname' => 'ItemSubType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMicrosoft\ItemSubType',
                ),
                'lastkeywordiptc' => array(
                    'namespace' => 'XMP-microsoft',
                    'tagname' => 'LastKeywordIPTC',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMicrosoft\LastKeywordIPTC',
                ),
                'lastkeywordxmp' => array(
                    'namespace' => 'XMP-microsoft',
                    'tagname' => 'LastKeywordXMP',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMicrosoft\LastKeywordXMP',
                ),
                'lensmanufacturer' => array(
                    'namespace' => 'XMP-microsoft',
                    'tagname' => 'LensManufacturer',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMicrosoft\LensManufacturer',
                ),
                'lensmodel' => array(
                    'namespace' => 'XMP-microsoft',
                    'tagname' => 'LensModel',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMicrosoft\LensModel',
                ),
                'ratingpercent' => array(
                    'namespace' => 'XMP-microsoft',
                    'tagname' => 'RatingPercent',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMicrosoft\RatingPercent',
                ),
            ),
  
            'xmp-plus' => array(
                'adultcontentwarning' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'AdultContentWarning',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\AdultContentWarning',
                ),
                'copyrightowner' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'CopyrightOwner',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\CopyrightOwner',
                ),
                'copyrightownerid' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'CopyrightOwnerID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\CopyrightOwnerID',
                ),
                'copyrightownername' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'CopyrightOwnerName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\CopyrightOwnerName',
                ),
                'copyrightownerimageid' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'CopyrightOwnerImageID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\CopyrightOwnerImageID',
                ),
                'copyrightregistrationnumber' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'CopyrightRegistrationNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\CopyrightRegistrationNumber',
                ),
                'copyrightstatus' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'CopyrightStatus',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\CopyrightStatus',
                ),
                'creditlinerequired' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'CreditLineRequired',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\CreditLineRequired',
                ),
                'custom1' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'Custom1',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\Custom1',
                ),
                'custom10' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'Custom10',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\Custom10',
                ),
                'custom2' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'Custom2',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\Custom2',
                ),
                'custom3' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'Custom3',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\Custom3',
                ),
                'custom4' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'Custom4',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\Custom4',
                ),
                'custom5' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'Custom5',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\Custom5',
                ),
                'custom6' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'Custom6',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\Custom6',
                ),
                'custom7' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'Custom7',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\Custom7',
                ),
                'custom8' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'Custom8',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\Custom8',
                ),
                'custom9' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'Custom9',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\Custom9',
                ),
                'enduser' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'EndUser',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\EndUser',
                ),
                'enduserid' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'EndUserID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\EndUserID',
                ),
                'endusername' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'EndUserName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\EndUserName',
                ),
                'filenameasdelivered' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'FileNameAsDelivered',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\FileNameAsDelivered',
                ),
                'firstpublicationdate' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'FirstPublicationDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\FirstPublicationDate',
                ),
                'imagealterationconstraints' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'ImageAlterationConstraints',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\ImageAlterationConstraints',
                ),
                'imagecreator' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'ImageCreator',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\ImageCreator',
                ),
                'imagecreatorid' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'ImageCreatorID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\ImageCreatorID',
                ),
                'imagecreatorname' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'ImageCreatorName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\ImageCreatorName',
                ),
                'imagecreatorimageid' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'ImageCreatorImageID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\ImageCreatorImageID',
                ),
                'imageduplicationconstraints' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'ImageDuplicationConstraints',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\ImageDuplicationConstraints',
                ),
                'imagefileconstraints' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'ImageFileConstraints',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\ImageFileConstraints',
                ),
                'imagefileformatasdelivered' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'ImageFileFormatAsDelivered',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\ImageFileFormatAsDelivered',
                ),
                'imagefilesizeasdelivered' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'ImageFileSizeAsDelivered',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\ImageFileSizeAsDelivered',
                ),
                'imagesupplier' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'ImageSupplier',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\ImageSupplier',
                ),
                'imagesupplierimageid' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'ImageSupplierImageID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\ImageSupplierImageID',
                ),
                'imagesupplierid' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'ImageSupplierID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\ImageSupplierID',
                ),
                'imagesuppliername' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'ImageSupplierName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\ImageSupplierName',
                ),
                'imagetype' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'ImageType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\ImageType',
                ),
                'licenseenddate' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'LicenseEndDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\LicenseEndDate',
                ),
                'licenseid' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'LicenseID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\LicenseID',
                ),
                'licensestartdate' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'LicenseStartDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\LicenseStartDate',
                ),
                'licensetransactiondate' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'LicenseTransactionDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\LicenseTransactionDate',
                ),
                'licensee' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'Licensee',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\Licensee',
                ),
                'licenseeimageid' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'LicenseeImageID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\LicenseeImageID',
                ),
                'licenseeimagenotes' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'LicenseeImageNotes',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\LicenseeImageNotes',
                ),
                'licenseeid' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'LicenseeID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\LicenseeID',
                ),
                'licenseename' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'LicenseeName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\LicenseeName',
                ),
                'licenseeprojectreference' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'LicenseeProjectReference',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\LicenseeProjectReference',
                ),
                'licenseetransactionid' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'LicenseeTransactionID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\LicenseeTransactionID',
                ),
                'licensor' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'Licensor',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\Licensor',
                ),
                'licensorimageid' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'LicensorImageID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\LicensorImageID',
                ),
                'licensorcity' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'LicensorCity',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\LicensorCity',
                ),
                'licensorcountry' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'LicensorCountry',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\LicensorCountry',
                ),
                'licensoremail' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'LicensorEmail',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\LicensorEmail',
                ),
                'licensorextendedaddress' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'LicensorExtendedAddress',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\LicensorExtendedAddress',
                ),
                'licensorid' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'LicensorID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\LicensorID',
                ),
                'licensorname' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'LicensorName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\LicensorName',
                ),
                'licensorpostalcode' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'LicensorPostalCode',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\LicensorPostalCode',
                ),
                'licensorregion' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'LicensorRegion',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\LicensorRegion',
                ),
                'licensorstreetaddress' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'LicensorStreetAddress',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\LicensorStreetAddress',
                ),
                'licensortelephone1' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'LicensorTelephone1',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\LicensorTelephone1',
                ),
                'licensortelephone2' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'LicensorTelephone2',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\LicensorTelephone2',
                ),
                'licensortelephonetype1' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'LicensorTelephoneType1',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\LicensorTelephoneType1',
                ),
                'licensortelephonetype2' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'LicensorTelephoneType2',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\LicensorTelephoneType2',
                ),
                'licensorurl' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'LicensorURL',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\LicensorURL',
                ),
                'licensornotes' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'LicensorNotes',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\LicensorNotes',
                ),
                'licensortransactionid' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'LicensorTransactionID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\LicensorTransactionID',
                ),
                'mediaconstraints' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'MediaConstraints',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\MediaConstraints',
                ),
                'mediasummarycode' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'MediaSummaryCode',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\MediaSummaryCode',
                ),
                'minormodelagedisclosure' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'MinorModelAgeDisclosure',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\MinorModelAgeDisclosure',
                ),
                'modelreleaseid' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'ModelReleaseID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\ModelReleaseID',
                ),
                'modelreleasestatus' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'ModelReleaseStatus',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\ModelReleaseStatus',
                ),
                'otherconditions' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'OtherConditions',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\OtherConditions',
                ),
                'otherconstraints' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'OtherConstraints',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\OtherConstraints',
                ),
                'otherimageinfo' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'OtherImageInfo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\OtherImageInfo',
                ),
                'otherlicensedocuments' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'OtherLicenseDocuments',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\OtherLicenseDocuments',
                ),
                'otherlicenseinfo' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'OtherLicenseInfo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\OtherLicenseInfo',
                ),
                'otherlicenserequirements' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'OtherLicenseRequirements',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\OtherLicenseRequirements',
                ),
                'productorserviceconstraints' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'ProductOrServiceConstraints',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\ProductOrServiceConstraints',
                ),
                'propertyreleaseid' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'PropertyReleaseID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\PropertyReleaseID',
                ),
                'propertyreleasestatus' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'PropertyReleaseStatus',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\PropertyReleaseStatus',
                ),
                'regionconstraints' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'RegionConstraints',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\RegionConstraints',
                ),
                'reuse' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'Reuse',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\Reuse',
                ),
                'termsandconditionstext' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'TermsAndConditionsText',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\TermsAndConditionsText',
                ),
                'termsandconditionsurl' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'TermsAndConditionsURL',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\TermsAndConditionsURL',
                ),
                'plusversion' => array(
                    'namespace' => 'XMP-plus',
                    'tagname' => 'PLUSVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPlus\PLUSVersion',
                ),
            ),
            'cameraifd' => array(
                'multishoton' => array(
                    'namespace' => 'CameraIFD',
                    'tagname' => 'MultishotOn',
                    'classname' => 'PHPExiftool\Driver\Tag\CameraIFD\MultishotOn',
                ),
                'focusstepnear' => array(
                    'namespace' => 'CameraIFD',
                    'tagname' => 'FocusStepNear',
                    'classname' => 'PHPExiftool\Driver\Tag\CameraIFD\FocusStepNear',
                ),
                'focusstepcount' => array(
                    'namespace' => 'CameraIFD',
                    'tagname' => 'FocusStepCount',
                    'classname' => 'PHPExiftool\Driver\Tag\CameraIFD\FocusStepCount',
                ),
                'flashfired' => array(
                    'namespace' => 'CameraIFD',
                    'tagname' => 'FlashFired',
                    'classname' => 'PHPExiftool\Driver\Tag\CameraIFD\FlashFired',
                ),
                'zoomposition' => array(
                    'namespace' => 'CameraIFD',
                    'tagname' => 'ZoomPosition',
                    'classname' => 'PHPExiftool\Driver\Tag\CameraIFD\ZoomPosition',
                ),
                'lensattached' => array(
                    'namespace' => 'CameraIFD',
                    'tagname' => 'LensAttached',
                    'classname' => 'PHPExiftool\Driver\Tag\CameraIFD\LensAttached',
                ),
                'lenstypemake' => array(
                    'namespace' => 'CameraIFD',
                    'tagname' => 'LensTypeMake',
                    'classname' => 'PHPExiftool\Driver\Tag\CameraIFD\LensTypeMake',
                ),
                'lenstypemodel' => array(
                    'namespace' => 'CameraIFD',
                    'tagname' => 'LensTypeModel',
                    'classname' => 'PHPExiftool\Driver\Tag\CameraIFD\LensTypeModel',
                ),
                'focallengthin35mmformat' => array(
                    'namespace' => 'CameraIFD',
                    'tagname' => 'FocalLengthIn35mmFormat',
                    'classname' => 'PHPExiftool\Driver\Tag\CameraIFD\FocalLengthIn35mmFormat',
                ),
                'highisomode' => array(
                    'namespace' => 'CameraIFD',
                    'tagname' => 'HighISOMode',
                    'classname' => 'PHPExiftool\Driver\Tag\CameraIFD\HighISOMode',
                ),
                'wb_cfa0_leveldaylight' => array(
                    'namespace' => 'CameraIFD',
                    'tagname' => 'WB_CFA0_LevelDaylight',
                    'classname' => 'PHPExiftool\Driver\Tag\CameraIFD\WBCFA0LevelDaylight',
                ),
                'wb_cfa1_leveldaylight' => array(
                    'namespace' => 'CameraIFD',
                    'tagname' => 'WB_CFA1_LevelDaylight',
                    'classname' => 'PHPExiftool\Driver\Tag\CameraIFD\WBCFA1LevelDaylight',
                ),
                'wb_cfa2_leveldaylight' => array(
                    'namespace' => 'CameraIFD',
                    'tagname' => 'WB_CFA2_LevelDaylight',
                    'classname' => 'PHPExiftool\Driver\Tag\CameraIFD\WBCFA2LevelDaylight',
                ),
                'wb_cfa3_leveldaylight' => array(
                    'namespace' => 'CameraIFD',
                    'tagname' => 'WB_CFA3_LevelDaylight',
                    'classname' => 'PHPExiftool\Driver\Tag\CameraIFD\WBCFA3LevelDaylight',
                ),
                'whitebalanceset' => array(
                    'namespace' => 'CameraIFD',
                    'tagname' => 'WhiteBalanceSet',
                    'classname' => 'PHPExiftool\Driver\Tag\CameraIFD\WhiteBalanceSet',
                ),
                'wb_redlevelauto' => array(
                    'namespace' => 'CameraIFD',
                    'tagname' => 'WB_RedLevelAuto',
                    'classname' => 'PHPExiftool\Driver\Tag\CameraIFD\WBRedLevelAuto',
                ),
                'wb_bluelevelauto' => array(
                    'namespace' => 'CameraIFD',
                    'tagname' => 'WB_BlueLevelAuto',
                    'classname' => 'PHPExiftool\Driver\Tag\CameraIFD\WBBlueLevelAuto',
                ),
                'orientation' => array(
                    'namespace' => 'CameraIFD',
                    'tagname' => 'Orientation',
                    'classname' => 'PHPExiftool\Driver\Tag\CameraIFD\Orientation',
                ),
                'whitebalancedetected' => array(
                    'namespace' => 'CameraIFD',
                    'tagname' => 'WhiteBalanceDetected',
                    'classname' => 'PHPExiftool\Driver\Tag\CameraIFD\WhiteBalanceDetected',
                ),
            ),
            'panasonicraw' => array(
                'distortionparam02' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'DistortionParam02',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\DistortionParam02',
                ),
                'distortionparam04' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'DistortionParam04',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\DistortionParam04',
                ),
                'distortionscale' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'DistortionScale',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\DistortionScale',
                ),
                'distortioncorrection' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'DistortionCorrection',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\DistortionCorrection',
                ),
                'distortionparam08' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'DistortionParam08',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\DistortionParam08',
                ),
                'distortionparam09' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'DistortionParam09',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\DistortionParam09',
                ),
                'distortionparam11' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'DistortionParam11',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\DistortionParam11',
                ),
                'distortionn' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'DistortionN',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\DistortionN',
                ),
                'numwbentries' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'NumWBEntries',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\NumWBEntries',
                ),
                'wbtype1' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'WBType1',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\WBType1',
                ),
                'wb_rblevels1' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'WB_RBLevels1',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\WBRBLevels1',
                ),
                'wbtype2' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'WBType2',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\WBType2',
                ),
                'wb_rblevels2' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'WB_RBLevels2',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\WBRBLevels2',
                ),
                'wbtype3' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'WBType3',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\WBType3',
                ),
                'wb_rblevels3' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'WB_RBLevels3',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\WBRBLevels3',
                ),
                'wbtype4' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'WBType4',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\WBType4',
                ),
                'wb_rblevels4' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'WB_RBLevels4',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\WBRBLevels4',
                ),
                'wbtype5' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'WBType5',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\WBType5',
                ),
                'wb_rblevels5' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'WB_RBLevels5',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\WBRBLevels5',
                ),
                'wbtype6' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'WBType6',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\WBType6',
                ),
                'wb_rblevels6' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'WB_RBLevels6',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\WBRBLevels6',
                ),
                'wbtype7' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'WBType7',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\WBType7',
                ),
                'wb_rblevels7' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'WB_RBLevels7',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\WBRBLevels7',
                ),
                'wb_rgblevels1' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'WB_RGBLevels1',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\WBRGBLevels1',
                ),
                'wb_rgblevels2' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'WB_RGBLevels2',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\WBRGBLevels2',
                ),
                'wb_rgblevels3' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'WB_RGBLevels3',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\WBRGBLevels3',
                ),
                'wb_rgblevels4' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'WB_RGBLevels4',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\WBRGBLevels4',
                ),
                'wb_rgblevels5' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'WB_RGBLevels5',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\WBRGBLevels5',
                ),
                'wb_rgblevels6' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'WB_RGBLevels6',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\WBRGBLevels6',
                ),
                'wb_rgblevels7' => array(
                    'namespace' => 'PanasonicRaw',
                    'tagname' => 'WB_RGBLevels7',
                    'classname' => 'PHPExiftool\Driver\Tag\PanasonicRaw\WBRGBLevels7',
                ),
            ),
            'photomechanic' => array(
                'rawcropleft' => array(
                    'namespace' => 'PhotoMechanic',
                    'tagname' => 'RawCropLeft',
                    'classname' => 'PHPExiftool\Driver\Tag\PhotoMechanic\RawCropLeft',
                ),
                'rawcroptop' => array(
                    'namespace' => 'PhotoMechanic',
                    'tagname' => 'RawCropTop',
                    'classname' => 'PHPExiftool\Driver\Tag\PhotoMechanic\RawCropTop',
                ),
                'rawcropright' => array(
                    'namespace' => 'PhotoMechanic',
                    'tagname' => 'RawCropRight',
                    'classname' => 'PHPExiftool\Driver\Tag\PhotoMechanic\RawCropRight',
                ),
                'rawcropbottom' => array(
                    'namespace' => 'PhotoMechanic',
                    'tagname' => 'RawCropBottom',
                    'classname' => 'PHPExiftool\Driver\Tag\PhotoMechanic\RawCropBottom',
                ),
                'constrainedcropwidth' => array(
                    'namespace' => 'PhotoMechanic',
                    'tagname' => 'ConstrainedCropWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\PhotoMechanic\ConstrainedCropWidth',
                ),
                'constrainedcropheight' => array(
                    'namespace' => 'PhotoMechanic',
                    'tagname' => 'ConstrainedCropHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\PhotoMechanic\ConstrainedCropHeight',
                ),
                'framenum' => array(
                    'namespace' => 'PhotoMechanic',
                    'tagname' => 'FrameNum',
                    'classname' => 'PHPExiftool\Driver\Tag\PhotoMechanic\FrameNum',
                ),
                'rotation' => array(
                    'namespace' => 'PhotoMechanic',
                    'tagname' => 'Rotation',
                    'classname' => 'PHPExiftool\Driver\Tag\PhotoMechanic\Rotation',
                ),
                'cropleft' => array(
                    'namespace' => 'PhotoMechanic',
                    'tagname' => 'CropLeft',
                    'classname' => 'PHPExiftool\Driver\Tag\PhotoMechanic\CropLeft',
                ),
                'croptop' => array(
                    'namespace' => 'PhotoMechanic',
                    'tagname' => 'CropTop',
                    'classname' => 'PHPExiftool\Driver\Tag\PhotoMechanic\CropTop',
                ),
                'cropright' => array(
                    'namespace' => 'PhotoMechanic',
                    'tagname' => 'CropRight',
                    'classname' => 'PHPExiftool\Driver\Tag\PhotoMechanic\CropRight',
                ),
                'cropbottom' => array(
                    'namespace' => 'PhotoMechanic',
                    'tagname' => 'CropBottom',
                    'classname' => 'PHPExiftool\Driver\Tag\PhotoMechanic\CropBottom',
                ),
                'tagged' => array(
                    'namespace' => 'PhotoMechanic',
                    'tagname' => 'Tagged',
                    'classname' => 'PHPExiftool\Driver\Tag\PhotoMechanic\Tagged',
                ),
                'colorclass' => array(
                    'namespace' => 'PhotoMechanic',
                    'tagname' => 'ColorClass',
                    'classname' => 'PHPExiftool\Driver\Tag\PhotoMechanic\ColorClass',
                ),
                'rating' => array(
                    'namespace' => 'PhotoMechanic',
                    'tagname' => 'Rating',
                    'classname' => 'PHPExiftool\Driver\Tag\PhotoMechanic\Rating',
                ),
                'previewcropleft' => array(
                    'namespace' => 'PhotoMechanic',
                    'tagname' => 'PreviewCropLeft',
                    'classname' => 'PHPExiftool\Driver\Tag\PhotoMechanic\PreviewCropLeft',
                ),
                'previewcroptop' => array(
                    'namespace' => 'PhotoMechanic',
                    'tagname' => 'PreviewCropTop',
                    'classname' => 'PHPExiftool\Driver\Tag\PhotoMechanic\PreviewCropTop',
                ),
                'previewcropright' => array(
                    'namespace' => 'PhotoMechanic',
                    'tagname' => 'PreviewCropRight',
                    'classname' => 'PHPExiftool\Driver\Tag\PhotoMechanic\PreviewCropRight',
                ),
                'previewcropbottom' => array(
                    'namespace' => 'PhotoMechanic',
                    'tagname' => 'PreviewCropBottom',
                    'classname' => 'PHPExiftool\Driver\Tag\PhotoMechanic\PreviewCropBottom',
                ),
            ),
            'xmp-photomech' => array(
                'colorclass' => array(
                    'namespace' => 'XMP-photomech',
                    'tagname' => 'ColorClass',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPhotomech\ColorClass',
                ),
                'countrycode' => array(
                    'namespace' => 'XMP-photomech',
                    'tagname' => 'CountryCode',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPhotomech\CountryCode',
                ),
                'editstatus' => array(
                    'namespace' => 'XMP-photomech',
                    'tagname' => 'EditStatus',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPhotomech\EditStatus',
                ),
                'pmversion' => array(
                    'namespace' => 'XMP-photomech',
                    'tagname' => 'PMVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPhotomech\PMVersion',
                ),
                'prefs' => array(
                    'namespace' => 'XMP-photomech',
                    'tagname' => 'Prefs',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPhotomech\Prefs',
                ),
                'tagged' => array(
                    'namespace' => 'XMP-photomech',
                    'tagname' => 'Tagged',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPhotomech\Tagged',
                ),
                'timecreated' => array(
                    'namespace' => 'XMP-photomech',
                    'tagname' => 'TimeCreated',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPhotomech\TimeCreated',
                ),
            ),
            
            'makernotes' => array(
                'previewimagewidth' => array(
                    'namespace' => 'MakerNotes',
                    'tagname' => 'PreviewImageWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\MakerNotes\PreviewImageWidth',
                ),
                'previewimageheight' => array(
                    'namespace' => 'MakerNotes',
                    'tagname' => 'PreviewImageHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\MakerNotes\PreviewImageHeight',
                ),
                'previewimagelength' => array(
                    'namespace' => 'MakerNotes',
                    'tagname' => 'PreviewImageLength',
                    'classname' => 'PHPExiftool\Driver\Tag\MakerNotes\PreviewImageLength',
                ),
                'serialnumber' => array(
                    'namespace' => 'MakerNotes',
                    'tagname' => 'SerialNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\MakerNotes\SerialNumber',
                ),
                'previewimage' => array(
                    'namespace' => 'MakerNotes',
                    'tagname' => 'PreviewImage',
                    'classname' => 'PHPExiftool\Driver\Tag\MakerNotes\PreviewImage',
                ),
                'model' => array(
                    'namespace' => 'MakerNotes',
                    'tagname' => 'Model',
                    'classname' => 'PHPExiftool\Driver\Tag\MakerNotes\Model',
                ),
                'firmware' => array(
                    'namespace' => 'MakerNotes',
                    'tagname' => 'Firmware',
                    'classname' => 'PHPExiftool\Driver\Tag\MakerNotes\Firmware',
                ),
                'parameters' => array(
                    'namespace' => 'MakerNotes',
                    'tagname' => 'Parameters',
                    'classname' => 'PHPExiftool\Driver\Tag\MakerNotes\Parameters',
                ),
            ),
            'itemlist' => array(
                'parentshorttitle' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'ParentShortTitle',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\ParentShortTitle',
                ),
                'parentproductid' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'ParentProductID',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\ParentProductID',
                ),
                'parenttitle' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'ParentTitle',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\ParentTitle',
                ),
                'shorttitle' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'ShortTitle',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\ShortTitle',
                ),
                'unknown_aacr' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'Unknown_AACR',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\UnknownAACR',
                ),
                'unknown_cdek' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'Unknown_CDEK',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\UnknownCDEK',
                ),
                'unknown_cdet' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'Unknown_CDET',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\UnknownCDET',
                ),
                'guid' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'GUID',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\GUID',
                ),
                'productversion' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'ProductVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\ProductVersion',
                ),
                'albumartist' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'AlbumArtist',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\AlbumArtist',
                ),
                'applestoreaccounttype' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'AppleStoreAccountType',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\AppleStoreAccountType',
                ),
                'album' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'Album',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\Album',
                ),
                'applestoreaccount' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'AppleStoreAccount',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\AppleStoreAccount',
                ),
                'albumtitleid' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'AlbumTitleID',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\AlbumTitleID',
                ),
                'author' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'Author',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\Author',
                ),
                'category' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'Category',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\Category',
                ),
                'applestorecatalogid' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'AppleStoreCatalogID',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\AppleStoreCatalogID',
                ),
                'coverart' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'CoverArt',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\CoverArt',
                ),
                'compilation' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'Compilation',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\Compilation',
                ),
                'copyright' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'Copyright',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\Copyright',
                ),
                'description' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'Description',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\Description',
                ),
                'disknumber' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'DiskNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\DiskNumber',
                ),
                'episodeglobaluniqueid' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'EpisodeGlobalUniqueID',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\EpisodeGlobalUniqueID',
                ),
                'genreid' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'GenreID',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\GenreID',
                ),
                'genre' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'Genre',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\Genre',
                ),
                'grouping' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'Grouping',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\Grouping',
                ),
                'googlehostheader' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'GoogleHostHeader',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\GoogleHostHeader',
                ),
                'googlepingmessage' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'GooglePingMessage',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\GooglePingMessage',
                ),
                'googlepingurl' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'GooglePingURL',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\GooglePingURL',
                ),
                'googlesourcedata' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'GoogleSourceData',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\GoogleSourceData',
                ),
                'googlestarttime' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'GoogleStartTime',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\GoogleStartTime',
                ),
                'googletrackduration' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'GoogleTrackDuration',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\GoogleTrackDuration',
                ),
                'hdvideo' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'HDVideo',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\HDVideo',
                ),
                'itunesu' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'iTunesU',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\ITunesU',
                ),
                'keyword' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'Keyword',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\Keyword',
                ),
                'longdescription' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'LongDescription',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\LongDescription',
                ),
                'podcast' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'Podcast',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\Podcast',
                ),
                'performer' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'Performer',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\Performer',
                ),
                'playgap' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'PlayGap',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\PlayGap',
                ),
                'playlistid' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'PlayListID',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\PlayListID',
                ),
                'productid' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'ProductID',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\ProductID',
                ),
                'purchasedate' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'PurchaseDate',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\PurchaseDate',
                ),
                'podcasturl' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'PodcastURL',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\PodcastURL',
                ),
                'ratingpercent' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'RatingPercent',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\RatingPercent',
                ),
                'releasedate' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'ReleaseDate',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\ReleaseDate',
                ),
                'rating' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'Rating',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\Rating',
                ),
                'applestorecountry' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'AppleStoreCountry',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\AppleStoreCountry',
                ),
                'sortalbumartist' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'SortAlbumArtist',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\SortAlbumArtist',
                ),
                'sortalbum' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'SortAlbum',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\SortAlbum',
                ),
                'sortartist' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'SortArtist',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\SortArtist',
                ),
                'sortcomposer' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'SortComposer',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\SortComposer',
                ),
                'sortname' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'SortName',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\SortName',
                ),
                'sortshow' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'SortShow',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\SortShow',
                ),
                'mediatype' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'MediaType',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\MediaType',
                ),
                'title' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'Title',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\Title',
                ),
                'beatsperminute' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'BeatsPerMinute',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\BeatsPerMinute',
                ),
                'tracknumber' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'TrackNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\TrackNumber',
                ),
                'tvepisodeid' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'TVEpisodeID',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\TVEpisodeID',
                ),
                'tvepisode' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'TVEpisode',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\TVEpisode',
                ),
                'tvnetworkname' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'TVNetworkName',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\TVNetworkName',
                ),
                'tvshow' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'TVShow',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\TVShow',
                ),
                'tvseason' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'TVSeason',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\TVSeason',
                ),
                'year' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'Year',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\Year',
                ),
                'artist' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'Artist',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\Artist',
                ),
                'comment' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'Comment',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\Comment',
                ),
                'composer' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'Composer',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\Composer',
                ),
                'contentcreatedate' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'ContentCreateDate',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\ContentCreateDate',
                ),
                'encodedby' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'EncodedBy',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\EncodedBy',
                ),
                'lyrics' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'Lyrics',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\Lyrics',
                ),
                'narrator' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'Narrator',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\Narrator',
                ),
                'publisher' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'Publisher',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\Publisher',
                ),
                'encoder' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'Encoder',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\Encoder',
                ),
                'track' => array(
                    'namespace' => 'ItemList',
                    'tagname' => 'Track',
                    'classname' => 'PHPExiftool\Driver\Tag\ItemList\Track',
                ),
            ),
            'keys' => array(
                'encodedwith' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'EncodedWith',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\EncodedWith',
                ),
                'album' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'Album',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\Album',
                ),
                'artist' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'Artist',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\Artist',
                ),
                'artwork' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'Artwork',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\Artwork',
                ),
                'author' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'Author',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\Author',
                ),
                'framereadouttime' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'FrameReadoutTime',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\FrameReadoutTime',
                ),
                'cameraidentifier' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'CameraIdentifier',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\CameraIdentifier',
                ),
                'usercollection' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'UserCollection',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\UserCollection',
                ),
                'androidversion' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'AndroidVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\AndroidVersion',
                ),
                'capturemode' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'CaptureMode',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\CaptureMode',
                ),
                'comment' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'Comment',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\Comment',
                ),
                'copyright' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'Copyright',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\Copyright',
                ),
                'creationdate' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'CreationDate',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\CreationDate',
                ),
                'description' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'Description',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\Description',
                ),
                'detectedfacebounds' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'DetectedFaceBounds',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\DetectedFaceBounds',
                ),
                'detectedfaceid' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'DetectedFaceID',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\DetectedFaceID',
                ),
                'detectedfacerollangle' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'DetectedFaceRollAngle',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\DetectedFaceRollAngle',
                ),
                'detectedfaceyawangle' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'DetectedFaceYawAngle',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\DetectedFaceYawAngle',
                ),
                'cameradirection' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'CameraDirection',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\CameraDirection',
                ),
                'cameramotion' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'CameraMotion',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\CameraMotion',
                ),
                'director' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'Director',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\Director',
                ),
                'displayname' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'DisplayName',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\DisplayName',
                ),
                'genre' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'Genre',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\Genre',
                ),
                'information' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'Information',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\Information',
                ),
                'keywords' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'Keywords',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\Keywords',
                ),
                'livephotoinfo' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'LivePhotoInfo',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\LivePhotoInfo',
                ),
                'gpscoordinates' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'GPSCoordinates',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\GPSCoordinates',
                ),
                'locationbody' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'LocationBody',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\LocationBody',
                ),
                'locationdate' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'LocationDate',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\LocationDate',
                ),
                'locationname' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'LocationName',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\LocationName',
                ),
                'locationnote' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'LocationNote',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\LocationNote',
                ),
                'locationrole' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'LocationRole',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\LocationRole',
                ),
                'make' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'Make',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\Make',
                ),
                'model' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'Model',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\Model',
                ),
                'balance' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'Balance',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\Balance',
                ),
                'bass' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'Bass',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\Bass',
                ),
                'audiogain' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'AudioGain',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\AudioGain',
                ),
                'mute' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'Mute',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\Mute',
                ),
                'pitchshift' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'PitchShift',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\PitchShift',
                ),
                'trebel' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'Trebel',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\Trebel',
                ),
                'brightness' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'Brightness',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\Brightness',
                ),
                'color' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'Color',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\Color',
                ),
                'contrast' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'Contrast',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\Contrast',
                ),
                'tint' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'Tint',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\Tint',
                ),
                'playerversion' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'PlayerVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\PlayerVersion',
                ),
                'producer' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'Producer',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\Producer',
                ),
                'publisher' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'Publisher',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\Publisher',
                ),
                'userrating' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'UserRating',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\UserRating',
                ),
                'software' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'Software',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\Software',
                ),
                'stillimagetime' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'StillImageTime',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\StillImageTime',
                ),
                'title' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'Title',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\Title',
                ),
                'version' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'Version',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\Version',
                ),
                'videoorientation' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'VideoOrientation',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\VideoOrientation',
                ),
                'year' => array(
                    'namespace' => 'Keys',
                    'tagname' => 'Year',
                    'classname' => 'PHPExiftool\Driver\Tag\Keys\Year',
                ),
            ),
            'track#' => array(
                'mediaheaderversion' => array(
                    'namespace' => 'Track#',
                    'tagname' => 'MediaHeaderVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\Track\MediaHeaderVersion',
                ),
                'mediacreatedate' => array(
                    'namespace' => 'Track#',
                    'tagname' => 'MediaCreateDate',
                    'classname' => 'PHPExiftool\Driver\Tag\Track\MediaCreateDate',
                ),
                'mediamodifydate' => array(
                    'namespace' => 'Track#',
                    'tagname' => 'MediaModifyDate',
                    'classname' => 'PHPExiftool\Driver\Tag\Track\MediaModifyDate',
                ),
                'mediatimescale' => array(
                    'namespace' => 'Track#',
                    'tagname' => 'MediaTimeScale',
                    'classname' => 'PHPExiftool\Driver\Tag\Track\MediaTimeScale',
                ),
                'mediaduration' => array(
                    'namespace' => 'Track#',
                    'tagname' => 'MediaDuration',
                    'classname' => 'PHPExiftool\Driver\Tag\Track\MediaDuration',
                ),
                'medialanguagecode' => array(
                    'namespace' => 'Track#',
                    'tagname' => 'MediaLanguageCode',
                    'classname' => 'PHPExiftool\Driver\Tag\Track\MediaLanguageCode',
                ),
                'nullmediaheader' => array(
                    'namespace' => 'Track#',
                    'tagname' => 'NullMediaHeader',
                    'classname' => 'PHPExiftool\Driver\Tag\Track\NullMediaHeader',
                ),
                'uuid-unknown' => array(
                    'namespace' => 'Track#',
                    'tagname' => 'UUID-Unknown',
                    'classname' => 'PHPExiftool\Driver\Tag\Track\UUIDUnknown',
                ),
                'cleanaperturedimensions' => array(
                    'namespace' => 'Track#',
                    'tagname' => 'CleanApertureDimensions',
                    'classname' => 'PHPExiftool\Driver\Tag\Track\CleanApertureDimensions',
                ),
                'encodedpixelsdimensions' => array(
                    'namespace' => 'Track#',
                    'tagname' => 'EncodedPixelsDimensions',
                    'classname' => 'PHPExiftool\Driver\Tag\Track\EncodedPixelsDimensions',
                ),
                'productionaperturedimensions' => array(
                    'namespace' => 'Track#',
                    'tagname' => 'ProductionApertureDimensions',
                    'classname' => 'PHPExiftool\Driver\Tag\Track\ProductionApertureDimensions',
                ),
                'trackheaderversion' => array(
                    'namespace' => 'Track#',
                    'tagname' => 'TrackHeaderVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\Track\TrackHeaderVersion',
                ),
                'trackcreatedate' => array(
                    'namespace' => 'Track#',
                    'tagname' => 'TrackCreateDate',
                    'classname' => 'PHPExiftool\Driver\Tag\Track\TrackCreateDate',
                ),
                'trackmodifydate' => array(
                    'namespace' => 'Track#',
                    'tagname' => 'TrackModifyDate',
                    'classname' => 'PHPExiftool\Driver\Tag\Track\TrackModifyDate',
                ),
                'trackid' => array(
                    'namespace' => 'Track#',
                    'tagname' => 'TrackID',
                    'classname' => 'PHPExiftool\Driver\Tag\Track\TrackID',
                ),
                'trackduration' => array(
                    'namespace' => 'Track#',
                    'tagname' => 'TrackDuration',
                    'classname' => 'PHPExiftool\Driver\Tag\Track\TrackDuration',
                ),
                'imagesizelookahead' => array(
                    'namespace' => 'Track#',
                    'tagname' => 'ImageSizeLookahead',
                    'classname' => 'PHPExiftool\Driver\Tag\Track\ImageSizeLookahead',
                ),
                'tracklayer' => array(
                    'namespace' => 'Track#',
                    'tagname' => 'TrackLayer',
                    'classname' => 'PHPExiftool\Driver\Tag\Track\TrackLayer',
                ),
                'trackvolume' => array(
                    'namespace' => 'Track#',
                    'tagname' => 'TrackVolume',
                    'classname' => 'PHPExiftool\Driver\Tag\Track\TrackVolume',
                ),
                'matrixstructure' => array(
                    'namespace' => 'Track#',
                    'tagname' => 'MatrixStructure',
                    'classname' => 'PHPExiftool\Driver\Tag\Track\MatrixStructure',
                ),
                'imagewidth' => array(
                    'namespace' => 'Track#',
                    'tagname' => 'ImageWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\Track\ImageWidth',
                ),
                'imageheight' => array(
                    'namespace' => 'Track#',
                    'tagname' => 'ImageHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\Track\ImageHeight',
                ),
                'contentdescribes' => array(
                    'namespace' => 'Track#',
                    'tagname' => 'ContentDescribes',
                    'classname' => 'PHPExiftool\Driver\Tag\Track\ContentDescribes',
                ),
                'chapterlisttrackid' => array(
                    'namespace' => 'Track#',
                    'tagname' => 'ChapterListTrackID',
                    'classname' => 'PHPExiftool\Driver\Tag\Track\ChapterListTrackID',
                ),
                'elementarystreamtrack' => array(
                    'namespace' => 'Track#',
                    'tagname' => 'ElementaryStreamTrack',
                    'classname' => 'PHPExiftool\Driver\Tag\Track\ElementaryStreamTrack',
                ),
                'timecode' => array(
                    'namespace' => 'Track#',
                    'tagname' => 'TimeCode',
                    'classname' => 'PHPExiftool\Driver\Tag\Track\TimeCode',
                ),
            ),
            'meta' => array(
                'binaryxml' => array(
                    'namespace' => 'Meta',
                    'tagname' => 'BinaryXML',
                    'classname' => 'PHPExiftool\Driver\Tag\Meta\BinaryXML',
                ),
                'free' => array(
                    'namespace' => 'Meta',
                    'tagname' => 'Free',
                    'classname' => 'PHPExiftool\Driver\Tag\Meta\Free',
                ),
                'itemlocation' => array(
                    'namespace' => 'Meta',
                    'tagname' => 'ItemLocation',
                    'classname' => 'PHPExiftool\Driver\Tag\Meta\ItemLocation',
                ),
                'ipmpcontrol' => array(
                    'namespace' => 'Meta',
                    'tagname' => 'IPMPControl',
                    'classname' => 'PHPExiftool\Driver\Tag\Meta\IPMPControl',
                ),
                'itemprotection' => array(
                    'namespace' => 'Meta',
                    'tagname' => 'ItemProtection',
                    'classname' => 'PHPExiftool\Driver\Tag\Meta\ItemProtection',
                ),
                'primaryitemreference' => array(
                    'namespace' => 'Meta',
                    'tagname' => 'PrimaryItemReference',
                    'classname' => 'PHPExiftool\Driver\Tag\Meta\PrimaryItemReference',
                ),
            ),
            'userdata' => array(
                'playallframes' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'PlayAllFrames',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\PlayAllFrames',
                ),
                'serialnumberhash' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'SerialNumberHash',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\SerialNumberHash',
                ),
                'compressorversion' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'CompressorVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\CompressorVersion',
                ),
                'firmwareversion' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'FirmwareVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\FirmwareVersion',
                ),
                'model' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Model',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Model',
                ),
                'fieldofview' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'FieldOfView',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\FieldOfView',
                ),
                'goprotype' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'GoProType',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\GoProType',
                ),
                'lensserialnumber' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'LensSerialNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\LensSerialNumber',
                ),
                'loopstyle' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'LoopStyle',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\LoopStyle',
                ),
                'levelmeter' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'LevelMeter',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\LevelMeter',
                ),
                'makernotepentaxunknown' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'MakerNotePentaxUnknown',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\MakerNotePentaxUnknown',
                ),
                'previewimage' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'PreviewImage',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\PreviewImage',
                ),
                'playmode' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'PlayMode',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\PlayMode',
                ),
                'serialnumber' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'SerialNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\SerialNumber',
                ),
                'playselection' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'PlaySelection',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\PlaySelection',
                ),
                'unknowntags' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'UnknownTags',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\UnknownTags',
                ),
                'windowlocation' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'WindowLocation',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\WindowLocation',
                ),
                'cx' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'CX',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\CX',
                ),
                'cy' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'CY',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\CY',
                ),
                'yaw' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Yaw',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Yaw',
                ),
                'unknown_adzc' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Unknown_adzc',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\UnknownAdzc',
                ),
                'unknown_adze' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Unknown_adze',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\UnknownAdze',
                ),
                'unknown_adzm' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Unknown_adzm',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\UnknownAdzm',
                ),
                'album' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Album',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Album',
                ),
                'albumartist' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'AlbumArtist',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\AlbumArtist',
                ),
                'cameraangle' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'CameraAngle',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\CameraAngle',
                ),
                'aperturemode' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'ApertureMode',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\ApertureMode',
                ),
                'author' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Author',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Author',
                ),
                'contentid' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'ContentID',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\ContentID',
                ),
                'contentdistributorid' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'ContentDistributorID',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\ContentDistributorID',
                ),
                'chapterlist' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'ChapterList',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\ChapterList',
                ),
                'clipfilename' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'ClipFileName',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\ClipFileName',
                ),
                'clipid' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'ClipID',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\ClipID',
                ),
                'classification' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Classification',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Classification',
                ),
                'cameraid' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'CameraID',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\CameraID',
                ),
                'collectionname' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'CollectionName',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\CollectionName',
                ),
                'copyright' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Copyright',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Copyright',
                ),
                'codeversion' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'CodeVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\CodeVersion',
                ),
                'coveruri' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'CoverURI',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\CoverURI',
                ),
                'datetimeoriginal' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'DateTimeOriginal',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\DateTimeOriginal',
                ),
                'description' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Description',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Description',
                ),
                'genre' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Genre',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Genre',
                ),
                'hintversion' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'HintVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\HintVersion',
                ),
                'iconuri' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'IconURI',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\IconURI',
                ),
                'infourl' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'InfoURL',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\InfoURL',
                ),
                'tracktype' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'TrackType',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\TrackType',
                ),
                'keywords' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Keywords',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Keywords',
                ),
                'locationinformation' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'LocationInformation',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\LocationInformation',
                ),
                'lyricsuri' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'LyricsURI',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\LyricsURI',
                ),
                'make' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Make',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Make',
                ),
                'name' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Name',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Name',
                ),
                'performer' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Performer',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Performer',
                ),
                'pitch' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Pitch',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Pitch',
                ),
                'rads' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Rads',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Rads',
                ),
                'reelname' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'ReelName',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\ReelName',
                ),
                'roll' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Roll',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Roll',
                ),
                'rating' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Rating',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Rating',
                ),
                'scene' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Scene',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Scene',
                ),
                'shotname' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'ShotName',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\ShotName',
                ),
                'thumbnailimage' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'ThumbnailImage',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\ThumbnailImage',
                ),
                'thumbnailpng' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'ThumbnailPNG',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\ThumbnailPNG',
                ),
                'unknownthumbnail' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'UnknownThumbnail',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\UnknownThumbnail',
                ),
                'title' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Title',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Title',
                ),
                'userrating' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'UserRating',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\UserRating',
                ),
                'vendor' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Vendor',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Vendor',
                ),
                'year' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Year',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Year',
                ),
                'artist' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Artist',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Artist',
                ),
                'starttimecode' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'StartTimecode',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\StartTimecode',
                ),
                'starttimescale' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'StartTimeScale',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\StartTimeScale',
                ),
                'starttimesamplesize' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'StartTimeSampleSize',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\StartTimeSampleSize',
                ),
                'arranger' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Arranger',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Arranger',
                ),
                'arrangerkeywords' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'ArrangerKeywords',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\ArrangerKeywords',
                ),
                'comment' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Comment',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Comment',
                ),
                'composerkeywords' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'ComposerKeywords',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\ComposerKeywords',
                ),
                'composer' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Composer',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Composer',
                ),
                'contentcreatedate' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'ContentCreateDate',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\ContentCreateDate',
                ),
                'director' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Director',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Director',
                ),
                'userdata_dji' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'UserData_dji',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\UserDataDji',
                ),
                'edit1' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Edit1',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Edit1',
                ),
                'edit2' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Edit2',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Edit2',
                ),
                'edit3' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Edit3',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Edit3',
                ),
                'edit4' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Edit4',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Edit4',
                ),
                'edit5' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Edit5',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Edit5',
                ),
                'edit6' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Edit6',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Edit6',
                ),
                'edit7' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Edit7',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Edit7',
                ),
                'edit8' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Edit8',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Edit8',
                ),
                'edit9' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Edit9',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Edit9',
                ),
                'encoderid' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'EncoderID',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\EncoderID',
                ),
                'format' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Format',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Format',
                ),
                'camerapitch' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'CameraPitch',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\CameraPitch',
                ),
                'cameraroll' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'CameraRoll',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\CameraRoll',
                ),
                'grouping' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Grouping',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Grouping',
                ),
                'camerayaw' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'CameraYaw',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\CameraYaw',
                ),
                'information' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Information',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Information',
                ),
                'isrccode' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'ISRCCode',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\ISRCCode',
                ),
                'recordlabelname' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'RecordLabelName',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\RecordLabelName',
                ),
                'recordlabelurl' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'RecordLabelURL',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\RecordLabelURL',
                ),
                'lyrics' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Lyrics',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Lyrics',
                ),
                'makerurl' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'MakerURL',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\MakerURL',
                ),
                'producerkeywords' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'ProducerKeywords',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\ProducerKeywords',
                ),
                'recordingcopyright' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'RecordingCopyright',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\RecordingCopyright',
                ),
                'producer' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Producer',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Producer',
                ),
                'performers' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Performers',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Performers',
                ),
                'performerkeywords' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'PerformerKeywords',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\PerformerKeywords',
                ),
                'performerurl' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'PerformerURL',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\PerformerURL',
                ),
                'requirements' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Requirements',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Requirements',
                ),
                'userdata_res' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'UserData_res',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\UserDataRes',
                ),
                'subtitlekeywords' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'SubtitleKeywords',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\SubtitleKeywords',
                ),
                'subtitle' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Subtitle',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Subtitle',
                ),
                'sourcecredits' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'SourceCredits',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\SourceCredits',
                ),
                'songwriter' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'SongWriter',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\SongWriter',
                ),
                'songwriterkeywords' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'SongWriterKeywords',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\SongWriterKeywords',
                ),
                'softwareversion' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'SoftwareVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\SoftwareVersion',
                ),
                'encoder' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Encoder',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Encoder',
                ),
                'track' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'Track',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\Track',
                ),
                'userdata_uid' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'UserData_uid',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\UserDataUid',
                ),
                'speedx' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'SpeedX',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\SpeedX',
                ),
                'gpscoordinates' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'GPSCoordinates',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\GPSCoordinates',
                ),
                'speedy' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'SpeedY',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\SpeedY',
                ),
                'speedz' => array(
                    'namespace' => 'UserData',
                    'tagname' => 'SpeedZ',
                    'classname' => 'PHPExiftool\Driver\Tag\UserData\SpeedZ',
                ),
            ),
           
            'real' => array(
                'text' => array(
                    'namespace' => 'Real',
                    'tagname' => 'Text',
                    'classname' => 'PHPExiftool\Driver\Tag\Real\Text',
                ),
                'url' => array(
                    'namespace' => 'Real',
                    'tagname' => 'URL',
                    'classname' => 'PHPExiftool\Driver\Tag\Real\URL',
                ),
            ),
            'real-prop' => array(
                'maxbitrate' => array(
                    'namespace' => 'Real-PROP',
                    'tagname' => 'MaxBitrate',
                    'classname' => 'PHPExiftool\Driver\Tag\RealPROP\MaxBitrate',
                ),
                'avgbitrate' => array(
                    'namespace' => 'Real-PROP',
                    'tagname' => 'AvgBitrate',
                    'classname' => 'PHPExiftool\Driver\Tag\RealPROP\AvgBitrate',
                ),
                'maxpacketsize' => array(
                    'namespace' => 'Real-PROP',
                    'tagname' => 'MaxPacketSize',
                    'classname' => 'PHPExiftool\Driver\Tag\RealPROP\MaxPacketSize',
                ),
                'avgpacketsize' => array(
                    'namespace' => 'Real-PROP',
                    'tagname' => 'AvgPacketSize',
                    'classname' => 'PHPExiftool\Driver\Tag\RealPROP\AvgPacketSize',
                ),
                'numpackets' => array(
                    'namespace' => 'Real-PROP',
                    'tagname' => 'NumPackets',
                    'classname' => 'PHPExiftool\Driver\Tag\RealPROP\NumPackets',
                ),
                'duration' => array(
                    'namespace' => 'Real-PROP',
                    'tagname' => 'Duration',
                    'classname' => 'PHPExiftool\Driver\Tag\RealPROP\Duration',
                ),
                'preroll' => array(
                    'namespace' => 'Real-PROP',
                    'tagname' => 'Preroll',
                    'classname' => 'PHPExiftool\Driver\Tag\RealPROP\Preroll',
                ),
                'indexoffset' => array(
                    'namespace' => 'Real-PROP',
                    'tagname' => 'IndexOffset',
                    'classname' => 'PHPExiftool\Driver\Tag\RealPROP\IndexOffset',
                ),
                'dataoffset' => array(
                    'namespace' => 'Real-PROP',
                    'tagname' => 'DataOffset',
                    'classname' => 'PHPExiftool\Driver\Tag\RealPROP\DataOffset',
                ),
                'numstreams' => array(
                    'namespace' => 'Real-PROP',
                    'tagname' => 'NumStreams',
                    'classname' => 'PHPExiftool\Driver\Tag\RealPROP\NumStreams',
                ),
                'flags' => array(
                    'namespace' => 'Real-PROP',
                    'tagname' => 'Flags',
                    'classname' => 'PHPExiftool\Driver\Tag\RealPROP\Flags',
                ),
            ),
            
            'xmp-album' => array(
                'notes' => array(
                    'namespace' => 'XMP-album',
                    'tagname' => 'Notes',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAlbum\Notes',
                ),
            ),
            'xmp-dicom' => array(
                'equipmentinstitution' => array(
                    'namespace' => 'XMP-DICOM',
                    'tagname' => 'EquipmentInstitution',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDICOM\EquipmentInstitution',
                ),
                'equipmentmanufacturer' => array(
                    'namespace' => 'XMP-DICOM',
                    'tagname' => 'EquipmentManufacturer',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDICOM\EquipmentManufacturer',
                ),
                'patientbirthdate' => array(
                    'namespace' => 'XMP-DICOM',
                    'tagname' => 'PatientBirthDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDICOM\PatientBirthDate',
                ),
                'patientid' => array(
                    'namespace' => 'XMP-DICOM',
                    'tagname' => 'PatientID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDICOM\PatientID',
                ),
                'patientname' => array(
                    'namespace' => 'XMP-DICOM',
                    'tagname' => 'PatientName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDICOM\PatientName',
                ),
                'patientsex' => array(
                    'namespace' => 'XMP-DICOM',
                    'tagname' => 'PatientSex',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDICOM\PatientSex',
                ),
                'seriesdatetime' => array(
                    'namespace' => 'XMP-DICOM',
                    'tagname' => 'SeriesDateTime',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDICOM\SeriesDateTime',
                ),
                'seriesdescription' => array(
                    'namespace' => 'XMP-DICOM',
                    'tagname' => 'SeriesDescription',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDICOM\SeriesDescription',
                ),
                'seriesmodality' => array(
                    'namespace' => 'XMP-DICOM',
                    'tagname' => 'SeriesModality',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDICOM\SeriesModality',
                ),
                'seriesnumber' => array(
                    'namespace' => 'XMP-DICOM',
                    'tagname' => 'SeriesNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDICOM\SeriesNumber',
                ),
                'studydatetime' => array(
                    'namespace' => 'XMP-DICOM',
                    'tagname' => 'StudyDateTime',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDICOM\StudyDateTime',
                ),
                'studydescription' => array(
                    'namespace' => 'XMP-DICOM',
                    'tagname' => 'StudyDescription',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDICOM\StudyDescription',
                ),
                'studyid' => array(
                    'namespace' => 'XMP-DICOM',
                    'tagname' => 'StudyID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDICOM\StudyID',
                ),
                'studyphysician' => array(
                    'namespace' => 'XMP-DICOM',
                    'tagname' => 'StudyPhysician',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDICOM\StudyPhysician',
                ),
            ),
            'xmp-expressionmedia' => array(
                'catalogsets' => array(
                    'namespace' => 'XMP-expressionmedia',
                    'tagname' => 'CatalogSets',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPExpressionmedia\CatalogSets',
                ),
                'event' => array(
                    'namespace' => 'XMP-expressionmedia',
                    'tagname' => 'Event',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPExpressionmedia\Event',
                ),
                'people' => array(
                    'namespace' => 'XMP-expressionmedia',
                    'tagname' => 'People',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPExpressionmedia\People',
                ),
                'status' => array(
                    'namespace' => 'XMP-expressionmedia',
                    'tagname' => 'Status',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPExpressionmedia\Status',
                ),
            ),
            'xmp-gaudio' => array(
                'audiodata' => array(
                    'namespace' => 'XMP-GAudio',
                    'tagname' => 'AudioData',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGAudio\AudioData',
                ),
                'audiomimetype' => array(
                    'namespace' => 'XMP-GAudio',
                    'tagname' => 'AudioMimeType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGAudio\AudioMimeType',
                ),
            ),
            'xmp-gcamera' => array(
                'burstid' => array(
                    'namespace' => 'XMP-GCamera',
                    'tagname' => 'BurstID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGCamera\BurstID',
                ),
                'burstprimary' => array(
                    'namespace' => 'XMP-GCamera',
                    'tagname' => 'BurstPrimary',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGCamera\BurstPrimary',
                ),
                'disableautocreation' => array(
                    'namespace' => 'XMP-GCamera',
                    'tagname' => 'DisableAutoCreation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGCamera\DisableAutoCreation',
                ),
                'hdrpmakernote' => array(
                    'namespace' => 'XMP-GCamera',
                    'tagname' => 'HDRPMakerNote',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGCamera\HDRPMakerNote',
                ),
                'portraitnote' => array(
                    'namespace' => 'XMP-GCamera',
                    'tagname' => 'PortraitNote',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGCamera\PortraitNote',
                ),
                'portraitrequest' => array(
                    'namespace' => 'XMP-GCamera',
                    'tagname' => 'PortraitRequest',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGCamera\PortraitRequest',
                ),
                'portraitversion' => array(
                    'namespace' => 'XMP-GCamera',
                    'tagname' => 'PortraitVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGCamera\PortraitVersion',
                ),
                'specialtypeid' => array(
                    'namespace' => 'XMP-GCamera',
                    'tagname' => 'SpecialTypeID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGCamera\SpecialTypeID',
                ),
            ),
            'xmp-gcreations' => array(
                'cameraburstid' => array(
                    'namespace' => 'XMP-GCreations',
                    'tagname' => 'CameraBurstID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGCreations\CameraBurstID',
                ),
            ),
            'xmp-gdepth' => array(
                'confidence' => array(
                    'namespace' => 'XMP-GDepth',
                    'tagname' => 'Confidence',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGDepth\Confidence',
                ),
                'confidencemime' => array(
                    'namespace' => 'XMP-GDepth',
                    'tagname' => 'ConfidenceMime',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGDepth\ConfidenceMime',
                ),
                'depthimage' => array(
                    'namespace' => 'XMP-GDepth',
                    'tagname' => 'DepthImage',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGDepth\DepthImage',
                ),
                'far' => array(
                    'namespace' => 'XMP-GDepth',
                    'tagname' => 'Far',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGDepth\Far',
                ),
                'format' => array(
                    'namespace' => 'XMP-GDepth',
                    'tagname' => 'Format',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGDepth\Format',
                ),
                'imageheight' => array(
                    'namespace' => 'XMP-GDepth',
                    'tagname' => 'ImageHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGDepth\ImageHeight',
                ),
                'imagewidth' => array(
                    'namespace' => 'XMP-GDepth',
                    'tagname' => 'ImageWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGDepth\ImageWidth',
                ),
                'manufacturer' => array(
                    'namespace' => 'XMP-GDepth',
                    'tagname' => 'Manufacturer',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGDepth\Manufacturer',
                ),
                'measuretype' => array(
                    'namespace' => 'XMP-GDepth',
                    'tagname' => 'MeasureType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGDepth\MeasureType',
                ),
                'mime' => array(
                    'namespace' => 'XMP-GDepth',
                    'tagname' => 'Mime',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGDepth\Mime',
                ),
                'model' => array(
                    'namespace' => 'XMP-GDepth',
                    'tagname' => 'Model',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGDepth\Model',
                ),
                'near' => array(
                    'namespace' => 'XMP-GDepth',
                    'tagname' => 'Near',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGDepth\Near',
                ),
                'software' => array(
                    'namespace' => 'XMP-GDepth',
                    'tagname' => 'Software',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGDepth\Software',
                ),
                'units' => array(
                    'namespace' => 'XMP-GDepth',
                    'tagname' => 'Units',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGDepth\Units',
                ),
            ),
            'xmp-gfocus' => array(
                'bluratinfinity' => array(
                    'namespace' => 'XMP-GFocus',
                    'tagname' => 'BlurAtInfinity',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGFocus\BlurAtInfinity',
                ),
                'focaldistance' => array(
                    'namespace' => 'XMP-GFocus',
                    'tagname' => 'FocalDistance',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGFocus\FocalDistance',
                ),
                'focalpointx' => array(
                    'namespace' => 'XMP-GFocus',
                    'tagname' => 'FocalPointX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGFocus\FocalPointX',
                ),
                'focalpointy' => array(
                    'namespace' => 'XMP-GFocus',
                    'tagname' => 'FocalPointY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGFocus\FocalPointY',
                ),
            ),
            'xmp-gimage' => array(
                'imagedata' => array(
                    'namespace' => 'XMP-GImage',
                    'tagname' => 'ImageData',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGImage\ImageData',
                ),
                'imagemimetype' => array(
                    'namespace' => 'XMP-GImage',
                    'tagname' => 'ImageMimeType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGImage\ImageMimeType',
                ),
            ),
            'xmp-gpano' => array(
                'capturesoftware' => array(
                    'namespace' => 'XMP-GPano',
                    'tagname' => 'CaptureSoftware',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGPano\CaptureSoftware',
                ),
                'croppedareaimageheightpixels' => array(
                    'namespace' => 'XMP-GPano',
                    'tagname' => 'CroppedAreaImageHeightPixels',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGPano\CroppedAreaImageHeightPixels',
                ),
                'croppedareaimagewidthpixels' => array(
                    'namespace' => 'XMP-GPano',
                    'tagname' => 'CroppedAreaImageWidthPixels',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGPano\CroppedAreaImageWidthPixels',
                ),
                'croppedarealeftpixels' => array(
                    'namespace' => 'XMP-GPano',
                    'tagname' => 'CroppedAreaLeftPixels',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGPano\CroppedAreaLeftPixels',
                ),
                'croppedareatoppixels' => array(
                    'namespace' => 'XMP-GPano',
                    'tagname' => 'CroppedAreaTopPixels',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGPano\CroppedAreaTopPixels',
                ),
                'exposurelockused' => array(
                    'namespace' => 'XMP-GPano',
                    'tagname' => 'ExposureLockUsed',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGPano\ExposureLockUsed',
                ),
                'firstphotodate' => array(
                    'namespace' => 'XMP-GPano',
                    'tagname' => 'FirstPhotoDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGPano\FirstPhotoDate',
                ),
                'fullpanoheightpixels' => array(
                    'namespace' => 'XMP-GPano',
                    'tagname' => 'FullPanoHeightPixels',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGPano\FullPanoHeightPixels',
                ),
                'fullpanowidthpixels' => array(
                    'namespace' => 'XMP-GPano',
                    'tagname' => 'FullPanoWidthPixels',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGPano\FullPanoWidthPixels',
                ),
                'initialcameradolly' => array(
                    'namespace' => 'XMP-GPano',
                    'tagname' => 'InitialCameraDolly',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGPano\InitialCameraDolly',
                ),
                'initialhorizontalfovdegrees' => array(
                    'namespace' => 'XMP-GPano',
                    'tagname' => 'InitialHorizontalFOVDegrees',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGPano\InitialHorizontalFOVDegrees',
                ),
                'initialviewheadingdegrees' => array(
                    'namespace' => 'XMP-GPano',
                    'tagname' => 'InitialViewHeadingDegrees',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGPano\InitialViewHeadingDegrees',
                ),
                'initialviewpitchdegrees' => array(
                    'namespace' => 'XMP-GPano',
                    'tagname' => 'InitialViewPitchDegrees',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGPano\InitialViewPitchDegrees',
                ),
                'initialviewrolldegrees' => array(
                    'namespace' => 'XMP-GPano',
                    'tagname' => 'InitialViewRollDegrees',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGPano\InitialViewRollDegrees',
                ),
                'largestvalidinteriorrectheight' => array(
                    'namespace' => 'XMP-GPano',
                    'tagname' => 'LargestValidInteriorRectHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGPano\LargestValidInteriorRectHeight',
                ),
                'largestvalidinteriorrectleft' => array(
                    'namespace' => 'XMP-GPano',
                    'tagname' => 'LargestValidInteriorRectLeft',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGPano\LargestValidInteriorRectLeft',
                ),
                'largestvalidinteriorrecttop' => array(
                    'namespace' => 'XMP-GPano',
                    'tagname' => 'LargestValidInteriorRectTop',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGPano\LargestValidInteriorRectTop',
                ),
                'largestvalidinteriorrectwidth' => array(
                    'namespace' => 'XMP-GPano',
                    'tagname' => 'LargestValidInteriorRectWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGPano\LargestValidInteriorRectWidth',
                ),
                'lastphotodate' => array(
                    'namespace' => 'XMP-GPano',
                    'tagname' => 'LastPhotoDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGPano\LastPhotoDate',
                ),
                'poseheadingdegrees' => array(
                    'namespace' => 'XMP-GPano',
                    'tagname' => 'PoseHeadingDegrees',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGPano\PoseHeadingDegrees',
                ),
                'posepitchdegrees' => array(
                    'namespace' => 'XMP-GPano',
                    'tagname' => 'PosePitchDegrees',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGPano\PosePitchDegrees',
                ),
                'poserolldegrees' => array(
                    'namespace' => 'XMP-GPano',
                    'tagname' => 'PoseRollDegrees',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGPano\PoseRollDegrees',
                ),
                'projectiontype' => array(
                    'namespace' => 'XMP-GPano',
                    'tagname' => 'ProjectionType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGPano\ProjectionType',
                ),
                'sourcephotoscount' => array(
                    'namespace' => 'XMP-GPano',
                    'tagname' => 'SourcePhotosCount',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGPano\SourcePhotosCount',
                ),
                'stitchingsoftware' => array(
                    'namespace' => 'XMP-GPano',
                    'tagname' => 'StitchingSoftware',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGPano\StitchingSoftware',
                ),
                'usepanoramaviewer' => array(
                    'namespace' => 'XMP-GPano',
                    'tagname' => 'UsePanoramaViewer',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGPano\UsePanoramaViewer',
                ),
            ),
            'gspherical' => array(
                'croppedareaimageheightpixels' => array(
                    'namespace' => 'GSpherical',
                    'tagname' => 'CroppedAreaImageHeightPixels',
                    'classname' => 'PHPExiftool\Driver\Tag\GSpherical\CroppedAreaImageHeightPixels',
                ),
                'croppedareaimagewidthpixels' => array(
                    'namespace' => 'GSpherical',
                    'tagname' => 'CroppedAreaImageWidthPixels',
                    'classname' => 'PHPExiftool\Driver\Tag\GSpherical\CroppedAreaImageWidthPixels',
                ),
                'croppedarealeftpixels' => array(
                    'namespace' => 'GSpherical',
                    'tagname' => 'CroppedAreaLeftPixels',
                    'classname' => 'PHPExiftool\Driver\Tag\GSpherical\CroppedAreaLeftPixels',
                ),
                'croppedareatoppixels' => array(
                    'namespace' => 'GSpherical',
                    'tagname' => 'CroppedAreaTopPixels',
                    'classname' => 'PHPExiftool\Driver\Tag\GSpherical\CroppedAreaTopPixels',
                ),
                'fullpanoheightpixels' => array(
                    'namespace' => 'GSpherical',
                    'tagname' => 'FullPanoHeightPixels',
                    'classname' => 'PHPExiftool\Driver\Tag\GSpherical\FullPanoHeightPixels',
                ),
                'fullpanowidthpixels' => array(
                    'namespace' => 'GSpherical',
                    'tagname' => 'FullPanoWidthPixels',
                    'classname' => 'PHPExiftool\Driver\Tag\GSpherical\FullPanoWidthPixels',
                ),
                'initialviewheadingdegrees' => array(
                    'namespace' => 'GSpherical',
                    'tagname' => 'InitialViewHeadingDegrees',
                    'classname' => 'PHPExiftool\Driver\Tag\GSpherical\InitialViewHeadingDegrees',
                ),
                'initialviewpitchdegrees' => array(
                    'namespace' => 'GSpherical',
                    'tagname' => 'InitialViewPitchDegrees',
                    'classname' => 'PHPExiftool\Driver\Tag\GSpherical\InitialViewPitchDegrees',
                ),
                'initialviewrolldegrees' => array(
                    'namespace' => 'GSpherical',
                    'tagname' => 'InitialViewRollDegrees',
                    'classname' => 'PHPExiftool\Driver\Tag\GSpherical\InitialViewRollDegrees',
                ),
                'projectiontype' => array(
                    'namespace' => 'GSpherical',
                    'tagname' => 'ProjectionType',
                    'classname' => 'PHPExiftool\Driver\Tag\GSpherical\ProjectionType',
                ),
                'sourcecount' => array(
                    'namespace' => 'GSpherical',
                    'tagname' => 'SourceCount',
                    'classname' => 'PHPExiftool\Driver\Tag\GSpherical\SourceCount',
                ),
                'spherical' => array(
                    'namespace' => 'GSpherical',
                    'tagname' => 'Spherical',
                    'classname' => 'PHPExiftool\Driver\Tag\GSpherical\Spherical',
                ),
                'stereomode' => array(
                    'namespace' => 'GSpherical',
                    'tagname' => 'StereoMode',
                    'classname' => 'PHPExiftool\Driver\Tag\GSpherical\StereoMode',
                ),
                'stitched' => array(
                    'namespace' => 'GSpherical',
                    'tagname' => 'Stitched',
                    'classname' => 'PHPExiftool\Driver\Tag\GSpherical\Stitched',
                ),
                'stitchingsoftware' => array(
                    'namespace' => 'GSpherical',
                    'tagname' => 'StitchingSoftware',
                    'classname' => 'PHPExiftool\Driver\Tag\GSpherical\StitchingSoftware',
                ),
                'timestamp' => array(
                    'namespace' => 'GSpherical',
                    'tagname' => 'TimeStamp',
                    'classname' => 'PHPExiftool\Driver\Tag\GSpherical\TimeStamp',
                ),
            ),
            'xmp-getty' => array(
                'assetid' => array(
                    'namespace' => 'XMP-getty',
                    'tagname' => 'AssetID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGetty\AssetID',
                ),
                'callforimage' => array(
                    'namespace' => 'XMP-getty',
                    'tagname' => 'CallForImage',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGetty\CallForImage',
                ),
                'camerafilename' => array(
                    'namespace' => 'XMP-getty',
                    'tagname' => 'CameraFilename',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGetty\CameraFilename',
                ),
                'cameramakemodel' => array(
                    'namespace' => 'XMP-getty',
                    'tagname' => 'CameraMakeModel',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGetty\CameraMakeModel',
                ),
                'cameraserialnumber' => array(
                    'namespace' => 'XMP-getty',
                    'tagname' => 'CameraSerialNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGetty\CameraSerialNumber',
                ),
                'composition' => array(
                    'namespace' => 'XMP-getty',
                    'tagname' => 'Composition',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGetty\Composition',
                ),
                'exclusivecoverage' => array(
                    'namespace' => 'XMP-getty',
                    'tagname' => 'ExclusiveCoverage',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGetty\ExclusiveCoverage',
                ),
                'giftftppriority' => array(
                    'namespace' => 'XMP-getty',
                    'tagname' => 'GIFTFtpPriority',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGetty\GIFTFtpPriority',
                ),
                'imagerank' => array(
                    'namespace' => 'XMP-getty',
                    'tagname' => 'ImageRank',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGetty\ImageRank',
                ),
                'mediaeventiddate' => array(
                    'namespace' => 'XMP-getty',
                    'tagname' => 'MediaEventIdDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGetty\MediaEventIdDate',
                ),
                'originalcreatedatetime' => array(
                    'namespace' => 'XMP-getty',
                    'tagname' => 'OriginalCreateDateTime',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGetty\OriginalCreateDateTime',
                ),
                'originalfilename' => array(
                    'namespace' => 'XMP-getty',
                    'tagname' => 'OriginalFileName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGetty\OriginalFileName',
                ),
                'parentmediaeventid' => array(
                    'namespace' => 'XMP-getty',
                    'tagname' => 'ParentMediaEventID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGetty\ParentMediaEventID',
                ),
                'parentmeid' => array(
                    'namespace' => 'XMP-getty',
                    'tagname' => 'ParentMEID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGetty\ParentMEID',
                ),
                'personality' => array(
                    'namespace' => 'XMP-getty',
                    'tagname' => 'Personality',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGetty\Personality',
                ),
                'primaryftp' => array(
                    'namespace' => 'XMP-getty',
                    'tagname' => 'PrimaryFTP',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGetty\PrimaryFTP',
                ),
                'routingdestinations' => array(
                    'namespace' => 'XMP-getty',
                    'tagname' => 'RoutingDestinations',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGetty\RoutingDestinations',
                ),
                'routingexclusions' => array(
                    'namespace' => 'XMP-getty',
                    'tagname' => 'RoutingExclusions',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGetty\RoutingExclusions',
                ),
                'secondaryftp' => array(
                    'namespace' => 'XMP-getty',
                    'tagname' => 'SecondaryFTP',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGetty\SecondaryFTP',
                ),
                'timeshot' => array(
                    'namespace' => 'XMP-getty',
                    'tagname' => 'TimeShot',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPGetty\TimeShot',
                ),
            ),
            'xmp-limage' => array(
                'majorversion' => array(
                    'namespace' => 'XMP-LImage',
                    'tagname' => 'MajorVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPLImage\MajorVersion',
                ),
                'minorversion' => array(
                    'namespace' => 'XMP-LImage',
                    'tagname' => 'MinorVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPLImage\MinorVersion',
                ),
                'rightalbedo' => array(
                    'namespace' => 'XMP-LImage',
                    'tagname' => 'RightAlbedo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPLImage\RightAlbedo',
                ),
            ),
            'xmp-lr' => array(
                'hierarchicalsubject' => array(
                    'namespace' => 'XMP-lr',
                    'tagname' => 'HierarchicalSubject',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPLr\HierarchicalSubject',
                ),
                'privatertkinfo' => array(
                    'namespace' => 'XMP-lr',
                    'tagname' => 'PrivateRTKInfo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPLr\PrivateRTKInfo',
                ),
            ),
            'xmp-mediapro' => array(
                'catalogsets' => array(
                    'namespace' => 'XMP-mediapro',
                    'tagname' => 'CatalogSets',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMediapro\CatalogSets',
                ),
                'event' => array(
                    'namespace' => 'XMP-mediapro',
                    'tagname' => 'Event',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMediapro\Event',
                ),
                'location' => array(
                    'namespace' => 'XMP-mediapro',
                    'tagname' => 'Location',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMediapro\Location',
                ),
                'people' => array(
                    'namespace' => 'XMP-mediapro',
                    'tagname' => 'People',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMediapro\People',
                ),
                'status' => array(
                    'namespace' => 'XMP-mediapro',
                    'tagname' => 'Status',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMediapro\Status',
                ),
                'userfields' => array(
                    'namespace' => 'XMP-mediapro',
                    'tagname' => 'UserFields',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPMediapro\UserFields',
                ),
            ),
            'xmp-pixellive' => array(
                'author' => array(
                    'namespace' => 'XMP-PixelLive',
                    'tagname' => 'Author',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPixelLive\Author',
                ),
                'comments' => array(
                    'namespace' => 'XMP-PixelLive',
                    'tagname' => 'Comments',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPixelLive\Comments',
                ),
                'copyright' => array(
                    'namespace' => 'XMP-PixelLive',
                    'tagname' => 'Copyright',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPixelLive\Copyright',
                ),
                'date' => array(
                    'namespace' => 'XMP-PixelLive',
                    'tagname' => 'Date',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPixelLive\Date',
                ),
                'genre' => array(
                    'namespace' => 'XMP-PixelLive',
                    'tagname' => 'Genre',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPixelLive\Genre',
                ),
                'title' => array(
                    'namespace' => 'XMP-PixelLive',
                    'tagname' => 'Title',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPixelLive\Title',
                ),
            ),
            'svg' => array(
                'imageheight' => array(
                    'namespace' => 'SVG',
                    'tagname' => 'ImageHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\SVG\ImageHeight',
                ),
                'id' => array(
                    'namespace' => 'SVG',
                    'tagname' => 'ID',
                    'classname' => 'PHPExiftool\Driver\Tag\SVG\ID',
                ),
                'metadataid' => array(
                    'namespace' => 'SVG',
                    'tagname' => 'MetadataID',
                    'classname' => 'PHPExiftool\Driver\Tag\SVG\MetadataID',
                ),
                'svgversion' => array(
                    'namespace' => 'SVG',
                    'tagname' => 'SVGVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\SVG\SVGVersion',
                ),
                'imagewidth' => array(
                    'namespace' => 'SVG',
                    'tagname' => 'ImageWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\SVG\ImageWidth',
                ),
            ),
            'xmp-aas' => array(
                'affinea' => array(
                    'namespace' => 'XMP-aas',
                    'tagname' => 'AffineA',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAas\AffineA',
                ),
                'affineb' => array(
                    'namespace' => 'XMP-aas',
                    'tagname' => 'AffineB',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAas\AffineB',
                ),
                'affinec' => array(
                    'namespace' => 'XMP-aas',
                    'tagname' => 'AffineC',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAas\AffineC',
                ),
                'affined' => array(
                    'namespace' => 'XMP-aas',
                    'tagname' => 'AffineD',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAas\AffineD',
                ),
                'affinex' => array(
                    'namespace' => 'XMP-aas',
                    'tagname' => 'AffineX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAas\AffineX',
                ),
                'affiney' => array(
                    'namespace' => 'XMP-aas',
                    'tagname' => 'AffineY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAas\AffineY',
                ),
                'croph' => array(
                    'namespace' => 'XMP-aas',
                    'tagname' => 'CropH',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAas\CropH',
                ),
                'cropw' => array(
                    'namespace' => 'XMP-aas',
                    'tagname' => 'CropW',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAas\CropW',
                ),
                'cropx' => array(
                    'namespace' => 'XMP-aas',
                    'tagname' => 'CropX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAas\CropX',
                ),
                'cropy' => array(
                    'namespace' => 'XMP-aas',
                    'tagname' => 'CropY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAas\CropY',
                ),
                'curve0x' => array(
                    'namespace' => 'XMP-aas',
                    'tagname' => 'Curve0x',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAas\Curve0x',
                ),
                'curve0y' => array(
                    'namespace' => 'XMP-aas',
                    'tagname' => 'Curve0y',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAas\Curve0y',
                ),
                'curve1x' => array(
                    'namespace' => 'XMP-aas',
                    'tagname' => 'Curve1x',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAas\Curve1x',
                ),
                'curve1y' => array(
                    'namespace' => 'XMP-aas',
                    'tagname' => 'Curve1y',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAas\Curve1y',
                ),
                'curve2x' => array(
                    'namespace' => 'XMP-aas',
                    'tagname' => 'Curve2x',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAas\Curve2x',
                ),
                'curve2y' => array(
                    'namespace' => 'XMP-aas',
                    'tagname' => 'Curve2y',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAas\Curve2y',
                ),
                'curve3x' => array(
                    'namespace' => 'XMP-aas',
                    'tagname' => 'Curve3x',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAas\Curve3x',
                ),
                'curve3y' => array(
                    'namespace' => 'XMP-aas',
                    'tagname' => 'Curve3y',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAas\Curve3y',
                ),
                'curve4x' => array(
                    'namespace' => 'XMP-aas',
                    'tagname' => 'Curve4x',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAas\Curve4x',
                ),
                'curve4y' => array(
                    'namespace' => 'XMP-aas',
                    'tagname' => 'Curve4y',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAas\Curve4y',
                ),
                'facebalanceorigi' => array(
                    'namespace' => 'XMP-aas',
                    'tagname' => 'FaceBalanceOrigI',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAas\FaceBalanceOrigI',
                ),
                'facebalanceorigq' => array(
                    'namespace' => 'XMP-aas',
                    'tagname' => 'FaceBalanceOrigQ',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAas\FaceBalanceOrigQ',
                ),
                'facebalancestrength' => array(
                    'namespace' => 'XMP-aas',
                    'tagname' => 'FaceBalanceStrength',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAas\FaceBalanceStrength',
                ),
                'facebalancewarmth' => array(
                    'namespace' => 'XMP-aas',
                    'tagname' => 'FaceBalanceWarmth',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAas\FaceBalanceWarmth',
                ),
                'highlights' => array(
                    'namespace' => 'XMP-aas',
                    'tagname' => 'Highlights',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAas\Highlights',
                ),
                'shadows' => array(
                    'namespace' => 'XMP-aas',
                    'tagname' => 'Shadows',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAas\Shadows',
                ),
                'vibrance' => array(
                    'namespace' => 'XMP-aas',
                    'tagname' => 'Vibrance',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAas\Vibrance',
                ),
            ),
            'xmp-acdsee' => array(
                'author' => array(
                    'namespace' => 'XMP-acdsee',
                    'tagname' => 'Author',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAcdsee\Author',
                ),
                'caption' => array(
                    'namespace' => 'XMP-acdsee',
                    'tagname' => 'Caption',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAcdsee\Caption',
                ),
                'categories' => array(
                    'namespace' => 'XMP-acdsee',
                    'tagname' => 'Categories',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAcdsee\Categories',
                ),
                'collections' => array(
                    'namespace' => 'XMP-acdsee',
                    'tagname' => 'Collections',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAcdsee\Collections',
                ),
                'datetime' => array(
                    'namespace' => 'XMP-acdsee',
                    'tagname' => 'DateTime',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAcdsee\DateTime',
                ),
                'dpp' => array(
                    'namespace' => 'XMP-acdsee',
                    'tagname' => 'DPP',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAcdsee\DPP',
                ),
                'editstatus' => array(
                    'namespace' => 'XMP-acdsee',
                    'tagname' => 'EditStatus',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAcdsee\EditStatus',
                ),
                'fixtureidentifier' => array(
                    'namespace' => 'XMP-acdsee',
                    'tagname' => 'FixtureIdentifier',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAcdsee\FixtureIdentifier',
                ),
                'keywords' => array(
                    'namespace' => 'XMP-acdsee',
                    'tagname' => 'Keywords',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAcdsee\Keywords',
                ),
                'notes' => array(
                    'namespace' => 'XMP-acdsee',
                    'tagname' => 'Notes',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAcdsee\Notes',
                ),
                'objectcycle' => array(
                    'namespace' => 'XMP-acdsee',
                    'tagname' => 'ObjectCycle',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAcdsee\ObjectCycle',
                ),
                'originatingprogram' => array(
                    'namespace' => 'XMP-acdsee',
                    'tagname' => 'OriginatingProgram',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAcdsee\OriginatingProgram',
                ),
                'rating' => array(
                    'namespace' => 'XMP-acdsee',
                    'tagname' => 'Rating',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAcdsee\Rating',
                ),
                'rawrppused' => array(
                    'namespace' => 'XMP-acdsee',
                    'tagname' => 'Rawrppused',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAcdsee\Rawrppused',
                ),
                'releasedate' => array(
                    'namespace' => 'XMP-acdsee',
                    'tagname' => 'ReleaseDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAcdsee\ReleaseDate',
                ),
                'releasetime' => array(
                    'namespace' => 'XMP-acdsee',
                    'tagname' => 'ReleaseTime',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAcdsee\ReleaseTime',
                ),
                'rpp' => array(
                    'namespace' => 'XMP-acdsee',
                    'tagname' => 'RPP',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAcdsee\RPP',
                ),
                'snapshots' => array(
                    'namespace' => 'XMP-acdsee',
                    'tagname' => 'Snapshots',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAcdsee\Snapshots',
                ),
                'tagged' => array(
                    'namespace' => 'XMP-acdsee',
                    'tagname' => 'Tagged',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAcdsee\Tagged',
                ),
            ),
            'xmp-apple-fi' => array(
                'angleinforoll' => array(
                    'namespace' => 'XMP-apple-fi',
                    'tagname' => 'AngleInfoRoll',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAppleFi\AngleInfoRoll',
                ),
                'angleinfoyaw' => array(
                    'namespace' => 'XMP-apple-fi',
                    'tagname' => 'AngleInfoYaw',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAppleFi\AngleInfoYaw',
                ),
                'confidencelevel' => array(
                    'namespace' => 'XMP-apple-fi',
                    'tagname' => 'ConfidenceLevel',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAppleFi\ConfidenceLevel',
                ),
                'faceid' => array(
                    'namespace' => 'XMP-apple-fi',
                    'tagname' => 'FaceID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAppleFi\FaceID',
                ),
                'timestamp' => array(
                    'namespace' => 'XMP-apple-fi',
                    'tagname' => 'TimeStamp',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAppleFi\TimeStamp',
                ),
            ),
            'xmp-aux' => array(
                'approximatefocusdistance' => array(
                    'namespace' => 'XMP-aux',
                    'tagname' => 'ApproximateFocusDistance',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAux\ApproximateFocusDistance',
                ),
                'distortioncorrectionalreadyapplied' => array(
                    'namespace' => 'XMP-aux',
                    'tagname' => 'DistortionCorrectionAlreadyApplied',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAux\DistortionCorrectionAlreadyApplied',
                ),
                'firmware' => array(
                    'namespace' => 'XMP-aux',
                    'tagname' => 'Firmware',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAux\Firmware',
                ),
                'flashcompensation' => array(
                    'namespace' => 'XMP-aux',
                    'tagname' => 'FlashCompensation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAux\FlashCompensation',
                ),
                'imagenumber' => array(
                    'namespace' => 'XMP-aux',
                    'tagname' => 'ImageNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAux\ImageNumber',
                ),
                'ismergedhdr' => array(
                    'namespace' => 'XMP-aux',
                    'tagname' => 'IsMergedHDR',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAux\IsMergedHDR',
                ),
                'ismergedpanorama' => array(
                    'namespace' => 'XMP-aux',
                    'tagname' => 'IsMergedPanorama',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAux\IsMergedPanorama',
                ),
                'lateralchromaticaberrationcorrectionalreadyapplied' => array(
                    'namespace' => 'XMP-aux',
                    'tagname' => 'LateralChromaticAberrationCorrectionAlreadyApplied',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAux\LateralChromaticAberrationCorrectionAlreadyApplied',
                ),
                'lens' => array(
                    'namespace' => 'XMP-aux',
                    'tagname' => 'Lens',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAux\Lens',
                ),
                'lensdistortinfo' => array(
                    'namespace' => 'XMP-aux',
                    'tagname' => 'LensDistortInfo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAux\LensDistortInfo',
                ),
                'lensid' => array(
                    'namespace' => 'XMP-aux',
                    'tagname' => 'LensID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAux\LensID',
                ),
                'lensinfo' => array(
                    'namespace' => 'XMP-aux',
                    'tagname' => 'LensInfo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAux\LensInfo',
                ),
                'lensserialnumber' => array(
                    'namespace' => 'XMP-aux',
                    'tagname' => 'LensSerialNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAux\LensSerialNumber',
                ),
                'ownername' => array(
                    'namespace' => 'XMP-aux',
                    'tagname' => 'OwnerName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAux\OwnerName',
                ),
                'serialnumber' => array(
                    'namespace' => 'XMP-aux',
                    'tagname' => 'SerialNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAux\SerialNumber',
                ),
                'vignettecorrectionalreadyapplied' => array(
                    'namespace' => 'XMP-aux',
                    'tagname' => 'VignetteCorrectionAlreadyApplied',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPAux\VignetteCorrectionAlreadyApplied',
                ),
            ),
            'xmp-cc' => array(
                'attributionname' => array(
                    'namespace' => 'XMP-cc',
                    'tagname' => 'AttributionName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCc\AttributionName',
                ),
                'attributionurl' => array(
                    'namespace' => 'XMP-cc',
                    'tagname' => 'AttributionURL',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCc\AttributionURL',
                ),
                'deprecatedon' => array(
                    'namespace' => 'XMP-cc',
                    'tagname' => 'DeprecatedOn',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCc\DeprecatedOn',
                ),
                'jurisdiction' => array(
                    'namespace' => 'XMP-cc',
                    'tagname' => 'Jurisdiction',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCc\Jurisdiction',
                ),
                'legalcode' => array(
                    'namespace' => 'XMP-cc',
                    'tagname' => 'LegalCode',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCc\LegalCode',
                ),
                'license' => array(
                    'namespace' => 'XMP-cc',
                    'tagname' => 'License',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCc\License',
                ),
                'morepermissions' => array(
                    'namespace' => 'XMP-cc',
                    'tagname' => 'MorePermissions',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCc\MorePermissions',
                ),
                'permits' => array(
                    'namespace' => 'XMP-cc',
                    'tagname' => 'Permits',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCc\Permits',
                ),
                'prohibits' => array(
                    'namespace' => 'XMP-cc',
                    'tagname' => 'Prohibits',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCc\Prohibits',
                ),
                'requires' => array(
                    'namespace' => 'XMP-cc',
                    'tagname' => 'Requires',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCc\Requires',
                ),
                'useguidelines' => array(
                    'namespace' => 'XMP-cc',
                    'tagname' => 'UseGuidelines',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCc\UseGuidelines',
                ),
            ),
            'xmp-cell' => array(
                'celltowerid' => array(
                    'namespace' => 'XMP-cell',
                    'tagname' => 'CellTowerID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCell\CellTowerID',
                ),
                'cellglobalid' => array(
                    'namespace' => 'XMP-cell',
                    'tagname' => 'CellGlobalID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCell\CellGlobalID',
                ),
                'locationareacode' => array(
                    'namespace' => 'XMP-cell',
                    'tagname' => 'LocationAreaCode',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCell\LocationAreaCode',
                ),
                'mobilecountrycode' => array(
                    'namespace' => 'XMP-cell',
                    'tagname' => 'MobileCountryCode',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCell\MobileCountryCode',
                ),
                'mobilenetworkcode' => array(
                    'namespace' => 'XMP-cell',
                    'tagname' => 'MobileNetworkCode',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCell\MobileNetworkCode',
                ),
                'cellr' => array(
                    'namespace' => 'XMP-cell',
                    'tagname' => 'CellR',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCell\CellR',
                ),
            ),
            'xmp-crd' => array(
                'alreadyapplied' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'AlreadyApplied',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\AlreadyApplied',
                ),
                'autobrightness' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'AutoBrightness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\AutoBrightness',
                ),
                'autocontrast' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'AutoContrast',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\AutoContrast',
                ),
                'autoexposure' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'AutoExposure',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\AutoExposure',
                ),
                'autolateralca' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'AutoLateralCA',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\AutoLateralCA',
                ),
                'autoshadows' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'AutoShadows',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\AutoShadows',
                ),
                'autotone' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'AutoTone',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\AutoTone',
                ),
                'autowhiteversion' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'AutoWhiteVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\AutoWhiteVersion',
                ),
                'blacks2012' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'Blacks2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\Blacks2012',
                ),
                'bluehue' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'BlueHue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\BlueHue',
                ),
                'bluesaturation' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'BlueSaturation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\BlueSaturation',
                ),
                'brightness' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'Brightness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\Brightness',
                ),
                'cameraprofile' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CameraProfile',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CameraProfile',
                ),
                'cameraprofiledigest' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CameraProfileDigest',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CameraProfileDigest',
                ),
                'chromaticaberrationb' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'ChromaticAberrationB',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\ChromaticAberrationB',
                ),
                'chromaticaberrationr' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'ChromaticAberrationR',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\ChromaticAberrationR',
                ),
                'circulargradientbasedcorrections' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircularGradientBasedCorrections',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircularGradientBasedCorrections',
                ),
                'circgradbasedcorractive' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrActive',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrActive',
                ),
                'circgradbasedcorramount' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrAmount',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrAmount',
                ),
                'circgradbasedcorrmasks' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrMasks',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMasks',
                ),
                'circgradbasedcorrmaskalpha' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrMaskAlpha',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskAlpha',
                ),
                'circgradbasedcorrmaskangle' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrMaskAngle',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskAngle',
                ),
                'circgradbasedcorrmaskbottom' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrMaskBottom',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskBottom',
                ),
                'circgradbasedcorrmaskcentervalue' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrMaskCenterValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskCenterValue',
                ),
                'circgradbasedcorrmaskcenterweight' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrMaskCenterWeight',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskCenterWeight',
                ),
                'circgradbasedcorrmaskdabs' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrMaskDabs',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskDabs',
                ),
                'circgradbasedcorrmaskfeather' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrMaskFeather',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskFeather',
                ),
                'circgradbasedcorrmaskflipped' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrMaskFlipped',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskFlipped',
                ),
                'circgradbasedcorrmaskflow' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrMaskFlow',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskFlow',
                ),
                'circgradbasedcorrmaskfullx' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrMaskFullX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskFullX',
                ),
                'circgradbasedcorrmaskfully' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrMaskFullY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskFullY',
                ),
                'circgradbasedcorrmaskleft' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrMaskLeft',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskLeft',
                ),
                'circgradbasedcorrmaskvalue' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrMaskValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskValue',
                ),
                'circgradbasedcorrmaskmidpoint' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrMaskMidpoint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskMidpoint',
                ),
                'circgradbasedcorrmaskperimetervalue' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrMaskPerimeterValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskPerimeterValue',
                ),
                'circgradbasedcorrmaskradius' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrMaskRadius',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskRadius',
                ),
                'circgradbasedcorrmaskright' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrMaskRight',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskRight',
                ),
                'circgradbasedcorrmaskroundness' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrMaskRoundness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskRoundness',
                ),
                'circgradbasedcorrmasksizex' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrMaskSizeX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskSizeX',
                ),
                'circgradbasedcorrmasksizey' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrMaskSizeY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskSizeY',
                ),
                'circgradbasedcorrmasktop' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrMaskTop',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskTop',
                ),
                'circgradbasedcorrmaskversion' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrMaskVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskVersion',
                ),
                'circgradbasedcorrmaskwhat' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrMaskWhat',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskWhat',
                ),
                'circgradbasedcorrmaskx' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrMaskX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskX',
                ),
                'circgradbasedcorrmasky' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrMaskY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskY',
                ),
                'circgradbasedcorrmaskzerox' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrMaskZeroX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskZeroX',
                ),
                'circgradbasedcorrmaskzeroy' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrMaskZeroY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMaskZeroY',
                ),
                'circgradbasedcorrbrightness' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrBrightness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrBrightness',
                ),
                'circgradbasedcorrclarity' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrClarity',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrClarity',
                ),
                'circgradbasedcorrclarity2012' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrClarity2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrClarity2012',
                ),
                'circgradbasedcorrcontrast' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrContrast',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrContrast',
                ),
                'circgradbasedcorrcontrast2012' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrContrast2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrContrast2012',
                ),
                'circgradbasedcorrdefringe' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrDefringe',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrDefringe',
                ),
                'circgradbasedcorrexposure' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrExposure',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrExposure',
                ),
                'circgradbasedcorrexposure2012' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrExposure2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrExposure2012',
                ),
                'circgradbasedcorrhighlights2012' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrHighlights2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrHighlights2012',
                ),
                'circgradbasedcorrluminancenoise' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrLuminanceNoise',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrLuminanceNoise',
                ),
                'circgradbasedcorrmoire' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrMoire',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrMoire',
                ),
                'circgradbasedcorrsaturation' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrSaturation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrSaturation',
                ),
                'circgradbasedcorrshadows2012' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrShadows2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrShadows2012',
                ),
                'circgradbasedcorrsharpness' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrSharpness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrSharpness',
                ),
                'circgradbasedcorrtemperature' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrTemperature',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrTemperature',
                ),
                'circgradbasedcorrtint' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrTint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrTint',
                ),
                'circgradbasedcorrhue' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrHue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrHue',
                ),
                'circgradbasedcorrwhat' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CircGradBasedCorrWhat',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CircGradBasedCorrWhat',
                ),
                'clarity' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'Clarity',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\Clarity',
                ),
                'clarity2012' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'Clarity2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\Clarity2012',
                ),
                'colornoisereduction' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'ColorNoiseReduction',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\ColorNoiseReduction',
                ),
                'colornoisereductiondetail' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'ColorNoiseReductionDetail',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\ColorNoiseReductionDetail',
                ),
                'colornoisereductionsmoothness' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'ColorNoiseReductionSmoothness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\ColorNoiseReductionSmoothness',
                ),
                'contrast' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'Contrast',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\Contrast',
                ),
                'contrast2012' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'Contrast2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\Contrast2012',
                ),
                'converter' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'Converter',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\Converter',
                ),
                'converttograyscale' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'ConvertToGrayscale',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\ConvertToGrayscale',
                ),
                'cropangle' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CropAngle',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CropAngle',
                ),
                'cropbottom' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CropBottom',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CropBottom',
                ),
                'cropconstraintowarp' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CropConstrainToWarp',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CropConstrainToWarp',
                ),
                'cropheight' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CropHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CropHeight',
                ),
                'cropleft' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CropLeft',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CropLeft',
                ),
                'cropright' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CropRight',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CropRight',
                ),
                'croptop' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CropTop',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CropTop',
                ),
                'cropunit' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CropUnit',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CropUnit',
                ),
                'cropunits' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CropUnits',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CropUnits',
                ),
                'cropwidth' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'CropWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\CropWidth',
                ),
                'defaultautogray' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'DefaultAutoGray',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\DefaultAutoGray',
                ),
                'defaultautotone' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'DefaultAutoTone',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\DefaultAutoTone',
                ),
                'defaultsspecifictoiso' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'DefaultsSpecificToISO',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\DefaultsSpecificToISO',
                ),
                'defaultsspecifictoserial' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'DefaultsSpecificToSerial',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\DefaultsSpecificToSerial',
                ),
                'defringe' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'Defringe',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\Defringe',
                ),
                'defringegreenamount' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'DefringeGreenAmount',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\DefringeGreenAmount',
                ),
                'defringegreenhuehi' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'DefringeGreenHueHi',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\DefringeGreenHueHi',
                ),
                'defringegreenhuelo' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'DefringeGreenHueLo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\DefringeGreenHueLo',
                ),
                'defringepurpleamount' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'DefringePurpleAmount',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\DefringePurpleAmount',
                ),
                'defringepurplehuehi' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'DefringePurpleHueHi',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\DefringePurpleHueHi',
                ),
                'defringepurplehuelo' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'DefringePurpleHueLo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\DefringePurpleHueLo',
                ),
                'dehaze' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'Dehaze',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\Dehaze',
                ),
                'dngignoresidecars' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'DNGIgnoreSidecars',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\DNGIgnoreSidecars',
                ),
                'exposure' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'Exposure',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\Exposure',
                ),
                'exposure2012' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'Exposure2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\Exposure2012',
                ),
                'filllight' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'FillLight',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\FillLight',
                ),
                'gradientbasedcorrections' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrections',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrections',
                ),
                'gradientbasedcorractive' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrActive',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrActive',
                ),
                'gradientbasedcorramount' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrAmount',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrAmount',
                ),
                'gradientbasedcorrmasks' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrMasks',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMasks',
                ),
                'gradientbasedcorrmaskalpha' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrMaskAlpha',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskAlpha',
                ),
                'gradientbasedcorrmaskangle' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrMaskAngle',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskAngle',
                ),
                'gradientbasedcorrmaskbottom' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrMaskBottom',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskBottom',
                ),
                'gradientbasedcorrmaskcentervalue' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrMaskCenterValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskCenterValue',
                ),
                'gradientbasedcorrmaskcenterweight' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrMaskCenterWeight',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskCenterWeight',
                ),
                'gradientbasedcorrmaskdabs' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrMaskDabs',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskDabs',
                ),
                'gradientbasedcorrmaskfeather' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrMaskFeather',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskFeather',
                ),
                'gradientbasedcorrmaskflipped' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrMaskFlipped',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskFlipped',
                ),
                'gradientbasedcorrmaskflow' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrMaskFlow',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskFlow',
                ),
                'gradientbasedcorrmaskfullx' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrMaskFullX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskFullX',
                ),
                'gradientbasedcorrmaskfully' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrMaskFullY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskFullY',
                ),
                'gradientbasedcorrmaskleft' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrMaskLeft',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskLeft',
                ),
                'gradientbasedcorrmaskvalue' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrMaskValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskValue',
                ),
                'gradientbasedcorrmaskmidpoint' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrMaskMidpoint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskMidpoint',
                ),
                'gradientbasedcorrmaskperimetervalue' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrMaskPerimeterValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskPerimeterValue',
                ),
                'gradientbasedcorrmaskradius' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrMaskRadius',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskRadius',
                ),
                'gradientbasedcorrmaskright' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrMaskRight',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskRight',
                ),
                'gradientbasedcorrmaskroundness' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrMaskRoundness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskRoundness',
                ),
                'gradientbasedcorrmasksizex' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrMaskSizeX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskSizeX',
                ),
                'gradientbasedcorrmasksizey' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrMaskSizeY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskSizeY',
                ),
                'gradientbasedcorrmasktop' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrMaskTop',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskTop',
                ),
                'gradientbasedcorrmaskversion' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrMaskVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskVersion',
                ),
                'gradientbasedcorrmaskwhat' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrMaskWhat',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskWhat',
                ),
                'gradientbasedcorrmaskx' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrMaskX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskX',
                ),
                'gradientbasedcorrmasky' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrMaskY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskY',
                ),
                'gradientbasedcorrmaskzerox' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrMaskZeroX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskZeroX',
                ),
                'gradientbasedcorrmaskzeroy' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrMaskZeroY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMaskZeroY',
                ),
                'gradientbasedcorrbrightness' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrBrightness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrBrightness',
                ),
                'gradientbasedcorrclarity' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrClarity',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrClarity',
                ),
                'gradientbasedcorrclarity2012' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrClarity2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrClarity2012',
                ),
                'gradientbasedcorrcontrast' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrContrast',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrContrast',
                ),
                'gradientbasedcorrcontrast2012' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrContrast2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrContrast2012',
                ),
                'gradientbasedcorrdefringe' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrDefringe',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrDefringe',
                ),
                'gradientbasedcorrexposure' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrExposure',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrExposure',
                ),
                'gradientbasedcorrexposure2012' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrExposure2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrExposure2012',
                ),
                'gradientbasedcorrhighlights2012' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrHighlights2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrHighlights2012',
                ),
                'gradientbasedcorrluminancenoise' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrLuminanceNoise',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrLuminanceNoise',
                ),
                'gradientbasedcorrmoire' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrMoire',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrMoire',
                ),
                'gradientbasedcorrsaturation' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrSaturation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrSaturation',
                ),
                'gradientbasedcorrshadows2012' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrShadows2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrShadows2012',
                ),
                'gradientbasedcorrsharpness' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrSharpness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrSharpness',
                ),
                'gradientbasedcorrtemperature' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrTemperature',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrTemperature',
                ),
                'gradientbasedcorrtint' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrTint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrTint',
                ),
                'gradientbasedcorrhue' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrHue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrHue',
                ),
                'gradientbasedcorrwhat' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GradientBasedCorrWhat',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GradientBasedCorrWhat',
                ),
                'grainamount' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GrainAmount',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GrainAmount',
                ),
                'grainfrequency' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GrainFrequency',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GrainFrequency',
                ),
                'grainsize' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GrainSize',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GrainSize',
                ),
                'graymixeraqua' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GrayMixerAqua',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GrayMixerAqua',
                ),
                'graymixerblue' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GrayMixerBlue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GrayMixerBlue',
                ),
                'graymixergreen' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GrayMixerGreen',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GrayMixerGreen',
                ),
                'graymixermagenta' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GrayMixerMagenta',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GrayMixerMagenta',
                ),
                'graymixerorange' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GrayMixerOrange',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GrayMixerOrange',
                ),
                'graymixerpurple' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GrayMixerPurple',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GrayMixerPurple',
                ),
                'graymixerred' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GrayMixerRed',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GrayMixerRed',
                ),
                'graymixeryellow' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GrayMixerYellow',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GrayMixerYellow',
                ),
                'greenhue' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GreenHue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GreenHue',
                ),
                'greensaturation' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'GreenSaturation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\GreenSaturation',
                ),
                'hascrop' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'HasCrop',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\HasCrop',
                ),
                'hassettings' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'HasSettings',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\HasSettings',
                ),
                'highlight2012' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'Highlight2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\Highlight2012',
                ),
                'highlightrecovery' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'HighlightRecovery',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\HighlightRecovery',
                ),
                'highlights2012' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'Highlights2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\Highlights2012',
                ),
                'hueadjustmentaqua' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'HueAdjustmentAqua',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\HueAdjustmentAqua',
                ),
                'hueadjustmentblue' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'HueAdjustmentBlue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\HueAdjustmentBlue',
                ),
                'hueadjustmentgreen' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'HueAdjustmentGreen',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\HueAdjustmentGreen',
                ),
                'hueadjustmentmagenta' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'HueAdjustmentMagenta',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\HueAdjustmentMagenta',
                ),
                'hueadjustmentorange' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'HueAdjustmentOrange',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\HueAdjustmentOrange',
                ),
                'hueadjustmentpurple' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'HueAdjustmentPurple',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\HueAdjustmentPurple',
                ),
                'hueadjustmentred' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'HueAdjustmentRed',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\HueAdjustmentRed',
                ),
                'hueadjustmentyellow' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'HueAdjustmentYellow',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\HueAdjustmentYellow',
                ),
                'incrementaltemperature' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'IncrementalTemperature',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\IncrementalTemperature',
                ),
                'incrementaltint' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'IncrementalTint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\IncrementalTint',
                ),
                'jpeghandling' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'JPEGHandling',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\JPEGHandling',
                ),
                'lensmanualdistortionamount' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'LensManualDistortionAmount',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\LensManualDistortionAmount',
                ),
                'lensprofilechromaticaberrationscale' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'LensProfileChromaticAberrationScale',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\LensProfileChromaticAberrationScale',
                ),
                'lensprofiledigest' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'LensProfileDigest',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\LensProfileDigest',
                ),
                'lensprofiledistortionscale' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'LensProfileDistortionScale',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\LensProfileDistortionScale',
                ),
                'lensprofileenable' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'LensProfileEnable',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\LensProfileEnable',
                ),
                'lensprofilefilename' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'LensProfileFilename',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\LensProfileFilename',
                ),
                'lensprofilematchkeycameramodelname' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'LensProfileMatchKeyCameraModelName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\LensProfileMatchKeyCameraModelName',
                ),
                'lensprofilematchkeyexifmake' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'LensProfileMatchKeyExifMake',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\LensProfileMatchKeyExifMake',
                ),
                'lensprofilematchkeyexifmodel' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'LensProfileMatchKeyExifModel',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\LensProfileMatchKeyExifModel',
                ),
                'lensprofilematchkeyisraw' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'LensProfileMatchKeyIsRaw',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\LensProfileMatchKeyIsRaw',
                ),
                'lensprofilematchkeylensid' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'LensProfileMatchKeyLensID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\LensProfileMatchKeyLensID',
                ),
                'lensprofilematchkeylensinfo' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'LensProfileMatchKeyLensInfo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\LensProfileMatchKeyLensInfo',
                ),
                'lensprofilematchkeylensname' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'LensProfileMatchKeyLensName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\LensProfileMatchKeyLensName',
                ),
                'lensprofilematchkeysensorformatfactor' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'LensProfileMatchKeySensorFormatFactor',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\LensProfileMatchKeySensorFormatFactor',
                ),
                'lensprofilename' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'LensProfileName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\LensProfileName',
                ),
                'lensprofilesetup' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'LensProfileSetup',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\LensProfileSetup',
                ),
                'lensprofilevignettingscale' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'LensProfileVignettingScale',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\LensProfileVignettingScale',
                ),
                'look' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'Look',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\Look',
                ),
                'lookname' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'LookName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\LookName',
                ),
                'luminanceadjustmentaqua' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'LuminanceAdjustmentAqua',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\LuminanceAdjustmentAqua',
                ),
                'luminanceadjustmentblue' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'LuminanceAdjustmentBlue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\LuminanceAdjustmentBlue',
                ),
                'luminanceadjustmentgreen' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'LuminanceAdjustmentGreen',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\LuminanceAdjustmentGreen',
                ),
                'luminanceadjustmentmagenta' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'LuminanceAdjustmentMagenta',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\LuminanceAdjustmentMagenta',
                ),
                'luminanceadjustmentorange' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'LuminanceAdjustmentOrange',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\LuminanceAdjustmentOrange',
                ),
                'luminanceadjustmentpurple' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'LuminanceAdjustmentPurple',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\LuminanceAdjustmentPurple',
                ),
                'luminanceadjustmentred' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'LuminanceAdjustmentRed',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\LuminanceAdjustmentRed',
                ),
                'luminanceadjustmentyellow' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'LuminanceAdjustmentYellow',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\LuminanceAdjustmentYellow',
                ),
                'luminancenoisereductioncontrast' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'LuminanceNoiseReductionContrast',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\LuminanceNoiseReductionContrast',
                ),
                'luminancenoisereductiondetail' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'LuminanceNoiseReductionDetail',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\LuminanceNoiseReductionDetail',
                ),
                'luminancesmoothing' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'LuminanceSmoothing',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\LuminanceSmoothing',
                ),
                'moirefilter' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'MoireFilter',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\MoireFilter',
                ),
                'negativecachelargepreviewsize' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'NegativeCacheLargePreviewSize',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\NegativeCacheLargePreviewSize',
                ),
                'negativecachemaximumsize' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'NegativeCacheMaximumSize',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\NegativeCacheMaximumSize',
                ),
                'negativecachepath' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'NegativeCachePath',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\NegativeCachePath',
                ),
                'overridelookvignette' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'OverrideLookVignette',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\OverrideLookVignette',
                ),
                'paintbasedcorrections' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintBasedCorrections',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintBasedCorrections',
                ),
                'paintcorrectionactive' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionActive',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionActive',
                ),
                'paintcorrectionamount' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionAmount',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionAmount',
                ),
                'paintbasedcorrectionmasks' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintBasedCorrectionMasks',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintBasedCorrectionMasks',
                ),
                'paintcorrectionmaskalpha' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionMaskAlpha',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskAlpha',
                ),
                'paintcorrectionmaskangle' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionMaskAngle',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskAngle',
                ),
                'paintcorrectionmaskbottom' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionMaskBottom',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskBottom',
                ),
                'paintcorrectionmaskcentervalue' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionMaskCenterValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskCenterValue',
                ),
                'paintcorrectionmaskcenterweight' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionMaskCenterWeight',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskCenterWeight',
                ),
                'paintcorrectionmaskdabs' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionMaskDabs',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskDabs',
                ),
                'paintcorrectionmaskfeather' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionMaskFeather',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskFeather',
                ),
                'paintcorrectionmaskflipped' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionMaskFlipped',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskFlipped',
                ),
                'paintcorrectionmaskflow' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionMaskFlow',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskFlow',
                ),
                'paintcorrectionmaskfullx' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionMaskFullX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskFullX',
                ),
                'paintcorrectionmaskfully' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionMaskFullY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskFullY',
                ),
                'paintcorrectionmaskleft' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionMaskLeft',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskLeft',
                ),
                'paintcorrectionmaskvalue' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionMaskValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskValue',
                ),
                'paintcorrectionmaskmidpoint' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionMaskMidpoint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskMidpoint',
                ),
                'paintcorrectionmaskperimetervalue' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionMaskPerimeterValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskPerimeterValue',
                ),
                'paintcorrectionmaskradius' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionMaskRadius',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskRadius',
                ),
                'paintcorrectionmaskright' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionMaskRight',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskRight',
                ),
                'paintcorrectionmaskroundness' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionMaskRoundness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskRoundness',
                ),
                'paintcorrectionmasksizex' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionMaskSizeX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskSizeX',
                ),
                'paintcorrectionmasksizey' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionMaskSizeY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskSizeY',
                ),
                'paintcorrectionmasktop' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionMaskTop',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskTop',
                ),
                'paintcorrectionmaskversion' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionMaskVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskVersion',
                ),
                'paintcorrectionmaskwhat' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionMaskWhat',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskWhat',
                ),
                'paintcorrectionmaskx' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionMaskX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskX',
                ),
                'paintcorrectionmasky' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionMaskY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskY',
                ),
                'paintcorrectionmaskzerox' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionMaskZeroX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskZeroX',
                ),
                'paintcorrectionmaskzeroy' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionMaskZeroY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMaskZeroY',
                ),
                'paintcorrectionbrightness' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionBrightness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionBrightness',
                ),
                'paintcorrectionclarity' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionClarity',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionClarity',
                ),
                'paintcorrectionclarity2012' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionClarity2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionClarity2012',
                ),
                'paintcorrectioncontrast' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionContrast',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionContrast',
                ),
                'paintcorrectioncontrast2012' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionContrast2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionContrast2012',
                ),
                'paintcorrectiondefringe' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionDefringe',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionDefringe',
                ),
                'paintcorrectionexposure' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionExposure',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionExposure',
                ),
                'paintcorrectionexposure2012' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionExposure2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionExposure2012',
                ),
                'paintcorrectionhighlights2012' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionHighlights2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionHighlights2012',
                ),
                'paintcorrectionluminancenoise' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionLuminanceNoise',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionLuminanceNoise',
                ),
                'paintcorrectionmoire' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionMoire',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionMoire',
                ),
                'paintcorrectionsaturation' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionSaturation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionSaturation',
                ),
                'paintcorrectionshadows2012' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionShadows2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionShadows2012',
                ),
                'paintcorrectionsharpness' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionSharpness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionSharpness',
                ),
                'paintcorrectiontemperature' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionTemperature',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionTemperature',
                ),
                'paintcorrectiontint' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionTint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionTint',
                ),
                'paintcorrectionhue' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionHue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionHue',
                ),
                'paintcorrectionwhat' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PaintCorrectionWhat',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PaintCorrectionWhat',
                ),
                'parametricdarks' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'ParametricDarks',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\ParametricDarks',
                ),
                'parametrichighlights' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'ParametricHighlights',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\ParametricHighlights',
                ),
                'parametrichighlightsplit' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'ParametricHighlightSplit',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\ParametricHighlightSplit',
                ),
                'parametriclights' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'ParametricLights',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\ParametricLights',
                ),
                'parametricmidtonesplit' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'ParametricMidtoneSplit',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\ParametricMidtoneSplit',
                ),
                'parametricshadows' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'ParametricShadows',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\ParametricShadows',
                ),
                'parametricshadowsplit' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'ParametricShadowSplit',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\ParametricShadowSplit',
                ),
                'perspectiveaspect' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PerspectiveAspect',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PerspectiveAspect',
                ),
                'perspectivehorizontal' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PerspectiveHorizontal',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PerspectiveHorizontal',
                ),
                'perspectiverotate' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PerspectiveRotate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PerspectiveRotate',
                ),
                'perspectivescale' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PerspectiveScale',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PerspectiveScale',
                ),
                'perspectiveupright' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PerspectiveUpright',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PerspectiveUpright',
                ),
                'perspectivevertical' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PerspectiveVertical',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PerspectiveVertical',
                ),
                'perspectivex' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PerspectiveX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PerspectiveX',
                ),
                'perspectivey' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PerspectiveY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PerspectiveY',
                ),
                'postcropvignetteamount' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PostCropVignetteAmount',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PostCropVignetteAmount',
                ),
                'postcropvignettefeather' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PostCropVignetteFeather',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PostCropVignetteFeather',
                ),
                'postcropvignettehighlightcontrast' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PostCropVignetteHighlightContrast',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PostCropVignetteHighlightContrast',
                ),
                'postcropvignettemidpoint' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PostCropVignetteMidpoint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PostCropVignetteMidpoint',
                ),
                'postcropvignetteroundness' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PostCropVignetteRoundness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PostCropVignetteRoundness',
                ),
                'postcropvignettestyle' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'PostCropVignetteStyle',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\PostCropVignetteStyle',
                ),
                'processversion' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'ProcessVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\ProcessVersion',
                ),
                'rawfilename' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RawFileName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RawFileName',
                ),
                'redeyeinfo' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RedEyeInfo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RedEyeInfo',
                ),
                'redhue' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RedHue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RedHue',
                ),
                'redsaturation' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RedSaturation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RedSaturation',
                ),
                'retouchareas' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreas',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreas',
                ),
                'retouchareafeather' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaFeather',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaFeather',
                ),
                'retouchareamasks' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaMasks',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMasks',
                ),
                'retouchareamaskalpha' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaMaskAlpha',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskAlpha',
                ),
                'retouchareamaskangle' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaMaskAngle',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskAngle',
                ),
                'retouchareamaskbottom' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaMaskBottom',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskBottom',
                ),
                'retouchareamaskcentervalue' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaMaskCenterValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskCenterValue',
                ),
                'retouchareamaskcenterweight' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaMaskCenterWeight',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskCenterWeight',
                ),
                'retouchareamaskdabs' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaMaskDabs',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskDabs',
                ),
                'retouchareamaskfeather' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaMaskFeather',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskFeather',
                ),
                'retouchareamaskflipped' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaMaskFlipped',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskFlipped',
                ),
                'retouchareamaskflow' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaMaskFlow',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskFlow',
                ),
                'retouchareamaskfullx' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaMaskFullX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskFullX',
                ),
                'retouchareamaskfully' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaMaskFullY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskFullY',
                ),
                'retouchareamaskleft' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaMaskLeft',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskLeft',
                ),
                'retouchareamaskvalue' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaMaskValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskValue',
                ),
                'retouchareamaskmidpoint' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaMaskMidpoint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskMidpoint',
                ),
                'retouchareamaskperimetervalue' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaMaskPerimeterValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskPerimeterValue',
                ),
                'retouchareamaskradius' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaMaskRadius',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskRadius',
                ),
                'retouchareamaskright' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaMaskRight',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskRight',
                ),
                'retouchareamaskroundness' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaMaskRoundness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskRoundness',
                ),
                'retouchareamasksizex' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaMaskSizeX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskSizeX',
                ),
                'retouchareamasksizey' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaMaskSizeY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskSizeY',
                ),
                'retouchareamasktop' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaMaskTop',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskTop',
                ),
                'retouchareamaskversion' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaMaskVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskVersion',
                ),
                'retouchareamaskwhat' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaMaskWhat',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskWhat',
                ),
                'retouchareamaskx' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaMaskX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskX',
                ),
                'retouchareamasky' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaMaskY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskY',
                ),
                'retouchareamaskzerox' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaMaskZeroX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskZeroX',
                ),
                'retouchareamaskzeroy' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaMaskZeroY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMaskZeroY',
                ),
                'retouchareamethod' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaMethod',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaMethod',
                ),
                'retouchareaoffsety' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaOffsetY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaOffsetY',
                ),
                'retouchareaopacity' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaOpacity',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaOpacity',
                ),
                'retouchareaseed' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaSeed',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaSeed',
                ),
                'retouchareasourcestate' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaSourceState',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaSourceState',
                ),
                'retouchareasourcex' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaSourceX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaSourceX',
                ),
                'retouchareaspottype' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchAreaSpotType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchAreaSpotType',
                ),
                'retouchinfo' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'RetouchInfo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\RetouchInfo',
                ),
                'saturation' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'Saturation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\Saturation',
                ),
                'saturationadjustmentaqua' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'SaturationAdjustmentAqua',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\SaturationAdjustmentAqua',
                ),
                'saturationadjustmentblue' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'SaturationAdjustmentBlue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\SaturationAdjustmentBlue',
                ),
                'saturationadjustmentgreen' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'SaturationAdjustmentGreen',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\SaturationAdjustmentGreen',
                ),
                'saturationadjustmentmagenta' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'SaturationAdjustmentMagenta',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\SaturationAdjustmentMagenta',
                ),
                'saturationadjustmentorange' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'SaturationAdjustmentOrange',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\SaturationAdjustmentOrange',
                ),
                'saturationadjustmentpurple' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'SaturationAdjustmentPurple',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\SaturationAdjustmentPurple',
                ),
                'saturationadjustmentred' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'SaturationAdjustmentRed',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\SaturationAdjustmentRed',
                ),
                'saturationadjustmentyellow' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'SaturationAdjustmentYellow',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\SaturationAdjustmentYellow',
                ),
                'shadows' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'Shadows',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\Shadows',
                ),
                'shadows2012' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'Shadows2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\Shadows2012',
                ),
                'shadowtint' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'ShadowTint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\ShadowTint',
                ),
                'sharpendetail' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'SharpenDetail',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\SharpenDetail',
                ),
                'sharpenedgemasking' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'SharpenEdgeMasking',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\SharpenEdgeMasking',
                ),
                'sharpenradius' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'SharpenRadius',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\SharpenRadius',
                ),
                'sharpness' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'Sharpness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\Sharpness',
                ),
                'smoothness' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'Smoothness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\Smoothness',
                ),
                'splittoningbalance' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'SplitToningBalance',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\SplitToningBalance',
                ),
                'splittoninghighlighthue' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'SplitToningHighlightHue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\SplitToningHighlightHue',
                ),
                'splittoninghighlightsaturation' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'SplitToningHighlightSaturation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\SplitToningHighlightSaturation',
                ),
                'splittoningshadowhue' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'SplitToningShadowHue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\SplitToningShadowHue',
                ),
                'splittoningshadowsaturation' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'SplitToningShadowSaturation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\SplitToningShadowSaturation',
                ),
                'colortemperature' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'ColorTemperature',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\ColorTemperature',
                ),
                'texture' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'Texture',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\Texture',
                ),
                'tiffhandling' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'TIFFHandling',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\TIFFHandling',
                ),
                'tint' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'Tint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\Tint',
                ),
                'tonecurve' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'ToneCurve',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\ToneCurve',
                ),
                'tonecurveblue' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'ToneCurveBlue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\ToneCurveBlue',
                ),
                'tonecurvegreen' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'ToneCurveGreen',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\ToneCurveGreen',
                ),
                'tonecurvename' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'ToneCurveName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\ToneCurveName',
                ),
                'tonecurvename2012' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'ToneCurveName2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\ToneCurveName2012',
                ),
                'tonecurvepv2012' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'ToneCurvePV2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\ToneCurvePV2012',
                ),
                'tonecurvepv2012blue' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'ToneCurvePV2012Blue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\ToneCurvePV2012Blue',
                ),
                'tonecurvepv2012green' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'ToneCurvePV2012Green',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\ToneCurvePV2012Green',
                ),
                'tonecurvepv2012red' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'ToneCurvePV2012Red',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\ToneCurvePV2012Red',
                ),
                'tonecurvered' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'ToneCurveRed',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\ToneCurveRed',
                ),
                'tonemapstrength' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'ToneMapStrength',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\ToneMapStrength',
                ),
                'uprightcentermode' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'UprightCenterMode',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\UprightCenterMode',
                ),
                'uprightcenternormx' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'UprightCenterNormX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\UprightCenterNormX',
                ),
                'uprightcenternormy' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'UprightCenterNormY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\UprightCenterNormY',
                ),
                'uprightdependentdigest' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'UprightDependentDigest',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\UprightDependentDigest',
                ),
                'uprightfocallength35mm' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'UprightFocalLength35mm',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\UprightFocalLength35mm',
                ),
                'uprightfocalmode' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'UprightFocalMode',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\UprightFocalMode',
                ),
                'uprightfoursegmentscount' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'UprightFourSegmentsCount',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\UprightFourSegmentsCount',
                ),
                'uprightpreview' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'UprightPreview',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\UprightPreview',
                ),
                'uprighttransform_0' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'UprightTransform_0',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\UprightTransform0',
                ),
                'uprighttransform_1' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'UprightTransform_1',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\UprightTransform1',
                ),
                'uprighttransform_2' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'UprightTransform_2',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\UprightTransform2',
                ),
                'uprighttransform_3' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'UprightTransform_3',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\UprightTransform3',
                ),
                'uprighttransform_4' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'UprightTransform_4',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\UprightTransform4',
                ),
                'uprighttransform_5' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'UprightTransform_5',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\UprightTransform5',
                ),
                'uprighttransformcount' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'UprightTransformCount',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\UprightTransformCount',
                ),
                'uprightversion' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'UprightVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\UprightVersion',
                ),
                'version' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'Version',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\Version',
                ),
                'vibrance' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'Vibrance',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\Vibrance',
                ),
                'vignetteamount' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'VignetteAmount',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\VignetteAmount',
                ),
                'vignettemidpoint' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'VignetteMidpoint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\VignetteMidpoint',
                ),
                'what' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'What',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\What',
                ),
                'whitebalance' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'WhiteBalance',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\WhiteBalance',
                ),
                'whites2012' => array(
                    'namespace' => 'XMP-crd',
                    'tagname' => 'Whites2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrd\Whites2012',
                ),
            ),
            'xmp-creatoratom' => array(
                'aeprojectlink' => array(
                    'namespace' => 'XMP-creatorAtom',
                    'tagname' => 'AeProjectLink',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCreatorAtom\AeProjectLink',
                ),
                'aeprojectlinkcompositionid' => array(
                    'namespace' => 'XMP-creatorAtom',
                    'tagname' => 'AeProjectLinkCompositionID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCreatorAtom\AeProjectLinkCompositionID',
                ),
                'aeprojectlinkfullpath' => array(
                    'namespace' => 'XMP-creatorAtom',
                    'tagname' => 'AeProjectLinkFullPath',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCreatorAtom\AeProjectLinkFullPath',
                ),
                'aeprojectlinkrenderoutputmoduleindex' => array(
                    'namespace' => 'XMP-creatorAtom',
                    'tagname' => 'AeProjectLinkRenderOutputModuleIndex',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCreatorAtom\AeProjectLinkRenderOutputModuleIndex',
                ),
                'aeprojectlinkrenderqueueitemid' => array(
                    'namespace' => 'XMP-creatorAtom',
                    'tagname' => 'AeProjectLinkRenderQueueItemID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCreatorAtom\AeProjectLinkRenderQueueItemID',
                ),
                'aeprojectlinkrendertimestamp' => array(
                    'namespace' => 'XMP-creatorAtom',
                    'tagname' => 'AeProjectLinkRenderTimeStamp',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCreatorAtom\AeProjectLinkRenderTimeStamp',
                ),
                'macatom' => array(
                    'namespace' => 'XMP-creatorAtom',
                    'tagname' => 'MacAtom',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCreatorAtom\MacAtom',
                ),
                'macatomapplicationcode' => array(
                    'namespace' => 'XMP-creatorAtom',
                    'tagname' => 'MacAtomApplicationCode',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCreatorAtom\MacAtomApplicationCode',
                ),
                'macatominvocationappleevent' => array(
                    'namespace' => 'XMP-creatorAtom',
                    'tagname' => 'MacAtomInvocationAppleEvent',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCreatorAtom\MacAtomInvocationAppleEvent',
                ),
                'macatomposixprojectpath' => array(
                    'namespace' => 'XMP-creatorAtom',
                    'tagname' => 'MacAtomPosixProjectPath',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCreatorAtom\MacAtomPosixProjectPath',
                ),
                'windowsatom' => array(
                    'namespace' => 'XMP-creatorAtom',
                    'tagname' => 'WindowsAtom',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCreatorAtom\WindowsAtom',
                ),
                'windowsatomextension' => array(
                    'namespace' => 'XMP-creatorAtom',
                    'tagname' => 'WindowsAtomExtension',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCreatorAtom\WindowsAtomExtension',
                ),
                'windowsatominvocationflags' => array(
                    'namespace' => 'XMP-creatorAtom',
                    'tagname' => 'WindowsAtomInvocationFlags',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCreatorAtom\WindowsAtomInvocationFlags',
                ),
                'windowsatomuncprojectpath' => array(
                    'namespace' => 'XMP-creatorAtom',
                    'tagname' => 'WindowsAtomUncProjectPath',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCreatorAtom\WindowsAtomUncProjectPath',
                ),
            ),
            'xmp-crs' => array(
                'alreadyapplied' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'AlreadyApplied',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\AlreadyApplied',
                ),
                'autobrightness' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'AutoBrightness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\AutoBrightness',
                ),
                'autocontrast' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'AutoContrast',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\AutoContrast',
                ),
                'autoexposure' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'AutoExposure',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\AutoExposure',
                ),
                'autolateralca' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'AutoLateralCA',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\AutoLateralCA',
                ),
                'autoshadows' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'AutoShadows',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\AutoShadows',
                ),
                'autotone' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'AutoTone',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\AutoTone',
                ),
                'autowhiteversion' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'AutoWhiteVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\AutoWhiteVersion',
                ),
                'blacks2012' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'Blacks2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\Blacks2012',
                ),
                'bluehue' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'BlueHue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\BlueHue',
                ),
                'bluesaturation' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'BlueSaturation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\BlueSaturation',
                ),
                'brightness' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'Brightness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\Brightness',
                ),
                'cameraprofile' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CameraProfile',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CameraProfile',
                ),
                'cameraprofiledigest' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CameraProfileDigest',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CameraProfileDigest',
                ),
                'chromaticaberrationb' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'ChromaticAberrationB',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\ChromaticAberrationB',
                ),
                'chromaticaberrationr' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'ChromaticAberrationR',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\ChromaticAberrationR',
                ),
                'circulargradientbasedcorrections' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircularGradientBasedCorrections',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircularGradientBasedCorrections',
                ),
                'circgradbasedcorractive' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrActive',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrActive',
                ),
                'circgradbasedcorramount' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrAmount',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrAmount',
                ),
                'circgradbasedcorrmasks' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrMasks',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMasks',
                ),
                'circgradbasedcorrmaskalpha' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrMaskAlpha',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskAlpha',
                ),
                'circgradbasedcorrmaskangle' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrMaskAngle',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskAngle',
                ),
                'circgradbasedcorrmaskbottom' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrMaskBottom',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskBottom',
                ),
                'circgradbasedcorrmaskcentervalue' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrMaskCenterValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskCenterValue',
                ),
                'circgradbasedcorrmaskcenterweight' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrMaskCenterWeight',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskCenterWeight',
                ),
                'circgradbasedcorrmaskdabs' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrMaskDabs',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskDabs',
                ),
                'circgradbasedcorrmaskfeather' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrMaskFeather',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskFeather',
                ),
                'circgradbasedcorrmaskflipped' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrMaskFlipped',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskFlipped',
                ),
                'circgradbasedcorrmaskflow' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrMaskFlow',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskFlow',
                ),
                'circgradbasedcorrmaskfullx' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrMaskFullX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskFullX',
                ),
                'circgradbasedcorrmaskfully' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrMaskFullY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskFullY',
                ),
                'circgradbasedcorrmaskleft' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrMaskLeft',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskLeft',
                ),
                'circgradbasedcorrmaskvalue' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrMaskValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskValue',
                ),
                'circgradbasedcorrmaskmidpoint' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrMaskMidpoint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskMidpoint',
                ),
                'circgradbasedcorrmaskperimetervalue' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrMaskPerimeterValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskPerimeterValue',
                ),
                'circgradbasedcorrmaskradius' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrMaskRadius',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskRadius',
                ),
                'circgradbasedcorrmaskright' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrMaskRight',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskRight',
                ),
                'circgradbasedcorrmaskroundness' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrMaskRoundness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskRoundness',
                ),
                'circgradbasedcorrmasksizex' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrMaskSizeX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskSizeX',
                ),
                'circgradbasedcorrmasksizey' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrMaskSizeY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskSizeY',
                ),
                'circgradbasedcorrmasktop' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrMaskTop',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskTop',
                ),
                'circgradbasedcorrmaskversion' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrMaskVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskVersion',
                ),
                'circgradbasedcorrmaskwhat' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrMaskWhat',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskWhat',
                ),
                'circgradbasedcorrmaskx' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrMaskX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskX',
                ),
                'circgradbasedcorrmasky' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrMaskY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskY',
                ),
                'circgradbasedcorrmaskzerox' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrMaskZeroX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskZeroX',
                ),
                'circgradbasedcorrmaskzeroy' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrMaskZeroY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMaskZeroY',
                ),
                'circgradbasedcorrbrightness' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrBrightness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrBrightness',
                ),
                'circgradbasedcorrclarity' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrClarity',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrClarity',
                ),
                'circgradbasedcorrclarity2012' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrClarity2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrClarity2012',
                ),
                'circgradbasedcorrcontrast' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrContrast',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrContrast',
                ),
                'circgradbasedcorrcontrast2012' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrContrast2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrContrast2012',
                ),
                'circgradbasedcorrdefringe' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrDefringe',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrDefringe',
                ),
                'circgradbasedcorrexposure' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrExposure',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrExposure',
                ),
                'circgradbasedcorrexposure2012' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrExposure2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrExposure2012',
                ),
                'circgradbasedcorrhighlights2012' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrHighlights2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrHighlights2012',
                ),
                'circgradbasedcorrluminancenoise' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrLuminanceNoise',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrLuminanceNoise',
                ),
                'circgradbasedcorrmoire' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrMoire',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrMoire',
                ),
                'circgradbasedcorrsaturation' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrSaturation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrSaturation',
                ),
                'circgradbasedcorrshadows2012' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrShadows2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrShadows2012',
                ),
                'circgradbasedcorrsharpness' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrSharpness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrSharpness',
                ),
                'circgradbasedcorrtemperature' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrTemperature',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrTemperature',
                ),
                'circgradbasedcorrtint' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrTint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrTint',
                ),
                'circgradbasedcorrhue' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrHue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrHue',
                ),
                'circgradbasedcorrwhat' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CircGradBasedCorrWhat',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CircGradBasedCorrWhat',
                ),
                'clarity' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'Clarity',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\Clarity',
                ),
                'clarity2012' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'Clarity2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\Clarity2012',
                ),
                'colornoisereduction' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'ColorNoiseReduction',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\ColorNoiseReduction',
                ),
                'colornoisereductiondetail' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'ColorNoiseReductionDetail',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\ColorNoiseReductionDetail',
                ),
                'colornoisereductionsmoothness' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'ColorNoiseReductionSmoothness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\ColorNoiseReductionSmoothness',
                ),
                'contrast' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'Contrast',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\Contrast',
                ),
                'contrast2012' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'Contrast2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\Contrast2012',
                ),
                'converter' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'Converter',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\Converter',
                ),
                'converttograyscale' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'ConvertToGrayscale',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\ConvertToGrayscale',
                ),
                'cropangle' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CropAngle',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CropAngle',
                ),
                'cropbottom' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CropBottom',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CropBottom',
                ),
                'cropconstraintowarp' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CropConstrainToWarp',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CropConstrainToWarp',
                ),
                'cropheight' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CropHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CropHeight',
                ),
                'cropleft' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CropLeft',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CropLeft',
                ),
                'cropright' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CropRight',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CropRight',
                ),
                'croptop' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CropTop',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CropTop',
                ),
                'cropunit' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CropUnit',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CropUnit',
                ),
                'cropunits' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CropUnits',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CropUnits',
                ),
                'cropwidth' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'CropWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\CropWidth',
                ),
                'defaultautogray' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'DefaultAutoGray',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\DefaultAutoGray',
                ),
                'defaultautotone' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'DefaultAutoTone',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\DefaultAutoTone',
                ),
                'defaultsspecifictoiso' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'DefaultsSpecificToISO',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\DefaultsSpecificToISO',
                ),
                'defaultsspecifictoserial' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'DefaultsSpecificToSerial',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\DefaultsSpecificToSerial',
                ),
                'defringe' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'Defringe',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\Defringe',
                ),
                'defringegreenamount' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'DefringeGreenAmount',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\DefringeGreenAmount',
                ),
                'defringegreenhuehi' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'DefringeGreenHueHi',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\DefringeGreenHueHi',
                ),
                'defringegreenhuelo' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'DefringeGreenHueLo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\DefringeGreenHueLo',
                ),
                'defringepurpleamount' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'DefringePurpleAmount',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\DefringePurpleAmount',
                ),
                'defringepurplehuehi' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'DefringePurpleHueHi',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\DefringePurpleHueHi',
                ),
                'defringepurplehuelo' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'DefringePurpleHueLo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\DefringePurpleHueLo',
                ),
                'dehaze' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'Dehaze',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\Dehaze',
                ),
                'dngignoresidecars' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'DNGIgnoreSidecars',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\DNGIgnoreSidecars',
                ),
                'exposure' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'Exposure',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\Exposure',
                ),
                'exposure2012' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'Exposure2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\Exposure2012',
                ),
                'filllight' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'FillLight',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\FillLight',
                ),
                'gradientbasedcorrections' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrections',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrections',
                ),
                'gradientbasedcorractive' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrActive',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrActive',
                ),
                'gradientbasedcorramount' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrAmount',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrAmount',
                ),
                'gradientbasedcorrmasks' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrMasks',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMasks',
                ),
                'gradientbasedcorrmaskalpha' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrMaskAlpha',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskAlpha',
                ),
                'gradientbasedcorrmaskangle' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrMaskAngle',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskAngle',
                ),
                'gradientbasedcorrmaskbottom' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrMaskBottom',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskBottom',
                ),
                'gradientbasedcorrmaskcentervalue' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrMaskCenterValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskCenterValue',
                ),
                'gradientbasedcorrmaskcenterweight' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrMaskCenterWeight',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskCenterWeight',
                ),
                'gradientbasedcorrmaskdabs' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrMaskDabs',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskDabs',
                ),
                'gradientbasedcorrmaskfeather' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrMaskFeather',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskFeather',
                ),
                'gradientbasedcorrmaskflipped' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrMaskFlipped',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskFlipped',
                ),
                'gradientbasedcorrmaskflow' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrMaskFlow',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskFlow',
                ),
                'gradientbasedcorrmaskfullx' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrMaskFullX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskFullX',
                ),
                'gradientbasedcorrmaskfully' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrMaskFullY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskFullY',
                ),
                'gradientbasedcorrmaskleft' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrMaskLeft',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskLeft',
                ),
                'gradientbasedcorrmaskvalue' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrMaskValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskValue',
                ),
                'gradientbasedcorrmaskmidpoint' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrMaskMidpoint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskMidpoint',
                ),
                'gradientbasedcorrmaskperimetervalue' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrMaskPerimeterValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskPerimeterValue',
                ),
                'gradientbasedcorrmaskradius' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrMaskRadius',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskRadius',
                ),
                'gradientbasedcorrmaskright' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrMaskRight',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskRight',
                ),
                'gradientbasedcorrmaskroundness' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrMaskRoundness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskRoundness',
                ),
                'gradientbasedcorrmasksizex' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrMaskSizeX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskSizeX',
                ),
                'gradientbasedcorrmasksizey' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrMaskSizeY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskSizeY',
                ),
                'gradientbasedcorrmasktop' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrMaskTop',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskTop',
                ),
                'gradientbasedcorrmaskversion' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrMaskVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskVersion',
                ),
                'gradientbasedcorrmaskwhat' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrMaskWhat',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskWhat',
                ),
                'gradientbasedcorrmaskx' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrMaskX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskX',
                ),
                'gradientbasedcorrmasky' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrMaskY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskY',
                ),
                'gradientbasedcorrmaskzerox' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrMaskZeroX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskZeroX',
                ),
                'gradientbasedcorrmaskzeroy' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrMaskZeroY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMaskZeroY',
                ),
                'gradientbasedcorrbrightness' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrBrightness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrBrightness',
                ),
                'gradientbasedcorrclarity' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrClarity',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrClarity',
                ),
                'gradientbasedcorrclarity2012' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrClarity2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrClarity2012',
                ),
                'gradientbasedcorrcontrast' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrContrast',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrContrast',
                ),
                'gradientbasedcorrcontrast2012' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrContrast2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrContrast2012',
                ),
                'gradientbasedcorrdefringe' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrDefringe',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrDefringe',
                ),
                'gradientbasedcorrexposure' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrExposure',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrExposure',
                ),
                'gradientbasedcorrexposure2012' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrExposure2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrExposure2012',
                ),
                'gradientbasedcorrhighlights2012' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrHighlights2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrHighlights2012',
                ),
                'gradientbasedcorrluminancenoise' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrLuminanceNoise',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrLuminanceNoise',
                ),
                'gradientbasedcorrmoire' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrMoire',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrMoire',
                ),
                'gradientbasedcorrsaturation' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrSaturation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrSaturation',
                ),
                'gradientbasedcorrshadows2012' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrShadows2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrShadows2012',
                ),
                'gradientbasedcorrsharpness' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrSharpness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrSharpness',
                ),
                'gradientbasedcorrtemperature' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrTemperature',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrTemperature',
                ),
                'gradientbasedcorrtint' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrTint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrTint',
                ),
                'gradientbasedcorrhue' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrHue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrHue',
                ),
                'gradientbasedcorrwhat' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GradientBasedCorrWhat',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GradientBasedCorrWhat',
                ),
                'grainamount' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GrainAmount',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GrainAmount',
                ),
                'grainfrequency' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GrainFrequency',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GrainFrequency',
                ),
                'grainsize' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GrainSize',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GrainSize',
                ),
                'graymixeraqua' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GrayMixerAqua',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GrayMixerAqua',
                ),
                'graymixerblue' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GrayMixerBlue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GrayMixerBlue',
                ),
                'graymixergreen' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GrayMixerGreen',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GrayMixerGreen',
                ),
                'graymixermagenta' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GrayMixerMagenta',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GrayMixerMagenta',
                ),
                'graymixerorange' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GrayMixerOrange',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GrayMixerOrange',
                ),
                'graymixerpurple' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GrayMixerPurple',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GrayMixerPurple',
                ),
                'graymixerred' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GrayMixerRed',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GrayMixerRed',
                ),
                'graymixeryellow' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GrayMixerYellow',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GrayMixerYellow',
                ),
                'greenhue' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GreenHue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GreenHue',
                ),
                'greensaturation' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'GreenSaturation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\GreenSaturation',
                ),
                'hascrop' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'HasCrop',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\HasCrop',
                ),
                'hassettings' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'HasSettings',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\HasSettings',
                ),
                'highlight2012' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'Highlight2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\Highlight2012',
                ),
                'highlightrecovery' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'HighlightRecovery',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\HighlightRecovery',
                ),
                'highlights2012' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'Highlights2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\Highlights2012',
                ),
                'hueadjustmentaqua' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'HueAdjustmentAqua',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\HueAdjustmentAqua',
                ),
                'hueadjustmentblue' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'HueAdjustmentBlue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\HueAdjustmentBlue',
                ),
                'hueadjustmentgreen' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'HueAdjustmentGreen',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\HueAdjustmentGreen',
                ),
                'hueadjustmentmagenta' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'HueAdjustmentMagenta',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\HueAdjustmentMagenta',
                ),
                'hueadjustmentorange' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'HueAdjustmentOrange',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\HueAdjustmentOrange',
                ),
                'hueadjustmentpurple' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'HueAdjustmentPurple',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\HueAdjustmentPurple',
                ),
                'hueadjustmentred' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'HueAdjustmentRed',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\HueAdjustmentRed',
                ),
                'hueadjustmentyellow' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'HueAdjustmentYellow',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\HueAdjustmentYellow',
                ),
                'incrementaltemperature' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'IncrementalTemperature',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\IncrementalTemperature',
                ),
                'incrementaltint' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'IncrementalTint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\IncrementalTint',
                ),
                'jpeghandling' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'JPEGHandling',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\JPEGHandling',
                ),
                'lensmanualdistortionamount' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'LensManualDistortionAmount',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\LensManualDistortionAmount',
                ),
                'lensprofilechromaticaberrationscale' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'LensProfileChromaticAberrationScale',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\LensProfileChromaticAberrationScale',
                ),
                'lensprofiledigest' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'LensProfileDigest',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\LensProfileDigest',
                ),
                'lensprofiledistortionscale' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'LensProfileDistortionScale',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\LensProfileDistortionScale',
                ),
                'lensprofileenable' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'LensProfileEnable',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\LensProfileEnable',
                ),
                'lensprofilefilename' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'LensProfileFilename',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\LensProfileFilename',
                ),
                'lensprofilematchkeycameramodelname' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'LensProfileMatchKeyCameraModelName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\LensProfileMatchKeyCameraModelName',
                ),
                'lensprofilematchkeyexifmake' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'LensProfileMatchKeyExifMake',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\LensProfileMatchKeyExifMake',
                ),
                'lensprofilematchkeyexifmodel' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'LensProfileMatchKeyExifModel',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\LensProfileMatchKeyExifModel',
                ),
                'lensprofilematchkeyisraw' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'LensProfileMatchKeyIsRaw',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\LensProfileMatchKeyIsRaw',
                ),
                'lensprofilematchkeylensid' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'LensProfileMatchKeyLensID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\LensProfileMatchKeyLensID',
                ),
                'lensprofilematchkeylensinfo' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'LensProfileMatchKeyLensInfo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\LensProfileMatchKeyLensInfo',
                ),
                'lensprofilematchkeylensname' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'LensProfileMatchKeyLensName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\LensProfileMatchKeyLensName',
                ),
                'lensprofilematchkeysensorformatfactor' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'LensProfileMatchKeySensorFormatFactor',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\LensProfileMatchKeySensorFormatFactor',
                ),
                'lensprofilename' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'LensProfileName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\LensProfileName',
                ),
                'lensprofilesetup' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'LensProfileSetup',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\LensProfileSetup',
                ),
                'lensprofilevignettingscale' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'LensProfileVignettingScale',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\LensProfileVignettingScale',
                ),
                'look' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'Look',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\Look',
                ),
                'lookname' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'LookName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\LookName',
                ),
                'luminanceadjustmentaqua' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'LuminanceAdjustmentAqua',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\LuminanceAdjustmentAqua',
                ),
                'luminanceadjustmentblue' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'LuminanceAdjustmentBlue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\LuminanceAdjustmentBlue',
                ),
                'luminanceadjustmentgreen' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'LuminanceAdjustmentGreen',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\LuminanceAdjustmentGreen',
                ),
                'luminanceadjustmentmagenta' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'LuminanceAdjustmentMagenta',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\LuminanceAdjustmentMagenta',
                ),
                'luminanceadjustmentorange' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'LuminanceAdjustmentOrange',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\LuminanceAdjustmentOrange',
                ),
                'luminanceadjustmentpurple' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'LuminanceAdjustmentPurple',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\LuminanceAdjustmentPurple',
                ),
                'luminanceadjustmentred' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'LuminanceAdjustmentRed',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\LuminanceAdjustmentRed',
                ),
                'luminanceadjustmentyellow' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'LuminanceAdjustmentYellow',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\LuminanceAdjustmentYellow',
                ),
                'luminancenoisereductioncontrast' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'LuminanceNoiseReductionContrast',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\LuminanceNoiseReductionContrast',
                ),
                'luminancenoisereductiondetail' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'LuminanceNoiseReductionDetail',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\LuminanceNoiseReductionDetail',
                ),
                'luminancesmoothing' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'LuminanceSmoothing',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\LuminanceSmoothing',
                ),
                'moirefilter' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'MoireFilter',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\MoireFilter',
                ),
                'negativecachelargepreviewsize' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'NegativeCacheLargePreviewSize',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\NegativeCacheLargePreviewSize',
                ),
                'negativecachemaximumsize' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'NegativeCacheMaximumSize',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\NegativeCacheMaximumSize',
                ),
                'negativecachepath' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'NegativeCachePath',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\NegativeCachePath',
                ),
                'overridelookvignette' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'OverrideLookVignette',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\OverrideLookVignette',
                ),
                'paintbasedcorrections' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintBasedCorrections',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintBasedCorrections',
                ),
                'paintcorrectionactive' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionActive',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionActive',
                ),
                'paintcorrectionamount' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionAmount',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionAmount',
                ),
                'paintbasedcorrectionmasks' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintBasedCorrectionMasks',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintBasedCorrectionMasks',
                ),
                'paintcorrectionmaskalpha' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionMaskAlpha',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskAlpha',
                ),
                'paintcorrectionmaskangle' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionMaskAngle',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskAngle',
                ),
                'paintcorrectionmaskbottom' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionMaskBottom',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskBottom',
                ),
                'paintcorrectionmaskcentervalue' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionMaskCenterValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskCenterValue',
                ),
                'paintcorrectionmaskcenterweight' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionMaskCenterWeight',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskCenterWeight',
                ),
                'paintcorrectionmaskdabs' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionMaskDabs',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskDabs',
                ),
                'paintcorrectionmaskfeather' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionMaskFeather',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskFeather',
                ),
                'paintcorrectionmaskflipped' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionMaskFlipped',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskFlipped',
                ),
                'paintcorrectionmaskflow' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionMaskFlow',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskFlow',
                ),
                'paintcorrectionmaskfullx' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionMaskFullX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskFullX',
                ),
                'paintcorrectionmaskfully' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionMaskFullY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskFullY',
                ),
                'paintcorrectionmaskleft' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionMaskLeft',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskLeft',
                ),
                'paintcorrectionmaskvalue' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionMaskValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskValue',
                ),
                'paintcorrectionmaskmidpoint' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionMaskMidpoint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskMidpoint',
                ),
                'paintcorrectionmaskperimetervalue' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionMaskPerimeterValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskPerimeterValue',
                ),
                'paintcorrectionmaskradius' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionMaskRadius',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskRadius',
                ),
                'paintcorrectionmaskright' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionMaskRight',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskRight',
                ),
                'paintcorrectionmaskroundness' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionMaskRoundness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskRoundness',
                ),
                'paintcorrectionmasksizex' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionMaskSizeX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskSizeX',
                ),
                'paintcorrectionmasksizey' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionMaskSizeY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskSizeY',
                ),
                'paintcorrectionmasktop' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionMaskTop',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskTop',
                ),
                'paintcorrectionmaskversion' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionMaskVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskVersion',
                ),
                'paintcorrectionmaskwhat' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionMaskWhat',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskWhat',
                ),
                'paintcorrectionmaskx' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionMaskX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskX',
                ),
                'paintcorrectionmasky' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionMaskY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskY',
                ),
                'paintcorrectionmaskzerox' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionMaskZeroX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskZeroX',
                ),
                'paintcorrectionmaskzeroy' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionMaskZeroY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMaskZeroY',
                ),
                'paintcorrectionbrightness' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionBrightness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionBrightness',
                ),
                'paintcorrectionclarity' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionClarity',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionClarity',
                ),
                'paintcorrectionclarity2012' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionClarity2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionClarity2012',
                ),
                'paintcorrectioncontrast' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionContrast',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionContrast',
                ),
                'paintcorrectioncontrast2012' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionContrast2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionContrast2012',
                ),
                'paintcorrectiondefringe' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionDefringe',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionDefringe',
                ),
                'paintcorrectionexposure' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionExposure',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionExposure',
                ),
                'paintcorrectionexposure2012' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionExposure2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionExposure2012',
                ),
                'paintcorrectionhighlights2012' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionHighlights2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionHighlights2012',
                ),
                'paintcorrectionluminancenoise' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionLuminanceNoise',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionLuminanceNoise',
                ),
                'paintcorrectionmoire' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionMoire',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionMoire',
                ),
                'paintcorrectionsaturation' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionSaturation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionSaturation',
                ),
                'paintcorrectionshadows2012' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionShadows2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionShadows2012',
                ),
                'paintcorrectionsharpness' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionSharpness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionSharpness',
                ),
                'paintcorrectiontemperature' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionTemperature',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionTemperature',
                ),
                'paintcorrectiontint' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionTint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionTint',
                ),
                'paintcorrectionhue' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionHue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionHue',
                ),
                'paintcorrectionwhat' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PaintCorrectionWhat',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PaintCorrectionWhat',
                ),
                'parametricdarks' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'ParametricDarks',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\ParametricDarks',
                ),
                'parametrichighlights' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'ParametricHighlights',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\ParametricHighlights',
                ),
                'parametrichighlightsplit' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'ParametricHighlightSplit',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\ParametricHighlightSplit',
                ),
                'parametriclights' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'ParametricLights',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\ParametricLights',
                ),
                'parametricmidtonesplit' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'ParametricMidtoneSplit',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\ParametricMidtoneSplit',
                ),
                'parametricshadows' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'ParametricShadows',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\ParametricShadows',
                ),
                'parametricshadowsplit' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'ParametricShadowSplit',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\ParametricShadowSplit',
                ),
                'perspectiveaspect' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PerspectiveAspect',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PerspectiveAspect',
                ),
                'perspectivehorizontal' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PerspectiveHorizontal',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PerspectiveHorizontal',
                ),
                'perspectiverotate' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PerspectiveRotate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PerspectiveRotate',
                ),
                'perspectivescale' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PerspectiveScale',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PerspectiveScale',
                ),
                'perspectiveupright' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PerspectiveUpright',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PerspectiveUpright',
                ),
                'perspectivevertical' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PerspectiveVertical',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PerspectiveVertical',
                ),
                'perspectivex' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PerspectiveX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PerspectiveX',
                ),
                'perspectivey' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PerspectiveY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PerspectiveY',
                ),
                'postcropvignetteamount' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PostCropVignetteAmount',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PostCropVignetteAmount',
                ),
                'postcropvignettefeather' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PostCropVignetteFeather',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PostCropVignetteFeather',
                ),
                'postcropvignettehighlightcontrast' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PostCropVignetteHighlightContrast',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PostCropVignetteHighlightContrast',
                ),
                'postcropvignettemidpoint' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PostCropVignetteMidpoint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PostCropVignetteMidpoint',
                ),
                'postcropvignetteroundness' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PostCropVignetteRoundness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PostCropVignetteRoundness',
                ),
                'postcropvignettestyle' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'PostCropVignetteStyle',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\PostCropVignetteStyle',
                ),
                'processversion' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'ProcessVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\ProcessVersion',
                ),
                'rawfilename' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RawFileName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RawFileName',
                ),
                'redeyeinfo' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RedEyeInfo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RedEyeInfo',
                ),
                'redhue' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RedHue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RedHue',
                ),
                'redsaturation' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RedSaturation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RedSaturation',
                ),
                'retouchareas' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreas',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreas',
                ),
                'retouchareafeather' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaFeather',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaFeather',
                ),
                'retouchareamasks' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaMasks',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMasks',
                ),
                'retouchareamaskalpha' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaMaskAlpha',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskAlpha',
                ),
                'retouchareamaskangle' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaMaskAngle',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskAngle',
                ),
                'retouchareamaskbottom' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaMaskBottom',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskBottom',
                ),
                'retouchareamaskcentervalue' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaMaskCenterValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskCenterValue',
                ),
                'retouchareamaskcenterweight' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaMaskCenterWeight',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskCenterWeight',
                ),
                'retouchareamaskdabs' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaMaskDabs',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskDabs',
                ),
                'retouchareamaskfeather' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaMaskFeather',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskFeather',
                ),
                'retouchareamaskflipped' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaMaskFlipped',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskFlipped',
                ),
                'retouchareamaskflow' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaMaskFlow',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskFlow',
                ),
                'retouchareamaskfullx' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaMaskFullX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskFullX',
                ),
                'retouchareamaskfully' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaMaskFullY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskFullY',
                ),
                'retouchareamaskleft' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaMaskLeft',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskLeft',
                ),
                'retouchareamaskvalue' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaMaskValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskValue',
                ),
                'retouchareamaskmidpoint' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaMaskMidpoint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskMidpoint',
                ),
                'retouchareamaskperimetervalue' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaMaskPerimeterValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskPerimeterValue',
                ),
                'retouchareamaskradius' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaMaskRadius',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskRadius',
                ),
                'retouchareamaskright' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaMaskRight',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskRight',
                ),
                'retouchareamaskroundness' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaMaskRoundness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskRoundness',
                ),
                'retouchareamasksizex' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaMaskSizeX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskSizeX',
                ),
                'retouchareamasksizey' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaMaskSizeY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskSizeY',
                ),
                'retouchareamasktop' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaMaskTop',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskTop',
                ),
                'retouchareamaskversion' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaMaskVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskVersion',
                ),
                'retouchareamaskwhat' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaMaskWhat',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskWhat',
                ),
                'retouchareamaskx' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaMaskX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskX',
                ),
                'retouchareamasky' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaMaskY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskY',
                ),
                'retouchareamaskzerox' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaMaskZeroX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskZeroX',
                ),
                'retouchareamaskzeroy' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaMaskZeroY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMaskZeroY',
                ),
                'retouchareamethod' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaMethod',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaMethod',
                ),
                'retouchareaoffsety' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaOffsetY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaOffsetY',
                ),
                'retouchareaopacity' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaOpacity',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaOpacity',
                ),
                'retouchareaseed' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaSeed',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaSeed',
                ),
                'retouchareasourcestate' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaSourceState',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaSourceState',
                ),
                'retouchareasourcex' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaSourceX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaSourceX',
                ),
                'retouchareaspottype' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchAreaSpotType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchAreaSpotType',
                ),
                'retouchinfo' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'RetouchInfo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\RetouchInfo',
                ),
                'saturation' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'Saturation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\Saturation',
                ),
                'saturationadjustmentaqua' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'SaturationAdjustmentAqua',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\SaturationAdjustmentAqua',
                ),
                'saturationadjustmentblue' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'SaturationAdjustmentBlue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\SaturationAdjustmentBlue',
                ),
                'saturationadjustmentgreen' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'SaturationAdjustmentGreen',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\SaturationAdjustmentGreen',
                ),
                'saturationadjustmentmagenta' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'SaturationAdjustmentMagenta',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\SaturationAdjustmentMagenta',
                ),
                'saturationadjustmentorange' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'SaturationAdjustmentOrange',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\SaturationAdjustmentOrange',
                ),
                'saturationadjustmentpurple' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'SaturationAdjustmentPurple',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\SaturationAdjustmentPurple',
                ),
                'saturationadjustmentred' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'SaturationAdjustmentRed',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\SaturationAdjustmentRed',
                ),
                'saturationadjustmentyellow' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'SaturationAdjustmentYellow',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\SaturationAdjustmentYellow',
                ),
                'shadows' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'Shadows',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\Shadows',
                ),
                'shadows2012' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'Shadows2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\Shadows2012',
                ),
                'shadowtint' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'ShadowTint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\ShadowTint',
                ),
                'sharpendetail' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'SharpenDetail',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\SharpenDetail',
                ),
                'sharpenedgemasking' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'SharpenEdgeMasking',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\SharpenEdgeMasking',
                ),
                'sharpenradius' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'SharpenRadius',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\SharpenRadius',
                ),
                'sharpness' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'Sharpness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\Sharpness',
                ),
                'smoothness' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'Smoothness',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\Smoothness',
                ),
                'splittoningbalance' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'SplitToningBalance',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\SplitToningBalance',
                ),
                'splittoninghighlighthue' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'SplitToningHighlightHue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\SplitToningHighlightHue',
                ),
                'splittoninghighlightsaturation' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'SplitToningHighlightSaturation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\SplitToningHighlightSaturation',
                ),
                'splittoningshadowhue' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'SplitToningShadowHue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\SplitToningShadowHue',
                ),
                'splittoningshadowsaturation' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'SplitToningShadowSaturation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\SplitToningShadowSaturation',
                ),
                'colortemperature' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'ColorTemperature',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\ColorTemperature',
                ),
                'texture' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'Texture',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\Texture',
                ),
                'tiffhandling' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'TIFFHandling',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\TIFFHandling',
                ),
                'tint' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'Tint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\Tint',
                ),
                'tonecurve' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'ToneCurve',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\ToneCurve',
                ),
                'tonecurveblue' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'ToneCurveBlue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\ToneCurveBlue',
                ),
                'tonecurvegreen' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'ToneCurveGreen',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\ToneCurveGreen',
                ),
                'tonecurvename' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'ToneCurveName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\ToneCurveName',
                ),
                'tonecurvename2012' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'ToneCurveName2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\ToneCurveName2012',
                ),
                'tonecurvepv2012' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'ToneCurvePV2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\ToneCurvePV2012',
                ),
                'tonecurvepv2012blue' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'ToneCurvePV2012Blue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\ToneCurvePV2012Blue',
                ),
                'tonecurvepv2012green' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'ToneCurvePV2012Green',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\ToneCurvePV2012Green',
                ),
                'tonecurvepv2012red' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'ToneCurvePV2012Red',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\ToneCurvePV2012Red',
                ),
                'tonecurvered' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'ToneCurveRed',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\ToneCurveRed',
                ),
                'tonemapstrength' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'ToneMapStrength',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\ToneMapStrength',
                ),
                'uprightcentermode' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'UprightCenterMode',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\UprightCenterMode',
                ),
                'uprightcenternormx' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'UprightCenterNormX',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\UprightCenterNormX',
                ),
                'uprightcenternormy' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'UprightCenterNormY',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\UprightCenterNormY',
                ),
                'uprightdependentdigest' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'UprightDependentDigest',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\UprightDependentDigest',
                ),
                'uprightfocallength35mm' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'UprightFocalLength35mm',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\UprightFocalLength35mm',
                ),
                'uprightfocalmode' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'UprightFocalMode',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\UprightFocalMode',
                ),
                'uprightfoursegmentscount' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'UprightFourSegmentsCount',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\UprightFourSegmentsCount',
                ),
                'uprightpreview' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'UprightPreview',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\UprightPreview',
                ),
                'uprighttransform_0' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'UprightTransform_0',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\UprightTransform0',
                ),
                'uprighttransform_1' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'UprightTransform_1',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\UprightTransform1',
                ),
                'uprighttransform_2' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'UprightTransform_2',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\UprightTransform2',
                ),
                'uprighttransform_3' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'UprightTransform_3',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\UprightTransform3',
                ),
                'uprighttransform_4' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'UprightTransform_4',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\UprightTransform4',
                ),
                'uprighttransform_5' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'UprightTransform_5',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\UprightTransform5',
                ),
                'uprighttransformcount' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'UprightTransformCount',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\UprightTransformCount',
                ),
                'uprightversion' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'UprightVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\UprightVersion',
                ),
                'version' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'Version',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\Version',
                ),
                'vibrance' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'Vibrance',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\Vibrance',
                ),
                'vignetteamount' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'VignetteAmount',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\VignetteAmount',
                ),
                'vignettemidpoint' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'VignetteMidpoint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\VignetteMidpoint',
                ),
                'what' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'What',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\What',
                ),
                'whitebalance' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'WhiteBalance',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\WhiteBalance',
                ),
                'whites2012' => array(
                    'namespace' => 'XMP-crs',
                    'tagname' => 'Whites2012',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPCrs\Whites2012',
                ),
            ),
            'xmp-dc' => array(
                'contributor' => array(
                    'namespace' => 'XMP-dc',
                    'tagname' => 'Contributor',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDc\Contributor',
                ),
                'coverage' => array(
                    'namespace' => 'XMP-dc',
                    'tagname' => 'Coverage',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDc\Coverage',
                ),
                'creator' => array(
                    'namespace' => 'XMP-dc',
                    'tagname' => 'Creator',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDc\Creator',
                ),
                'date' => array(
                    'namespace' => 'XMP-dc',
                    'tagname' => 'Date',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDc\Date',
                ),
                'description' => array(
                    'namespace' => 'XMP-dc',
                    'tagname' => 'Description',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDc\Description',
                ),
                'format' => array(
                    'namespace' => 'XMP-dc',
                    'tagname' => 'Format',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDc\Format',
                ),
                'identifier' => array(
                    'namespace' => 'XMP-dc',
                    'tagname' => 'Identifier',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDc\Identifier',
                ),
                'language' => array(
                    'namespace' => 'XMP-dc',
                    'tagname' => 'Language',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDc\Language',
                ),
                'publisher' => array(
                    'namespace' => 'XMP-dc',
                    'tagname' => 'Publisher',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDc\Publisher',
                ),
                'relation' => array(
                    'namespace' => 'XMP-dc',
                    'tagname' => 'Relation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDc\Relation',
                ),
                'rights' => array(
                    'namespace' => 'XMP-dc',
                    'tagname' => 'Rights',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDc\Rights',
                ),
                'source' => array(
                    'namespace' => 'XMP-dc',
                    'tagname' => 'Source',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDc\Source',
                ),
                'subject' => array(
                    'namespace' => 'XMP-dc',
                    'tagname' => 'Subject',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDc\Subject',
                ),
                'title' => array(
                    'namespace' => 'XMP-dc',
                    'tagname' => 'Title',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDc\Title',
                ),
                'type' => array(
                    'namespace' => 'XMP-dc',
                    'tagname' => 'Type',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDc\Type',
                ),
            ),
            'xmp-dex' => array(
                'crc32' => array(
                    'namespace' => 'XMP-dex',
                    'tagname' => 'CRC32',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDex\CRC32',
                ),
                'ffid' => array(
                    'namespace' => 'XMP-dex',
                    'tagname' => 'FFID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDex\FFID',
                ),
                'licensetype' => array(
                    'namespace' => 'XMP-dex',
                    'tagname' => 'LicenseType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDex\LicenseType',
                ),
                'os' => array(
                    'namespace' => 'XMP-dex',
                    'tagname' => 'OS',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDex\OS',
                ),
                'rating' => array(
                    'namespace' => 'XMP-dex',
                    'tagname' => 'Rating',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDex\Rating',
                ),
                'revision' => array(
                    'namespace' => 'XMP-dex',
                    'tagname' => 'Revision',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDex\Revision',
                ),
                'shortdescription' => array(
                    'namespace' => 'XMP-dex',
                    'tagname' => 'ShortDescription',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDex\ShortDescription',
                ),
                'source' => array(
                    'namespace' => 'XMP-dex',
                    'tagname' => 'Source',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDex\Source',
                ),
            ),
            'xmp-digikam' => array(
                'captionsauthornames' => array(
                    'namespace' => 'XMP-digiKam',
                    'tagname' => 'CaptionsAuthorNames',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDigiKam\CaptionsAuthorNames',
                ),
                'captionsdatetimestamps' => array(
                    'namespace' => 'XMP-digiKam',
                    'tagname' => 'CaptionsDateTimeStamps',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDigiKam\CaptionsDateTimeStamps',
                ),
                'colorlabel' => array(
                    'namespace' => 'XMP-digiKam',
                    'tagname' => 'ColorLabel',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDigiKam\ColorLabel',
                ),
                'imagehistory' => array(
                    'namespace' => 'XMP-digiKam',
                    'tagname' => 'ImageHistory',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDigiKam\ImageHistory',
                ),
                'imageuniqueid' => array(
                    'namespace' => 'XMP-digiKam',
                    'tagname' => 'ImageUniqueID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDigiKam\ImageUniqueID',
                ),
                'lenscorrectionsettings' => array(
                    'namespace' => 'XMP-digiKam',
                    'tagname' => 'LensCorrectionSettings',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDigiKam\LensCorrectionSettings',
                ),
                'picklabel' => array(
                    'namespace' => 'XMP-digiKam',
                    'tagname' => 'PickLabel',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDigiKam\PickLabel',
                ),
                'tagslist' => array(
                    'namespace' => 'XMP-digiKam',
                    'tagname' => 'TagsList',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPDigiKam\TagsList',
                ),
            ),
           
           
            'xmp-extensis' => array(
                'approved' => array(
                    'namespace' => 'XMP-extensis',
                    'tagname' => 'Approved',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPExtensis\Approved',
                ),
                'approvedby' => array(
                    'namespace' => 'XMP-extensis',
                    'tagname' => 'ApprovedBy',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPExtensis\ApprovedBy',
                ),
                'clientname' => array(
                    'namespace' => 'XMP-extensis',
                    'tagname' => 'ClientName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPExtensis\ClientName',
                ),
                'jobname' => array(
                    'namespace' => 'XMP-extensis',
                    'tagname' => 'JobName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPExtensis\JobName',
                ),
                'jobstatus' => array(
                    'namespace' => 'XMP-extensis',
                    'tagname' => 'JobStatus',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPExtensis\JobStatus',
                ),
                'routedto' => array(
                    'namespace' => 'XMP-extensis',
                    'tagname' => 'RoutedTo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPExtensis\RoutedTo',
                ),
                'routingnotes' => array(
                    'namespace' => 'XMP-extensis',
                    'tagname' => 'RoutingNotes',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPExtensis\RoutingNotes',
                ),
                'worktodo' => array(
                    'namespace' => 'XMP-extensis',
                    'tagname' => 'WorkToDo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPExtensis\WorkToDo',
                ),
            ),
            'xmp-fpv' => array(
                'richtextcomment' => array(
                    'namespace' => 'XMP-fpv',
                    'tagname' => 'RichTextComment',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPFpv\RichTextComment',
                ),
            ),
            'xmp-ics' => array(
                'appversion' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'AppVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\AppVersion',
                ),
                'imageref' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'ImageRef',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\ImageRef',
                ),
                'subversions' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'SubVersions',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\SubVersions',
                ),
                'subversionfilename' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'SubVersionFileName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\SubVersionFileName',
                ),
                'subversionreference' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'SubVersionReference',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\SubVersionReference',
                ),
                'tagstructure' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'TagStructure',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\TagStructure',
                ),
                'labelname1' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'LabelName1',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\LabelName1',
                ),
                'parentreference1' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'ParentReference1',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\ParentReference1',
                ),
                'reference1' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'Reference1',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\Reference1',
                ),
                'sublabels1' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'SubLabels1',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\SubLabels1',
                ),
                'labelname2' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'LabelName2',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\LabelName2',
                ),
                'parentreference2' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'ParentReference2',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\ParentReference2',
                ),
                'reference2' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'Reference2',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\Reference2',
                ),
                'sublabels2' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'SubLabels2',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\SubLabels2',
                ),
                'labelname3' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'LabelName3',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\LabelName3',
                ),
                'parentreference3' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'ParentReference3',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\ParentReference3',
                ),
                'reference3' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'Reference3',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\Reference3',
                ),
                'sublabels3' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'SubLabels3',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\SubLabels3',
                ),
                'labelname4' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'LabelName4',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\LabelName4',
                ),
                'parentreference4' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'ParentReference4',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\ParentReference4',
                ),
                'reference4' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'Reference4',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\Reference4',
                ),
                'sublabels4' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'SubLabels4',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\SubLabels4',
                ),
                'labelname5' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'LabelName5',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\LabelName5',
                ),
                'parentreference5' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'ParentReference5',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\ParentReference5',
                ),
                'reference5' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'Reference5',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\Reference5',
                ),
                'sublabels5' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'SubLabels5',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\SubLabels5',
                ),
                'labelname6' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'LabelName6',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\LabelName6',
                ),
                'parentreference6' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'ParentReference6',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\ParentReference6',
                ),
                'reference6' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'Reference6',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\Reference6',
                ),
                'timestamp' => array(
                    'namespace' => 'XMP-ics',
                    'tagname' => 'TimeStamp',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIcs\TimeStamp',
                ),
            ),
           
            'xmp-iptcext' => array(
               
                'registryid' => array(
                    'namespace' => 'XMP-iptcExt',
                    'tagname' => 'RegistryID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIptcExt\RegistryID',
                ),
                'registryentryrole' => array(
                    'namespace' => 'XMP-iptcExt',
                    'tagname' => 'RegistryEntryRole',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIptcExt\RegistryEntryRole',
                ),
                'registryitemid' => array(
                    'namespace' => 'XMP-iptcExt',
                    'tagname' => 'RegistryItemID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIptcExt\RegistryItemID',
                ),
                'registryorganisationid' => array(
                    'namespace' => 'XMP-iptcExt',
                    'tagname' => 'RegistryOrganisationID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPIptcExt\RegistryOrganisationID',
                ),
               
            ),
            'xmp-pdf' => array(
                'author' => array(
                    'namespace' => 'XMP-pdf',
                    'tagname' => 'Author',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPdf\Author',
                ),
                'copyright' => array(
                    'namespace' => 'XMP-pdf',
                    'tagname' => 'Copyright',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPdf\Copyright',
                ),
                'creationdate' => array(
                    'namespace' => 'XMP-pdf',
                    'tagname' => 'CreationDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPdf\CreationDate',
                ),
                'creator' => array(
                    'namespace' => 'XMP-pdf',
                    'tagname' => 'Creator',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPdf\Creator',
                ),
                'keywords' => array(
                    'namespace' => 'XMP-pdf',
                    'tagname' => 'Keywords',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPdf\Keywords',
                ),
                'marked' => array(
                    'namespace' => 'XMP-pdf',
                    'tagname' => 'Marked',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPdf\Marked',
                ),
                'moddate' => array(
                    'namespace' => 'XMP-pdf',
                    'tagname' => 'ModDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPdf\ModDate',
                ),
                'pdfversion' => array(
                    'namespace' => 'XMP-pdf',
                    'tagname' => 'PDFVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPdf\PDFVersion',
                ),
                'producer' => array(
                    'namespace' => 'XMP-pdf',
                    'tagname' => 'Producer',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPdf\Producer',
                ),
                'subject' => array(
                    'namespace' => 'XMP-pdf',
                    'tagname' => 'Subject',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPdf\Subject',
                ),
                'title' => array(
                    'namespace' => 'XMP-pdf',
                    'tagname' => 'Title',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPdf\Title',
                ),
                'trapped' => array(
                    'namespace' => 'XMP-pdf',
                    'tagname' => 'Trapped',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPdf\Trapped',
                ),
            ),
            'xmp-photoshop' => array(
                
                'captionwriter' => array(
                    'namespace' => 'XMP-photoshop',
                    'tagname' => 'CaptionWriter',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPhotoshop\CaptionWriter',
                ),
                
                'city' => array(
                    'namespace' => 'XMP-photoshop',
                    'tagname' => 'City',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPhotoshop\City',
                ),
                
                'credit' => array(
                    'namespace' => 'XMP-photoshop',
                    'tagname' => 'Credit',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPhotoshop\Credit',
                ),
              
                'headline' => array(
                    'namespace' => 'XMP-photoshop',
                    'tagname' => 'Headline',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPhotoshop\Headline',
                ),
               
                'source' => array(
                    'namespace' => 'XMP-photoshop',
                    'tagname' => 'Source',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPhotoshop\Source',
                ),
               
            ),
            'xmp-pmi' => array(
                'color' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'Color',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\Color',
                ),
                'contactinfo' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'ContactInfo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\ContactInfo',
                ),
                'displayname' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'DisplayName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\DisplayName',
                ),
                'distributorproductid' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'DistributorProductID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\DistributorProductID',
                ),
                'eventalias' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'EventAlias',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\EventAlias',
                ),
                'eventend' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'EventEnd',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\EventEnd',
                ),
                'eventstart' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'EventStart',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\EventStart',
                ),
                'eventsubtype' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'EventSubtype',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\EventSubtype',
                ),
                'eventtype' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'EventType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\EventType',
                ),
                'field' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'Field',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\Field',
                ),
                'framing' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'Framing',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\Framing',
                ),
                'location' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'Location',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\Location',
                ),
                'make' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'Make',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\Make',
                ),
                'manufacturer' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'Manufacturer',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\Manufacturer',
                ),
                'model' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'Model',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\Model',
                ),
                'modelyear' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'ModelYear',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\ModelYear',
                ),
                'objectdescription' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'ObjectDescription',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\ObjectDescription',
                ),
                'objectsubtype' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'ObjectSubtype',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\ObjectSubtype',
                ),
                'objecttype' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'ObjectType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\ObjectType',
                ),
                'orientation' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'Orientation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\Orientation',
                ),
                'positiondescriptor' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'PositionDescriptor',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\PositionDescriptor',
                ),
                'productid' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'ProductID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\ProductID',
                ),
                'productidtype' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'ProductIDType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\ProductIDType',
                ),
                'season' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'Season',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\Season',
                ),
                'sequencename' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'SequenceName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\SequenceName',
                ),
                'sequencenumber' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'SequenceNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\SequenceNumber',
                ),
                'sequencetotalnumber' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'SequenceTotalNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\SequenceTotalNumber',
                ),
                'setting' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'Setting',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\Setting',
                ),
                'shootid' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'ShootID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\ShootID',
                ),
                'slideshowname' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'SlideshowName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\SlideshowName',
                ),
                'slideshownumber' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'SlideshowNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\SlideshowNumber',
                ),
                'slideshowtotalnumber' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'SlideshowTotalNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\SlideshowTotalNumber',
                ),
                'viewpoint' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'Viewpoint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\Viewpoint',
                ),
                'visualtechnique' => array(
                    'namespace' => 'XMP-pmi',
                    'tagname' => 'VisualTechnique',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPmi\VisualTechnique',
                ),
            ),
            'xmp-prism' => array(
                'academicfield' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'AcademicField',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\AcademicField',
                ),
                'aggregateissuenumber' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'AggregateIssueNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\AggregateIssueNumber',
                ),
                'aggregationtype' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'AggregationType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\AggregationType',
                ),
                'alternatetitle' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'AlternateTitle',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\AlternateTitle',
                ),
                'alternatetitlea-lang' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'AlternateTitleA-lang',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\AlternateTitleALang',
                ),
                'alternatetitlea-platform' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'AlternateTitleA-platform',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\AlternateTitleAPlatform',
                ),
                'alternatetitletext' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'AlternateTitleText',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\AlternateTitleText',
                ),
                'blogtitle' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'BlogTitle',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\BlogTitle',
                ),
                'blogurl' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'BlogURL',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\BlogURL',
                ),
                'bookedition' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'BookEdition',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\BookEdition',
                ),
                'bytecount' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'ByteCount',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\ByteCount',
                ),
                'channel' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'Channel',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\Channel',
                ),
                'channela-lang' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'ChannelA-lang',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\ChannelALang',
                ),
                'channelchannel' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'ChannelChannel',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\ChannelChannel',
                ),
                'channelsubchannel1' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'ChannelSubchannel1',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\ChannelSubchannel1',
                ),
                'channelsubchannel2' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'ChannelSubchannel2',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\ChannelSubchannel2',
                ),
                'channelsubchannel3' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'ChannelSubchannel3',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\ChannelSubchannel3',
                ),
                'channelsubchannel4' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'ChannelSubchannel4',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\ChannelSubchannel4',
                ),
                'complianceprofile' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'ComplianceProfile',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\ComplianceProfile',
                ),
                'contenttype' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'ContentType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\ContentType',
                ),
                'copyrightyear' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'CopyrightYear',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\CopyrightYear',
                ),
                'corporateentity' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'CorporateEntity',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\CorporateEntity',
                ),
                'coverdate' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'CoverDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\CoverDate',
                ),
                'coverdisplaydate' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'CoverDisplayDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\CoverDisplayDate',
                ),
                'creationdate' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'CreationDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\CreationDate',
                ),
                'daterecieved' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'DateRecieved',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\DateRecieved',
                ),
                'device' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'Device',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\Device',
                ),
                'distributor' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'Distributor',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\Distributor',
                ),
                'doi' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'DOI',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\DOI',
                ),
                'edition' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'Edition',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\Edition',
                ),
                'eissn' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'EIssn',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\EIssn',
                ),
                'endingpage' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'EndingPage',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\EndingPage',
                ),
                'event' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'Event',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\Event',
                ),
                'genre' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'Genre',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\Genre',
                ),
                'hasalternative' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'HasAlternative',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\HasAlternative',
                ),
                'hascorrection' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'HasCorrection',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\HasCorrection',
                ),
                'hascorrectiona-lang' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'HasCorrectionA-lang',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\HasCorrectionALang',
                ),
                'hascorrectiona-platform' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'HasCorrectionA-platform',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\HasCorrectionAPlatform',
                ),
                'hascorrectiontext' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'HasCorrectionText',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\HasCorrectionText',
                ),
                'hastranslation' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'HasTranslation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\HasTranslation',
                ),
                'industry' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'Industry',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\Industry',
                ),
                'isalternativeof' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'IsAlternativeOf',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\IsAlternativeOf',
                ),
                'isbn' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'ISBN',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\ISBN',
                ),
                'iscorrectionof' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'IsCorrectionOf',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\IsCorrectionOf',
                ),
                'issn' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'ISSN',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\ISSN',
                ),
                'issueidentifier' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'IssueIdentifier',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\IssueIdentifier',
                ),
                'issuename' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'IssueName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\IssueName',
                ),
                'issueteaser' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'IssueTeaser',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\IssueTeaser',
                ),
                'issuetype' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'IssueType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\IssueType',
                ),
                'istranslationof' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'IsTranslationOf',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\IsTranslationOf',
                ),
                'keyword' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'Keyword',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\Keyword',
                ),
                'killdate' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'KillDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\KillDate',
                ),
                'killdatea-platform' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'KillDateA-platform',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\KillDateAPlatform',
                ),
                'killdatedate' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'KillDateDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\KillDateDate',
                ),
                'link' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'Link',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\Link',
                ),
                'location' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'Location',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\Location',
                ),
                'modificationdate' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'ModificationDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\ModificationDate',
                ),
                'nationalcatalognumber' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'NationalCatalogNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\NationalCatalogNumber',
                ),
                'number' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'Number',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\Number',
                ),
                'object' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'Object',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\Object0',
                ),
                'offsaledate' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'OffSaleDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\OffSaleDate',
                ),
                'offsaledatea-platform' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'OffSaleDateA-platform',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\OffSaleDateAPlatform',
                ),
                'offsaledatedate' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'OffSaleDateDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\OffSaleDateDate',
                ),
                'onsaledate' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'OnSaleDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\OnSaleDate',
                ),
                'onsaledatea-platform' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'OnSaleDateA-platform',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\OnSaleDateAPlatform',
                ),
                'onsaledatedate' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'OnSaleDateDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\OnSaleDateDate',
                ),
                'onsaleday' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'OnSaleDay',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\OnSaleDay',
                ),
                'onsaledaya-platform' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'OnSaleDayA-platform',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\OnSaleDayAPlatform',
                ),
                'onsaledayday' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'OnSaleDayDay',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\OnSaleDayDay',
                ),
                'organization' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'Organization',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\Organization',
                ),
                'originplatform' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'OriginPlatform',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\OriginPlatform',
                ),
                'pagecount' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'PageCount',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\PageCount',
                ),
                'pageprogressiondirection' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'PageProgressionDirection',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\PageProgressionDirection',
                ),
                'pagerange' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'PageRange',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\PageRange',
                ),
                'person' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'Person',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\Person',
                ),
                'platform' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'Platform',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\Platform',
                ),
                'productcode' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'ProductCode',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\ProductCode',
                ),
                'profession' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'Profession',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\Profession',
                ),
                'publicationdate' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'PublicationDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\PublicationDate',
                ),
                'publicationdatea-platform' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'PublicationDateA-platform',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\PublicationDateAPlatform',
                ),
                'publicationdatedate' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'PublicationDateDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\PublicationDateDate',
                ),
                'publicationdisplaydate' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'PublicationDisplayDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\PublicationDisplayDate',
                ),
                'publicationdisplaydatea-platform' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'PublicationDisplayDateA-platform',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\PublicationDisplayDateAPlatform',
                ),
                'publicationdisplaydatedate' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'PublicationDisplayDateDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\PublicationDisplayDateDate',
                ),
                'publicationname' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'PublicationName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\PublicationName',
                ),
                'publishingfrequency' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'PublishingFrequency',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\PublishingFrequency',
                ),
                'rating' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'Rating',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\Rating',
                ),
                'samplepagerange' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'SamplePageRange',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\SamplePageRange',
                ),
                'section' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'Section',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\Section',
                ),
                'sellingagency' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'SellingAgency',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\SellingAgency',
                ),
                'seriesnumber' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'SeriesNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\SeriesNumber',
                ),
                'seriestitle' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'SeriesTitle',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\SeriesTitle',
                ),
                'sport' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'Sport',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\Sport',
                ),
                'startingpage' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'StartingPage',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\StartingPage',
                ),
                'subsection1' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'Subsection1',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\Subsection1',
                ),
                'subsection2' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'Subsection2',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\Subsection2',
                ),
                'subsection3' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'Subsection3',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\Subsection3',
                ),
                'subsection4' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'Subsection4',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\Subsection4',
                ),
                'subtitle' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'Subtitle',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\Subtitle',
                ),
                'supplementdisplayid' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'SupplementDisplayID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\SupplementDisplayID',
                ),
                'supplementstartingpage' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'SupplementStartingPage',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\SupplementStartingPage',
                ),
                'supplementtitle' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'SupplementTitle',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\SupplementTitle',
                ),
                'teaser' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'Teaser',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\Teaser',
                ),
                'ticker' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'Ticker',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\Ticker',
                ),
                'timeperiod' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'TimePeriod',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\TimePeriod',
                ),
                'url' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'URL',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\URL',
                ),
                'urla-platform' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'URLA-platform',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\URLAPlatform',
                ),
                'urlurl' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'URLUrl',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\URLUrl',
                ),
                'uspsnumber' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'UspsNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\UspsNumber',
                ),
                'versionidentifier' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'VersionIdentifier',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\VersionIdentifier',
                ),
                'volume' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'Volume',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\Volume',
                ),
                'wordcount' => array(
                    'namespace' => 'XMP-prism',
                    'tagname' => 'WordCount',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrism\WordCount',
                ),
            ),
            'xmp-prl' => array(
                'geography' => array(
                    'namespace' => 'XMP-prl',
                    'tagname' => 'Geography',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrl\Geography',
                ),
                'industry' => array(
                    'namespace' => 'XMP-prl',
                    'tagname' => 'Industry',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrl\Industry',
                ),
                'usage' => array(
                    'namespace' => 'XMP-prl',
                    'tagname' => 'Usage',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrl\Usage',
                ),
            ),
            'xmp-prm' => array(
                'cookingequipment' => array(
                    'namespace' => 'XMP-prm',
                    'tagname' => 'CookingEquipment',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrm\CookingEquipment',
                ),
                'cookingmethod' => array(
                    'namespace' => 'XMP-prm',
                    'tagname' => 'CookingMethod',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrm\CookingMethod',
                ),
                'course' => array(
                    'namespace' => 'XMP-prm',
                    'tagname' => 'Course',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrm\Course',
                ),
                'cuisine' => array(
                    'namespace' => 'XMP-prm',
                    'tagname' => 'Cuisine',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrm\Cuisine',
                ),
                'dietaryneeds' => array(
                    'namespace' => 'XMP-prm',
                    'tagname' => 'DietaryNeeds',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrm\DietaryNeeds',
                ),
                'dishtype' => array(
                    'namespace' => 'XMP-prm',
                    'tagname' => 'DishType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrm\DishType',
                ),
                'duration' => array(
                    'namespace' => 'XMP-prm',
                    'tagname' => 'Duration',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrm\Duration',
                ),
                'ingredientexclusion' => array(
                    'namespace' => 'XMP-prm',
                    'tagname' => 'IngredientExclusion',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrm\IngredientExclusion',
                ),
                'mainingredient' => array(
                    'namespace' => 'XMP-prm',
                    'tagname' => 'MainIngredient',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrm\MainIngredient',
                ),
                'meal' => array(
                    'namespace' => 'XMP-prm',
                    'tagname' => 'Meal',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrm\Meal',
                ),
                'recipeendingpage' => array(
                    'namespace' => 'XMP-prm',
                    'tagname' => 'RecipeEndingPage',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrm\RecipeEndingPage',
                ),
                'recipepagerange' => array(
                    'namespace' => 'XMP-prm',
                    'tagname' => 'RecipePageRange',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrm\RecipePageRange',
                ),
                'recipesource' => array(
                    'namespace' => 'XMP-prm',
                    'tagname' => 'RecipeSource',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrm\RecipeSource',
                ),
                'recipestartingpage' => array(
                    'namespace' => 'XMP-prm',
                    'tagname' => 'RecipeStartingPage',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrm\RecipeStartingPage',
                ),
                'recipetitle' => array(
                    'namespace' => 'XMP-prm',
                    'tagname' => 'RecipeTitle',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrm\RecipeTitle',
                ),
                'servingsize' => array(
                    'namespace' => 'XMP-prm',
                    'tagname' => 'ServingSize',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrm\ServingSize',
                ),
                'skilllevel' => array(
                    'namespace' => 'XMP-prm',
                    'tagname' => 'SkillLevel',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrm\SkillLevel',
                ),
                'specialoccasion' => array(
                    'namespace' => 'XMP-prm',
                    'tagname' => 'SpecialOccasion',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrm\SpecialOccasion',
                ),
                'yield' => array(
                    'namespace' => 'XMP-prm',
                    'tagname' => 'Yield',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPrm\Yield0',
                ),
            ),
            'xmp-pur' => array(
                'adultcontentwarning' => array(
                    'namespace' => 'XMP-pur',
                    'tagname' => 'AdultContentWarning',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPur\AdultContentWarning',
                ),
                'agreement' => array(
                    'namespace' => 'XMP-pur',
                    'tagname' => 'Agreement',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPur\Agreement',
                ),
                'copyright' => array(
                    'namespace' => 'XMP-pur',
                    'tagname' => 'Copyright',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPur\Copyright',
                ),
                'creditline' => array(
                    'namespace' => 'XMP-pur',
                    'tagname' => 'CreditLine',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPur\CreditLine',
                ),
                'embargodate' => array(
                    'namespace' => 'XMP-pur',
                    'tagname' => 'EmbargoDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPur\EmbargoDate',
                ),
                'exclusivityenddate' => array(
                    'namespace' => 'XMP-pur',
                    'tagname' => 'ExclusivityEndDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPur\ExclusivityEndDate',
                ),
                'expirationdate' => array(
                    'namespace' => 'XMP-pur',
                    'tagname' => 'ExpirationDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPur\ExpirationDate',
                ),
                'imagesizerestriction' => array(
                    'namespace' => 'XMP-pur',
                    'tagname' => 'ImageSizeRestriction',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPur\ImageSizeRestriction',
                ),
                'optionenddate' => array(
                    'namespace' => 'XMP-pur',
                    'tagname' => 'OptionEndDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPur\OptionEndDate',
                ),
                'permissions' => array(
                    'namespace' => 'XMP-pur',
                    'tagname' => 'Permissions',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPur\Permissions',
                ),
                'restrictions' => array(
                    'namespace' => 'XMP-pur',
                    'tagname' => 'Restrictions',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPur\Restrictions',
                ),
                'reuseprohibited' => array(
                    'namespace' => 'XMP-pur',
                    'tagname' => 'ReuseProhibited',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPur\ReuseProhibited',
                ),
                'rightsagent' => array(
                    'namespace' => 'XMP-pur',
                    'tagname' => 'RightsAgent',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPur\RightsAgent',
                ),
                'rightsowner' => array(
                    'namespace' => 'XMP-pur',
                    'tagname' => 'RightsOwner',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPPur\RightsOwner',
                ),
            ),
            'xmp-rdf' => array(
                'about' => array(
                    'namespace' => 'XMP-rdf',
                    'tagname' => 'About',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPRdf\About',
                ),
            ),
            'xmp-swf' => array(
                'backgroundalpha' => array(
                    'namespace' => 'XMP-swf',
                    'tagname' => 'BackgroundAlpha',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPSwf\BackgroundAlpha',
                ),
                'forwardlock' => array(
                    'namespace' => 'XMP-swf',
                    'tagname' => 'ForwardLock',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPSwf\ForwardLock',
                ),
                'maxstorage' => array(
                    'namespace' => 'XMP-swf',
                    'tagname' => 'MaxStorage',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPSwf\MaxStorage',
                ),
                'type' => array(
                    'namespace' => 'XMP-swf',
                    'tagname' => 'Type',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPSwf\Type',
                ),
            ),
            'xmp-tiff' => array(
                'artist' => array(
                    'namespace' => 'XMP-tiff',
                    'tagname' => 'Artist',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPTiff\Artist',
                ),
                'bitspersample' => array(
                    'namespace' => 'XMP-tiff',
                    'tagname' => 'BitsPerSample',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPTiff\BitsPerSample',
                ),
                'compression' => array(
                    'namespace' => 'XMP-tiff',
                    'tagname' => 'Compression',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPTiff\Compression',
                ),
                'copyright' => array(
                    'namespace' => 'XMP-tiff',
                    'tagname' => 'Copyright',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPTiff\Copyright',
                ),
                'datetime' => array(
                    'namespace' => 'XMP-tiff',
                    'tagname' => 'DateTime',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPTiff\DateTime',
                ),
                'imagedescription' => array(
                    'namespace' => 'XMP-tiff',
                    'tagname' => 'ImageDescription',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPTiff\ImageDescription',
                ),
                'imageheight' => array(
                    'namespace' => 'XMP-tiff',
                    'tagname' => 'ImageHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPTiff\ImageHeight',
                ),
                'imagewidth' => array(
                    'namespace' => 'XMP-tiff',
                    'tagname' => 'ImageWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPTiff\ImageWidth',
                ),
                'make' => array(
                    'namespace' => 'XMP-tiff',
                    'tagname' => 'Make',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPTiff\Make',
                ),
                'model' => array(
                    'namespace' => 'XMP-tiff',
                    'tagname' => 'Model',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPTiff\Model',
                ),
                'nativedigest' => array(
                    'namespace' => 'XMP-tiff',
                    'tagname' => 'NativeDigest',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPTiff\NativeDigest',
                ),
                'orientation' => array(
                    'namespace' => 'XMP-tiff',
                    'tagname' => 'Orientation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPTiff\Orientation',
                ),
                'photometricinterpretation' => array(
                    'namespace' => 'XMP-tiff',
                    'tagname' => 'PhotometricInterpretation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPTiff\PhotometricInterpretation',
                ),
                'planarconfiguration' => array(
                    'namespace' => 'XMP-tiff',
                    'tagname' => 'PlanarConfiguration',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPTiff\PlanarConfiguration',
                ),
                'primarychromaticities' => array(
                    'namespace' => 'XMP-tiff',
                    'tagname' => 'PrimaryChromaticities',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPTiff\PrimaryChromaticities',
                ),
                'referenceblackwhite' => array(
                    'namespace' => 'XMP-tiff',
                    'tagname' => 'ReferenceBlackWhite',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPTiff\ReferenceBlackWhite',
                ),
                'resolutionunit' => array(
                    'namespace' => 'XMP-tiff',
                    'tagname' => 'ResolutionUnit',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPTiff\ResolutionUnit',
                ),
                'samplesperpixel' => array(
                    'namespace' => 'XMP-tiff',
                    'tagname' => 'SamplesPerPixel',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPTiff\SamplesPerPixel',
                ),
                'software' => array(
                    'namespace' => 'XMP-tiff',
                    'tagname' => 'Software',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPTiff\Software',
                ),
                'transferfunction' => array(
                    'namespace' => 'XMP-tiff',
                    'tagname' => 'TransferFunction',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPTiff\TransferFunction',
                ),
                'whitepoint' => array(
                    'namespace' => 'XMP-tiff',
                    'tagname' => 'WhitePoint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPTiff\WhitePoint',
                ),
                'xresolution' => array(
                    'namespace' => 'XMP-tiff',
                    'tagname' => 'XResolution',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPTiff\XResolution',
                ),
                'ycbcrcoefficients' => array(
                    'namespace' => 'XMP-tiff',
                    'tagname' => 'YCbCrCoefficients',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPTiff\YCbCrCoefficients',
                ),
                'ycbcrpositioning' => array(
                    'namespace' => 'XMP-tiff',
                    'tagname' => 'YCbCrPositioning',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPTiff\YCbCrPositioning',
                ),
                'ycbcrsubsampling' => array(
                    'namespace' => 'XMP-tiff',
                    'tagname' => 'YCbCrSubSampling',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPTiff\YCbCrSubSampling',
                ),
                'yresolution' => array(
                    'namespace' => 'XMP-tiff',
                    'tagname' => 'YResolution',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPTiff\YResolution',
                ),
            ),
            'xmp-x' => array(
                'xmptoolkit' => array(
                    'namespace' => 'XMP-x',
                    'tagname' => 'XMPToolkit',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPX\XMPToolkit',
                ),
            ),
            'xmp-xmp' => array(
                'advisory' => array(
                    'namespace' => 'XMP-xmp',
                    'tagname' => 'Advisory',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmp\Advisory',
                ),
                'author' => array(
                    'namespace' => 'XMP-xmp',
                    'tagname' => 'Author',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmp\Author',
                ),
                'baseurl' => array(
                    'namespace' => 'XMP-xmp',
                    'tagname' => 'BaseURL',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmp\BaseURL',
                ),
                'createdate' => array(
                    'namespace' => 'XMP-xmp',
                    'tagname' => 'CreateDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmp\CreateDate',
                ),
                'creatortool' => array(
                    'namespace' => 'XMP-xmp',
                    'tagname' => 'CreatorTool',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmp\CreatorTool',
                ),
                'description' => array(
                    'namespace' => 'XMP-xmp',
                    'tagname' => 'Description',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmp\Description',
                ),
                'format' => array(
                    'namespace' => 'XMP-xmp',
                    'tagname' => 'Format',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmp\Format',
                ),
                'identifier' => array(
                    'namespace' => 'XMP-xmp',
                    'tagname' => 'Identifier',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmp\Identifier',
                ),
                'keywords' => array(
                    'namespace' => 'XMP-xmp',
                    'tagname' => 'Keywords',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmp\Keywords',
                ),
                'label' => array(
                    'namespace' => 'XMP-xmp',
                    'tagname' => 'Label',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmp\Label',
                ),
                'metadatadate' => array(
                    'namespace' => 'XMP-xmp',
                    'tagname' => 'MetadataDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmp\MetadataDate',
                ),
                'modifydate' => array(
                    'namespace' => 'XMP-xmp',
                    'tagname' => 'ModifyDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmp\ModifyDate',
                ),
                'nickname' => array(
                    'namespace' => 'XMP-xmp',
                    'tagname' => 'Nickname',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmp\Nickname',
                ),
                'pageinfo' => array(
                    'namespace' => 'XMP-xmp',
                    'tagname' => 'PageInfo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmp\PageInfo',
                ),
                'pageimageformat' => array(
                    'namespace' => 'XMP-xmp',
                    'tagname' => 'PageImageFormat',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmp\PageImageFormat',
                ),
                'pageimageheight' => array(
                    'namespace' => 'XMP-xmp',
                    'tagname' => 'PageImageHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmp\PageImageHeight',
                ),
                'pageimage' => array(
                    'namespace' => 'XMP-xmp',
                    'tagname' => 'PageImage',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmp\PageImage',
                ),
                'pageimagepagenumber' => array(
                    'namespace' => 'XMP-xmp',
                    'tagname' => 'PageImagePageNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmp\PageImagePageNumber',
                ),
                'pageimagewidth' => array(
                    'namespace' => 'XMP-xmp',
                    'tagname' => 'PageImageWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmp\PageImageWidth',
                ),
                'rating' => array(
                    'namespace' => 'XMP-xmp',
                    'tagname' => 'Rating',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmp\Rating',
                ),
                'thumbnails' => array(
                    'namespace' => 'XMP-xmp',
                    'tagname' => 'Thumbnails',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmp\Thumbnails',
                ),
                'thumbnailformat' => array(
                    'namespace' => 'XMP-xmp',
                    'tagname' => 'ThumbnailFormat',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmp\ThumbnailFormat',
                ),
                'thumbnailheight' => array(
                    'namespace' => 'XMP-xmp',
                    'tagname' => 'ThumbnailHeight',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmp\ThumbnailHeight',
                ),
                'thumbnailimage' => array(
                    'namespace' => 'XMP-xmp',
                    'tagname' => 'ThumbnailImage',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmp\ThumbnailImage',
                ),
                'thumbnailwidth' => array(
                    'namespace' => 'XMP-xmp',
                    'tagname' => 'ThumbnailWidth',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmp\ThumbnailWidth',
                ),
                'title' => array(
                    'namespace' => 'XMP-xmp',
                    'tagname' => 'Title',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmp\Title',
                ),
            ),
            'xmp-xmpbj' => array(
                'jobref' => array(
                    'namespace' => 'XMP-xmpBJ',
                    'tagname' => 'JobRef',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpBJ\JobRef',
                ),
                'jobrefid' => array(
                    'namespace' => 'XMP-xmpBJ',
                    'tagname' => 'JobRefId',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpBJ\JobRefId',
                ),
                'jobrefname' => array(
                    'namespace' => 'XMP-xmpBJ',
                    'tagname' => 'JobRefName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpBJ\JobRefName',
                ),
                'jobrefurl' => array(
                    'namespace' => 'XMP-xmpBJ',
                    'tagname' => 'JobRefUrl',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpBJ\JobRefUrl',
                ),
            ),
            'xmp-xmpdm' => array(
                'abspeakaudiofilepath' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'AbsPeakAudioFilePath',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\AbsPeakAudioFilePath',
                ),
                'album' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'Album',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\Album',
                ),
                'alttapename' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'AltTapeName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\AltTapeName',
                ),
                'alttimecode' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'AltTimecode',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\AltTimecode',
                ),
                'alttimecodetimeformat' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'AltTimecodeTimeFormat',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\AltTimecodeTimeFormat',
                ),
                'alttimecodetimevalue' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'AltTimecodeTimeValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\AltTimecodeTimeValue',
                ),
                'alttimecodevalue' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'AltTimecodeValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\AltTimecodeValue',
                ),
                'artist' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'Artist',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\Artist',
                ),
                'audiochanneltype' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'AudioChannelType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\AudioChannelType',
                ),
                'audiocompressor' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'AudioCompressor',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\AudioCompressor',
                ),
                'audiomoddate' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'AudioModDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\AudioModDate',
                ),
                'audiosamplerate' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'AudioSampleRate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\AudioSampleRate',
                ),
                'audiosampletype' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'AudioSampleType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\AudioSampleType',
                ),
                'beatspliceparams' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'BeatSpliceParams',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\BeatSpliceParams',
                ),
                'beatspliceparamsriseindecibel' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'BeatSpliceParamsRiseInDecibel',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\BeatSpliceParamsRiseInDecibel',
                ),
                'beatspliceparamsriseintimeduration' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'BeatSpliceParamsRiseInTimeDuration',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\BeatSpliceParamsRiseInTimeDuration',
                ),
                'beatspliceparamsriseintimedurationscale' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'BeatSpliceParamsRiseInTimeDurationScale',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\BeatSpliceParamsRiseInTimeDurationScale',
                ),
                'beatspliceparamsriseintimedurationvalue' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'BeatSpliceParamsRiseInTimeDurationValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\BeatSpliceParamsRiseInTimeDurationValue',
                ),
                'beatspliceparamsusefilebeatsmarker' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'BeatSpliceParamsUseFileBeatsMarker',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\BeatSpliceParamsUseFileBeatsMarker',
                ),
                'cameraangle' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'CameraAngle',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\CameraAngle',
                ),
                'cameralabel' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'CameraLabel',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\CameraLabel',
                ),
                'cameramodel' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'CameraModel',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\CameraModel',
                ),
                'cameramove' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'CameraMove',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\CameraMove',
                ),
                'client' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'Client',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\Client',
                ),
                'dmcomment' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'DMComment',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\DMComment',
                ),
                'composer' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'Composer',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\Composer',
                ),
                'contributedmedia' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'ContributedMedia',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\ContributedMedia',
                ),
                'contributedmediaduration' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'ContributedMediaDuration',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\ContributedMediaDuration',
                ),
                'contributedmediadurationscale' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'ContributedMediaDurationScale',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\ContributedMediaDurationScale',
                ),
                'contributedmediadurationvalue' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'ContributedMediaDurationValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\ContributedMediaDurationValue',
                ),
                'contributedmediamanaged' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'ContributedMediaManaged',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\ContributedMediaManaged',
                ),
                'contributedmediapath' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'ContributedMediaPath',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\ContributedMediaPath',
                ),
                'contributedmediastarttime' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'ContributedMediaStartTime',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\ContributedMediaStartTime',
                ),
                'contributedmediastarttimescale' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'ContributedMediaStartTimeScale',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\ContributedMediaStartTimeScale',
                ),
                'contributedmediastarttimevalue' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'ContributedMediaStartTimeValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\ContributedMediaStartTimeValue',
                ),
                'contributedmediatrack' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'ContributedMediaTrack',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\ContributedMediaTrack',
                ),
                'contributedmediawebstatement' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'ContributedMediaWebStatement',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\ContributedMediaWebStatement',
                ),
                'copyright' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'Copyright',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\Copyright',
                ),
                'director' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'Director',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\Director',
                ),
                'directorphotography' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'DirectorPhotography',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\DirectorPhotography',
                ),
                'discnumber' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'DiscNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\DiscNumber',
                ),
                'duration' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'Duration',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\Duration',
                ),
                'durationscale' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'DurationScale',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\DurationScale',
                ),
                'durationvalue' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'DurationValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\DurationValue',
                ),
                'engineer' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'Engineer',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\Engineer',
                ),
                'filedatarate' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'FileDataRate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\FileDataRate',
                ),
                'genre' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'Genre',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\Genre',
                ),
                'good' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'Good',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\Good',
                ),
                'instrument' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'Instrument',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\Instrument',
                ),
                'introtime' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'IntroTime',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\IntroTime',
                ),
                'introtimescale' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'IntroTimeScale',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\IntroTimeScale',
                ),
                'introtimevalue' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'IntroTimeValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\IntroTimeValue',
                ),
                'key' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'Key',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\Key',
                ),
                'logcomment' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'LogComment',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\LogComment',
                ),
                'loop' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'Loop',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\Loop',
                ),
                'lyrics' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'Lyrics',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\Lyrics',
                ),
                'markers' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'Markers',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\Markers',
                ),
                'markerscomment' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'MarkersComment',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\MarkersComment',
                ),
                'markerscuepointparams' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'MarkersCuePointParams',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\MarkersCuePointParams',
                ),
                'markerscuepointparamskey' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'MarkersCuePointParamsKey',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\MarkersCuePointParamsKey',
                ),
                'markerscuepointparamsvalue' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'MarkersCuePointParamsValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\MarkersCuePointParamsValue',
                ),
                'markerscuepointtype' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'MarkersCuePointType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\MarkersCuePointType',
                ),
                'markersduration' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'MarkersDuration',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\MarkersDuration',
                ),
                'markerslocation' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'MarkersLocation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\MarkersLocation',
                ),
                'markersname' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'MarkersName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\MarkersName',
                ),
                'markersprobability' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'MarkersProbability',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\MarkersProbability',
                ),
                'markersspeaker' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'MarkersSpeaker',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\MarkersSpeaker',
                ),
                'markersstarttime' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'MarkersStartTime',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\MarkersStartTime',
                ),
                'markerstarget' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'MarkersTarget',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\MarkersTarget',
                ),
                'markerstype' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'MarkersType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\MarkersType',
                ),
                'metadatamoddate' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'MetadataModDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\MetadataModDate',
                ),
                'numberofbeats' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'NumberOfBeats',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\NumberOfBeats',
                ),
                'outcue' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'OutCue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\OutCue',
                ),
                'outcuescale' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'OutCueScale',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\OutCueScale',
                ),
                'outcuevalue' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'OutCueValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\OutCueValue',
                ),
                'partofcompilation' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'PartOfCompilation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\PartOfCompilation',
                ),
                'projectname' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'ProjectName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\ProjectName',
                ),
                'projectref' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'ProjectRef',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\ProjectRef',
                ),
                'projectrefpath' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'ProjectRefPath',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\ProjectRefPath',
                ),
                'projectreftype' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'ProjectRefType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\ProjectRefType',
                ),
                'pulldown' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'PullDown',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\PullDown',
                ),
                'relativepeakaudiofilepath' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'RelativePeakAudioFilePath',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\RelativePeakAudioFilePath',
                ),
                'relativetimestamp' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'RelativeTimestamp',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\RelativeTimestamp',
                ),
                'relativetimestampscale' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'RelativeTimestampScale',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\RelativeTimestampScale',
                ),
                'relativetimestampvalue' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'RelativeTimestampValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\RelativeTimestampValue',
                ),
                'releasedate' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'ReleaseDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\ReleaseDate',
                ),
                'resampleparams' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'ResampleParams',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\ResampleParams',
                ),
                'resampleparamsquality' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'ResampleParamsQuality',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\ResampleParamsQuality',
                ),
                'scaletype' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'ScaleType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\ScaleType',
                ),
                'scene' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'Scene',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\Scene',
                ),
                'shotdate' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'ShotDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\ShotDate',
                ),
                'shotday' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'ShotDay',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\ShotDay',
                ),
                'shotlocation' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'ShotLocation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\ShotLocation',
                ),
                'shotname' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'ShotName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\ShotName',
                ),
                'shotnumber' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'ShotNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\ShotNumber',
                ),
                'shotsize' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'ShotSize',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\ShotSize',
                ),
                'speakerplacement' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'SpeakerPlacement',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\SpeakerPlacement',
                ),
                'starttimecode' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'StartTimecode',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\StartTimecode',
                ),
                'starttimecodetimeformat' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'StartTimecodeTimeFormat',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\StartTimecodeTimeFormat',
                ),
                'starttimecodetimevalue' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'StartTimecodeTimeValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\StartTimecodeTimeValue',
                ),
                'starttimecodevalue' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'StartTimecodeValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\StartTimecodeValue',
                ),
                'starttimesamplesize' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'StartTimeSampleSize',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\StartTimeSampleSize',
                ),
                'starttimescale' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'StartTimeScale',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\StartTimeScale',
                ),
                'stretchmode' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'StretchMode',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\StretchMode',
                ),
                'takenumber' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'TakeNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\TakeNumber',
                ),
                'tapename' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'TapeName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\TapeName',
                ),
                'tempo' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'Tempo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\Tempo',
                ),
                'timescaleparams' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'TimeScaleParams',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\TimeScaleParams',
                ),
                'timescaleparamsframeoverlappingpercentage' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'TimeScaleParamsFrameOverlappingPercentage',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\TimeScaleParamsFrameOverlappingPercentage',
                ),
                'timescaleparamsframesize' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'TimeScaleParamsFrameSize',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\TimeScaleParamsFrameSize',
                ),
                'timescaleparamsquality' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'TimeScaleParamsQuality',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\TimeScaleParamsQuality',
                ),
                'timesignature' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'TimeSignature',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\TimeSignature',
                ),
                'tracknumber' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'TrackNumber',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\TrackNumber',
                ),
                'tracks' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'Tracks',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\Tracks',
                ),
                'tracksframerate' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'TracksFrameRate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\TracksFrameRate',
                ),
                'tracksmarkers' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'TracksMarkers',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\TracksMarkers',
                ),
                'tracksmarkerscomment' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'TracksMarkersComment',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\TracksMarkersComment',
                ),
                'tracksmarkerscuepointparams' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'TracksMarkersCuePointParams',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\TracksMarkersCuePointParams',
                ),
                'tracksmarkerscuepointparamskey' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'TracksMarkersCuePointParamsKey',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\TracksMarkersCuePointParamsKey',
                ),
                'tracksmarkerscuepointparamsvalue' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'TracksMarkersCuePointParamsValue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\TracksMarkersCuePointParamsValue',
                ),
                'tracksmarkerscuepointtype' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'TracksMarkersCuePointType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\TracksMarkersCuePointType',
                ),
                'tracksmarkersduration' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'TracksMarkersDuration',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\TracksMarkersDuration',
                ),
                'tracksmarkerslocation' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'TracksMarkersLocation',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\TracksMarkersLocation',
                ),
                'tracksmarkersname' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'TracksMarkersName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\TracksMarkersName',
                ),
                'tracksmarkersprobability' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'TracksMarkersProbability',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\TracksMarkersProbability',
                ),
                'tracksmarkersspeaker' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'TracksMarkersSpeaker',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\TracksMarkersSpeaker',
                ),
                'tracksmarkersstarttime' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'TracksMarkersStartTime',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\TracksMarkersStartTime',
                ),
                'tracksmarkerstarget' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'TracksMarkersTarget',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\TracksMarkersTarget',
                ),
                'tracksmarkerstype' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'TracksMarkersType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\TracksMarkersType',
                ),
                'trackstrackname' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'TracksTrackName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\TracksTrackName',
                ),
                'trackstracktype' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'TracksTrackType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\TracksTrackType',
                ),
                'videoalphamode' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'VideoAlphaMode',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaMode',
                ),
                'videoalphapremultiplecolor' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'VideoAlphaPremultipleColor',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColor',
                ),
                'videoalphapremultiplecolora' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'VideoAlphaPremultipleColorA',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorA',
                ),
                'videoalphapremultiplecolorb' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'VideoAlphaPremultipleColorB',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorB',
                ),
                'videoalphapremultiplecolorblack' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'VideoAlphaPremultipleColorBlack',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorBlack',
                ),
                'videoalphapremultiplecolorblue' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'VideoAlphaPremultipleColorBlue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorBlue',
                ),
                'videoalphapremultiplecolorcyan' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'VideoAlphaPremultipleColorCyan',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorCyan',
                ),
                'videoalphapremultiplecolorgray' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'VideoAlphaPremultipleColorGray',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorGray',
                ),
                'videoalphapremultiplecolorgreen' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'VideoAlphaPremultipleColorGreen',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorGreen',
                ),
                'videoalphapremultiplecolorl' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'VideoAlphaPremultipleColorL',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorL',
                ),
                'videoalphapremultiplecolormagenta' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'VideoAlphaPremultipleColorMagenta',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorMagenta',
                ),
                'videoalphapremultiplecolormode' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'VideoAlphaPremultipleColorMode',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorMode',
                ),
                'videoalphapremultiplecolorred' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'VideoAlphaPremultipleColorRed',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorRed',
                ),
                'videoalphapremultiplecolorswatchname' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'VideoAlphaPremultipleColorSwatchName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorSwatchName',
                ),
                'videoalphapremultiplecolortint' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'VideoAlphaPremultipleColorTint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorTint',
                ),
                'videoalphapremultiplecolortype' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'VideoAlphaPremultipleColorType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorType',
                ),
                'videoalphapremultiplecoloryellow' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'VideoAlphaPremultipleColorYellow',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaPremultipleColorYellow',
                ),
                'videoalphaunityistransparent' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'VideoAlphaUnityIsTransparent',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\VideoAlphaUnityIsTransparent',
                ),
                'videocolorspace' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'VideoColorSpace',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\VideoColorSpace',
                ),
                'videocompressor' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'VideoCompressor',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\VideoCompressor',
                ),
                'videofieldorder' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'VideoFieldOrder',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\VideoFieldOrder',
                ),
                'videoframerate' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'VideoFrameRate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\VideoFrameRate',
                ),
                'videoframesize' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'VideoFrameSize',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\VideoFrameSize',
                ),
                'videoframesizeh' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'VideoFrameSizeH',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\VideoFrameSizeH',
                ),
                'videoframesizeunit' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'VideoFrameSizeUnit',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\VideoFrameSizeUnit',
                ),
                'videoframesizew' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'VideoFrameSizeW',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\VideoFrameSizeW',
                ),
                'videomoddate' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'VideoModDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\VideoModDate',
                ),
                'videopixelaspectratio' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'VideoPixelAspectRatio',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\VideoPixelAspectRatio',
                ),
                'videopixeldepth' => array(
                    'namespace' => 'XMP-xmpDM',
                    'tagname' => 'VideoPixelDepth',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpDM\VideoPixelDepth',
                ),
            ),
            'xmp-xmpmm' => array(
                'derivedfrom' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'DerivedFrom',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFrom',
                ),
                'derivedfromalternatepaths' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'DerivedFromAlternatePaths',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromAlternatePaths',
                ),
                'derivedfromdocumentid' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'DerivedFromDocumentID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromDocumentID',
                ),
                'derivedfromfilepath' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'DerivedFromFilePath',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromFilePath',
                ),
                'derivedfromfrompart' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'DerivedFromFromPart',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromFromPart',
                ),
                'derivedfrominstanceid' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'DerivedFromInstanceID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromInstanceID',
                ),
                'derivedfromlastmodifydate' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'DerivedFromLastModifyDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromLastModifyDate',
                ),
                'derivedfromlasturl' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'DerivedFromLastURL',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromLastURL',
                ),
                'derivedfromlinkcategory' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'DerivedFromLinkCategory',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromLinkCategory',
                ),
                'derivedfromlinkform' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'DerivedFromLinkForm',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromLinkForm',
                ),
                'derivedfrommanager' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'DerivedFromManager',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromManager',
                ),
                'derivedfrommanagervariant' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'DerivedFromManagerVariant',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromManagerVariant',
                ),
                'derivedfrommanageto' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'DerivedFromManageTo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromManageTo',
                ),
                'derivedfrommanageui' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'DerivedFromManageUI',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromManageUI',
                ),
                'derivedfrommaskmarkers' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'DerivedFromMaskMarkers',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromMaskMarkers',
                ),
                'derivedfromoriginaldocumentid' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'DerivedFromOriginalDocumentID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromOriginalDocumentID',
                ),
                'derivedfrompartmapping' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'DerivedFromPartMapping',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromPartMapping',
                ),
                'derivedfromplacedresolutionunit' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'DerivedFromPlacedResolutionUnit',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromPlacedResolutionUnit',
                ),
                'derivedfromplacedxresolution' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'DerivedFromPlacedXResolution',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromPlacedXResolution',
                ),
                'derivedfromplacedyresolution' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'DerivedFromPlacedYResolution',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromPlacedYResolution',
                ),
                'derivedfromrenditionclass' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'DerivedFromRenditionClass',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromRenditionClass',
                ),
                'derivedfromrenditionparams' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'DerivedFromRenditionParams',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromRenditionParams',
                ),
                'derivedfromtopart' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'DerivedFromToPart',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromToPart',
                ),
                'derivedfromversionid' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'DerivedFromVersionID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\DerivedFromVersionID',
                ),
                'documentid' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'DocumentID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\DocumentID',
                ),
                'history' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'History',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\History',
                ),
                'historyaction' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'HistoryAction',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\HistoryAction',
                ),
                'historychanged' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'HistoryChanged',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\HistoryChanged',
                ),
                'historyinstanceid' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'HistoryInstanceID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\HistoryInstanceID',
                ),
                'historyparameters' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'HistoryParameters',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\HistoryParameters',
                ),
                'historysoftwareagent' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'HistorySoftwareAgent',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\HistorySoftwareAgent',
                ),
                'historywhen' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'HistoryWhen',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\HistoryWhen',
                ),
                'ingredients' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'Ingredients',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\Ingredients',
                ),
                'ingredientsalternatepaths' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'IngredientsAlternatePaths',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsAlternatePaths',
                ),
                'ingredientsdocumentid' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'IngredientsDocumentID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsDocumentID',
                ),
                'ingredientsfilepath' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'IngredientsFilePath',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsFilePath',
                ),
                'ingredientsfrompart' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'IngredientsFromPart',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsFromPart',
                ),
                'ingredientsinstanceid' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'IngredientsInstanceID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsInstanceID',
                ),
                'ingredientslastmodifydate' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'IngredientsLastModifyDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsLastModifyDate',
                ),
                'ingredientslasturl' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'IngredientsLastURL',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsLastURL',
                ),
                'ingredientslinkcategory' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'IngredientsLinkCategory',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsLinkCategory',
                ),
                'ingredientslinkform' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'IngredientsLinkForm',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsLinkForm',
                ),
                'ingredientsmanager' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'IngredientsManager',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsManager',
                ),
                'ingredientsmanagervariant' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'IngredientsManagerVariant',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsManagerVariant',
                ),
                'ingredientsmanageto' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'IngredientsManageTo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsManageTo',
                ),
                'ingredientsmanageui' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'IngredientsManageUI',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsManageUI',
                ),
                'ingredientsmaskmarkers' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'IngredientsMaskMarkers',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsMaskMarkers',
                ),
                'ingredientsoriginaldocumentid' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'IngredientsOriginalDocumentID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsOriginalDocumentID',
                ),
                'ingredientspartmapping' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'IngredientsPartMapping',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsPartMapping',
                ),
                'ingredientsplacedresolutionunit' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'IngredientsPlacedResolutionUnit',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsPlacedResolutionUnit',
                ),
                'ingredientsplacedxresolution' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'IngredientsPlacedXResolution',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsPlacedXResolution',
                ),
                'ingredientsplacedyresolution' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'IngredientsPlacedYResolution',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsPlacedYResolution',
                ),
                'ingredientsrenditionclass' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'IngredientsRenditionClass',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsRenditionClass',
                ),
                'ingredientsrenditionparams' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'IngredientsRenditionParams',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsRenditionParams',
                ),
                'ingredientstopart' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'IngredientsToPart',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsToPart',
                ),
                'ingredientsversionid' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'IngredientsVersionID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\IngredientsVersionID',
                ),
                'instanceid' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'InstanceID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\InstanceID',
                ),
                'lasturl' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'LastURL',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\LastURL',
                ),
                'managedfrom' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManagedFrom',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFrom',
                ),
                'managedfromalternatepaths' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManagedFromAlternatePaths',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromAlternatePaths',
                ),
                'managedfromdocumentid' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManagedFromDocumentID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromDocumentID',
                ),
                'managedfromfilepath' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManagedFromFilePath',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromFilePath',
                ),
                'managedfromfrompart' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManagedFromFromPart',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromFromPart',
                ),
                'managedfrominstanceid' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManagedFromInstanceID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromInstanceID',
                ),
                'managedfromlastmodifydate' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManagedFromLastModifyDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromLastModifyDate',
                ),
                'managedfromlasturl' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManagedFromLastURL',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromLastURL',
                ),
                'managedfromlinkcategory' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManagedFromLinkCategory',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromLinkCategory',
                ),
                'managedfromlinkform' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManagedFromLinkForm',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromLinkForm',
                ),
                'managedfrommanager' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManagedFromManager',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromManager',
                ),
                'managedfrommanagervariant' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManagedFromManagerVariant',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromManagerVariant',
                ),
                'managedfrommanageto' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManagedFromManageTo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromManageTo',
                ),
                'managedfrommanageui' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManagedFromManageUI',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromManageUI',
                ),
                'managedfrommaskmarkers' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManagedFromMaskMarkers',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromMaskMarkers',
                ),
                'managedfromoriginaldocumentid' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManagedFromOriginalDocumentID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromOriginalDocumentID',
                ),
                'managedfrompartmapping' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManagedFromPartMapping',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromPartMapping',
                ),
                'managedfromplacedresolutionunit' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManagedFromPlacedResolutionUnit',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromPlacedResolutionUnit',
                ),
                'managedfromplacedxresolution' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManagedFromPlacedXResolution',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromPlacedXResolution',
                ),
                'managedfromplacedyresolution' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManagedFromPlacedYResolution',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromPlacedYResolution',
                ),
                'managedfromrenditionclass' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManagedFromRenditionClass',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromRenditionClass',
                ),
                'managedfromrenditionparams' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManagedFromRenditionParams',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromRenditionParams',
                ),
                'managedfromtopart' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManagedFromToPart',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromToPart',
                ),
                'managedfromversionid' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManagedFromVersionID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManagedFromVersionID',
                ),
                'manager' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'Manager',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\Manager',
                ),
                'managervariant' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManagerVariant',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManagerVariant',
                ),
                'manageto' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManageTo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManageTo',
                ),
                'manageui' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManageUI',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManageUI',
                ),
                'manifest' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'Manifest',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\Manifest',
                ),
                'manifestlinkform' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManifestLinkForm',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManifestLinkForm',
                ),
                'manifestplacedresolutionunit' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManifestPlacedResolutionUnit',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManifestPlacedResolutionUnit',
                ),
                'manifestplacedxresolution' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManifestPlacedXResolution',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManifestPlacedXResolution',
                ),
                'manifestplacedyresolution' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManifestPlacedYResolution',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManifestPlacedYResolution',
                ),
                'manifestreference' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManifestReference',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReference',
                ),
                'manifestreferencealternatepaths' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManifestReferenceAlternatePaths',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceAlternatePaths',
                ),
                'manifestreferencedocumentid' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManifestReferenceDocumentID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceDocumentID',
                ),
                'manifestreferencefilepath' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManifestReferenceFilePath',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceFilePath',
                ),
                'manifestreferencefrompart' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManifestReferenceFromPart',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceFromPart',
                ),
                'manifestreferenceinstanceid' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManifestReferenceInstanceID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceInstanceID',
                ),
                'manifestreferencelastmodifydate' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManifestReferenceLastModifyDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceLastModifyDate',
                ),
                'manifestreferencelasturl' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManifestReferenceLastURL',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceLastURL',
                ),
                'manifestreferencelinkcategory' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManifestReferenceLinkCategory',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceLinkCategory',
                ),
                'manifestreferencelinkform' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManifestReferenceLinkForm',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceLinkForm',
                ),
                'manifestreferencemanager' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManifestReferenceManager',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceManager',
                ),
                'manifestreferencemanagervariant' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManifestReferenceManagerVariant',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceManagerVariant',
                ),
                'manifestreferencemanageto' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManifestReferenceManageTo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceManageTo',
                ),
                'manifestreferencemanageui' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManifestReferenceManageUI',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceManageUI',
                ),
                'manifestreferencemaskmarkers' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManifestReferenceMaskMarkers',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceMaskMarkers',
                ),
                'manifestreferenceoriginaldocumentid' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManifestReferenceOriginalDocumentID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceOriginalDocumentID',
                ),
                'manifestreferencepartmapping' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManifestReferencePartMapping',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferencePartMapping',
                ),
                'manifestreferenceplacedresolutionunit' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManifestReferencePlacedResolutionUnit',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferencePlacedResolutionUnit',
                ),
                'manifestreferenceplacedxresolution' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManifestReferencePlacedXResolution',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferencePlacedXResolution',
                ),
                'manifestreferenceplacedyresolution' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManifestReferencePlacedYResolution',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferencePlacedYResolution',
                ),
                'manifestreferencerenditionclass' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManifestReferenceRenditionClass',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceRenditionClass',
                ),
                'manifestreferencerenditionparams' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManifestReferenceRenditionParams',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceRenditionParams',
                ),
                'manifestreferencetopart' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManifestReferenceToPart',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceToPart',
                ),
                'manifestreferenceversionid' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'ManifestReferenceVersionID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\ManifestReferenceVersionID',
                ),
                'originaldocumentid' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'OriginalDocumentID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\OriginalDocumentID',
                ),
                'pantry' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'Pantry',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\Pantry',
                ),
                'pantryinstanceid' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'PantryInstanceID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\PantryInstanceID',
                ),
                'preservedfilename' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'PreservedFileName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\PreservedFileName',
                ),
                'renditionclass' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'RenditionClass',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\RenditionClass',
                ),
                'renditionof' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'RenditionOf',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOf',
                ),
                'renditionofalternatepaths' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'RenditionOfAlternatePaths',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfAlternatePaths',
                ),
                'renditionofdocumentid' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'RenditionOfDocumentID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfDocumentID',
                ),
                'renditionoffilepath' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'RenditionOfFilePath',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfFilePath',
                ),
                'renditionoffrompart' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'RenditionOfFromPart',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfFromPart',
                ),
                'renditionofinstanceid' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'RenditionOfInstanceID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfInstanceID',
                ),
                'renditionoflastmodifydate' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'RenditionOfLastModifyDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfLastModifyDate',
                ),
                'renditionoflasturl' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'RenditionOfLastURL',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfLastURL',
                ),
                'renditionoflinkcategory' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'RenditionOfLinkCategory',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfLinkCategory',
                ),
                'renditionoflinkform' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'RenditionOfLinkForm',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfLinkForm',
                ),
                'renditionofmanager' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'RenditionOfManager',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfManager',
                ),
                'renditionofmanagervariant' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'RenditionOfManagerVariant',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfManagerVariant',
                ),
                'renditionofmanageto' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'RenditionOfManageTo',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfManageTo',
                ),
                'renditionofmanageui' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'RenditionOfManageUI',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfManageUI',
                ),
                'renditionofmaskmarkers' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'RenditionOfMaskMarkers',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfMaskMarkers',
                ),
                'renditionoforiginaldocumentid' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'RenditionOfOriginalDocumentID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfOriginalDocumentID',
                ),
                'renditionofpartmapping' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'RenditionOfPartMapping',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfPartMapping',
                ),
                'renditionofplacedresolutionunit' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'RenditionOfPlacedResolutionUnit',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfPlacedResolutionUnit',
                ),
                'renditionofplacedxresolution' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'RenditionOfPlacedXResolution',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfPlacedXResolution',
                ),
                'renditionofplacedyresolution' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'RenditionOfPlacedYResolution',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfPlacedYResolution',
                ),
                'renditionofrenditionclass' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'RenditionOfRenditionClass',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfRenditionClass',
                ),
                'renditionofrenditionparams' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'RenditionOfRenditionParams',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfRenditionParams',
                ),
                'renditionoftopart' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'RenditionOfToPart',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfToPart',
                ),
                'renditionofversionid' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'RenditionOfVersionID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\RenditionOfVersionID',
                ),
                'renditionparams' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'RenditionParams',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\RenditionParams',
                ),
                'saveid' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'SaveID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\SaveID',
                ),
                'subject' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'Subject',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\Subject',
                ),
                'versionid' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'VersionID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\VersionID',
                ),
                'versions' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'Versions',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\Versions',
                ),
                'versionscomments' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'VersionsComments',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\VersionsComments',
                ),
                'versionsevent' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'VersionsEvent',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\VersionsEvent',
                ),
                'versionseventaction' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'VersionsEventAction',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\VersionsEventAction',
                ),
                'versionseventchanged' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'VersionsEventChanged',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\VersionsEventChanged',
                ),
                'versionseventinstanceid' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'VersionsEventInstanceID',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\VersionsEventInstanceID',
                ),
                'versionseventparameters' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'VersionsEventParameters',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\VersionsEventParameters',
                ),
                'versionseventsoftwareagent' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'VersionsEventSoftwareAgent',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\VersionsEventSoftwareAgent',
                ),
                'versionseventwhen' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'VersionsEventWhen',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\VersionsEventWhen',
                ),
                'versionsmodifier' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'VersionsModifier',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\VersionsModifier',
                ),
                'versionsmodifydate' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'VersionsModifyDate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\VersionsModifyDate',
                ),
                'versionsversion' => array(
                    'namespace' => 'XMP-xmpMM',
                    'tagname' => 'VersionsVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpMM\VersionsVersion',
                ),
            ),
            'xmp-xmpnote' => array(
                'hasextendedxmp' => array(
                    'namespace' => 'XMP-xmpNote',
                    'tagname' => 'HasExtendedXMP',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpNote\HasExtendedXMP',
                ),
            ),
            'xmp-xmpplus' => array(
                'creditlinereq' => array(
                    'namespace' => 'XMP-xmpPLUS',
                    'tagname' => 'CreditLineReq',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpPLUS\CreditLineReq',
                ),
                'reuseallowed' => array(
                    'namespace' => 'XMP-xmpPLUS',
                    'tagname' => 'ReuseAllowed',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpPLUS\ReuseAllowed',
                ),
            ),
            'xmp-xmprights' => array(
                'certificate' => array(
                    'namespace' => 'XMP-xmpRights',
                    'tagname' => 'Certificate',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpRights\Certificate',
                ),
                'marked' => array(
                    'namespace' => 'XMP-xmpRights',
                    'tagname' => 'Marked',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpRights\Marked',
                ),
                'owner' => array(
                    'namespace' => 'XMP-xmpRights',
                    'tagname' => 'Owner',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpRights\Owner',
                ),
                'usageterms' => array(
                    'namespace' => 'XMP-xmpRights',
                    'tagname' => 'UsageTerms',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpRights\UsageTerms',
                ),
                'webstatement' => array(
                    'namespace' => 'XMP-xmpRights',
                    'tagname' => 'WebStatement',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpRights\WebStatement',
                ),
            ),
            'xmp-xmptpg' => array(
                'colorants' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'Colorants',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\Colorants',
                ),
                'coloranta' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'ColorantA',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantA',
                ),
                'colorantb' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'ColorantB',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantB',
                ),
                'colorantblack' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'ColorantBlack',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantBlack',
                ),
                'colorantblue' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'ColorantBlue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantBlue',
                ),
                'colorantcyan' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'ColorantCyan',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantCyan',
                ),
                'colorantgray' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'ColorantGray',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantGray',
                ),
                'colorantgreen' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'ColorantGreen',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantGreen',
                ),
                'colorantl' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'ColorantL',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantL',
                ),
                'colorantmagenta' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'ColorantMagenta',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantMagenta',
                ),
                'colorantmode' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'ColorantMode',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantMode',
                ),
                'colorantred' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'ColorantRed',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantRed',
                ),
                'colorantswatchname' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'ColorantSwatchName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantSwatchName',
                ),
                'coloranttint' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'ColorantTint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantTint',
                ),
                'coloranttype' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'ColorantType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantType',
                ),
                'colorantyellow' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'ColorantYellow',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\ColorantYellow',
                ),
                'fonts' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'Fonts',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\Fonts',
                ),
                'childfontfiles' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'ChildFontFiles',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\ChildFontFiles',
                ),
                'fontcomposite' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'FontComposite',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\FontComposite',
                ),
                'fontface' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'FontFace',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\FontFace',
                ),
                'fontfamily' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'FontFamily',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\FontFamily',
                ),
                'fontfilename' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'FontFileName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\FontFileName',
                ),
                'fontname' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'FontName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\FontName',
                ),
                'fonttype' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'FontType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\FontType',
                ),
                'fontversion' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'FontVersion',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\FontVersion',
                ),
                'hasvisibleoverprint' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'HasVisibleOverprint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\HasVisibleOverprint',
                ),
                'hasvisibletransparency' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'HasVisibleTransparency',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\HasVisibleTransparency',
                ),
                'maxpagesize' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'MaxPageSize',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\MaxPageSize',
                ),
                'maxpagesizeh' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'MaxPageSizeH',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\MaxPageSizeH',
                ),
                'maxpagesizeunit' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'MaxPageSizeUnit',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\MaxPageSizeUnit',
                ),
                'maxpagesizew' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'MaxPageSizeW',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\MaxPageSizeW',
                ),
                'npages' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'NPages',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\NPages',
                ),
                'platenames' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'PlateNames',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\PlateNames',
                ),
                'swatchgroups' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'SwatchGroups',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchGroups',
                ),
                'swatchgroupscolorants' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'SwatchGroupsColorants',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchGroupsColorants',
                ),
                'swatchcoloranta' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'SwatchColorantA',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantA',
                ),
                'swatchcolorantb' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'SwatchColorantB',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantB',
                ),
                'swatchcolorantblack' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'SwatchColorantBlack',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantBlack',
                ),
                'swatchcolorantblue' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'SwatchColorantBlue',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantBlue',
                ),
                'swatchcolorantcyan' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'SwatchColorantCyan',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantCyan',
                ),
                'swatchcolorantgray' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'SwatchColorantGray',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantGray',
                ),
                'swatchcolorantgreen' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'SwatchColorantGreen',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantGreen',
                ),
                'swatchcolorantl' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'SwatchColorantL',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantL',
                ),
                'swatchcolorantmagenta' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'SwatchColorantMagenta',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantMagenta',
                ),
                'swatchcolorantmode' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'SwatchColorantMode',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantMode',
                ),
                'swatchcolorantred' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'SwatchColorantRed',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantRed',
                ),
                'swatchcolorantswatchname' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'SwatchColorantSwatchName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantSwatchName',
                ),
                'swatchcoloranttint' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'SwatchColorantTint',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantTint',
                ),
                'swatchcoloranttype' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'SwatchColorantType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantType',
                ),
                'swatchcolorantyellow' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'SwatchColorantYellow',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchColorantYellow',
                ),
                'swatchgroupname' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'SwatchGroupName',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchGroupName',
                ),
                'swatchgrouptype' => array(
                    'namespace' => 'XMP-xmpTPg',
                    'tagname' => 'SwatchGroupType',
                    'classname' => 'PHPExiftool\Driver\Tag\XMPXmpTPg\SwatchGroupType',
                ),
            ),
           
        );
    }
}
